//analisis30//
package analysis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
import schema.*;
import control.*;

/**
* Clase analisis30. 
* Proporciona funciones para la explicacion semantica y sintactica del contenido de las listas y
* diversas estrategias del analisis de sensibilidad multiparametrico.
* de una kbm2l. 
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  analisis30  { 

  private static final String ERROR = "Error(analisis30): ";
  private static boolean chk = false;
  
/**
* Contructor por defecto
**/
public analisis30( ) {

  chk = new controlPrefs30().checkMode();
//  System.out.println( "analisis30");
}//analisis30

/**
* Borrado de los elementos constantes de una explicacion fij. Simplifica.
* @param fij   Vector explicacion inicial 
* @param CONST Vector att's constantes en la lista
* @return fix  Vector explicacion simplificada 
**/
private Vector explicSimple( Vector fij, Vector CONST) {

  for( int j = 0; j < CONST.size(); j++) {
    Integer C = new Integer( ((Integer)(CONST.get( j))).intValue());
    fij.remove( C);
    }//for

  return fij;
}//explicSimple

/**
* Explicacion en base arbitraria del item i.
* @param i numero del item
* @param l30 lista
* @param EXPLIC vector de att's relevantes, minimo o simplificado.
* @return void. Texto.
**/
private void explicGeneral( int i, lista30 l30, Vector EXPLIC) {

  Vector politica =  l30.Get( i).GetRespuesta();
  Vector atributos = l30.Get( i).GetIndice(); 

  try {

    frame30.kbm2lBrowser.append("\nItem: " + i + "  S:  " + politica.toString() + 
      "  size: " + l30.Get(i).getLongitud() + "\n");
    if ( chk) {
      frame30.kbm2lBrowser.append("EXPLANATION(index): " + l30.Fij( i).toString());
      frame30.kbm2lBrowser.append(".\n");
      frame30.kbm2lBrowser.append("EXPLANATION(value): " + l30.Fix( i).toString());
      frame30.kbm2lBrowser.append(".\n");
      }
    frame30.kbm2lBrowser.append("*** POLICY: [\n");
    try {
      for( int j = 0; j < l30.ParRespuesta(); j++) {
        int v = ((Integer)(politica.get( j))).intValue();
        frame30.kbm2lBrowser.append( litPolitica( l30.Esqu, j, v) + "\n");
        }//for j
      
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "explicGeneral.1");
      frame30.exit( 0, e);
    }//catch

    frame30.kbm2lBrowser.append("] ===> ");

  if ( EXPLIC.size()==0) {
    frame30.kbm2lBrowser.append("EXPLANATION: [].\n");
  } else {
      frame30.kbm2lBrowser.append("EXPLANATION: "+ EXPLIC.toString() + " [\n");
    int j = -1, v = -1;  
  try {
	 atributos = basex30.Trnp( l30.Base, atributos, null);//!
    for( j = 0; j < l30.dimension(); j++) {
      Integer V = new Integer( j);
      if ( EXPLIC.indexOf( V) != -1) {//explicacion minima
        v = ((Integer)(atributos.get( j))).intValue();
        frame30.kbm2lBrowser.append( litAtributos( l30, j, v) + "\n");
        }//if
      }//for j

    }//try
    catch (Exception e) {
      frame30.kbm2lSystem.append( ERROR + "explicGeneral.2\n");
      frame30.kbm2lSystem.append( "Item-i: " + i + "  EXPLIC: " + EXPLIC.toString() + "\n");
      frame30.kbm2lSystem.append( "j: " + j + "  v: " + v + "\n");
      frame30.kbm2lSystem.append( "Base: \n" + l30.Base.toString( l30) + "\n");
      frame30.exit( 0, e);
    }//catch
 
    int k = -1, k_t = -1;
    Vector cAD = null;
  try {
    k = l30.cutDimension( i);
    cAD = l30.cutAttributeDomain( i); 
    if (( k >= 0) && ( cAD.size() != l30.Base.dom( k))) {
      k_t = l30.Base.bas( k);//BC
      try {
      for ( v = 0; v < cAD.size(); v++)
        cAD.set( v, new Integer( l30.Base.att( k, ((Integer)cAD.get( v)).intValue())));//BC
       } catch (ArrayIndexOutOfBoundsException e) {
      }
      frame30.kbm2lBrowser.append(" ---> CDAtt: " + 
        (String)( l30.Esqu.Atributos.get( k_t)) + ":" + cAD + "/" + l30.Base.dom( k) + "\n");
      for ( v = 0; v < cAD.size(); v++) { 
	     int v_t = ((Integer)cAD.get( v)).intValue(); 
	     frame30.kbm2lBrowser.append( litAtributos( l30, k_t, v_t) + "\n");
       }
      }//if(k>=0)
    }//try
    catch (Exception e) {
      frame30.kbm2lSystem.append( ERROR + "explicGeneral.3\n");
      frame30.kbm2lSystem.append( "Item-i: " + i + "  cutDimension() k: " + k + "\n");
      frame30.kbm2lSystem.append( "Item-i: " + i + "  cutDimension() k_t: " + k_t + "\n");
      frame30.kbm2lSystem.append( "cutAttributeDomain: " + l30.cutAttributeDomain( i) + "\n");
      frame30.kbm2lSystem.append( "cutAttributeDomain_t: " + cAD.toString() + "\n");
      frame30.kbm2lSystem.append( "Base: \n" + l30.Base.toString( l30) + "\n");
      frame30.exit( 0, e);
    }//catch

  frame30.kbm2lBrowser.append("].\n");
  }

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "explicGeneral.");
    System.out.println( "item: " + i + " list: " +  l30.Name() + " EXPLANATION: " + EXPLIC.toString());
    System.out.println( "Attributes: " + atributos);
    System.out.println( "Policie: " + politica);
    frame30.exit( 0, e);
  }//catch

  return;
}//explicGeneral

/**
* Interpretacion de l30 segun su esquema declarado en f30
* @param l30 lista con su equema.
**/
protected void interpretacion( lista30 l30) {
//explicacin de items de la lista

  frame30.kbm2lBrowser.setText("Interpretation of: " + l30.Name()+ ".\n");
  frame30.kbm2lBrowser.append("BASE  size: "  + 
    l30.Base.size() + " --- \n" + l30.Base.toString( l30) + ".\n");
//marco general
  frame30.kbm2lBrowser.append("KNOWLEDGE BASE: " + "\n");
//explicaciones
  Vector Const = listStat30.constAtt( l30);

  frame30.kbm2lBrowser.append(
    "GENERAL EXPLANATION by CONTSTANT ATTRIBUTES(" + Const.size() + "): [\n");
  try {
  
    Vector atributos = null;
    if ( !l30.esUNKB( l30.Get( 0)))
      atributos = l30.Get( 0).GetIndice();
      else atributos = l30.Get( 1).GetIndice();
      
    for( int j = 0; j < l30.dimension(); j++) {
      int v = ((Integer)(atributos.get( j))).intValue();
      Integer V = new Integer( j);
      if ( Const.indexOf( V) != -1) {//explicacion minima
        frame30.kbm2lBrowser.append( litAtributos( l30, l30.Base.bas( j), v) + "\n");
        }//if
      }//for j

    }//try
    catch (Exception e) {
      System.out.println( ERROR + "interpretacion.1");
      e.printStackTrace();
    }//catch
  frame30.kbm2lBrowser.append("].\n");

  int firstItemVer = new controlPrefs30().firstItemBrowser();
  int numItems = firstItemVer + new controlPrefs30().itemNumberBrowser();
  if ( numItems >= l30.size())
    numItems = l30.size();

  frame30.kbm2lBrowser.append("\n*** KBM2L ***\nItems: " + listStat30.kb( l30) + ".\n"); 
  frame30.kbm2lBrowser.append("Rules: " + listStat30.KB( l30) + ".\n");
  for( int i = firstItemVer;  i < numItems; i++) {

    if ( !l30.esUNKB( l30.Get( i))) {//se explica el conocmiento

      Vector EXPLIC = explicSimple( index30.cpT( l30.Fij( i)), Const);//FIX
      for( int x = 0; x < EXPLIC.size(); x++)
        EXPLIC.set( x, new Integer( l30.Base.bas(((Integer)EXPLIC.get( x)).intValue())));
      explicGeneral( i, l30, EXPLIC);

    }//if
  }//for-i

  return;
}//interpretacion

/**
* Literales de Respuesta.
* @param eq30 esquema de la lista, contenido semantico.
* @param codePolitica componente de Respuesta.
* @param v ordinal del valor de Respuesta codePolitica.
* @return String cadena de texto.
**/
public String litPolitica( esquema30 eq30, int codePolitica, int v) {

  Vector V = null;
    
  try {

  if (( codePolitica < 0) || ( codePolitica >= eq30.ValoresDecisiones.size())) {
    System.out.println( ERROR + "litPolitica. ");
    System.out.println( "codePolitica: " + codePolitica);
    System.out.println( "eq30.ValoresDecisiones.size(): " + eq30.ValoresDecisiones.size());
    frame30.exit( 0);	  
	 }

    V = (Vector)(eq30.ValoresDecisiones.get( codePolitica));//alternativas

    if (( v > V.size()) || ( v < 0))
      return (String)( eq30.Decisiones.get( codePolitica)) + " = " + v + "!?";//???
      else return (String)( eq30.Decisiones.get( codePolitica)) + " = " + (String)( V.get( v));//ok

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "litPolitica.");
    System.out.println( codePolitica);
    System.out.println( v);
    System.out.println( V);
    System.out.println( eq30.ValoresDecisiones);
    System.out.println( eq30.Decisiones);
    frame30.exit( 0, e);
  }//catch

  return null;
}//litPolitica

/**
* Literales de atributos
* @param l30 lista30.
* @param codeAtributo componente de Indice.
* @param v ordinal del valor de Indice codeAtributo.
* @return String cadena de texto.
**/
public String litAtributos( lista30 l30, int codeAtributo, int v) {

  Vector atributos = new Vector();
  Vector V = null;
  try {

  if (( codeAtributo < 0) || ( codeAtributo >= l30.Esqu.ValoresAtributos.size())) {
    System.out.println( ERROR + "litAtributos. ");
    System.out.println( "codeAtributo: " + codeAtributo);
    System.out.println( "l30.Esqu.ValoresAtributos.size(): " + l30.Esqu.ValoresAtributos.size());
    frame30.exit( 0);	  
	 }

    V = (Vector)(l30.Esqu.ValoresAtributos.get( codeAtributo));

    if (( v > V.size()) || ( v < 0))
      return (String)( codeAtributo + "-x-" + l30.Base.bas( codeAtributo) + "::" + 
        l30.Esqu.Atributos.get( codeAtributo)) + " = " + v + "!?";//???
      else return (String)( codeAtributo + "-x-" + l30.Base.bas( codeAtributo) + "::" + 
        l30.Esqu.Atributos.get( codeAtributo)) + " = " + (String)(V.get( v));//ok

  }//try
  catch (Exception e) {
    frame30.kbm2lSystem.append( ERROR + "litAtributos.\n"); 
    frame30.kbm2lSystem.append( "codeAtributo: " + codeAtributo + "  v: " + v + "\n");
    frame30.kbm2lSystem.append( "V: " + V.toString() + "\n");
    l30.Esqu.browser( frame30.kbm2lSystem);
    frame30.exit( 0, e);
  }//catch

  return null;
}//litAtributos

/**
* Vector de valores (String) correspondiente a un indice en el esquema, 
**/
protected Vector Valor( lista30 l30, Vector INDICE) {

  Vector VALOR = new Vector();
  int j = 0, iv = 0;
  try {
  for( j = 0; j < l30.dimparam+1; j++) {
      iv = ((Integer)INDICE.get( j)).intValue();
//      if ( l30.Base.rol( j) == 1)
        String valor = new String((String)((Vector)l30.Esqu.ValoresAtributos.get( j)).get( iv));
        VALOR.add( valor);// 
      }//for-j

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "Valor.");
    System.out.println( "j: " + j + "  iv: " + iv);
    System.out.println((Vector)l30.Esqu.ValoresAtributos.get( j));
    System.out.println( "I: " + INDICE.toString());
    System.out.println( "V: " + VALOR.toString());
    frame30.exit( 0, e);
  }//catch
  
  return VALOR;
}//Valor

}//class analisis30