//analisisFullScanner30//
package analysis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
import tables.*;
import schema.*;
import tools.*;
import control.*;

/**
* Clase analisisFullScanner30.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class  analisisFullScanner30  extends  analisisScanner30  {

  private static final String ERROR = "Error(analisisFullScanner30): ";

/**
* Constructor por defecto
**/
public analisisFullScanner30( ) {

  System.out.println( "analisisFullScanner30");
}//analisisFullScanner30

/**
* Scanner de la lista extendida, busca diferencias entre modelos: X-Y
* La base tiene las dimensiones parametros primero y las dimensiones 
* variables despues de izq-der.
* Recorrido de la listas comparando con el modelo de referencia. xi != ri -> rs.
* Puede ser respecto de un subconjunto de los parametros que son libres, 
* frente al resto que estan ligados a una distancia maxima.
**/
public void scanner( lista30 l30) {
//0-18, 19-27
  BufferedWriter out1 = null;// *.txt
  BufferedWriter out2 = null;// *.txt
  String linea = null; // linea del fichero
  lista30 sa30 = null;
  double sa30KB = -1.0;
  double MaxDist = 0.0;
  double iterac = 1.0;
  Vector MASK = null;

  Vector ipd = protocolo30.ipdAccess( "");//filename, dimparam, PARAMS, Decs
  l30.dimparam = ((Integer)(ipd.get(1))).intValue();
  l30.PARAMS = (Vector)(ipd.get(2));

  if (( l30.dimparam+1 > l30.dimension()) || ( l30.dimparam < 1)) {
    System.out.println( ERROR + "scanner. dimaparam: " + l30.dimparam);
    System.out.println( ERROR + "         INDEX.sz:  " + l30.dimension());
    frame30.exit( 0);
  }

  frame30.kbm2lSystem.append( "Sensitivity Analysis. scanner.\n");

  try {
  
    //especifica las dimen-param que se analizan
    Vector Param = new controlPrefs30().sensitivityAnalisysParam();
    MASK = new Vector();//mascara de distancias
    for( int i = 0; i < l30.dimension(); i++)
      MASK.add( new Integer( -1));
    if ( Param != null) { 
      for( int i = 0; i < Param.size(); i++)
        if (((Integer)Param.get( i)).intValue() != -1)
          MASK.set( ((Integer)Param.get( i)).intValue(), new Integer( 0));           
      frame30.kbm2lSystem.append( "Sensitivity Analysis. Param: " + Param.toString() + ".\n");
    }
    frame30.kbm2lSystem.append( "Sensitivity Analysis. Mask:  \n" + MASK.toString() + ".\n");
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "scanner.0\n");
    frame30.exit( 0, e);
  }//catch

  try {
  
//lista kbm2l para sensibilidad de contexto.
    sa30 = new lista30( l30, l30);//copia de estructura y contenido
    sa30.Name( "sa-"+l30.Name());
    sa30KB = listStat30.KB( sa30).doubleValue();

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "scanner.1\n");
    frame30.exit( 0, e);
  }//catch

    boolean chk = new controlPrefs30().checkMode();
    frame30.kbm2lSystem.append( "Sensitivity Analysis. Full Scanner.\n");
    frame30.kbm2lSystem.append( "sa30KB: " + sa30KB + "\n");
    frame30.kbm2lBrowser.append( "Sensibilidad relativa.- \n\t MaxDist,\t (RSKB / KBx)\n");

//
    while ( MaxDist < 140) {
      boolean OVFdist = false;
          
  try {

    if ( chk) {
      out1 = new BufferedWriter( new FileWriter( dato30.workspace + "scanner1" + ".txt"));//.hkb
      out2 = new BufferedWriter( new FileWriter( dato30.workspace + "scanner2" + ".txt"));//.hkb
      }  

    item30 item = null;
    Vector INDEX = null; // recorrido de l30
    Vector DOMINIO = l30.Base.Dom();
    Vector ULTIMO = index30.ultimoT( DOMINIO);
    for( INDEX = index30.primeroT( DOMINIO);
         index30.myeqT( ULTIMO, INDEX);
         INDEX = index30.siguienteT( DOMINIO, INDEX)) {

       item = l30.GET( INDEX);///!!!

       if ( !l30.esUNKB( item)) {  

         if ( distancia( l30, INDEX, MASK) <= MaxDist) {

         if ( !index30.eqS( sa30.GET( INDEX).GetRespuesta(), sa30.RSKB)) {
           Vector refINDEX = new Vector();
           refINDEX = refParams( l30, INDEX);//refParams+INDEX[19]...INDEX[27]
           item30 refItem = l30.GET( refINDEX);// !!!
           Vector refRESPUESTA = refItem.GetRespuesta();

           if ( !l30.esUNKB( refItem)) {

             Vector RESPUESTA = item.GetRespuesta();
             Vector MEDIDA = item.GetMedida();

             if ( !index30.eqS( refRESPUESTA, RESPUESTA)) {// ! - sensible

               frame30.kbm2lSystem.estatus( "scanner: " + item.getOffsetSup() + "  SA: " + 
                 listStat30.KB( sa30, sa30.RSKB).doubleValue() / sa30KB + 
                   "  refR:" + refRESPUESTA + "  R:" + RESPUESTA);

               sa30.Set( new item30( sa30, MEDIDA, sa30.RSKB, INDEX));// ! - sensible
               if ( chk) {
                 linea = INDEX.toString() + refRESPUESTA.toString() + RESPUESTA.toString();
                 out1.write( linea, 0, linea.length()); out1.newLine();
                 linea = Valor( l30, INDEX).toString()  + refRESPUESTA.toString() + RESPUESTA.toString();
                 out2.write( linea, 0, linea.length()); out2.newLine();
                 } 
               }//-if- sensible
               else {
                 int k = l30.indexOf( item);
                 int rk = l30.indexOf( refItem);
                 if ( eqV( l30.dimparam, item.GetIndice(), refItem.GetIndice()) &&
//                    (item.getLongitud().longValue() == refItem.getLongitud().longValue())
                      eqV( l30.dimparam, l30.Inf( k), l30.Inf( rk))) {
                   frame30.kbm2lSystem.estatus( "jump. i: " + k + "  length: " + item.getLongitud());
                   INDEX = item.GetIndice();//salta el item
                   }
               }

             }//-if-unKB
             else {
             
             }

           }//if-RS

            }//if-dist

            else { 
              OVFdist = true;
              frame30.kbm2lSystem.estatus( "distance: " + distancia( l30, INDEX, MASK));
              INDEX = item.GetIndice();//salta el item
              }

          }//-if-unKB
          else { frame30.kbm2lSystem.estatus( "scanner: " + item.getOffsetSup());   
            INDEX = item.GetIndice(); }//salta el item UNKB

         if ( index30.eqT( ULTIMO, INDEX)) { break; }
  
      }//for-INDEX

    if ( chk) 
    if ( listStat30.KB( sa30, sa30.RSKB).doubleValue() > 0.0)
      new outputList30( ).escribeKBM2L( sa30,
        dato30.workspace + dato30.extFile( dato30.nameFile( sa30.Name()), "hkb"));//no filedlg        

    if ( chk) {
      out1.close(); 
      out2.close(); 
     }
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "scanner.2");
    frame30.exit( 0, e);
  }//catch

    //listStat30.reset( sa30);
    double RSKB = listStat30.KB( sa30, sa30.RSKB).doubleValue();
    double KBx = listStat30.KB( l30, MASK, MaxDist).doubleValue();
    frame30.kbm2lSystem.append( iterac + ".-  MaxDist: " + MaxDist + 
      "\n  SA(RSKB,RSKB/KB): (" + RSKB + "," + (RSKB / (double)(sa30KB)) + ")" +
      "\n  SA(RSKB/KBx): (" + (RSKB / KBx) + ")  KBx: " + KBx + "\n");
    long ce = 100000;  
    frame30.kbm2lBrowser.append( "\t" + (Math.ceil(MaxDist*ce)/ce) + ",\t\t" + 
      (Math.ceil((RSKB / KBx)*ce)/ce) + "\n");

    MaxDist = MaxDist + 0.075*iterac/16;//15-rango del AttPar-0
    iterac++;

    if ( !OVFdist) break;//la lista sa30 se ha recorrido completamente a esta cota de MaxDist.
  }//while-MaxDist
  
    if ( listStat30.KB( sa30, sa30.RSKB).doubleValue() > 0.0)
      new outputList30( ).escribeKBM2L( sa30,
        dato30.workspace + dato30.extFile( dato30.nameFile( sa30.Name()), "hkb"));//no filedlg        

  frame30.kbm2lSystem.append( "Analysis. Full Scanner. OK\n");
  return;
}//scanner

/**
* Run.
**/
public void run() {

  try {
    long ts0 = (new Date()).getTime();
    scanner( frame30.activel30);
    frame30.kbm2lTime.append("scanner:: " + (new Date().getTime() - ts0) + ".\n");        
 }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    frame30.exit( 0, e);
  }//catch
  return;
}//run

}//analsisSensibilidad30