//analisisParser30//
package analysis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
import tables.*;
import schema.*;
import tools.*;

/**
* Clase analisisParser30.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class analisisParser30  extends analisisSensibilidad30  {

  private static final String ERROR = "Error(analisisParser30): ";

/**
* Constructor por defecto
**/
public analisisParser30( ) {

//  System.out.println( "analisisParser30");
}//analisisParser30

/**
* matching de labels en el diagrama de referencia y reescritura con los nuevos parametros
* Hay dos tipos de labels: p y k. Los p tienen asociados los q con una distribucion de reparto
* del resto de masa de probabilidad. Se reparte proporcionalmente: r/sum(r), sum(r)=1-p.
* @param dimparam numero de parametros
* @param linea linea del fichero del diagrama de referencia
* @param VALOR nuevos valores de los parametros
* @return linea linea del fichero del diagrama nuevo
**/
public String parser( int dimparam, String linea, Vector VALOR) {

  int ptk = -1;
  double q = -1.0;

  for( int p = dimparam+1; p >= 1; p--) {
    try {
    if ( (ptk = linea.indexOf( "$p" + p)) != -1) {
      return linea.substring( 0, ptk) + ((String)VALOR.get( p-1));
    }
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "parser - $p" + p + "   " + linea + ".");
      frame30.exit( 0);
    }//catch	  
	 }//for

//  System.out.println( "parser.p...");
/*
  for( int p = 10; p <= dimparam+1; p++) {
    try {
    if ( (ptk = linea.indexOf( "$p" + p)) != -1) {
      return linea.substring( 0, ptk) + ((String)VALOR.get( p-1));
    }
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "parser - $p" + p + "   " + linea + ".");
      frame30.exit( 0);
    }//catch	  
	 }//for

  for( int p = 1; p <= 9; p++) {
    try {
    if ( (ptk = linea.indexOf( "$p" + p)) != -1) {
      return linea.substring( 0, ptk) + ((String)VALOR.get( p-1));
    }
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "parser - $p" + p + "   " + linea + ".");
      frame30.exit( 0);
    }//catch	  
	 }//for
*/

  for( int pq = dimparam+1; pq >= 1; pq--) {
    try {
    if ( (ptk = linea.indexOf( "$q" + pq)) != -1) {
      q = 1.0 - (new Double(((String)VALOR.get( pq-1)))).doubleValue();
      String proporc = linea.substring( ptk, linea.length());
      proporc = proporc.substring( proporc.indexOf(" "), proporc.indexOf("]"));
      proporc = proporc.trim();
      q = q * (new Double( proporc)).doubleValue();
      return linea.substring( 0, ptk) + q;
    }
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "parser - $q" + pq + "   " + linea + ".");
      frame30.exit( 0);
    }//catch
	 }//for

/*
  for( int pq = 10; pq <= dimparam+1; pq++) {
    try {
    if ( (ptk = linea.indexOf( "$q" + pq)) != -1) {
      q = 1.0 - (new Double(((String)VALOR.get( pq-1)))).doubleValue();
      String proporc = linea.substring( ptk, linea.length());
      proporc = proporc.substring( proporc.indexOf(" "), proporc.indexOf("]"));
      proporc = proporc.trim();
      q = q * (new Double( proporc)).doubleValue();
      return linea.substring( 0, ptk) + q;
    }
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "parser - $q" + pq + "   " + linea + ".");
      frame30.exit( 0);
    }//catch
	 }//for

  for( int pq = 1; pq <= 9; pq++) {
    try {
    if ( (ptk = linea.indexOf( "$q" + pq)) != -1) {
      q = 1.0 - (new Double(((String)VALOR.get( pq-1)))).doubleValue();
      String proporc = linea.substring( ptk, linea.length());
      proporc = proporc.substring( proporc.indexOf(" "), proporc.indexOf("]"));
      proporc = proporc.trim();
      q = q * (new Double( proporc)).doubleValue();
      return linea.substring( 0, ptk) + q;
    }
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "parser - $q" + pq + "   " + linea + ".");
      frame30.exit( 0);
    }//catch
	 }//for
*/

/*
//K 4 k's !!!
  double K = -1.0;
                   
  try {
  if ( (ptk = linea.indexOf( "$K")) != -1) {
    K = solver( VALOR);// K = 1.44
    linea = linea.substring( 0, ptk) + K + " " +
    linea.substring( linea.indexOf( "]")+1, linea.length());
    }
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "parser - K " + linea + ".");
    frame30.exit( 0);
  }//catch
*/
//  System.out.println( "parser.OK.");
  return linea;
}//parser

private double solver( Vector VALOR) {
//1.0 = (1+k*k1)(1+k*k2)(1+k*k3)(1+k*k4) - k;
  double k = 10.0;// ret
  double k1 = ((Double)VALOR.get( 15)).doubleValue(), 
         k2 = ((Double)VALOR.get( 16)).doubleValue(), 
         k3 = ((Double)VALOR.get( 17)).doubleValue(), 
         k4 = ((Double)VALOR.get( 18)).doubleValue();
  Vector VAL = new Vector();
  Vector ERR = new Vector();  

  for( int i = 0; i < 1000; i++) {
    VAL.add( new Double( k));
    ERR.add( new Double( (1+k*k1)*(1+k*k2)*(1+k*k3)*(1+k*k4) - k - 1.0));
    k = k - 0.01;
    }//for-i
  
  double err = 100.0;
  for( int i = 0; i< ERR.size(); i++) {
    if ( Math.abs( err) > Math.abs( ((Double)ERR.get(i)).doubleValue())) {
      err = ((Double)ERR.get(i)).doubleValue();
      k = ((Double)VAL.get(i)).doubleValue();  
      }//if
    }//for-i

  return k;
}//solver

}//analisisParser30