//analisisRandomScanner30//
package analysis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
import tables.*;
import schema.*;
import tools.*;
import control.*;

/**
* Clase analisisRandomScanner30.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class  analisisRandomScanner30  extends  analisisScanner30   {

  private static final String ERROR = "Error(analisisRandomScanner30): ";

/**
* Constructor por defecto
**/
public analisisRandomScanner30( ) {

  System.out.println( "analisisRandomScanner30");
}//analisisRandomScanner30

/**
* Scanner aleatorio de la lista extendida, busca diferencias entre modelos: X-Y
* La base tiene las dimensiones parametros primero y las dimensiones variables despues de izq-der.
* recorrido de la listas comparando con el modelo de referencia. xi != ri -> rs.
* puede ser respecto de un subconjunto de los parametros que son libres, frente al resto que
* estan ligados a una distancia maxima.
**/
public void rscanner( lista30 l30) {
//0-18, 19-27
  BufferedWriter out1 = null;// *.txt
  BufferedWriter out2 = null;// *.txt
  String linea = null; // linea del fichero
  lista30 sa30 = null;
  double sa30KB = -1.0;
  double MaxDist = 0;
  double iterac = 1.0;
  Vector MASK = null;
  long samplesize = 5;
  long samples = 0;

  if ( l30.dimparam+1 > l30.dimension()) {
    System.out.println( ERROR + "rscanner. dimaparam: " + l30.dimparam);
    System.out.println( ERROR + "         INDEX.sz:  " + l30.dimension());
    frame30.exit( 0);
  }

  frame30.kbm2lSystem.append( "Sensitivity Analysis. rscanner." + l30.Name() + " (" + l30.size() + ")\n");

  try {
  
    //especifica las dimen-param que se analizan
    Vector Param = new controlPrefs30().sensitivityAnalisysParam();
    MASK = new Vector();//mascara de distancias
    for(int i = 0; i < l30.dimension(); i++)
      MASK.add( new Integer( -1));
    if ( Param != null) { 
      for( int i = 0; i < Param.size(); i++)
        if (((Integer)Param.get( i)).intValue() != -1)
          MASK.set( ((Integer)Param.get( i)).intValue(), new Integer( 0));           
      frame30.kbm2lSystem.append( "Sensitivity Analysis r. Param: " + Param.toString() + ".\n");
    }
    frame30.kbm2lSystem.append( "Sensitivity Analysis r. Mask:  \n" + MASK.toString() + ".\n");
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "rscanner.0\n");
    frame30.exit( 0, e);
  }//catch

  try {
  
//lista kbm2l para sensibilidad de contexto.
    sa30 = new lista30( l30, l30);//copia de estructura y contenido
    sa30.Name( "rsa-"+l30.Name());
    sa30KB = listStat30.KB( sa30).doubleValue();

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "rscanner.1\n");
    frame30.exit( 0, e);
  }//catch

    frame30.kbm2lSystem.append( "Sensitivity Analysis. RScanner.\n");

    samples = 0;
    while (MaxDist < 140) {
      boolean OVFdist = false;
          
  try {

    out1 = new BufferedWriter( new FileWriter( dato30.workspace + "rscanner1" + ".txt"));//.hkb
    out2 = new BufferedWriter( new FileWriter( dato30.workspace + "rscanner2" + ".txt"));//.hkb

    item30 item = null;
    Vector INDEX = null; // recorrido de l30
    Vector DOMINIO = l30.Base.Dom();
    Vector ULTIMO = index30.ultimoT( DOMINIO);
    boolean chk = new controlPrefs30().checkMode();
    for( long i = 0; i < samplesize; i++) {
      control30.gr.setSeed( 123);
    for( int mk = 0; mk < l30.size(); mk++) {
      if ( control30.gr.nextInt(1000) > 50) continue;// 
      if ( l30.esUNKB( l30.Get( mk))) continue;
      INDEX = index30.cpT( l30.GetIndice( mk));//indice de un modelo  
      INDEX = new randomkbm2l30().randomINDICE( INDEX, 19, l30);  
      samples++;
       
      item = l30.GET( INDEX);///!!!

      if ( !l30.esUNKB( item)) {  

        if ( distancia( l30, INDEX, MASK) <= MaxDist) {

        if ( !index30.eqS( sa30.GET( INDEX).GetRespuesta(), sa30.RSKB)) {
          Vector refINDEX = new Vector();
          refINDEX = refParams( l30, INDEX);//refParams+INDEX[19]...INDEX[27]
          item30 refItem = l30.GET( refINDEX);// !!!
          Vector refRESPUESTA = refItem.GetRespuesta();

          if ( !l30.esUNKB( refItem)) {

            Vector RESPUESTA = item.GetRespuesta();
            Vector MEDIDA = item.GetMedida();

            if ( !index30.eqS( refRESPUESTA, RESPUESTA)) {// ! - sensible
              if (  chk)
              frame30.kbm2lSystem.estatus( "scanner: " + mk + "  SA(a): " + 
                listStat30.KB( sa30, sa30.RSKB).doubleValue() / sa30KB + "  SA(r): " + 
                listStat30.KB( sa30, sa30.RSKB).doubleValue() / samples + 
                "  refR:" + refRESPUESTA + "  R:" + RESPUESTA);
              sa30.Set( new item30( sa30, MEDIDA, sa30.RSKB, INDEX));// ! - sensible
              if ( chk) {
                linea = INDEX.toString() + refRESPUESTA.toString() + RESPUESTA.toString();
                out1.write( linea, 0, linea.length()); out1.newLine();
                linea = Valor( l30, INDEX).toString()  + refRESPUESTA.toString() + RESPUESTA.toString();
                out2.write( linea, 0, linea.length()); out2.newLine();
                } 
              }//-if- sensible

            }//-if-unKB
          else frame30.kbm2lSystem.estatus( "scanner if-unKB.2"); 

          }//if-RSKB
          else frame30.kbm2lSystem.estatus( "scanner if-RSKB."); 

        }//if-dist
        else { frame30.kbm2lSystem.estatus( "scanner if-dist."); OVFdist = true; }

      }//-if-unKB
      else frame30.kbm2lSystem.append( "scanner if-unKB.1 " + INDEX + item.GetRespuesta()+"\n"); 

      }//for-k

    }//for-i

    if ( chk) 
      if ( listStat30.KB( sa30, sa30.RSKB).doubleValue() > 0.0)
        new outputList30( ).escribeKBM2L( sa30,
          dato30.workspace + dato30.extFile( dato30.nameFile( sa30.Name()), "hkb"));//no filedlg        

    out1.close(); 
    out2.close(); 
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "rscanner.1");
    frame30.exit( 0, e);
  }//catch

    //listStat30.reset( sa30);
    double RSKB = listStat30.KB( sa30, sa30.RSKB).doubleValue();
    double KBx = listStat30.KB( l30, MASK, MaxDist).doubleValue();
    frame30.kbm2lSystem.append( iterac + ".-  MaxDist: " + MaxDist + 
      "\n  SA(RSKB,RSKB/KB): (" + RSKB + "," + (RSKB / (double)(sa30KB)) + ")" +
      "\n  SA(RSKB/KBx): (" + (RSKB / KBx) + ")  KBx: " + KBx + "\n");
    
    MaxDist = MaxDist + 0.075*iterac/16;//15-rango del AttPar-0
    iterac++;

    if ( !OVFdist) break;//la lista sa30 se ha recorrido completamente a esta cota de MaxDist.
  }//wihle-MaxDist
  
  if ( listStat30.KB( sa30, sa30.RSKB).doubleValue() > 0.0)
    new outputList30( ).escribeKBM2L( sa30,
      dato30.workspace + dato30.extFile( dato30.nameFile( sa30.Name()), "hkb"));//no filedlg        

  frame30.kbm2lSystem.append( "Analysis. RScanner. OK\n");
  return;
}//rscanner

/**
* Run.
**/
public void run() {

  try {
    long ts0 = (new Date()).getTime();
    Vector ipd = protocolo30.ipdAccess( "");//filename, dimparam, PARAMS, Decs
    frame30.activel30.dimparam = ((Integer)(ipd.get(1))).intValue();
    frame30.activel30.PARAMS = (Vector)(ipd.get(2));
    rscanner( frame30.activel30);
    frame30.kbm2lTime.append("rscanner:: " + (new Date().getTime() - ts0) + ".\n");        
 }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    frame30.exit( 0, e);
  }//catch
  return;
}//run

}//analsisRandomSensibilidad30