//analisisScanner30//
package analysis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
import tables.*;
import schema.*;
import tools.*;
import control.*;

/**
* Clase analisisScanner30.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class  analisisScanner30  extends  analisisSensibilidad30  implements Runnable  {

  private static final String ERROR = "Error(analisisScanner30): ";

/**
* Constructor por defecto
**/
public analisisScanner30( ) {

  System.out.println( "analisisScanner30");
}//analisisScanner30

/**
* Valores son iguales entre dimval0 y size().
* Responde a si dos indices son homologos en modelos diferentes.
**/
protected boolean eqV( int dimparam, Vector refINDEX, Vector INDEX) {

  try {
  for( int i = dimparam+1; i < refINDEX.size(); i++)
    if ( ((Integer)refINDEX.get( i)).intValue() != ((Integer)INDEX.get( i)).intValue())
      return false;
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "eqV.");
    System.out.println( "dimparam. " + dimparam);
    System.out.println( "refINDEX. " + refINDEX.toString());
    System.out.println( "INDEX.     " + INDEX.toString());
    frame30.exit( 0, e);
  }//catch
    
  return true;
}//eqV

/**
* Aade al final del vector-indice de parametros de referencia los valores de los atributos-indice.
**/
protected Vector refParams( lista30 l30, Vector INDEX) {

  try {	
  if ( l30.PARAMS.size() < INDEX.size())
    for( int i = l30.dimparam+1; i < INDEX.size(); i++)
      l30.PARAMS.add( new Integer( -1));
  for( int i = l30.dimparam+1; i < INDEX.size(); i++)
    l30.PARAMS.set( i, new Integer( ((Integer)INDEX.get( i)).intValue()));//
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "refParams.");
    System.out.println( "dimparam. " + l30.dimparam);
    System.out.println( "PARAMS. " + l30.PARAMS.toString());
    System.out.println( "INDEX.  " + INDEX.toString());
    frame30.exit( 0, e);
  }//catch
    
  return l30.PARAMS;	
}//refParams

/**
* 
**/
private static double distanciaSIM( lista30 l30, Vector INDEX, Vector MASK) {

  double dist = 0.0;
  Vector valores = null;

  for( int i = 0; i < l30.dimparam+1; i++) { //PARAMS es la referencia
    try {
      if (((Integer)MASK.get( i)).intValue() == -1) 
          dist = dist + 
            Math.abs(((Integer)INDEX.get( i)).intValue()-((Integer)l30.PARAMS.get( i)).intValue());

    }//try
    catch (Exception e) {
      System.out.println( ERROR + "distanciaSIM.");
      System.out.println( "dimparam. " + l30.dimparam);
      System.out.println( "valores. " + valores);
      System.out.println( "INDEX.     " + INDEX.toString());
      System.out.println( "MASK. " + MASK.toString());
      System.out.println( "PARAMS. " + l30.PARAMS.toString());
      System.out.println( "dist. " + dist);
      frame30.exit( 0, e);
    }//catch
      }//for-i  

  return dist;    
}//

/**
*
**/
private static double distanciaNUM( lista30 l30, Vector INDEX, Vector MASK) {

  double dist = 0.0;
  Vector valores = null;

  for( int i = 0; i < l30.dimparam+1; i++) { //PARAMS es la referencia
    try {
    if (((Integer)MASK.get( i)).intValue() == -1) {

    valores = (Vector)l30.Esqu.ValoresAtributos.get( i);
    String strParamMin = ((String)valores.get( 0));
    double paramMin = Double.parseDouble( strParamMin.trim());
    String strParamMax = ((String)valores.get( valores.size()-1));
    double paramMax = Double.parseDouble( strParamMax.trim());

    Integer I = (Integer)INDEX.get( i);//componente del indice !!!
    String strParamI = ((String)valores.get( I.intValue()));
    double paramI = Double.parseDouble( strParamI.trim());
          
    Integer J = (Integer)l30.PARAMS.get( i);//componente del indice-param !!!
    String strParamJ = ((String)valores.get( J.intValue()));
    double paramJ = Double.parseDouble( strParamJ.trim());

            dist = dist + 
              Math.abs(paramJ-paramI)/(paramMax-paramMin);//normalizada
        }
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "distanciaNUM.");
      System.out.println( "dimparam. " + l30.dimparam);
      System.out.println( "valores. " + valores);
      System.out.println( "INDEX.     " + INDEX.toString());
      System.out.println( "MASK. " + MASK.toString());
      System.out.println( "PARAMS. " + l30.PARAMS.toString());
      System.out.println( "dist. " + dist);
      frame30.exit( 0, e);
    }//catch
      }//for-i  

  return dist;    
}//

/**
* Distancia a la referencia, el atributo indice es el mismo. Para comparar la sensibilidad !
* libre: sa conjunta
* ligaduras: subconj param-indices con distancia acotada (pequea) sa del resto.
* curva incremental de sensibilidad de un subconj de param-indices.
* L1. indice (simbolica) / valores (numerica.normalizada)
* MASK controla el conjunto de dimensiones que participan en la distancia (-1).
* INDEX identifica el modelo particular.
* PARAMS es el modelo de referencia.
**/
public static double distancia( lista30 l30, Vector INDEX, Vector MASK) {
	
  boolean simbol = false;//true-simbolica, false-numerica.normalizada
  try {
    if ( MASK.indexOf( new Integer( 0)) != -1)
      if ( simbol) 
        return distanciaSIM( l30, INDEX, MASK);
        else return distanciaNUM( l30, INDEX, MASK);
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "distancia.");
      frame30.exit( 0, e);
    }//catch
    
//  System.out.println( "dist. " + dist);
  return 0.0;	
}//distancia

}//analsisSensibilidad30