//analisisSensibilidad30//
package analysis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
import tables.*;
import schema.*;
import tools.*;
import synthesis.*;
import control.*;

/**
* Clase analisisSensibilidad30.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class analisisSensibilidad30  extends analisis30  implements Runnable  {

  private static final String ERROR = "Error(analisisSensiblidad30): ";

/**
* $p   -label.txt
**/
  private String fileLabels = null;
/**
* compilacin   -instancia.pro
**/
  private String filePro = null;
/**
* 
**/
  private String Dec1 = null;

/**
* Constructor por defecto
**/
public analisisSensibilidad30( ) {

//  System.out.println( "analisisSensibilidad30");
}//analisisSensibilidad30

/**
* Distancia a la referencia, el atributo indice es el mismo. Para comparar la sensibilidad !
* libre: sa conjunta
* ligaduras: subconj param-indices con distancia acotada (pequea) sa del resto.
* curva incremental de sensibilidad de un subconj de param-indices.
* L1. simbolica / valores
**/
protected int distancia( lista30 l30, Vector INDEX) {
	
  int dist = 0;	
  for( int i = 0; i < l30.dimparam+1; i++)//PARAMS es la referencia
    dist = dist + 
      Math.abs(((Integer)INDEX.get( i)).intValue()-((Integer)l30.PARAMS.get( i)).intValue());
    
  return dist;	
}//distancia

/**
* Initial Random Sample
**/
private Vector sample( lista30 l30) {
   
// l30: modelo de referencia optimizado.
  int muestras = 0;
  for( int i = 0; i < l30.dimparam; i++)
    muestras = muestras + l30.Base.dom( i);
  muestras = muestras - l30.Base.size();  
  muestras = l30.dimparam * muestras;
// muestras = l30.dimparam + (int)(Math.log(( new offset30().getLONGITUD( l30.Base.Dom())).doubleValue()));
  muestras = l30.dimparam;
  Vector DISTANCIAS = new Vector();//Integer
  Vector INDICES = new Vector();//Vector
  Vector flags = checkIndex30.FLAGS( l30); 

  for( int i = 0; i < 150; i++) DISTANCIAS.add( new Integer( 0));    

//  muestras = 64;////
  
  frame30.kbm2lSystem.append( "Initial Random Sample: " + muestras + "\n");
  for( int i = 0; i < muestras; i++) {

    Vector INDICE = null;
    INDICE = analisisSetIndex30.set( i, l30, INDICE);
    checkIndex30.INDX( l30, INDICE, flags);
    Vector VALOR = null;

  try {//

    for( int j = l30.dimparam+1; j < INDICE.size(); j++) {
//      if ( l30.Base.rol( j) == 1)
        INDICE.set( j, new Integer( -1));// es dim-var
      }//for-j

    System.out.println( "i: " + i + "   I: " + INDICE.toString()+ "   INDICES.size: " + INDICES.size());

    if ( INDICES.indexOf( INDICE) != -1) {
      i--;
      System.out.println( "INDICES:\n " + INDICES.toString());
      continue;
    } else {
      checkIndex30.INDX( l30, INDICE, flags);
	   INDICES.add( INDICE.clone());
	   }
        
    int d = distancia( l30, INDICE);
    frame30.kbm2lSystem.estatus( "AS: " + i + "   d(ref,ind): " + d);
    if ( d < DISTANCIAS.size()) {
      int D = ((Integer)DISTANCIAS.get( d)).intValue();
      if ( D > l30.dimparam*l30.dimparam/1.05) {
        frame30.kbm2lSystem.estatus( "AS: " + i + "   d(ref,ind): " + d + "  D: " + D);
        i--;
        continue;
        }
        DISTANCIAS.set( d, new Integer(D+1));//histograma de distancias
      }  
      
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "analisisSensibilidad. for-muestras");
    System.out.println( "I: " + INDICE.toString());
    System.out.println( "V: " + VALOR.toString());
    System.out.println( distancia( l30, INDICE));
    frame30.exit( 0, e);
  }//catch

  }//for-i

 frame30.kbm2lSystem.append( "INITIAL - RANDOM - SAMPLE\n" + DISTANCIAS.toString() + ".\n");
 return INDICES;
}//sample

/**
* GAPS Random sample in KBM2L(PAR) optimiz about gapsXY
**/
private Vector sampleGaps( Vector ipd, protocolo30 p30, lista30 l30) {

  frame30.kbm2lSystem.append( "GAPS - RANDOM - SAMPLE....\n");
  lista30 auxl30 =  null;
 
//no Thread  
  try {
  auxl30 = new proyectionPar30( ).proyectionPar( ipd, (p30.get( p30.size()-1)));
  frame30.kbm2lSystem.append( "analisisSensibilidad dynamic synthesis 1 - KBM2L(PAR):\n" +
    auxl30.Base.Bas() + " Items - " + auxl30.size() + " gapsXY - " + auxl30.gapsXY() + "\n");
  new controlPrefs30().focusPolicy( auxl30.coKB);//opt-gapsXY    
  new controlPrefs30().timeOutTest( 1000);//
  auxl30 = new sintesisHamming230( auxl30).Hamming2( auxl30);
  frame30.kbm2lSystem.append( "analisisSensibilidad dynamic syntehsis 2 - KBM2L(PAR):\n" +
    auxl30.Base.Bas() + " Items - " + auxl30.size() + " gapsXY - " + auxl30.gapsXY() + "\n");
  listStat30.calc( auxl30);  
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "sampleGaps-");
    frame30.exit( 0, e);
  }//catch

  Vector INDICES = new Vector();// l30
    
  try {

    Vector INDICE = null;//new randomkbm2l30().randomINDICE( l30);
//    for( int j = l30.dimparam+1; j < INDICE.size(); j++) {
//      if ( l30.Base.rol( j) == 1)
//        INDICE.set( j, new Integer( -1));// es dim-var
//      }//for-j
  
//    INDICE = analisisSetIndex30.setRef( l30, INDICE);
//    checkIndex30.INDX( auxl30, INDICE);
//    INDICES.add( INDICE.clone());

//muestreo de gaps.
  for( int i = 0; i < auxl30.size()-2; i++) {
    if ( auxl30.esUNKB( auxl30.Get( i+1))) {
      if ( index30.eqS( auxl30.Get( i).GetRespuesta(), auxl30.Get( i+2).GetRespuesta())) {
      //XX
        INDICE = analisisSetIndex30.center( auxl30, i+1);
        checkIndex30.INDX( auxl30, INDICE);
        for( int j = l30.dimparam+1; j < l30.dimension(); j++) {
          //if ( l30.Base.rol( j) == 1)
          INDICE.add( j, new Integer( -1));// es dim-var
        }//for-j
        INDICES.add( INDICE.clone());      
        }
        else {
        //XY
        double sampleSize = Math.log( 
          (auxl30.Get(i+2).getOffsetSup().add( auxl30.Get(i).getOffsetSup().negate())).doubleValue());
        for( int k = 2; k < sampleSize; k++) {
	       INDICE =  analisisSetIndex30.sample( auxl30, i+1, k);
          checkIndex30.INDX( auxl30, INDICE);
          for( int j = l30.dimparam+1; j < l30.dimension(); j++) {
            //if ( l30.Base.rol( j) == 1)
            INDICE.add( j, new Integer( -1));// es dim-var
          }//for-j
          INDICES.add( INDICE.clone());       
         }//for-k
        }//if
    }//if-esUNKB  
  
  }//for-gaps

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "sampleGaps-for");
    frame30.exit( 0, e);
  }//catch

 frame30.kbm2lSystem.append( "GAPS - RANDOM - SAMPLE   " + INDICES.size() + ".\n");
 return INDICES;
}//sampleGaps

/**
* 
**/
private  void commands( BufferedWriter out_bat, int i, Vector ipd, Vector INDICE) {

  String linea = null; // linea del fichero

  try {//
    linea = "REM   " + i;    
    out_bat.write( linea, 0, linea.length()); out_bat.newLine();
    linea = "del " + filePro + ".pro";    
    out_bat.write( linea, 0, linea.length()); out_bat.newLine();
    linea = "copy " + filePro + "-" + dato30.toString( INDICE, "", "") + ".pro " + filePro + ".pro";    
    out_bat.write( linea, 0, linea.length()); out_bat.newLine();
    linea = " ..\\bin\\edi5 "+ filePro + "  1  1  paciente.dat > null";
    out_bat.write( linea, 0, linea.length()); out_bat.newLine();
    for( int k = 3; k < ipd.size(); k++) {
      linea = "ren " + ((String)ipd.get(k)) + " " + 
                       ((String)ipd.get(k)) + "-" + dato30.toString( INDICE, "", "") + ".tdu";
      out_bat.write( linea, 0, linea.length()); out_bat.newLine();
      }//for    
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "commands. fileLabels: " + fileLabels);
    System.out.println( ERROR + "commands. " + dato30.nameFile(fileLabels));
    frame30.exit( 0, e);
  }//catch
  return;
}//commands

/**
* 
**/
private void labels( lista30 l30, Vector INDICE, Vector VALOR) {

  BufferedReader in = null; // protocolo de decisiones -label.txt
  BufferedWriter out = null;// *.pro
  String linea = null; // linea del fichero

  try {//labels -> pro
    in = dato30.openFile( dato30.nameFile( fileLabels), "txt");//master *.pro
    if ( in==null) {
      System.out.println( ERROR + "sampler. in" + ".  " + fileLabels);
      frame30.exit( 0);
      }
    out = new BufferedWriter( new FileWriter( dato30.workspace +  filePro + "-" + 
      dato30.toString( INDICE, "", "") + ".pro"));//
    if ( out==null) {
      System.out.println( ERROR + "sampler. out" + ".  " + fileLabels);
      frame30.exit( 0);
      }

  while (( linea = in.readLine()) != null) {
    linea = new String( linea.trim());
    //parsing label
    linea = new analisisParser30().parser( l30.dimparam, linea, VALOR);//filtro de labels de los parametros
    out.write( linea, 0, linea.length());
    out.newLine();
  }//while
  in.close(); //"-label.txt" 
  out.close(); //"-*.pro" 
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "labels. " + linea + ".  " + fileLabels);
    frame30.exit( 0, e);
  }//catch
  return;
}//labels

/**
* append instancia .itd  
**/
private void instancia( BufferedWriter out_itd, lista30 l30, Vector INDICE, Vector VALOR) {

  String linea = null; // linea del fichero

  try {//
    linea = dato30.toString( INDICE, "", " ") + " ;";
    out_itd.write( linea, 0, linea.length());
    out_itd.newLine();
    linea = ";" + VALOR.toString() + ":" + distancia( l30, INDICE);
    out_itd.write( linea, 0, linea.length());
    out_itd.newLine();
  }//try
  catch (IOException e) {
    System.out.println( ERROR + "instancia. itd - " + linea + ".");
    frame30.exit( 0, e);
  }//catch
  return;
}//instancia
 
/**
* Generador de la muestra de INDICES
**/
private void sampler( Vector ipd, lista30 l30, Vector INDICES) { 
//fichero -label.txt + parsing labels ---> -index.pro  
  BufferedWriter out_bat = null; // call edi5 muestras
  BufferedWriter out_itd = null;// *.itd

  frame30.kbm2lSystem.append( "sampler....\n");

  try {//
    out_bat = new BufferedWriter( new FileWriter( dato30.workspace + filePro + ".bat"));
    out_itd = new BufferedWriter( new FileWriter( dato30.workspace + "Decs" + ".itd"));
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "sampler. out_bat open.");
    frame30.exit( 0, e);
  }//catch
  
  Vector flags = checkIndex30.FLAGS( l30); 
  
  for( int i = 0; i < INDICES.size(); i++) {

    Vector INDICE = (Vector)INDICES.get( i);
    checkIndex30.INDX( l30, INDICE, flags);
    Vector VALOR = Valor( l30, INDICE);
    
    frame30.kbm2lSystem.estatus( "Sampler: " + i + "   INDICE: " + INDICE.toString());

    commands( out_bat, i, ipd, INDICE);
    labels( l30, INDICE, VALOR);
    instancia( out_itd, l30, INDICE, VALOR);
  
    }//for-i

////----

  try {//
    out_itd.close(); 
    for( int k = 3; k < ipd.size(); k++) {
      String linea = "copy Decs.itd " + ((String)ipd.get(k)) + ".itd";
      out_bat.write( linea, 0, linea.length()); out_bat.newLine();
      }//for
  
    out_bat.close(); 
  }//try
  catch (IOException e) {
    System.out.println( ERROR + "sampler. out_bat close.");
    System.out.println( ERROR + "sampler. out_itd close.");
    frame30.exit( 0, e);
  }//catch

  frame30.kbm2lSystem.append( "....sampler\n");
  return;
}//sampler

/**
* exec( filePro.bat)
**/
private void execModel( ) { 

  frame30.kbm2lSystem.append( "execModel....\n");
  boolean threadMode = new controlPrefs30().threadMode();
  try {//
    String osName = System.getProperty("os.name");
    Runtime rt1 = Runtime.getRuntime();
    String cmd = new String("");
    Process pr1 = null;
    BufferedReader in_bat = null; // bat
    in_bat = dato30.openFile( dato30.nameFile( filePro), "bat");// filePro.bat
    if ( in_bat==null) {
      System.out.println( ERROR + "execModel. in_bat" + ".  " + fileLabels);
      frame30.exit( 0);
      }//if
  int commands = 0;
  while (( cmd = in_bat.readLine()) != null) {
    cmd = new String( "CMD.EXE  /C  " + cmd);
    pr1 = rt1.exec(cmd);
    frame30.kbm2lSystem.estatus( "AS: exec i "  + (commands++) + "  " + cmd);

    StreamGobbler errorGobbler = new StreamGobbler(pr1.getErrorStream(), "ERROR");
    StreamGobbler outputGobbler = new StreamGobbler(pr1.getErrorStream(), "OUTPUT");
    errorGobbler.start();
    outputGobbler.start();

    if ( threadMode) 
    try {
      Thread.sleep(Thread.activeCount());//!!!
    }//try
    catch (InterruptedException e) {
      System.out.println( ERROR + "execModel.");
      frame30.exit( 0, e);
    }//catch
    
    int exitVal = pr1.waitFor();
    if ( exitVal!=0)
      System.out.println( "Process exitValue: " + exitVal);
  }//while

  in_bat.close(); // 

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "execModel. runtime." + filePro);
    frame30.exit( 0, e);
  }//catch

  frame30.kbm2lSystem.append( "....execModel\n");
  return;
}//execModel

/**
* Procedimiento de analisis de sensibilidad, con el esquema extendido, de la lista l30. 
* p, 1-p. 
* 1 + k = (1 + k*k1)(1 + k*k2)(1 + k*k3)(1 + k*k4).
**/
public void analisisSensibilidad( ) {

  String pathKBM = null;
  lista30 l30 = null;
  Vector ipd = null;//indice de protocolo

  frame30.kbm2lSystem.append( "Sensitivity Analysis: EKBM2L.\n");
  
  try {//!!!
    ipd = protocolo30.ipdAccess( "");//filename, dimparam, PARAMS, Decs
    if ( ipd == null) {
      frame30.kbm2lSystem.append("IPD not selected.\n");
	   return; 
      }

    filePro = dato30.extFile( dato30.nameFile( (String)( ipd.get( 0))), "");
    fileLabels = dato30.extFile( dato30.extFile( filePro + "-label", ""), "txt");

    Dec1 = dato30.extFile( dato30.nameFile( (String)( ipd.get( 3))), "");//first decision

    l30 = new emptykbm2l30( ).emptyList( 
      new esquema30( "", 0, 0).leerEq( dato30.extFile( Dec1, "eq")));    
    if ( l30 == null) {
      frame30.kbm2lSystem.append("l30 null.\n");
	   return; 
      }
    l30.dimparam = ((Integer)(ipd.get( 1))).intValue();
    l30.PARAMS = (Vector)(ipd.get( 2));
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "analisisSensibilidad. ipdAccess.");
    System.out.println( "ipd: " + ipd.toString());
    System.out.println( "ipd.get( 0): " + ipd.get( 0).toString());
    System.out.println( "ipd.get( 1): " + ipd.get( 1).toString());
    System.out.println( "ipd.get( 2): " + ipd.get( 2).toString());
    System.out.println( "filePro: " + filePro);
    System.out.println( "fileLabels: " + fileLabels);
    System.out.println( "Dec1: " + Dec1);    
    frame30.exit( 0, e);
  }//catch

  Vector SAMPLE0 = sample( l30);
  frame30.kbm2lSystem.append( "SAMPLE0.size(): "+ SAMPLE0.size()+"\n");
  sampler( ipd, l30, SAMPLE0); //instancias del protocolo
  execModel( ); // TDU 
  protocolo30 p30 = new protocolo30( ).protocolo( //protocolo30 ---> extended list.
    dato30.extFile( dato30.extFile( filePro, ""), "ipd"));//no Thread

  int loops = 0;
  while( p30.get( p30.size()-1).size() < 10000) {
//  for( int s = 0; s < 8; s++) {
    Vector SAMPLE1 = sampleGaps( ipd, p30, l30);
    if ( SAMPLE1.size() == 0) break;
    frame30.kbm2lSystem.append( "SAMPLE1.size(): "+ SAMPLE1.size()+"\n");
    sampler( ipd, l30, SAMPLE1);
    execModel( ); // TDU 
    p30 = new protocolo30( ).protocolo( //protocolo30 ---> extended list.
      dato30.extFile( dato30.extFile( filePro, ""), "ipd"));//no Thread
    if ( loops++ > 8) break; 
  }//while

  frame30.p30 = p30;
  
//generalizacion de gaps + explicacion.

  frame30.kbm2lSystem.append( "Sensitivity Analysis. OK\n");
  return;
}//analisisSensibilidad

/**
* Run.
**/
public void run() {

  try {
    analisisSensibilidad( );
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    frame30.exit( 0, e);
  }//catch
  return;
}//run

}//analisisSensibilidad30

/**
* Engullir un Stream
**/
/**
* Clase StreamGobbler.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
class  StreamGobbler  extends  Thread  {
	
	InputStream is;
	String type;

/**
* Constructor por defecto
**/	
StreamGobbler( InputStream is, String type) {
		this.is = is;
		this.type = type;
	}//

/**
* 
**/
public void run() {

  try {
	  InputStreamReader isr = new InputStreamReader( is);
	  BufferedReader br = new BufferedReader( isr);
	  String line=null;
	  while ((line = br.readLine()) != null)
	    System.out.println( type + ">" + line);
	 } catch (IOException ioe) {
		 ioe.printStackTrace();		 
		}	
}//run
	
}//StreamGlobber