//analisisSintactico30//
package analysis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kernel.*;
import kbm2l.*;

/**
* Clase analisisSintactico30
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class analisisSintactico30  extends  analisis30  {

  private static final String ERROR = "Error(analisisSintacico30): ";

/**
* Constructor por defecto
**/
public analisisSintactico30( ) {

}//analisisSintactico30

/**
* Analisis sintactico de un item i
**/
private void asItem( lista30 l30, int i) {

  item30 item = l30.Get( i);
  frame30.kbm2lBrowser.append("ITEM[" + i + "]"+
    "  DC: (" + l30.cutDimension( i) + ")" +
    "  LONG: " + ( item.getLongitud()) + ".\n");
  frame30.kbm2lBrowser.append("S:  " + item.GetRespuesta().toString() + "\n");
  frame30.kbm2lBrowser.append("IxINF:  " + l30.Inf( i).toString() + "\n");
  frame30.kbm2lBrowser.append("IxSUP:  " + l30.Sup( i).toString() + "\n");
  frame30.kbm2lBrowser.append("IdFIJO: " + l30.Fij( i).toString() + "\n");
  frame30.kbm2lBrowser.append("IdVAR:  " + l30.Var( i).toString() + "\n\n");

  return;
}//asItem

/**
* Procedimiento de analisis sintactico de la lista l30 (index analysis).
**/
public void analisisSintactico( lista30 l30) {

  frame30.kbm2lSystem.append("Sintactic Analysis: list simbolic espectrum.\n\n");
  frame30.kbm2lBrowser.setText("Ver. " + 
    "  items(KBM2L): " + l30.size() + 
    "  KBitems: " + listStat30.kb( l30) + 
    "  KBcasos: " + listStat30.KB( l30) + 
    "  unKBitems: " + ( l30.size( ) - listStat30.kb( l30)) + 
    "  unKBcasos: " + 
    ( (new offset30().getLONGITUD( l30.Base.Dom()).subtract( 
       listStat30.KB( l30)))).add(
       BigInteger.ONE) + "\n");

  frame30.kbm2lBrowser.append(
    " D --- (" + l30.Base.Dom().toString() + ")\n B --- (" + l30.Base.Bas().toString() + ").\n\n");

  int numItems = Integer.parseInt( frame30.kbm2lControl.getText( frame30.kbm2lControl.ItemsNumberBrowser)), 
  numItemsVer = 0;

  if ( numItems >= l30.size()) numItemsVer = l30.size(); else numItemsVer = numItems;

  for( int i = 0; i < numItemsVer-1; i++) {
    asItem( l30, i);
    }

  if ( numItems <= l30.size()-1) frame30.kbm2lBrowser.append("............\n");

  asItem( l30, ( l30.size()-1));

  if ( !listStat30.KB( l30).equals( BigInteger.ZERO)) {
    frame30.kbm2lBrowser.append("Sparse-Ratio ( casosKB / itemsKB): " + 
    (listStat30.KB( l30)).divide( BigInteger.valueOf( listStat30.kb( l30))) + "\n\n");
    }

  return;
}//analisisSintactico

}//class analisisSintactico30