//PROYECTIONPARX30//
package analysis;

//
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kernel.*;
import control.*;
import kbm2l.*;
import tables.*;
import analysis.*;

/**
* Clase proyectionParX30, parametros.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class proyectionParX30  extends  proyection30  implements  Runnable  {

  private static final String ERROR = "Error(proyectionParX30): ";

/**
* Constructor por defecto
**/
public proyectionParX30( ) {

  System.out.println( "proyectionParX30");
}//proyectionParX30

/**
* Proyection la lista sobre la respuesta (RRKB, ~RRKB) (RespReferKB, ~RespReferKB).
* @param l30 Lista con el esquema de parametros.
*/
public lista30 proyectionParX_( lista30 l30) {
//l30 es la lista original o la sa-list
  
  boolean chk = new controlPrefs30().checkMode();
  
    try {
  frame30.kbm2lSystem.append( "proyectionParX_. List MOD: " + 
    l30.RRKB.toString() + "/" + l30.RSKB.toString() + ".\n");
  frame30.kbm2lSystem.append( "l30.dimparam: " + l30.dimparam + ".\n");
  frame30.kbm2lSystem.append( "l30.PARAMS:   " + l30.PARAMS.toString() + ".\n");

  listStat30.calc( l30);
  if ( l30.dimension() <= l30.dimparam) {
    frame30.kbm2lSystem.append( 
      "proyectionParX_.  l30.dimparam: " + (l30.dimparam) + 
      ",   dimList: " + (l30.dimension()) +
      ",   there is no attributes.\n");
    return l30; //System.exit( 0);
    } 

  } catch (Exception e) {
    System.out.println( ERROR + "proyectionParX_.0");
    frame30.exit( 0, e);
  }//catch

//// proyectionParX -->>
   new proyection30().REFmodel( l30);

// preparar la lista proyeccion 
  lista30 h30 = new proyection30().proyection( l30);

  working = true;//???? algoritmo ????
  try {
  for( int i = 0; i < l30.size(); i++) {

    frame30.kbm2lSystem.estatus( "projectionPar_. i: " + i + "  h30: " + h30.size());

    if ( new proyection30().beginModel( l30, i)) {

      boolean diff = false;//discrepancia del modelo respecto del RefModel
      int j = i-1; // for items del modelo
      int z = 0;// count-ref.model-items
      do {

        if ( j < l30.size()-1) 
          j++; 
          else break;  //items etiquetados en un modelo  

        if ( !diff) diff = ( !index30.eqS( l30.Get( j).GetRespuesta(), l30.Get( k+z).GetRespuesta()) ||
           ( l30.Get( j).getLongitud().doubleValue() != l30.Get( k+z).getLongitud().doubleValue())); 

        z++;
      } while( !new proyection30().endModel( l30, j)); //while-j      

      if ( diff) {// hay diff
        h30.Set( new item30( h30, l30.Get( i).GetMedida(), h30.RSKB, 
          index30.cpT( l30.Get( i).GetIndice(), l30.dimparam)));// es sensible y se registra en h30, 
       }  
        else {// no hay diff
        h30.Set( new item30( h30, l30.Get( i).GetMedida(), h30.RRKB, 
          index30.cpT( l30.Get( i).GetIndice(), l30.dimparam)));// == no sensible, es ref
        }//if

      if ( l30.esUNKB( l30.Get( j))) 
        if ( j < l30.size()-1) 
          j++; 
          else break;

      i = j;
      }//if
    }//for-i

  } catch (Exception e) {
    System.out.println( ERROR + "proyectionParX_.1");
    frame30.exit( 0, e);
  }//catch

  try {
  for( int i = 0; i < h30.size(); i++) {

	 if ( index30.eqS( h30.Get( i).GetRespuesta(), h30.RSKB)) {// es diff
		Vector MODRES = index30.cpS( h30.RSKB); 
		MODRES.set(  0, new Integer( i));
      h30.Get( i).SetRespuesta( MODRES);      

//// proyectionParX -->>
    new proyection30().refmodel( l30, h30.Get( i).GetIndice());

    frame30.kbm2lSystem.estatus( "ReEtiqu.....i: " + i);

    for( int s = 0; s < l30.size(); s++) {

      frame30.kbm2lSystem.estatus( "projectionPar_. s: " + s);

    if ( new proyection30().beginModel( l30, s)) {

      boolean diff = true;//discrepancia del modelo s respecto del iModel
      int j = s-1; // for items del modelo s
      int z = 0;// count-ref.model-items
      do {

        if ( j < l30.size()-1) 
          j++; 
          else break;  //items etiquetados en un modelo  

        if ( diff) diff = ( !index30.eqS( l30.Get( j).GetRespuesta(), l30.Get( k+z).GetRespuesta()) ||
           ( l30.Get( j).getLongitud().doubleValue() != l30.Get( k+z).getLongitud().doubleValue())); 

        z++;
      } while( !new proyection30().endModel( l30, s)); //while-j      

      if ( !diff) {// no hay diff
        h30.Set( new item30( h30, 
          h30.Get( i).GetMedida(), h30.Get( s).GetRespuesta(), h30.Get( i).GetIndice()));// == no sensible, es s
        break;  
        }//if

      if ( l30.esUNKB( l30.Get( j))) 
        if ( j < l30.size()-1) 
          j++; 
          else break;

      s = j;
      }//if
    }//for-s	    
   }
  }//for-i

  } catch (Exception e) {
    System.out.println( ERROR + "proyectionParX_.2");
    frame30.exit( 0, e);
  }//catch

  listStat30.calc( h30);
  frame30.kbm2lBrowser.summaryView( h30);
  working = false;
  return h30;  
}//proyectionParX_

/**
* La lista l30 tiene p dimensiones parametricas y el resto atributos
* se trata de generar la lista de modelos, proyectando.
* la secuencia del modelo de referencia definido en analisis30.PARAMS se compara
* con las secuencias homologas en otros modelos y se completa la lista h30
* con RRKB si coincide y RSKB si es sensible.
* Se podia generalizar la respuesta para almacenar la lista del modelo en el 
* esquema complementario de atributos.
**/
public void proyectionParX( Vector ipd, lista30 l30) {

  lista30 h30 = null; 
  if (ipd == null) 
    ipd = protocolo30.ipdAccess( "");//filename, dimparam, PARAMS, Decs
  l30.dimparam = ((Integer)(ipd.get(1))).intValue();
  l30.PARAMS = (Vector)(ipd.get(2));
  if ( listStat30.KB( l30).doubleValue() > 0.0) {
    h30 = proyectionParX_( l30);    
    new outputList30( ).escribeKBM2L( h30,
      dato30.workspace + dato30.extFile( dato30.nameFile( h30.Name()), "hkb"));//no filedlg        
    }//if
    else frame30.kbm2lSystem.estatus("proyection. Any: " + l30.size());

  return;
}//proyeccionParX

/**
* Run.
**/
public void run() {

  try {
    long ts0 = (new Date()).getTime();
    proyectionParX( null, frame30.activel30);
    frame30.kbm2lTime.append("proyectionParX:: " + (new Date().getTime() - ts0) + ".\n");        
 }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    frame30.exit( 0, e);
  }//catch
  return;
}//run

}//class proyectionParX30
