//MathProg30//
package mathprog;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kernel.*;
import kbm2l.*;
import modelo.*;
import spectrum.*;

/**
* Clase MathProg30
*
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class MathProg30  extends  frame30  implements  Runnable {

  private static final String ERROR = "Error(MathProg30): ";
  private static boolean working = false;
  private frame30 f30 = null;

  protected static int tipoOR = -1;
  protected static final int MINIMO = 0;
  protected static final int MAXIMO = 1;
  public static final int ProgramaEntero = 0;
  public static final int ProgramaContinuo  = 1;
  public static final int ProgramaMixto  = 2;

  protected final int NumeroVariables  = 10;
  protected final int DominioVariables  = 2;
  protected int NumeroRestricciones  = 5;

public MathProg30( int tipoOR) {

  working = false;
  this.tipoOR = tipoOR;
}//OR30

public item30 componerItem( lista30 l30) {
//medida min-max

   Vector MEDIDA = new Vector();  
   double obj = mod30.Objetivo( );
   Vector RESPUESTA = new Vector();
   RESPUESTA = index30.cpS( mod30.Factible( 3)); // NumeroRestricciones
   Vector INDICE = new Vector();
   INDICE = index30.cpT( mod30.Variables);
   
   item30 item = l30.GET( INDICE);
   
   if ( index30.eqS( item.GetRespuesta(), index30.unRespuesta( l30.ParRespuesta()))) {
     MEDIDA.add( new Double( obj));//min
     MEDIDA.add( new Double( obj));//max
     }
     else {

        double obj_min = ((Double)((Vector)item.GetMedida()).get( MINIMO)).doubleValue();
        if (obj_min > obj) { MEDIDA.add( new Double( obj));//min
          } else { MEDIDA.add( new Double( obj_min));//min
            }

        double obj_max = ((Double)((Vector)item.GetMedida()).get( MAXIMO)).doubleValue();
        if (obj_max < obj) { MEDIDA.add( new Double( obj));//min
          } else { MEDIDA.add( new Double( obj_max));//min        
            }

     }//if    
 
   item30 itemOpt = new item30( l30, MEDIDA, RESPUESTA, INDICE);

   l30.Set( itemOpt );//!!! NEW
  
   itemOpt = new item30( l30, MEDIDA, RESPUESTA, item.GetIndice()); 

   l30.Set( itemOpt );//!!! OPT
   
   return item; 
}//componerItem

public lista30 OptimizacionEntera( frame30 f30) {

  kbm2lSystem.append("Optimizacion Entera - Inicio.\n");

  lista30 l30 = new lista30( "PE", 2, //medida min-max
    NumeroRestricciones, NumeroVariables, DominioVariables);

  mod30 = new modelo30( NumeroVariables, NumeroRestricciones, DominioVariables-1);//

  long instancias = 0;

  while (( working) && ( !listStat30.completa( l30))) {
    mod30.GenerarVariableUniforme( );
    long entorno = NumeroVariables * DominioVariables;
    do {    
      instancias ++;
      item30 item = componerItem( l30);
      if ( index30.myT( index30.ultimoT( l30.Base.Dom()), mod30.Variables))
        mod30.Variables = index30.siguienteT( l30.Base.Dom(), mod30.Variables);
      } while ( (entorno--) > 0);  
      if (( instancias % 100) == 0) {
        kbm2lBrowser.listView( l30); 
        new Thread( new spectrumPaint30( f30)).start();
        }
      if ( l30.size() > 10 * listStat30.DS( l30).size())  
        Refinar( l30);
    }//while

  kbm2lSystem.append("Optimizacion Entera - Fin.\n");
  working = false;
  return l30;
}//OptimizacionEntera


public lista30 OptimizacionContinua( frame30 f30) {

  kbm2lSystem.append("Optimizacion Continua - Inicio.\n");

  kbm2lSystem.append("Optimizacion Continua - Fin.\n");

  working = false;
  return null;
}//OptimizacionContinua

public lista30 OptimizacionMixta(frame30 f30) {

  kbm2lSystem.append("Optimizacion Mixta - Inicio.\n");

  kbm2lSystem.append("Optimizacion Mixta - Fin.\n");

  working = false;
  return null;
}//OptimizacionMixta

public void Refinar( lista30 l30) {
// l30: fusion de items en subobjetivos, 
// mod30: aadir restriccion-subobjetivo y 
// eliminar restricicones redundantes(?)

  kbm2lSystem.append("Refinar - Inicio.\n");
  double obj = -1000.0, subobj = -1000.0;
  
  Vector factible = new Vector();
  for ( int i = 0; i < NumeroRestricciones; i++)
    factible.add( new Integer( 1));//todas factibles

//fijar maximo y subojetivos
  try {
  for( int i = 0; i < l30.size(); i++) {
    item30 item = l30.Get( i);
    if ( !index30.eqS( item.GetRespuesta(), index30.unRespuesta( l30.ParRespuesta()))) 
      if ( index30.eqS( item.GetRespuesta(), factible)) {
      double obj_max = ((Double)((Vector)item.GetMedida()).get( MAXIMO)).doubleValue();
      if (obj_max > obj) obj = obj_max;
      if ((obj_max > subobj)&&( obj_max < obj)) subobj = obj_max;    
      }
    }//for
  } catch (Exception e){
      System.out.println("e. Refinar - Inicio.");
      e.printStackTrace();
  }
  
  kbm2lSystem.append("Refinar - Inicio. obj: " + obj + "   subobj: " + subobj + ".\n");
  kbm2lSystem.append("Refinar - fusion. l30.size(): " + l30.size() + ".\n");

  try {
  for( int i = 0; i < l30.size()-1; i++) {
 
    item30 item1 = l30.Get( i);
    double obj_max1 = ((Double)((Vector)item1.GetMedida()).get( MAXIMO)).doubleValue();
    double obj_min1 = ((Double)((Vector)item1.GetMedida()).get( MINIMO)).doubleValue();
    item30 item2 = l30.Get( i+1);
    double obj_max2 = ((Double)((Vector)item2.GetMedida()).get( MAXIMO)).doubleValue();
    double obj_min2 = ((Double)((Vector)item2.GetMedida()).get( MINIMO)).doubleValue();

    if ( !index30.eqS( item1.GetRespuesta(), index30.unRespuesta( l30.ParRespuesta())) && 
         !index30.eqS( item2.GetRespuesta(), index30.unRespuesta( l30.ParRespuesta()))) {//kb

      if ( index30.eqS( item1.GetRespuesta(), factible) && ( obj_max1 <= subobj)||//fact+subobj
           !index30.eqS( item1.GetRespuesta(), factible)) {//infactible

        if ( index30.eqS( item1.GetRespuesta(), factible) && ( obj_max1 <= subobj)||//fact+subobj
             !index30.eqS( item2.GetRespuesta(), factible)) {//infactible

//            i = 0;//reset
            if ( obj_min1 < obj_min2) 
              ((Vector)item2.GetMedida()).set( MINIMO, new Double (obj_min1));
            if ( obj_max1 > obj_max2) 
            ((Vector)item2.GetMedida()).set( MAXIMO, new Double( obj_max1));
            //resp2 = resp1 && resp2;

            if ( !index30.eqS( l30.Get( i).GetRespuesta(), factible)) 

            l30.REMOVE( i);            
            if ( i > 0) {
              
              if ( index30.eqS( l30.Get( i-1).GetRespuesta(),
                                l30.Get( i).GetRespuesta())) {
              l30.REMOVE( i-1);
                }
              }  
            //mod30.Refinar( f30, subobj);      
            //NumeroRestricciones++;
          }  
        }  
      }
    }//for  
  } catch (Exception e){
      System.out.println( ERROR + "Refinar - fusion.");
      e.printStackTrace();
  }

  l30 = l30;
  kbm2lSystem.append("Refinar - fusion. l30.size(): " + l30.size() + ".\n");
    kbm2lSystem.append("Refinar - Fin.\n");

  return;
}//Refinar

public void run() {

  if ( !working) {
  working = true;
    try {
  if ( tipoOR == ProgramaEntero) {
    f30.activel30 = OptimizacionEntera( f30);
    } else
  if ( tipoOR == ProgramaContinuo) {
    f30.activel30 = OptimizacionContinua( f30);
    } else 
  if ( tipoOR == ProgramaMixto) {
    f30.activel30 = OptimizacionMixta( f30);
    } else {
    System.out.println( ERROR + "run(). tipoOR.\n");
    System.exit( 0);
    }
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().\n");
    e.printStackTrace();
    System.exit( 0);
  }//catch
  }
  return;
}//run

/**
* Entrada de la aplicacion
**/
public static void main( String args[]) {

  return;  
}//main

}//class MathProg30