//CONTROL30//
package control;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kernel.*;
import kbm2l.*;
import menu.*;
import tables.*;
import synthesis.*;

/**
* Clase control30.
* Propiedades del control: parametros de aplicacion.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  control30  implements  Runnable {

  private static final String ERROR = "Error(control30): ";

  protected static frame30 f30 = null;
  protected TextArea taCtl = null;  
  protected String oldCtl = null;
  
  public static Random gr = null;

//[SECTION - ]
//property(descrition):valor;
//.....

//SECTION - KBM2L LISTS
/**
* Directorio de trabajo.
**/
  public static final String WorkSpace         =   "WorkSpace";
/**
* Protocolo de decisiones (archivo).
**/
  public static final String ProtocolName      =   "ProtocolName";
/**
* Esquema de la lista (archivo).
**/
  public static final String ListSchema        =   "ListSchema";
/**
* Lista activa (archivo).
**/
  public static final String ListName          =   "ListName";
/**
* Tamao de la lista activa (numero).
**/
  public static final String ListSize          =   "ListSize";

//SECTION - MAIN PREFERENCES
/**
* Se verifica la consistencia de las listas en todas las trasnformaciones y operaciones
**/
  public static final String CheckMode         =   "CheckMode";// Y/N
/**
* Modo de Ejecucion 
**/
  public static final String ThreadMode         =   "ThreadMode";// Y/N
/**
* Modo de Ejecucion para la copia
**/
  public static final String ThreadCplMode      =   "ThreadCplMode";// Y/N
/**
* Semilla del generador
**/  
  public static final String RandomSeed        =   "RandomSeed";// int
/**
* Tipo de protocolo: se contruye el protocolo con input de tablas o listas.
**/  
  public static final String ProtocolType       =   "ProtocolType";// Table/List
/**
* Maximo numero de casos KB.
**/  
  public static final String KBCasesLengthOVF   =   "KBCasesLengthOVF";//BigInt
/**
* Maxima longitud de una lista.
**/  
  public static final String ItemLengthOVF      =   "ItemLengthOVF";//Int
/**
* Maxima numerode instancias.
**/  
  public static final String InstancesOVF       =   "InstancesOVF";//Int
/**
* UtilityManager.
**/  
  public static final String UtilityManager       =   "UtilityManager";// Max/Min/Avg
/**
* OutPutData.
**/  
  public static final String OutPutData   =   "OutPutData";// Data/Code

//SECTION - BROWSER PREFERENCES
/**
* Muestra la informacion del systema breve o extendida
**/
  public static final String VerboseSystem       =   "VerboseSystem";// Y/N
/**
* Primer item que se muestra en el browser.
**/
  public static final String FirstItemBrowser    =   "FirstItemBrowser";
/**
* Numero de items que se muestran en le browser desde el primero.
**/  
  public static final String ItemsNumberBrowser    =   "ItemsNumberBrowser";
/**
* Tamao de items que se muestran en le browser desde el primero.
**/  
  public static final String ItemsSizeBrowser    =   "ItemsSizeBrowser";// 1,2,3,4...
/**
* Muestra la informacion del browser breve o extendida
**/
  public static final String VerboseBrowser        =   "VerboseBrowser";// Y/N
/**
* Item que fija la modalidad de respuesta en la lista, para size, sintesis, browser,...
**/
  public static final String FocusPolicy           =   "FocusPolicy";//-1,0,1,2,3,
/**
* Muestra el grafico Spectrum respecto de casos o items
**/
  public static final String SpectrumChart          =   "SpectrumChart";// Case/Item
/**
* Fija una resolucion de ancho en pixels para el grafico de Spectrum.
**/
  public static final String SpectrumResolution     = "SpectrumResolution"; 
/**
* Para el grafico de Spectrum estable el numero de lineas.
**/
  public static final String SpectrumLines        = "SpectrumLines"; // 1,2,...50,...
/**
* Para el grafico de Spectrum muestra limites de los items en negro.
**/
  public static final String SpectrumItemsVBars      = "SpectrumItemsVBars"; // Y/N

//SINTHESYS 
/**
*
**/
  public static final String NBase             = "NaturalBase";//Y/N
/**
* Historia de sintesis
**/  
  public static final String ListHistory       =   "ListHistory";// Y/N
/**
* Copia rapida.
**/
  public static final String FastCopy          =   "FastCopy";// Y/N
/**
* Copia with ModalCriterion.
**/
  public static final String ModalCriterion     =   "ModalCriterion";// Y/N
/**
* Copia with ImprovementTest, aTest.
**/
  public static final String AttributeTest    =   "AttributeTest";// Y/N
/**
* Copia with ImprovementTest, bTest.
**/
  public static final String BaseTest    =   "BaseTest";// Y/N
/**
* Copia with ImprovementTest, iTest.
**/
  public static final String ImprovementTest    =   "ImprovementTest";// Y/N
/**
* % de comparacion de Switches. 100% es swTarget > swSource * (ImprovTestParam / 100)
**/
  public static final String ImprovTestParam    =  "ImprovTestParam";// % int
/**
* tiempo de iTest. mseg.
**/
  public static final String TimeOutTest    =  "TimeOutTest";// int

//
/**
* Heuristica G0
**/ 
  public static final String HeuristicG0       =   "HeuristicG0";// Y/N
  public static final String Range             =   "Range";// 0..n
//
/**
* Genetico: tamao de la poblacion
**/
  public static final String PoblacionSize     =   "PoblacionSize";// int
/**
* Tiempo de proceso de fitness, -1 -- indefinido
**/  
  public static final String TimeOutFitness    =   "TimeOutFitness";// int


//SECTION - ANALYSIS PREFERENCES
  public static final String SensitivityAnalisysDimen    =   "SensitivityAnalisysDimen";
  public static final String SensitivityAnalisysParam    =   "SensitivityAnalisysParam";
  public static final String OptimizeReferenceModel      =   "OptimizeReferenceModel";
//SECTION - LEARNING PREFERENCES


//QUERY - SYSTEM
/**
* El dialog de consultas es modal/no modal
**/
  public static final String ModalQueryDialog  =   "ModalQueryDialog";// Y/N
/**
* 
**/
  public static final String BrowseQuery       =   "BrowseQuery";// Y/N
/**
* 
**/
  public static final String AproxClosedQuery   =   "AproxClosedQuery";// L/LL/LR/U

//AproxClosedQuery
/**
* Modo de AproxClosedQuery
**/
    public static final String Lower           =   "L";
/**
* 
**/
    public static final String Left            =   "LL";
/**
* 
**/
    public static final String Right           =   "LR";
/**
* 
**/
    public static final String Upper           =   "U";  

//AprendizajeBayesiano
/**
* Cabera del conjunto de datos de apredizaje del K2.
**/
  public static final String HeadK2BayesQuery  =   "HeadK2BayesQuery";// Y/N
/**
* Numero de entradas en el conjunto de datos con los que se aprende la red bayesiana
* en la pregunta general. -1 es todos los disponibles, KB-casos.
**/
  public static final String SubKBLearningSize =   "SubKBLearningSize";//-1,0,1,2,3,
/**
* Nombre, del conjunto de datos con los que se aprende la red bayesiana
* en la pregunta general.
**/
  public static final String SubKBLearningName =   "SubKBLearningName";//-1,0,1,2,3,
/**
* El learning data set proyecta o no las dimensiones atributos instanciadas.
* Si proyecta NO parecen en el conjunto.
**/
  public static final String SubKBProjection = "SubKBProjection";// Y/N
/**
* Mascara de proyecccion al conjunto de datos de apredizaje del K2
**/
  public static final String SubKBMeasure = "SubKBMeasure";// Y/N
/**
* Mascara de proyecccion al conjunto de datos de apredizaje del K2
**/
  public static final String SubKBResponse = "SubKBResponse";// Y/N
/**
* Mascara de proyecccion al conjunto de datos de apredizaje del K2
**/
  public static final String SubKBIndex = "SubKBIndex";// Y/N

//SECTION - TOOLS
/**
* Fija el atributo que se traslada a la posicion 0, mas izquierda, de mayor peso
* Fija el atributo movil, swap, de mayor peso
**/
  public static final String OnTopAttribute    = "onTopAttribute";//int
/**
* Fija el atributo que se traslada a la posicion size(), mas derecha, de menor peso
* Fija el atributo movil, swap, de menor peso
**/
  public static final String OnBotAttribute    = "onBotAttribute";//int
/**
* Fija el radio del entorno del la base en el estudio metrico 
**/
  public static final String NRadius      = "NRadius";//int
/**
* Fija la dimension de atributo para una kbm2l (T) generada al azar
**/
  public static final String RandomDimension   = "RandomDimension";//int
/**
* Fija el dominio de atributo para una kbm2l (T) generada al azar
**/
  public static final String RandomDomain      = "RandomDomain";//int
/**
* Fija el numero de items para una kbm2l (T) generada al azar
**/
  public static final String RandomnItems      = "RandomnItems";//int
/**
* Fija el numero de casos para una kbm2l (T) generada al azar
**/
  public static final String RandomnCases      = "RandomnCases";//int

//SECTION - CPT
/**
* Fija la dimension de atributo para una kbm2l (CPT) generada al azar
**/
  public static final String CPTDimension   = "CPTDimension";//int
/**
* Fija el dominio de atributo para una kbm2l (CPT) generada al azar
**/
  public static final String CPTDomain      = "CPTDomain";//int
/**
* Fija el numero de items para una kbm2l (CPT) generada al azar
**/
  public static final String CPTnItems      = "CPTnItems";//int

////
////
/**
* Valor de preferencia afirmativo
**/
  protected static final String Yes             =   "Yes";
/**
* Valor de preferencia negativo
**/  
  protected static final String No              =   "No";

/**
* Valor de preferencia Data
**/
  protected static final String Data             =   "Data";

/**
* Valor de preferencia Code
**/
  protected static final String Code             =   "Code";

/**
* Valor de preferencia Case
**/
  protected static final String Case             =   "Case";
/**
* Valor de preferencia Item
**/  
  protected static final String Item              =   "Item";

/**
* Valor de preferencia Table
**/
  protected static final String Table             =   "Table";
/**
* Valor de preferencia List
**/
  protected static final String List              =   "List";

////
////
  public static Frame frame = null;
  public menuBarControl30 kbm2lMenu = null;

/**
* Constructor por defecto
**/
public control30( ) {

}//control30

//control30
/**
* Constructor 
**/
public control30( frame30 f30) {

  this.f30 = f30;
  frame = new Frame( "KBM2L30 = " + "CONTROL - ");
  control();
  
  return;  
}//control30

/**
* Configuracion de la ventana de control
**/
public void control() {

//MenuApp
  kbm2lMenu = new menuBarControl30( f30);
  frame.setMenuBar( kbm2lMenu.mainMenu);

//Layout
  GridBagConstraints C = new GridBagConstraints();
  GridBagLayout gbl = new GridBagLayout();

  C.gridx = 0; C.gridy = 0; C.gridwidth = 2; C.gridheight = 2; C.fill = GridBagConstraints.BOTH; 
  C.ipadx = 0; C.ipady = 0; C.insets = new Insets(5,5,5,5); C.anchor = GridBagConstraints.CENTER;
  C.weightx = 2; C.weighty = 12;
  taCtl = new TextArea(); gbl.setConstraints( taCtl, C); frame.add( taCtl);//+++

  frame.setLayout( gbl); 
  iniControl();
  
}//Control

/**
* Inicializacion de la ventana de control
**/
public void iniControl() {

  setText( iniCtl());
  oldCtl = new String( getText());
//  control30.gr = new Random( new controlPrefs30().randomSeed());
  gr = new Random(  1227);
  frame.setLocation( 600, 0);
  frame.setSize( 300, 670);
  frame.setVisible(true);
  frame.toFront();  

}//iniControl()

/**
* Inicializacion de las preferencias, propiedades de aplicacion.
**/
protected String iniCtl() {

  String iniCtlStr = new String( "KBM2L 30.0   Control 30.0\n"    + 

  "\n" +
  "[SECTION - KBM2L LISTS]\n"               +
  WorkSpace        +  "(path): ?;\n"        + 
  ProtocolName     +  "(name): ?;\n"        +
  ProtocolType     +  "(Table/List): Table;\n"  +
  ListSchema       +  "(name): ?;\n"        +
  ListName         +  "(name): ?;\n"        +
  ListSize         +  "(num): ?;\n"         +

  "\n" +
  "[SECTION - MAIN PREFERENCES]\n"                 +
  CheckMode        +  "(Yes/No): No;\n"            +
  ThreadMode       +  "(Yes/No): Yes;\n"           +
  ThreadCplMode    +  "(Yes/No): No;\n"            +
  RandomSeed       +  "(num): 1492;\n"             +
  KBCasesLengthOVF +  "(num): 100000000;\n"        +
  ItemLengthOVF    +  "(num): 240000;\n"           +
  InstancesOVF     +  "(num): 0;\n"                +
  OutPutData       +  "(Data/Code): Data;\n"       +
  UtilityManager   +  "(None/Max/Min/Avg): None;\n"      +

  "\n" +
  "[SECTION - BROWSER PREFERENCES]\n"              +
  VerboseSystem       +  "(Yes/No): No;\n"         +
  VerboseBrowser      +  "(Yes/No): No;\n"         +
  FirstItemBrowser    +  "(num): 0;\n"             +
  ItemsNumberBrowser  +  "(num): 200;\n"           +
  ItemsSizeBrowser    +  "(num): 1;\n"             +
  FocusPolicy         +  "(num): -1;\n"            +
  SpectrumChart       +  "(Case/Item): Case;\n"    +
  SpectrumResolution  +  "(num): 8.0;\n"           +
  SpectrumLines       +  "(num): 2;\n"             +
  SpectrumItemsVBars  +  "(Yes/No): No;\n"         +

  "\n" +
  "[SECTION - SINTHESYS PREFERENCES]\n"        +
  OnTopAttribute  +  "(num): 0;\n"             +
  OnBotAttribute  +  "(num): 0;\n"             +
  NBase           +  "(Yes/No): Yes;\n"        +
  ListHistory     +  "(Yes/No): Yes;\n"        +
  FastCopy        +  "(Yes/No): No;\n"         +
  ModalCriterion  +  "(Yes/No): No;\n"         +
  AttributeTest   +  "(Yes/No): No;\n"         +
  BaseTest        +  "(Yes/No): Yes;\n"        +
  ImprovementTest +  "(Yes/No): No;\n"        +
  ImprovTestParam +  "(num %): 100;\n"         + 
  TimeOutTest     +  "(num): 3000;\n"           +
//heuristics params lists
  HeuristicG0     +  "(Yes/No): No;\n"         +
  Range           +  "(0..n): 0;\n"            + 
//genetico
  PoblacionSize   +  "(num): 7;\n"             +
  TimeOutFitness  +  "(num): 5000;\n"           +

  "\n" +
  "[SECTION - ANALYSIS PREFERENCES]\n"         +
//
  SensitivityAnalisysDimen +  "(num): 0;\n"             +
  SensitivityAnalisysParam +  "()(num)(...,num): ;\n"   +
  OptimizeReferenceModel   +  "(Yes/No): No;\n"         +

  "\n" +
  "[SECTION - LEARNING PREFERENCES]\n"         +
//

  "\n" +
  "[SECTION - QUERY PREFERENCES]\n"              +
  ModalQueryDialog  +  "(Yes/No): No;\n"         +
  BrowseQuery       +  "(Yes/No): Yes;\n"        +
  AproxClosedQuery  +  "(L,LL,LR,U): L;\n"       +
  HeadK2BayesQuery  +  "(Yes/No): Yes;\n"        +
  SubKBLearningSize +  "(num): 5000;\n"          +   
  SubKBLearningName +  "(name): subKBM2L.dat;\n" +
  SubKBProjection   +  "(Yes/No): No;\n"         +
  SubKBMeasure      +  "(Yes/No): No;\n"         +
  SubKBResponse     +  "(Yes/No): Yes;\n"        +
  SubKBIndex        +  "(Yes/No): Yes;\n"        +
 
  "\n" +
  "[SECTION - TOOLS]\n"     +
  NRadius                   +  "(num): 2;\n"    +
  RandomDimension           +  "(num): 10;\n"   +
  RandomDomain              +  "(num): 2;\n"    +
  RandomnItems              +  "(num): 20;\n"   +
  RandomnCases              +  "(num): 200;\n"  +
  
  "\n" +
  "[SECTION - CPT]\n"    +
  CPTDimension           +  "(num): 10;\n"    +
  CPTnItems              +  "(num): 1000;\n"  +
  CPTDomain              +  "(num): 2;\n"     +
  
  "\n" +
  "[SECTION - ]\n"  
  
  );

//datos por efecto

  setText( iniCtlStr);
  
//datos actuales

  if ( dato30.workspace != null) 
    setText( WorkSpace, dato30.workspace);

  if ( f30.activel30 != null) {
    setText( ListName, f30.activel30.Name());
    setText( ListSize, String.valueOf( f30.activel30.size()));
    if ( f30.p30 != null)
      if ( f30.p30.name != null)
        setText( ProtocolName, f30.p30.name);
    if ( f30.activel30.Esqu != null)  
    setText( ListSchema, f30.activel30.Esqu.nombre);
    }
  
  return getText();
}//iniCtl

/**
* Texto de preferencias
**/
public String getText( ) {
     
  return taCtl.getText( );
}//getText

/**
* Nuevo texto de preferencias
**/
public void setText( String str) {
  
  taCtl.setText( str); 
  return;
}//setText

/**
* Texto de preferencias de la propiedad arg.
* @param tkProperty literal de preferencias.
* @return literal del valor de la propiedad.
**/
public String getText( String tkProperty) {
     
  String strValor = null;   
  try {
    String strControl = getText( ).trim();//texto de preferencias
//Property  
    strControl = strControl.substring( strControl.indexOf( tkProperty), strControl.length()).trim();
    strValor = strControl.substring( strControl.indexOf(':')+1, strControl.indexOf(';')).trim();
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "getText()." + strValor.trim());
    e.printStackTrace();
    catchCtl( tkProperty);//recuperacion de error
  }//catch

  return strValor.trim();  
}//getText

/**
* Nuevo valor de la preferencias arg.
* @param tkProperty literal de preferencias.
* @param strValor literal de valor de preferencias.
* @return literal del valor de la propiedad.
**/
public String setText( String tkProperty, String strValor) {
     
  try {
    String strMain = getText( ).trim();//texto de preferencias
    int IndexProperty = strMain.indexOf( tkProperty);
    String strPrefijo = strMain.substring( 0, strMain.indexOf( ':', IndexProperty)+1);
    String strSufijo =  strMain.substring( strMain.indexOf( ';', IndexProperty), strMain.length());
    setText( strPrefijo + strValor + strSufijo);
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "setText().");
    e.printStackTrace();
    catchCtl( tkProperty);//recuperacion de error
    f30.kbm2lSystem.append( "Value Error : " + strValor);
  }//catch

  return getText( );  
}//setText

/**
* append
**/
public void append( String str) {
  
  taCtl.append( str); 
  return;
}//append

/**
* Exception handler
**/
protected void catchCtl( String strMsgError) {
  
  f30.kbm2lSystem.append( "Property Error: " + strMsgError + "\n");
  setText( oldCtl);//recuperacion de error
  return;
}//catchCtl

////
/**
*
**/
public void run() {

  try {
//lectura de prefeencias?

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
  }//catch
  
  return;
}//run

}//class control30
