//CONTROLPREFS30//
package control;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;
//import javax.swing.JDialog;

//
import kernel.*;
import kbm2l.*;

/**
* Clase controlPrefs30.
* Preferencias de procesos
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  controlPrefs30  extends  control30  implements  Runnable  {

  private static final String ERROR  =  "Error(controlPrefs30): ";
  private static final boolean chkprefs = false;
/**
* Constructor por defecto
**/
public controlPrefs30() {

}//control30Prefs

//// SECTION MAIN PREFERENCES

/**
* Preferencias: CheckMode: Yes/No.
**/
public static boolean checkMode( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("\n"); 
    return Yes.compareTo(f30.kbm2lControl.getText( f30.kbm2lControl.CheckMode)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.CheckMode);
    return false;
    }//catch
}//checkMode

/**
* Preferencias: ThreadMode: Yes/No.
**/
public static boolean threadMode( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("threadMode\n"); 
    return Yes.compareTo(f30.kbm2lControl.getText( f30.kbm2lControl.ThreadMode)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.ThreadMode);
    return false;
    }//catch
}//threadMode

/**
* Preferencias: ThreadCplMode: Yes/No.
**/
public static boolean threadCplMode( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("threadCplMode\n"); 
    return Yes.compareTo(f30.kbm2lControl.getText( f30.kbm2lControl.ThreadCplMode)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.ThreadCplMode);
    return false;
    }//catch
}//threadCplMode

/**
* Preferencias: randomSeed: int. 0,1,2,3,....
**/
public static long randomSeed( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("randomSeed\n"); 
    return (long)(Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.RandomSeed)));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.RandomSeed);
    return (long)(1227);//
    }//catch  
}//randomSeed

/**
* Preferencias: ProtocolType: Table/List.
**/
public boolean protocolType( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("protocolType\n"); 
    return Table.compareTo( f30.kbm2lControl.getText( f30.kbm2lControl.ProtocolType)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.ProtocolType);
    return false;
    }//catch
}//protocolType

/**
* Preferencias: ProtocolType: Table/List.
**/
public boolean protocolType( String pType) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("protocolType\n"); 
    f30.kbm2lControl.setText( f30.kbm2lControl.ProtocolType, pType);
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.ProtocolType);
    return false;
    }//catch
  return Table.compareTo( f30.kbm2lControl.getText( pType)) == 0;  
}//protocolType

/**
* Preferencias: KBCasesLengthOVF: int. 1000000000,....
**/
public long KBCasesLengthOVF( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("KBCasesLengthOVF\n"); 
    return (long)(Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.KBCasesLengthOVF)));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.KBCasesLengthOVF);
    return (long)(1000000000);//
    }//catch  
}//KBCasesLengthOVF

/**
* Preferencias: ItemLengthOVF: int. 10000,....
**/
public int itemLengthOVF( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("itemLengthOVF\n"); 
    return (Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.ItemLengthOVF)));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.ItemLengthOVF);
    return (10000);//
    }//catch  
}//itemLengthOVF

/**
* Preferencias: InstancesOVF: int. 0,100,....
**/
public int instancesOVF( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("instancesOVF\n"); 
    return (Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.InstancesOVF)));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.InstancesOVF);
    return (0);//
    }//catch  
}//instancesOVF

/**
* Preferencias: UtilityManager: None-(-1)/Max-0/Min-1/Avg-2.
**/
public static int utilityManager( ) {

  String Max = "Max";
  String Min = "Min";
  String Avg = "Avg";
  String Manager = f30.kbm2lControl.getText( f30.kbm2lControl.UtilityManager);

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("UtilityManager\n"); 
	 if ( Max.compareTo( Manager) == 0) 
      return 0; 
      else if ( Min.compareTo( Manager) == 0) 
      return 1; 
      else if ( Avg.compareTo( Manager) == 0) 
      return 2; 
      else return -1;// None
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.UtilityManager);
    return -1;
    }//catch
}//utilityManager

/**
* Preferencias: OutPutData: Data/Code.
**/
public boolean outPutData( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("outPutData\n"); 
    return Data.compareTo( f30.kbm2lControl.getText( f30.kbm2lControl.OutPutData)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.OutPutData);
    return false;
    }//catch
}//outPutData

//// SECTION BROWSER PREFERENCES
/**
* Preferencias: FirstItemBrowser: 0,1,2,3,....
**/
public int firstItemBrowser( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("firstItemBrowser\n"); 
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.FirstItemBrowser));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.FirstItemBrowser);
    return 0;//
    }//catch  
}//firstItemBrowser

/**
* Preferencias: FirstItemBrowser: 1,2,3,....
**/
public int firstItemBrowser( int first) {

  try {
    f30.kbm2lControl.setText( f30.kbm2lControl.FirstItemBrowser, String.valueOf( first));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.FirstItemBrowser);
    return 0;//
    }//catch
  return first;//
}//firstItemBrowser

/**
* Preferencias: ItemNumberBrowser: 0,1,2,3,....
**/
public int itemNumberBrowser( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("itemNumberBrowser\n"); 
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.ItemsNumberBrowser));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.ItemsNumberBrowser);
    return 0;//
    }//catch  
}//itemNumberBrowser

/**
* Preferencias: ItemSizeBrowser: 0,1,2,3,....
**/
public int itemSizeBrowser( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("itemSizeBrowser\n"); 
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.ItemsSizeBrowser));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.ItemsSizeBrowser);
    return 0;//
    }//catch  
}//itemSizeBrowser

/**
* Preferencias: VerboseSystem: Yes/No.
**/
public boolean verboseSystem( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("verboseSystem\n"); 
    return Yes.compareTo(f30.kbm2lControl.getText( f30.kbm2lControl.VerboseSystem)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.VerboseSystem);
    return false;
    }//catch
}//verboseSystem

/**
* Preferencias: VerboseBrowser: Yes/No.
**/
public boolean verboseBrowser( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("verboseBrowser\n"); 
    return Yes.compareTo( f30.kbm2lControl.getText( f30.kbm2lControl.VerboseBrowser)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.VerboseBrowser);
    return false;
    }//catch
}//verboseBrowser

/**
* Preferencias: FocusPolicy: -1 (por defecto todas),0,1,2,3,....
**/
public static int focusPolicy( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("focusPolicy\n"); 
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.FocusPolicy));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.FocusPolicy);
    return -1;//
    }//catch  
}//focusPolicy

/**
* Preferencias: FocusPolicy: -1 (por defecto todas),0,1,2,3,....
**/
public static int focusPolicy( int fp) {

  try {
    f30.kbm2lControl.setText( f30.kbm2lControl.FocusPolicy, String.valueOf( fp));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.FocusPolicy);
    return 0;//
    }//catch
  return fp;//
}//focusPolicy

/**
* Preferencias: SpectrumChart: Case/Item.
**/
public boolean spectrumChart( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("spectrumChart\n"); 
    return Case.compareTo( f30.kbm2lControl.getText( f30.kbm2lControl.SpectrumChart)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.SpectrumChart);
    return false;
    }//catch
}//spectrumChart

/**
* Preferencias: SpectrumResolution: 1,2,3,....
**/
public double spectrumResolution( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("spectrumResolution\n"); 
    return Double.parseDouble( f30.kbm2lControl.getText( f30.kbm2lControl.SpectrumResolution));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.SpectrumResolution);
    return 1.0;//
    }//catch
}//spectrumResolution

/**
* Preferencias: SpectrumResolution: 1,2,3,....
**/
public double spectrumResolution( double res) {

  try {
    f30.kbm2lControl.setText( f30.kbm2lControl.SpectrumResolution, String.valueOf( res));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.SpectrumResolution);
    return 1.0;//
    }//catch
  return res;//
}//spectrumResolution

/**
* Preferencias: SpectrumLines: 1,2,3,....
**/
public int spectrumLines( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("spectrumLines\n"); 
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.SpectrumLines));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.SpectrumLines);
    return 30;//
    }//catch
}//spectrumLines

/**
* Preferencias: SpectrumItemsVBars: Yes/No.
**/
public boolean spectrumItemsVBars( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("spectrumItemsVBars\n"); 
    return Yes.compareTo( f30.kbm2lControl.getText( f30.kbm2lControl.SpectrumItemsVBars)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.SpectrumItemsVBars);
    return false;
    }//catch
}//spectrumItemsVBars

////SECTION - SYNTHESIS

/**
* [SECTION - SINTHESYS PREFERENCES]
* Preferencias: NBase: Yes/No.
**/
public static boolean nBase( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("nBase\n"); 
    return Yes.compareTo(f30.kbm2lControl.getText( f30.kbm2lControl.NBase)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.NBase);
    return false;
    }//catch
}//nBase

/**
* [SECTION - SINTHESYS PREFERENCES]
* Preferencias: NBase: Yes/No.
**/
public static boolean nBase( String nB) {

  try {
    f30.kbm2lControl.setText( f30.kbm2lControl.NBase, nB );
    return Yes.compareTo(f30.kbm2lControl.getText( f30.kbm2lControl.NBase)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.NBase);
    return false;
    }//catch
}//nBase

/**
* [SECTION - SINTHESYS PREFERENCES]
* Preferencias: ListHistory: Yes/No.
**/
public static boolean listHistory( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("listHistory\n"); 
    return Yes.compareTo(f30.kbm2lControl.getText( f30.kbm2lControl.ListHistory)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.ListHistory);
    return false;
    }//catch
}//listHistory

/**
* [SECTION - SINTHESYS PREFERENCES]
* Preferencias: FastCopy: Yes/No.
**/
public static boolean fastCopy( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("fastCopy\n"); 
    return Yes.compareTo(f30.kbm2lControl.getText( f30.kbm2lControl.FastCopy)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.FastCopy);
    return false;
    }//catch
}//fastCopy

/**
* [SECTION - SINTHESYS PREFERENCES]
* Preferencias: FastCopy: Yes/No.
**/
public static boolean fastCopy( String fCpy) {

  try {
	 f30.kbm2lControl.setText( f30.kbm2lControl.FastCopy, fCpy); 
    return Yes.compareTo( f30.kbm2lControl.getText( f30.kbm2lControl.FastCopy)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.FastCopy);
    return false;
    }//catch
}//fastCopy

/**
* [SECTION - SINTHESYS PREFERENCES]
* Preferencias: ModalCriterion: Yes/No.
**/
public static boolean modalCriterion( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("modalCriterion\n"); 
    return Yes.compareTo(f30.kbm2lControl.getText( f30.kbm2lControl.ModalCriterion)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.ModalCriterion);
    return false;
    }//catch
}//modalCriterion

/**
* [SECTION - SINTHESYS PREFERENCES]
* Preferencias: AttributeTest: Yes/No.
**/
public static boolean attributeTest( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("attributeTest\n"); 
    return Yes.compareTo(f30.kbm2lControl.getText( f30.kbm2lControl.AttributeTest)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.AttributeTest);
    return false;
    }//catch
}//attributeTest

/**
* [SECTION - SINTHESYS PREFERENCES]
* Preferencias: BaseTest: Yes/No.
**/
public static boolean baseTest( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("baseTest\n"); 
    return Yes.compareTo(f30.kbm2lControl.getText( f30.kbm2lControl.BaseTest)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.BaseTest);
    return false;
    }//catch
}//baseTest

/**
* [SECTION - SINTHESYS PREFERENCES]
* Preferencias: ImprovementTest: Yes/No.
**/
public static boolean improvementTest( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("improvementTest\n"); 
    return Yes.compareTo(f30.kbm2lControl.getText( f30.kbm2lControl.ImprovementTest)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.ImprovementTest);
    return false;
    }//catch
}//improvementTest

/**
* [SECTION - SINTHESYS PREFERENCES]
* Preferencias: ImprovementTest: Yes/No.
**/
public static boolean improvementTest( String iTest) {

  try {
    f30.kbm2lControl.setText( f30.kbm2lControl.ImprovementTest, iTest);
    return Yes.compareTo( f30.kbm2lControl.getText( f30.kbm2lControl.ImprovementTest)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.ImprovementTest);
    return false;
    }//catch
}//improvementTest

/**
* [SECTION - SINTHESYS PREFERENCES]
* Preferencias: ImprovTestPAram: 10,20,30,40,50,60,70,80,90,100.
**/
public int improvTestParam( ) {

  try {
    int param = Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.ImprovTestParam));
    if ( param < 1 ) return 1; else 
    if ( param > 100) return 100;
 	 if ( chkprefs) frame30.kbm2lSystem.append("improvTestParam\n"); 
    return param;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.ImprovTestParam);
    return -1;//
    }//catch  
}//improvTestParam

/**
* [SECTION - SINTHESYS PREFERENCES]
* Preferencias: improvTestParam: 10,20,30,....,100
**/
public int improvTestParam( int param) {

  try {
    if ( param < 1 ) return 1; else 
    if ( param > 100) return 100;
    f30.kbm2lControl.setText( f30.kbm2lControl.ImprovTestParam, String.valueOf( param));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.ImprovTestParam);
    return 100;//
    }//catch
  return param;//
}//improvTestParam

/**
* [SECTION - SINTHESYS PREFERENCES]
* Preferencias: TimeOutTest: 0,1,2,3,....
**/
public long timeOutTest( ) {

  try {
    int time = Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.TimeOutTest));
 	 if ( chkprefs) frame30.kbm2lSystem.append("timeOutTest\n"); 
    if (time < 0) return 1000000; else return time;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.TimeOutTest);
    return 0;//
    }//catch  
}//timeOutTest

/**
* [SECTION - SINTHESYS PREFERENCES]
* Preferencias: TimeOutTest: 0,1,2,3,....
**/
public long timeOutTest( int tot) {

  try {
    f30.kbm2lControl.setText( f30.kbm2lControl.TimeOutTest, String.valueOf( tot));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.TimeOutTest);
    return 0;//
    }//catch
  return tot;//
}//timeOutTest

/**
* [SECTION - SINTHESYS PREFERENCES]
* Preferencias: HeuristicG0: Yes/No.
**/
public boolean heuristicG0( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("heuristicG0\n"); 
    return Yes.compareTo( f30.kbm2lControl.getText( f30.kbm2lControl.HeuristicG0)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.HeuristicG0);
    return false;
    }//catch
}//heuristicG0

/**
* [SECTION - SINTHESYS PREFERENCES]
* Preferencias: Range: 0..n.
**/
public int range( ) {

  try {
    int r = Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.Range));
 	 if ( chkprefs) frame30.kbm2lSystem.append("range\n"); 
    return r;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.Range);
    return 0;
    }//catch
}//range

/**
* [SECTION - SINTHESYS PREFERENCES]
* Preferencias: PoblacionSize: 0,1,2,3,....
**/
public int poblacionSize( ) {

  try {
    int size = Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.PoblacionSize));
 	 if ( chkprefs) frame30.kbm2lSystem.append("poblacionSize\n"); 
    if (size < f30.activel30.dimension()) return f30.activel30.dimension(); else return size;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.PoblacionSize);
    return 0;//
    }//catch  
}//poblacionSize

/**
* [SECTION - SINTHESYS PREFERENCES]
* Preferencias: TimeOutFitness: 0,1,2,3,....
**/
public long timeOutFitness( ) {

  try {
    int time = Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.TimeOutFitness));
 	 if ( chkprefs) frame30.kbm2lSystem.append("timeOutFitness\n"); 
    if (time < 0) return 1000000; else return time;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.TimeOutFitness);
    return 0;//
    }//catch  
}//timeOutFitness


////SECTION - QUERY

/**
* Preferencias: browserQuery: Yes/No.
**/
public boolean browserQuery( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("browserQuery\n"); 
    return Yes.compareTo( f30.kbm2lControl.getText( f30.kbm2lControl.BrowseQuery)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.BrowseQuery);
    return false;
    }//catch
}//browserQuery

/**
* Preferencias: AproxClosedQuery: L/LL/LR/U.
**/
public String aproxClosedQuery( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("aproxClosedQuery\n"); 
    return new String( f30.kbm2lControl.getText( f30.kbm2lControl.AproxClosedQuery));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.AproxClosedQuery);
    return new String( f30.kbm2lControl.Upper);
    }//catch
}//aproxClosedQuery

/**
* Preferencias: HeadK2BayesQuery: Yes/No.
**/
public boolean headK2BayesQuery( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("headK2BayesQuery\n"); 
    return Yes.compareTo( f30.kbm2lControl.getText( f30.kbm2lControl.HeadK2BayesQuery)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.HeadK2BayesQuery);
    return false;
    }//catch
}//headK2BayesQuery

/**
* Preferencias: SubKBLearningSize: -1,0,1,2,3,....
**/
public int subKBLearningSize( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("subKBLearningSize\n"); 
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.SubKBLearningSize));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.SubKBLearningSize);
    return -1;//
    }//catch  
}//subKBLearningSize

/**
* Preferencias: SubKBProjection: Yes/No.
**/
public boolean subKBProjection( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("subKBProjection\n"); 
    return Yes.compareTo( f30.kbm2lControl.getText( f30.kbm2lControl.SubKBProjection)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.SubKBProjection);
    return false;
    }//catch
}//subKBProjection

/**
* Preferencias: SubKBMeasure: Yes/No.
**/
public boolean subKBMeasure( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("subKBMeasure\n"); 
    return Yes.compareTo( f30.kbm2lControl.getText( f30.kbm2lControl.SubKBMeasure)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.SubKBMeasure);
    return false;
    }//catch
}//subKB

/**
* Preferencias: SubKBResponse: Yes/No.
**/
public boolean subKBResponse( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("subKBResponse\n"); 
    return Yes.compareTo( f30.kbm2lControl.getText( f30.kbm2lControl.SubKBResponse)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.SubKBResponse);
    return true;
    }//catch
}//subKB

/**
* Preferencias: SubKBIndex: Yes/No.
**/
public boolean subKBIndex( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("subKBIndex\n"); 
    return Yes.compareTo( f30.kbm2lControl.getText( f30.kbm2lControl.SubKBIndex)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.SubKBIndex);
    return true;
    }//catch
}//subKBIndex

/**
* [SECTION - ANALYSIS PREFERENCES]
* Preferencias: SensitivityAnalisysDimen: 0,1,2,3,....
* 0 es sa respecto de todos y SensitivityParam es vacio.
**/
public int sensitivityAnalisysDimen( ) {

  try {
    int dimen = Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.SensitivityAnalisysDimen));
 	 if ( chkprefs) frame30.kbm2lSystem.append("sensitivityAnalisysDimen\n"); 
    if (dimen < 0) return 0; else return dimen;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.SensitivityAnalisysDimen);
    return 0;//
    }//catch  
}//sensitivityAnalisys

/**
* [SECTION - ANALYSIS PREFERENCES]
* Preferencias: SensitivityAnalisysParam: 0,1,2,3,....
* 0 en SensitivityAnalisysDimen es sa respecto de todos y SensitivityParam es vacio.
**/
public Vector sensitivityAnalisysParam( ) {

  int dimen = sensitivityAnalisysDimen( );
  if (dimen == 0 ) return null;
  
  Vector Param = new Vector();
  try {
    String strParam = new String( f30.kbm2lControl.getText( f30.kbm2lControl.SensitivityAnalisysParam));
    strParam = strParam.trim();
    if ( strParam == "") return null;     
  for(int i = 0; i < dimen; i++) {
    if ( strParam.indexOf(" ") != -1) 
      Param.add( new Integer( Integer.parseInt( strParam.substring(0, strParam.indexOf(" ")).trim())));
      else
        Param.add( new Integer( Integer.parseInt( strParam.substring(0, strParam.length()).trim())));
      if ( strParam.indexOf(" ") != -1) 
        strParam = strParam.substring(strParam.indexOf(" "), strParam.length()).trim();
      }
 	 if ( chkprefs) frame30.kbm2lSystem.append("sensitivityAnalisysParam\n"); 
    return Param;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.SensitivityAnalisysParam);
    return null;//
    }//catch  
}//sensitivityAnalisysParam

/**
* [SECTION - ANALYSIS PREFERENCES]
* Preferencias: OptimizeReferenceModel: Yes/No
**/
public static boolean optimizeReferenceModel( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("optimizeReferenceModel\n"); 
    return Yes.compareTo(f30.kbm2lControl.getText( f30.kbm2lControl.OptimizeReferenceModel)) == 0;
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.OptimizeReferenceModel);
    return false;
    }//catch
}//optimizeReferenceModel


////SECTION - TOOLS

/**
* Preferencias: OnTopAttribute: 0,1,2,3,....
**/
public int onTopAttribute( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("onTopAttribute\n"); 
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.OnTopAttribute));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.OnTopAttribute);
    return 0;//
    }//catch  
}//onTopAttribute

/**
* Preferencias: OnTopAttribute: 0,1,2,3,....
**/
public int onTopAttribute( int att) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("onTopAttribute\n"); 
    f30.kbm2lControl.setText( f30.kbm2lControl.OnTopAttribute, String.valueOf( att));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.OnTopAttribute);
    return 0;//
    }//catch
  return att;//
}//onTopAttribute

/**
* Preferencias: OnBotAttribute: 0,1,2,3,....
**/
public int onBotAttribute( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("onBotAttribute\n"); 
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.OnBotAttribute));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.OnBotAttribute);
    return 0;//
    }//catch  
}//onBotAttribute

/**
* Preferencias: OnBotAttribute: 0,1,2,3,....
**/
public int onBotAttribute( int att) {

  try {
    f30.kbm2lControl.setText( f30.kbm2lControl.OnBotAttribute, String.valueOf( att));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.OnBotAttribute);
    return 0;//
    }//catch
  return att;//
}//onBotAttribute

/**
* Preferencias: NRadius: 2 (por defecto todas)1,2,3,..., n
**/
public int nRadius( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("nRadius\n"); 
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.NRadius));
  }//try
  catch (Exception e) {
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.NRadius);
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.NRadius));
  }//catch
}//NRadius

/**
* Preferencias: RandomDimension: 10 (por defecto todas)1,2,3,..., n
**/
public int randomDimension( ) {

  try {
	 if ( chkprefs) frame30.kbm2lSystem.append("randomDimension\n"); 
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.RandomDimension));
  }//try
  catch (Exception e) {
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.RandomDimension);
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.RandomDimension));
  }//catch
}//RandomDimension

/**
* Preferencias: RandomDomain: 2 (por defecto todas)2,3,..., n
**/
public int randomDomain( ) {

  try {
	 if ( chkprefs) frame30.kbm2lSystem.append("randomDomain\n"); 
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.RandomDomain));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.RandomDomain);
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.RandomDomain)); 
    }//catch
}//randomDomain

/**
* Preferencias: RandomnItems: 20 (por defecto todas)2,3,..., n
**/
public int randomnItems( ) {

  try {
	 if ( chkprefs) frame30.kbm2lSystem.append("randomItems\n"); 
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.RandomnItems));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.RandomnItems);
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.RandomnItems)); 
    }//catch
}//randomnItems

/**
* Preferencias: RandomnCases: 200 (por defecto todas)2,3,..., n
**/
public int randomnCases( ) {

  try {
	 if ( chkprefs) frame30.kbm2lSystem.append("randomCases\n"); 
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.RandomnCases));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.RandomnCases);
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.RandomnCases)); 
    }//catch
}//randomnCases

////SECTION - CPT

/**
* Preferencias: CPTDimension: 2 (por defecto todas)2,3,..., n
**/
public int cPTDimension( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("cPTDimension\n"); 
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.CPTDimension));
  }//try
  catch (Exception e) {
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.CPTDimension);
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.CPTDimension));
  }//catch
}//CPTDimension

/**
* Preferencias: CPTDomain: 2 (por defecto todas)2,3,..., n
**/
public int cPTDomain( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("cPTDomain\n"); 
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.CPTDomain));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.CPTDomain);
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.CPTDomain)); 
    }//catch
}//CPTDomain

/**
* Preferencias: CPTnIems: 2 (por defecto todas)2,3,..., n
**/
public int cPTnItems( ) {

  try {
 	 if ( chkprefs) frame30.kbm2lSystem.append("cPTnItems\n"); 
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.CPTnItems));
  } catch (Exception e) { 
    f30.kbm2lControl.catchCtl( f30.kbm2lControl.CPTnItems);
    return Integer.parseInt( f30.kbm2lControl.getText( f30.kbm2lControl.CPTnItems)); 
    }//catch
}//CPTnItems


////
/**
* 
**/
public void run() {

  try {
//lectura de preferencias?

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
    System.exit( 0);
  }//catch
  
  return;
}//run

}//class controlPrefs30


