//checkCPT30//
package cpt;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kernel.*;
import kbm2l.*;
//import modelo.*;
import control.*;
import tools.*;

/**
* Clase checkCPT30.
* Checking de Distribuciones de probabilidad. Tipo logico [-2,-1,0]. Suma == 1.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class checkCPT30  extends  cpt30  implements  Runnable {

/**
*
**/
  private static final String ERROR = "Error(checkCPT30): ";
/**
* flag de ejecucion en curso
**/
  public static boolean working = false;
  
/**
* Constructor por defecto
**/
public checkCPT30( ) {

}//checkCPT30

/**
* minimo de los valores enteros del vector V
* @param V Vector
* @return int
**/
private  static  int min( Vector V) {

  int minimo = DominioProbabilidad;
  for( int i = 0; i < V.size(); i++) {
    int v = ((Integer)V.get( i)).intValue();
    if ( v < minimo) minimo = v;
    }
  
 return minimo;
}//min

/**
* maximo de los valores enteros del vector V
* @param V Vector
* @return int
**/
private  static  int max( Vector V) {

  int maximo = -1;
  for( int i = 0; i < V.size(); i++) {
    int v = ((Integer)V.get( i)).intValue();
    if ( v > maximo)  maximo = v;
    }
  
 return maximo;
}//max

/**
* for-next de Z respecto del convexo
* @return Z Vector incrementado.
**/
private  static  Vector next( Vector Z, Vector Convex) {

  for( int i = 0; i < Z.size(); i++) {

  try {  
    Vector convex = (Vector)Convex.get( i);
    if (((Integer)Z.get(i)).intValue() < max(convex)) {
      int j = convex.indexOf((Integer)Z.get(i))+1;
      Z.set( i, new Integer(((Integer)convex.get( j)).intValue()));
      return Z;
      }
      else {
        Z.set( i, new Integer( min(convex)));//i++        
      }
  }//try
    catch (Exception e) {
      System.out.println( ERROR + "next().");
      e.printStackTrace();
      exit( 0);
    }//catch

    }//for i    

  return null;
}//next

/**
* Vector de vectores vacios, size() == 0.
* @return false/true.
**/
private  static  boolean vacio( Vector Convex) {

  for( int i = 0; i < Convex.size(); i++) {
    if ( ((Vector)Convex.get(i)).size() != 0) {
      return false;
      }//if
    }//for i

  return true;  
}//vacio

/**
* Genera el Convexo.
* El Convexo puede ser o no conexo. 
* Debe ser conexo, asi se trata de intervalos de probabilidad.
* Si no es conexo la asignacion es inconsistente ? es multimodal !!
* Todos los puntos del convexo estan en algun camino de longitud 1.0.
* @return false/true.
**/
private  static  boolean  UnitConvexPath( lista30 l30, Vector Convex) {

//Genera los extremos del Convexo.
  Vector inf = new Vector();
  Vector sup = new Vector();
  long paths = 1;//BigInteger ?
  for( int i = 0; i < Convex.size(); i++) {
    inf.add( new Integer( min((Vector)Convex.get( i))));
    sup.add( new Integer( max((Vector)Convex.get( i))));    
    paths = paths * ((Vector)Convex.get( i)).size();
    }//for i

  int i_x = l30.Base.indexOfrol( rolX);//Att==cond 
  if ( Convex.size() != l30.Base.dom( i_x)) {
    System.out.println( ERROR + "Convex.size(): " + Convex.size());
    System.out.println( "l30.getDominio( i_x): " + l30.Base.dom( i_x));
    System.out.println( "Total paths: " + paths);
    System.out.println( "Convex:");    
    for( int i = 0; i < inf.size(); i++) {
      System.out.println( "Convex"+i+((Vector)Convex.get(i)).toString());
      }
    exit( 0);   
    }

//init Z-camino
  Vector Z = new Vector();
  for( int i = 0; i < Convex.size(); i++) {
    Z.add( i, new Integer( min((Vector)Convex.get( i))));//ini Z
    }

  while (( paths > 0) && ( !vacio( Convex))) {

    int suma1 = 0;
    for( int j = 0; j < Z.size(); j++) {//long de un camino Z
      suma1 = suma1 + ((Integer)Z.get( j)).intValue();//z(i,j)
      }

    if ( suma1 == DominioProbabilidad) {//borrar los elementos del camino
      for( int i = 0; i < Z.size(); i++) {     
        Vector convex = ((Vector)Convex.get( i));
        convex.remove(((Integer)Z.get( i)));
        }//for i
      }//if suma1

    if ((Z = next( Z, Convex)) == null) break;    
    paths--;           
    }//

  return vacio( Convex);//todos eliminados pues estan en algun camino de long 1.
}//UnitConvexPath

/**
* Genera los extremos del convexo.
* El numero de segmentos del covexo es el dominio de X.
* @return false/true.
**/
private  static  boolean  TablaCheck( lista30 l30, Vector Context) {
    
  int i_p = l30.Base.indexOfrol( rolP);//Att==prob
  int i_x = l30.Base.indexOfrol( rolX);//Att==cond 
    
//Convex
  Vector Convex = new Vector();
  for( int i = 0; i < l30.Base.dom( i_x); i++) {//i == dom X
    Vector convex = new Vector();//componente del Convex asociada a i
    
    for( int j = 0; j < l30.size(); j++) {// en la lista de items

      item30 item = l30.Get( j);
      if ( item.GetRespuesta( 0) == 1) {//// p - true

        for( Vector INDEX = l30.Inf( j); 
          index30.myeqT( l30.Sup( j), INDEX); 
          INDEX = index30.siguienteT( l30.Base.Dom(), INDEX)) {
    
          if ( index30.eqT( Context, contexto( l30, INDEX))) {//contexto

            if (((Integer)INDEX.get( i_x)).intValue() == i) {

              int p = ((Integer)INDEX.get( i_p)).intValue();
              if (convex.indexOf( new Integer( p)) == -1) {
                convex.add( new Integer( p));//componente del Convex asociada a i
                }//if

              }//if i_x
            }//if context
          }//for INDEX
        }//if item  
      }//for j

    Convex.add( convex);
  }//for i

  if ( UnitConvexPath( l30, Convex)) {

    return true;//ok

    } else {
      
    kbm2lBrowser.append( "Context: " + Context + "\n");    
    kbm2lBrowser.append( "Convex:\n");    
    for( int i = 0; i < l30.Base.dom( i_x); i++) {
      kbm2lBrowser.append("Convex"+i+((Vector)Convex.get(i)).toString()+"\n");
      }
    return false;  
  }//if vacio
    
}//TablaCheck

/**
* Check de cada caso del item i, en su contexto.
* @return false/true.
**/
private  static  boolean  TablaCheck( lista30 l30, int i) {

  for( Vector INDEX = l30.Inf( i); 
       index30.myeqT( l30.Sup( i), INDEX); 
       INDEX = index30.siguienteT( l30.Base.Dom(), INDEX)) {

    if (!working) break;
    if ( !TablaCheck( l30, contexto( l30, INDEX))) {//check INDEX que es p - true
      kbm2lSystem.append( ERROR + "TablaCheck().");
      kbm2lBrowser.append( "suma != 1.");
      kbm2lBrowser.append( "INDEX: " + INDEX);
      return false;
      }//if

    }// for INDEX
  
  return true;
}//TablaCheck

/**
* Check distribucion. Convexidad.
* Suma x en cada contexto de p = 1.0.
* Check de cada item p - true.
* Check de cada item p - false.
* @return false/true.
**/
public static boolean checkCPT( lista30 l30) {

  working = true;
  kbm2lSystem.append("Check Table - Init.\n");

  if (( l30.Base.indexOfrol( rolP) == -1) ||
      ( l30.Base.indexOfrol( rolX) == -1) ||
      ( l30.Base.indexOfrol( rolY) == -1))  {
    kbm2lSystem.append("KBM2L not CPT. Check Att's role.\n");
    kbm2lSystem.append("Check Table - End.\n");
    working = false;
    return true;  
    }//

  checkList30.chk( l30, "TablaCheck.");//check

  for( int i = 0; i < l30.size(); i++) {

  frame30.kbm2lSystem.estatus("Check - " + i);

//suma p en x_i = k-1 ; suma == 1.0;
    if (!working) break;
    if ( l30.Get( i).GetRespuesta( 0) == PTRUE) {//// p - true
      if ( !TablaCheck( l30, i)) {
        working = false;
        return false;
        }
      if (!working) break;
      }//if   

    }//for i

  kbm2lSystem.append("Check Table - End.\n");

  working = false;
  return true;
}//checkCPT

/**
* run process: TablaCheck.
**/
public void run() {

  if ( !working) {
  working = true;
  try {
    checkCPT( f30.activel30);
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run()");
    e.printStackTrace();
    exit( 0);
  }//catch
  }
  return;
}//run

}//class checkCPT30