//constraintCPT30//
package cpt;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
//import modelo.*;
import control.*;
import tools.*;

/**
* Clase constraintCPT30.
* Checking de Distribuciones de probabilidad. Tipo logico [-2,-1,0].
* coKB -> context(pi,xi).
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class constraintCPT30  extends  cpt30  implements  Runnable {

/**
*
**/
  private static final String ERROR = "Error(constraintCPT30): ";
/**
* flag de ejecucion en curso
**/
  public static boolean working = false;
  
/**
* Constructor por defecto
**/
public constraintCPT30( ) {
  
}//constraintCPT30

/**
* coKB --> Y-context
* @return boolean false/true.
**/
private  static  boolean  TablaConstraint( lista30 l30, int i) {

  for( Vector INDEX = l30.Inf( i); 
       index30.myeqT( l30.Sup( i), INDEX); 
       INDEX = index30.siguienteT( l30.Base.Dom(), INDEX)) {

    if (!working) break;
    if ( !TablaConstraint( l30, INDEX)) {//check INDEX que es p - false
      kbm2lSystem.append( ERROR + "TablaConstraint().");
      kbm2lSystem.append( "coKB == > y.");
      kbm2lSystem.append( "INDEX: " + INDEX);
      return false;
      }//if

    }// for INDEX

  return true;
}//TablaConstraint

/**
*
* @return false/true.
**/
private  static  boolean  TablaConstraint( lista30 l30, Vector index) {
    
  int i_p = 0;
  while ( l30.Base.rol( i_p) != rolP) {
    i_p++;
    }//ROL.indexOf( new Integer( rolP));//Att==prob

  int i_x = 0; 
  while ( l30.Base.rol( i_x) != rolX) {
    i_x++;
    }//ROL.indexOf( new Integer( rolX));//Att==cond

//for PXy ---> -2 false;
  int dx = l30.Base.dom( i_x);

  Vector medida = new Vector();
  medida.add( new Double( -1.0));
  Vector respuesta = new Vector();
  respuesta.add( new Integer( index30.coKB));
  Vector indice = index30.cpT( index);// copia

  for( int ix = 0; ix < dx; ix++) {//el dominio de X
    indice.set( i_x, new Integer( ix));
    for( int ip = 0; ip < cpt30.DominioProbabilidad; ip++) {
      indice.set( i_p, new Integer( ip));
      if ( !index30.eqS( l30.GET( indice).GetRespuesta(), respuesta)) {
        item30 item = new item30( l30, medida, respuesta, indice); 
        l30.Set( item);
        }//if
      }//for ip
    }//for ix

  return true;
}//TablaConstraint

/**
* constraintCPT coKB y check distribucion. 
* Check de cada item p - false.
* @return lista30 l30.
**/
public lista30 constraintCPT( lista30 l30) {

  working = true;
  kbm2lSystem.append("Constraint Table - Init.\n");

  if (( l30.Base.indexOfrol( rolP) == -1) ||
      ( l30.Base.indexOfrol( rolX) == -1) ||
      ( l30.Base.indexOfrol( rolY) == -1))  {
    kbm2lSystem.append("KBM2L not CPT. Check Att's role.\n");
    kbm2lSystem.append("Constraint Table - End.\n"); 
    working = false;
    return l30;  
    }//

  checkList30.chk( l30, "constraintCPT-0.");//std check list

  lista30 lTarget = null;
  if ( l30.dimension() >= 3) {
//cambio de base pxy...y -> y...yxp, set item(coKB)
    lTarget = targetStd30.Target2( l30, l30.Base.indexOfrol( rolP), l30.dimension()-1);//std    
    lTarget = targetStd30.Target2( lTarget, l30.Base.indexOfrol( rolX), lTarget.dimension()-2);//std
    l30 = new listUnion30().union_lr( l30, lTarget); 
    if ( lTarget == null) {
      System.out.println( ERROR + "ConstraintCheck.");
      }//if
    }//if

  l30 = new lista30( lTarget, lTarget);//std

  for( int i = 0; i < l30.size(); i++) {

  frame30.kbm2lSystem.estatus("Check Constraints - " + i);

//coKB --> Y-context
    if (!working) break;
    if (( l30.Get( i).GetRespuesta( 0) == PcoKB)) {//// p - false
      if ( !TablaConstraint( l30, i)) {
        working = false;
        return l30;
        }
      if (!working) break;
      }//if   

    }//for i

  l30 = new lista30( lTarget, lTarget);//std

  lTarget = null;
  if ( l30.dimension() >= 3) {
//cambio de base y...yxp -> pxy...y, set item(coKB)
    lTarget = targetStd30.Target2( l30, l30.Base.indexOfrol( rolP), 0);//std    
    lTarget = targetStd30.Target2( lTarget, l30.Base.indexOfrol( rolX), 1);//std
    l30 = new listUnion30().union_lr( l30, lTarget); 
    if ( lTarget == null) {
      System.out.println( ERROR + "ConstraintCheck.");
      }//if
    }//if

  checkList30.chk( l30, "constraintCPT-1.");//std check list
  kbm2lSystem.append("Constraint Table - End.\n");

  working = false;
  return l30;
}//constraintCPT

/**
* run process: ConstraintCheck.
**/
public void run() {

  if ( !working) {
  working = true;
  try {
    f30.activel30 = constraintCPT( f30.activel30);
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run()");
    e.printStackTrace();
    System.exit( 0);
  }//catch
  }
  return;
}//run

}//class constraintCPT30