//distribucion30//
package cpt;

//
import java.util.*;
import java.lang.*;

import java.io.*;
import java.math.*;
import java.awt.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
//import modelo.*;
import control.*;
import tools.*;

/**
* Clase cpt30. La CPT es la lista activa.
* Distribuciones de probabilidad. Tipo logico [-2,-1,0]=[coKB,unKB,true].
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class cpt30  extends  frame30  implements  Runnable {

/**
*
**/
  private static final String ERROR = "Error(cpt30): ";
/**
* flag de ejecucion en curso
**/
  public static boolean working = false;

/**
*
**/  
  protected static int DominioProbabilidad = 100;//p, k=101
/**
*
**/  
  protected static int NumeroVariables  = 0;//pxy, prefs
/**
*
**/  
  protected static int DominioVariables  = 0;//xy

/**
//un solo comp de probabilidad
**/
  protected static final int rolP = 0;
/**  
//una sola variable condicionada
**/
  protected static final int rolX = 1;
/**  
//comp's de contexto  
**/
  protected static final int rolY = 2;  

/**
*
**/  
  protected static final int PcoKB  = index30.coKB;
/**
*
**/  
  protected static final int PunKB  = index30.unKB;
/**
*
**/  
  protected static final int PFALSE  = 0;  
/**
*
**/  
  protected static final int PTRUE  = 1;

/**
* componer ROL pxy, canonico, 01222..22.
**/
public cpt30( ) {
  
  if ( f30.activel30 == null) {//leer prefs
      NumeroVariables = new controlPrefs30().cPTDimension();
      DominioVariables = new controlPrefs30().cPTDomain();
      f30.activel30 = new lista30 ( "", 1, 1, NumeroVariables, DominioVariables);
    }//if
    
}//cpt30

/**
* formato P(X|Y)=p ;
* p x x x y y y y y y y y y y ; ---> 1
**/
public boolean leerCpt( ) {

  return true;
}//leerCpt

/**
* formato P(X|Y)=p ;
* x x x y y y y y y y y y y p ;
**/
public boolean guardarCpt( ) {

  return true;
}//guardarCpt

/**
* En un indice el subconjunto de attributos que condicionan la probabilidad. Y.
* @return Vector de valores de atts.
**/
protected  static  Vector contexto( lista30 l30, Vector index) {

  Vector Ctext = new Vector();
  try {
    for( int j = 0; j < l30.dimension(); j++) {
      if (l30.Base.rol( j) == rolY) //ROL.get( j)
        Ctext.add( new Integer(((Integer)index.get( j)).intValue()));  
      }//for j
  }//try
    catch (Exception e) {
      System.out.println( ERROR + "contexto().");
      System.out.println( "ROL-0:   " + l30.Base.rol( 0));
      System.out.println( "ROL-1:   " + l30.Base.rol( 1));
      System.out.println( "ROL-2:   " + l30.Base.rol( 2));
      System.out.println( "index: " + index.toString());
      e.printStackTrace();
      exit( 0);
    }//catch

  return Ctext;
}//contexto

/*
* Tabla de probabilidad condicionada. Random - CPT.
*/
public lista30 TablaCondicionada( ) {

  working = true;
  kbm2lSystem.append("Conditioned Table  - Init.\n");

//preparar lista
  Vector dominio = new Vector();
  for( int i = 0; i < NumeroVariables-1; i++) {
    dominio.add( new Integer( DominioVariables));//xy 
    }//for i
  dominio.add( new Integer( DominioProbabilidad+1));//p
//xyp
  base30 base = new base30( NumeroVariables, 0, dominio, 
    new Integer( rolX), new Integer( rolY), new Integer( rolP));

  lista30 l30 = null;
  l30 = new lista30( "cpt" + base.size(), 1, 1, base);

  Vector INDICE0 = null;
  Vector RESPUESTA0 = null;
  Vector MEDIDA0 = null;

  Vector INDICE1 = null;
  Vector RESPUESTA1 = null;
  Vector MEDIDA1 = null;

//x binary
//random xyp + random [-1,0,1] + complemento
// < (x)y[p], 1|  < [1-p](~x)y, 1|
  long nItems = new controlPrefs30().itemLengthOVF();
  long nKBCases = new controlPrefs30().KBCasesLengthOVF();

  while ( working && ( l30.size() < nItems)) {//Set

    try {
      if ( listStat30.KB( l30).longValue() > nKBCases) break;

      int i = l30.Base.size()-1;//p

//p
    try {
      INDICE0 = new randomkbm2l30().randomINDICE( l30);//pxy
      INDICE0.set( 0, new Integer( 0));//x == 0
      RESPUESTA0 = new randomkbm2l30().randomRESPUESTA( l30, 2);//ds 
      RESPUESTA0.set( 0, new Integer( PTRUE));//true
      MEDIDA0 = new randomkbm2l30().randomMEDIDA( l30);//p / k 
      MEDIDA0.set( 0, 
        new Double (((double)((Integer)INDICE0.get(i)).intValue()/(double)DominioProbabilidad)));
      l30.Set( new item30( l30, MEDIDA0, RESPUESTA0, INDICE0));
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "TablaCondicionada().1\n");
    e.printStackTrace();
    exit( 0);
  }//catch

//1-p                               
    try {
      INDICE0.set( i, 
        new Integer( DominioProbabilidad - ((Integer)INDICE0.get(i)).intValue()));//p == 1-p
      INDICE0.set( 0, new Integer( 1));//x == 1
      RESPUESTA0 = new randomkbm2l30().randomRESPUESTA( l30, 2);//ds 
      RESPUESTA0.set( 0, new Integer( PTRUE));// true
      MEDIDA0 = new randomkbm2l30().randomMEDIDA( l30);//p / k 
      MEDIDA0.set( 0, 
        new Double (((double)((Integer)INDICE0.get(i)).intValue()/(double)DominioProbabilidad)));
      l30.Set( new item30( l30, MEDIDA0, RESPUESTA0, INDICE0));
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "TablaCondicionada().2\n");
    e.printStackTrace();
    exit( 0);
  }//catch

//false
    try {
      INDICE0 = new randomkbm2l30().randomINDICE( l30);//pxy
      INDICE0.set( 0, new Integer( 0));//x == 0
      RESPUESTA0 = new randomkbm2l30().randomRESPUESTA( l30, 2);//ds 
      RESPUESTA0.set( 0, new Integer( PFALSE));//false
      MEDIDA0 = new randomkbm2l30().randomMEDIDA( l30);//p / k 
      MEDIDA0.set( 0, new Double ( -1.0));
      l30.Set( new item30( l30, MEDIDA0, RESPUESTA0, INDICE0));
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "TablaCondicionada().3\n");
    e.printStackTrace();
    exit( 0);
  }//catch

//false
    try {
      INDICE0 = new randomkbm2l30().randomINDICE( l30);//pxy
      INDICE0.set( 0, new Integer( 1));//x == 1
      RESPUESTA0 = new randomkbm2l30().randomRESPUESTA( l30, 2);//ds 
      RESPUESTA0.set( 0, new Integer( PFALSE));//false
      MEDIDA0 = new randomkbm2l30().randomMEDIDA( l30);//p / k 
      MEDIDA0.set( 0, new Double ( -1.0));
      l30.Set( new item30( l30, MEDIDA0, RESPUESTA0, INDICE0));
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "TablaCondicionada().3\n");
    e.printStackTrace();
    exit( 0);
  }//catch
                               
      frame30.kbm2lSystem.estatus( 
        "Set: "+ ( l30.size()) + " | " + listStat30.KB( l30).longValue());//

    }//try
    catch (Exception e) {
      System.out.println( ERROR + "TablaCondicionada().4\n");
      e.printStackTrace();
      exit( 0);
    }//catch

    //new checkCPT30().checkCPT( l30);

    }//while

  checkList30.chk( l30, "r2.");//checks
  new checkCPT30().checkCPT( l30);  
  frame30.kbm2lSystem.estatus( ": "+ ( l30.size()) + " | " + listStat30.KB( l30).longValue());//

  kbm2lSystem.append("Conditioned Table  - End.\n");

  checkCPT30.checkCPT( l30);
  
  working = false;
  return l30;
}//TablaCondicionada

/**
* 
**/
public void run() {

  if ( !working) {
  working = true;
  try {
    f30.activel30 = TablaCondicionada( );
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().\n");
    e.printStackTrace();
    exit( 0);
  }//catch
  }
  return;
}//run

//
// transformaciones tipo logico en categorico, logico en prob, categorico en prob, 
//                       prob en categorico, prob en logico, categorico en logico.
//

//
// teorema probabilidad total.
//

//
// teorema bayes.
//

/**
* Entrada de la aplicacion
**/
public static void main( String args[]) {

  return;  
}//main

}//class Distribucion30