//
package genetic;

import java.util.*;
import java.io.*;

import kbm2l.*;
import kernel.*;
import tables.*;

public  class  Aev  implements  Runnable {
  // Individuo usado para la evolucion del proceso

  Individuo individuo;

  // Para indicar el sentido de la busqueda

  String objetivo;

  // Parametro para indicar el maximo numero de iteraciones
  // sin mejora

  int limite_ciclos_sin_mejora;

  // Constructor de la clase

public  Aev ( lista30 l30) {

}

  Aev(fitnessMgo fitness){
   boolean valido;

    // Se leen los parametros de configuracion

    lectura_parametros();

    // Creamos un individuo

    individuo=new Individuo(fitness.dimension(),fitness);

    // Se muta la solucion inicial, para que se aleatoria

    individuo.mutar(General.generar_ent_uniforme(1,2*fitness.dimension()));

    valido=individuo.comprobar();

    if (valido == false) {
          System.out.println("Individuo mal generado.......\n");
          System.exit(-10);
    }
  }

 // Metodo para la lectura de los parametros de configuracion.
  // Los valores definidos en el son:
  //  a) Sentido de la busqueda
  //  b) Numero maximo de generaciones sin mejora

  private void lectura_parametros() {
    InputStreamReader lector;
    BufferedReader lector_bufer;
    FileInputStream file=null;
    Double valor;

    try {
       file=new FileInputStream(dato30.workspace + File.separatorChar + "configAev.dat");
    }
    catch(FileNotFoundException e) {
       System.out.println("No existe el archivo configAev.dat");
       System.exit(0);
    }

    lector=new InputStreamReader(file);
    lector_bufer=new BufferedReader(lector);

    // En caso de existir leemos los siguientes valores:

    // A) si es un problema de maximizacion o minimizacion

    objetivo=General.leer_cadena(lector_bufer);

    // B) Se lee el numero maximo de iteraciones sin mejora

    limite_ciclos_sin_mejora=General.leer_entero(lector_bufer);

    System.out.println("***********************************************");
    System.out.println("Sentido de la busqueda:    "+objetivo);
    System.out.println("Numero maximo de iter. sin mejora: "+limite_ciclos_sin_mejora);
    System.out.println("***********************************************");
  } 

/**
* entry-point
**/
  public static lista30 aevman( ) {
    Evolucion evol;
 
    // Se comprueba que se introduce el nombre del ejemplo
    // sobre el que trabajar

//    if (args.length < 1){
//      System.out.println("Especificar nombre base");
//      System.exit(-1);
//    }

    // Creo el objeto de la clase fitness asociado a esta base
    fitnessMgo fitness=new fitnessMgo(frame30.activel30.Name());

    // Creo el nuevo genetico
    Aev aev=new Aev(fitness);

    // Se crea un objeto de la clase EvolNormal
    evol=new EvolAev(aev.individuo, aev.objetivo,aev.limite_ciclos_sin_mejora);

    // Se hace evolucionar
    evol.evolucionar();

  return frame30.activel30;

}//


  // Metodo para probar la clase. Main

  public static void main (String args[]){
    Evolucion evol;
 
    // Se comprueba que se introduce el nombre del ejemplo
    // sobre el que trabajar

    if (args.length < 1){
      System.out.println("Especificar nombre base");
      System.exit(-1);
    }

    // Creo el objeto de la clase fitness asociado a esta base

    fitnessMgo fitness=new fitnessMgo(args[0]);

    // Creo el nuevo genetico

    Aev aev=new Aev(fitness);

    // Se crea un objeto de la clase EvolNormal

    evol=new EvolAev(aev.individuo, aev.objetivo,aev.limite_ciclos_sin_mejora);

    // Se hace evolucionar

    evol.evolucionar();
  }

/**
* run process
**/
public void run() {

  if ( frame30.activel30.dimension() > 1)
  try {
    long ts0 = (new Date()).getTime();

    frame30.activel30 = Aev.aevman();

    frame30.kbm2lTime.append("Sintesis Entorno Variable:: " + (new Date().getTime() - ts0) + ".\n");      
  } catch (Exception e) {
    System.out.println( "ERROR  " + "run().");
    e.printStackTrace();
    System.exit( 0);
  }//catch

  return;
}//run


}//class Aev
