//
package genetic;

import java.util.*;

abstract class Evolucion {

  // Datos miembro

  Poblacion poblacion;

  // Numero de generaciones maximas de funcionamiento

  int limite_ciclos;

  // Numero de ciclos sin mejora permitidos

  int limite_ciclos_sin_mejora;

  // Para controlar el numero de generaciones de funcionamiento

  int ciclos;

  // Para controlar el numero de ciclos sin mejora

  int ciclos_sin_mejora;

  // Probabilidad de seleccion

  double probabilidad_seleccion;

  // Probabilidad de mutacion

  double probabilidad_mutacion;

  // Probabilidad de descarte

  double probabilidad_descarte;

  // Nombre del operador de cruce

  String operador_cruce;

  // Para guardar el sentido de la evolucion

  boolean maximizacion;

  // Selector para cruce

  Seleccion selector_cruce;

  // Selector para descarte

  Seleccion selector_descarte;

  // Estadistica

  Estadistica estadistica;

  // Metodos miembro

   // Para la evolucion de la poblacion 

   abstract void evolucionar();

   // Para asignar la poblacion sobre la que se trabaja

   void asignar_poblacion(Poblacion pob) {
     poblacion=pob;
   }
}
