//
package genetic;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kbm2l.*;
import kernel.*;
import tables.*;
import synthesis.*;
import target.*;

/**
* Clase fitnessMgo.
* @author Manuel Gmez Olmedo 
* @version 3.0
**/
public class fitnessMgo {

private static final String ERROR = "Error(fitnessMgo30): ";
private inputTable30 table;
private lista30 list;

/**
* Constructor por defecto
**/
public fitnessMgo(  ) {

}//fitness30

/**
 * Constructor que recibe un nombre para construir una tabla
 */

public fitnessMgo(String archivo){

  table=new inputTable30(archivo);

  list=table.leerTabla( null, archivo);
  
//  systemVer30.ver( list);
}

// Devuelve el numero de variables de la base

public int dimension(){
  return list.Base.size();
}

/**
* Nueva base implicita en el vector orden
**/
public long getFitness(Vector orden) {

  if ( orden.size() != list.Base.size()) {
    System.out.println( ERROR + "getFitness.2");
    System.out.println( "orden.size()= " + orden.size());
    System.out.println( "orden= " + orden.toString());
    System.out.println( "Base.size()= " + list.Base.size());
    System.out.println( "Base.size()= " + list.Base.toString());
    new Exception().printStackTrace();
    System.exit(0);
    }

  if ( !base30.esPermutacion( orden)) {
    System.out.println( ERROR + "getFitness.3");
    System.out.println( "orden.size()= " + orden.size());
    System.out.println( "orden= " + orden.toString());
    new Exception().printStackTrace();
    System.exit(0);
    }

  try {//
    base30 base = null;
    base=target30.swap( list.Base, orden);
    //System.out.println(base.toString());
    //return getFitness( list.Base, base);
    return new fitness30().getFitness( list, base);
    } catch (Exception e) {
      System.out.println( ERROR + "getFitness.2");
      e.printStackTrace();
      System.exit( 0);
  }//catch

  return -1;//ERROR
}//getFitness

/**
* Fitness de la lista en otra nueva base
**/
public long getFitness( lista30 l30, base30 base) {

  if ( base.size() != l30.Base.size()) {
    System.out.println( ERROR + "getFitness.1");
    System.out.println( "base.size()= " + base.size());
    System.out.println( "base= " + base.toString());
    System.out.println( "Base.size()= " + l30.Base.size());
    System.out.println( "Base.size()= " + l30.Base.toString());
    new Exception().printStackTrace();
    System.exit(0);
    }

  try {//
//    return (getFitnessLOW( l30, base) + getFitnessUPP( l30, base)) / 2;//!!

//    return getFitnessLOW( l30, base);//!

    return getFitnessUPP( l30, base);//!

    } catch (Exception e) {
      System.out.println( ERROR + "getFitness.1");
      e.printStackTrace();
      System.exit( 0);
  }//catch

  return -1;//ERROR
}//getFitness

/**
*
**/
public long getFitnessUPP( lista30 l30, base30 base) {

  if ( base.size() != l30.Base.size()) {
    System.out.println( ERROR + "getFitnessUPP.1");
    System.out.println( "base.size()= " + base.size());
    System.out.println( "base= " + base.toString());
    System.out.println( "Base.size()= " + l30.Base.size());
    System.out.println( "Base.size()= " + l30.Base.toString());
    new Exception().printStackTrace();
    System.exit(0);
    }

  try {//
    lista30 aux30 = targetStd30.TargetG( l30, base);//crea la lista compatible en la "base"
    l30.cpUPP(aux30);//copia los casos UPP de los items items
    return aux30.Switches( );//scan switches
    } catch (Exception e) {
      System.out.println( ERROR + "getFitnessUPP.");
      e.printStackTrace();
      System.exit( 0);
  }//catch

  return -1;//ERROR
}//getFitnessUPP


/**
* 
**/
public static void main(String args[]) {
 fitnessMgo fitness;
 int i;


  if(args.length < 1){
    System.out.println("Has de introducir un nombre de archivo");
    System.exit(-1);
  }

  // En caso contrario, crea un objeto de la clase

  System.out.println("Archivo: "+args[0]);
  System.out.println(".....................................");
  fitness=new fitnessMgo(args[0]);
  
  // Obtenemos la dimension 

  int dim=fitness.list.dimension();

  // Genero un vector de prueba

  Vector prueba=new Vector();

  for(i=dim-1; i >= 0; i--){
    prueba.addElement(new Integer(i));
  }

  // Probamos el fitness

  System.out.println("FITNESS = "+fitness.getFitness(prueba));

  prueba=new Vector();
  for(i=0; i < dim; i++){
    prueba.addElement(new Integer(i));
  }

  // Probamos el fitness

  System.out.println("FITNESS = "+fitness.getFitness(prueba));
  
}//main

}
