//
package genetic;

import java.util.*;

class RankSelector extends Seleccion {

  RankSelector(String objetivo, Poblacion pob) {
   // Se almacena el dato miembro que indica el sentido de la busqueda

   sentido=objetivo.equalsIgnoreCase("max");

   // Se asigna tambien la poblacion

   asignar_poblacion(pob);
  }

  // Implementacion del metodo seleccionar. En este caso, la seleccion
  // siempre devuelve el mejor individuo de la poblacion. Hemos de tener
  // en cuenta que pudiera haber varios individuos con el mismo valor
  // de objetivo, y que todos ellos deberian tener la misma probabilidad
  // de ser seleccionado

  Individuo seleccionar() {
    Vector indices=new Vector(); 
    int seleccion;
    Individuo seleccionado;

    // Se considera cual es el sentido de la busqueda: maximizacion o
    // minimizacion

    if (sentido) {
       // Estamos interesados en el maximo

       poblacion.obtener_indices_maximo_valor_objetivo(indices);
    }   
    else {
       // Estamos interesados en el minimo

       poblacion.obtener_indices_minimo_valor_objetivo(indices);
    }

    // En el vector de indices devuelto tenemos todos los indices
    // asociados a los individuos de mayor valor de funcion objetivo.
    // Se obtiene un numero aleatorio para seleccionar uno de ellos

    seleccion=General.generar_ent_uniforme(0,indices.size());

    // Se obtiene de la poblacion el individuo asociado a este indice
    // y se retorna

    seleccionado=poblacion.acceder_individuo(seleccion);

    return(seleccionado);
  }
}


