//BROWSER30//
package kbm2l;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;
//import javax.swing.JDialog;

//
import control.*;
import kernel.*;
import target.*;
import schema.*;
import tables.*;
import spectrum.*;
import tools.*;

/**
* Clase browser30, 
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  browser30  extends  system30   {

  private static final String ERROR = "Error(browser30): ";
  private static int logs = 0;

  public TextArea taVer = null;

/**
* Ventana de sistema.
**/
  public Frame frame = null;

/**
* Constructor por defecto
**/
public browser30( frame30 f30) {

  this.f30 = f30;
  frame = new Frame( "KBM2L30 = " + "BROWSER - ");
  logs = 0;
  browser();

  return;  
}//browser30

/**
* Componentes del browser
**/
public void browser() {

//Layout
  GridBagConstraints C = new GridBagConstraints();
  GridBagLayout gbl = new GridBagLayout();
  frame.setLayout( gbl); 

  C.gridx = 0; C.gridy = 0;
  C.gridwidth = 1; C.gridheight = 1;
  C.fill = GridBagConstraints.BOTH;
  C.ipadx = 0; C.ipady = 0;
  C.insets = new Insets(5,5,5,5);
  C.anchor = GridBagConstraints.CENTER;
  C.weightx = 1; C.weighty = 1;
  taVer = new TextArea();
  gbl.setConstraints( taVer, C);
  frame.add( taVer);//+++
  frame.setLocation( 0, 270);
  frame.setSize( 900, 390);
  frame.setVisible(true);
  frame.toFront();  

  setText( about());

  return;  
}//browser

/**
* Iniciar el texto del browser
**/
public void setText( String str) {
  
  taVer.setText( str); 
  return;
}//setText

/**
* texto en el browser
**/
public String getText( ) {
     
  return taVer.getText( );
}//getText

/**
* nuevo texto al browser
**/
public void append( String str) {

  String t = taVer.getText();
  if ( t.length() > buffer) {
	 saveText( taVer, "browser-", logs++); 
    taVer.setText( str);
    } else { 
	     taVer.append( str); 
    }

  return;
}//append

/**
* Rules set applied
**/
private void  verReglas( lista30 l30) {

  append( "Rules: " + l30.Name() + "\n");
  for( int i = 0; i < l30.reglas.size(); i++) {
    append( (String)( l30.reglas.get( i)) + " \t ");
    if (( (i+1) % 4) == 0) append("\n");
    }
  return;
}//verReglas

////
private  int firstItemVer = 0, numItems = 0, numResponses = 0;
private  Vector policy = null;
private  boolean verbose = false;
private  int numItemsVer = 0;
private  int ItemsSize = 0;

/**
* Item list view
**/
private void verItem( lista30 l30, int i) {

  try {
    item30 item = l30.Get( i);
    append(" <");  
    append( item.GetIndice().toString()    + " - ");
    append( item.GetRespuesta().toString() + " - ");
    append( "%" + item.GetMedida().toString());
    append( "  |");

    if ( verbose) {      
      append( "\n" + l30.Esqu.consultaEqIndice( base30.Trnp( l30.Base, item.GetIndice(), null)));      
      append( "FIX: " + l30.Fij( i) +  
              "   CAtt: " + l30.cutDimension( i) + "   dCAtt: " + l30.dominioCorte( i) + "\n");
      append( l30.Esqu.consultaEqRespuesta(item.GetRespuesta()));
      }
    
    append("  offset = " + item.getOffsetSup().toString());
    append("  length = " + item.getLongitud().toString());
    append("  fixed-att = " + l30.Fix( i).size());

    if ( verbose) {
      append(" - Offset = (low = " + item.getOffsetInf().toString() + ", upp = " + 
                                     item.getOffsetSup().toString() + "))\n");
      append(" index = " + offset30.index( l30, listStat30.getWeights( l30), item.getOffsetSup()));
      }//if

     append("\n.#.\n");
  } catch (Exception e) { 
    System.out.println( ERROR + "VerItem( item30 item)");
    e.printStackTrace();
    f30.exit( 0);
  }//catch

  return; 
}//verItem

/**
* Preferencias del Browser e inicia el area de texto.
**/
private  boolean iniVer( lista30 l30) {

  firstItemVer = new controlPrefs30().firstItemBrowser();
  numItems = new controlPrefs30().itemNumberBrowser();
  ItemsSize = new controlPrefs30().itemSizeBrowser();
  verbose = new controlPrefs30().verboseBrowser(); 
  checkList30.chk( l30, "iniVer.");//???
  if ( verbose) {
    if ( l30.Esqu == null) {
    String pathKBM2L = null;
      f30.kbm2lSystem.estatus("Select Literal Schema: *.eq  - .");
      pathKBM2L = new String( dato30.selectFile( f30.kbm2lSystem.frame, FileDialog.LOAD, "*.eq"));
      if ( pathKBM2L == null) {
        f30.kbm2lSystem.estatus("No schema selection.");
        return false;//offset
        } 
      pathKBM2L = dato30.nameFile( pathKBM2L);
      pathKBM2L = dato30.extFile( pathKBM2L, "eq");
      l30.Esqu = new esquema30( l30.Name(), l30.ParIndice(), l30.ParRespuesta());
      l30.Esqu.leerEq( pathKBM2L);//nombre.eq
    }//if ( eq30 == null)
    }
  
  int p = new controlPrefs30().focusPolicy();  
  if ( p >= 0)  
    policy = l30.Get( new controlPrefs30().focusPolicy()).GetRespuesta();
    else policy = l30.UNKB;

  numItemsVer = firstItemVer + numItems;
  if ( numItemsVer >= l30.size()) {
    firstItemVer = l30.size() -1 - numItems ;
    if ( firstItemVer < 0) firstItemVer = 0;
    numItemsVer = l30.size() -2; 
    }
  setText( about());//borra

  return true;
}//iniVer

/**
* kbm2l browser view
**/
private void kbm2lVer( lista30 l30) {

  try {

    append("KBM2L: " + l30.Name() + "\n");
    append("Base-dbr --- *** " + l30.size() + 
      " ***  V(" + verbose + ") S(" + ItemsSize + ")\n(" + 
      l30.Base.toString( l30) + ").\n\n");

    int i = 0;
    for( i = firstItemVer; i <= numItemsVer; i++) {
      if ( index30.eqS( policy, l30.UNKB)) 
        if ( l30.Get( i).getLongitud().doubleValue() >= ItemsSize) {//todo
          append( "\t" + String.valueOf( i));    
          if ( i < l30.size()) { 
            verItem( l30, i); 
            }
          }
       else 
      if ( index30.eqS( l30.Get( i).GetRespuesta(), policy)) {//selecc
        if ( l30.Get( i).getLongitud().doubleValue() >= ItemsSize) {
          append( "\t" + String.valueOf( i) + "\t");    
          if ( i < l30.size()) { verItem( l30, i); 
          }
          }          
        }
      }//for i  
    
    if ( i <= (l30.size() -2))
      append("......................................\n");

    numItemsVer = l30.size(); 

    if ( index30.eqS( policy, l30.UNKB)) {//todo
      append( String.valueOf( "\t" + String.valueOf( l30.size()-1)));    
      verItem( l30, l30.size()-1);
      }
      else 
      if ( index30.eqS( l30.Get( l30.size()-1).GetRespuesta(), policy)) {
        append( String.valueOf( "\t" + String.valueOf( l30.size()-1)) + "\t");    
        verItem( l30, l30.size()-1);
      }

  } catch (Exception e) { 
    System.out.println( ERROR + "kbm2lVer( frame30 f30)");
    f30.exit( 0);
  }//catch

  return;
}//kbm2lVer

/**
* kbm2l summary view
**/
private void summaryVer( lista30 l30) {
///
  if ( l30.size() > 1) {

    listStat30.calc( l30);

    Vector S = listStat30.DS( l30); 
    int numResponses = new controlPrefs30().itemNumberBrowser();

    if ( numResponses >= S.size()) {
      numItemsVer = S.size(); 
      numResponses = S.size();
      }
      else {
        numItemsVer = numResponses;
        }

  try {

    append("KBM2L: " + l30.Name() + "  EQ:" + l30.Esqu.nombre + "[" + l30.Esqu.numDecisiones + "]");
    append("\nCells(KBM2L): (0,..," + new offset30().getLONGITUD( l30.Base.Dom()) + ")");
    append("   Items(KBM2L): ***  " + l30.size() + "   ***");
    append("   KB-alternatives: " + S.size());

  } catch (Exception e) { 
    System.out.println( ERROR + "summaryVer( frame30 f30).1");
    f30.exit( 0, e);
  }//catch

  try {

    Vector M = listStat30.moda( l30);
    if ( index30.eqS( M, l30.UNKB))
      append(".   MODE: " + M + ". unKB-items: " + listStat30.kb( l30, M) + 
        ". unKB-cases: " + listStat30.KB( l30, M) + "\n");
      else append(".   MODE: " + M + ". KB-items: " + listStat30.kb( l30, M) + 
        ".  KB-cases: " + listStat30.KB( l30, M) + "\n");
    append("gapsXX: " + l30.gapsXX() + ".  ");
    append("gapsXY: " + l30.gapsXY() + ".\n");
    if (l30.dimension()==2) {
	   append("Size:            " + l30.size() + ".\n"); 
      append("Stress:          " + table2D30.stress( l30) + ".\n");
      lista30 sl30 = new simetricBase30().simetric( l30);
      append("Simetric-Size:   " + sl30.size() + ".\n");
      append("Simetric-Stress: " + table2D30.stress( sl30) + ".\n");      
     }
  } catch (Exception e) { 
    System.out.println( ERROR + "summaryVer( frame30 f30).2");
    f30.exit( 0, e);
  }//catch

  try {

   append("Schema.\n");
   l30.Esqu.browser( frame30.kbm2lSystem);
   append("\n");

    append("KB-items: " + listStat30.kb( l30) + ".  ");
    for( int i = 0; i < numResponses-1; i++) {
      append( listStat30.kb( l30, (Vector)S.get( i)) + 
        " / " + ((Vector)S.get( i)).toString() + ", ");
      if (((i+1)%4) == 0) append( "\n");
      }  
    if ( numItems <= S.size()-1)
      append("....., ");
    append("  and  " + listStat30.kb( l30, (Vector)S.get( S.size()-1)) + 
      " / " + ((Vector)S.get( S.size()-1)).toString()+ "\n");

  } catch (Exception e) { 
    System.out.println( ERROR + "summaryVer( frame30 f30).3");
    System.out.println( "S: " + S.toString() + "   numResponses: " + numResponses);
    f30.exit( 0, e);
  }//catch

  BigInteger KBcases = listStat30.KB( l30);

  try {

    append("KB-cases: " + KBcases.toString() + ".    KBtypes:  ");
    for( int i = 0; i < numResponses-1; i++) {
      append( listStat30.KB( l30, (Vector)S.get( i)) + 
        " / " + ((Vector)S.get( i)).toString() + ", ");
      if (((i+1)%4) == 0) append( "\n");
      }  
    if ( numItems <= S.size()-1)
      append("....., ");
    append("  and  " + listStat30.KB( l30, (Vector)S.get( S.size()-1)) + 
      " / " + ((Vector)S.get( S.size()-1)).toString()+ "\n");

  } catch (Exception e) { 
    System.out.println( ERROR + "summaryVer( frame30 f30).4");
    System.out.println( "S: " + S.toString() + "   numResponses: " + numResponses);
    f30.exit( 0, e);
  }//catch

  try {

    double rskb = listStat30.KB( l30, l30.RSKB).doubleValue();
    if (rskb > 0.0)
      append( "SA(RSKB,RSKB/KB): (" + rskb + "," + rskb / KBcases.doubleValue() + ")\n");

    BigInteger It = listStat30.MaximoItem( l30);
    int it = listStat30.maximoItem( l30);
    append(" max Item ---  " + it + "   Size:(" + It + ").   ");
    It = listStat30.MinimoItem( l30);
    it = listStat30.minimoItem( l30);
    append(" min Item ---  " + it + "   Size:(" + It + ").\n");
    
    append(" Base-dbari ---(\n" + l30.Base.toString( l30) + ").\n");
    append(" Weights  ---  (" + listStat30.getWeights( l30).toString() + ").\n");
    append(" (memSize ---  (" + listStat30.memSize( l30) + ")).\n");

  } catch (Exception e) { 
    System.out.println( ERROR + "summaryVer( frame30 f30).5");
    f30.exit( 0, e);
  }//catch
    
  try {
	    
    if ( l30.BasesList != null) {// bTest
      append(" (BasesList ---  (" + l30.BasesList.size( ) + ")).\n");
     }//

    if ( f30.p30 != null) { // listHistory
      append(" (listHistory ---  (" + f30.p30.size( ) + ")).\n");
      for( int i = 0; i < f30.p30.size(); i++)
        append("List: " + i + ".......( ---  (" + f30.p30.get( i).size() + " items)).\n");
      }//
     
    if ( new controlPrefs30().checkMode()) {
      verReglas( l30);
      }//
    
  } catch (Exception e) { 
    System.out.println( ERROR + "summaryVer( frame30 f30).6");
    f30.exit( 0, e);
  }//catch

  } else {
      append("KBM2L: empty. " + l30.Name() + "\n");
      append(" Base-dbari ---(\n" + l30.Base.toString( l30) + ").\n");
      append(" Weights  ---  (" + listStat30.getWeights( l30).toString() + ").\n");
      append(" (memSize ---  (" + listStat30.memSize( l30) + ")).\n");
      }//

  append("//###//.\n");
  f30.kbm2lSystem.estatus( "Summary KBM2L.");
  return;
}//summaryVer

/**
* Run procedure on traceBrowser30
* BasesList: traza de sintesis de l30. 
**/
public  void  traceViewThread( lista30 l30) {

//BasesList 
  if ( l30.BasesList != null) { 
    append( "\nBasesList.  BasesList.sz: "  + l30.BasesList.size() + "\n");
    for( int i = 0; i < l30.BasesList.size(); i++) {
      append("i: " + i + "  " +((base30)l30.BasesList.get( i)).Bas() + "\n");  
      for( int j = 0; j < l30.dimension(); j++)
        append("    j: " + j + "  " +((base30)l30.BasesList.get( i)).bas( j) + "\n");
     }
    }//if

  return;
}//summaryViewSynthesisTrace

/**
* Run procedure on summaryBrowser30 class
**/
protected  synchronized  void summaryViewThread( lista30 l30) {

  checkList30.chk( l30, "summaryViewThread");
  iniVer( l30);
  summaryVer( l30);
  return;
}//summaryViewThread

/**
* Procedimiento de evento de menu.
**/
public  void summaryView( lista30 l30) {

  new Thread ( new summaryBrowser30( l30) ).start();  
  return;
}//summaryView

/**
* Procedimiento de evento de menu.
**/
public  void traceView( lista30 l30) {

  new Thread ( new traceBrowser30( l30) ).start();  
  return;
}//summaryView


/**
* Run procedure on listBrowser30 class
**/
protected  synchronized  void listViewThread( lista30 l30) {

  checkList30.chk( l30, "listViewThread");
  if ( iniVer( l30))
    kbm2lVer( l30);
  return;
}//listViewThread

/**
* Procedimiento de evento de menu.
**/
public  void listView( lista30 l30) {

  new Thread ( new listBrowser30( l30) ).start();  
  return;
}//listView

public static spectrumPaint30 brsp = null;
/**
* 
**/
public void spectrumView( lista30 l30) {

  iniVer( l30);
  if ( brsp == null) 
    brsp = new spectrumPaint30( f30);
  if ( !brsp.working) 
    new Thread( brsp).start();
  return;
}//spectrumView

public String about() {

  return "KBM2L 30.0   Browser 30.0\n";
}//about


}//public class browser30


/**
* Clase summaryBrowser30
**/
class  summaryBrowser30  extends  frame30  implements Runnable {

  private static final String ERROR = "Error(summaryBrowser30): ";
  private lista30 l30 = null;
/**
* Constructor por defecto
**/
public summaryBrowser30( lista30 l30) {

  this.l30 = l30;
}//summaryBrowser

/**
* run process
**/
public void run() {

  try {
    kbm2lBrowser.summaryViewThread( l30);//synchronized
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
  }//catch
  
  return;
}//run

}//class summaryBrowser30


/**
* Clase listBrowser30
**/
class  listBrowser30  extends  frame30  implements Runnable {

  private static final String ERROR = "Error(listBrowser30): ";
  private lista30 l30 = null;
  private static boolean working = false;

/**
* Constructor por defecto
**/
public listBrowser30( lista30 l30) {

  this.l30 = l30;
}//listBrowser

/**
* run process
**/
public void run() {

  try {
    if (!working) {
      working = true;
      kbm2lBrowser.listViewThread( l30);//synchronized
      working = false;
      }
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
  }//catch
  
  return;
}//run

}//class ListBrowser30


/**
* Clase traceBrowser30
**/
class  traceBrowser30  extends  frame30  implements Runnable {

  private static final String ERROR = "Error(traceBrowser30): ";
  private lista30 l30 = null;
  private static boolean working = false;

/**
* Constructor por defecto
**/
public traceBrowser30( lista30 l30) {

  this.l30 = l30;
}//traceBrowser

/**
* run process
**/
public void run() {

  try {
    if (!working) {
      working = true;
      kbm2lBrowser.traceViewThread( l30);//synchronized
      working = false;
    }
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
  }//catch
  
  return;
}//run

}//class traceBrowser30

