//FRAME30//
package kbm2l;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import control.*;
import kernel.*;
import tables.*;
import schema.*;
import target.*;
import synthesis.*;
import modelo.*;

/**
* Clase frame30.
* <p>
* <pre>
* Entorno de la aplicacion.
* </pre>
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
* @since    KBM2L 1.0
**/
public  class  frame30  extends  Object  implements  Runnable {

  private static final String ERROR = "Error(frame30): ";
  public static final int exitCodeOK = 1000;

/**
* Check general
**/
  public static boolean chk = false;

/**
* Utility manager funcion
**/
  public static int utmanager = -1;
  
//AWT  
/**
* Entorno de system
**/
  public static system30 kbm2lSystem = null;
/**
* Entorno de time
**/
  public static time30 kbm2lTime = null;
/**
* Entorno de control  
**/
  public static control30 kbm2lControl = null;
/**
* Entorno de browser
**/
  public static browser30 kbm2lBrowser = null;

//Aplicacion

/**
* Entorno Global
**/
  public  static frame30 f30 = null;//AWT - Window - frame

/**
* Tiempo inicial
**/
  public static long TCP1 = -1;//mseg de sesion

/**
* protocolo activo
**/
  public static protocolo30 p30 = null;//protocolo: Vector listas
/**
* lista activa
**/
  public static lista30     activel30 = null;//lista activa
/**
* modelo activo
**/
  public static modelo30  mod30 = null;//modelo de Programacion math

/**
* Constructor por defecto, sin ventanas
**/
public frame30( ) {

}//frame30

/**
* Constructor general. Inicializa el entono de ventanas
* 
* @param TITULO titulo de la ventana de system
**/
public frame30( String TITULO) {

  kbm2lSystem = new system30( this, TITULO);
  kbm2lControl = new control30( this);
  kbm2lBrowser = new browser30( this);
  kbm2lTime = new time30( this);

//componentes de la ventana principal y de control
  kbm2lSystem.frame.addWindowListener( new mainListener());//eventos de la ventana
  kbm2lControl.frame.addWindowListener( new mainListener());//eventos de la ventana
  kbm2lBrowser.frame.addWindowListener( new mainListener());//eventos de la ventana
  kbm2lTime.frame.addWindowListener( new mainListener());//eventos de la ventana

  chk = controlPrefs30.checkMode();

  utmanager = controlPrefs30.utilityManager();
  
  return;  
}//frame30

/**
* Inicializacion basica de la aplicacion
**/
public static frame30 iniFrame() {

  if ( f30 == null)
    f30 = new frame30( " Knowledge Bases Multidimensionals Matrices to Lists.");//Windows
  f30.TCP1 = new Date().getTime();    
  f30.p30 = null;//protocolo
  f30.activel30 = null;//lista activa
  f30.mod30 = null;//modelo

  return f30;
}//iniFrame

/**
* Inicializacion de la aplicacion con una tabla o protocolo
**/
public static frame30 iniFrame( String fileTable) {

  if ( f30 == null)
    f30 = new frame30( " Knowledge Bases Multidimensionals Matrices to Lists. " + fileTable);//Windows
  f30.TCP1 = new Date().getTime();    
  f30.p30 = null;//protocolo
  f30.activel30 = null;//lista activa
  f30.mod30 = null;//modelo

    if ( fileTable != "") {
    //captura de tabla o protocolo
      if (( fileTable.indexOf( ".ipd") == -1) && ( fileTable.indexOf( ".IPD") == -1)) {
        new Thread ( new tabla30( fileTable)).start();//filedlg ?
      } else {
      new Thread ( new protocolo30( fileTable)).start();
      }
    }

  return f30;
}//iniFrame

/**
* Mensage inicial del las ventanas
**/
private String about() {

  return "KBM2L 30.0   version 30.0\n";
}//about

/**
* Entrada de la aplicacion
* 0 args entorno de ventanas
* 1 args lista kbm2l || fichero de casos || fichero de datos; las extensiones determinan el tipo de entrada
* 2 args ??
* 3 args kbm2l + fichero de entrada con N bases (naturales) + fichero de salida con fitness de cada base
**/
public static void main( String args[]) {
/* la ventana, la tabla, la app y los enlaces */

  if (args.length < 1) {
    f30 = iniFrame();
    }
    else
    
  if (args.length == 1) {
    f30 = iniFrame( args[0]);
    } else    
    
  if (args.length == 2) {
    System.err.println( "Usage: java frame30 [filepath]");
    System.exit( -1);
    } else
        
  if (args.length == 3) {
	 f30 = new frame30();//sin entorno de ventanas
	 new fitness30( -1).fitnessF( args[0], args[1], args[2]);    
    } else {
    System.err.println( "Usage: java frame30 [filepath]");
    exit( -1);
    }

  return;  
}//main

/**
* Termina KBM32. 
* Guarda informacion de ventanas y cierra las ventanas y muestra el stack. exit.
* @param code int, codigo de terminacion
* @return code int, codigo de terminacion
**/
public static int exit( int code) {

  kbm2lSystem.saveText( kbm2lSystem.taSys, "system-exit", exitCodeOK);
  kbm2lBrowser.saveText( kbm2lBrowser.taVer, "browser-exit", exitCodeOK);
  kbm2lTime.saveText( kbm2lTime.taTim, "time-exit", exitCodeOK);

  kbm2lSystem.frame.setVisible(false);
  kbm2lSystem.frame.dispose();
  kbm2lControl.frame.setVisible(false);
  kbm2lControl.frame.dispose();
  kbm2lBrowser.frame.setVisible(false);
  kbm2lBrowser.frame.dispose();
  kbm2lTime.frame.setVisible(false);
  kbm2lTime.frame.dispose();

  System.out.println( "frame30 - code: " + code);
  if ( code != exitCodeOK) 
    new Exception().printStackTrace();//***
   
  System.exit( code);
  return code;
}//exit

/**
* Termina KBM32. 
* Guarda informacion de ventanas y cierra las ventanas y muestra el stack. exit.
* @param code int, codigo de terminacion
* @param e Exception, causa try--catch.
* @return code int, codigo de terminacion
**/
public static int exit( int code, Exception e) {

  kbm2lSystem.saveText( kbm2lSystem.taSys, "system-exit", exitCodeOK);
  kbm2lBrowser.saveText( kbm2lBrowser.taVer, "browser-exit", exitCodeOK);
  kbm2lTime.saveText( kbm2lTime.taTim, "time-exit", exitCodeOK);

  kbm2lSystem.frame.setVisible(false);
  kbm2lSystem.frame.dispose();
  kbm2lControl.frame.setVisible(false);
  kbm2lControl.frame.dispose();
  kbm2lBrowser.frame.setVisible(false);
  kbm2lBrowser.frame.dispose();
  kbm2lTime.frame.setVisible(false);
  kbm2lTime.frame.dispose();

  System.out.println( "frame30 - code: " + code);
  if ( code != exitCodeOK) e.printStackTrace();//***
   
  System.exit( code);
  return code;
}//exit

/**
* LLamada desde otra aplicacion en multithreading.
* @see #iniFrame()
* @exception Exception iniFrame
**/
public void run() {

  try {

    f30 = iniFrame();

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
    exit( -1, e);
  }//catch
  
  return;
}//run

}//class frame30

/*

import java.awt.*;
import java.awt.event.*;

public class MyApp extends Frame
{
	public MyApp()
	{
		this.addWindowListener	(new WindowAdapter(){
			public void windowClosing(WindowEvent e){
				dispose();
				System.exit(0);
			}
		});
	}
	
	public static void main(String args[])
	{
		System.out.println("Starting App");
		MyApp f = new MyApp();
		f.setSize(100,100);
		f.show();
	}
}

*/