//checkIndex30//
package kernel;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import control.*;
import kbm2l.*;

/**
* Test de validez de indices de las listas kbm2l
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  checkIndex30  extends  checkItem30 {

  private static final String ERROR = "Error(checkIndex30): ";

/**
* Constructor por defecto
**/
public checkIndex30( ) {
//

}//checkIndex30

/**
* Dimensiones parametros en la lista30, flags == true,...true,flase,...,false.
* @param l30 lista30
* @return flags Vector
**/
public  static  Vector FLAGS( lista30 l30) {

  Vector flags = new Vector(); 
  for( int i = 0; i <= l30.dimparam; i++) flags.add( new Boolean( true));
  for( int i = l30.dimparam+1; i < l30.dimension(); i++) flags.add( new Boolean( false));

  return flags;
}

/**
* Comprueba que un indice es factible en la lista
* Constructor del item30, CHK y eqKBM2L. 
* @param l30 kbm2l30
* @param indice Vector
* @return true/false
**/
public  static  boolean INDX( kbm2l30 l30, Vector indice) {

  try {
  for( int j = 0; j < indice.size(); j++) {
    int d = l30.Base.dom( j);
    int v = ((Integer)indice.get( j)).intValue();
    if (( v < 0)||( v >= d)) {
      frame30.kbm2lSystem.append( ERROR + "INDX: " + v + "<0 OR " + v + ">=" + d + "  en " + j + "\n");
      frame30.kbm2lSystem.append( "l30: " + l30.Name() + "\n");
      frame30.kbm2lSystem.append( "inx: " + indice + "  inx.sz: " + indice.size() + "\n");
      frame30.kbm2lSystem.append( "Bas: " + l30.Base.Bas() + "\n");
      frame30.kbm2lSystem.append( "Dom: " + l30.Base.Dom() + "\n");
      //return false;
      frame30.exit( -1);
      }//if
  }//for
    }//try
  catch (Exception e) {
    frame30.kbm2lSystem.append( ERROR + "INDX( l30, indice).\n");
    frame30.exit( 0, e);
  }//catch

  return true;
}//INDX

/**
* Comprueba que un indice es factible en la lista restringido a las dimemsiones con flags true
* Constructor del item30, CHK y eqKBM2L. 
* @param l30 kbm2l30
* @param indice Vector
* @param flags Vector
* @return true/false
**/
public  static  boolean INDX( kbm2l30 l30, Vector indice, Vector flags) {

  try {
    for( int j = 0; j < indice.size(); j++) 
      if (((Boolean)flags.get( j)).booleanValue()){
      int d = l30.Base.dom( j);
      int v = ((Integer)indice.get( j)).intValue();
      if (( v < 0)||( v >= d)) {
        frame30.kbm2lSystem.append( ERROR + "INDX: " + v + "<0 OR " + v + ">=" + d + "  en " + j + "\n");
        frame30.kbm2lSystem.append( "l30:   " + l30.Name() + "\n");
        frame30.kbm2lSystem.append( "inx:   " + indice + "  inx.sz: " + indice.size() + "\n");
        frame30.kbm2lSystem.append( "flags: " + flags + "  flags.sz: " + flags.size() + "\n");
        frame30.kbm2lSystem.append( "Bas:   " + l30.Base.Bas() + "\n");
        frame30.kbm2lSystem.append( "Dom:   " + l30.Base.Dom() + "\n");
        //return false;
        frame30.exit( -1);
        }//if
      }//for
    }//try
  catch (Exception e) {
    frame30.kbm2lSystem.append( ERROR + "INDX( l30, indice, flags).\n");
    frame30.exit( 0, e);
  }//catch

  return true;
}//INDX

}//class checkIndex30