//EQKBM2L30//
package kernel;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kbm2l.*;
import tables.*;
import control.*;
import target.*;

/**
* Clase eqKBM2L30, listas iguales, en bases distintas ?. Comparacion.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  eqKBM2L30  {

//
  private static final String ERROR = "Error(eqKBM2L30): ";

/**
* Constructor por defecto
**/
public eqKBM2L30( ) {
//

}//eqKBM2L30

/**
* Compatibles si: los parametros son identicos, 
* el espacios de representacion es igual,
* los dominios son iguales. 
* Para copias y uniones, pueden estar en bases diferentes.
* @return true/false, valor boolean 
**/
protected  static  boolean  compatible( lista30 l1, lista30 l2) {

//descriptor compatible-igual
  if ( !(( l1.ParMedida() == l2.ParMedida() ) && 
         ( l1.ParRespuesta() == l2.ParRespuesta() ) && 
         ( l1.ParIndice() == l2.ParIndice()))) {
    frame30.kbm2lSystem.append( ERROR + "NO compatible:\n"); 
    frame30.kbm2lSystem.append( "r:" + l1.ParMedida() + " ==> r:" + l2.ParMedida() + "\n"); 
    frame30.kbm2lSystem.append( "s:" + l1.ParRespuesta() + " ==> s:" + l2.ParRespuesta() + "\n"); 
    frame30.kbm2lSystem.append( "t:" + l1.ParIndice() + " ==> t:" + l2.ParIndice() + "\n"); 
    new Exception().printStackTrace();
    return false;
    }//if

//espacio de representacion compatible-igual
  BigInteger longitud1 = new offset30().getLONGITUD( l1.Base.Dom());
  BigInteger longitud2 = new offset30().getLONGITUD( l2.Base.Dom());
  if ( longitud1.compareTo( longitud2) != 0 ) {
    frame30.kbm2lSystem.append( ERROR + "NO compatible:\n"); 
    frame30.kbm2lSystem.append( "l1: " + longitud1 + " != l2: " + longitud2 + "\n"); 
    new Exception().printStackTrace();
    return false;
    }//if

//esquema compatible-igual, igualdad de dominio en bases diferentes
  for( int j = 0; j < l1.ParIndice(); j++) {
    int bj = l1.Base.bas( j);
    int dj=  l1.Base.dom( j);
    for( int k = 0; k < l2.ParIndice(); k++) {
      int bk = l2.Base.bas(    k);
      int dk = l2.Base.dom( k);
      if ( bj == bk) if ( dj != dk) {
        frame30.kbm2lSystem.append( ERROR + 
          "NO compatible: " + bj + "==" + bk + "  " + dj + "=/=" + dk + "\n"); 
        new Exception().printStackTrace();
        return false; 
        }//if
        }//for
     }//for

  return true;//OK!!!
}//compatible

/**
* Las compara listando las diferencias de contenido
* 
**/
protected  static  boolean  differences( lista30 l1, lista30 l2) {

  boolean dif = false;

  if ( !compatible( l1, l2)) {
    System.out.println( ERROR + "differences. NO compatible. <<"); 
    return false;
    } 

  Vector RESPUESTA1 = null;
  Vector INDICE1 = null;
  Vector RESPUESTA2 = null;
  Vector INDICE2 = null;

////COMPLEJO - TABLA
  Vector ULTIMO = index30.ultimoT( l1.Base.Dom());//indice ultimo de l1;
//interior de items
  for( INDICE1 = index30.primeroT( l1.Base.Dom());//indice primero de l1
      ( index30.myeqT( ULTIMO, INDICE1));// ((ULTIMO > INDEX) || (ULTIMO == INDEX))
      INDICE1 = index30.siguienteT( l1.Base.Dom(), INDICE1)) { // INDEX++

      RESPUESTA1 = l1.GET( INDICE1).GetRespuesta();
      INDICE2 = base30.Trnp( l1.Base, INDICE1, l2.Base);
      RESPUESTA2 = l2.GET( INDICE2).GetRespuesta();

      frame30.kbm2lSystem.estatus( "INDICE1: " + INDICE1.toString());

      if ( !index30.eqS( RESPUESTA1, RESPUESTA2)) { dif = true;
        frame30.kbm2lSystem.append( "INDICE1: " + INDICE1.toString() + "\n");
        frame30.kbm2lSystem.append( "INDICE2: " + INDICE2.toString() + "\n");
        frame30.kbm2lSystem.append( "RESPUESTA1: " + RESPUESTA1.toString() + "\n");
        frame30.kbm2lSystem.append( "RESPUESTA2: " + RESPUESTA2.toString() + "\n");
        }
      if ( index30.eqT( ULTIMO, INDICE1)) break;//evita OVF en siguienteT  
   }//for lista l1

//interior de items
  ULTIMO = index30.ultimoT( l2.Base.Dom());//indice ultimo de l2
  for( INDICE2 = index30.primeroT( l2.Base.Dom());//indice primero de l2
      ( index30.myeqT( ULTIMO, INDICE2)); // ((ULTIMO > INDICE2) || (ULTIMO == INDICE2))
      INDICE2 = index30.siguienteT( l2.Base.Dom(), INDICE2)) { // INDEX++

      RESPUESTA2 = l2.GET( INDICE2).GetRespuesta();
      INDICE1 = base30.Trnp( l2.Base, INDICE2, l1.Base);
      RESPUESTA1 = l1.GET( INDICE1).GetRespuesta();

      frame30.kbm2lSystem.estatus( "INDICE2: " + INDICE2.toString());

      if ( !index30.eqS( RESPUESTA2, RESPUESTA1)) { dif = true;
        frame30.kbm2lSystem.append( "INDICE2: " + INDICE2.toString() + "\n");
        frame30.kbm2lSystem.append( "INDICE1: " + INDICE1.toString() + "\n");
        frame30.kbm2lSystem.append( "RESPUESTA2: " + RESPUESTA2.toString() + "\n");
        frame30.kbm2lSystem.append( "RESPUESTA1: " + RESPUESTA1.toString() + "\n");
        }
      if ( index30.eqT( ULTIMO, INDICE2)) break;//evita OVF en siguienteT  
    }//for lista l2

  return dif;
}//differences

private  static  boolean eqDS( lista30 l1, lista30 l2, String msg) {
//dominio de respuestas DS
  if ( listStat30.DS( l1).size() != listStat30.DS( l2).size()) {
    frame30.kbm2lSystem.append( "eqDS. " + msg + ". DS:\n"); 
    frame30.kbm2lSystem.append( l1.Name() + "  l1.DS(): " + listStat30.DS( l1).size() + "\n"); 
    frame30.kbm2lSystem.append( l2.Name() + "  l2.DS(): " + listStat30.DS( l2).size() + "\n" ); 
    return false; //diferente dominio de respuestas
    }
  return true;
}//eqDS

private  static  boolean eqKB( lista30 l1, lista30 l2, String msg) {
//numero de casos conocidos
  if ( listStat30.KB( l1).compareTo( listStat30.KB( l2)) != 0) {
    frame30.kbm2lSystem.append( "eqKB. " + msg + ". KB:\n"); 
    frame30.kbm2lSystem.append( "l1: " + l1.Name() + "\n"); 
    frame30.kbm2lSystem.append( "l2: " + l2.Name() + "\n"); 
    frame30.kbm2lSystem.append( "l1.KB: " + listStat30.KB( l1) + " != l2.KB: " + listStat30.KB( l2) + "\n"); 
    return false; //numero de casos conocidos no iguales
    } 
  return true; 
}//eqKB

private  static  boolean  eqKBS( lista30 l1, lista30 l2, String msg) {
//los casos S de l1 son los mismos que los casos S de l2
  Vector S1 = listStat30.DS( l1);
  for( int i = 0; i < S1.size(); i++) {
    Vector S = ((Vector)S1.get( i));//para todas las modalidades que hay en l1
    if ( listStat30.KB( l1, S).compareTo( listStat30.KB( l2, S)) != 0) {
      frame30.kbm2lSystem.append( "eqKBS. " + msg + ".  S: " + S.toString() + "\n");     
      return false; //numero de casos conocidos de una respuesta concreta no iguales
      }
    }//for

  return true;  
}//eqKBS

private  static  boolean  eqITEMS( lista30 l1, lista30 l2, String msg) {

  Vector RESPUESTA1 = null;
  Vector INDICE1 = null;
  Vector RESPUESTA2 = null;
  Vector INDICE2 = null;

//extremos de items
  for( int i = 0; i < l1.size(); i++) {

    frame30.kbm2lSystem.estatus("eqITEMS - " + msg + ". item: " + i);

    item30 ITEM1 = l1.Get( i);
    INDICE1 = //indices de l1 en la base de l2
      base30.Trnp( l1.Base, ITEM1.GetIndice(), l2.Base);//
    INDICE2 = //indices de l2 en la base de l1
      base30.Trnp( l2.Base, INDICE1, l1.Base);//

//es indice de l1 ?
   if ( !checkIndex30.INDX( l1, INDICE2)) {
     frame30.kbm2lSystem.append( ERROR + "eqITEMS. INDICE2 in " + msg + ". i:" + i + "\n"); 
     frame30.kbm2lSystem.append( "ITEM1.GetIndice(): " + ITEM1.GetIndice().toString() + "\n"); 
     frame30.kbm2lSystem.append( "DOMINIO1: " + l1.Base.Dom().toString() + "\n"); 
     frame30.kbm2lSystem.append( "INDICE2: " + INDICE2.toString() + "\n"); 
     frame30.exit(0); //panic
     }//if

//es indice de l2 ?
   if ( !checkIndex30.INDX( l2, INDICE1)) {
     frame30.kbm2lSystem.append( ERROR + "eqITEMS. INDICE1 in " + msg + ". i:" + i + "\n"); 
     frame30.kbm2lSystem.append( "ITEM1.GetIndice(): " + ITEM1.GetIndice().toString() + "\n"); 
     frame30.kbm2lSystem.append( "DOMINIO2: " + l2.Base.Dom().toString() + "\n");      
     frame30.kbm2lSystem.append( "INDICE1: " + INDICE1.toString() + "\n"); 
     frame30.exit(0); //panic
     }//if

//INDICE2 es Trnp del Trnp del indice de ITEM1, son iguales ?
   if ( !(index30.eqT( ITEM1.GetIndice(), INDICE2))) {
     frame30.kbm2lSystem.append( ERROR + "eqITEMS. INDICE. " + msg + ". i:" + i + "\n"); 
     frame30.kbm2lSystem.append( "ITEM1.GetIndice(): " + ITEM1.GetIndice().toString() + "in B1\n"); 
     frame30.kbm2lSystem.append( "INDICE1: " + INDICE1.toString() + "in B2\n"); 
     frame30.kbm2lSystem.append( "INDICE2: " + INDICE2.toString() + "in B1\n"); 
     frame30.kbm2lSystem.append( "BASE1: \n" + l1.Base.toString( l1) + "\n"); 
     frame30.kbm2lSystem.append( "BASE2: \n" + l2.Base.toString( l2) + "\n");      
     frame30.exit(0); //panic
     }//if

//Las respuestas que corresponden a indices Trnp en sus respectivas listas deben ser iguales.
   RESPUESTA2 = l2.GET( INDICE1).GetRespuesta();//
   RESPUESTA1 = l1.GET( INDICE2).GetRespuesta();//

   if ( !index30.eqS( RESPUESTA1, RESPUESTA2)) {
     frame30.kbm2lSystem.append( "eqKBM2L. RESPUESTA. " + msg + ". i:" + i + "\n"); 
     frame30.kbm2lSystem.append( "ITEM1.GetIndice(): " + ITEM1.GetIndice().toString() + " in B1\n"); 
     frame30.kbm2lSystem.append( "INDICE1: " + INDICE1.toString() + " in B2\n");      
     frame30.kbm2lSystem.append( "INDICE2: " + INDICE2.toString() + " in B1\n");      
     frame30.kbm2lSystem.append( "BASE1: \n" + l1.Base.toString( l1) + "\n"); 
     frame30.kbm2lSystem.append( "BASE2: \n" + l2.Base.toString( l2) + "\n");      
     frame30.kbm2lSystem.append( "RESPUESTA1: " + RESPUESTA1.toString() + "\n"); 
     frame30.kbm2lSystem.append( "RESPUESTA2: " + RESPUESTA2.toString() + "\n"); 
     frame30.kbm2lSystem.append("   eqITEMS - End.\n");
     return false;// 
     }//if
   
   }//for lista l1

  return true;  
}//eqITEMS

/**
*
**/
private  static  Vector  IndexSchema( lista30 l30, Vector INDICE) {
	
   int codeAtributo = -1, codeAtributo_t = -1, codeValor_t = -1;
   Vector strIndex = new Vector();
   try {
     for( int i = 0; i < l30.dimension(); i++) {
       codeAtributo = ((Integer)INDICE.get( i)).intValue();
       codeAtributo_t = l30.Base.bas( i);//BC
       Vector V = (Vector)(l30.Esqu.ValoresAtributos.get( codeAtributo_t));
       codeValor_t = l30.Base.att( i, codeAtributo);
       strIndex.add( new String((String)(V.get( codeValor_t))));
       }
  }//try
  catch (Exception e) {
    frame30.kbm2lSystem.append( ERROR + "IndexSchema.\n");
    frame30.kbm2lSystem.append( "INDICE: " + INDICE.toString() + "\n");
    frame30.kbm2lSystem.append("codeAtt: " + codeAtributo + "\n");
    frame30.kbm2lSystem.append("codeAtt_t: " + codeAtributo_t + "\n");
    frame30.kbm2lSystem.append("codeValor_t: " + codeValor_t + "\n");
    frame30.kbm2lSystem.append("BASE:\n" + l30.Base.toString( l30) + "\n");
    l30.Esqu.browser( frame30.kbm2lSystem);
    frame30.exit( 0, e);    
  }//catch
  return strIndex;
}//IndexSchema

private  static  boolean  eqTABLES( lista30 l1, lista30 l2, String msg) {

  Vector ULTIMO = null;
  Vector RESPUESTA1 = null;
  Vector INDICE1 = null;
  Vector RESPUESTA2 = null;
  Vector INDICE2 = null;

  boolean chk = new controlPrefs30().checkMode();

  try {

//interior de items
  ULTIMO = index30.ultimoT( l1.Base.Dom());//indice ultimo de l1
  for( INDICE1 = index30.primeroT( l1.Base.Dom());//indice primero de l1
      ( index30.myeqT( ULTIMO, INDICE1));// ((ULTIMO > INDEX) || (ULTIMO == INDEX))
      INDICE1 = index30.siguienteT( l1.Base.Dom(), INDICE1)) { // INDEX++
      if ( !l1.esUNKB( l1.GET( INDICE1))) {
        RESPUESTA1 = l1.GET( INDICE1).GetRespuesta();
        INDICE2 = base30.Trnp( l1.Base, INDICE1, l2.Base);
        RESPUESTA2 = l2.GET( INDICE2).GetRespuesta();
        if ( chk) {
          frame30.kbm2lSystem.append( "INDICE1: " + INDICE1.toString()+".\n"); 
          frame30.kbm2lSystem.append( "INDICE2: " + INDICE2.toString()+".\n");      
          frame30.kbm2lSystem.append( "INDICE1: " + IndexSchema( l1, INDICE1).toString()+".\n"); 
          frame30.kbm2lSystem.append( "INDICE1: " + IndexSchema( l2, INDICE2).toString()+".\n"); 
          frame30.kbm2lSystem.append( "RESPUESTA1: " + RESPUESTA1.toString()+".  "); 
          frame30.kbm2lSystem.append( "RESPUESTA2: " + RESPUESTA2.toString()+".\n"); 
          }
        if ( !index30.eqS( RESPUESTA1, RESPUESTA2)) {
          frame30.kbm2lSystem.append( ERROR + "eqKBM2L. RESPUESTA. " + msg + ".\n"); 
          frame30.kbm2lSystem.append( "INDICE1: " + INDICE1.toString()+".\n"); 
          frame30.kbm2lSystem.append( "INDICE2: " + INDICE2.toString()+".\n");      
          frame30.kbm2lSystem.append( "INDICE1: " + IndexSchema( l1, INDICE1).toString()+".\n"); 
          frame30.kbm2lSystem.append( "INDICE1: " + IndexSchema( l2, INDICE2).toString()+".\n"); 
          frame30.kbm2lSystem.append( "RESPUESTA1: " + RESPUESTA1.toString()+".\n"); 
          frame30.kbm2lSystem.append( "RESPUESTA2: " + RESPUESTA2.toString()+".\n"); 
          return false; 
          }
      if ( index30.eqT( ULTIMO, INDICE1)) break;//evita OVF en siguienteT  
  frame30.kbm2lSystem.estatus( msg + INDICE1.toString());     
     }//-if-esUNKB
     else INDICE1 = l1.GET( INDICE1).GetIndice();
   }//for lista l1

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "eqTABLES. " + msg);
    frame30.exit( 0, e);
  }//catch

  return true;  
}//eqTABLES

/**
* Listas equivalentes en bases distintas: compatibles, igual dominio de respuesta y
* numero de casos conocidos, numero de casos conocidos de tipo S, 
* @param l1 lista30
* @param l2 lista30
* @param msg string mensaje
**/
protected  static  boolean  eqKBM2L( lista30 l1, lista30 l2, String msg) {

  frame30.kbm2lTime.append("eqKBM2L - Init.\n");

  frame30.kbm2lTime.append("eqKBM2L - CALC+CHK l1.\n");

  listStat30.calc( l1);
  checkList30.CHK( l1, "eqKBM2L-l1: " + l1.Name());

  frame30.kbm2lTime.append("eqKBM2L - CALC+CHK l2.\n");

  listStat30.calc( l2);
  checkList30.CHK( l2, "eqKBM2L-l2: " + l2.Name());

  frame30.kbm2lTime.append("eqKBM2L - compatible (l1,l2).\n");

  if ( !compatible( l1, l2)) {
    System.out.println( ERROR + "eqKBM2L. compatible. <<" + msg); 
    new Exception().printStackTrace();
    return false;
    } 

  frame30.kbm2lTime.append("eqKBM2L - eq[DS,KB,KBS] (l1,l2).\n");

  if ( !eqDS( l1, l2, msg)) return false;
  if ( !eqKB( l1, l2, msg)) return false;
  if ( !eqKBS( l1, l2, msg + " (l1->l2)")) return false;
  if ( !eqKBS( l2, l1, msg + " (l2->l1)")) return false;

//SIMPLE - LIST
  frame30.kbm2lTime.append("eqITEMS (l1->l2).\n");
  if ( !eqITEMS( l1, l2, msg + " (l1->l2)")) return false;
  frame30.kbm2lTime.append("eqITEMS (l2->l1).\n");
  if ( !eqITEMS( l2, l1, msg + " (l2->l1)")) return false;

////COMPLEX - TABLE
  frame30.kbm2lSystem.append( "\nTABLES::..::\n"); 
  frame30.kbm2lSystem.append("\nBASE l1:\n" + l1.Base.toString( l1) + "\n");
  l1.Esqu.browser( frame30.kbm2lSystem);
  frame30.kbm2lSystem.append("\nBASE l2:\n" + l2.Base.toString( l2) + "\n");
  l2.Esqu.browser( frame30.kbm2lSystem);

  frame30.kbm2lSystem.append( "\nTABLES::.l1<>l2.::\n"); 
  if ( !eqTABLES( l1, l2, msg + " eqTABLES - l1")) return false;

  frame30.kbm2lSystem.append( "TABLES::.l2<>l1.::\n"); 
  if ( !eqTABLES( l2, l1, msg + " eqTABLES - l2")) return false;

  frame30.kbm2lTime.append("   eqKBM2L - End.\n");
  return true;
}//eqKBM2L

}//class eqKBM2L30