//EQKBM2L30//
package kernel;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kbm2l.*;
import tables.*;
import control.*;
import target.*;

/**
* Clase eqLista30, listas iguales, en bases distintas ?. Comparacion, diferencias y equivalencia.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  eqLista30  extends  eqKBM2L30  {

//
  private static final String ERROR = "Error(eqLista30): ";

/**
* Constructor por defecto
**/
public eqLista30( ) {
//

}//eqLista30

/**
* Compatibles si: los parametros son identicos, 
* el espacio de representacion es igual,
* los dominios son iguales. 
* Para copias y uniones.
* Lee dos listas y las compara estructuralmente.
* @return true/false, valor boolean 
**/
public  static  boolean  compatible( ) {

  frame30.p30 = new protocolo30();
  frame30.kbm2lSystem.append("eqKBM2L -Cmp- list: l1?");
  lista30 l1 = new inputTable30().leerTabla( null, "");
  if ( l1 == null) return false;
  frame30.p30.add( l1);
  frame30.kbm2lSystem.append("eqKBM2L -Cmp- list: l2?");
  lista30 l2 = new inputTable30().leerTabla( null, "");
  if ( l2 == null) return false;
  frame30.p30.add( l2);

  if ( compatible( l1, l2)) {
    frame30.kbm2lSystem.append(
      "eqKBM2L -Cmp T- list: " + l1.Name() + "  list: " + l2.Name()+"\n");  
    return true;
    } else {
      frame30.kbm2lSystem.append(
        "eqKBM2L -Cmp F- list: " + l1.Name() + "  list: " + l2.Name()+"\n");  
      return false;
    }
}//compatible

/**
* Lee dos listas y las compara listando las diferencias de contenido
* 
**/
public  static  boolean  differences( ) {

  frame30.p30 = new protocolo30();
  frame30.kbm2lSystem.append("eqKBM2L -Dif- list: l1?");
  lista30 l1 = new inputTable30().leerTabla( null, "");
  if ( l1 == null) return false;
  frame30.p30.add( l1);
  frame30.kbm2lSystem.append("eqKBM2L -Dif- list: l2?");
  lista30 l2 = new inputTable30().leerTabla( null, "");
  if ( l2 == null) return false;
  frame30.p30.add( l2);

  if ( differences( l1, l2)) {
    frame30.kbm2lSystem.append(
      "eqKBM2L -Diff True - list: " + l1.Name() + "  list: " + l2.Name());  
    return true;
    } else {
      frame30.kbm2lSystem.append(
        "eqKBM2L - Diff False - list: " + l1.Name() + "  list: " + l2.Name());  
      return false;
    }
}//differences

/**
* Listas equivalentes en bases distintas: compatibles, igual dominio de respuesta y
* numero de casos conocidos, numero de casos conocidos de tipo S, 
* Lee dos listas (compatibles) y las compara por el contenido.
* 
**/
public  static  boolean equivalent( String msg) {

  frame30.p30 = new protocolo30();
  frame30.kbm2lSystem.append("equivalent -Eqv- list: l1?");
  lista30 l1 = new inputTable30().leerTabla( null, "");
  if ( l1 == null) return false;
  frame30.p30.add( l1);
  frame30.kbm2lSystem.append("equivalent -Eqv- list: l2?");
  lista30 l2 = new inputTable30().leerTabla( null, "");
  if ( l2 == null) return false;
  frame30.p30.add( l2);

  if ( eqKBM2L( l1, l2, "Eqv")) {
    frame30.kbm2lSystem.append(
      "equivalent - Eqv True - list: " + l1.Name() + "  list: " + l2.Name());  
    return true;
    } else {
      frame30.kbm2lSystem.append(
        "equivalent -Eqv False - list: " + l1.Name() + "  list: " + l2.Name());  
      return false;
    }
}//equivalent

}//class eqLista30