//INDEX30//
package kernel;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kbm2l.*;
import control.*;

/**
* Clase index30.
* Indices, respuestas y medidas de items.
* metodos static
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class index30 {

//
  private static final String ERROR = "Error(index30): "; 

/**
* Componente de indice desconocida, abierta, libre o overlimit. -1.
**/
  public static final int unIndex = -1;
/**
* Componente de respuesta desconocida. -1.
**/
  public static final int unKB = -1; 
/**
* Componente de respuesta restringida. -2.
**/
  public static final int coKB = -2;
/**
* Componente de respuesta sensible. -3.
**/
  public static final int rsKB = -3;
/**
* Componente de respuesta de referencia. -4.
**/
  public static final int rrKB = -4;
  
/**
* Constructor por defecto.
**/
public index30() {

}//index30

/**
* Vector de indice de componentes desconocidas.
**/
public static Vector unIndice( int dT) {

  Vector UNKB = new Vector();
  for( int i = 0; i < dT; i++)
    UNKB.add( new Integer( unIndex));
  return UNKB;
}//unIndice

/**
* Vector de respuesta desconocida.
**/
public static Vector unRespuesta( int dS) {

  Vector UNKB = new Vector();
  for( int i = 0; i < dS; i++)
    UNKB.add( new Integer( unKB));
  return UNKB;
}//unRespuesta

/**
* Vector de respuesta imposible o restringida.
**/
public static Vector coRespuesta( int dS) {

  Vector COKB = new Vector();
  for( int i = 0; i < dS; i++)
    COKB.add( new Integer( coKB));
  return COKB;
}//coRespuesta

/**
* Vector de respuesta sensible.
**/
public static Vector rsRespuesta( int dS) {

  Vector RSKB = new Vector();
  for( int i = 0; i < dS; i++)
    RSKB.add( new Integer( rsKB));
  return RSKB;
}//rsRespuesta

/**
* Vector de respuesta de referencia.
**/
public static Vector rrRespuesta( int dS) {

  Vector RRKB = new Vector();
  for( int i = 0; i < dS; i++)
    RRKB.add( new Integer( rrKB));
  return RRKB;
}//rrRespuesta

/**
* Vector de medida desconocida.
**/
public static Vector unMedida( int dR) {

  Vector UNKB = new Vector();
  for( int i = 0; i < dR; i++)
    UNKB.add( new Double( unKB));
  return UNKB;
}//unMedida

/**
* Vector de medida imposible o restringida.
**/
public static Vector coMedida( int dR) {

  Vector COKB = new Vector();
  for( int i = 0; i < dR; i++)
    COKB.add( new Double( coKB));
  return COKB;
}//coMedida

/**
* Copia de medidas
**/
public static Vector cpR( Vector J) {

  Vector I = new Vector( );
  for(int i = 0; i < J.size(); i++) {//!!!
    double n = ((Double)J.get( i)).floatValue();
    Double N = new Double( n);
    I.add( N);
    }
  return I;
}//cpR

/**
* Copia de respuestas
**/
public static Vector cpS( Vector J) {

  Vector I = new Vector( );
  for(int i = 0; i < J.size(); i++) {//!!!
    int r = ((Integer)J.get( i)).intValue();
    Integer R = new Integer( r);
    I.add( R);
    }
  return I;
}//cpS

/**
* Copia de indices
**/
public static Vector cpT( Vector J) {

  Vector I = new Vector( );
  for(int i = 0; i < J.size(); i++) {//!!!
    int n = ((Integer)J.get( i)).intValue();
    Integer N = new Integer( n);
    I.add( N);
    }
  return I;
}//cpT

/**
* Copia de indices, prefijo
**/
public static Vector cpT( Vector J, int p) {

  if ( J.size() <= p) {
      System.out.println( ERROR + "J: " + J.size() + " <= p: " + p);
      new Exception().printStackTrace();
      System.exit(0);
    }
  Vector I = new Vector( );
  for(int i = 0; i <= p; i++) {//!!!
    int n = ((Integer)J.get( i)).intValue();
    Integer N = new Integer( n);
    I.add( N);
    }
  return I;
}//cpT

/**
* Igualdad de indices
**/
public static boolean eqT( Vector I1, Vector I2) {// I1==I2

    return I1.equals(I2);
}//eqT "indices iguales"

/**
* Indice I1 > I2, mayor
**/
public static boolean myT( Vector I1, Vector I2) {// I1>I2

  try {
  if ( I1.size() == 0) {
      System.out.println( ERROR + "myT: " + I1.size() + " == 0");
      new Exception().printStackTrace();
      System.exit(0);
    }
  if ( I1.size() != I2.size()) {
      System.out.println( ERROR + "myT: " + I1.size() + " != " + I2.size());
      new Exception().printStackTrace();
      System.exit(0);
    }
  } catch (Exception e){
      System.out.println( ERROR + "exception myT-1");
      e.printStackTrace();
      System.exit(0);
  }

  try {
    for(int i = 0; i < I1.size(); i++) {
      int nI1 = ((Integer)I1.get( i)).intValue();
      int nI2 = ((Integer)I2.get( i)).intValue();
      if (nI1 > nI2) return true;
      if (nI1 < nI2) return false;
      } 
  } catch (Exception e){
      System.out.println( ERROR + "exception myT-2");
      e.printStackTrace();
      System.exit( 0);
  }
  return false;
}//myT "mayor que" indice

/**
* Indice INDICE >= INDEX, mayor o igual.
**/
public static boolean myeqT( Vector INDICE, Vector INDEX) {
// ((INDICE > INDEX) || (INDICE == INDEX))

  return (( index30.myT( INDICE, INDEX) || index30.eqT( INDICE, INDEX)));
}// INDICE "mayor o igual que" INDEX

/**
* Respuestas iguales. Comparacion logica. 
* la respuesta es cualitativa, no hay >.
**/
public static boolean eqS( Vector S1, Vector S2) {//S1==S2

  return S1.equals( S2);
}//respuesta igual

/**
* medidas iguales.
**/
public static boolean eqR( Vector R1, Vector R2) {//R1==R2

  return R1.equals( R2);
}//medida igual

/**
* Medida R1 > R2, mayor.  
**/
public static boolean myR( Vector R1, Vector R2) {//R1>R2
//tema abierto

  if (R1.size() != R2.size()) {
      System.out.println( ERROR + "myR: " + R1.size() + "!=,  " + R2.size());
      new Exception().printStackTrace();
      System.exit(0);
    }
  for(int i = 0; i < R1.size(); i++) {//flag==R
    double rR1 = ((Double)R1.get( i)).doubleValue();
    double rR2 = ((Double)R2.get( i)).doubleValue();
    if (rR1 > rR2) return true;
    }
  return false;
}//"mayor que" medida

/**
* Indice J--.
**/
public static Vector anteriorT( Vector D, Vector J) {//J-1
//Dominio, Indice

  Vector I = cpT( J);
  if ( eqT( I, primeroT( D))) {//???
    System.out.println( ERROR + "anterior-3: OVF INDICE."+I.toString());
    new Exception().printStackTrace();
    System.exit(0);
    }//if

  for( int i = I.size()-1; i >= 0; i--) {

    int d = ((Integer)D.get( i)).intValue();
    if (d <= 1) {
      System.out.println( ERROR + "anterior-1: " + d + "<=1.");
      new Exception().printStackTrace();
      System.exit(0);
      }//if

    int v = ((Integer)I.get(i)).intValue();
    if (( v < 0)||( v >= d)) {
      System.out.println( ERROR + "anterior-2: " + v + "<=0 o " + v + ">=" + d);
      new Exception().printStackTrace();
      System.exit(0);
      }//if
    
      if ( v > 0) { I.set( i, new Integer( v - 1)); return I; }
        else I.set( i, new Integer( d - 1));
    }//for

  return I;
}//anterior indice 

/**
* Indice J++.
**/
public static Vector siguienteT( Vector D, Vector J) {//J+1
//Dominio, Indice

  if ( eqT( J, ultimoT( D))) {//???
    System.out.println( ERROR + "siguiente-3: OVF INDICE. " + J.toString());
    new Exception().printStackTrace();
    frame30.exit(0);
    }//if
  Vector I = cpT( J);
  for(int i = I.size()-1; i >=0 ; i--) {

    //dom
    int d = ((Integer)D.get( i)).intValue();
    if (d <= 1) {
      System.out.println( ERROR + "siguiente-1: [i]" + i + "  " + d + " <= 1.");
      new Exception().printStackTrace();
      frame30.exit(0);
      }//if

    //J
    int v = ((Integer)I.get( i )).intValue();
    if ((v < 0)||(v >= d)) {
      System.out.println( ERROR + "siguiente-2: [i]" + i + "  " + v + "<=0 o " + v + " >= " + d);
      new Exception().printStackTrace();
      frame30.exit(0);
      }//if

    //J++
      if ( v < d-1) { I.set(i,new Integer( v + 1)); return I; }
        else I.set(i,new Integer( 0));
    }//for

  return I;
}//siguiente indice

/**
* Indice primero. CERO.
**/
public static Vector primeroT( Vector D) {
//Dominio ==>> D

  Vector u = new Vector();
  for(int i = 0; i < D.size(); i++) {
    int d = ((Integer)D.get( i)).intValue();
    if (d<=1) {
      System.out.println( ERROR + "primeroT(D): " + d + " <= 1.");
      new Exception().printStackTrace();
      System.exit(0);
      }//if
    u.add( new Integer( 0));
    }//for
  if (u.size() < D.size()) {
    System.out.println( ERROR + "primeroT(D). " + u.size() + " < " + D.size());
    new Exception().printStackTrace();
    System.exit( 0);
  }//if
  return u;
}//indice primero == CERO.

/**
* Indice ultimo, d-1.
**/
public static Vector ultimoT( Vector D) {
//Dominio ==>> D

  Vector u = new Vector();
  for( int i = 0; i < D.size(); i++) {
    int d = ((Integer)D.get(i)).intValue();
    if (d<=1) {
      System.out.println( ERROR + "ultimo: " + d + "<=1.");
      new Exception().printStackTrace();
      System.exit(0);
      }//if
    u.add( new Integer( d-1));
    }//for
  if ( u.size() < D.size()) {
    System.out.println( ERROR + "ultimo.");
    new Exception().printStackTrace();
    System.exit( 0);
  }//if
  return u;
}//indice ultimo, depende del dominio

////
////
/**
* 
**/
public static Vector siguienteT( Vector D, Vector W, Vector J) {
//Dominio Instancia Indice

  Vector I = cpT( J);
  if ( eqT( I, ultimoT( D, W))) {//???
    System.out.println( ERROR + "siguiente-3: OVF INDICE."+I.toString());
    System.exit(0);
    }//if

  for(int i = I.size()-1; i >=0 ; i--) {

    int d = ((Integer)D.get( i)).intValue();
    if (d <= 1) {
      System.out.println( ERROR + "siguiente-1: " + d + "<=1.");
      System.exit(0);
      }//if

    int v = ((Integer)I.get( i )).intValue();
    if ((v < 0)||(v >= d)) {
      System.out.println( ERROR + "siguiente-2: " + v + "<=0 o " + v + ">=" + d);
      System.exit(0);
      }//if
    
    int w = ((Integer)W.get( i)).intValue();
    if (( w < d)&&( w >= 0)) ;//instanciado
      else {
        if ( v < d-1) { I.set(i,new Integer( v + 1)); return I; }
          else I.set(i,new Integer( 0));
      }
    }//for

  return I;
}//siguiente indice

/**
* 
**/
public static Vector primeroT( Vector D, Vector W) {
//Dominio Instancia 

  Vector u = new Vector();
  for(int i = 0; i < D.size(); i++) {
    int d = ((Integer)D.get( i)).intValue();
    if ( d <= 1) {
      System.out.println( ERROR + "primeroT(D,W): " + d + " <= 1.");
      System.exit(0);
      }//if
    int w = ((Integer)W.get( i)).intValue();
    if ((w < d)&&(w >= 0))
      u.add( new Integer( w));//instanciado
      else
        u.add( new Integer( 0));
    }//for
  if (u == null) {
    System.out.println( ERROR + "primeroT(D,W). u == null");
    System.exit( 0);
  }//if
  if (u.size() < D.size()) {
    System.out.println( ERROR + "primeroT(D,W). " + u.size() + " < " + D.size());
    System.exit( 0);
  }//if
  return u;
}//indice primero == CERO-INST.

/**
* 
**/
public static Vector ultimoT( Vector D, Vector W) {
//Dominio Instancia

  Vector u = new Vector();
  for(int i = 0; i < D.size(); i++) {
    int d = ((Integer)D.get(i)).intValue();
    if ( d <= 1) {
      System.out.println("Error(index30) ultimo: " + d + "<=1.");
      System.exit(0);
      }//if
    int w = ((Integer)W.get( i)).intValue();
    if ((w < d)&&(w >= 0))
      u.add( new Integer( w));//instanciado
      else
        u.add( new Integer(d-1));
    }//for
  if (( u == null)||( u.size() < D.size())) {
    System.out.println("Error(index30) ultimo.");
    System.exit( 0);
  }//if
  return u;
}//indice ultimo, depende del dominio y de la instancia

/**
* Indice de un offset dado el dominio. Offset inverso.
**/
public static Vector index( Vector Weights, BigInteger offset)  {

  BigInteger Q_1 = new BigInteger("0");
  Vector Indice = new Vector();
  for( int i = 0; i < Weights.size(); i++) {

    BigInteger DIFF = (offset.subtract( Q_1));
    BigInteger WEIGHT = (BigInteger)Weights.get( i);
    int v = DIFF.divide( WEIGHT).intValue();
    Indice.add( new Integer( v));

    Q_1 = new BigInteger("0");
    for( int j = 0; j <= i; j++) {
	   WEIGHT = (BigInteger)Weights.get( j);
	   BigInteger VALUE = BigInteger.valueOf(((Integer)Indice.get( j)).longValue());
      Q_1 = Q_1.add( WEIGHT.multiply( VALUE));
     }//for-j

  }//for-i

  return Indice;	
}//

}//class index30
