//ITEM30//
package kernel;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kbm2l.*;
import control.*;
import tables.*;
import target.*;

/**
* Clase item30. Representa un conjunto de entradas adyacentes iguales en una lista.
* Tiene entidad en la lista, con los items adyacentes, la base y el dominio.
* Componenentes: medida, respuesta, indice, offset, specX0, specY0, specX1, specY1.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  item30   {

  private static final String ERROR = "Error(item30): ";

  //contenidos
  private Vector medida = null; // double -> Double
  private Vector respuesta = null; // int -> Integer 
  private Vector indice = null; // int -> Integer 
  private offset30 offset = null;// int -> BigInteger
  private int specX0 = -1, specY0 = -1, specX1 = -1, specY1 = -1;//spectrum 

/**
* Constructor por defecto
**/
public item30( ) {

//contenidos
 medida = null;
 respuesta = null;
 indice = null;
 offset = null;
 specX0 = -1; specY0 = -1; specX1 = -1; specY1 = -1;
}//item30

/**
* Constructor general.
**/
public item30( kbm2l30 l30, Vector R, Vector S, Vector I) {
// contruye un item para la lista l30

  int r = R.size();
  int s = S.size();
  int t = I.size();

  checkIndex30.INDX( l30, I);

  if (( s <= 0)||( t <= 0)) {//hay respuesta e indice
      System.out.println( "List: " + ERROR + "s: " + s + "<=0,  t: " + t + "<=0");
      new Exception( ).printStackTrace();
      frame30.exit( -1);
    }//
  if ( l30.ParMedida() != r) {
      System.out.println( ERROR + "ParMedida(): " + l30.ParMedida() + "!=,  r: " + r);
      System.out.println( "List: " + l30.Name() + "    R: " + R);
      new Exception( ).printStackTrace();
      frame30.exit( -1);
    }//
  if ( l30.ParRespuesta() != s) {
      System.out.println( ERROR + "ParRespuesta(): " + l30.ParRespuesta() + "!=,  s: " + s);
      System.out.println( "List: " + l30.Name() + "    S: " + S);
      new Exception( ).printStackTrace();
      frame30.exit( -1);
    }//
  if ( l30.ParIndice() != t) {
      System.out.println( ERROR + "getParIndice(): " + l30.ParIndice() + "!=,  t: " + t);
      System.out.println( "List: " + l30.Name() + "    I: " + I);
      new Exception( ).printStackTrace();
      frame30.exit( -1);
    }//

  try {
    medida      =   index30.cpR( R);
    respuesta   =   index30.cpS( S);
    indice      =   index30.cpT( I);
    offset = new offset30( l30.Base.Dom(), I, I); 
    Cache( false);
    specX0 = -1; specY0 = -1; specX1 = -1; specY1 = -1;
  } catch (Exception e){
      System.out.println( ERROR + "item30.a   " + "List: " + l30.Name());
      System.out.println("R: " + R.toString());
      System.out.println("S: " + S.toString());
      System.out.println("I: " + I.toString());
      e.printStackTrace();
      frame30.exit( 0);
  }

}//item30

/**
* Constructor copia.
**/
public item30( kbm2l30 l30, item30 item) {
// contruye un item para la lista l30

  Vector R = item.GetMedida(); 
  Vector S = item.GetRespuesta(); 
  Vector I = item.GetIndice();

  int r = R.size();
  int s = S.size();
  int t = I.size();

  checkIndex30.INDX( l30, I);

  if (( s <= 0)||( t <= 0)) {//hay respuesta e indice
      System.out.println( ERROR + "s: " + s + "<=0,  t: " + t + "<=0");
      System.exit(0);
    }//
  if ( l30.ParMedida() != r) {
      System.out.println( ERROR + "ParMedida(): " + l30.ParMedida() + "!=,  r: " + r);
      System.exit(0);
    }//
  if ( l30.ParRespuesta() != s) {
      System.out.println( ERROR + "ParRespuesta(): " + l30.ParRespuesta() + "!=,  s: " + s);
      System.exit(0);
    }//
  if ( l30.ParIndice() != t) {
      System.out.println( ERROR + "getParIndice(): " + l30.ParIndice() + "!=,  t: " + t);
      System.exit(0);
    }//

  try {
    medida      =   index30.cpR( R);
    respuesta   =   index30.cpS( S);
    indice      =   index30.cpT( I);
    offset = new offset30( l30.Base.Dom(), I, I); 
    Cache( false);
    specX0 = item.specX0; specY0 = item.specY0; specX1 = item.specX1; specY1 = item.specY1;
  } catch (Exception e){
      System.out.println( ERROR + "item30.b");
      e.printStackTrace();
  }

}//item30

/**
* Items de la lista leida de un fichero externo, Tablas/Listas.
* @param c30 cabecera para interpretar el buffer.
* @param Ix indice para la tabla implicita
* @param buftks buffer de tokens que sirve para construir el indice, respuesta y medida del item.
* @return el item construido.
**/
public item30 item( kbm2l30 l30, cabecera30 c30, Vector Ix, Vector buftks) {
//componentes del item con instancias en indices

  Vector MEDIDA = new Vector();
  Vector RESPUESTA = new Vector();
  Vector INDICE = new Vector();

    try { 
      for( int i = 0; i < c30.R.size(); i++) {
        int k = ((Integer)( c30.R.get( i))).intValue();//mascara
        double v = ((Double)( buftks.get( k))).doubleValue();
        MEDIDA.add( new Double( v));// MEDIDA 
        }//for
      }//try
      catch (Exception e) {
        System.out.println(buftks.toString());
        int k = ((Integer)(c30.R.get( 0))).intValue();//mascara
        System.out.println(buftks.get( k).toString());
        System.out.println( ERROR + "Set.1 " + e + ", " +  "MEDIDA:" + MEDIDA.toString() +        
          "  RESPUESTA:" + RESPUESTA.toString() + "  INDICE:" + INDICE.toString());
        e.printStackTrace(); 
        frame30.exit( 0);
      }//catch
     
    try { 
      for( int i = 0; i < c30.S.size(); i++) {
        int k = ((Integer)( c30.S.get( i))).intValue();//mascara
        int v = ((Integer)( buftks.get( k))).intValue();
        RESPUESTA.add(new Integer( v));// RESPUESTA 
        }//for
      }//try
      catch (Exception e) {
        System.out.println( buftks.toString());
        int k = ((Integer)( c30.S.get( 0))).intValue();//mascara
        System.out.println( buftks.get( k).toString());
        System.out.println( ERROR + "Set.2 " + e + ", " + "MEDIDA:" + MEDIDA.toString() + 
          "  RESPUESTA:" + RESPUESTA.toString() + "  INDICE:" + INDICE.toString());
        e.printStackTrace();  
        frame30.exit( 0);
      }//catch

    try { 
      if ( c30.T.size() > 0) {//Tabla-explicita
        for( int i = 0; i < c30.T.size(); i++) {
          int k = ((Integer)(c30.T.get( i))).intValue();//mascara
          int v = ((Integer)(buftks.get( k))).intValue();
//          INDICE.add( new Integer( v));// INDICE
          INDICE.add( new Integer( l30.Base.att( i, v)));// INDICE
         }//for
       }//if
       else { 
         INDICE = index30.cpT( Ix);//Tabla-implicita 
         Ix = index30.siguienteT( l30.Base.Dom(), Ix);//nextIndice-Tabla implicita
         }
     }//try
     catch (Exception e) {
       System.out.println( buftks.toString());
       int k = ((Integer)( c30.T.get( 0))).intValue();//mascara
       System.out.println( buftks.get( k).toString());
       System.out.println( ERROR + "Set.3 " + e + ", " +  
         "MEDIDA:" + MEDIDA.toString() + "  RESPUESTA:" + RESPUESTA.toString() + 
         "  INDICE:" + INDICE.toString() + "  " + l30.Base.Att());
       frame30.exit( 0, e);
     }//catch

  if (( INDICE != null)&&( RESPUESTA != null)&&( MEDIDA != null)) {
    return new item30( l30, MEDIDA, RESPUESTA, INDICE);//!!!
    }
    
  System.out.println( ERROR + "itemTabla. Set.... Flag.");
  frame30.exit( -1);

  return null;  
}//item

////
//// Interfaz con la medida
////

/**
* Vector de medida del item
* @return medida Vector
**/
public Vector GetMedida() {

  if ( medida == null) {
    System.out.println( ERROR + "media.");
    System.exit(0);
  }//if
  return medida;
}//GetMedida

/**
* Vector de medida del item 
* @return medida Vector 
**/
public Vector SetMedida( Vector medida) {

  if ( medida == null) {
    System.out.println( ERROR + "medida.");
    System.exit( 0);
  }//if  
  
  return this.medida = medida;
}//SetMedida

/**
* Valor double de la posicion i del Vector de medida del item
* @param i componente de la medida 
* @return valor double del componente i de la medida del item
**/
public double GetMedida( int i) {

  if ( medida == null) {
    System.out.println( ERROR + "media.");
    System.exit(0);
  }//if
  return ((Double)medida.get( i)).floatValue();
}//GetMedida

////
//// Interfaz con la respuesta
////

/**
* Vector de respuesta del item 
* @return respuesta Vector 
**/
public Vector GetRespuesta() {

  if ( respuesta == null) {
    System.out.println( ERROR + "respuesta.");
    System.exit( 0);
  }//if  
  return respuesta;
}//GetRespuesta

/**
* Vector de respuesta del item 
* @return respuesta Vector 
**/
public Vector SetRespuesta( Vector respuesta) {

  if ( respuesta == null) {
    System.out.println( ERROR + "respuesta.");
    System.exit( 0);
  }//if  
  
  return this.respuesta = respuesta;
}//SetRespuesta

/**
* Valor int de la componente i del Vector de respuesta del item 
* @param i componente del vector de la respuesta
* @return valor int del componenete i de la respuesta del item
**/
public int GetRespuesta( int i) {

  if ( respuesta == null) {
    System.out.println( ERROR + "respuesta.");
    System.exit( 0);
  }//if  
  return ((Integer)respuesta.get( i)).intValue();
}//GetRespuesta

////
//// Interfaz con el indice
////

/**
* Vector de indice del item
* @return indice Vector.
**/
public Vector GetIndice() {

  if (indice == null) {
    System.out.println( ERROR + "indice.");
    System.exit( 0);
  }//if  
  return indice;
}//getIndice

/**
* Vector de indice del item
* @param i componente del vector del indice
* @return valor int del componente i del indice del item
**/
public int GetIndice( int i) {

  if (indice == null) {
    System.out.println( ERROR + "indice.");
    System.exit( 0);
  }//if  
  return ((Integer)indice.get( i)).intValue();
}//GetIndice

////
//// Interfaz con su offset
////

/**
* Offset inferior del item
**/
public BigInteger getOffsetInf() {
  
  return offset.getOffsetInf();
}//

/**
* Offset superior del item
**/
public BigInteger getOffsetSup() {
  
  return offset.getOffsetSup();
}//

/**
* Offset del item
**/
public offset30 setOffset( offset30 offset) {

  return (this.offset = offset);
}//

/**
* Longitud del item, numero de casos.
**/
public BigInteger getLongitud() {
  
  return offset.getLongitud();
}//

/**
* Longitud o numero de casos de una lista con dominio D:(0..d0-1,0..d1-1,0..d2-1,.....)
**/
public BigInteger getLONGITUD( Vector D) {
  
  return offset.getLONGITUD( D);
}//

/**
* flag de cache 
**/
public boolean Cache() {

  return offset.Cache();
}//Cache

/**
* flag de cache 
**/
public boolean Cache( boolean c) {

  return offset.Cache( c);
}//Cache

////
//// Interfaz con su spectrum
////

/**
*
**/
public void setBox( int newX0, int newY0, int newX1, int newY1) {

  specX0 = newX0; specY0 = newY0; specX1 = newX1; specY1 = newY1;
}//setBox

/**
*
**/
public int getX0() {

  return specX0;
}//getX0

/**
*
**/
public int getY0() {

  return specY0;
}//getY0

/**
*
**/
public int getX1() {

  return specX1;
}//getX1

/**
*
**/
public int getY1() {

  return specY1;
}//getY1

}//class item30
