//KBM2L30//
package kernel;

//
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import control.*;
import kbm2l.*;

/**
* clase kbm2l30 kernel del sistema kbm2l
* Dimensiones, dominios, base, lista de items y pesos.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  kbm2l30  extends  kbm30 {

//constantes
  private static final String ERROR = "Error(kbm2l30): ";

/**
* numero de casos maximo en la lista
**/  
  public long limitCases = 0;
/**
* numero de items maximo en la lista
**/  
  public long limitItems = 0;
/**
* numero de switches de la lista
**/  
  public long switches = 0;
/**
* vector de pesos de la lista, descriptor del espacio
**/
  public Vector Weights = null;//vector de pesos  
/**
* Control de monotonia de la informacion 
**/
  protected BigInteger controlKB = null;//monotono
/**
* MODE, respuesta mas frecuente, unkb (-1) por defecto
**/
  protected Vector MODE = null;//

/**
* ultima regla que se ha usado, para depurar
**/
  public static int lastRULE = -1;//
/**
* Reglas utilizadas, historia de la gestion de la lista desde su creacion
**/
  public Vector reglas = null;

//// Metodos

/**
* Constructor por defecto
**/
public kbm2l30( ) {

  limitCases = 0;
  limitItems = 0;
  switches = 0;
}//kbm2l

/**
*
**/
public BigInteger ctlKB( ) {

  return (controlKB);
}//ctlKB

/**
*
**/
public BigInteger ctlKB( BigInteger kbs) {

  return (controlKB = kbs);
}//ctlKB

////
////

/**
* Vector indice inferior del item en la lista l30.
* Es el siguiente del indice del item anterior el la lista o el primero del item 0.
* @param i posicion del item el la lista l30
* @return vector indice inferior
**/
public Vector Inf( int i) {

  try {
    if ( i == 0) {
      return index30.primeroT( Base.Dom());
      }

    if (( i > 0) && ( i < size())) {//el elto i de la lista.
      return ( index30.siguienteT( Base.Dom(), Get( i-1).GetIndice()));
      }
  } catch (Exception e) {
    System.out.println( ERROR  + "Inf( int). i: " + i);
    frame30.exit( 0, e);
  }//catch

  System.out.println( ERROR + "Inf: i = " + i);
  frame30.exit(-1);
  return null;
}//Inf

/**
* Vector del indice (superior) del item de la lista l30
* @param i posicion del item el la lista l30
* @return vector indice superior
**/
public Vector Sup( int i) {

  try {
    if (( i >= 0)&&( i < size())) {//el elto i de la lista.
      return ( Get( i).GetIndice());
      }
  } catch (Exception e) {
    System.out.println( ERROR  + "Sup( int). i: " + i);
    frame30.exit( 0, e);
  }//catch

  System.out.println( ERROR + "Sup: i = " + i);
  frame30.exit(-1);
  return null;
}//Sup

/**
* Vector de posiciones de atributos fijas en un item de la lista l30
* @param i posicion del item en la lista l30
* @return vector de atributos fijos en el indice del item i de la lista l30
**/
public Vector Fij( int i) {

  Vector iinf = Inf( i);
  Vector isup = Sup( i);
  Vector fij = new Vector();
  int j = 0;
  try {
    for( j = 0; j < dimension(); j++) {
      int x = ((Integer)iinf.get( j)).intValue();
      int y = ((Integer)isup.get( j)).intValue();
      if ( x == y)
        fij.add( new Integer( j));
        else return fij;
      }//for
  } catch (Exception e) {
    System.out.println( ERROR  + "Fij( int). i: " + i + "  Fij( int). j: " + j);
    System.out.println( "dimension(): " + dimension());
    System.out.println( "Fij( int). iinf: " + iinf);
    System.out.println( "Fij( int). isup: " + isup);
    frame30.exit( -1, e);
  }//catch

  return fij;//todo es fijo
}//Fij

/**
* Vector de valores de atributos fijos en un item de la lista l30
* @param i posicion del item el la lista l30
* @return fix vector de valores de atributos fijos en le indice del item i de la lista l30
**/
public Vector Fix( int i) {

  Vector isup = Sup( i);
  Vector fij = Fij( i);
  Vector fix = new Vector();
  int j = -1;
  int k = -1;
  try {
    for( j = 0; j < fij.size(); j++) {
      k = ((Integer)isup.get( j)).intValue();
      fix.add( new Integer( k));
    }//for
  } catch (Exception e) {
    System.out.println( ERROR  + "Fix( int). i:" + i + ". j: " + j + "  k: " + k);
    System.out.println( "Sup( i): " + isup.toString());
    System.out.println( "Fij( i): " + fij.toString());
    System.out.println( "fix:     " + fix.toString());
    frame30.exit( -1, e);
  }//catch

  return fix;//
}//Fix

/**
* Vector de posiciones de atributos variables en un item de la lista l30
* @param i posicion del item el la lista l30
* @return vector de atributos variables en le indice del item i de la lista l30
**/
public Vector Var( int i) {

  Vector iinf = Inf( i);
  Vector isup = Sup( i);
  Vector var = new Vector();
  if ( index30.eqT( iinf, isup))
      return var;//es null
  for(int j = 0; j < dimension(); j++) {
    int x = ((Integer)iinf.get( j)).intValue();
    int y = ((Integer)isup.get( j)).intValue();
    if (x != y) {
      for(int k = j; k < dimension(); k++) 
        var.add( new Integer( k));
      return var;
      }//if
    }//for

  System.out.println( ERROR + "Var."); 
  frame30.exit( -1, new Exception());
  return null;// error
}//Var

/**
* Primera posicion de izq a der en la base que ocupa un atributo variable. 
* Att de corte, ADR: atributo de dominio restringido si no recorre todo el dominio.
* @param i posicion del item en la lista l30.
* @return j posicion en la base del primer atributo variable en le indice del item i de la lista l30.
**/
public int cutDimension( int i) {

  Vector iinf = Inf( i);
  Vector isup = Sup( i);
  for( int j = 0; j < dimension(); j++) {
    int x = ((Integer)iinf.get( j)).intValue();
    int y = ((Integer)isup.get( j)).intValue();
    if ( x != y) return j;
    } 

  return -1;//no hay, el item es de longitud == 1.
}//cutDimension

/**
* Dominio de Atributo de corte. Indices de valores.
* LOs Att fijos toman un valor, los Att variables toman todos, el
* @param i posicion del item en la lista l30
* @return j, -1 si es irrelvante, 1,...j valores que toma en el item 
**/
public Vector cutAttributeDomain( int i) {

  Vector iinf = Inf( i);
  Vector isup = Sup( i);
  int x = -1, y = -1;
  for( int j = 0; j < dimension(); j++) {
    x = ((Integer)iinf.get( j)).intValue();
    y = ((Integer)isup.get( j)).intValue();
    if ( x != y) {
      Vector Dom = new Vector();
      for( int k = x; k <= y; k++) {  
        Dom.add( new Integer( k));
        }
      return Dom;
      } //return j;
    } 

  return null;//no hay, el item es de longitud == 1.
}//cutAttributeDomain

/**
* Dominio del atributo en la dimension de corte.
* @param i posicion del item el la lista l30
* @return j posicion en la base del primer atributo varible en le indice del item i de la lista l30
**/
public Vector dominioCorte( int i) {

  Vector iinf = Inf( i);
  Vector isup = Sup( i);
  Vector dom = new Vector();
  int k = cutDimension( i);
  if (  k != -1) {
  try {  
    for( int j = 0; j < Base.dom( k); j++) {
      Vector INDEX = index30.cpT (isup);
      INDEX.set( k, new Integer( j));
      if (( index30.myeqT( INDEX, iinf)) && ( index30.myeqT( isup, INDEX)))   
        dom.add( new Integer( j));
      } 
    } catch (Exception e) {
      System.out.println( ERROR  + "dominioCorte.");
      frame30.exit( -1, e);
    }//catch
  } else return null;

  return dom;//no hay, el item es de longitud == 1.
}//dominioCorte

/**
* Resultado de scannear la lista de izq a der contando los cambios en la modalidad de respuesta.
* Es el fitness de las configuraciones del esquema respecto de la longitud de las listas.
* @see item30#GetRespuesta()
* @return numero de Switches
**/
public long Switches( ) {

  if ( MODE == null) MODE = listStat30.moda( ((lista30)this));//Yes Mode, No unKB (-1);
  
  Vector U = null;//respuesta (i-1)
  Vector V = null;//respuesta (i) 

  U = Get( 0).GetRespuesta();//siempre existe el 0.

  long S = 0;//numero de Switches
  int j = 0;//primer item no unKB-MODA
  if ( index30.eqS( U, MODE)) j++;//el siguiente ya es KB-noMODA

  try {
  if ( j < size()) { 
    U = Get( j).GetRespuesta(); 
    }
    else return S;//KBM2L vacia, S == 0.
  } catch (Exception e) {
    System.out.println( ERROR  + "Switches( ).1  List: " + Name());
    frame30.exit( 0, e);
  }//catch

  try {
  for( int i = j + 1; i < size()-1; i++) {
    V = Get( i).GetRespuesta();
    if ( !index30.eqS( V, MODE)) {
      if ( !index30.eqS( V, U)) { 
        S++;//!!! 
        if ( S > 32000) { switches = S; return S; }
        U = index30.cpS( V);//!!! 
        }//if
      }//if  
    }//for
  } catch (Exception e) {
    System.out.println( ERROR  + "Switches( ).2  List: " + Name());
    frame30.exit( 0, e);
  }//catch

  switches = S; 
  return S ;
}//Switches

/**
* Resultado de scannear la lista de izq a der contando los cambios en la modalidad de respuesta.
* Si es superior a la cota para, y devuelve el valor acumulado de Switches.
* @see item30#GetRespuesta()
* @param cota limite de cuenta de Switches.
* @return numero de Switches
**/
public long Switches( long cota) {

  if ( MODE == null) MODE = listStat30.moda( ((lista30)this));//Yes Mode, No unKB (-1);

  Vector U = null;//respuesta (i-1)
  Vector V = null;//respuesta (i) 

  U = Get( 0).GetRespuesta();//siempre existe el 0.

  long S = 0;//numero de Switches
  int j = 0;//primer item no unKB-MODA
  if ( index30.eqS( U, MODE)) j++;//el siguiente ya es KB-noMODA

  try {
  if ( j < size()) { 
    U = Get( j).GetRespuesta(); 
    }
    else return S;//KBM2L vacia, S == 0.
  } catch (Exception e) {
    System.out.println( ERROR  + "Switches( cota).1  List: " + Name());
    frame30.exit( 0, e);
  }//catch

  try {
  for( int i = j + 1; i < size()-1; i++) {
    V = Get( i).GetRespuesta();
    if ( !index30.eqS( V, MODE)) {
      if ( !index30.eqS( V, U)) { 
        S++;//!!! 
        if ( S >= cota) { switches = S; return S;}
        U = index30.cpS( V); 
        }//if
      }//if  
    }//for
  } catch (Exception e) {
    System.out.println( ERROR  + "Switches( cota).2  List: " + Name());
    frame30.exit( 0, e);
  }//catch

  switches = S; 
  return S ;
}//Switches

/**
* (X)(-1)(X)
**/
public long gapsXX() {

  long gaps = 0;
  for( int i = 0; i < size()-2; i++) {
    if ( index30.eqS( Get( i).GetRespuesta(),Get( i+2).GetRespuesta()) &&
         index30.eqS( Get( i+1).GetRespuesta(),UNKB)) { gaps++; i++; }
  }

  return gaps;
}//gapsXX

/**
* (X)(-1)(Y)
**/
public long gapsXY() {

  long gaps = 0;
  for( int i = 0; i < size()-2; i++) {
    if ( !index30.eqS( Get( i).GetRespuesta(),Get( i+2).GetRespuesta()) &&
         index30.eqS( Get( i+1).GetRespuesta(),UNKB)) { gaps++; i++; }
  }

  return gaps;
}//gapsXY

/**
* Ordinales de items de l30 con igual respuesta a un item dado i.
* @param i ordinal del item de referencia para la respuesta de la familia.
* @return Vector de ordinales 0..l30.size()-1, con la respuesta del item i.
**/
public Vector Familia( int i) {

  Vector FAMILIA = null;
  if ( i < size()) {
  FAMILIA = new Vector();
  try {
    Vector RESPUESTA1 = Get( i).GetRespuesta();//respuesta de un item dado
    FAMILIA.add( new Integer( i));//el mismo
    for(int j = 0; j < size(); j++) {
      if (i != j) {
        Vector RESPUESTA2 = Get( j).GetRespuesta();
        if ( index30.eqS( RESPUESTA1, RESPUESTA2)) {
           FAMILIA.add( new Integer( j));
          }//if
       }//if
     }//for
  } catch (Exception e){
      System.out.println( ERROR + "Familia. i");
      frame30.exit( 0, e);
  }
  }

  return FAMILIA;//puede ser vacia.
}//Familia

/**
* Ordinales de items de l30 con igual respuesta a una dada S.
* @param S respuesta de la lista y de la familia
* @return Vector de ordinales 0..l30.size()-1, con la respuesta S.
**/
public Vector Familia( Vector S) {

  Vector FAMILIA = new Vector();//vacia
  try {
    for(int j = 0; j < size(); j++) {
      Vector RESPUESTA2 = Get( j).GetRespuesta();
      if ( index30.eqS( S, RESPUESTA2)) {
         FAMILIA.add( new Integer( j));
        }//if
    }//for
  } catch (Exception e){
      System.out.println( ERROR + "Familia. S");
      frame30.exit(0 ,e);
  }

  return FAMILIA;//puede ser vacia.
}//Familia


private void panic( Vector INDICE, Vector indice, int label) {
	
  if ( index30.myT( INDICE, indice)) {
    System.out.println( ERROR + "GET(INDICE)." + label); 
    System.out.println( "INDICE: " + INDICE); 
    System.out.println( "indice: " + indice); 
    System.out.println( "GET_." + GET_( INDICE).toString());
    frame30.exit( 0); //panic
    }
}//panic

/**
* KBM2L[INDICE] --> item(MEDIDA,RESPUESTA,INDICE), CONSULTA BASICA.
* INDICE - descripcion lexicografica que permite hacer binary-search.
* @param INDICE coordenadas de la informacion.
* @return item de la lista cuyo indice es el argumento INDICE
**/
public item30 GET( Vector INDICE) {

  if ( !( new checkIndex30().INDX( this, INDICE))) {
    System.out.println( ERROR + "GET. INDICE en l30. i:" + INDICE.toString()); 
    System.out.println( "DOMINIO: " + Base.Dom());      
    System.out.println( "INDICE: " + INDICE.toString()); 
    frame30.exit( -1);
    }//if

  int ix = 0;
  int itop = 0, ibot = size();
  int controlBB = 0;
  Vector J = null;
  Vector K = null;

  try {
  while (true) {
  
    if ( ibot < itop) { 
      System.out.println( ERROR + "GET  ibot <= itop !!!"); 
      frame30.exit( 0); 
      }

    ix = itop + (int)( ibot - itop) / 2;

    if ( ix > 0)
      J = Get( ix-1).GetIndice();
      else J = index30.primeroT( Base.Dom());//CERO

    K = Get( ix).GetIndice();
    
    if ( index30.myT( INDICE, J))
    if (( index30.myT( K, INDICE)) || ( index30.eqT( K, INDICE))) {
      item30 item = Get( ix);//existe
      panic( INDICE, item.GetIndice(), 1);
      return item; 
      }//if

    if ( index30.eqT( INDICE, J)) {
      if ( ix > 0) {
      item30 item = Get( ix-1);//existe
      panic( INDICE, item.GetIndice(), 2);
      return item; 

        }
        else {
          item30 item = Get( 0);//existe
          panic( INDICE, item.GetIndice(), 3);
          return item; 
        }
      }  

    if ( index30.eqT( INDICE, K)) {
      item30 item = Get( ix);//existe
      panic( INDICE, item.GetIndice(), 4);
      return item; 
      }

    if ( index30.myT( K, INDICE)) {
      ibot = ix; 
      }  

    if ( index30.myT( INDICE, K)) {
      itop = ix; 
      }  

    if ( controlBB > size()) { 
      System.out.println( ERROR + "GET.controlBB !" + ix + " size(): " + size());
      System.out.println( "INDICE." + INDICE.toString());
      System.out.println( "     J." + J.toString());
      System.out.println( "     K." + K.toString());
      System.out.println( " KBM2L." + Name());
      System.out.println( "  CERO." + Get(0).GetIndice().toString());
      System.out.println( "ULTIMO." + Get( size()-1).GetIndice().toString());
      System.out.println( "GET_." + GET_( INDICE).toString());
      frame30.exit(0); 
      return null; 
      }
    controlBB++;//contador de BBitem

    }//while
  } catch (Exception e){
      System.out.println( ERROR + "GET.");
      frame30.exit( 0, e);
  }

  System.out.println( ERROR + "GET(INDICE) null-ITEM."); 
  frame30.exit( 0); //panic!!
  return null;  
}//GET

public item30 GET_( Vector INDICE) {
// INDICE - descripcion lex 
//no hace binary-search
/*
  if ( !( new checkIndex30().INDX( true, this, INDICE))) {
    System.out.println( ERROR + "indice. INDICE en l30. i:" + INDICE.toString()); 
    System.out.println( "DOMINIO: " + getDominio().toString());      
    System.out.println( "INDICE: " + INDICE.toString()); 
    System.exit(0); 
    }//if
*/
  Vector K = null;

//Secuencial
  for(int i = 0; i < size(); i++) {
    K = Get( i).GetIndice();
    if (( index30.myT( K, INDICE)) || ( index30.eqT( K, INDICE))) {
      System.out.println( "(item30) GET_(INDICE) no hace binary-search.\n");
      return Get( i);//existe 
      }//if
    }//for  

  System.out.println( ERROR + "GET_(INDICE) null-ITEM."); 
  frame30.exit( 0); 
  return null;//panic!!!!
}//GET_

}//class kbm2l30
