//KBM30//
package kernel;

//
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import control.*;
import target.*;
import schema.*;
import kbm2l.*;
import tools.*;

/**
* Clase kbm30 kernel del sistema kbm2l.
* article{fdezdelpozo-2003b,
*  author  = {Fer\mbox{n\'andez del Pozo}, J.A. and Bielza, C. and G\'omez, M.},
*  title   = {A List-Based Compact Representation for Large Decision Tables Management},
*  year    = {2005}, 
*  journal = {European Journal of Operational Research}, 
*  volume  = {160, Special Issue on Decision Making and AI}, 
*  pages   = {638--662},
*} 
* Dimensiones, dominios, base, lista de items.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class kbm30 {

//constantes
  private static final String ERROR = "Error(kbm30): ";

  /**
  * Checking in list
  **/
  public boolean checkMode = false; 
  /**
  * Unknowledge policy, attribute value, meassure value.
  **/
  public static final  int unKB = index30.unKB;//respuesta desconocida
  /**
  * Constrained policy
  **/
  public static final  int coKB = index30.coKB;//respuesta restringida
  /**
  * Sensitive policy
  **/
  public static final  int rsKB = index30.rsKB;//respuesta sensible
  /**
  * Reference policy
  **/
  public static final  int rrKB = index30.rrKB;//respuesta de referencia

  /**
  * Implicit Var Att's, kbm2l de orden superior, no implementado.
  * Atributos indice variable (j,j+1,...n), 
  **/
  public static final  int unIN = index30.unIndex;//

/**
* Vector respuesta desconocida
**/
  public Vector UNKB = null;//respuesta desconocida, depende de unKB y s,
/**
* Vector respuesta restringida
**/
  public Vector COKB = null;//respuesta restringida, depende de coKB y s,
/**
* Vector respuesta sensible
**/
  public Vector RSKB = null;//respuesta sensible, depende de rsKB y s,
/**
* Vector respuesta referencia
**/
  public Vector RRKB = null;//respuesta referencia, depende de rrKB y s,

/**
* Nombre de la lista.
**/
  private String idkbm30 = null;

//flag Head, [medida] == 3, (min, sum, max).
//public final static int r_default = 3;

/**
* Componentes de medida, respuesta e indice.
**/  
  private int  r = 0,  s = 0,  t = 0;//
  
/**
* Esquema, declaracion de la estructura logica y semantica  de la tabla-lista.
* Orden canonico de atributos.
**/  
  public esquema30 Esqu = null;//
    
/**
* Base, orden de los att's que determina el desarrollo del indice y 
* el orden de los casos que agrupan los items. Estructura fisica de la tabla-lista.
* Orden de desarrollo del indice, role de componentes del indice.
**/
  public base30 Base = null;//
  public Vector RangoHr =  null;// distancias en el entorno Hr, Integer

/**
* matriz multimensional ---> lista !!!
* Vector de item30
**/
  public Vector lkbm = null;//matriz multimensional ---> lista !!!

//// Metodos

/**
* Constructor por defecto
**/
public kbm30() {

  checkMode = new controlPrefs30().checkMode();
}//kbm30

/**
* Numero de Atributos del indice de la lista. get.
**/
public int dimension() { return t; 
}//dimension

/**
* Numero de Atributos del indice de la lista. set.
**/
public int dimension( int t) { return this.t = t; 
}//dimension

/**
* Nombre de la lista ->
**/
public String Name() { return idkbm30; 
}//Name

/**
* -> nombre de la lista
**/
public String Name( String idkbm30) {

  this.idkbm30 = new String( idkbm30);
  return idkbm30;
}//Name

/**
* Dimension de medidas de la lista
**/
public int ParMedida() { return r; 
}//ParMedida

/**
* Dimension de medidas de la lista
**/
public int ParMedida( int r) { return (this.r = r); 
}//ParMedida

/**
* Dimension de respuestas de la lista
**/
public int ParRespuesta() { return s; 
}//ParRespuesta

/**
* Dimension de respuestas de la lista
**/
public int ParRespuesta( int s) { return (this.s = s); 
}//ParRespuesta

/**
* Dimension de indices de la lista
**/
public int ParIndice() { return t; 
}//ParIndice

/**
* Dimension de indices de la lista
**/
public int ParIndice( int t) { return (this.t = t); 
}//ParIndice

////

/**
* inicializacion cruda, sin inicializar a vacia, item vacio
**/
public Vector ini_() { return (lkbm = new Vector());
}//

/**
* Numero de items. Objetivo general a minimizar en sintesis30.
**/
public int size() { return lkbm.size();
}//

/**
* Nuevo items item al final
**/
public void add( item30 item) { lkbm.add( item);
}//

/**
* Nuevo item en una posicion i.
**/
public void add( int i, item30 item) { lkbm.add( i, item);
}//

/**
* Nuevo item que sustituye al i.
**/
public void set( int i, item30 item) { lkbm.set( i, item);
}//

/**
* Borra el item en la posion i.
**/
public void remove( int i) { lkbm.remove( i);
}//

/**
* Posicion de un item en la lista.
* #see kbm2l30#get(int)
* @return 0-base-posicion del item en el vector lkbm. -1 --> no esta.
**/
public int indexOf( item30 item) {

  return lkbm.indexOf( item);
}//

////
/**
* Vector de medida del item i.
**/
public Vector GetMedida( int i) {

  return ((item30)lkbm.get( i)).GetMedida();
}//

/**
* Componente j del vector de medida del item i.
**/
public double GetMedida( int i, int j) {

  return ((Double)((item30)lkbm.get( i)).GetMedida().get( j)).doubleValue();
}//

/**
* Vector de respuesta del item i.
**/
public Vector GetRespuesta( int i) {

  return ((item30)lkbm.get( i)).GetRespuesta();
}//

/**
* Componente j del vector de respuesta del item i.
**/
public int GetRespuesta( int i, int j) {

  return ((Integer)((item30)lkbm.get( i)).GetRespuesta().get( j)).intValue();
}//

/**
* Vector de indice del item i.
**/
public Vector GetIndice( int i) {

  return ((item30)lkbm.get( i)).GetIndice();
}//

/**
* Componente j del vector de indice del item i.
**/
public int GetIndice( int i, int j) {

  return ((Integer)((item30)lkbm.get( i)).GetIndice().get( j)).intValue();
}//

////
/**
* Item de la lista que ocupa la posicion i
* @param i posicion
* @return item 
**/
public item30 Get( int i) {

  if (( i < 0) || ( size() <= i)) {
    System.out.println( ERROR + "Get(i) ovf-ITEM.  size(): " + size() + "  --  i: " + i); 
    frame30.exit( 0, new Exception()); 
    }
  item30 item = ((item30)lkbm.get( i));//un solo item.
  if ( item == null) { 
    System.out.println( ERROR + "Get( i) null-ITEM."); 
    frame30.exit( 0, new Exception()); 
    }//if

  return item;
}//Get

/**
* RangoHr, vector de distancias GH2 en el entorno de la base.
**/
public Vector rango( ) {

  try {
	  
  if ( RangoHr == null) {
    RangoHr = neighborhood30.rango( new neighborhood30( ).neighborhood( (lista30)this));//[M...m]  
    frame30.kbm2lTime.append( "Range: " + (RangoHr.toString()) + "\n");    
   }
   
   } catch (Exception e) {
      System.out.println( ERROR  + "rango().1");
      frame30.exit( 0, e);
    }//catch

  return (RangoHr);
}//rango

}//class kbm30
