//LISTCOPY30//
package kernel;

//
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kbm2l.*;
import kernel.*;
import control.*;
import target.*;
import synthesis.*;

/**
* Clase listCopy30. std & fast.
* Procedimiento de transposicion de listas mediante copia de listas.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  listCopy30  {

  private static final String ERROR = "Error(listCopy30): ";
  private boolean threadCplMode = false;  
  private boolean fastCopy = false;  
  private int AC = -1;
  private BigInteger maxOffset = null;

/**
* Constructor por defecto
**/
public listCopy30( ) {

}//listCopy30

/**
* Copia una lista en otra con una nueva base. Copia Items.
* std-cpl
* Copia de conocimiento de l30 en lTarget (sin items desconocidos). ini - unKB
* fast-cpl
* La copia rapida solo entre bases naturales, sin permutar dominios.
* si Ib1r == Ib2r --> no-Set y salta Tk-1
* r = i+1,.... ini - clone
* @see itemCopy30#stdCpi
* @return lTarget lista30
**/
public lista30 cpl( lista30 l30, lista30 lTarget) {
//std-cpl
// 
  try {
    fastCopy = new controlPrefs30().fastCopy();
    threadCplMode = new controlPrefs30().threadCplMode();
    AC = Thread.activeCount();
    System.gc( );
  } catch (Exception e) {
    frame30.kbm2lSystem.append( ERROR + "cpl()\n");
    frame30.exit( 0, e);
  }//catch

  BigInteger IncOffset = null;
  boolean chk = new controlPrefs30().checkMode();

  if ( fastCopy)
    IncOffset = incOffset( l30.Base, lTarget.Base);

  if ( fastCopy && IncOffset.compareTo( BigInteger.ZERO) != 0) { //*** fastCopy ***
    
    if ( IncOffset.compareTo( maxOffset) < 0) {
      frame30.kbm2lSystem.append( ERROR + "IncOffset.compareTo( -0)\n");
      frame30.kbm2lSystem.append( "IncOffset: " + IncOffset.toString() + "\n");
      frame30.kbm2lSystem.append( "maxOffset: " + maxOffset.toString() + "\n");
      frame30.exit( 0, new Exception());
      }

    maxOffset = new offset30().offset( l30.Base.Dom(), index30.ultimoT( l30.Base.Dom()));
    
    if ( IncOffset.compareTo( maxOffset) > 0) {
      frame30.kbm2lSystem.append( ERROR + "IncOffset.compareTo( maxOffset)\n");
      frame30.kbm2lSystem.append( "IncOffset: " + IncOffset.toString() + "\n");
      frame30.kbm2lSystem.append( "maxOffset: " + maxOffset.toString() + "\n");
      frame30.exit( 0, new Exception());
      }

    BigInteger infBlock = BigInteger.ZERO;    
    BigInteger supBlock = new BigInteger( IncOffset.toString());
    supBlock = supBlock.subtract( BigInteger.ONE);

    frame30.kbm2lSystem.append( "maxOffset. "  + maxOffset.toString() + "\n");
    frame30.kbm2lSystem.append( "IncOffset. "  + IncOffset.toString() + "\n");
    frame30.kbm2lSystem.append( "infBlock. "  + infBlock.toString() + "\n");
    frame30.kbm2lSystem.append( "supBlock. "  + supBlock.toString() + "\n");

    do {    
      lTarget = cplBlock( l30, lTarget, infBlock, supBlock);
      infBlock = new BigInteger( supBlock.toString());    
      supBlock = supBlock.add( IncOffset);
      if ( chk)  {
        frame30.kbm2lSystem.append( "infBlock. "  + infBlock.toString() + "\n");
        frame30.kbm2lSystem.append( "supBlock. "  + supBlock.toString() + "\n");
        }
    } while( supBlock.compareTo( maxOffset) < 0);
    
    } else {//*** stdCopy ***
       if ( fastCopy) frame30.kbm2lSystem.append( "fastCopy by stdCopy. \n");

      listStat30.moda( l30);//Yes Mode, No unKB (-1)

      lTarget = cplZero( l30, lTarget);//Zero

    if ( lTarget == null) {
      frame30.kbm2lSystem.append( "### cp --- 0\n");
      return null;//
      } else { 
        lTarget = cplOne( l30, lTarget);//One. Two,...
        if ( lTarget == null) {
          frame30.kbm2lSystem.append( "### cp --- 1\n");
          return null;//
          }
        }
      }//*** fastCopy ***

  try {//comun a ambas estrategias de copia.
    if ( lTarget.size() >= l30.size()) {
      l30.Switches( l30.size());//cache l30.switches
      frame30.kbm2lSystem.append("### cpl-bad. lTarget.size():" + lTarget.size() + "   l30.size():" + l30.size() + ",\n");
      frame30.kbm2lSystem.append("lTargetSwitches:" + lTarget.Switches( l30.switches) + "   l30Switches:" + l30.switches + ".\n");
frame30.kbm2lSystem.append( "cp --- 3\n");
      return null;//incompleta
      }//if mal    

  }//try
  catch (Exception e) {
    frame30.kbm2lSystem.append( ERROR + "cpl-3.\n");
    frame30.exit( 0, e);
  }//catch

  if ( chk)
    eqKBM2L30.eqKBM2L( l30, lTarget, "listCopy30-cpl"); // eqKBM2L !!!
frame30.kbm2lSystem.append( ">>>cp --- 4\n");
  return lTarget;//completa ------------------------------------------
}//cpl

/**
* Copia una lista en otra con una nueva base. Copia Item Zero. std-cpl.
* @see itemCopy30#fastCpi
* @see itemCopy30#stdCpi
* @return lTarget lista30
**/
private lista30 cplZero( lista30 l30, lista30 lTarget) {
//item ZERO *****************************************************

  try {

    if ( !index30.eqS( l30.Get( 0).GetRespuesta(), l30.MODE)) { // solo conocimiento KB

    if ( threadCplMode) {
      new Thread ( new itemCopy30( l30, lTarget, 0)).start();
      frame30.kbm2lSystem.estatus( "listCopy30 - std. k: " + 0 + " th: " + Thread.activeCount());      
      }
      else {
        frame30.kbm2lSystem.estatus( "listCopy30 - std. k: " + 0 + 
          " sz: " + lTarget.size() + " KB: " + listStat30.KB( lTarget) + 
          " sw: " + lTarget.Switches( l30.switches));
        lTarget = new itemCopy30( ).stdCpi( l30, lTarget, 0);
       }

     }//if solo con conocimiento

    if ( !sintesis30.working) return l30;

  } catch (Exception e) {
    System.out.println( ERROR + "cplZero.");
    frame30.exit( 0);
  }//catch

  checkList30.chk( l30, "cplZero.");
  return lTarget;//ok
}//cplZero

/**
* Copia una lista en otra con una nueva base. Copia Items. std-cpl.
* @see itemCopy30#fastCpi
* @see itemCopy30#stdCpi
* @return lTarget lista30
**/
private lista30 cplOne( lista30 l30, lista30 lTarget) {
//RESTO k-items ****************************************************

  for( int k = 1; k < l30.size(); k++) {// in list

    if ( lTarget == null) {
	   break;
	   }
	 
    try {

    if ( !index30.eqS( l30.Get( k).GetRespuesta(), l30.MODE)) { // solo conocimiento KB

      if ( threadCplMode) {
        new Thread ( new itemCopy30( l30, lTarget, k)).start();
        frame30.kbm2lSystem.estatus( "listCopy30 - std. k: " + k + " th: " + Thread.activeCount());      
        }
        else { 
	       if (( k % 100) == 0) 
          frame30.kbm2lSystem.estatus( "listCopy30 - std. k: " + k + 
            " sz: " + lTarget.size() + " KB: " + listStat30.KB( lTarget) + 
            " sw: " + lTarget.Switches( l30.switches));
	       lTarget = new itemCopy30( ).stdCpi( l30, lTarget, k);       
         } 

      }//if solo con conocimiento 

    } catch (Exception e) {
      frame30.kbm2lSystem.append( ERROR + "cplOne-std  k: " + k + "\n");
      frame30.kbm2lSystem.append( "l30 " + l30.size() + "\n");
      frame30.exit( -1);
    }//catch

    if ( !sintesis30.working) return l30;

    if ( threadCplMode) 
    try {
      Thread.sleep(Thread.activeCount());//!!!
    }//try
    catch (InterruptedException e) {
      frame30.kbm2lSystem.append( ERROR + "cpl-sleep.1\n");
      frame30.exit( 0);
    }//catch
      
    }//for-k

  if ( threadCplMode) 
  try {
  while ( ( AC - Thread.activeCount()) != 0 ) {
	 Thread.sleep( Thread.activeCount()*control30.gr.nextInt(1000));
	 }//
  }//try
  catch (InterruptedException e) {
    frame30.kbm2lSystem.append( ERROR + "cpl-sleep.2\n");
    frame30.exit( 0);
  }//catch

  checkList30.chk( l30, "cplOne.");
  return lTarget;//completa o incompleta ------------------------------------------
}//cplOne

/*
* Calcula el diametro de la trama que delimita los bloques de casos
* que se transponen solidariamente en el cambio de base
*/
private BigInteger incOffset( base30 b30, base30 bt) {

  BigInteger Inc = null;

  if ( base30.eqB( b30, bt)) {
    Inc = BigInteger.ONE;
    for( int j = 0; j < b30.size(); j++) {
	   Integer DOM = new Integer( b30.dom( j));
      Inc = Inc.multiply( new BigInteger( DOM.toString()));
      }
    return Inc;
    }
  
  for( int i = b30.size()-1; i >= 0; i--) {
    if ( b30.bas( i) != bt.bas( i)) {
      if ( i == b30.size()-1) { 
	     Inc = BigInteger.ZERO; 
        return Inc;
      }
      Inc = BigInteger.ONE;
      for( int j = i+1; j < b30.size(); j++) {
        Integer DOM = new Integer( b30.dom( j));	      
        Inc = Inc.multiply( new BigInteger( DOM.toString()));
       }
      return Inc;
      }
    }
     
  System.out.println( ERROR + "incOffset");
  frame30.exit( -1, new Exception());
  return BigInteger.ONE.negate();
}//incOffset

/*
* Copia bloques de la lista l30 en lTarget.
*/
private lista30 cplBlock( lista30 l30, lista30 lTarget, BigInteger infBlock, BigInteger supBlock) {

  if ( infBlock.compareTo( BigInteger.ZERO) < 0) {
    System.out.println( ERROR + "cplBolck-infBlock");
    System.out.println( "infBlock: " + infBlock.toString());
    new Exception().printStackTrace();
    frame30.exit( 0);
	 }

  if ( supBlock.compareTo( maxOffset) > 0)  {
    System.out.println( ERROR + "cplBolck-supBlock");
    System.out.println( "supBlock: " + supBlock.toString());
    System.out.println( "maxOffset: " + maxOffset.toString());
    new Exception().printStackTrace();
    frame30.exit( 0);
    }

  Vector WEIGHTS = listStat30.getWeights( l30);      
  Vector infINDEX = offset30.index( l30, WEIGHTS, infBlock);//inverso de offset
  Vector supINDEX = offset30.index( l30, WEIGHTS, supBlock);
  item30 nuevoItem = null, item = null;
  Vector INDEX = null;
  int regla = -1;
  int i = BBitem( l30, infINDEX);
  int j = BBitem( l30, supINDEX);
  int k = -1;

  frame30.kbm2lSystem.estatus( "listCopy30 - fast. k: " + k + 
        " sz: " + lTarget.size() + 
        " KB: " + listStat30.KB( lTarget) + 
        " sw: " + lTarget.Switches( l30.switches) + 
        " inf " + infBlock.toString() + " sup " + supBlock);

 try {
 
  item = l30.Get( i);
  INDEX = base30.Trnp( l30.Base, infINDEX, lTarget.Base); 
  nuevoItem = new item30( lTarget, item.GetMedida(), item.GetRespuesta(), INDEX);
  regla = lTarget.Set( nuevoItem); 

  for( i++; i < j; i++) {
    item = l30.Get( i);
    INDEX = base30.Trnp( l30.Base, item.GetIndice(), lTarget.Base); 
    nuevoItem = new item30( lTarget, item.GetMedida(), item.GetRespuesta(), INDEX);
    regla = lTarget.Set( nuevoItem); 
    k = l30.indexOf( nuevoItem);
    if ( k > 0)
    if ( index30.eqS( lTarget.Get( k-1).GetRespuesta(), lTarget.UNKB)) {
      lTarget.remove( k-1);
      if ( k > 1)
      if ( index30.eqS( lTarget.Get( k-1).GetRespuesta(), lTarget.Get( k-2).GetRespuesta())) {
        lTarget.remove( k-2);
        }
      }//if
    }//for

  item = l30.Get( j);
  INDEX = base30.Trnp( l30.Base, supINDEX, lTarget.Base); 
  nuevoItem = new item30( lTarget, item.GetMedida(), item.GetRespuesta(), INDEX);
  regla = lTarget.Set( nuevoItem); 
    k = l30.indexOf( nuevoItem);
    if ( k>0)
    if ( index30.eqS( lTarget.Get( k-1).GetRespuesta(), lTarget.UNKB)) {
      lTarget.remove( k-1);
      if ( k>1)
      if ( index30.eqS( lTarget.Get( k-1).GetRespuesta(), lTarget.Get( k-2).GetRespuesta())) {
        lTarget.remove( k-2);
        }
      }//if

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "cplBlock.");
    e.printStackTrace();
    frame30.exit( 0);
  }//catch

  return lTarget;
}//cplBlock

  private int ix = 0;//posicion del indice. ITEM3
  private int ixbin = 0, ixsec = 0;

/**
* Buscador binario del item que contiene el indice que se inserta...
**/
private int BBitem( lista30 l30, Vector indice) {

  item30 ITEM2 = null;  
//  Vector MEDIDA2 = null;  
//  Vector RESPUESTA2 = null;  
  Vector INDICE2 = null;
  item30 ITEM3 = null;  
//  Vector MEDIDA3 = null;  
//  Vector RESPUESTA3 = null;  
  Vector INDICE3 = null;

  int itop = 0, ibot = l30.size();
  int controlBB = 0;
  int l30sz = l30.size();
  
//  checkIndex30.INDX( l30, indice);
  
  if ( index30.eqT( indice, index30.primeroT( l30.Base.Dom())) ||
       index30.myeqT( l30.Get( 0).GetIndice(), indice))
    return 0;

  if ( index30.eqT( indice, index30.ultimoT( l30.Base.Dom())) ||
       index30.myT( indice, l30.Get( l30sz-2).GetIndice()))// existe l30sz-2
    return ( l30sz-1);
  
  try {
  while (true) {

    if ( ibot < itop) { 
      System.out.println( "Set ibot <= itop !!!"); 
      frame30.exit(0); 
      }
    ix = itop + (int)( ibot - itop) / 2;

    if ((( ix - 1) >= 0) && (( ix - 1) < l30sz)) {
      INDICE2 = l30.Get( ix-1).GetIndice();//un solo item.
    }//if
    else { 
      System.out.println( "BB: ix - INDICE2 !!!-l30"); 
      System.out.println( "ix " + ix + "  l30z " + l30sz); 
      core30.core( l30, indice, ix, ITEM2, ITEM3);
      frame30.exit( 0); 
      } // 

    if (( ix >= 0) && ( ix < l30sz)) {
      INDICE3 = l30.Get( ix).GetIndice();//un solo item.
    }//if
    else { 
      System.out.println( "BB: ix - INDICE3 !!!-l30"); 
      System.out.println( "ix " + ix + "  l30z " + l30sz); 
      core30.core( l30, indice, ix, ITEM2, ITEM3);
      frame30.exit( 0); 
      } // 

    if ( index30.myeqT( INDICE2, INDICE3)) {
      System.out.println( 
        "BB: INDICE2 >= INDICE3 !!!-l30. xi: " + ix  + " itop: " + itop + " ibot: " + ibot); 
      if (INDICE2 != null) System.out.println("I2." + INDICE2.toString());
      if (INDICE3 != null) System.out.println("I3." + INDICE3.toString());
      System.out.println("I(ix-1). " + l30.Get( ix-1).GetIndice());
      System.out.println("I(ix).   " + l30.Get( ix).GetIndice());
      System.out.println( "LAST RULE: " + l30.lastRULE + "  l30sz: " + l30sz);
      checkList30.CHK( l30, "BB I2 >= I3");
      System.out.println( "ix " + ix + "  l30z " + l30sz); 
      core30.core( l30, indice, ix, ITEM2, ITEM3);
      frame30.exit( 0); 
      } //

    if ( index30.myT( indice, INDICE2) && index30.myeqT( INDICE3, indice)) {
      break;// INDICE3 == indice
      }

    if ( index30.myT( INDICE3, indice)) { ibot = ix; }  
      else
        if ( index30.myT( indice, INDICE3)) { itop = ix; }  

    if ( controlBB > l30sz) { 
      System.out.println( ERROR + "controlBB !"); 
      System.out.println( "BBitem." + ix + " l30.size(): " + l30sz);
      if (INDICE2 != null) System.out.println("I2." + INDICE2.toString());
      if (indice != null)  System.out.println("IZ." + indice.toString());
      if (INDICE3 != null) System.out.println("I3." + INDICE3.toString());
      System.out.println( "Reglas: " + l30.reglas.toString());
      if ( index30.myT( indice, INDICE2) && index30.myeqT( INDICE3, indice)) {
        System.out.println( "I2 Iz I3: ?");
      }

      System.out.println( "ix " + ix + "  l30z " + l30sz); 
      core30.core( l30, indice, ix, ITEM2, ITEM3);
      frame30.exit(0); 
      }
    controlBB++;//contador de BBitem

    }//while
  } catch (Exception e){
      System.out.println( ERROR + "BBitem. exception");
      e.printStackTrace();
      System.out.println( "ix " + ix + "  l30z " + l30sz); 
      core30.core( l30, indice, ix, ITEM2, ITEM3);
      frame30.exit(0); 
  }

  ixbin = ix;//<INDICE3,RESPUESTA3,MEDIDA3|

//ix-2  ITEM1
//..........
//xi-1  ITEM2
//  ITEM2 = l30.Get( ix-1);//existe el ix-1.
//  MEDIDA2 = l30.Get( ix-1).GetMedida();//un solo item.
//  RESPUESTA2 = l30.Get( ix-1).GetRespuesta();//un solo item.
//xi    ITEM3
//  ITEM3 = l30.Get( ix);//existe el ix.
//  MEDIDA3 = l30.Get( ix).GetMedida();//un solo item.
//  RESPUESTA3 = l30.Get( ix).GetRespuesta();//un solo item.
//xi+1  ITEM4
//..........

  return ix;
}//BBitem

/**
* Copia l30.size() random index.
* @see lista30#Switches(long).
* @param l30 lista original de casos.
* @param lTarget lista destinio de los casos.
* @return lTarget lista con los representantes.
**/
public static lista30 randomCopy( lista30 l30, lista30 lTarget, int CASES) { 

  item30 nuevoItem = null;
  item30 ITEM = null;  Vector MEDIDA = null;  Vector RESPUESTA = null;  Vector INDICE = null;
  Vector indice = null;
  int regla = -1;

  if ( CASES <= 0)
    CASES = l30.size();
    
  for(int k = 0; k < CASES; k++) {// in list

    INDICE = new Vector();// indice RANDOM
    try {
      for( int j = 0; j < l30.dimension(); j++) {  
        INDICE.add( new Integer( control30.gr.nextInt( l30.Base.dom(j))));
        }//for
      ITEM = l30.GET( INDICE);//siempre existe.
      RESPUESTA = ITEM.GetRespuesta();
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "iTestRANDOM().1");
      frame30.exit( 0, e);
    }//catch

    try {
      if ( !index30.eqS( RESPUESTA, l30.MODE)) {// conocimiento
        MEDIDA = ITEM.GetMedida();
        indice = base30.Trnp( l30.Base, INDICE, lTarget.Base); // CAMBIO DE BASE
        nuevoItem = new item30( lTarget, MEDIDA, RESPUESTA, indice); // new
        regla = lTarget.Set( nuevoItem); //copy !!
      }//if conocimiento
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "iTestRANDOM().2");
      frame30.exit( 0, e);
    }//catch

    }//for copia de random items

  return lTarget;//
}//randomCopy

}//class listCopy30

