//listManager30//
package kernel;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kbm2l.*;
import control.*;
import tables.*;
import target.*;

/**
* Clase listManager30, gestion de kbm2l. Indices y respuestas. No gestiona las medidas.
* Gestion de Indices: orden.
* Gestion de Respuestas: adyacencia.
* Gestion de Medidas: min, media, max. Son utilidades, probabilidades,...
* Es miembro privado de lista30.
* @see lista30
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class listManager30 {

  private static final String ERROR = "Error(listManager30): ";
//  private static final boolean frame30.chk = false; //false;
/**
* Contador de operaciones/llamadas al listManager30.
**/
  public static long counterSet = 0;

  private item30 ITEM0 = null;  
  private Vector MEDIDA0 = null;  
  private Vector RESPUESTA0 = null;  
  private Vector INDICE0 = null;
  
  private item30 ITEM1 = null;  
  private Vector MEDIDA1 = null;  
  private Vector RESPUESTA1 = null;  
  private Vector INDICE1 = null;
  private item30 ITEM2 = null;  
  private Vector MEDIDA2 = null;  
  private Vector RESPUESTA2 = null;  
  private Vector INDICE2 = null;
  private item30 ITEM3 = null;  
  private Vector MEDIDA3 = null;  
  private Vector RESPUESTA3 = null;  
  private Vector INDICE3 = null;
  private item30 ITEM4 = null;  
  private Vector MEDIDA4 = null;  
  private Vector RESPUESTA4 = null;  
  private Vector INDICE4 = null;

  private Vector CERO = null;   
  private Vector ULTIMO = null;   

  private int criterioMedida = 0;

  private String msg = null;//frame30.chk de gestion

  private item30 nuevoItem = null;

  private lista30 l30 = null;

/**
* Constructor por defecto
**/
public listManager30( ) {
//
  counterSet = 0;//
}//listManager30


/**
* La medida de un item se actualiza con la de un caso que se incorpora
* al grupo. Si MEDIDA es negativa no cuenta. medida es positiva.
* maxima, minima, media, serie.
* @param medida Vector del caso.
* @param MEDIDA Vector del item.
* @return medida Vector agregado de un item.
**/
private Vector UtilityManager( String msg, Vector medida, Vector MEDIDA) {

   if ( frame30.utmanager == -1)
	for( int i = 0; i < medida.size(); i++) {
	  double M = ((Double)MEDIDA.get( i)).doubleValue();

     if ( M > 0.0) {

	  double m = ((Double)medida.get( i)).doubleValue();

	  if ( frame30.utmanager == 0) if ( m < M) {
		 if ( frame30.chk) System.out.println( msg + ": " + i + "......." + m + " <<== " + M);
	    medida.set( i, new Double( M));
	   }
	  if ( frame30.utmanager == 1) if ( m > M) {
		 if ( frame30.chk) System.out.println( msg + ": " + i + "......." + m + " ==>> " + M);
	    medida.set( i, new Double( M));
	   }
	  if ( frame30.utmanager == 2) if ( m != M) {
		 if ( frame30.chk) System.out.println( msg + ": " + i + "......." + m + " <<==>> " + M);
	    medida.set( i, new Double( (m+M)/2));
	   }

	  }//if

	  }//for

  return medida;
}//UtilityManager

//:::::::::::::::::::::::::::::::::::::::::::::::::
/**
* Gestion INI. Reglas: 0,1,2,3,4,5.
* La lista esta vacia, la longitud debe ser 1 y el indice del item debe ser el maximo o ultimo.
* La respuesta se sobrescribe, monotonia. Puede olvidar si se inserta unKB.
* El item 0 tiene como INDICE0 == ULTIMO.
**/
private int SetINI( Vector medida, Vector respuesta, Vector indice) {

  if ( l30.size() != 1) {
    System.out.println( ERROR + "l30.size() = " + l30.size() + "!= 1.");
    frame30.exit( -1);
    }//if
    
  if ( !index30.eqT( INDICE0, ULTIMO)) {
    System.out.println( ERROR + "SetINI.");
    System.out.println( "INDICE0: " + INDICE0.toString());
    System.out.println( "ULTIMO: " + ULTIMO.toString());
    frame30.exit( -1);
    }//if

//Regla-0
//indice == CERO y respuesta == RESPUESTA0
//set: ret.
  if ( index30.eqT( indice, CERO) &&
       index30.eqS( respuesta, RESPUESTA0)) {//---
    if (frame30.chk) msg = new String( "Regla-0.");
    l30.Get( 0).SetMedida( UtilityManager( msg, medida, l30.Get( 0).GetMedida()));
    return  0;//OK!!! r==
    }//if-Regla-0

//Regla-1
//indice==CERO y respuesta!=RESPUESTA0
//set: new( mri) + add( 0) + ret.
  if ( index30.eqT( indice, CERO) &&
       !index30.eqS( respuesta, RESPUESTA0)) {//---
    if (frame30.chk) msg = new String( "Regla-1.");
    nuevoItem = new item30( l30, medida, respuesta, indice);
    l30.add( 0, nuevoItem);
    return 1;//OK!!! r+
    }//if-Regla-1

//Regla-2
//indice > CERO y indice < INDICE0 y respuesta==RESPUESTA0
//set: ret. 
  if ( index30.myT( indice, CERO) &&
       index30.myT( INDICE0, indice) &&
       index30.eqS( respuesta, RESPUESTA0)) {//---
    if (frame30.chk) msg = new String( "Regla-2.");
    l30.Get( 0).SetMedida( UtilityManager( msg, medida, l30.Get( 0).GetMedida()));
    return 2;//OK!!! r==
    }//if-Regla-2

//Regla-3
//indice > CERO y indice < INDICE0 y respuesta!=RESPUESTA0
//set: new( mri) + add( 0) + new( M0R0(i-1)) + add( 0) + ret.
  if ( index30.myT( indice, CERO) &&
       index30.myT( INDICE0, indice) &&
       !index30.eqS( respuesta, RESPUESTA0)) {//---
    if (frame30.chk) msg = new String( "Regla-3."+0);
    nuevoItem = new item30( l30, medida, respuesta, indice);
    l30.add( 0, nuevoItem);
    nuevoItem = new item30( 
      l30, MEDIDA0, RESPUESTA0, index30.anteriorT( l30.Base.Dom(), indice));
    l30.add( 0, nuevoItem);
    return 3;//OK!!! r++
    }//if-Regla-3

//Regla-4
//indice==INDICE0 y respuesta==RESPUESTA0
//set: ret.
  if ( index30.eqT( indice, INDICE0) &&
       index30.eqS( respuesta, RESPUESTA0)) {//---
    if (frame30.chk) msg = new String( "Regla-4.");
    l30.Get( 0).SetMedida( UtilityManager( msg, medida, l30.Get( 0).GetMedida()));
    return  4;//OK!!! r==
    }//if-Regla-4

//Regla-5
//indice==INDICE0 y respuesta!=RESPUESTA0
//set: new( mri) + set( 0) + new( M0R0(i-1)) + add( 0) + ret.
  if ( index30.eqT( indice, INDICE0) &&
       !index30.eqS( respuesta, RESPUESTA0)) {//---
    if (frame30.chk) msg = new String( "Regla-5.");
    nuevoItem = new item30( 
      l30, MEDIDA0, RESPUESTA0, index30.anteriorT( l30.Base.Dom(), indice));
    l30.add( 0, nuevoItem);
    nuevoItem = new item30( l30, medida, respuesta, indice);
    l30.set( 1, nuevoItem);
    return  5;//OK!!! r!+
    }//if-Regla-5

  return -1;
}//SetINI

//:::::::::::::::::::::::::::::::::::::::::::::::::
/**
* Gestion TOP. Reglas: (6,7,8,9)CERO,10,11.a.b.c.  
* La lista no es vacia. Hay al menos dos items: 0, 1, (?)....
* La respuesta se sobrescribe, monotonia. Puede olvidar si se inserta unKB.
* INDICE0 == indice //top-lista.
**/
private int SetTOP( Vector medida, Vector respuesta, Vector indice) {

    ITEM1 = l30.Get( 1);//el segundo item.
    MEDIDA1 = ITEM1.GetMedida();
    RESPUESTA1 = ITEM1.GetRespuesta();
    INDICE1 = ITEM1.GetIndice();

//Regla-6
//indice==CERO y respuesta==RESPUESTA0
//set: ret.
  if ( index30.eqT( indice, CERO) &&
       index30.eqS( respuesta, RESPUESTA0)) {//---
    if (frame30.chk) msg = new String( "Regla-6."+0);
    l30.Get( 0).SetMedida( UtilityManager( msg, medida, l30.Get( 0).GetMedida()));
    return 6;//OK!!! r==
    }//if-Regla-6

//Regla-7
//indice==CERO y respuesta!=RESPUESTA1 y longitud( 0)==1
//set: new( mri) + set( 0) + ret.
  if ( index30.eqT( indice, CERO) && ( isLongitud1( 0)) &&
       !index30.eqS( respuesta, RESPUESTA1)) {//---
    if (frame30.chk) msg = new String( "Regla-7."+0);
    nuevoItem = new item30( l30, medida, respuesta, indice);
    l30.set( 0, nuevoItem);
    return  7;//OK!!! r!
    }//if-Regla-7

//Regla-8
//indice==CERO y respuesta==RESPUESTA1 y longitud( 0)==1
//set: del( 0) + ret.
  if ( index30.eqT( indice, CERO) && ( isLongitud1( 0)) &&
       index30.eqS( respuesta, RESPUESTA1)) {//---
    if (frame30.chk) msg = new String( "Regla-8."+0);
    ITEM1.SetMedida( UtilityManager( msg, medida, MEDIDA1));
    l30.remove( 0);
    return 8;//OK!!! r-
    }//if-Regla-8

//Regla-9
//indice==CERO y respuesta!=RESPUESTA0 y longitud( 0)!=1
//set: new( mri) + add( 0) + ret.
  if ( index30.eqT( indice, CERO) && ( !isLongitud1( 0)) &&
       !index30.eqS( respuesta, RESPUESTA0)) {//---
    if (frame30.chk) msg = new String( "Regla-9."+0);
    nuevoItem = new item30( l30, medida, respuesta, indice);
    l30.add( 0, nuevoItem);
    return 9;//OK!!! r+
    }//if-Regla-9

//Regla-10
//indice > CERO y indice <= INDICE0 y respuesta==RESPUESTA0
//set: ret.
  if ( index30.myT( indice, CERO) && ( !isLongitud1( 0)) &&
       index30.myeqT( INDICE0, indice) && index30.eqS( respuesta, RESPUESTA0)) {//---
    if (frame30.chk) msg = new String( "Regla-10."+0);
    l30.Get( 0).SetMedida( UtilityManager( msg, medida, l30.Get( 0).GetMedida()));
    return 10;//OK!!! r==
    }//if-Regla-10

//Regla-11 <0,r0<I0,r0|<I1,r1|.....
//indice > CERO y indice <= INDICE0 y respuesta!=RESPUESTA0
//set: new( mri) + add( 0) + new( M0R0(i-1)) + add( 0) + ret.
  if ( index30.myT( indice, CERO) && ( !isLongitud1( 0)) &&
       index30.myeqT( INDICE0, indice) && !index30.eqS( respuesta, RESPUESTA0)) {//---
    if (frame30.chk) msg = new String( "Regla-11.a.");
    nuevoItem = new item30( 
      l30, MEDIDA0, RESPUESTA0, index30.anteriorT( l30.Base.Dom(), indice));
    l30.add( 0, nuevoItem);
    nuevoItem = new item30( l30, medida, respuesta, indice);
    l30.add( 1, nuevoItem);
    if ( index30.eqT( INDICE0, indice)) {
      if (frame30.chk) msg = new String( msg + "b.");
      l30.remove( 2);
      if (( l30.size() > 2) && ( index30.eqS( respuesta, l30.Get( 2).GetRespuesta()))) {
        if (frame30.chk) msg = new String( msg + "c.");
        l30.Get( 2).SetMedida( UtilityManager( msg, medida, l30.Get( 2).GetMedida()));
        l30.remove( 1);
        }//if.c
    }//if.b
    if (frame30.chk) msg = new String( msg + 0);
    return 11;//OK!!! r++
    }//if-Regla-11

  return -1;
}//SetTOP

  private int ix = 0;//posicion del indice. ITEM3
  private int ixbin = 0, ixsec = 0;

/**
* Buscador binario del item que contiene el indice que se inserta...
**/
private int BBitem( Vector indice) {

  int itop = 0, ibot = l30.size();
  int controlBB = 0;
  int l30sz = l30.size();
  
  if (frame30.chk) 
    checkIndex30.INDX( l30, indice);

  try {
  while (true) {

    if ( ibot < itop) { 
      frame30.kbm2lSystem.append( "Set ibot <= itop !!!\n"); 
      frame30.exit( 0, new Exception()); 
      }
    ix = itop + (int)( ibot - itop) / 2;

    if ((( ix - 1) >= 0) && (( ix - 1) < l30sz)) {
      INDICE2 = l30.Get( ix-1).GetIndice();//un solo item.
    }//if
    else { 
      frame30.kbm2lSystem.append( "BB: ix - INDICE2 !!!-l30\n"); 
      frame30.exit( 0, new Exception()); 
      } // 

    if (( ix >= 0) && ( ix < l30sz)) {
      INDICE3 = l30.Get( ix).GetIndice();//un solo item.
    }//if
    else { 
      frame30.kbm2lSystem.append( "BB: ix - INDICE3 !!!-l30\n"); 
      frame30.exit( 0, new Exception()); 
      } // 

    if ( index30.myeqT( INDICE2, INDICE3)) {
      frame30.kbm2lSystem.append( 
        "BB: INDICE2 >= INDICE3 !!!-l30. xi: " + ix  + " itop: " + itop + " ibot: " + ibot + "n"); 
      if (INDICE2 != null) frame30.kbm2lSystem.append( "I2." + INDICE2.toString()+"\n");
      if (INDICE3 != null) frame30.kbm2lSystem.append( "I3." + INDICE3.toString()+"\n");
      frame30.kbm2lSystem.append( "I(ix-1). " + l30.Get( ix-1).GetIndice()+"\n");
      frame30.kbm2lSystem.append( "I(ix).   " + l30.Get( ix).GetIndice()+"\n");
      frame30.kbm2lSystem.append( "LAST RULE: " + l30.lastRULE + "  l30sz: " + l30sz + "\n");
      checkList30.CHK( l30, "BB I2 >= I3");
      frame30.exit( 0, new Exception()); 
      } //

    if ( index30.myT( indice, INDICE2) && index30.myeqT( INDICE3, indice)) {
      break;// INDICE3 == indice
      }

    if ( index30.myT( INDICE3, indice)) { ibot = ix; }  
      else
        if ( index30.myT( indice, INDICE3)) { itop = ix; }  

    if ( controlBB > l30sz) { 
      frame30.kbm2lSystem.append( ERROR + "controlBB !\n"); 
      frame30.kbm2lSystem.append( "BBitem." + ix + " l30.size(): " + l30sz + "\n");
      if (INDICE2 != null) frame30.kbm2lSystem.append( "I2." + INDICE2.toString()+"\n");
      if (indice != null)  frame30.kbm2lSystem.append( "IZ." + indice.toString()+"\n");
      if (INDICE3 != null) frame30.kbm2lSystem.append( "I3." + INDICE3.toString()+"\n");
      frame30.kbm2lSystem.append( "Reglas: " + l30.reglas.toString()+"\n");
      if ( index30.myT( indice, INDICE2) && index30.myeqT( INDICE3, indice)) {
        frame30.kbm2lSystem.append( "I2 Iz I3: ?\n");
      }

      frame30.exit(0, new Exception()); 
      }
    controlBB++;//contador de BBitem

    }//while
  } catch (Exception e){
      frame30.kbm2lSystem.append( ERROR + "BBitem. exception\n");
      frame30.exit(0, e); 
  }

  ixbin = ix;//<INDICE3,RESPUESTA3,MEDIDA3|

//ix-2  ITEM1
//..........
//xi-1  ITEM2
  ITEM2 = l30.Get( ix-1);//existe el ix-1.
  MEDIDA2 = l30.Get( ix-1).GetMedida();//un solo item.
  RESPUESTA2 = l30.Get( ix-1).GetRespuesta();//un solo item.
//xi    ITEM3
  ITEM3 = l30.Get( ix);//existe el ix.
  MEDIDA3 = l30.Get( ix).GetMedida();//un solo item.
  RESPUESTA3 = l30.Get( ix).GetRespuesta();//un solo item.
//xi+1  ITEM4
//..........

  return ix;
}//BBitem

/**
* Test: el item x-esimo, tiene 1 solo caso ? 
* @return index30.eqT( upp, low). True es iguales ---> longitud de casos unidad.
**/
private boolean isLongitud1( int x) {

  if (( x > 0) && ( x < l30.size())) {
    try { // x > 0 && x < l30.size
      Vector nextT = index30.siguienteT( l30.Base.Dom(), l30.Get( x-1).GetIndice());
      return index30.eqT( l30.Get( x).GetIndice(), nextT);
    } catch (Exception e) {
        System.out.println( ERROR + "isLongitud1.-1");
        frame30.exit( 0, e);
      }
    }//if                  

  if ( x == 0) {
    try { // x == 0
      Vector firstT = index30.primeroT( l30.Base.Dom());
      return index30.eqT( l30.Get( x).GetIndice(), firstT);
    } catch (Exception e) {
        System.out.println( ERROR + "isLongitud1.-2");
        frame30.exit( 0, e);
      }
      }//if
    
  System.out.println( ERROR + "isLongitud1.-3");
  frame30.exit( 0);
  return false;    
}//isLongitud1

//:::::::::::::::::::::::::::::::::::::::::::::::::
/**
* Gestion. Reglas: 12,13.a.b.c.d,14.a.b.c,15,16.a.b.,17,18.a.b,19,20,21,22,23,24,25.
* @param medida se procesa, MAXIMO de optimos. 
* @param respuesta gestion de la adyacencia que mantiene los items.
* @param indice orden estricto de indices. INDICE0 < indice y l30.size() > 1.
* @return idRegla numero identificador de regla. Traza msg.
**/
private int Set( Vector medida, Vector respuesta, Vector indice) {

  ix = BBitem( indice);//busq bin item

// (xi,ITEM3)

  if ( index30.eqT( INDICE3, indice)) {//bottom-item

//Regla-12
//respuesta==RESPUESTA3
//set: ret.
    if ( index30.eqS( respuesta, RESPUESTA3)) {//---
      if (frame30.chk) msg = new String( "Regla-12."+ix);
      ITEM3.SetMedida( UtilityManager( msg, medida, MEDIDA3));
      return 12;//OK!!! r==
      }//if-Regla-12

//Regla-13
//longitud( xi)==1 y respuesta!=RESPUESTA3
//set: new( mri) + set( xi).
//respuesta==RESPUESTA2
//set: del( xi-1);
//respuesta==RESPUESTA4
//set: del( xi);
//set: ret.
    //xi ---> ITEM3 !!!
    if ( isLongitud1( ix) && !index30.eqS( respuesta, RESPUESTA3)) {//---
      if (frame30.chk) msg = new String( "Regla-13.a.");    
      nuevoItem = new item30( l30, UtilityManager( msg, medida, MEDIDA3), respuesta, indice);
      l30.set( ix, nuevoItem);//!!!
      ITEM2 = l30.Get( ix-1);//un solo item. ix-1 existe siempre.
      MEDIDA2 = ITEM2.GetMedida();
      RESPUESTA2 = ITEM2.GetRespuesta();
      INDICE2 = ITEM2.GetIndice();
      if ( index30.eqS( respuesta, RESPUESTA2)) {
        if (frame30.chk) msg = new String( msg + "b."); 
        ITEM3.SetMedida( UtilityManager( msg, UtilityManager( msg, medida, MEDIDA3), MEDIDA2));        
        l30.remove( ix-1);//del(ix-1)
      // xi ---> ITEM4 !!! 
      if (( ix) < l30.size()) {//existe ITEM4
        ITEM4 = l30.Get( ix);//un solo item.
        MEDIDA4 = ITEM4.GetMedida();
        RESPUESTA4 = ITEM4.GetRespuesta();
        INDICE4 = ITEM4.GetIndice();
        if ( index30.eqS( respuesta, RESPUESTA4)) {
          if (frame30.chk) msg = new String( msg + "c.");   
          ITEM4.SetMedida( UtilityManager( msg, UtilityManager( msg, UtilityManager( msg, medida, MEDIDA3), MEDIDA2), MEDIDA4));
          l30.remove( ix-1);//del(ix-1)
          }//if eqS
        }//if ix+1 < l30.size()
        }//if eqS
      else {
      //xi ---> ITEM3 !!!
      if (( ix+1) < l30.size()) {//existe ITEM4
        ITEM4 = l30.Get( ix+1);//un solo item.
        MEDIDA4 = ITEM4.GetMedida();
        RESPUESTA4 = ITEM4.GetRespuesta();
        INDICE4 = ITEM4.GetIndice();
        if ( index30.eqS( respuesta, RESPUESTA4)) {
          if (frame30.chk) msg = new String( msg + "d.");   
          ITEM4.SetMedida( UtilityManager( msg, UtilityManager( msg, medida, MEDIDA3), MEDIDA4));
          l30.remove( ix);//del(ix)
          }//if eqS
        }//if ix+1 < l30.size()
      }

      if (frame30.chk) msg = new String( msg + ix);
      return 13;//OK!!! r!--    
      }//if-Regla-13

//Regla-14
//longitud( xi) > 1 y respuesta!=RESPUESTA3
//set: new( M3R3(i-1)) + set( xi)
//set: new( mri + set( xi+1)
//respuesta==RESPUESTA4
//set: del( xi+1) + ret.
    if ( !isLongitud1( ix) && !index30.eqS( respuesta, RESPUESTA3)) {//---
      if (frame30.chk) msg = new String( "Regla-14.");
      nuevoItem = new item30( 
        l30, MEDIDA3, RESPUESTA3, index30.anteriorT( l30.Base.Dom(), indice));
      l30.set( ix, nuevoItem);
      
      if (( ix + 1) < l30.size()) {
        ITEM4 = l30.Get( ix + 1);//un solo item.
        MEDIDA4 = ITEM4.GetMedida();
        RESPUESTA4 = ITEM4.GetRespuesta();
        INDICE4 = ITEM4.GetIndice();
        if ( !index30.eqS( respuesta, RESPUESTA4)) {
          if (frame30.chk) msg = new String( msg + "a.");
          nuevoItem = new item30( l30, medida, respuesta, indice);
          l30.add( ix+1, nuevoItem);
          }//if
        }//if ix + 1
        else {
          if (frame30.chk) msg = new String( msg + "b.");
          nuevoItem = new item30( l30, medida, respuesta, indice);
          l30.add( nuevoItem);
        }

      if (frame30.chk) msg = new String( msg + ix);
      return 14;//OK!!! r!+  
      }//if-Regla-14
  
  }//if bottom-item

//(xi-2,ITEM1)  (xi-1,ITEM2)  (xi,ITEM3)  (xi+1,ITEM4)

  if ( index30.myT( INDICE3, indice)) {//interior-item

  if ( ix - 2 >= 0) {
    ITEM1 = l30.Get( ix-2);//un solo item.
    MEDIDA1 = ITEM1.GetMedida();
    RESPUESTA1 = ITEM1.GetRespuesta();
    INDICE1 = ITEM1.GetIndice();
  }//if ( ix - 2 >= 0)
    else {
      ITEM1 = null;
      MEDIDA1 = null;
      RESPUESTA1 = null;
      INDICE1 = null;
    }

  if ( INDICE2 == null) {
    System.out.println("size():  "+l30.size());
    System.out.println("Error INDICE2.  ix:"+(ix)+"  ix-1:"+(ix-1));
    System.out.println("INDICE3:"+INDICE3.toString());
    System.out.println("indice: "+indice.toString());
    System.out.println("Dominio: "+l30.Base.Dom().toString());
    System.out.println("Base:    "+l30.Base.toString());
    System.exit( 0);
    }//if

//Regla-15
//indice==INDICE2 y respuesta==RESPUESTA2
//set: ret.
  if ( index30.eqT( indice, INDICE2) && index30.eqS( respuesta, RESPUESTA2)) {//---
    if (frame30.chk) msg = new String( "Regla-15."+ix);
    ITEM2.SetMedida( UtilityManager( msg, medida, MEDIDA2));
    return  15;//OK!!! r==
    }//if-Regla-15  

//Regla-16
//indice==INDICE2 y respuesta!=RESPUESTA2 y respuesta==RESPUESTA3 y longitud( xi-1)==1
//set: del( xi-1) 
//respuesta==RESPUESTA1
//set: del( xi-2) + ret.
  if ( index30.eqT( indice, INDICE2) && isLongitud1( ix-1) &&
       !index30.eqS( respuesta, RESPUESTA2) && index30.eqS( respuesta, RESPUESTA3)) {//---
    if (frame30.chk) msg = new String( "Regla-16.a.");
    ITEM3.SetMedida( UtilityManager( msg, medida, MEDIDA3));
    l30.remove( ix - 1);
    if ((ix - 2) >= 0) {
      if ( index30.eqS( respuesta, RESPUESTA1)) {
        if (frame30.chk) msg = new String( msg + "b.");
        ITEM1.SetMedida( UtilityManager( msg, UtilityManager( msg, medida, MEDIDA3), MEDIDA1));
        l30.remove( ix - 2);
        }//if
      }  
    if (frame30.chk) msg = new String( msg + ix);
    return 16;//OK!!! r--    
    }//if-Regla-16  

//Regla-17
//indice==INDICE2 y respuesta!=RESPUESTA2 y respuesta==RESPUESTA3 y longitud( ix-1)!=1
//set: new( M2R2(ix-1)) + set( ix-1) + ret.
  if ( index30.eqT( indice, INDICE2) && !isLongitud1( ix-1) &&
       !index30.eqS( respuesta, RESPUESTA2) &&  index30.eqS( respuesta, RESPUESTA3)) {//---
    if (frame30.chk) msg = new String( "Regla-17."+ix);
    nuevoItem = new item30( l30, MEDIDA2, RESPUESTA2, index30.anteriorT( l30.Base.Dom(), indice));
    ITEM3.SetMedida( UtilityManager( msg, medida, MEDIDA3));
    l30.set( ix-1, nuevoItem);
    return 17;//OK!!! r!
    }//if-Regla-17  

//Regla-18
//indice==INDICE2 y respuesta!=RESPUESTA2 y respuesta!=RESPUESTA3 y longitud( ix-1)==1
//set: new( mri) + set( ix-1) 
//respuesta==RESPUESTA1
//set: del( ix-2) + ret.
  if ( index30.eqT( indice, INDICE2) && isLongitud1( ix-1) &&
       !index30.eqS( respuesta, RESPUESTA2) && !index30.eqS( respuesta, RESPUESTA3)) {//---
    if (frame30.chk) msg = new String( "Regla-18.a.");
    nuevoItem = new item30( l30, medida, respuesta, indice);
    l30.set( ix-1, nuevoItem);
    if (( ix - 2 ) >= 0) {
      if ( index30.eqS( respuesta, RESPUESTA1)) {
        if (frame30.chk) msg = new String( msg + "b.");
        ITEM1.SetMedida( UtilityManager( msg, medida, MEDIDA1));
        l30.remove( ix-2);
        }//if
      }
    if (frame30.chk) msg = new String( msg + ix);
    return 18;//OK!!! r!-    
    }//if-Rega-l8  

//Regla-19
//indice==INDICE2 y respuesta!=RESPUESTA2 y respuesta!=RESPUESTA3 y longitud( ix-1)!=1
//set: new( M2R2(ix-1)) + set( ix-1) + new( mri) + add( ix) + ret.
  if ( index30.eqT( indice, INDICE2) && !isLongitud1( ix-1) &&
       !index30.eqS( respuesta, RESPUESTA2) && !index30.eqS( respuesta, RESPUESTA3)) {//---
    if (frame30.chk) msg = new String( "Regla-19."+ix);
    nuevoItem = new item30( l30, MEDIDA2, RESPUESTA2, index30.anteriorT( l30.Base.Dom(), indice));
    l30.set( ix-1, nuevoItem);
    nuevoItem = new item30( l30, medida, respuesta, indice);
    l30.add( ix, nuevoItem);
    return 19;//OK!!! r!+
    }//if-Regla-19

//Regla-20
//indice==INDICE2 y respuesta!=RESPUESTA2 y respuesta==RESPUESTA3 y 
//respuesta!=RESPUESTA1 y longitud( ix-1)==1
//set: del( ix-1) + ret.
  if ( index30.eqT( indice, INDICE2) && isLongitud1( ix-1) &&
       !index30.eqS( respuesta, RESPUESTA1) && !index30.eqS( respuesta, RESPUESTA2) &&
       index30.eqS( respuesta, RESPUESTA3)) {//---
    if (frame30.chk) msg = new String( "Regla-20."+ix);
    ITEM3.SetMedida( UtilityManager( msg, medida, MEDIDA3));
    l30.remove( ix-1);
    return 20;//OK!!! r-
    }//if-Regla-20  

//Regla-21
//indice==INDICE2 y respuesta!=RESPUESTA2 y respuesta!=RESPUESTA3 y 
//respuesta==RESPUESTA1 y longitud( ix-1)==1
//set: new( mri) + set( ix-1) + del( ix-2) + ret.
  if ( index30.eqT( indice, INDICE2) && isLongitud1( ix-1) &&
       index30.eqS( respuesta, RESPUESTA1) && !index30.eqS( respuesta, RESPUESTA2) &&
       !index30.eqS( respuesta, RESPUESTA3)) {//---
    if (frame30.chk) msg = new String( "Regla-21."+ix);
    nuevoItem = new item30( l30, UtilityManager( msg, medida, MEDIDA1), respuesta, indice);
    l30.set( ix - 1, nuevoItem);
    l30.remove( ix - 2);
    return 21;//OK!!! r!-
    }//if-Regla-21  

//// <I2,R2|<i,r<I3,R3|

//Regla-22
//indice > INDICE2 y indice < INDICE3 y respuesta==RESPUESTA3
//set: ret.
  if ( index30.myT( indice, INDICE2) && index30.myT( INDICE3, indice) &&
       index30.eqS( respuesta, RESPUESTA3)) {//---
    if (frame30.chk) msg = new String( "Regla-22."+ix);
    ITEM3.SetMedida( UtilityManager( msg, medida, MEDIDA3));
    return 22;//OK!!! r==
    }//if-Regla-22  

//Regla-23
//indice == INDICE2+1 y indice < INDICE3 y respuesta==RESPUESTA2 y respuesta!=RESPUESTA3
//set: new( mri) + set( ix-1) + ret.
  if ( index30.myT( indice, INDICE2) && index30.myT( INDICE3, indice) &&
       index30.eqS( respuesta, RESPUESTA2) && !index30.eqS( respuesta, RESPUESTA3) &&
       index30.eqT( index30.siguienteT( l30.Base.Dom(), INDICE2), indice)) {//---
    if (frame30.chk) msg = new String( "Regla-23."+ix);
    nuevoItem = new item30( l30, UtilityManager( msg, medida, MEDIDA2), respuesta, indice);
    l30.set( ix-1, nuevoItem);
    return 23;//OK!!! r!
    }//if-Regla-23  

//Regla-24
//indice == INDICE2+1 y indice < INDICE3 y respuesta!=RESPUESTA2 y respuesta!=RESPUESTA3
//set: new( mri) + add( ix) + ret.
  if ( index30.myT( indice, INDICE2) && index30.myT( INDICE3, indice) &&
       !index30.eqS( respuesta, RESPUESTA2) && !index30.eqS( respuesta, RESPUESTA3) &&
       index30.eqT( index30.siguienteT( l30.Base.Dom(), INDICE2), indice)) {//---
    if (frame30.chk) msg = new String( "Regla-24."+ix);
    nuevoItem = new item30( l30, medida, respuesta, indice);
    l30.add( ix, nuevoItem);
    return 24;//OK!!! r+
    }//if-Regla-24  

//Regla-25
//indice > INDICE2+1 y indice < INDICE3 y respuesta!=RESPUESTA3
//set: new( mri) + add( ix) + new( mr(ix-1)) + add( ix) + ret.
  if ( index30.myT( indice, INDICE2) &&  index30.myT( INDICE3, indice) &&
       !index30.eqS( respuesta, RESPUESTA3) &&
       index30.myT( indice, index30.siguienteT( l30.Base.Dom(), INDICE2))) {//---
    if (frame30.chk) msg = new String( "Regla-25."+ix);
    nuevoItem = new item30( l30, medida, respuesta, indice);
    l30.add( ix, nuevoItem);
    nuevoItem = new item30( 
      l30, MEDIDA3, RESPUESTA3, index30.anteriorT( l30.Base.Dom(), indice));
    l30.add( ix, nuevoItem);
    return 25;//OK!!! r++
    }//if-Regla-25  

  }//if interior-item

System.out.println( ERROR);
  return -1;
}//SetINT

/**
* Introduce un caso en la lista.
* Reglas de gestion kbm2l, el item tiene las coordenadas en la base de la lista, 
* la medida asociada a los items se procesa en esta version, MAXIMO de optimos, otras Alternativas?: 
* Se gestiona el orden y la adyacencia de la lista !!! 
* @return idRegla, numero de la regla de gestion que se ha aplicado.
**/
public int Set( lista30 l30, item30 caso) { 

  if ( l30 == null) {
    System.out.println( ERROR + "l30 == null");
    new Exception().printStackTrace();
    return -1;//
	 }

  if ( caso == null) {
    System.out.println( ERROR + "caso == null");
    new Exception().printStackTrace();
    return -1;//
	 }
  this.l30 = l30;//!!!

  int idREGLA = -1;
  nuevoItem = null;
  ix = 0;

//caso(item)
  Vector medida = caso.GetMedida();
  Vector respuesta = caso.GetRespuesta();
  Vector indice = caso.GetIndice();

  if ( index30.eqS( respuesta, l30.UNKB)) {
    System.out.println( ERROR + "index30.eqS( respuesta, l30.UNKB)");
    frame30.exit( -1);
    }

  CERO = index30.primeroT( l30.Base.Dom());// pueden ser parte de la lista
  ULTIMO = index30.ultimoT( l30.Base.Dom());

  ITEM0 = l30.Get( 0);//siempre existe el 0.
  MEDIDA0 = ITEM0.GetMedida();
  RESPUESTA0 = ITEM0.GetRespuesta();
  INDICE0 = ITEM0.GetIndice();

  //dimension de observacion del conjunto de datos: dat
  if ( tabla30.FlagSet == 'd') {
    while ( !l30.esUNKB( l30.GET( indice))) {
      int obs = ((Integer)indice.get( indice.size()-1)).intValue();
      obs++;
//      if ( obs >= l30.Base.dom( indice.size()-1))
  //      l30.Base.dom( indice.size()-1, obs+1);
      indice.set( indice.size()-1, new Integer( obs)); 
      System.out.println( "indice == " + indice);
      }
    }//  

  if (frame30.chk) 
  if ( index30.myT( CERO, indice) || index30.myT( indice, ULTIMO) 
       || !checkIndex30.INDX( l30, indice)
       ) {       
    System.out.println( ERROR + "indice == -1");
    System.out.println( "indice == " + indice);
    System.out.println( "base: " + l30.Base.toString());
    core30.core( l30, caso, ix, CERO, ULTIMO, ITEM0, ITEM1, ITEM2, ITEM3, ITEM4);
    System.out.println( "*************************" );    
    }//  

  if (frame30.chk) 
    checkList30.chk( l30, "Pre-Set");//!!!
    
  try {

  if ( l30.size() == 1) {
    idREGLA = SetINI( medida, respuesta, indice);
    }//if ( l30.lkbm.size() == 1)
  else {
    if ( index30.myeqT( INDICE0, indice)) {//top-lista
      idREGLA = SetTOP( medida, respuesta, indice);
      }//if Top-lista
    else {  
      idREGLA = Set( medida, respuesta, indice);
      }//if lista
    }

//mantenimiento del CACHE !
    long l30sz = l30.size();
//    for( int iy = 0; iy < l30sz; iy++) l30.Get( iy).Cache(false);
    int env_cache = 4;
    for( int iy = -env_cache; iy <= env_cache; iy++)
      if (( ix+iy >= 0) && ( ix+iy < l30sz)) l30.Get( ix+iy).Cache(false);

  } catch (Exception e) {
      System.out.println( "************************************ Exception *******" );
      System.out.println( ERROR + "Set: " + msg + "  idREGLA: " + idREGLA);
      e.printStackTrace();
      System.out.println( "************************************" );
      core30.core( l30, caso, ix, CERO, ULTIMO, ITEM0, ITEM1, ITEM2, ITEM3, ITEM4);
      System.out.println( "*************************" );    
  }

  if (( idREGLA >= 0) && ( idREGLA <= 25)) {//OK

    if (frame30.chk) if (( l30.reglas.indexOf( msg) == -1) && ( msg.charAt( 0) == 'R'))
      l30.reglas.add( new String( msg));//frame30.chk de gestion

    l30.lastRULE = idREGLA;//
    counterSet++;//

    if (frame30.chk) {
      //conocimiento y control de monotonia
      if ( listStat30.KB( l30).equals( BigInteger.ONE.negate())) {
        System.out.println( "************************* KB( ) *******" );
        System.out.println( ERROR + "Set: idREGLA == " + l30.lastRULE);
        core30.core( l30, caso, ix, CERO, ULTIMO, ITEM0, ITEM1, ITEM2, ITEM3, ITEM4);
        System.out.println( "*************************" );    
        }
      checkList30.CHK( l30, msg);
    }

  if ( index30.eqS( respuesta, l30.MODE)) {//aviso para la copia std !!!
    System.out.println( ERROR + "respuesta == -1.  LAST.RULE: " + l30.lastRULE);
    }

    return idREGLA;//OK
    }
 
//idREGLA == -1
  System.out.println( "************************* idREGLA == -1 *******" );
  System.out.println( ERROR + "Set: idREGLA == " + idREGLA);
  core30.core( l30, caso, ix, CERO, ULTIMO, ITEM0, ITEM1, ITEM2, ITEM3, ITEM4);
  System.out.println( "*************************" );
  
  return -1;
}//Set

/**
* Introduce items en una lista. Lectura de un fichero de una lista ordenada.
* Secuential SET.
* @param l30 lista destino.
* @param item conjunto de casos.
* @return l30.size(), numero de items de la lista, tamao de la lista.
**/
public long SET( lista30 l30, item30 item) {
//KBM2L
 
  try {
    l30.ctlKB( new BigInteger( "0"));//RESET!!!
    this.l30 = l30;//!!!
    item.Cache( false);
    l30.add( new item30( l30, item));
    ((item30)l30.Get(l30.size()-1)).Cache( false);
  } catch (Exception e){
      System.out.println( ERROR + "Regla-SET.");
      frame30.exit( 0);
  }
  if ( l30.size() >= 2)
    if ( index30.myeqT( l30.Get( l30.size() - 2).GetIndice(), l30.Get( l30.size() - 1).GetIndice())) {  
      System.out.println( ERROR + "SET:" + l30.size());
      System.out.println( "SET:" + l30.Get( l30.size()-2).GetIndice());//anterior
      System.out.println( "SET:" + l30.Get( l30.size()-1).GetIndice());//ultimo
      frame30.exit( 0);
      }//if
  if ( index30.eqT( item.GetIndice(), 
                   index30.ultimoT( l30.Base.Dom()))) {
    //calc KB-casos + calc-offset + chk-monotono
    l30.controlKB = new BigInteger( listStat30.KB( l30).toString());
    checkList30.chk( l30, "SET.");//???
    }
    
  l30.lastRULE = 100;
  counterSet++;//
  return (long)l30.size();
}//SET 

/**
* Introduce items en una lista. Lectura de un fichero de una lista indexada.
* Random SET. No hace comprobaciones de consistencia.
* @param l30 lista destino.
* @param item conjunto de casos.
* @return l30.size(), numero de items de la lista, tamao de la lista.
**/
public long SET( lista30 l30, int i, item30 item) {
//KBM2L
 
  try {
    l30.ctlKB( new BigInteger( "0"));//RESET!!!
    this.l30 = l30;//!!!
    l30.set( i, new item30( l30, item));
  } catch (Exception e){
      System.out.println( ERROR + "Regla-SET. i: " +i);
      System.out.println( "Lista: " +l30.size());
      frame30.exit( 0);
  }

  l30.lastRULE = 200;
  counterSet++;//
  return (long)l30.size();
}//SET

/**
* Eliminar un item de la lista en bloque.
* El ultimo no se puede borrar!!!
* El espacio (casos) del item borrado se aade al siguiente
**/
public BigInteger REMOVE( lista30 l30, int p) {

  try {
    if ( p >= (l30.size())) {
      //el mayor que el ultimo no se puede borrar!!!
      System.out.println( ERROR + "REMOVE: p=" + p);
      frame30.exit( 0);
      }//if
    } catch (Exception e){
        System.out.println( ERROR + "REMOVE.* p: " + p);
        System.out.println( "List size: " +l30.size());
        e.printStackTrace(); 
        frame30.exit( 0);
    }

  try {
    l30.controlKB = new BigInteger( "0");//RESET!!!
    if ( index30.eqT( l30.Get( p).GetIndice(), index30.ultimoT( l30.Base.Dom()))) {
      //el ultimo no se borra, se hace UNKB
      Vector MEDIDA = index30.cpR( l30.Get( p).GetMedida());
      Vector RESPUESTA = index30.cpS( l30.UNKB);
      Vector INDICE = index30.cpT(l30.Get( p).GetIndice());
      l30.SET( p, new item30( l30, MEDIDA, RESPUESTA, INDICE)); //
      if ( p-1 >= 0)
        if ( l30.esUNKB( l30.Get( p-1)))
          l30.remove( p-1);//!
      }//if
    else {
      try {
        //el espacio (casos) del item borrado se aade al siguiente
        l30.remove( p);//!
      } catch (Exception e){
          System.out.println( ERROR + "REMOVE.1 p: " + p);
          System.out.println( "List size: " +l30.size());
          e.printStackTrace(); 
          frame30.exit( 0);
      }

      try {
        //coalescencia de los items adyacentes iguales
        if ( p-1 >= 0)
          if ( index30.eqS( l30.Get( p-1).GetRespuesta(), l30.Get( p).GetRespuesta()))
            l30.remove( p-1);//!
      } catch (Exception e){
          System.out.println( ERROR + "REMOVE.2 p: " + p);
          System.out.println( "List size: " + l30.size());
          e.printStackTrace(); 
          frame30.exit( 0);
      }
    }//if
      } catch (Exception e){
          System.out.println( ERROR + "REMOVE.0 p: " + p);
          System.out.println( "List size: " +l30.size());
          e.printStackTrace(); 
          frame30.exit( 0);
       }

  if (l30.size()>0) {
    l30.lastRULE = 300;
    counterSet++;//
    checkList30.chk( l30, "REMOVE.");//???
    return l30.Get( l30.size()-1).getLongitud();
   }
    else {
      System.out.println( ERROR + "REMOVE.3 p: " + p);
      System.out.println( "List size: " + l30.size());
      new Exception().printStackTrace(); 
      frame30.exit( 0); return null;
	    }
}//REMOVE

/**
* Eliminar un item de la lista caso a caso.
* 
**/
public BigInteger remove( lista30 l30, int p) {

  if ( p >= (l30.size()-1)) {//el ultimo no se puede borrar!!!
    System.out.println( ERROR + "remove: p=" + p);
    new Exception().printStackTrace(); 
    frame30.exit( 0);
    }//if

  l30.controlKB = new BigInteger( "0");//RESET!!!
  BigInteger iniKB = listStat30.KB( l30);

  Vector RESPUESTA = l30.Get( p+1).GetRespuesta();
  Vector MEDIDA = l30.Get( p+1).GetMedida();
  Vector INDICE = l30.Get( p).GetIndice();//==index30.Sup( l30, p)
  Vector INDEX = null;//contador de indice
  int regla = -1;
  long elemento = 0;
  Vector ULTIMO = index30.ultimoT( l30.Base.Dom());//indice ultimo

  INDICE = l30.Get( p).GetIndice();//limite de copia

  for( INDEX = index30.cpT( l30.Inf( p));
    (( index30.myT( INDICE, INDEX) || index30.eqT( INDICE, INDEX)));
    // ((INDICE > INDEX) || (INDICE == INDEX))
    INDEX = index30.siguienteT( l30.Base.Dom(), INDEX)) { // INDEX++
    item30 nuevoItem = null;
      // in ITEM
        nuevoItem = new item30( l30, MEDIDA, RESPUESTA, INDEX);
        regla = l30.Set( nuevoItem); 
      }//for-INDEX
  
  BigInteger finKB = listStat30.KB( l30);  
  if ( iniKB.compareTo( finKB) != 0)
    System.out.println(
      "item30 remove KB??.  iniKB: " + iniKB.toString() + "  finKB: " + finKB.toString());
   
  checkList30.chk( l30, "remove.");//???

  counterSet++;//
  return l30.Get( l30.size()-1).getLongitud();
}//remove

}//class listManager30
