//LISTSTAT30//
package kernel;

//
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kbm2l.*;
import control.*;
import schema.*;
import analysis.*;
import target.*;

/**
* Clase listStat30, estadisticas de una lista.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  listStat30 {

//constantes
  private static final String ERROR = "Error(listStat30): ";

///////////////////
/**
* Constructor por defecto
**/
public listStat30( ) {
//

}//listStat30

/**
* Tamao de la lista, en memoria
**/
public static long memSize( lista30 l30) { 

  return (long)(l30.lkbm.size())*
    (long)(l30.ParMedida()+l30.ParRespuesta()+l30.ParIndice());
}//memSize()

/**
* el item es deconocido ?
**/
public static boolean esUNKB( lista30 l30, item30 item) {

  return index30.eqS( item.GetRespuesta(), l30.UNKB);
}//

/**
* el item es resticcion ?
**/
public static boolean esCOKB( lista30 l30, item30 item) {

  return index30.eqS( item.GetRespuesta(), l30.COKB);
}//

/**
* Vector respuesta mas frecuente: moda de la KBM2L.
**/
public static Vector moda( lista30 l30) {

 if ( !new controlPrefs30().modalCriterion()) {
	l30.MODE = l30.UNKB; 
   return l30.UNKB;
   }//if
  
  long tcp1 = new Date().getTime();
  Vector S = DS( l30); 
  S.add( (Vector)l30.UNKB.clone());
  BigInteger maxCases = new BigInteger( "0");
  int s = -1;
  try {
    for( int i = 0; i < S.size(); i++) {
      BigInteger cases = KB( l30, (Vector)S.get( i));
      if ( cases.compareTo( maxCases) == 1 ) { 
        maxCases = new BigInteger( cases.toString()); 
        s = i; //moda en S sobre i.
        }//if
      }//for
    }//try
      catch (Exception e) {
        System.out.println( ERROR + "moda.");
        frame30.exit( 0, e);
      }//catch

  if ( l30.checkMode)
    frame30.kbm2lTime.append( "moda:" + (new Date().getTime()-tcp1) + "\n" );

  l30.MODE = (Vector)S.get( s);
  return l30.MODE;
}//moda

/**
* Hay items con respuesta desconocida ?.
* Hay items con respuesta desconocida: false.
* Todos los items de la lista son conocidos: true.
* @see item30#GetRespuesta()
* @see index30#eqS(Vector, Vector)
* @return true si todos los items tienen respuesta conocida
**/
public static boolean completa( lista30 l30) {
//hay items sin conocimiento ? 

  long tcp1 = new Date().getTime();
  for( int i = 0; i < l30.size(); i++) {
    if ( index30.eqS( l30.Get( i).GetRespuesta(), l30.UNKB)) {
      return false;
      }
    }//for

  if ( l30.checkMode)
    frame30.kbm2lTime.append( "completa:" + (new Date().getTime()-tcp1) + "\n" );

  return true;
}//completa

/**
* Numero de items conocidos en una lista.
* @see item30#GetRespuesta()
* @see index30#eqS(Vector,Vector)
* @return kbs items con conocimiento, numero entero.
**/
public static int kb( lista30 l30) {

  int kbs = 0;

  long tcp1 = new Date().getTime();
  for( int i = 0; i < l30.size(); i++) {
    Vector RESPUESTA = l30.Get( i).GetRespuesta();
    if ( !index30.eqS( RESPUESTA, l30.UNKB))
      kbs = kbs + 1;
    }//for

  if ( l30.checkMode)
    frame30.kbm2lTime.append( "kb:" + (new Date().getTime()-tcp1) + "\n" );

  return kbs;
}//kb

/**
* Numero de items cuya respuesta es S.
* Items con conocimiento S
* @see item30#GetRespuesta()
* @see index30#eqS(Vector, Vector)
* @param S respuesta 
* @return items con conocimiento tipo S, numero entero.
**/
public static int kb( lista30 l30, Vector S) {

  long tcp1 = new Date().getTime();
  int kbs = 0;
  calc( l30);//con cache
  for( int i = 0; i < l30.size(); i++) {
    Vector RESPUESTA = l30.Get( i).GetRespuesta();
    if ( index30.eqS( RESPUESTA, S))
      kbs = kbs + 1;
    }//for

  if ( l30.checkMode)
    frame30.kbm2lTime.append( "kbs:" + (new Date().getTime()-tcp1) + "\n" );
  return kbs;
}//kb

/**
* Casos conocidos
* calc offset
* KB-casos con conocimiento
* chk KB-monotono
**/
public static BigInteger KB( lista30 l30) {

  long tcp1 = new Date().getTime();
  BigInteger kbs = new BigInteger( new String( "0"));
  calc( l30);//con cache
  for( int i = 0; i < l30.size(); i++) {
    try {
      if ( !index30.eqS( l30.Get( i).GetRespuesta(), l30.UNKB)) {
        kbs = kbs.add( l30.Get( i).getLongitud());
        } 
      }//try
      catch (Exception e) {
        System.out.println( ERROR + "KB.1");
        frame30.exit( 0, e);
      }//catch
    }//for

  if ( l30.checkMode)  
  try {
   System.out.println( "CHECK KB-control");
   if (( l30.controlKB == null) && ( l30.size() == 1)) {
     l30.controlKB = new BigInteger( new String( "0"));
     }
    if (!( new controlPrefs30().modalCriterion()))
    if ( l30.controlKB.compareTo( kbs) <= 0) {
      l30.controlKB = new BigInteger( kbs.toString());//monotono
      }
      else {
        System.out.println( ERROR + "controlKB(): " + l30.controlKB + 
          ",  KB( ): " +          kbs + 
          "  List: " + l30.Name() + 
          "  RULE: " + l30.lastRULE);
        if ( checkList30.chk( l30, "KB-control"))
          System.out.println( "chk: KB-control");      
        //frame30.exit( 0);//no-monotono       
        return BigInteger.ONE.negate();
        }//
      }//try
      catch (Exception e) {
        System.out.println( ERROR + "KB.2");
        frame30.exit( 0, e);
      }//catch
    
  if ( l30.checkMode)
    frame30.kbm2lTime.append( "KB:" + (new Date().getTime()-tcp1) + "\n" );
  return kbs;//casos conocidos != UNKB
}//KB

/**
* Casos con conocimiento S
**/
public static BigInteger KB( lista30 l30, Vector S) {

  long tcp1 = new Date().getTime();
  BigInteger kbs = new BigInteger( "0");
  calc( l30);//con cache
  for( int i = 0; i < l30.size(); i++) {
    try {
      if ( index30.eqS( l30.Get( i).GetRespuesta(), S)) {
        kbs = kbs.add( l30.Get( i).getLongitud());
        }
      }//try
      catch (Exception e) {
        System.out.print( ERROR + "KB( S).\n");
        frame30.exit( 0, e);
      }//catch
    }//for

  if ( l30.checkMode)
    frame30.kbm2lTime.append( "KBs:" + (new Date().getTime()-tcp1) + "\n" );
  return kbs;
}//KB

/**
* Casos conocidos a menor distancia MaxDist de un caso de REF y 
* con las dimensiones del indice MASK
* calc offset
* KB-casos con conocimiento
* chk KB-monotono
* @param l30
* @param MASK
* @param MaxDist
* @return kbs casos conocidos
**/
public static BigInteger KB( lista30 l30, Vector MASK, double MaxDist) {

  long tcp1 = new Date().getTime();
  BigInteger kbs = new BigInteger( "0");
  calc( l30);//con cache
  for( int i = 0; i < l30.size(); i++) {
    try {
      if ( !index30.eqS( l30.Get( i).GetRespuesta(), l30.UNKB)) {
	     if ( analisisScanner30.distancia( l30, l30.Get( i).GetIndice(), MASK) <= MaxDist) 
          kbs = kbs.add( l30.Get( i).getLongitud());
        } 
      }//try
      catch (Exception e) {
        System.out.println( ERROR + "KB.");
        frame30.exit( 0, e);
      }//catch
    }//for

  if ( l30.checkMode)
    if (!( new controlPrefs30().modalCriterion()))
    if ( l30.controlKB.compareTo( kbs) <= 0) {
      l30.controlKB = new BigInteger( kbs.toString());//monotono
      }
      else {
        System.out.println( ERROR + "controlKB(): " + l30.controlKB + 
          ",  KB( ): " +          kbs + 
          "  List: " + l30.Name() + 
          "  RULE: " + l30.lastRULE);
        if ( checkList30.chk( l30, "KB-control"))
          System.out.println( "chk: KB-control");      
        //System.exit( 0);//no-monotono       
        return BigInteger.ONE.negate();
        }//
    
  if ( l30.checkMode)
    frame30.kbm2lTime.append( "KBmd:" + (new Date().getTime()-tcp1) + "\n" );
  return kbs;//casos conocidos != UNKB
}//KB

/**
* mayor item de la lista en Numero de casos 
**/
public static int maximoItem( lista30 l30) {

  long tcp1 = new Date().getTime();
  calc( l30);//con cache
  int max = 0;
  BigInteger OF1 = null, OF2 = null; 
  BigInteger MAX = BigInteger.ONE, newMAX= null, wItem = null;
  for( int i = 0; i < l30.size(); i++) {
    item30 item = l30.Get( i);
    try {
      OF1 = item.getOffsetInf();
      OF2 = item.getOffsetSup();
      wItem = (( OF2.add( OF1.negate()).add( BigInteger.ONE)));//numero de casos
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "maximoItem.1");
      frame30.exit( 0, e);
    }//catch
    try {
      newMAX = wItem.max( MAX);
      if ( newMAX.compareTo( MAX) != 0) { 
        MAX = new BigInteger (newMAX.toString()); 
        max = i;
        }
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "maximoItem.2");
      frame30.exit( 0, e);
    }//catch
  }//for

  if ( l30.checkMode)
    frame30.kbm2lTime.append( "maximoItem:" + (new Date().getTime()-tcp1) + "\n" );
  return max;
}//maximoItem

/**
* Numero de casos del mayor item de la lista
**/
public static BigInteger MaximoItem( lista30 l30) {

  long tcp1 = new Date().getTime();
  calc( l30);//con cache
  BigInteger OF1 = null, OF2 = null; 
  BigInteger MAX = BigInteger.ONE, wItem = null;
  for( int i = 0; i < l30.size(); i++) {
    item30 item = l30.Get( i);
    try {
      OF1 = item.getOffsetInf();
      OF2 = item.getOffsetSup();
      wItem = (( OF2.add( OF1.negate()).add( BigInteger.ONE)));//numero de casos
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "MaximoItem.1");
      frame30.exit( 0, e);
    }//catch
    try {
      MAX = wItem.max( MAX);
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "MaximoItem.2");
      frame30.exit( 0, e);
    }//catch
  }//for

  if ( l30.checkMode)
    frame30.kbm2lTime.append( "MaximoItem:" + (new Date().getTime()-tcp1) + "\n" );
  return MAX;
}//MaximoItem

/**
* El menor item de la lista en Numero de casos
**/
public static int minimoItem( lista30 l30) {

  long tcp1 = new Date().getTime();
  calc( l30);//con cache
  int min = 0;
  BigInteger OF1 = null, OF2 = null; 
  BigInteger MIN = new offset30().getLONGITUD( l30.Base.Dom()), newMIN = null, wItem = null;
  for( int i = 0; i < l30.size(); i++) {
    item30 item = l30.Get( i);
    try {
      OF1 = item.getOffsetInf();
      OF2 = item.getOffsetSup();
      wItem = (( OF2.add( OF1.negate()).add( BigInteger.ONE)));//numero de casos
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "minimoItem.1");
      frame30.exit( 0, e);
    }//catch
    try {
      newMIN = wItem.min( MIN);
      if ( newMIN.compareTo( MIN) != 0) {
        MIN = new BigInteger (newMIN.toString()); 
        min = i;
      }
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "minimoItem.2");
      frame30.exit( 0, e);
    }//catch
  }//for

  if ( l30.checkMode)
    frame30.kbm2lTime.append( "minimoItem:" + (new Date().getTime()-tcp1) + "\n" );
  return min;
}//minimoItem

/**
* Numero de casos del menor item de la lista
**/
public static BigInteger MinimoItem( lista30 l30) {

  long tcp1 = new Date().getTime();
  calc( l30);//con cache
  BigInteger OF1 = null, OF2 = null; 
  BigInteger MAX = BigInteger.ONE, wItem = null;
  for( int i = 0; i < l30.size(); i++) {
    item30 item = l30.Get( i);
    try {
      OF1 = item.getOffsetInf();
      OF2 = item.getOffsetSup();
      wItem = (( OF2.add( OF1.negate()).add( BigInteger.ONE)));//numero de casos
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "MinimoItem.1");
      frame30.exit( 0);
    }//catch
    try {
      MAX = wItem.min( MAX);
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "MinimoItem.2");
      frame30.exit( 0, e);
    }//catch
  }//for

  if ( l30.checkMode)
    frame30.kbm2lTime.append( "MinimoItem:" + (new Date().getTime()-tcp1) + "\n" );
  return MAX;
}//MinimoItem

/**
* Vector de pesos o descriptor del espacio
**/
public static Vector getWeights( lista30 l30) {

  calc( l30);//con cache
//  CALC( l30);//sin cache
  return l30.Weights;
}//getWeights

/**
* Alternativas vectoriales de respuesta presentes en la lista.
* La respuesta de la lista, vector de modalidades instanciadas.
* @see item30#GetRespuesta()
* @see index30#eqS(Vector, Vector)
* @return Vector de modos de respuesta de la lista
**/
public  static  Vector DS( lista30 l30) {

  Vector KB = new Vector();
  try {
    for( int i = 0; i < l30.size(); i++) {
      Vector RESPUESTA = l30.Get( i).GetRespuesta();
      if ( !index30.eqS( RESPUESTA, l30.UNKB))
        if ( KB.indexOf( RESPUESTA) == -1)
          KB.add( RESPUESTA);
      }//for
  } catch (Exception e) {
      System.out.println( ERROR + "DS( ).");
      frame30.exit( 0, e);
  }//

  return KB;
}//DS

/**
* Alternativas escalares de respuesta presentes en la lista.
* La respuesta de la lista, vector de modalidades instanciadas.
* @see item30#GetRespuesta()
* @see index30#eqS(Vector, Vector)
* @return Vector de modos de respuesta de la lista
**/
public  static  Vector ds( lista30 l30, int i) {

  Vector KB = DS( l30);//alternativas vectoriales de la lista
  Vector ALT = new Vector();//alternativas de la componente i
  try {
    for( int j = 0; j < KB.size(); j++) {
	   Integer Alt = ((Integer)((Vector)KB.get( j)).get( i));
	   if ( ALT.indexOf( Alt ) == -1)
        ALT.add( Alt);
    }//for
  } catch (Exception e) {
      System.out.println( ERROR + "ds( ).");
      frame30.exit( 0, e);
  }//

  return ALT;
}//ds


/**
* Calcula el offset de todos los items de la lista l30. Incondicional.
* Cache desactivada. Sin cache ni flag fuerza el calculo completo de todo el offset.
* synchronized ! y static ?
* @return void
**/
private  static  lista30  CALC( lista30 l30) {

  try {
    if ( l30.checkMode)
      frame30.kbm2lTime.append( "CALC: " + l30.Name() + "\n");
    for( int i = 0; i < l30.size(); i++) {
      l30.Get( i).setOffset( new offset30( l30.Base.Dom(), l30.Inf( i), l30.Sup( i)));
    }//for
    l30.Weights = weights( l30);//
  } catch (Exception e) {
      System.out.println( ERROR + "CALC( ).");
      frame30.exit( 0, e);
  }//

  return l30;   
}//CALC

/**
* Vector de pesos o descriptor del espacio.
* @return vector de pesos
**/
private  static  Vector  weights( lista30 l30) {
//Wn = 1, Wi = Wi+1 * di+1.

  Vector WEIGHTS = new Vector();
  for( int i = 0; i < l30.ParIndice(); i++)
    WEIGHTS.add( new BigInteger( "1"));//Wn

  try {  
    for( int i = l30.ParIndice()-2; i >= 0; i--) {
      BigInteger W = ((BigInteger)(WEIGHTS.get( i+1)));
      BigInteger D = new BigInteger( ((Integer)l30.Base.Dom().get( i+1)).toString());
      WEIGHTS.set( i, new BigInteger( (W.multiply( D)).toString()));
      }//for
  } catch (Exception e) {
      System.out.println( ERROR + "weights( ).");
      frame30.exit( 0, e);
  }

  return WEIGHTS;
}//weights

/**
* Calcula el offset de todos los items de la lista l30.
* Cache activada.
* synchronized ! y static ?
* @return l30 lista30
**/
public  static  lista30  calc( lista30 l30) {

//  CALC( l30);//sin cache

  int c = 0;
  try {
    if ( l30.checkMode)
      frame30.kbm2lTime.append( "calc: " + l30.Name()+"\n");
    item30 item = null;
    for( int i = 0; i < l30.size(); i++) {
      item = l30.Get( i);
      if ( !item.Cache()) {
        item.setOffset( new offset30( l30.Base.Dom(), l30.Inf( i), l30.Sup( i)));
        c++;
        }
    }//for
  l30.Weights = weights( l30);//
  } catch (Exception e) {
      System.out.println( ERROR + "calc( ).");
      frame30.exit( 0, e);
  }

  return l30;   
}//calc 

/**
* Calcula el offset del item i del la lista l30.
* Cache activada.
* @param i posicion del item en l30.
* @return l30 lista30
**/
private  static  lista30  calc( lista30 l30, int i) {

  try {
    if (( i >= 0) && ( i < l30.size())) {
      item30 item = l30.Get( i);
      if ( !item.Cache()) {
        item.setOffset( new offset30( l30.Base.Dom(), l30.Inf( i), l30.Sup( i)));
        }
      }//if
  } catch (Exception e) {
      System.out.println( ERROR + "calc( i).");
      frame30.exit( 0, e);
  }//

  return l30;   
}//calc

/**
* Ordinal del item ms grande o general de la familia, que tiene la parte fija ms corta.
* @param l30 lista de trabajo.
* @param FAMILIA ordinales de items de respuesta igual en l30.
**/
private static int minFIX(  lista30 l30, Vector FAMILIA) {

  int f = (( Integer)( FAMILIA.get( 0))).intValue();//item f, siempre existe, la FAMILIA no es vacia;
  int minfix = f;
  try {
    for( int j = 1; j < FAMILIA.size(); j++) {
      f = (( Integer)( FAMILIA.get( j))).intValue();//item f
      if ( l30.Fij( minfix).size() > l30.Fij( f).size())
        minfix = f;
      }//for
  } catch (Exception e) {
      System.out.println( ERROR + "minFIX( ).");
      frame30.exit( 0, e);
  }//

   return minfix;        
}//minFIX      

/**
* Valores del att en la interseccion (minFIX) de partes fijas de la familia, 
* que determina la menor de todas, que tiene la parte fija ms corta.
* Si q es 0, no existe parte fija.
* @param l30 lista de trabajo.
* @param FAMILIA ordinales de items de respuesta igual en l30.
* @param att atributo de la base,
* @return VALORES del atributo a que estan en as partes fijas de todos los familiares.
**/
private static Vector valFIX( lista30 l30, Vector FAMILIA, int att) {

  int f = 0;
  item30 ITEM = null;
  int minFix = minFIX( l30, FAMILIA);
  Vector VALORES = new Vector();
  int p = l30.Base.indexOfbas( att);
  int q = l30.Fij( minFix).size();
  try {
    if ( p < q) {//es fijo
      for( int j = 0; j < FAMILIA.size(); j++) {
        f = (( Integer)( FAMILIA.get( j))).intValue();//item f
        ITEM = l30.Get( f);
        Integer V = new Integer(((Integer)((ITEM).GetIndice()).get( p)).intValue());
        if ( VALORES.indexOf( V)==-1) VALORES.add( V);
      }//for
  }//if
  } catch (Exception e) {
      System.out.println( ERROR + "ValFIX( ).");
      frame30.exit( 0, e);
  }//

  return VALORES;        
}//valFIX      

/**
* El atributo att de la base de l30 toma todos los valores de su dominio en la parte fija 
* de todos los items de una familia: es irrelevante en la respuesta familiar. 
* Puede ser relevante en otras familias.
* @param l30 lista de trabajo.
* @param FAMILIA ordinales de items de respuesta igual en l30.
* @param att atributo de la base,
**/
public static boolean nonRelevantVariable( lista30 l30, Vector FAMILIA, int att) {
  
  int valFIXsz = valFIX( l30, FAMILIA, att).size();//parte de dominio del att que se muestra en la familia 
  try {
    if ( valFIXsz == 0) return true;//no existe parte fija minima, ni valores de los atts fijos
      else  if (  valFIXsz == l30.Base.dom( l30.Base.indexOfbas( att))) {
        System.out.println( "nonRelevantVariable. att: " + att + "  Familia: " + ((Integer)FAMILIA.get( 0)).intValue());
        return true;//nonRelevant
       }
      else if (  valFIXsz < l30.Base.dom( l30.Base.indexOfbas( att)))
        return true;//Relevant?
      else if (  valFIXsz == 1)
        return false;//Relevant
      else {// (  valFIXsz > l30.Base.dom( l30.Base.indexOfbas( att))) ???
        System.out.println( ERROR + "nonRelevantVariable. att: " + att);
        System.out.println( ERROR + "indexOfbase att: " + l30.Base.indexOfbas( att));
        System.out.println( "l30.Base: " + l30.Base.Bas());
        System.out.println( "l30.Base.dom( att): " + l30.Base.dom( att));
        System.out.println( "valFIXsz: " + valFIXsz); 
        System.out.println( "valFIX: " + valFIX( l30, FAMILIA, att).toString());
        frame30.exit( 0);
        return false;            
        }//
  } catch (Exception e) {
      System.out.println( ERROR + "nonRelevantVariable( ).");
      frame30.exit( 0, e);
  }//
    
  return false;            
}//nonRelevantVariable

/**
* Atributos constantes en toda la lista, simplificacion de la explicacion.
* El esquema de referencia en base canonica, del esquema.
* @param l30 lista30 en la base del esquema.
* @return CONTANTES Vector.
**/
public static Vector constAtt( lista30 l30) {

  Vector CONSTANTES = new Vector(); // de dimensiones.

  try {

  for( int a = 0; a < l30.dimension(); a++) {//Atributos 0,1,2,...
    Vector CTE = new Vector(); 
    Integer D = null;
    int d = 0, c = 0; 

    for( int i = 0; i < l30.size(); i++) {//Items 0,1,2,...
      if ( !l30.esUNKB( l30.Get( i))) {// conocidos
        if ( a < l30.Fij( i).size()) { 
          c = ((Integer)( l30.Fij( i)).get( a)).intValue();//att
          d = ((Integer) l30.Get( i).GetIndice().get( c)).intValue();//val
          D = new Integer( d);
          if ( CTE.indexOf( D) == -1) CTE.add( D);//es constante en el item i
          }//if
          else { CTE.add( new Integer( -1)); CTE.add( new Integer( -1)); }//es variable en el item i
        }//if
      }//for i

      if ( CTE.size() == 1) 
        CONSTANTES.add( new Integer( a));//un solo valor -->> es constante en toda la lista

    }//for a

  } catch (Exception e) {
      System.out.println( ERROR + "nonRelevantVariable( ).");
      frame30.exit( 0, e);
  }//

  return CONSTANTES;
}//constantes

/**
* Actualiza el registro IMP de la base. Mejorar: amplitud del dominio y de la familia (KB). ???
**/
public  static  lista30  importanceAtt( lista30 l30) {

 try {

  //if (1==1) return l30;
  Vector ALT = listStat30.DS( l30);
  for( int a = 0; a < l30.dimension(); a++) {//primero los atts de mayor importancia
    int att = l30.Base.bas( a);
    int importance = 0;//irrelevante
    for( int i = 0; i < ALT.size(); i++) {
	   Vector S = (Vector)ALT.get( i);
      if ( !nonRelevantVariable( l30, l30.Familia( S), att)) 
        importance++;
    }//for-i
    l30.Base.imp( a, importance);
  }//for-a
  
  } catch (Exception e) {
      System.out.println( ERROR + "importanceAtt( ).");
      frame30.exit( 0, e);
  }//
  //System.out.println( "Bas "+l30.Base.Bas());
  //System.out.println( "Imp "+l30.Base.Imp());
  return l30;
}//importanceAtt

}//class listStat30
