//LISTTEST30//
package kernel;

//
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
import java.io.*;

//
import kbm2l.*;
import control.*;
import target.*;

/**
* Clase listTest30.
* Test mejora de copia a la base nueva.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  listTest30  {

  private static final String ERROR = "Error(listTest30): ";

/**
**/
  private static double paramTest = -1.0;//porcentaje, 1%-100% 

/**
**/  
  private static long timeTest = 0;//mseg

///////////////////
/**
* Constructor por defecto
**/
public listTest30( ) {

}//listTest30

/**
* Test del historico de bases en la sintesis.
**/
public lista30 bTest( lista30 l30, lista30 lTarget) {
//Base Test ***

  if ( !new controlPrefs30().baseTest()) 
    return lTarget;

  try {
	  
  if ( l30.BasesList != null) {
    for( int i = 0; i < l30.BasesList.size(); i++) {
	   base30 bl = ((base30)l30.BasesList.get( i)); 
	   if ( base30.eqB( lTarget.Base, bl)) {
        return null;
	     }//-if
      }//-for
      return lTarget;
    }//-if
  else {
  	 return lTarget;
	 }
	 
	 } catch (Exception e) {
      System.out.println( ERROR  + "bTest( l30, lTarget).1");
      frame30.exit( 0, e);
    }//catch
  
  return null;
  
}//bTest

/**
* Test de la Copia propuesta si los attributos son relevantes y 
* pierden "mucho" peso restringe la copia.
* @see lista30#Switches(long).
* @return l30, lista con los representantes.
**/
public lista30 aTest( lista30 l30, lista30 lTarget) {
//Attribute Test ***

  if ( !controlPrefs30.attributeTest()) 
    return lTarget;
  
  try {
  
  l30 = listStat30.importanceAtt( l30);//Actualiza el registro IMP de la base.
  for( int a = 0; a < l30.dimension(); a++) {//primero los atts de mayor importancia
    int att = l30.Base.bas( a);
    int aNew = lTarget.Base.Bas().indexOf( new Integer( att));
    if (( a) < ( aNew)) {//pierde peso en lTarget!!!

      if ( l30.Base.imp( a) > 0) {//es relevante!!!
          return null;// att pierde peso  
          }//if 

      }//if-a
    }//for-a

 } catch (Exception e) {
      System.out.println( ERROR  + "aTest( l30, lTarget).1");
      frame30.exit( 0, e);
    }//catch

  return lTarget;
}//aTest

/**
* Copia de casos representantes UPP de items.
* Si el Target tiene mas Switches que l30: ret null. 
* test cada 100 casos copiados
* Si se supera timeTest --> ret lTarget, con los index que haya dado tiempo a copiar.
* @see lista30#Switches(Vector,long).
* @param l30 lista original de casos.
* @param ltarget lista destinio de los casos.
* @return l30, lista con los representantes.
**/
private lista30 iTestUPP( lista30 l30, lista30 lTarget) {
//Improvement Test *** UPP

  item30 nuevoItem = null;
  item30 ITEM = null;  Vector MEDIDA = null;  Vector RESPUESTA = null;  Vector INDICE = null;  
  Vector indice = null;
  int regla = -1;
//tiempo -cp
  long tcp1 = new Date().getTime();

  for(int k = 0; k < l30.size(); k++) {// in list

    try {
      ITEM = l30.Get( k);//siempre existe.
      RESPUESTA = ITEM.GetRespuesta();

      if ( !index30.eqS( RESPUESTA, l30.MODE)) {// conocimiento
        MEDIDA = ITEM.GetMedida();
        INDICE = ITEM.GetIndice();// indice SUP
        indice = base30.Trnp( l30.Base, INDICE, lTarget.Base); // CAMBIO DE BASE
        nuevoItem = new item30( lTarget, MEDIDA, RESPUESTA, indice); // new
        regla = lTarget.Set( nuevoItem); // copy
      }//if conocimiento
      
    } catch (Exception e) {
      System.out.println( ERROR  + "itTestUPP( lTarget).1");
      frame30.exit( 0, e);
    }//catch

    if (( k % 100) == 0) {
      if ( l30.size() <= lTarget.size()) {
        return null;//rechaza
        }
      //tiempo -cp
      if ( new Date().getTime() - tcp1 > timeTest) {
        frame30.kbm2lTime.append( "iTestUPP: timeTestOut.   lTarget.size: " + 
          lTarget.size() + "   sw: " +   lTarget.Switches( lTarget.size()) + 
          "  timeTest: " + timeTest + "\n");
        break;// intenta cpl 
        }
      }//if-k

    }//for copia extremo superior de items

  if ( test( l30, lTarget)) {
    return null;//rechaza
    }

  return lTarget;//
}//iTestUPP

/**
* Copia l30.size() random index.
* Si el Target tiene mas Switches que l30: ret null. 
* test cada 100 casos copiados
* Si supera timeTest --> ret lTarget, con los index que haya dado tiempo a copiar.
* @see lista30#Switches(long).
* @param l30 lista original de casos.
* @param lTarget lista destinio de los casos.
* @return lTarget lista con los representantes.
**/
public lista30 iTestRANDOM( lista30 l30, lista30 lTarget) { 
//Improvement Test *** RANDOM

  item30 nuevoItem = null;
  item30 ITEM = null;  Vector MEDIDA = null;  Vector RESPUESTA = null;  Vector INDICE = null;
  Vector indice = null;
  int regla = -1;
//tiempo -cp
  long tcp1 = new Date().getTime();

  for(int k = 0; k < l30.size(); k++) {// in list

    INDICE = new Vector();// indice RANDOM
    try {
      for( int j = 0; j < l30.dimension(); j++) {  
        INDICE.add( new Integer( control30.gr.nextInt( l30.Base.dom(j))));
        }//for
      ITEM = l30.GET( INDICE);//siempre existe.
      RESPUESTA = ITEM.GetRespuesta();
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "iTestRANDOM().1");
      frame30.exit( 0, e);
    }//catch

    try {
      if ( !index30.eqS( RESPUESTA, l30.MODE)) {// conocimiento
        MEDIDA = ITEM.GetMedida();
        indice = base30.Trnp( l30.Base, INDICE, lTarget.Base); // CAMBIO DE BASE
        nuevoItem = new item30( lTarget, MEDIDA, RESPUESTA, indice); // new
        regla = lTarget.Set( nuevoItem); //copy !!
      }//if conocimiento
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "iTestRANDOM().2");
      frame30.exit( 0, e);
    }//catch

    if (( k % 100) == 0) {
      if ( l30.size() <= lTarget.size()) {
        return null;//rechaza
        }
      //tiempo -cp
      if ( new Date().getTime() - tcp1 > timeTest) {
        frame30.kbm2lTime.append( "iTestRANDOM: timeTestOut.   sz: " + 
          lTarget.size() + "   sw: " +   lTarget.Switches( lTarget.size()) + "  timeTest: " + timeTest + "\n");
        break;// intenta cpl 
        }
      }//if-k  

    }//for-k copia de random items

  if ( test( l30, lTarget)) {
    return null;//rechaza
    }

  return lTarget;//
}//iTestRANDOM

/**
* Copia de representantes UPP de items y random index.
* si el Target tiene mas Switches que l30: ret null.
* paramTest, timeTest, moda y switches.
* @see lista30#Switches(long).
* @return l30, lista con los representantes.
**/
public lista30 iTest( lista30 l30, lista30 lTarget) {
//Improvement Test ***

  if ( !new controlPrefs30().improvementTest()) 
    return lTarget;

  try {
	
  paramTest = (double)(new controlPrefs30( ).improvTestParam());
  timeTest = (new controlPrefs30( ).timeOutTest());

  if (( lTarget = iTestUPP( l30, lTarget)) == null) {
      return null;
      }
  else
  if (( lTarget = iTestRANDOM( l30, lTarget)) == null) {
      return null;
      }
   
   } catch (Exception e) {
      System.out.println( ERROR  + "iTest( l30, lTarget).1");
      frame30.exit( 0, e);
    }//catch

  return lTarget;//intentar cpl
}//iTest

/**
* test, true rechaza lTarget frente a l30
* Si solo hay una modalidad de respuesta el switch es 0.
**/
public  static  boolean  test( lista30 l30, lista30 lTarget) {
  
  if ( l30.MODE == null) listStat30.moda( l30); //l30.UNKB
  if ( paramTest == -1.0) 
    paramTest = (double)(new controlPrefs30( ).improvTestParam( ));
  l30.Switches( l30.size());
  lTarget.Switches( l30.switches);

  int policy = controlPrefs30.focusPolicy();//la politica del item policy. 
  long optPar = 0;
    
    if ( policy == l30.unKB) optPar = lTarget.switches;
    else if ( policy == l30.coKB) optPar = lTarget.gapsXY();
    else optPar = listStat30.kb( lTarget, lTarget.Get( policy).GetRespuesta());//opt focal
  
  if ( optPar >= ( l30.optSize( ) + 1)) return true;
    else {
      double ParamTest = (long)paramTest / (long)100;
      if ( lTarget.switches >= ((long)l30.switches * ParamTest + 1)) return true;
      }
   return ( lTarget.switches >= ( l30.switches + 1)); 
}//test

}//class listTest30
