//LISTUNION30//
package kernel;

//
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
import java.io.*;

//
import kbm2l.*;
import target.*;
import control.*;

/**
* Clase listUnion30. Procedimiento de transposicion de listas,
* union de listas en bases diferentes. Aprendizaje.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  listUnion30  extends  frame30  {

  private static final String ERROR = "Error(listUnion30): ";

/**
* Constructor por defecto 
**/
public listUnion30( ) {
//

}//listUnion30

/**
* Aade conocimiento de b30 en a30. 
* La union es caso a caso ignorando la moda de b30.
* @param a30 lista30.
* @param b30 lista30.
* @return a30 lista30. 
**/
public lista30 union_rl( lista30 a30, lista30 b30) {

  return union( b30.UNKB, a30, b30);//forzar la moda.
}//union_rl  
  
/**
* Aade conocimiento de a30 en b30 .
* La union es caso a caso ignorando la moda de a30.
* @param a30 lista30.
* @param b30 lista30.
* @return b30 list30. 
**/
public lista30 union_lr( lista30 a30, lista30 b30) {

  return union( a30.UNKB, b30, a30);//forzar la moda.
}//union_lr  

/**
* Aade conocimiento de a30 en b30. 
* La union es item a item conocido.
* @param a30 lista30.
* @param b30 lista30.
* @return a30 lista30. 
**/
public lista30 UNION_rl( lista30 a30, lista30 b30) {

  return UNION( a30, b30);  
}//UNION_rl  
  
/**
* Aade conocimiento de b30 en a30 .
* La union es item a item conocido.
* @param a30 lista30.
* @param b30 lista30.
* @return b30 list30. 
**/
public lista30 UNION_lr( lista30 a30, lista30 b30) {

  return UNION( b30, a30);  
}//UNION_lr  

/**
* UNION en bloque, en la misma base !!
* insertando todos items en bloque si
* las dos listas estan en la misma base !!.
**/  
private lista30 UNION( lista30 l30, lista30 lNew30) {  
 
  System.out.println( "union-block");

  if ( !base30.eqB( l30.Base, lNew30.Base)) {
    System.out.println( ERROR + "UNION -BLOCK: Bases are not equal.");
    frame30.exit( 0);         
	  }
    
  //es una suma de casos. verificacin...  
  long l30KB = listStat30.KB( l30).longValue();  
  long lNew30KB = listStat30.KB( lNew30).longValue();  

  try {

  if (( index30.eqS( lNew30.Get( 0).GetRespuesta(), lNew30.UNKB)) && 
      ( index30.eqS( lNew30.Get( lNew30.size()-1).GetRespuesta(), lNew30.UNKB))) {//bloque interior
      
      int XI = -1;//el indice de l30 donde enganchar lNew30
      Vector INDICE0 = lNew30.Get( 0).GetIndice();
      Vector INDICE2 = lNew30.Get( lNew30.size()-1).GetIndice();
      for( int i = 0; i < l30.size(); i++) {
        Vector INDICE = l30.Get( i).GetIndice();
        if ( l30.esUNKB( l30.Get( i)))
          if (( index30.myT( INDICE, INDICE0)) && 
              ( index30.myT( INDICE, INDICE2))) {
            XI = i; break;
            }//if
        }//for  

    if ( XI == -1) {
      System.out.println( "union-block-+++int");
      return union( listStat30.moda( l30), l30, lNew30); //by cases
      } else { //by items
      System.out.println( "union-block-***int");
      for( int k = 0; k < lNew30.size()-1; k++) { // in list
        l30.add( XI+k, lNew30.Get( k));
        }//for
      }  
    }//if
    else {
      System.out.println( "union-block-ext");
      return union( listStat30.moda( l30), l30, lNew30);//no bloque interior 
    }//if

    if (( l30KB + lNew30KB) != listStat30.KB(l30).longValue()) {
      System.out.println( ERROR + "Total iniKB: " + (l30KB + lNew30KB));
      System.out.println( ERROR + "Total endKB: " + listStat30.KB(l30));
      frame30.exit( 0);    
      }//if

    listStat30.calc( l30);
    checkList30.chk( l30, "union-l30.");
//    listStat30.importanceAtt( lNew30);//
    f30.kbm2lSystem.estatus( "union: (end) " + l30.Name() + "  U  " + lNew30.Name());
    return l30;
  } catch (Exception e) {
    System.out.println( ERROR + "union-2.block");
    frame30.exit( 0);
  }//catch

  System.out.println( ERROR + "union-3.block");
  System.exit( 0);
  return null;
}//UNION

/**
* Aade conocimiento de lNew30 en l30 (sin items desconocidos delNew30).
* Permite uniones parciales. Insercion de casos. La base puede ser diferente.
* l30 lista destino de los casos nuevos !!
* @return lNew30 casos originales y nuevos 
**/
private lista30 union( Vector MODA, lista30 l30, lista30 lNew30) {

  try {
    checkList30.chk( l30, "union-l30."); checkList30.chk( lNew30, "union-LNew30.");
    if ( !new eqKBM2L30( ).compatible( l30, lNew30) || !new eqKBM2L30( ).compatible( lNew30, l30)) {
       System.out.println( ERROR + "union-no-compatible.");
       frame30.exit( 0);         
       }
  } catch (Exception e) {
    System.out.println( ERROR + "union-0.");
    frame30.exit( 0, e);
  }//catch

//CERO
  try {
    if ( !index30.eqS( lNew30.Get( 0).GetRespuesta(), MODA)) {
      f30.kbm2lSystem.estatus(
        "union: (0) cases.size: " + lNew30.Get( 0).getLongitud() + 
        "   lNew30: " + (lNew30.size() - 0) + 
        "   l30.size(): " + l30.size());
      Vector INDICE0 = index30.primeroT( lNew30.Base.Dom());  
      new itemCopy30().union( l30, lNew30, INDICE0, lNew30.Get( 0));// el item 0!
      }//if
  } catch (Exception e) {
    System.out.println( ERROR + "union-1.");
    frame30.exit( 0, e);
  }//catch

//RESTO k-items
  try {
  for( int k = 1; k < lNew30.size(); k++) { // in list
    if ( !index30.eqS( lNew30.Get( k).GetRespuesta(), MODA)) {
      f30.kbm2lSystem.estatus(
        "union: (k) cases.size: " + lNew30.Get( k).getLongitud() + 
        "   lNew30: " + (lNew30.size() - k) + 
        "   l30.size(): " + l30.size());
      Vector INDICE0 = index30.siguienteT( lNew30.Base.Dom(), lNew30.Get( k-1).GetIndice());  
      new itemCopy30().union( l30, lNew30, INDICE0, lNew30.Get( k));//los items 1,2,3,4....
      }//if
    }//for
  } catch (Exception e) {
    System.out.println( ERROR + "union-2.");
    frame30.exit( 0, e);
  }//catch

  try {
    checkList30.chk( l30, "union-l30.");
    checkList30.chk( lNew30, "union-lNew30.");
//    listStat30.importanceAtt( l30);//
    f30.kbm2lSystem.estatus(
      "union: (end) " + l30.Name() + "  U  "+ lNew30.Name() + 
      ". MODE: " + MODA.toString());
    return l30;//!!!
  } catch (Exception e) {
    System.out.println( ERROR + "union-3.");
    frame30.exit( 0, e);
  }//catch

  System.out.println( ERROR + "union-4.");
  frame30.exit( 0);
  return null;
}//union

}//class listUnion30