//LISTA30//
package kernel;

//
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import control.*;
import schema.*;
import target.*;
import kbm2l.*;
import tools.*;
import tables.*;
import target.*;

/**
* Clase lista30,
* es una kbm2l30 con el listManager30 para gestionar casos
* y listCopy30 para transformar las coordenadas y optimizar.
* @see listManager30
* @see listCopy30
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  lista30  extends  kbm2l30  {

//constantes
  private static final String ERROR = "Error(lista30): ";
  private listManager30 m30 = null;//Set && SET casos
  private listCopy30 lc30 = null;//cpl listas
  protected boolean chk = false;//Check List
 
/**
* Historia de las bases en sintesis.
* Se construye si se cambia de base al generar la lTarget.
**/
  public Vector BasesList = null;
  
/**
* numero de dimensiones parametros de una ekbm2l
**/
  public int dimparam = -1; 
/**
* modelo de referencia para AS en un ekbm2l
**/
  public Vector PARAMS = null;

///////////////////
/**
* Constructor por defecto.
**/
public lista30( ) {
//

  Name( "KBM2L-default");
  ParMedida( 0);
  ParRespuesta( 0);
  ParIndice( 0);
  UNKB =  null;
  COKB =  null;
  RSKB =  null;
  RRKB =  null;
  Base =  new base30( 0, 0, null, null, null);// Dom = null; Base = null;// Rol = null;
  Esqu =  new esquema30( this.Name(), this.ParIndice(), this.ParRespuesta());//por defecto.
  lkbm =  null;
  limitCases = 0;
  limitItems = 0;
  Weights = null;
  controlKB = null;
  MODE = null;
  lastRULE = -1;
  reglas = null;
  m30 = null;
  lc30 = null;
  BasesList = null;
  RangoHr = null;
  dimparam = -1;
  PARAMS = null;
  chk = new controlPrefs30().checkMode();

}//lista30

//////////////////////////////
/**
* Constructor copia de estructura, lista vacia unKB(-1).
* Crea un target compatible en un cambio de base 
**/
public lista30( lista30 l30) {
//copia, solo copia la estructura

  try {
  Name( new String( l30.Name()));
  ParMedida( l30.ParMedida());//dimenR-medida
  ParRespuesta( l30.ParRespuesta());//dimenS-respuesta
  ParIndice( l30.ParIndice());//dimenI-indice
  UNKB =    index30.unRespuesta( ParRespuesta());
  COKB =    index30.coRespuesta( ParRespuesta());
  RSKB =    index30.rsRespuesta( ParRespuesta());
  RRKB =    index30.rrRespuesta( ParRespuesta());
  Base =    new base30( l30.Base);//copia.
  Esqu =    new esquema30( l30.Esqu);//copia.
  lkbm =    ini();//<Indice-ultimo,unKB,unKB|
  limitCases = new controlPrefs30().KBCasesLengthOVF();
  limitItems = new controlPrefs30().itemLengthOVF();
  Weights = listStat30.getWeights( this);
  controlKB = new BigInteger( new String( "0"));
  MODE = UNKB;
  lastRULE = -1;
  reglas = new Vector();//todas las reglas
  m30 =    new listManager30( );
  lc30 =   new listCopy30( );
  BasesList = l30.BasesList;//
  RangoHr = l30.RangoHr;
  dimparam = l30.dimparam;
  PARAMS = l30.PARAMS;//
  chk = new controlPrefs30().checkMode();

  }//try
  catch (Exception e) {
    frame30.kbm2lSystem.append( ERROR + "lista30.1\n");
    frame30.exit( 0, e);
  }//catch
  
  checkList30.chk( this, "lista30.1");//checks
}//lista30

//////////////////////////////
/**
* Constructor copia de estructura y contenido, compatibles. 
* @param el30 estructura
* @param cl30 contenido
**/
public lista30( lista30 el30, lista30 cl30) {
//copia, copia la estructura y el contenido

  try {
  if ( !base30.eqB( el30.Base, cl30.Base)) {
      System.out.println( ERROR + "lista30(el30,cl30)");
      frame30.exit( 0, new Exception());
  }//
 
  Name( new String( el30.Name()));

  String name = null;
    if ( el30.Name().indexOf( "(") == -1)
      Name( new String( el30.Name())+"(1)");
      else {
        name = new String( el30.Name());
        int n = Integer.parseInt( 
          name.substring( name.indexOf('(')+1, name.indexOf(')')));
        name = name.substring( 0, name.indexOf('(')+1);
        n++;
        name = name + (n) + ")";
        Name( new String( name));
        }
  
  try {
  ParMedida( el30.ParMedida());//dimenR-medida
  ParRespuesta( el30.ParRespuesta());//dimenS-respuesta
  ParIndice( el30.ParIndice());//dimenI-indice
  UNKB =  index30.unRespuesta( ParRespuesta());
  COKB =  index30.coRespuesta( ParRespuesta());
  RSKB =  index30.rsRespuesta( ParRespuesta());
  RRKB =    index30.rrRespuesta( ParRespuesta());
  Base =  new base30( el30.Base);//copia.
  Esqu = new esquema30( el30.Esqu);//copia.
  lkbm = new Vector();
  limitCases = new controlPrefs30().KBCasesLengthOVF();
  limitItems = new controlPrefs30().itemLengthOVF();

  } catch (Exception e) {
    System.out.println( ERROR + "lista30(el30. cl30).2*");
    frame30.exit( -1000, e);
  }//catch

  try {
  for( int i = 0; i < cl30.lkbm.size(); i++)
    lkbm.add( new item30( cl30,
      cl30.Get( i).GetMedida(), 
      cl30.Get( i).GetRespuesta(), 
      cl30.Get( i).GetIndice()));

  } catch (Exception e) {
    System.out.println( ERROR + "lista30(el30. cl30).2**");
    frame30.exit( -1000, e);
  }//catch

  Weights = listStat30.getWeights( this);
  controlKB = new BigInteger( new String( "0"));
  MODE = UNKB;
  lastRULE = -1;
  reglas = new Vector();//todas las reglas
  m30 = new listManager30( );
  lc30 = new listCopy30( );
  BasesList = cl30.BasesList;
  RangoHr = cl30.RangoHr;
  dimparam = el30.dimparam;
  PARAMS = el30.PARAMS;
  
  }//try
  catch (Exception e) {
    frame30.kbm2lSystem.append( ERROR + "lista30.2\n");
    frame30.exit( 0, e);
  }//catch
  chk = new controlPrefs30().checkMode();

  checkList30.chk( this, "lista30.2");//checks
}//lista30

//////////////////////////////
/**
* Constructor copia de estructura, lista vacia unKB(-1)
* fija una base especial, por ejemplo, la base operativa 
* para una consulta abierta.
**/
public lista30( lista30 l30, Vector openIndex) {
//copia, solo copia la estructura

  Name( new String( l30.Name())+"-opb-");
  ParMedida( l30.ParMedida());//dimenR-medida
  ParRespuesta( l30.ParRespuesta());//dimenS-respuesta
  ParIndice( l30.ParIndice());//dimenI-indice
  UNKB =  index30.unRespuesta( ParRespuesta());
  COKB =  index30.coRespuesta( ParRespuesta());
  RSKB =  index30.rsRespuesta( ParRespuesta());
  RRKB =    index30.rrRespuesta( ParRespuesta());
  Base =  new base30( l30.Base);
  Esqu = new esquema30( l30.Esqu);//por defecto.

  try {
////  
//Base Operativa segun openIndex
  Vector indice = index30.cpT( openIndex);
  int j = ParIndice();
  for( int i = 0; i <= j-1; i++) {
    if (((Integer)indice.get( i)).intValue() == -1) {
//Base
     Base.add( Base.dom( i), Base.bas( i), Base.rol( i));
     Base.remove( i); 
//indice
      int i0 = ((Integer)indice.get( i)).intValue();
      indice.add( new Integer( i0));indice.remove( i);
      j--;
      i--;
    }//if
  }//for
 // System.out.println(indice);
////  
  } catch (Exception e) {
    System.out.println( ERROR + "lista30( l30, openIndex).");
    frame30.exit( -1000, e);
  }//catch

  lkbm = ini();//<Indice-ultimo,unKB,unKB|
  limitCases = new controlPrefs30().KBCasesLengthOVF();
  limitItems = new controlPrefs30().itemLengthOVF();
  Weights = listStat30.getWeights( this);
  controlKB = new BigInteger( new String( "0"));
  MODE = UNKB;
  lastRULE = -1;
  reglas = new Vector();//todas las reglas
  m30 = new listManager30( );
  lc30 = new listCopy30( );
  BasesList = l30.BasesList;
  RangoHr = l30.RangoHr;
  dimparam = -1;
  PARAMS = null;
  chk = new controlPrefs30().checkMode();
  
  checkList30.chk( this, "lista30.3");//checks
}//lista30

///////////////////////////////////////////////////////////////////////////////
/**
* Constructor principal, tabla -> lista, estructura con la lista vacia unKB(-1) 
**/
public lista30( String idLista30, int R, int S, base30 B) {
//tabla, hkb, txt

  if ( idLista30 == null) {
    System.out.println( ERROR +"idLista30 null");
    frame30.exit( -1000);
    }//if
  Name( new String( idLista30));

  if ( B.size() < 1) {
    System.out.println( ERROR +"B" + B.size() + "< 1");
    frame30.exit( -1000);
  }//if

  if ( S < 1) {
    System.out.println( ERROR +"S" + S + "<1.");
    frame30.exit( -1000);
  }//if

  ParMedida( R);//dimenR-medida
  ParRespuesta( S);//dimenS-respuesta
  ParIndice( B.size());//dimenI-indice

  UNKB =  index30.unRespuesta( ParRespuesta());
  COKB =  index30.coRespuesta( ParRespuesta());
  RSKB =  index30.rsRespuesta( ParRespuesta());
  RRKB =    index30.rrRespuesta( ParRespuesta());
  Base =  new base30( B);
  Esqu = new esquema30( this);//por defecto.
  lkbm = ini();//<Indice-ultimo,unKB,unKB|
  limitCases = new controlPrefs30().KBCasesLengthOVF();
  limitItems = new controlPrefs30().itemLengthOVF();
  Weights = listStat30.getWeights( this);
  controlKB = new BigInteger( new String( "0"));
  MODE = UNKB;
  lastRULE = -1;
  reglas = new Vector();//todas las reglas
  m30 = new listManager30( ); 
  lc30 = new listCopy30( );
  BasesList = BasesListReset( );
  RangoHr = null;
  RangoHr = null;
  dimparam = -1;
  PARAMS = null;
  chk = new controlPrefs30().checkMode();

  checkList30.chk( this, "lista30.4");//checks
}//lista30

/////////////////////////////////////////////////////////////////
/**
* Constructor especial para modelos 
* @param  idLista30
* @param  R dimension de medida
* @param  S dimension de respuesta
* @param  T dimension de indice
* @param  MaxD Cardinal de dominio de todos los atributos del indice
**/
public lista30( String idLista30, int R, int S, int T, int MaxD) {
//modelo

  if ( idLista30 == null) {
    System.out.println( ERROR +"idlista30 null");
    new Exception().printStackTrace();    
    frame30.exit( -1000);
    }//if
  Name( new String( idLista30));

  if ( S < 1) {
    System.out.println( ERROR +"S" + S + "<1.");
    new Exception().printStackTrace();    
    frame30.exit( -1000);
  }//if

  ParMedida( R);//dimenR-medida
  ParRespuesta( S);//dimenS-respuesta
  ParIndice( T);//dimenI-indice
  UNKB =  index30.unRespuesta( ParRespuesta());
  COKB =  index30.coRespuesta( ParRespuesta());
  RSKB =  index30.rsRespuesta( ParRespuesta());
  RRKB =    index30.rrRespuesta( ParRespuesta());
  Base = new base30( T, MaxD, null, null, null);//homogeneo //canonica //-1
  Esqu = new esquema30( this);//por defecto.
  lkbm = ini();//<Indice-ultimo,unKB,unKB|
  limitCases = new controlPrefs30().KBCasesLengthOVF();
  limitItems = new controlPrefs30().itemLengthOVF();
  Weights = listStat30.getWeights( this);
  controlKB = new BigInteger( new String( "0"));
  MODE = UNKB;
  lastRULE = -1;
  reglas = new Vector();//todas las reglas
  m30 = new listManager30( ); 
  lc30 = new listCopy30( );
  BasesList = BasesListReset( );
  RangoHr = null;
  dimparam = -1;
  PARAMS = null;
  chk = new controlPrefs30().checkMode();

  checkList30.chk( this, "lista30.5");//checks
}//lista30

////////////////////////////////
/**
* Constructor especial, lista vacia unKB(-1) con la estructura del esquema.
* Inicializacion estandar. 1 s t.
* @param  eq30  esquema de relacion(tabla).
**/
public lista30( esquema30 eq30) {
//eq,itd,tdu

  try {
  if (eq30.nombre == null) {
    System.out.println( ERROR + "lista30(esquema30).0");
    frame30.exit( -1000, new Exception());
    }
  Name( new String( eq30.nombre));
  
  if (eq30.numDecisiones < 1) {
    System.out.println( ERROR + "lista30(esquema30).1");
    frame30.exit( -1000, new Exception());
    }

  ParMedida( eq30.numDecisiones/*r_default*/);//dimenR-medida-multidim       
//  ParMedida( 1/*r_default*/);//dimenR-medida-unidim       
  ParRespuesta( eq30.numDecisiones);//dimenS-respuesta  
  if (eq30.numAtributos < 1) {
    System.out.println( ERROR + "lista30(esquema30).2");
    new Exception().printStackTrace();    
    frame30.exit( -1000);
    }
  ParIndice( eq30.numAtributos);//dimenI-indice  
  UNKB =  index30.unRespuesta( ParRespuesta());//respuesta desconocida
  COKB =  index30.coRespuesta( ParRespuesta());//respuesta restringida
  RSKB =  index30.rsRespuesta( ParRespuesta());//respuesta sensible
  RRKB =  index30.rrRespuesta( ParRespuesta());//respuesta de referencia
  Base = new base30( eq30.numAtributos, 0, eq30.CDAtributos, null, null);//base canonica-esquema
  Esqu = new esquema30( eq30);//!!!.
  lkbm = ini();//<Indice-ultimo,unKB,unKB|
  limitCases = new controlPrefs30().KBCasesLengthOVF();
  limitItems = new controlPrefs30().itemLengthOVF();
  Weights = listStat30.getWeights( this);//vector de pesos
  controlKB = new BigInteger( new String( "0"));//conocimiento 0.
  MODE = UNKB;
  lastRULE = -1;
  reglas = new Vector();//todas las reglas de gestion que se usan sobre la lista
  m30 = new listManager30( );//gestor. 
  lc30 = new listCopy30( );//sistema de copia-tansposicion.
  BasesList = BasesListReset( );//historico.  
  RangoHr = null;
  dimparam = -1;//dimension de parametros del modelo mas baja
  PARAMS = null;//valores de referencia de los parametros, PARAMS.size()=dimparam+1
  } catch (Exception e) {
    System.out.println( ERROR + "lista30(esquema30).");
    frame30.exit( -1000, e);
  }//catch
  chk = new controlPrefs30().checkMode();

  checkList30.chk( this, "lista30.6");//checks
}//lista30

//// listManager30

/**
* Set un item(caso), simple.
* @see listManager30
**/
public int Set( item30 item) {

  return m30.Set( this, item);
}//Set

/**
* Numero de llamadas a Set en el manager30
* @see listManager30
**/
public long counterSet( ) {

  return m30.counterSet;
}//counterSet

/**
* SET un item(casos), compuesto.
* @see listManager30
**/
public long SET( item30 item) {

  return m30.SET( this, item);
}//SET

/**
* SET un item(casos), compuesto.
* @see listManager30
**/
public long SET( int i, item30 item) {

  return m30.SET( this, i, item);
}//SET

/**
* Elimina el item(casos) de la posicion i.
* @see listManager30#REMOVE(lista30,int).
* @param  i  posicion del item en las lista antes de ser eliminado.
**/
public BigInteger REMOVE( int i) {

  return m30.REMOVE( this, i);
}//REMOVE

//// listCopy30

/**
* cpl: copia o transformacion de coordenadas, base, de la lista.
* La lista objeto y la lista destino son equivalentes y compatibles. tiempo.
* @see listCopy30#cpl(lista30,lista30).
* @param lTarget destino del contenido de la lista objeto, en general, en otra base.
* @return lista30 copia. Si la lista copia es menos eficiente que la inicial, null.
**/
public lista30 cpl( lista30 lTarget) {

  if ( lTarget == null) {
    frame30.kbm2lSystem.append( ERROR + "cpl: lTarget==null\n");
    frame30.exit( 0);
  }

  try {
//tiempo -cp
  long tcp1 = new Date().getTime();
  lTarget = lc30.cpl( this, lTarget);
  if ( checkMode) {
    if ( lTarget != null) return listStat30.calc( lTarget);
    frame30.kbm2lTime.append( "cpl:" + (new Date().getTime() - tcp1) + 
      "   " + (new Date().getTime() - frame30.TCP1) + "\n" );
    }  
//tiempo cp-
  } catch (Exception e) {
    frame30.kbm2lSystem.append( ERROR + "cpl.\n");
    frame30.exit( 0, e);
  }//catch
  
  return lTarget;
}//cpl

/**
* cpLOW copia casos LOW de la lista.
* @see listPartialCopy30#cpLOW(lista30,lista30).
**/
public lista30 cpLOW( lista30 lTarget) {

  if ( lTarget == null) {
    frame30.kbm2lSystem.append( ERROR + "cpLOW: lTarget==null\n");
    frame30.exit( 0);
  }

  try {
//tiempo -cp
  long tcp1 = new Date().getTime();
  lTarget = new listPartialCopy30( ).cpLOW( this, lTarget);
  if ( checkMode) {
    if ( lTarget != null) return listStat30.calc( lTarget);
    frame30.kbm2lTime.append( "cpLOW:" + (new Date().getTime()-tcp1) + 
        "   " + (new Date().getTime() - frame30.TCP1) + "\n" );
    }    
//tiempo cp-
  } catch (Exception e) {
    frame30.kbm2lSystem.append( ERROR + "cpLOW.\n");
    frame30.exit( 0, e);
  }//catch

  return lTarget;
}//cpLOW

/**
* cpUPP copia casos UPP de la lista.
* @see listPartialCopy30#cpUPP(lista30,lista30).
**/
public lista30 cpUPP( lista30 lTarget) {

  if ( lTarget == null) {
    frame30.kbm2lSystem.append( ERROR + "cpUPP: lTarget==null\n");
    frame30.exit( 0);
  }

  try {
//tiempo -cp
  long tcp1 = new Date().getTime();
  lTarget = new listPartialCopy30( ).cpUPP( this, lTarget);
  if ( checkMode) {
    if ( lTarget != null) return listStat30.calc( lTarget);
    frame30.kbm2lTime.append( "cpUPP:" + (new Date().getTime()-tcp1) + 
      "   " + (new Date().getTime() - frame30.TCP1) + "\n" );
    }  
//tiempo cp-
  } catch (Exception e) {
    frame30.kbm2lSystem.append( ERROR + "cpUPP.\n");
    frame30.exit( 0, e);
  }//catch

  return lTarget;
}//cpUPP

/**
* cplLOWUPP copia casos LOW y UPP de la lista.
* @see listPartialCopy30#cpLOWUPP(lista30,lista30).
**/
public lista30 cpLOWUPP( lista30 lTarget) {

  if ( lTarget == null) {
    frame30.kbm2lSystem.append( ERROR + "cpLOWUPP: lTarget==null\n");
    frame30.exit( 0);
  }

  try {
//tiempo -cp
  long tcp1 = new Date().getTime();
  lTarget = new listPartialCopy30( ).cpLOWUPP( this, lTarget);
  if ( checkMode) {
    if ( lTarget != null) return listStat30.calc( lTarget);
    frame30.kbm2lTime.append( "cpLOWUPP:" + (new Date().getTime()-tcp1) + 
      "   " + (new Date().getTime() - frame30.TCP1) + "\n" );
    }  
//tiempo cp-
  } catch (Exception e) {
    frame30.kbm2lSystem.append( ERROR + "cpLOWUPP.\n");
    frame30.exit( 0, e);
  }//catch

  return lTarget;
}//cpLOWUPP

/**
* No se comprueban los duplicados. max.size 2100
**/
public Vector BasesListHistory( lista30 lTarget, String msg) {

  try {
	  
  if ( this.BasesList == null) {
    this.BasesListReset();////
    }//

  if ( this.BasesList.size() > this.Base.xComplex())
    for( int i = 0; i < this.Base.xComplex()/10; i++) 
      if ( this.BasesList.size() > 2) this.BasesList.remove( 1);//-100  
    
  this.BasesList.add( new base30( lTarget.Base));
  
  } catch (Exception e) {
      frame30.kbm2lSystem.append( ERROR + "BasesListHistory.\n");
      frame30.exit( 0, e);
    }//catch
  
  return this.BasesList;
}//BasesListHistory

/**
* Inicia la historia de bases de la lista
**/
public Vector BasesListReset( ) {

  this.BasesList = new Vector();////
  this.BasesList.add( new base30( this.Base));
  frame30.kbm2lSystem.append( "BasesListReset: " + this.Name() + ".\n");

  return this.BasesList;
}//BasesListReset

/**
* bTest sobre el historico de las lTarget.
* @see listTest30#bTest(lista30,lista30).
**/
public lista30 bTest( lista30 lTarget) {

  try {
    if ( controlPrefs30.baseTest()) 
      lTarget = new listTest30().bTest( this, lTarget); 
    } catch (Exception e) {
      frame30.kbm2lSystem.append( ERROR + "bTest.\n");
      frame30.exit( 0, e);
    }//catch
    
  return lTarget;
}//bTest

/**
* aTest sobre lTarget.
* @see listTest30#aTest(lista30,lista30).
**/
public lista30 aTest( lista30 lTarget) {

  if ( lTarget == null) {
    frame30.kbm2lSystem.append( ERROR + "aTest: lTarget==null\n");
    frame30.exit( 0);
  }
    
  try {
//tiempo -cp
  long tcp1 = new Date().getTime();
  if ( controlPrefs30.attributeTest()) {
    lTarget = new listTest30().aTest( this, lTarget); 
    if ( lTarget != null) {
      if ( checkMode)
        frame30.kbm2lTime.append( "aTest(+):" + (new Date().getTime()-tcp1) + 
          "   " + (new Date().getTime() - frame30.TCP1) + "\n" );
          return lTarget;
          }
  if ( checkMode)
      frame30.kbm2lTime.append( "aTest(-):" + (new Date().getTime()-tcp1) + 
        "   " + (new Date().getTime() - frame30.TCP1) + "\n" );
    } else {
  if ( checkMode)
    frame30.kbm2lTime.append( "aTest( ):" + (new Date().getTime()-tcp1) + 
      "   " + (new Date().getTime() - frame30.TCP1) + "\n" );
      return lTarget;// no aTest
      }
//tiempo cp-
    } catch (Exception e) {
      frame30.kbm2lSystem.append( ERROR + "aTest.\n");
      frame30.exit( 0, e);
    }//catch
    
  return null;  
}//aTest

/**
* iTest sobre lTarget.
* @see listTest30#iTest(lista30,lista30).
**/
public lista30 iTest( lista30 lTarget) {

  if ( lTarget == null) {
    frame30.kbm2lSystem.append( ERROR + "iTest: lTarget==null");
    frame30.exit( -1);
  }
    
  if ( checkMode)
    frame30.kbm2lTime.append( "iTest: " + lTarget.Base.Bas() + 
      "  G: " + metrica30.G( Base, lTarget.Base) + "\n");

  try {
    if ( controlPrefs30.improvementTest()) 
      lTarget = new listTest30().iTest( this, lTarget); 
  if ( lTarget != null) {
    frame30.kbm2lSystem.append( "  OK.  target.size: " + lTarget.size() + 
           ".  target.sw:   " + lTarget.switches +   
           ".  target.xy:   " + lTarget.gapsXY() + "\n" + 
           lTarget.Base.Bas().toString() + "\n"); 
    }
    } catch (Exception e) {
      System.out.println( ERROR + "iTest.");
      frame30.exit( 0, e);
    }//catch
    
    return lTarget;
}//iTest

/**
* Union de contenidos la lista y una nueva lista en la base de la lista.
* @param lNew30 lista resultado a la que se aade el contenido de la lista de trabajo this
**/
public lista30 union( lista30 lNew30) {

//tiempo -cp
  long tcp1 = new Date().getTime();  
  listStat30.calc( this);
  listStat30.calc( lNew30);
  double KB = listStat30.KB( this).doubleValue();
  double newKB = listStat30.KB( lNew30).doubleValue();
  lista30 l30 = null;

    if ( base30.eqB( Base, lNew30.Base)) {//la misma base, for items
      if ( KB >= newKB)
        { l30 = new listUnion30().union_rl( this, lNew30);
//          l30 = new listUnion30().UNION_rl( this, lNew30); 
          System.out.println("u1.  KB: " + KB + "  newKB: " + newKB);
          }//union 
        else { l30 = new listUnion30().union_lr( this, lNew30); 
//               l30 = new listUnion30().UNION_lr( this, lNew30); 
               System.out.println("u2.  KB: " + KB + "  newKB: " + newKB);
               }//union
      }// con bases distintas, FOR cases
      else if ( KB >= newKB)
        { l30 = new listUnion30().union_rl( this, lNew30); 
          System.out.println("u3.  KB: " + KB + "  newKB: " + newKB);
          }//union
        else { l30 = new listUnion30().union_lr( this, lNew30); 
               System.out.println("u4.  KB: " + KB + "  newKB: " + newKB);
               }//union

  if ( controlPrefs30.checkMode())
    frame30.kbm2lTime.append( "union:" + (new Date().getTime()-tcp1) + 
    "   absTime: " + (new Date().getTime() - frame30.TCP1) + "\n" );
//tiempo cp-
  return l30;  
}//union

//// lista30

/**
* Vacia el contenido de una lista unKB(-1), sin conocimiento.
**/
public Vector ini() {

  Vector R = new Vector();
  Vector S = new Vector();
  Vector T = new Vector(); 
  
  try {
  if ( this.UNKB == null) {
    System.out.println( ERROR + "ini: UNKB==null"); frame30.exit( 0);
  }
  
  S = index30.cpS( this.UNKB);
  if ( S == null) {
    System.out.println( ERROR + "ini: S==null"); frame30.exit( 0);
  }

  for(int i = 0; i < ParMedida(); i++)
    R.add( new Double((double)this.unKB));
  if ( R == null) {
    System.out.println( ERROR + "ini: R==null"); frame30.exit( 0);
  }
  
  if ( this.Base == null) {
    System.out.println( ERROR + "ini: Base==null"); frame30.exit( 0);
  }
  
  T = index30.ultimoT( this.Base.Dom());
  if ( T == null) {
    System.out.println( ERROR + "ini: T==null"); frame30.exit( 0);
  }
  
  UNKB =  index30.unRespuesta( ParRespuesta());//respuesta desconocida
  COKB =  index30.coRespuesta( ParRespuesta());//respuesta restringida
  RSKB =  index30.rsRespuesta( ParRespuesta());
  RRKB =  index30.rrRespuesta( ParRespuesta());

  } catch (Exception e) {
      System.out.println( ERROR + "ini.1");
      frame30.exit( 0, e);
    }//catch

  try {
  item30 item = new item30( this, R, S, T);
  if ( item == null)   {
    System.out.println( ERROR + "ini-item: s=" + ParRespuesta()); frame30.exit( 0);
  }

  lkbm = new Vector();
  lkbm.add( item);//<I-ultimo,unKB,unKB|

  if ( lkbm == null) {
    System.out.println( ERROR + "ini: lkbm==null"); frame30.exit( 0);
  }

  } catch (Exception e) {
      System.out.println( ERROR + "ini.2");
      frame30.exit( 0, e);
    }//catch

  listStat30.calc( this);
  checkList30.chk( this, "ini");
  return lkbm;
}//ini

/**
* Vacia el contenido de una lista unKB(-1), imposible.
**/
public Vector ini( Vector defRespuesta) {

  if ( defRespuesta.size() != ParRespuesta()) {
    System.out.println( ERROR + "ini-defRespuesta: s=" + ParRespuesta()); frame30.exit( 0);
  }
  
  UNKB =  index30.unRespuesta( ParRespuesta());//respuesta desconocida
  COKB =  index30.coRespuesta( ParRespuesta());//respuesta restringida
  RSKB =  index30.rsRespuesta( ParRespuesta());
  RRKB =    index30.rrRespuesta( ParRespuesta());

  Vector defMedida = new Vector();
  defMedida.add( new Double( -2.0));

  item30 item = new item30( this, defMedida, 
                                  defRespuesta, 
                                  index30.ultimoT( this.Base.Dom()));

  lkbm = new Vector();
  lkbm.add( item);//<I-ultimo, defRespuesta, defMedida|

  listStat30.calc( this);
  checkList30.chk( this, "ini-coKB");
  return lkbm;
}//ini

/**
* Vacia el contenido de una lista con valores de medida y respuesta por defecto
**/
public Vector ini( Vector defMedida, Vector defRespuesta) {

  if ( defRespuesta.size() != ParRespuesta()) {
    System.out.println( ERROR + "ini-defRespuesta: s=" + ParRespuesta()); frame30.exit( 0);
  }
  
  if ( defMedida.size() != ParMedida()) {
    System.out.println( ERROR + "ini-defMedida: r=" + ParMedida()); frame30.exit( 0);
  }
  
  UNKB =  index30.unRespuesta( ParRespuesta());//respuesta desconocida
  COKB =  index30.coRespuesta( ParRespuesta());//respuesta restringida
  RSKB =  index30.rsRespuesta( ParRespuesta());
  RRKB =    index30.rrRespuesta( ParRespuesta());

  item30 item = new item30( this, defMedida, 
                                  defRespuesta, 
                                  index30.ultimoT( this.Base.Dom()));

  lkbm = new Vector();
  lkbm.add( item);//<I-ultimo, defRespuesta, defMedida|

  listStat30.calc( this);
  checkList30.chk( this, "ini-def");
  return lkbm;
}//ini

/**
**/
public boolean esUNKB( item30 item) {

  return index30.eqS( item.GetRespuesta(), UNKB);
}//

/**
**/
public boolean esCOKB( item30 item) {

  return index30.eqS( item.GetRespuesta(), COKB);
}//

/**
* Numero de items. Objetivo general a minimizar en sintesis30.
* focusPolicy(): unKB-opt global, coKB-optXY, resto la familia de item numero <policy>.
* opt bicriterio: 2D, suma(size.01/dom(0)+size.10/dom(1))
**/
public long optSize( ) { 

  int policy = controlPrefs30.focusPolicy();//la politica del item policy. 
 
  if ( chk) frame30.kbm2lSystem.append( "focusPolicy(): " + policy + "\n");
  
  if ( policy == unKB) {
	 if ( chk) frame30.kbm2lSystem.append( "Global optimization\n");
	 if ( dimension() == 0)
	   return (size() / Base.dom(Base.bas(0)) + new simetricBase30().simetric2( this).size() / Base.dom(Base.bas(1)));
	   else return size();//opt global
    }
    else if ( policy == coKB) {
  	   if ( chk) frame30.kbm2lSystem.append( "XY optimization\n");
      return gapsXY();//opt XY, inference
    }  
    else if ( policy < super.size()) {//
	   int it = policy;
  	   if ( chk) frame30.kbm2lSystem.append( "Focal optimization\n");
      return listStat30.kb( this, Get( it).GetRespuesta());//opt focal
      }
    else return -1;  //error
}//optSize

/**
* Proyecta la lista sobre la respuesta R
* Borrado de las respuestas distintas de R
* Olvida todo menos R.
* @param R respuesta
*/
public lista30 response( Vector R) {
  
  double KBR = listStat30.KB( this, R).doubleValue();
  frame30.kbm2lSystem.append( "response. List R: " + R.toString() + ".\n");
  frame30.kbm2lSystem.append( "KB(ini): " + KBR + " / " + listStat30.KB( this) + ".\n");

  if ( KBR > 0.0) {

  for( int p = 0; KBR != listStat30.KB( this).doubleValue(); p++) {

    listStat30.calc( this);

  try {
    
  if ( !index30.eqS( Get(0).GetRespuesta(), R)) {
    if ( size() > 1)
    if ( !esUNKB( Get(1)))
      Get(0).SetRespuesta( UNKB);
      else REMOVE(0);
    }//if
  
    } catch (Exception e) {
      System.out.println( ERROR + "response.0");
      frame30.exit( 0, e);
    }//catch

  try {

  frame30.kbm2lSystem.estatus( "response.   p: " + p +  "   size: " + size() +
    "   KBR: " + listStat30.KB( this, R).doubleValue());    

  for( int i = 1; i < size()-1; i++) {
    if ( !index30.eqS( Get(i).GetRespuesta(), R)) {
      if ( !esUNKB( Get(i-1))) {
        if ( esUNKB( Get(i+1))) { REMOVE(i); } 
          else { Get(i).SetRespuesta( UNKB); }
        }//
        else {
          if ( esUNKB( Get(i+1))) { REMOVE(i); } 
            else { Get(i).SetRespuesta( UNKB); REMOVE(i-1); }
        }
      }//if - !R
    }//for-i
    
    } catch (Exception e) {
      System.out.println( ERROR + "response.1");
      frame30.exit( 0, e);
    }//catch

  try {

  if ( !index30.eqS( Get(size()-1).GetRespuesta(), R)) {
    if ( size()-1 > 0) {
      if ( esUNKB( Get(size()-2))) {
        REMOVE(size()-2);
        }
      Get(size()-1).SetRespuesta( UNKB);
      }//-if
    }
    
    } catch (Exception e) {
      System.out.println( ERROR + "response.2");
      frame30.exit( 0, e);
    }//catch

  }//for-p

  frame30.kbm2lSystem.append( "  KB(fin): " + listStat30.KB( this, R) +
    " / "+ listStat30.KB( this) + "\n");

  if ( KBR != listStat30.KB( this, R).doubleValue()) {
    System.out.println( ERROR + "response.a");
    System.out.println("  KB(fin): " + listStat30.KB( this, R) + " / "+ KBR);
    frame30.exit( 0);   
    } 
  if ( KBR != listStat30.KB( this).doubleValue()) {
    System.out.println( ERROR + "response.b");
    System.out.println("  KB(fin): " + listStat30.KB( this, R) + " / "+ KBR);
    frame30.exit( 0);   
    } 
  
  } else {
    frame30.kbm2lSystem.append( "  KB(fin*): " + KBR + " / "+ listStat30.KB( this) + "\n");
   }

  listStat30.calc( this);    

  for( int i = 0; i < size(); i++) {
    if ( !esUNKB(Get( i)))
    if ( Get(i).getLongitud().doubleValue() > 10000)
      frame30.kbm2lSystem.append(i+"  response  "+ Get(i).getLongitud().toString()+"\n");
    }
 
  checkList30.chk( this, "response.");//checks
  return this;  
}//response

/**
* Inferencia sobre la lista sobre la respuesta (X(-1)X -> X, X(-1)Y -> XY).
*/
public lista30 inference( String type) {
//this es la lista original o la sa-list
//pensada para la proyeccion PAR

  frame30.kbm2lSystem.append( "inference.   KB: " + listStat30.KB( this) + ".\n");

  Vector Entorno = new Vector();//012 102 021 210 201 120
  lista30 sparse30 = listCopy30.randomCopy( this, new lista30( this), 2*this.size());
  for( int i = 0; ( i < dimension()*dimension()) && ( Entorno.size() < dimension()); i++) {
    lista30 s30 = new targetStd30().TargetG( sparse30, basex30.randomBase( Base));//vacia
    if ( metrica30.G( sparse30.Base, s30.Base) < 4)
      Entorno.add( new listUnion30().union_lr( sparse30, s30));//sparse30 -> s30
  }
  
  frame30.kbm2lSystem.append( "inference.   Entorno: " + Entorno.size() + ".\n");
  
  Name( "i-"+Name());

  if ( type ==  "XX") { 
    inferenceXX( Entorno);
    }
  else
  for( int i = 0; i < size()-2; i++) {
    item30 itX = Get( i);     item30 it = Get( i+1);    item30 itY = Get( i+2);

    if ( esUNKB( it)) {
      if ( index30.eqS( itX.GetRespuesta(), itY.GetRespuesta())) {// X(-1)X -> X
          if ( size()>1) REMOVE(i+1);// -> X 
          i--;
        }//if
      if ( type ==  "XY")  
      if ( !index30.eqS( itX.GetRespuesta(), itY.GetRespuesta())) {// X(-1)Y -> XY
          if ( size()>1) REMOVE(i+1);// -> XY 
          i--;
        }//if
      }//esUNKB
   frame30.kbm2lSystem.estatus( "inference: KB: " + i + "  sz: " + size() + 
     "  gXX: " + gapsXX() + "  gXY: " + gapsXY());
    }//for-i

  listStat30.calc( this);    
  frame30.kbm2lSystem.append( "inference.   KB: " + listStat30.KB( this) + "OK .\n");

  checkList30.chk( this, "inference.");
  return this;  
}//inference

/**
* Inferencia sobre la lista sobre la respuesta (X(-1)X -> X.
*/
private lista30 inferenceXX( Vector Entorno) {

  frame30.kbm2lSystem.append( "inferenceXX.   KB: " + listStat30.KB( this) + ".\n");

  for( int i = 0; i < size()-2; i++) {

    item30 itX = Get( i);     item30 it = Get( i+1);    item30 itY = Get( i+2);

    if ( esUNKB( it)) {//XXh

      if ( index30.eqS( itX.GetRespuesta(), itY.GetRespuesta())) {// X(-1)X -> X

        if ( size() > 1) {

          int szE = Entorno.size();
          int test = 0;
          for( int j = 0; j < szE; j++) {
	         lista30 s30 = ((lista30)Entorno.get( j));
	         Vector indice = it.GetIndice();
	         indice = base30.Trnp( this.Base, indice, s30.Base); // CAMBIO DE BASE
            item30 its = s30.GET( indice);
            int k = s30.indexOf( its);
            if (( k > 0) && ( k < s30.size()-1)) {
	            item30 itsX = Get( k-1); item30 itsY = Get( k+1);
	            if ( s30.esUNKB( its)) {
                 if ( index30.eqS( itsX.GetRespuesta(), itsY.GetRespuesta())) {// X(-1)X -> X
                   test++;
                   frame30.kbm2lSystem.append( itsX.GetRespuesta().toString()+itsY.GetRespuesta().toString()+".\n");                   
                   }//if
		           }//if-esUNKB
	            }//if-k
	         }//for-j

          frame30.kbm2lSystem.append( test + "  ---  " +szE + ".\n");                   
          if ( test > szE/2) {
            REMOVE(i+1);// -> X 
            i--;
            }//test

          }//if
         
        }//if-// X(-1)X -> X

      }//if-esUNKB

   frame30.kbm2lSystem.estatus( "inference: KB: " + i + "  sz: " + size() + 
     "  gXX: " + gapsXX() + "  gXY: " + gapsXY());

    }//for-i

  listStat30.calc( this);    
  frame30.kbm2lSystem.append( "inferenceXX.   KB: " + listStat30.KB( this) + "OK .\n");

  checkList30.chk( this, "inferenceXX.");
  return this;  
}//inferenceXX

/**
* Inferencia sobre la lista sobre la respuesta (XX -> XXX, XY -> XXY|XYY). Random inf.
*/
public lista30 inferenceR( ) {
//this es la lista original o la sa-list
//pensada para la proyeccion PAR

  frame30.kbm2lSystem.append( "inferenceR.\n");
  boolean inf = true; 
  Random  r = new Random();
  r.setSeed( new controlPrefs30().randomSeed());
  
  int pxx = 100;
  int pxy_x = 0;
  int pxy_y = 0;

  Name( "i-"+Name());

  while ( inf) {
    inf = false;
  for( int i = 0; i < size()-2; i++) {
    item30 itX = Get( i); 
    item30 it = Get( i+1);
    item30 itY = Get( i+2);
    if ( esUNKB( it)) {
      if ( index30.eqS( itX.GetRespuesta(), itY.GetRespuesta())) {
        if (r.nextInt(100) < pxx) {           
          inf = true;
          if ( size()>1) REMOVE(i); 
          if ( size()>1) REMOVE(i);// -> X
          }
        }
        else {
        if (r.nextInt(100) < pxy_x) {
          inf = true;
          it.SetRespuesta( itX.GetRespuesta());
          if ( size()>1) REMOVE( i);// -> X          
          }
        if (r.nextInt(100) < pxy_y) {
          inf = true;
          if ( size()>1) REMOVE( i+1);// -> Y          
          }
        }  
      }//esUNKB
    }//for-i

   frame30.kbm2lSystem.estatus( "inferenceR: KB: " + listStat30.KB( this));

    }//while

  listStat30.calc( this);    

  frame30.kbm2lSystem.append( "inferenceR: KB: " + listStat30.KB( this) + "\n");
  return this;  
}//inferenceR

/**
* Pone el esqema alineado con la base canonica.
*
**/
public void canonica() {

  esquema30 newEsqu = new esquema30( Esqu); 
  
  try {

  for( int i = 0; i < dimension(); i++) {
    int x = ((Integer)(Esqu.CodigosAtributos.get( Base.bas( i)))).intValue();
    newEsqu.CodigosAtributos.set( i, new Integer( x));
    }

  } catch (Exception e) {
    System.out.println( ERROR + "canonica - CodigosAtributos");
    frame30.exit( 0, e);
  }//catch

  try {

  for( int i = 0; i < dimension(); i++) {
    String X = (String)(Esqu.Atributos.get( Base.bas( i)));
    newEsqu.Atributos.set( i, new String( X));
    }

  } catch (Exception e) {
    System.out.println( ERROR + "canonica - Atributos");
    frame30.exit( 0, e);
  }//catch

  try {

  for( int i = 0; i < dimension(); i++) {
    int x = ((Integer)(Esqu.CDAtributos.get( Base.bas( i)))).intValue();
    newEsqu.CDAtributos.set( i, new Integer( x));
    }

  } catch (Exception e) {
    System.out.println( ERROR + "canonica - CDAtributos");
    frame30.exit( 0, e);
  }//catch

  try {

  for( int i = 0; i < dimension(); i++) {
    Vector X = (Vector)(Esqu.ValoresAtributos.get( Base.bas( i)));
    for( int j = 0; j < Base.dom( i); j++)
      newEsqu.ValoresAtributos.set( Base.att( i, j), ((String)X.get( j)));
    }

  } catch (Exception e) {
    System.out.println( ERROR + "canonica - ValoresAtributos");
    frame30.exit( 0, e);
  }//catch

  Esqu = newEsqu;

  for( int i = 0; i < dimension(); i++) {
    Base.bas( i, i);
    for( int j = 0; j < Base.dom( i); j++)
      Base.att( i, j, j);
    }
  
  return;
}//canonica

}//class lista30
