//METRICA30//
package kernel;

//
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import control.*;
import target.*;
import kbm2l.*;

/**
* Clase metrica30.
* Distancias entre bases de kbm2l.  Natural bases.
* 
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class metrica30  extends  base30  {

  private static final String ERROR = "Error(metrica30): ";

/**
* Constructor por defecto
**/
public metrica30( ) {

}//metrica30

/**
* Test de distancia de Hamming 
* @param B1 base, Vector de Integer
* @param B2 base, Vector de Integer
* @param dist int, 
* @return la distancia Hamming entre B1 y B2 es dist
**/
public static boolean H( base30 B1, base30 B2, int dist) {

  return ( H( B1, B2) == dist);
}//H

/**
* Distancia de Hamming entre bases ( Vectores)
**/
public  static  int H( base30 B1, base30 B2) {

  if ( !base30.cmpB( B1, B2)) {
    System.out.println( ERROR + "H.");
    frame30.exit( 0);
    }//if
    
  int h = 0;//att
  if ( eqB( B1, B2)) return 0;
  for( int i = 0; i < B1.size(); i++) {
    if ( B1.bas( i) != B2.bas( i)) h++;
    }
  
  if ( h == 0)//dom
  for( int i = 0; i < B1.size(); i++) {
    for( int j = 0; j < B1.dom( i); j++) {
    if ( B1.att( i, j) != B2.att( i, j)) h++;
   }} else { 
	  for( int i = 0; i < B1.size(); i++) {
        int b1 = B1.bas( i);
		  for( int j = 0; j < B1.dom( i); j++) {
          if ( B1.att( i, j) != B2.att( B2.indexOfbas( b1), j)) h++;
   }}}

  return h;
}//H

/**
* Distancia de Hamming entre dominios ( Vectores)
**/
public  static  int h( Vector D1, Vector D2) {

  if ( D1.size() != D2.size()) {
    System.out.println( ERROR + "h. size D1 D2: " + D1.size() + "   " + D2.size());
    System.out.println( D1.toString() + D2.toString());
    frame30.exit( 0);
    }//if
    
  int hh = 0;
  if ( D1.equals( D2)) return 0;
  for( int i = 0; i < D1.size(); i++) {
    if ( ((Integer)D1.get(i)).intValue() != ((Integer)D2.get(i)).intValue()) hh++;
    }

  return hh;
}//h

/**
* Distancia de Hamming entre dominios ( Vectores)
**/
public  static  int hh( Vector D1, Vector D2) {

  if ( D1.size() != D2.size()) {
    System.out.println( ERROR + "h. size D1 D2: " + D1.size() + "   " + D2.size());
    System.out.println( D1.toString() + D2.toString());
    frame30.exit( 0);
    }//if
    
  int h = 0;
  if ( D1.equals( D2)) return 0;
  for( int i = 0; i < D1.size(); i++) {
	 int d1 = ((Integer)D1.get(i)).intValue();
	 int d2 = ((Integer)D2.get(i)).intValue();
	 int j = D2.indexOf( d1);
    if ( d1 != d2) h = h + Math.min(i,j) + Math.abs( i - j) - 1;
    }

  return h;
}//hh

/**
* Distancia tipo G entre bases. EJOR. Generalizada a permut de domnios.
* Hamming menos 1 mas la suma de 
* espacios entre atributos homologos en las bases.
* No es distancia
**/
private  static  double  oldGleft( base30 B1, base30 B2) {

  if ( B1.size() != B2.size()) {
    System.out.println( ERROR + "---> G.");
    frame30.exit( 0);// salir
    }//if
    
  if ( eqB( B1, B2)) return 0;
  boolean head = true;  
  double g = H( B1, B2) - 1;//!!!
  
  double rlef = 0;
  if (B1.bas(0) != B2.bas(0)) rlef = 0;
  else {
    for( int i = 1; i < B1.size(); i++) {
      int b1 = B1.bas( i);
      int b2 = B2.bas( i);
      if ( b1 != b2) {
        rlef = i;
        break;
        }//if
      }//for
    }//if 

  double ri = g;
  for( int i = 0; i < B1.size(); i++) {
    int b1 = B1.bas( i);
    int b2 = B2.bas( i);
    if ( b1 != b2) {
      int it = B2.indexOfbas( b1);//i transp
      ri = ri + Math.abs( i-it)-1;
      }//if
    }//for
    
// permut de dominio
  double hD = 0;
  for( int i = 0; i < B1.size(); i++) {
    int b1 = B1.bas( i);
    hD = hD + (i+1)*hh( B1.att( i), B2.att( B2.indexOfbas( b1)));//vector de dominio del att i de B1
    }//for
//System.out.println( rlef + ri + hD);
  return (rlef + ri + hD);
}//oldGleft

/**
* Distancia tipo G entre bases.
* Hamming menos 1 mas la suma de 
* espacios entre atributos homologos en las bases.
* No es distancia
**/
private  static  int oldGright( base30 B1, base30 B2) {

  if ( B1.size() != B2.size()) {
    System.out.println( ERROR + "---> G.");
    frame30.exit( 0);// salir
    }//if
    
  if ( eqB( B1, B2)) return 0;

  boolean head = true;  
  int g = H( B1, B2)-1;//!!!

  for( int i = B1.size()-1; i >= 0; i--) {
    int b1 = B1.bas(i);
    int b2 = B2.bas(i);
    if ( b1 != b2) {
      if (!head) g = g - i;
      head = false;
      g = g + Math.abs( B2.indexOfbas( b1) - i)-1;
      }//if
    }//for
    
  return g;
}//oldGright

/**
* Distancia tipo G entre bases.
* La suma de los maximos de pares de posiciones de atributos homologos en las bases.
* es distancia ? Tiene en cuenta el peso
**/
private  static  int  newGx( base30 B1, base30 B2) {

  if ( B1.size() != B2.size()) {
    System.out.println( ERROR + "---> G.");
    frame30.exit( 0);
    }//if
    
  if ( eqB( B1, B2)) return 0;
  int g = 0;
  for( int i = 0; i < B1.size(); i++) {
    int b1 = B1.bas( i);//i es la posicion de b1 en B1
    int b2 = B2.bas( i);//i es la posicion de b2 en B2
    if ( b1 != b2) 
      g = g + Math.max( B2.indexOfbas( b1), i);// max{a,b} --> b
    }//for

  return g/2;
}//newGx    

/**
* Distancia tipo G entre bases extendidas.
* La suma de los maximos de pares de posiciones de atributos homologos en las bases.
* es distancia ? Tiene en cuenta el peso
**/
private  static  int  newXGx( base30 B1, base30 B2) {

  if ( B1.size() != B2.size()) {
    System.out.println( ERROR + "---> G.");
    frame30.exit( 0);
    }//if
    
  if ( eqB( B1, B2)) return 0;
  int g = 0;
  for( int i = 0; i < B1.size(); i++) {
    int b1 = B1.bas( i);//i es la posicion de b1 en B1
    int b2 = B2.bas( i);//i es la posicion de b2 en B2
    if ( b1 != b2) 
      g = g + Math.max( B2.indexOfbas( b1), i);// max{a,b} --> b
    }//for

//?

  return g/2;
}//newXGx    

/**
* Distancia tipo G entre bases
**/
public  static  double  G( base30 B1, base30 B2) {

  return oldGleft( B1, B2);
//  return oldGright( B1, B2);
//  return newGx( B1, B2);
}//G

/**
* Distancia L1 entre bases
**/
public  static  int L1( base30 B1, base30 B2) {

  if ( B1.size() != B2.size()) {
    System.out.println( ERROR + "---> G.");
    frame30.exit( 0);
    }//if
    
  if ( eqB( B1, B2)) return 0;
  int g = 0;
  for( int i = 0; i < B1.size(); i++) {
    int b1 = B1.bas(i);
    int b2 = B2.bas(i);
    if ( b1 != b2) 
      g = g + Math.abs( B2.bas( i) - B1.bas( i));// 
    }//for

  return g;
}//L1    

/**
* Distancia L2 entre bases
**/
public  static  int L2( base30 B1, base30 B2) {

  if ( B1.size() != B2.size()) {
    System.out.println( ERROR + "---> G.");
    frame30.exit( 0);// salir
    }//if
    
  if ( eqB( B1, B2)) return 0;
  int g = 0;
  for( int i = 0; i < B1.size(); i++) {
    int b1 = B1.bas(i);
    int b2 = B2.bas(i);
    if ( b1 != b2) 
      g = g + Math.abs( B2.bas( i) - B1.bas( i))*
              Math.abs( B2.bas( i) - B1.bas( i));// 
    }//for

  return (int)Math.sqrt((double)g);
}//L2    


/**
* Test metrico de una funcion - distancia en un entorno.
* axionmas: separacion, simetria y desigualdad triangular, n^3
* @param Entorno vector de objetos bases30
* @return true/false
**/
public  static  boolean  esDistancia( Vector Entorno) {

  int Esz = Entorno.size();

  kbm2lSystem.append( "esDistancia. Entorno: " + Entorno.size() + ".\n");
  if ( Esz > 30) Esz = 30;
  
  for( int i = 0; i < Esz; i++) {
    base30 Bi = (base30)(Entorno.get(i));

    for( int j = 0; j < Esz; j++) {
      base30 Bj = (base30)(Entorno.get(j));      

      if ( eqB( Bi, Bj)) {//separacion
        if ( G( Bi, Bj) != 0) {
          System.out.println( "***s1 G(" + Bi.Bas()+", "+Bj.Bas() + "): " + G( Bi, Bj));        
          return false;
          }//if
        }//if

      if ( G( Bi, Bj) != 0) {//separacion
        if ( eqB( Bi, Bj)) {
          System.out.println( "***s2 G(" + Bi.Bas()+", "+Bj.Bas() + "): " + G( Bi, Bj));        
          return false;
          }//if
        }//if

      if ( G( Bi, Bj) != G( Bj, Bi)) {//simetria
        System.out.println( "***s G(" + Bi.Bas()+", "+Bj.Bas() + "): " + G( Bi, Bj));        
        System.out.println( "***s G(" + Bj.Bas()+", "+Bi.Bas() + "): " + G( Bj, Bi));        
        return false;
        }//if

      for( int k = 0; k < Esz; k++) {//desigualdad triangular
        base30 Bk = (base30)(Entorno.get(k));      

        if ( G( Bi, Bj) + G( Bi, Bk) < G( Bj, Bk)) {
           System.out.println( "***t G(" + Bi.Bas()+", "+Bj.Bas() + "): " + G( Bi, Bj));        
           System.out.println( "***t G(" + Bi.Bas()+", "+Bk.Bas() + "): " + G( Bi, Bk));        
           System.out.println( "***t G(" + Bj.Bas()+", "+Bk.Bas() + "): " + G( Bj, Bk));        
           return false;
           }//if    
        }// for k
      }//for j
    }//for i

  return true;
}//esDistancia

}//class metrica30
