//OFFSET30//
package kernel;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kbm2l.*;
import control.*;
import target.*;

/**
* Clase offset30: offsets inf y sup de los indices inf y sup un item
* numero de casos en el item y flag de cache.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class offset30 {

  private static final String ERROR = "Error(offset30): ";

  private boolean cache = true;//cache true - activada
  private BigInteger inf = null;//cache del offsetINF del item
  private BigInteger sup = null;//cache del offsetSUP del item
  private BigInteger longitud = null;//cache de tamao del item

/**
* Constructor por defecto
**/
public offset30( ) {

  cache = false;

  BigInteger inf = null;
  BigInteger sup = null;
  BigInteger longitud = null;  
}//offset30

/**
* FUNCION OFFSET.
* Offset del Vector indice I y el Vector dominio D. I*W(D).
* i0*d1*d2+i1*d2+i2 = (i0*d1+i1)*d2+i2.
* i0*d1*d2*d3+i1*d2*d3+i2*d3+i4 = ((i0*d1+i1)*d2+i2)*d3+i4.
* @param Dominio dominos (0..di-1).
* @param Indice indice de valores de atributos.
* @return BigInteger o   offset es BigInteger
**/
public BigInteger offset( Vector Dominio, Vector Indice) {

  long v = 0, d = 0;
  BigInteger o = null;

  cache = true;

  if ( Dominio.size() >= 2)
  try {

    v = ((Integer)Indice.get( 0)).intValue();  
    o = new BigInteger( new String( String.valueOf( v)));//ini-acum

    d = ((Integer)Dominio.get( 1)).intValue();

    o = o.multiply( new BigInteger( new String( String.valueOf( d))));

  for( int i = 1; i < Indice.size()-1; i++) {

    v = ((Integer)Indice.get( i)).intValue();
    String val = new String( String.valueOf( v));

    d = ((Integer)Dominio.get( i+1)).intValue();
    String dom = new String( String.valueOf( d));

    o = ( o.add( new BigInteger( val))).multiply( new BigInteger( dom));
    }//for

  } catch (Exception e) {
      System.out.println( ERROR + "offset().");
      e.printStackTrace();
      System.exit( 0);
  }
  else o = new BigInteger( new String( "0"));

  v = ((Integer)Indice.get( Indice.size()-1)).intValue(); 
  o = o.add( new BigInteger( new String( String.valueOf( v))));

  return o;
}//offset

/**
* Constructor general
* @param Dominio  dominios (0..di-1)
* @param IndiceInf  indice inf
* @param IndiceSup  indice sup
**/
public offset30( Vector Dominio, Vector IndiceInf, Vector IndiceSup) {
//Ii-indice INF, LOW
//Is-indice SUP, UPP
//Ii[0] Ii[1] Ii[2] Ii[3]
//Is[0] Is[1] Is[2] Is[3]
//D[0] D[1] D[2] D[3]
//Is[3] + ( Is[2] + ( Is[1] + Is[0] * D[2] ) * D[1] ) * D[0]
//(( Is[0] * D[2] + Is[1] ) * D[1] + I[2] ) * D[0] + Is[3]

  cache = true;
//  cache = false;//desactivada

  inf = offset( Dominio, IndiceInf);//inf
  sup = offset( Dominio, IndiceSup);//sup

  setLongitud();
}//offset30

/**
* index: Offset inverso, Vector indice de un offset 0..MaxOffset
* @param WEIGHTS pesos
* @param offset desplazamiento
* @return vector de indice del offset
**/
public  static  Vector index( lista30 l30, Vector WEIGHTS, BigInteger offset) {
// c0 = q / w0,
// c1 = (q - q0) / w1, q0 = c0 * w0
// c2 = (q - q1) / w2, q1 = c0 * w0 + c1 * w1
//...
// ci = ((q  -  qi-1)/ wi), qi-1 = c0 * w0 + c1 * w1 +... ci-1 * wi-1
//...
// cn = ((q  -  qn-1)/ wn), 

// qi-1 = S cj * wj, q-1 = 0 

  if ( l30.size() > 0)
  if ( offset.compareTo( 
    new offset30().offset( l30.Base.Dom(), index30.primeroT( l30.Base.Dom()))) == -1) {
      System.out.println( ERROR + "index( l30, w, o).");
      System.out.println( "MinOffset: " + 
        new offset30().offset( l30.Base.Dom(), index30.primeroT( l30.Base.Dom())));
      System.out.println( "offset:    " + offset.toString());
      frame30.exit( -1);
    }//  
  if ( offset.compareTo( 
    new offset30().offset( l30.Base.Dom(), index30.ultimoT( l30.Base.Dom()))) == 1) {
      System.out.println( ERROR + "index( l30, w, o).");
      System.out.println( "MaxOffset: " + 
        new offset30().offset( l30.Base.Dom(), index30.ultimoT( l30.Base.Dom())));
      System.out.println( "offset:    " + offset.toString());
      frame30.exit( -1);
    }//  

  Vector INDICE = null;
  INDICE = new Vector();
  BigInteger q = offset;//offset
  BigInteger p = new BigInteger( "0");//qi-1
  BigInteger W = (BigInteger)( WEIGHTS.get( 0));
  INDICE.add( new Integer( q.divide( W ).toString()));// q/W0
  if (((Integer)INDICE.get( 0)).intValue() < 0) {
    System.out.println( "INDICE:    " + INDICE);
    frame30.exit( 0, new Exception());
    }

  for( int i = 1; i < l30.ParIndice(); i++) {
    p = new BigInteger( "0");//qi-1
    for( int j = 0; j < i; j++ ) {
      BigInteger C = new BigInteger( ((Integer)INDICE.get( j)).toString());      
      W = (BigInteger)(WEIGHTS.get( j));
      p = p.add( new BigInteger( C.multiply( W).toString()));
      }//for
    W = (BigInteger)(WEIGHTS.get( i));  
    INDICE.add( new Integer((q.add(p.negate())).divide( W).toString()));
    if (((Integer)INDICE.get( i)).intValue() < 0) {
      System.out.println( "INDICE:    " + INDICE);
      frame30.exit( 0);
      }
  }//for

  return INDICE;//==offset
}//index

/**
* Offset sup
**/
public BigInteger getOffsetSup() {

  return sup;
}//

/**
* sup -> offset sup
**/
private BigInteger setOffsetSup( BigInteger sup) {

  return this.sup = sup;
}//

/**
* D*I -> offset sup
**/
private BigInteger setOffsetSup( Vector Dominio, Vector Indice) {

//sup
  try {
    return this.sup = offset( Dominio, Indice);
  } catch (Exception e) {
      System.out.println( ERROR + "setOffsetSup().");
      frame30.exit( 0);
  }
  
  return null;
}//

/**
* Offset inf
**/
public BigInteger getOffsetInf() {

  return inf;
}//

/**
* inf -> Offset inf
**/
private BigInteger setOffsetInf( BigInteger inf) {

  return this.inf = inf;
}//

/**
* D*H -> offset inf
**/
private BigInteger setOffsetInf( Vector Dominio, Vector Indice) {

//inf
  try {
    return this.inf = offset( Dominio, Indice);
  } catch (Exception e) {
      System.out.println( ERROR + "setOffsetInf().");
      frame30.exit( 0);
  }
  
  return null; 
}//setOffsetInf

/**
* Longitud o numero de casos de una lista.
* flag es true si el cache (longitud) es actual
* Cache activada.
**/
public BigInteger getLongitud() {
//longitud de un item

  if ( cache) {
    return longitud;//esta en cache
    }
    else {
      return setLongitud(); 
    }
}//getLongitud

/**
* Longitud o numero de casos de una lista con dominio D:(0..d0,0..d1,0..d2,.....)
**/
public BigInteger getLONGITUD( Vector D) {
//longitud de una lista

  Vector I = index30.ultimoT( D);
  BigInteger LONGITUD = null;
  long v = 0, d = 0;
    
//LONGITUD
  if ( D.size() >= 2) 
  try {

    v = ((Integer)I.get( 0)).intValue();  
    LONGITUD = new BigInteger( new String( String.valueOf( v)));//ini-acum

    d = ((Integer)D.get( 1)).intValue();
    LONGITUD = LONGITUD.multiply( new BigInteger( new String( String.valueOf( d))));

  for(int i = 1; i < I.size()-1; i++) {

    v = ((Integer)I.get( i)).intValue();
    String val = new String( String.valueOf( v));

    d = ((Integer)D.get( i+1)).intValue();
    String dom = new String( String.valueOf( d));

    LONGITUD = LONGITUD.add( new BigInteger( val)).multiply( new BigInteger( dom));

    }//for

  } catch (Exception e) {
      System.out.println( ERROR + "getLONGITUD().");
      frame30.exit( 0);
  }
  else LONGITUD = new BigInteger( new String( "0"));

  v = ((Integer)I.get( I.size()-1)).intValue();  
  LONGITUD = LONGITUD.add( new BigInteger( new String( String.valueOf( v))));
  
  return LONGITUD;
}//getLONGITUD

/**
* longitud -> longitud
**/
public BigInteger setLongitud( BigInteger longitud) {
//longitud de un item
 
  try {
    this.longitud = longitud;
  } catch (Exception e) {
      System.out.println( ERROR + "setLongitud( longitud).");
      frame30.exit( 0);
  }

  return longitud;
}//setLongitud

/**
* definicion de longitud -> longitud
**/
public BigInteger setLongitud() {
//longitud de un item

  try {
    this.longitud = sup.subtract( inf).add( BigInteger.ONE);
  } catch (Exception e) {
      System.out.println( ERROR + "setLongitud( ).");
      frame30.exit( 0);
  }
  
  return longitud;
}//setLongitud

/**
* cache
**/
public  boolean Cache() {

  return cache;
}//Cache

/**
* c -> cache 
**/
public  boolean Cache( boolean c) {

  return ( cache = c);
}//setFlag

}//class offset30
