//
package lbnk2;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.awt.*;

//
import kbm2l.*;
import kernel.*;
import tables.*;

import xbneditor.*;

/**
 * Title: LearningInputDataManager.java
 * Description:  Core Bayesian Network class for BBN Learning
 * Copyright:    Copyright (c) 2001
 * Company:      KSU / KDD
 * @author Haipeng Guo
 *
 * @version 0.2.0
 */

public  class  LBN  extends frame30 implements  Runnable  {

  private static final String ERROR = "Error(LBN): ";
/**
* flag de ejecucion en curso
**/
  public static boolean working = false;//
  private String inputfilename = null;
  private String outputfilename = null;

/**
* Constructor. Establece los ficheros.
**/
  public LBN( String inputfilename, String outputfilename) {

    if( inputfilename.equals( "")) {
      f30.kbm2lSystem.estatus("Data Set selecc: *.dat.");
      String filename = dato30.selectFile( f30.kbm2lSystem.frame, FileDialog.LOAD, "*.dat");
      if ( filename == null) {
        f30.kbm2lSystem.append("Data Set not readed.\n");
        return ;
        }//if
      this.inputfilename = new String( filename);
      }//if 
      else this.inputfilename = inputfilename;
  
    if( this.inputfilename == null) {
      System.out.println("[inputfilename] is null...");
      System.exit(0);
      }

    f30.kbm2lSystem.estatus("Data Set seleccted: " + dato30.workspace + 
        dato30.nameFile( dato30.extFile( this.inputfilename, "dat")));
            
    if( outputfilename.equals( "")) {
      this.outputfilename = dato30.workspace + 
        dato30.nameFile( dato30.extFile( this.inputfilename, "xml"));
        }
      else {  
        this.outputfilename = outputfilename;
      }//if

    if( this.outputfilename == null) {
      System.out.println("[outputfilename] is null...");
      System.exit(0);
     }
    
}//LBM

/**
* 
**/
public void lbn( ) {

    working = true;

    LearningInputDataManager indata = new LearningInputDataManager( inputfilename);
    indata.loadInputDataFile();
    K2 k2 = new K2(indata);
    LearningBBN bbn = k2.learnBBNFromData();
    bbn.writeToXML( outputfilename);
    f30.kbm2lSystem.append( "writeToXML: " + outputfilename + "\n");

    new BBNConvertor( outputfilename,
      dato30.workspace + 
        dato30.nameFile( dato30.extFile( outputfilename, "dsl")));
    f30.kbm2lSystem.append( "writeToDSL: " + outputfilename + "\n");

    new BBNConvertor( outputfilename,
      dato30.workspace + 
        dato30.nameFile( dato30.extFile( outputfilename, "net")));
    f30.kbm2lSystem.append( "writeToNET: " + outputfilename + "\n");

    working = false;
    return;
}//lbn

/**
*
**/
public void run() {

  if ( !working) {
    try {
      lbn( );
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "run().");
      e.printStackTrace();
      System.exit( 0);
    }//catch
    }
  return;
}//run
  
}//class LBN