package lbnk2;

//
import java.util.*;
import java.lang.*;

/**
 * Title: ParentNodes.java
 * Description:  Core Bayesian Network Learning class
 * Copyright:    Copyright (c) 2001
 * Company:      KSU / KDD
 * @author Haipeng Guo *
 * @version 0.2.0
 */

public class ParentNodes {
  private Vector nodesnamelist = new Vector();
  private Vector v = new Vector();     // a vector of all possible nodes value; vector of vector
  private LearningInputDataManager data = new LearningInputDataManager("nulldata");
  private int n = 0;		// number of nodes
  private int q = 0;		// there are q unique instantiations of nodelist

  public ParentNodes(LearningInputDataManager d, Vector nodes){
    data = d;
    int column;
    if (nodes.size()!=0){
      for(int i=0;i<nodes.size();i++)
	nodesnamelist.addElement(nodes.elementAt(i).toString());
	n = nodesnamelist.size();
      for(int i=0;i<data.getNumberOfCases();i++){
      	Vector nodesvaluelist = new Vector();
        for(int j=0;j<nodes.size();j++){
          column = data.getColumn(nodes.elementAt(j).toString());
	  nodesvaluelist.addElement(data.getDataAt(i, column-1));
	}
	if(!v.contains(nodesvaluelist)){
          v.addElement(nodesvaluelist);
	  q++;
        }
      }
    }
  } // end of constructor

  public int getQ(){
    return this.q;
  }

  public boolean isEmpty(){
    return this.nodesnamelist.isEmpty();
  }

  public void printNodesname(){
    System.out.println("parent nodes name:");
    for(int i=0;i<n;i++)
      System.out.println(this.nodesnamelist.elementAt(i).toString());
    }

  public void printNodevalue(){
    Object obj = new Object();
    Vector temp = new Vector();
    System.out.println("parent nodes possible value:");
    for(int i=0;i<q;i++){
      System.out.println("this is :" + i +"th instanciation");
      temp = (Vector)this.v.elementAt(i);
      for(int j=0;j<n;j++)
        System.out.println(temp.elementAt(j).toString()+", ");
    }
  }

  public Vector getParentnodesAtRow(int m){
    int column;
    Vector result = new Vector();
    for(int j=0;j<n;j++){
      column = data.getColumn(nodesnamelist.elementAt(j).toString());
      result.addElement(data.getDataAt(m-1, column-1));
    }
    return result;
  }

  public Vector get_jth_from_v(int j){
    Vector result = new Vector();
    result = (Vector)v.elementAt(j-1);
    return result;
  }

}
