//aprendizOptimo30//
package learning;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.awt.*;

//
import kernel.*;
import control.*;
import synthesis.*;
import kbm2l.*;
import tables.*;

/**
* Construccion, Optimizacion  y Aprendizaje simultaneo de listas.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class aprendizOptimo30  extends aprendiz30 implements  Runnable {

  private static final String ERROR = "Error(aprendizOptimo30): ";
/**
* Constructor por defecto
**/
public aprendizOptimo30( ) {

  this.pathKBM = "";
}//aprendizOptimo30

/**
* Constructor para un fichero de aprendizaje
**/
public aprendizOptimo30( String pathKBM) {

  this.pathKBM = new String( pathKBM);
}//aprendizOptio30

/**
* Se incorpora la lista externa a la lista l30
* @param l30 lista30 destino 
* @param fileList fichero externo con entradas para aprender
* @return l30 lista30, incremento de conocimiento, nuevos items.
**/
public lista30 aprendizOptimo( lista30 l30, String fileList) {

  kbm2lSystem.append("Optimal Learning started.\n");
  working = true;

  double ratioKBinicial = listStat30.KB( l30).doubleValue() / l30.size();
  double ratioKBnuevo = 0;
  
  if (fileList == "") {
    kbm2lSystem.append("Let Select kbm2l header: *.hkb.\n");
    pathKBM = new String( dato30.selectFile( f30.kbm2lSystem.frame, FileDialog.LOAD, "*.hkb"));
    if ( pathKBM == "") {
      kbm2lSystem.append("Learning is not performed.\n");
      return null;
    }
    } else pathKBM = new String( fileList);

  lista30 aux = new inputTable30( ).leerTabla( l30.Esqu, pathKBM);//nuevos datos,
  l30 = aux.union( aux);//aprendizaje simple, 
  l30 = new sintesisHammingV30( l30).HammingV( l30);//con sintesis.

  ratioKBnuevo = listStat30.KB( l30).doubleValue() / l30.size();
  if ( ratioKBinicial >= ratioKBnuevo)
    kbm2lSystem.append("Effective learning: "    + ratioKBnuevo + " >=  " + ratioKBinicial + ".\n");
    else kbm2lSystem.append("Complex learning: " + ratioKBnuevo + " <  "  + ratioKBinicial + ".\n");

  working = false;
  return l30;//final;
}//aprendizOptimo

/**
* 
**/
public void run() {

  if ( !working) {
    try {
      f30.activel30 = aprendizOptimo( f30.activel30, pathKBM);
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "run().");
      e.printStackTrace();
      exit( 0);
    }//catch
    if ( f30.activel30 != null) {
      if ( new controlPrefs30().checkMode()) {
        new outputTable30( f30.activel30).escribeTabla( f30.activel30, "");//filedlg
        new outputList30( ).escribeKBM2L( f30.activel30, "");//filedlg
        }
      }
  }
  return;
}//run

}//aprendizOptimo30