//aprendizSimple30//
package learning;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.awt.*;

//
import kernel.*;
import control.*;
import synthesis.*;
import kbm2l.*;
import tables.*;

/**
* Aprendizaje de listas.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class aprendizSimple30  extends aprendiz30  implements  Runnable {

  private static final String ERROR = "Error(aprendizSimple30): ";
/**
* Constructor por defecto
**/
public aprendizSimple30( ) {

  this.pathKBM = "";
}//aprendizSimple30

/**
* Constructor para un fichero de aprendizaje
**/
public aprendizSimple30( String pathKBM) {

  this.pathKBM = new String( pathKBM);
}//aprendizSimple30

/**
*
**/
public long aprendizSimple( lista30 l30) {

  kbm2lSystem.append("Simple learning is started.\n");
  working = true;

  long itemsKBiniciales = listStat30.kb( l30);//inicial
  long itemsKBnuevos = 0;
  lista30 aux;

  kbm2lSystem.append("Let select kbm2l header: *.hkb.\n");
  pathKBM = dato30.selectFile( f30.kbm2lSystem.frame, FileDialog.LOAD, "*.hkb");
  if ( pathKBM == null) {
    kbm2lSystem.append("Learning is not performed.\n");
    return -1;
    }
  if ( pathKBM == "") {
    kbm2lSystem.append("Learning is not performed.\n");
    return -1;
    }

  new inputTable30( ).leerTabla( l30.Esqu, pathKBM);//kbm
  aux = new lista30( l30, l30);
  kbm2lSystem.append("Aprendizaje de " + listStat30.KB( aux) + " casos nuevos.\n");
  kbm2lSystem.append("Aprendizaje de " + listStat30.KB( l30) + " casos previos.\n");

//  eqKBM2L30.eqKBM2L( l30, aux, "aprendizSimple30-aprendizSimple");
  aux.union( l30);//aprendizaje simple, sin sintesis.
  
  if ( l30 == null)
    return -1;

  itemsKBnuevos = listStat30.kb( l30);
  if ( itemsKBiniciales <= itemsKBnuevos)
    kbm2lSystem.append("Full learning: " + itemsKBnuevos + ".\n");
    else kbm2lSystem.append("Partial learning: " + itemsKBnuevos + ".\n");

  working = false;
  return itemsKBiniciales - listStat30.kb( l30);//final;
}//aprendizSimple

/**
*
**/
public void run() {

  if ( !working) {
    try {
      if ( aprendizSimple( f30.activel30) == -1) return;
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "run().");
      e.printStackTrace();
      exit( 0);
    }//catch
    if ( f30.activel30 != null) {
      if ( new controlPrefs30().checkMode()) {
        new outputTable30( f30.activel30).escribeTabla( f30.activel30, "");//filedlg
        new outputList30( ).escribeKBM2L( f30.activel30, "");//filedlg
        }
      }
  }
  return;
}//run

}//aprendizSimple30