//DLGKBM2L30//
package menu;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;
import javax.swing.JDialog;

//
import kernel.*;
import kbm2l.*;
import tables.*;
import analysis.*;
import synthesis.*;
import learning.*;

/**
* Clase dlgKBM2L30 fija la lista activa l30 del protocolo p30. 
* 
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  dlgKBM2L30  extends  frame30  implements  Runnable  {

  private static final String ERROR = "Error(dlgKBM2L30): ";

  protected static JDialog kbm2lDialog = null;
  protected static Button  bDialog  = null;
  protected static String strBSeleccKBM2L = "selecct KBM2L";
  protected static Choice cDialog = null;

/**
* Constructor del dialogo
**/
public dlgKBM2L30( ) {

  if (( f30.activel30 == null) && ( f30.p30 == null)) {
    kbm2lSystem.estatus( "No lists in KBM2L System."); 
    return;
    }
  
//Layout
  GridBagConstraints C = new GridBagConstraints();
  GridBagLayout gbl = new GridBagLayout();

//
  if ( f30.activel30 == null)
    kbm2lDialog = new JDialog( kbm2lControl.frame, 
      "KBM2L30 = " + "CONTROL - KBM2L - ", true);
    else kbm2lDialog = new JDialog( kbm2lControl.frame, 
      "KBM2L30 = " + "CONTROL - KBM2L - " + f30.activel30.Name(), true);
  kbm2lDialog.getContentPane().setLayout( gbl); 

  kbm2lDialog.setSize( 450, 90);

  C.gridx = 0; C.gridy = 0;
  C.gridwidth = 1; C.gridheight = 1;
  C.fill = GridBagConstraints.NONE;
  C.ipadx = 0; C.ipady = 0;
  C.insets = new Insets(5,5,5,5);
  C.anchor = GridBagConstraints.WEST;
  C.weightx = 1; C.weighty = 1;
  cDialog = new Choice();
  gbl.setConstraints( cDialog, C);
  kbm2lDialog.getContentPane().add( cDialog);

  C.gridx = 0; C.gridy = 1;
  C.gridwidth = 1; C.gridheight = 1;
  C.fill = GridBagConstraints.NONE;
  C.ipadx = 0; C.ipady = 0;
  C.insets = new Insets(5,5,5,5);
  C.anchor = GridBagConstraints.WEST;
  C.weightx = 1; C.weighty = 1;
  bDialog = new Button( strBSeleccKBM2L);
  gbl.setConstraints( bDialog, C);
  kbm2lDialog.getContentPane().add( bDialog);//+++
  bDialog.addActionListener( new dlgKBM2LListener( ));//!!!

}//dlgKBM2L30

/**
* Proceso de evento del boton de seleccion de la lista activa.
**/
public static void bSeleccKBM2LAction( ) {

  try {
    String listName = new String( cDialog.getSelectedItem());
    for( int i = 0; i < f30.p30.decisiones.size(); i++) {
      String id = ((lista30)f30.p30.decisiones.get( i)).Name().trim();
      if ( listName.equals( id)) {
          f30.activel30 = ((lista30)f30.p30.decisiones.get( i));
          if (f30.activel30.Esqu.numDecisiones == 0) {
            System.out.println( ERROR + "bSeleccKBM2LAction( ).0");
            f30.exit( 0, new Exception());
            };//si es preciso se debe volver a leer
          break;
          }//if    
      }//for
    }  catch (Exception e) {
      System.out.println( ERROR + "bSeleccKBM2LAction( ).");
      f30.exit( 0, e);
    }//catch

  cDialog.removeAll();  
  kbm2lDialog.setVisible( false);
  kbm2lDialog.dispose();

  kbm2lControl.setText( kbm2lControl.ListName, f30.activel30.Name());
  kbm2lControl.setText( kbm2lControl.ListSize, String.valueOf( f30.activel30.size()));
  kbm2lControl.setText( kbm2lControl.ListSchema, "");
  kbm2lSystem.estatus( "Active list selected: " + f30.activel30.Name().trim() + ".");

  return;  
}//bSeleccKBM2LAction()

/**
* 
**/
public void run() {

  try {

  if ( f30.p30 != null) {
    if ( f30.p30.decisiones != null) {
  
      f30.activel30 = ((lista30)f30.p30.decisiones.get( 0));
      
      if ( sintesis30.working || 
           aprendiz30.working) {
           kbm2lTime.append(
           "Active list is proccessing now: " + f30.activel30.Name().trim() + ". Stop ?\n");
        return;
        }

      if ( f30.activel30 == null)     
        kbm2lSystem.estatus(
        "Select active list: " + f30.activel30.Name().trim() + ".");

      for( int i = 0; i < f30.p30.decisiones.size(); i++)
        cDialog.addItem( ((lista30)f30.p30.decisiones.get(i)).Name().trim() );

      if ( f30.activel30.Name() != null) {  
        cDialog.select( f30.activel30.Name().trim());
        }
        else { 
          cDialog.select(((lista30)f30.p30.decisiones.get( 0)).Name().trim());
        }

     kbm2lDialog.setLocation( 300, 80);
//     kbm2lDialog.show();
  kbm2lDialog.setVisible(true);
  kbm2lDialog.toFront();  

     
     //modal  
     }//if
   else {kbm2lSystem.estatus( "No list decisions.");}
   }//if
 else {kbm2lSystem.estatus( "No list protocol.");}

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    f30.exit( 0, e);
  }//catch

  return;
}//run

}//class dlgKBM2L30
