//MENUBARSYSTEM30//
package menu;

//
import java.awt.*;
import java.awt.event.*;
import java.io.*;

//
import kbm2l.*;

/**
* Clase menuBarSystem30
* Configuracin de las entradas del menu la aplicacin
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class menuBarSystem30  extends  menuSystem30  {

  private static final String ERROR = "Error(menuBarSystemn30): ";
  public MenuBar mainMenu = null;
  private MenuItem menuItemSalir;//

/**
* Constructor por defecto.
* Llama a los procedimientos que configuran las
* entradas del menu: KBM2L, Tools, protocolo, Consulta
* Analisis, SintesisLocal, SintesisGlobal, Aprendizaje, OR y PD.
* @param f30 entorno de la aplicacion
**/
public menuBarSystem30( frame30 f30) {

//MenuApp
  mainMenu = new MenuBar();

  KBM2L( f30);
  Schema( f30);
  Tools( f30);
  Consulta( f30);

  Analisis( f30);
  SintesisLocal( f30);
  SintesisGlobal( f30);  
  Aprendizaje( f30);

//  MP( f30);
  CPT( f30);
//  C2Opt( f30);
  return;  
}//menuBar30

////
//// System
////

/**
* Configura la entrada KBM2L del menu con los items:
* leer, guardar, guardar Tabla y Salir.
* Pone los items en la lista de escucha de menuListener
* e indica el entorno para pasar parametros a los metodos del menu.
* @param f30 entorno de la aplicacion
* @return void
**/
private void KBM2L( frame30 f30) {

  menuKBM2L = new Menu( strMenuKBM2L);
  mainMenu.add( menuKBM2L);
    menuItemLeerTabla = new MenuItem( strMenuItemLeerTabla);
    menuKBM2L.add( menuItemLeerTabla);
    menuItemProtocolo = new MenuItem( strMenuItemProtocolo);
    menuKBM2L.add( menuItemProtocolo);
    menuItemPrincipal = new MenuItem( strMenuItemPrincipal);
    menuKBM2L.add(menuItemPrincipal);
    menuKBM2L.addSeparator();//--------------------------
    menuItemGuardarLista =   new MenuItem( strMenuItemGuardarLista);
    menuKBM2L.add( menuItemGuardarLista);
    menuItemGuardarTabla =   new MenuItem( strMenuItemGuardarTabla);
    menuKBM2L.add( menuItemGuardarTabla);
    menuItemGuardarDataFrame =   new MenuItem( strMenuItemGuardarDataFrame);
    menuKBM2L.add( menuItemGuardarDataFrame);
    menuKBM2L.addSeparator();//--------------------------
    menuItemCheck = new MenuItem( strMenuItemCheck);
    menuKBM2L.add(menuItemCheck);
    menuItemVerSummary = new MenuItem( strMenuItemVerSummary);
    menuKBM2L.add( menuItemVerSummary);
    menuItemVerBrowser = new MenuItem( strMenuItemVerBrowser);
    menuKBM2L.add( menuItemVerBrowser);
    menuKBM2L.addSeparator();//--------------------
    menuItemVerSpectrum = new MenuItem( strMenuItemVerSpectrum);
    menuKBM2L.add( menuItemVerSpectrum);
    menuItemZoomMas = new MenuItem( strMenuItemZoomMas);
    menuKBM2L.add(menuItemZoomMas);
    menuItemZoomMenos = new MenuItem( strMenuItemZoomMenos);
    menuKBM2L.add(menuItemZoomMenos);
    menuItemShiftLeft = new MenuItem( strMenuItemShiftLeft);
    menuKBM2L.add(menuItemShiftLeft);
    menuItemShiftRigth = new MenuItem( strMenuItemShiftRigth);
    menuKBM2L.add(menuItemShiftRigth);
    menuKBM2L.addSeparator();//--------------------
    menuItemSalir =          new MenuItem( strMenuItemSalir);
    menuKBM2L.add( menuItemSalir);

//eventos del menu KBM2L
  menuItemLeerTabla.addActionListener(         new menuListenerSystem( f30));
  menuItemProtocolo.addActionListener(         new menuListenerSystem( f30));
  menuItemPrincipal.addActionListener(         new menuListenerSystem( f30));
  menuItemGuardarLista.addActionListener(      new menuListenerSystem( f30));
  menuItemGuardarTabla.addActionListener(      new menuListenerSystem( f30));
  menuItemGuardarDataFrame.addActionListener(  new menuListenerSystem( f30));
  menuItemCheck.addActionListener(             new menuListenerSystem( f30));
  menuItemVerSummary.addActionListener(        new menuListenerSystem( f30));
  menuItemVerBrowser.addActionListener(        new menuListenerSystem( f30));
  menuItemVerSpectrum.addActionListener(       new menuListenerSystem( f30));
  menuItemZoomMas.addActionListener(           new menuListenerSystem( f30));
  menuItemZoomMenos.addActionListener(         new menuListenerSystem( f30));
  menuItemShiftLeft.addActionListener(         new menuListenerSystem( f30));
  menuItemShiftRigth.addActionListener(        new menuListenerSystem( f30));
  menuItemSalir.addActionListener(             new menuListenerSystem( f30));

  return;
}//KBM2L

/**
* Configura la entrada Schema del menu con los items:
* EqHkbKBM2L, extend, contract, breakAtt0, ontop, shiftatt .
* Pone los items en la lista de escucha de menuListener
* e indica el entorno para pasar parametros a los metodos del menu.
* @param f30 entorno de la aplicacion
* @return void
**/
private void Schema( frame30 f30) {

  menuSchema = new Menu( strMenuSchema);
  mainMenu.add( menuSchema);
    menuItemEqHkbKBM2L = new MenuItem( strMenuItemEqHkbKBM2L);
    menuSchema.add(menuItemEqHkbKBM2L);
    menuItemHkbEqKBM2L = new MenuItem( strMenuItemHkbEqKBM2L);
    menuSchema.add(menuItemHkbEqKBM2L);
    menuSchema.addSeparator();//-------------------------
    menuItemExtensionAtt = new MenuItem( strMenuItemExtensionAtt);
    menuSchema.add(menuItemExtensionAtt);    
    menuItemContraccionAtt = new MenuItem( strMenuItemContraccionAtt);
    menuSchema.add(menuItemContraccionAtt);    
    menuItemBreakAtt = new MenuItem( strMenuItemBreakAtt);
    menuSchema.add(menuItemBreakAtt);    
    menuItemSwapAtt = new MenuItem( strMenuItemSwapAtt);
    menuSchema.add(menuItemSwapAtt);    
    menuItemOnTopAtt = new MenuItem( strMenuItemOnTopAtt);
    menuSchema.add(menuItemOnTopAtt);    
    menuItemLShiftAtt = new MenuItem( strMenuItemLShiftAtt);
    menuSchema.add(menuItemLShiftAtt);    
    menuSchema.addSeparator();//-------------------------
    menuItemLTable2D = new MenuItem( strMenuItemTable2D);
    menuSchema.add(menuItemLTable2D); 
    
//eventos del menu Schema
  menuItemEqHkbKBM2L.addActionListener(       new menuListenerSystem( f30));
  menuItemHkbEqKBM2L.addActionListener(       new menuListenerSystem( f30));
  menuItemExtensionAtt.addActionListener(     new menuListenerSystem( f30));
  menuItemContraccionAtt.addActionListener(   new menuListenerSystem( f30));
  menuItemBreakAtt.addActionListener(         new menuListenerSystem( f30));
  menuItemSwapAtt.addActionListener(          new menuListenerSystem( f30));
  menuItemOnTopAtt.addActionListener(         new menuListenerSystem( f30));
  menuItemLShiftAtt.addActionListener(        new menuListenerSystem( f30));
  menuItemLTable2D.addActionListener(         new menuListenerSystem( f30));

  return;
}//Schema

/**
* Configura la entrada Tools del menu con los items:
* empty, random, simetric, extend, contract, breakAtt0,
* neighbDist, neighbourdhood y fitness2.
* Pone los items en la lista de escucha de menuListener
* e indica el entorno para pasar parametros a los metodos del menu.
* @param f30 entorno de la aplicacion
* @return void
**/
private void Tools( frame30 f30) {

  menuTools = new Menu( strMenuTools);
  mainMenu.add( menuTools);
    menuItemEmptyList = new MenuItem( strMenuItemEmptyList);
    menuTools.add(menuItemEmptyList);
    menuItemRulesList = new MenuItem( strMenuItemRulesList);
    menuTools.add(menuItemRulesList);
    menuItemRandomList = new MenuItem( strMenuItemRandomList);
    menuTools.add(menuItemRandomList);    
    menuItemRandomDel = new MenuItem( strMenuItemRandomDel);
    menuTools.add(menuItemRandomDel);    
    menuTools.addSeparator();//-------------------------
    menuItemSimetricaBase = new MenuItem( strMenuItemSimetricaBase);
    menuTools.add(menuItemSimetricaBase);    
    menuItemRandomBase = new MenuItem( strMenuItemRandomBase);
    menuTools.add(menuItemRandomBase);    
    menuItemSetBase = new MenuItem( strMenuItemSetBase);
    menuTools.add(menuItemSetBase);    
    menuTools.addSeparator();//-------------------------
    menuItemNeighDistance = new MenuItem( strMenuItemNeighDistance);
    menuTools.add(menuItemNeighDistance);    
    menuItemNeighbourdhood = new MenuItem( strMenuItemNeighbourdhood);
    menuTools.add(menuItemNeighbourdhood);
    menuItemFitness2 = new MenuItem( strMenuItemFitness2);
    menuTools.add(menuItemFitness2);
    menuTools.addSeparator();//-------------------------
    menuItemCmpList = new MenuItem( strMenuItemCmpList);
    menuTools.add(menuItemCmpList);    
    menuItemDifList = new MenuItem( strMenuItemDifList);
    menuTools.add(menuItemDifList);    
    menuItemEqvList = new MenuItem( strMenuItemEqvList);
    menuTools.add(menuItemEqvList);    

//eventos del menu Tools
  menuItemEmptyList.addActionListener(        new menuListenerSystem( f30));
  menuItemRulesList.addActionListener(        new menuListenerSystem( f30));
  menuItemRandomList.addActionListener(       new menuListenerSystem( f30));  
  menuItemRandomDel.addActionListener(        new menuListenerSystem( f30));  
  menuItemSimetricaBase.addActionListener(    new menuListenerSystem( f30));
  menuItemRandomBase.addActionListener(       new menuListenerSystem( f30));
  menuItemSetBase.addActionListener(          new menuListenerSystem( f30));
  menuItemNeighDistance.addActionListener(    new menuListenerSystem( f30));    
  menuItemNeighbourdhood.addActionListener(   new menuListenerSystem( f30));
  menuItemFitness2.addActionListener(         new menuListenerSystem( f30));
  menuItemCmpList.addActionListener(          new menuListenerSystem( f30));
  menuItemDifList.addActionListener(          new menuListenerSystem( f30));
  menuItemEqvList.addActionListener(          new menuListenerSystem( f30));

  return;
}//Tools

/**
* Configura la entrada Consulta del menu con los items:
* cerrada, abierta y general.
* Pone los items en la lista de escucha de menuListener
* e indica el entorno para pasar parametros a los metodos del menu.
* @param f30 entorno de la aplicacion
* @return void
**/
private void Consulta( frame30 f30) {

  menuConsulta = new Menu( strMenuConsulta);
  mainMenu.add( menuConsulta);
    menuItemCerrada = new MenuItem( strMenuItemCerrada);
    menuConsulta.add(menuItemCerrada);
    menuItemAbierta = new MenuItem( strMenuItemAbierta);
    menuConsulta.add(menuItemAbierta);
    menuItemBayes = new MenuItem( strMenuItemBayes);
    menuConsulta.add(menuItemBayes);
    menuItemGuardarLDS =   new MenuItem( strMenuItemGuardarLDS);
    menuConsulta.add( menuItemGuardarLDS);
    menuConsulta.addSeparator();//-------------------------
    menuItemEdit = new MenuItem( strMenuItemEdit);
    menuConsulta.add(menuItemEdit);

//eventos del menu Consulta
  menuItemCerrada.addActionListener (    new menuListenerSystem( f30));
  menuItemAbierta.addActionListener(     new menuListenerSystem( f30));
  menuItemBayes.addActionListener(       new menuListenerSystem( f30));
  menuItemGuardarLDS.addActionListener(  new menuListenerSystem( f30));
  menuItemEdit.addActionListener(        new menuListenerSystem( f30));
  
  return;
}//Consulta

/**
* Configura la entrada Analisis del menu con los items:
* sintactico y semantico.
* Pone los items en la lista de escucha de menuListener
* e indica el entorno para pasar parametros a los metodos del menu.
* @param f30 entorno de la aplicacion
* @return void
**/
private void Analisis( frame30 f30) {
  
  menuAnalisis = new Menu( strMenuAnalisis);
  mainMenu.add( menuAnalisis);
    menuItemSintactico = new MenuItem( strMenuItemSintactico);
    menuAnalisis.add( menuItemSintactico);
    menuItemSemantico = new MenuItem( strMenuItemSemantico);
    menuAnalisis.add( menuItemSemantico);
    menuItemFocusAlternative = new MenuItem( strMenuItemFocusAlternative);
    menuAnalisis.add(menuItemFocusAlternative);    
    menuAnalisis.addSeparator();//-------------------------
    menuItemSensitivity = new MenuItem( strMenuItemSensitivity);
    menuAnalisis.add( menuItemSensitivity);
    menuItemFullScanner = new MenuItem( strMenuItemFullScanner);
    menuAnalisis.add( menuItemFullScanner);
    menuItemRandomScanner = new MenuItem( strMenuItemRandomScanner);
    menuAnalisis.add( menuItemRandomScanner);
    menuAnalisis.addSeparator();//-------------------------
    menuItemProyectionAtt = new MenuItem( strMenuItemProyectionAtt);
    menuAnalisis.add(menuItemProyectionAtt);    
    menuItemProyectionPar = new MenuItem( strMenuItemProyectionPar);
    menuAnalisis.add(menuItemProyectionPar);    
    menuItemProyectionParX = new MenuItem( strMenuItemProyectionParX);
    menuAnalisis.add(menuItemProyectionParX);    
    menuAnalisis.addSeparator();//-------------------------
    menuItemInferenceXX = new MenuItem( strMenuItemInferenceXX);
    menuAnalisis.add(menuItemInferenceXX);    
    menuItemInferenceXY = new MenuItem( strMenuItemInferenceXY);
    menuAnalisis.add(menuItemInferenceXY);
    menuItemResponse = new MenuItem( strMenuItemResponse);
    menuAnalisis.add(menuItemResponse);    

//eventos del menu Analisis
  menuItemSintactico.addActionListener(         new menuListenerSystem( f30));
  menuItemSemantico.addActionListener(          new menuListenerSystem( f30));
  menuItemFocusAlternative.addActionListener(   new menuListenerSystem( f30));  
  menuItemSensitivity.addActionListener(        new menuListenerSystem( f30));
  menuItemFullScanner.addActionListener(        new menuListenerSystem( f30));
  menuItemRandomScanner.addActionListener(      new menuListenerSystem( f30));
  menuItemProyectionAtt.addActionListener(      new menuListenerSystem( f30));
  menuItemProyectionPar.addActionListener(      new menuListenerSystem( f30));
  menuItemProyectionParX.addActionListener(     new menuListenerSystem( f30));
  menuItemInferenceXX.addActionListener(        new menuListenerSystem( f30));
  menuItemInferenceXY.addActionListener(        new menuListenerSystem( f30));
  menuItemResponse.addActionListener(           new menuListenerSystem( f30));

  return;
}//Analisis

/**
* Configura la entrada SintesisLocal del menu con los items:
* hamming-2, hamming-C, hamming_X, y directa.
* Pone los items en la lista de escucha de menuListener
* e indica el entorno para pasar parametros a los metodos del menu.
* @param f30 entorno de la aplicacion
* @return void
**/
private void SintesisLocal( frame30 f30) {
  
  menuSintesisLocal = new Menu( strMenuSintesisLocal);
  mainMenu.add( menuSintesisLocal);
    menuItemHamming2 = new MenuItem( strMenuItemHamming2);
    menuSintesisLocal.add(menuItemHamming2);
    menuItemHammingCd = new MenuItem( strMenuItemHammingCd);
    menuSintesisLocal.add(menuItemHammingCd);
    menuItemHammingCi = new MenuItem( strMenuItemHammingCi);
    menuSintesisLocal.add(menuItemHammingCi);
    menuItemHammingV = new MenuItem( strMenuItemHammingV);
    menuSintesisLocal.add(menuItemHammingV);
    menuSintesisLocal.addSeparator();
    menuItemDirecta = new MenuItem( strMenuItemDirecta);
    menuSintesisLocal.add(menuItemDirecta);

//eventos del menu SintesisLocal
  menuItemHamming2.addActionListener(  new menuListenerSystem( f30));
  menuItemHammingCd.addActionListener(  new menuListenerSystem( f30));
  menuItemHammingCi.addActionListener(  new menuListenerSystem( f30));
  menuItemHammingV.addActionListener(  new menuListenerSystem( f30));
  menuItemDirecta.addActionListener(   new menuListenerSystem( f30));

  return;
}//SintesisLocal

/**
* Configura la entrada SintesisGlobal del menu con los items:
* hamming-R, 2Opt y genetica.
* Pone los items en la lista de escucha de menuListener
* e indica el entorno para pasar parametros a los metodos del menu.
* @param f30 entorno de la aplicacion
* @return void
**/
private void SintesisGlobal( frame30 f30) {  

  menuSintesisGlobal = new Menu( strMenuSintesisGlobal);
  mainMenu.add( menuSintesisGlobal);
    menuItemRandom2 = new MenuItem( strMenuItemRandom2);
    menuSintesisGlobal.add(menuItemRandom2);
    menuItem2Opt = new MenuItem( strMenuItem2Opt);
    menuSintesisGlobal.add(menuItem2Opt);
    menuSintesisGlobal.addSeparator();//-------------------------
    menuItemGeneticoJAF = new MenuItem( strMenuItemGeneticoJAF);
    menuSintesisGlobal.add(menuItemGeneticoJAF);
    menuItemGeneticoMGO = new MenuItem( strMenuItemGeneticoMGO);
    menuSintesisGlobal.add(menuItemGeneticoMGO);
    menuItemEntVarMGO = new MenuItem( strMenuItemEntVarMGO);
    menuSintesisGlobal.add(menuItemEntVarMGO);

//eventos del menu SintesisGlobal
  menuItemRandom2.addActionListener(      new menuListenerSystem( f30));
  menuItem2Opt.addActionListener(         new menuListenerSystem( f30));
  menuItemGeneticoJAF.addActionListener(  new menuListenerSystem( f30));
  menuItemGeneticoMGO.addActionListener(  new menuListenerSystem( f30));
  menuItemEntVarMGO.addActionListener(    new menuListenerSystem( f30));

  return;
}//SintesisGlobal

/**
* Configura la entrada Aprendizaje del menu con los items:
* simple y optimo. Redes bayesianas.
* Pone los items en la lista de escucha de menuListener
* e indica el entorno para pasar parametros a los metodos del menu.
* @param f30 entorno de la aplicacion
* @return void
**/
private void Aprendizaje( frame30 f30) {

  menuAprendizaje = new Menu( strMenuAprendizaje);
  mainMenu.add( menuAprendizaje);
    menuItemSimple = new MenuItem( strMenuItemSimple);
    menuAprendizaje.add(menuItemSimple);
    menuItemOptimo = new MenuItem( strMenuItemOptimo);
    menuAprendizaje.add(menuItemOptimo);
    menuAprendizaje.addSeparator();//-------------------------
    menuItemBayesianNetwork = new MenuItem( strMenuItemBayesianNetwork);
    menuAprendizaje.add(menuItemBayesianNetwork);
    menuItemBBNConvertor = new MenuItem( strMenuItemBBNConvertor);
    menuAprendizaje.add(menuItemBBNConvertor);
    menuItemXBNEditor = new MenuItem( strMenuItemXBNEditor);
    menuAprendizaje.add(menuItemXBNEditor);



//eventos del menu Aprendizaje
  menuItemSimple.addActionListener(           new menuListenerSystem( f30));
  menuItemOptimo.addActionListener(           new menuListenerSystem( f30));
  menuItemBayesianNetwork.addActionListener(  new menuListenerSystem( f30));
  menuItemBBNConvertor.addActionListener(     new menuListenerSystem( f30));
  menuItemXBNEditor.addActionListener(        new menuListenerSystem( f30));
  
  return;
}//Aprendizaje

/**
* Configura la entrada MP (Mathematical Programming ) del menu con los items:
* leer Modelo, guardar Modelo, ProgEntera, Progcontinua, progMixta y Refinar.
* Pone los items en la lista de escucha de menuListener
* e indica el entorno para pasar parametros a los metodos del menu.
* @param f30 entorno de la aplicacion
* @return void
**/
private void MP( frame30 f30)  {

  menuMP = new Menu( strMenuMP);
  mainMenu.add( menuMP);
    menuItemLeerModelo = new MenuItem( strMenuItemLeerModelo);
    menuMP.add(menuItemLeerModelo);
    menuItemGuardarModelo = new MenuItem( strMenuItemGuardarModelo);
    menuMP.add(menuItemGuardarModelo);
    menuMP.addSeparator();//-----------------------
    menuItemProgEntera = new MenuItem( strMenuItemProgEntera);
    menuMP.add(menuItemProgEntera);
    menuItemProgContinua = new MenuItem( strMenuItemProgContinua);
    menuMP.add(menuItemProgContinua);
    menuItemProgMixta = new MenuItem( strMenuItemProgMixta);
    menuMP.add(menuItemProgMixta);
    menuMP.addSeparator();//------------------------
    menuItemRefinar = new MenuItem( strMenuItemRefinar);
    menuMP.add(menuItemRefinar);

//eventos del menu MP
  menuItemProgEntera.addActionListener(    new menuListenerSystem( f30));
  menuItemProgContinua.addActionListener(  new menuListenerSystem( f30));
  menuItemProgMixta.addActionListener(     new menuListenerSystem( f30));
  menuItemRefinar.addActionListener(       new menuListenerSystem( f30));
  
  return;
}//MP

/**
* Configura la entrada CPT (Conditional Probability Tables) del menu con los items:
* check, leer Tabla, guardar Tabla, Tabla condicionada.
* Pone los items en la lista de escucha de menuListener
* e indica el entorno para pasar parametros a los metodos del menu.
* @param f30 entorno de la aplicacion
* @return void
**/
private void CPT( frame30 f30) {

  menuCPT = new Menu( strMenuCPT);
  mainMenu.add( menuCPT);
    menuItemDistrCondicionada = new MenuItem( strMenuItemDistrCondicionada);
    menuCPT.add( menuItemDistrCondicionada);
    menuItemDistrCheck = new MenuItem( strMenuItemDistrCheck);
    menuCPT.addSeparator();//------------------------------------
    menuCPT.add( menuItemDistrCheck);
    menuItemConstrCheck = new MenuItem( strMenuItemConstrCheck);
    menuCPT.add( menuItemConstrCheck);
    menuCPT.addSeparator();//------------------------------------
    menuItemLeerDistribucion = new MenuItem( strMenuItemLeerDistribucion);
    menuCPT.add( menuItemLeerDistribucion);
    menuItemGuardarDistribucion = new MenuItem( strMenuItemGuardarDistribucion);
    menuCPT.add( menuItemGuardarDistribucion);
    menuCPT.addSeparator();//------------------------------------
    menuItemRules = new MenuItem( strMenuItemRules);
    menuCPT.add( menuItemRules);

//eventos del menu Distribucion
  menuItemDistrCondicionada.addActionListener(  new menuListenerSystem( f30));
  menuItemDistrCheck.addActionListener(         new menuListenerSystem( f30));
  menuItemConstrCheck.addActionListener(        new menuListenerSystem( f30));
  menuItemRules.addActionListener(              new menuListenerSystem( f30));

  return;
}//CPT

/**
* Configura la entrada C2Opt (Clasiscal Combinatorial Optimisation) 
* del menu con los items: TSP, BAGP, KNN.
* Pone los items en la lista de escucha de menuListener
* e indica el entorno para pasar parametros a los metodos del menu.
* @param f30 entorno de la aplicacion
* @return void
**/
private void C2Opt( frame30 f30) {

  menuC2Opt = new Menu( strMenuC2Opt);
  mainMenu.add( menuC2Opt);
    menuItemTSP = new MenuItem( strMenuItemTSP);
    menuC2Opt.add( menuItemTSP);
    menuItemBAGP = new MenuItem( strMenuItemBAGP);
    menuC2Opt.add( menuItemBAGP);
    menuItemKNN = new MenuItem( strMenuItemKNN);
    menuC2Opt.add( menuItemKNN);

//eventos del menu C2Opt
  menuItemTSP.addActionListener(    new menuListenerSystem( f30));
  menuItemBAGP.addActionListener(   new menuListenerSystem( f30));
  menuItemKNN.addActionListener(    new menuListenerSystem( f30));

  return;
}//C2Opt

}//class menuBarSystem30