//menuListenerBarSystem
package menu;

//
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

//
import kernel.*;
import kbm2l.*;
import tables.*;
import schema.*;
import control.*;

//
import analysis.*;
import query.*;
import synthesis.*;
import genetic.*;
import learning.*;
import tools.*;
import lbnk2.*;
import xbneditor.*;

//
//import modelo.*;
//import mathprog.*;
import cpt.*;

/**
* SERVIDOR DE ESCUCHA DEL MENU y CONTROLES DE frame
*
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
class  menuListenerBarSystem  extends  menuSystem30  {

  private static final String ERROR = "Error(menuListenerBarSystem): ";
  private static long ts0 = 0;//tiempo de las tareas de menu

/**
* Constructor por defecto
**/
public menuListenerBarSystem( ) {

}//menuListenerBarSystem

/**
* Escucha las entradas del meun KBM2L:
* LeerTabla, Protocolo, GuardarLista, GuardarTabla, GuardarDataFrame,...
* @return true si se realiza una accin 
**/
public static boolean KBM2L( ActionEvent e) {
//KBM2L

  if (e.getActionCommand().equals( strMenuItemLeerTabla)) {
    f30 = frame30.iniFrame();  
    if ( new controlPrefs30().threadMode())
      new Thread ( new inputTable30( )).start();//filedlg
      else f30.activel30 = new inputTable30( ).leerTabla( null, "");//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemProtocolo)) {
    f30 = frame30.iniFrame();  
    if ( new controlPrefs30().threadMode())
      new Thread ( new protocolo30( )).start();//filedlg
      else f30.p30 = new protocolo30( ).protocolo( "");//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemPrincipal)) {
    new Thread ( new dlgKBM2L30( )).start();
    return true;
    }

////

  if ( f30.activel30 != null) {

  if (e.getActionCommand().equals( strMenuItemGuardarLista)) {
    if ( new controlPrefs30().threadMode()) {
      new Thread ( new outputList30( "")).start( );//filedlg
      }
      else {
        ts0 = (new Date()).getTime();
        new outputList30( ).escribeKBM2L( f30.activel30, "");//no Thread
        f30.kbm2lTime.append("KBM2L GuardarLista:: " + (new Date().getTime() - ts0) + ".\n");  
        }
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemGuardarTabla)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new outputTable30( "", f30.activel30)).start();//filedlg
      else {
        ts0 = (new Date()).getTime();
        new outputTable30( "", f30.activel30).escribeTabla( f30.activel30, "");//no Thread
        f30.kbm2lTime.append("KBM2L GuardarTabla:: " + (new Date().getTime() - ts0) + ".\n");  
        }
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemGuardarDataFrame)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new outputDataFrame30( "", f30.activel30)).start();//filedlg
      else {
        ts0 = (new Date()).getTime();
        new outputDataFrame30( "", f30.activel30).escribeDataFrame( f30.activel30, "");//no Thread
        f30.kbm2lTime.append("KBM2L GuardarDataFrame:: " + (new Date().getTime() - ts0) + ".\n");  
        }
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemCheck)) {
    checkList30.CHK( f30.activel30, "user");//incondicional
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemVerSummary)) {
    kbm2lControl.frame.toFront();
    kbm2lBrowser.frame.toFront();
    kbm2lBrowser.summaryView( f30.activel30);
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemVerBrowser)) {
    kbm2lBrowser.frame.toFront();
    kbm2lBrowser.listView( f30.activel30);
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemVerSpectrum)) {
    kbm2lBrowser.frame.toFront();
    kbm2lBrowser.summaryView( f30.activel30);
    kbm2lBrowser.spectrumView( f30.activel30);
    kbm2lBrowser.brsp.frame.toFront();
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemZoomMas)) {
    double res = new controlPrefs30().spectrumResolution();
    res = res * 2.0;
    new controlPrefs30().spectrumResolution( res);
    kbm2lBrowser.spectrumView( f30.activel30);
    kbm2lBrowser.brsp.frame.toFront();
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemZoomMenos)) {
    double res = new controlPrefs30().spectrumResolution();
    res = res * 0.5;
    new controlPrefs30().spectrumResolution( res);
    kbm2lBrowser.spectrumView( f30.activel30);
    kbm2lBrowser.brsp.frame.toFront();
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemShiftLeft)) {
    int first = new controlPrefs30( ).firstItemBrowser( );
    if ( first > 0) 
      first = first - 1;
    new controlPrefs30().firstItemBrowser( first);
//    new controlPrefs30().firstItemBrowser( spectrum30.lastItem+1);
    kbm2lBrowser.spectrumView( f30.activel30);
    kbm2lBrowser.brsp.frame.toFront();
    return true;
    }
    
  if (e.getActionCommand().equals( strMenuItemShiftRigth)) {
    int first = new controlPrefs30( ).firstItemBrowser( );
    if ( first < activel30.size() - 1) 
      first = first + 1;
    new controlPrefs30().firstItemBrowser( first);
//    new controlPrefs30().firstItemBrowser( spectrum30.fitsItem-1);
    kbm2lBrowser.spectrumView( f30.activel30);
    kbm2lBrowser.brsp.frame.toFront();
    return true;
    }

  }//if
    
  return false;  
}//KBM2L

/**
* @return true si se realiza una accin 
**/
public static boolean Schema( ActionEvent e) {
//Schema

  if (e.getActionCommand().equals( strMenuItemEqHkbKBM2L)) {
    cabecera30.EqHkbList( );
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemHkbEqKBM2L)) {
    cabecera30.HkbEqList( );
    return true;
    }

  if ( f30.activel30 != null) {

  if (e.getActionCommand().equals( strMenuItemExtensionAtt)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new extended30( )).start();
      else f30.activel30 = new extended30( ).extended( 
        f30.activel30, new controlPrefs30( ).randomDomain(), 0);//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemContraccionAtt)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new contracted30( )).start();
      else f30.activel30 = new contracted30( ).contracted( f30.activel30);//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemBreakAtt)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new breakAtt30( )).start();
      else f30.activel30 = new breakAtt30( ).breakAtt( f30.activel30);//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemSwapAtt)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new swapAtt30( )).start();
      else f30.activel30 = new swapAtt30( ).swapAtt( f30.activel30);//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemOnTopAtt)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new onTopAtt30( )).start();
      else f30.activel30 = new onTopAtt30( ).onTopAtt( f30.activel30);//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemLShiftAtt)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new lshiftAtt30( )).start();
      else f30.activel30 = new lshiftAtt30( ).lshiftAtt( f30.activel30);//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemTable2D)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new table2D30( )).start();
      else f30.activel30 = new table2D30( ).table2D( f30.activel30);//no Thread
    return true;
    }

  }//if
  
  return false;  
}//Schema

/**
* @return true si se realiza una accin 
**/
public static boolean Tools( ActionEvent e) {
//Tools

  if (e.getActionCommand().equals( strMenuItemEmptyList)) {
    f30.activel30 = new emptykbm2l30( ).emptyList( null);
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemRulesList)) {
    f30.activel30 = new ruleskbm2l30( ).rulesList( null);
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemRandomList)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new randomkbm2l30( )).start();
      else f30.activel30 = new randomkbm2l30( ).random( );//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemNeighDistance)) {
    new  neighborhood30( ).NeighborhoodDistance( f30.activel30);//puede ser null
    return true;
    }

  if ( f30.activel30 != null) {

  if (e.getActionCommand().equals( strMenuItemRandomDel)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new randomkbm2lDel30( )).start();
      else f30.activel30 = new randomkbm2lDel30( ).randomDel( f30.activel30);//no Thread
    return true;
    }

    if (e.getActionCommand().equals( strMenuItemSimetricaBase)) {
      if ( new controlPrefs30().threadMode())
       new Thread ( new simetricBase30( )).start();
       else f30.activel30 = new simetricBase30( ).simetric( f30.activel30);//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemRandomBase)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new randomBase30( )).start();
      else f30.activel30 = new randomBase30( ).random( f30.activel30);//no Thread
    return true;
    }
  
  if (e.getActionCommand().equals( strMenuItemSetBase)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new setBase30( )).start();
      else f30.activel30 = new setBase30( ).set( f30.activel30);//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemNeighbourdhood)) {
      new neighborhood30().neighborhood( f30.activel30);//
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemFitness2)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new fitness30( )).start();
      else   new fitness30( ).fitness2( f30.activel30);//
    return true;
    }

  }//if

  if (e.getActionCommand().equals( strMenuItemCmpList)) {
    new eqLista30().compatible( );
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemEqvList)) {
    new eqLista30().equivalent( "tools");
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemDifList)) {
    new eqLista30().differences( );
    return true;
    }

  return false;  
}//Tools

/**
* @return true si se realiza una accin 
**/
public static boolean Consulta( ActionEvent e) {
//Consulta
  if (e.getActionCommand().equals( strMenuItemCerrada)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new consultaCerrada30( )).start();
      else new consultaCerrada30( ).consultaCerrada( );//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemAbierta)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new consultaAbierta30( )).start();
      else new consultaAbierta30( ).consultaAbierta( );//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemBayes)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new consultaGeneral30( )).start();
      else new consultaGeneral30( ).consultaGeneral( );//no Thread
    return true;
    }
  
  if (e.getActionCommand().equals( strMenuItemEdit)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new consultaEdit30( )).start();
      else new consultaEdit30( ).consultaEdit( );//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemGuardarLDS)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new outputTable30( "", f30.activel30)).start();//filedlg
      else new outputTable30( "", f30.activel30).escribeTabla( f30.activel30, "");//no Thread
    return true;
    }

  return false;
    
}//Consulta

/**
* @return true si se realiza una accin 
**/
public static boolean  Analisis( ActionEvent e) {
//Analisis

  if ( f30.activel30 != null) {

  if (e.getActionCommand().equals( strMenuItemSintactico)) {
    new analisisSintactico30( ).analisisSintactico( f30.activel30);//
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemSemantico)) {
    new analisisSemantico30( ).analisisSemantico( f30.activel30);//
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemFocusAlternative)) {
    f30.activel30 = new focusAlternative30( ).focusAlternative( f30.activel30);//
    return true;
    }

  } else kbm2lSystem.estatus( "There is no active KBM2L");
    
  if (e.getActionCommand().equals( strMenuItemSensitivity)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new analisisSensibilidad30( )).start();
      else new analisisSensibilidad30( ).analisisSensibilidad( );//no Thread
    return true;
    }

  if ( f30.activel30 != null) {

  if (e.getActionCommand().equals( strMenuItemFullScanner)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new analisisFullScanner30( )).start();
      else new analisisFullScanner30( ).scanner( f30.activel30);//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemRandomScanner)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new analisisRandomScanner30( )).start();
      else new analisisRandomScanner30( ).rscanner( f30.activel30);//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemProyectionAtt)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new proyectionAtt30( )).start();
      else new proyectionAtt30( ).proyectionAtt( f30.activel30);//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemProyectionPar)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new proyectionPar30( )).start();
      else new proyectionPar30( ).proyectionPar( null, f30.activel30);//no Thread        
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemProyectionParX)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new proyectionParX30( )).start();
      else new proyectionParX30( ).proyectionParX( null, f30.activel30);//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemInferenceXX)) {
    f30.activel30 = new inference30( ).inference( f30.activel30, "XX");//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemInferenceXY)) {
    f30.activel30 = new inference30( ).inference( f30.activel30, "XY");//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemResponse)) {
    f30.activel30 = new response30( ).response( f30.activel30);//no Thread
    return true;
    }

  } else kbm2lSystem.estatus( "There is no active KBM2L");

  return false;

}//Analisis

/**
* Sintesis Local (sintesisHamming230, sintesisHammingC30, sintesisHammingV30 y 
* sintesisDirecta30) 
* @see sintesisHamming230
* @see sintesisHammingC30
* @see sintesisHammingV30
* @see sintesisDirecta30
* @return true si se realiza una accin 
**/
public static boolean SintesisLocal( ActionEvent e) {
//SintesisLocal

  if (e.getActionCommand().equals( strMenuItemHamming2)) {
    if ( new controlPrefs30().threadMode()) {
      new Thread ( new sintesisHamming230( )).start();
      }
      else {
        ts0 = (new Date()).getTime();
        f30.activel30 = new sintesisHamming230( ).Hamming2( f30.activel30);//no Thread
        f30.kbm2lTime.append("Sintesis Hamming2:: " + (new Date().getTime() - ts0) + ".\n");  
      }
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemHammingCd)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new sintesisHammingCd30( )).start();
      else {
        ts0 = new Date().getTime();
        f30.activel30 = new sintesisHammingCd30( ).HammingCd( f30.activel30);//no Thread
        f30.kbm2lTime.append("Sintesis HammingCd:: " + (new Date().getTime() - ts0) + ".\n");  
      }
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemHammingCi)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new sintesisHammingCi30( )).start();
      else {
        ts0 = new Date().getTime();
        f30.activel30 = new sintesisHammingCi30( ).HammingCi( f30.activel30);//no Thread
        f30.kbm2lTime.append("Sintesis HammingCi:: " + (new Date().getTime() - ts0) + ".\n");  
      }
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemHammingV)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new sintesisHammingV30( )).start();
      else {
        ts0 = new Date().getTime();
        f30.activel30 = new sintesisHammingV30( ).HammingV( f30.activel30);//no Thread
        f30.kbm2lTime.append("Sintesis HammingV:: " + (new Date().getTime() - ts0) + ".\n");  
      }  
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemDirecta)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new sintesisDirecta30( )).start();
      else {
        ts0 = new Date().getTime();
        f30.activel30 = new sintesisDirecta30( ).Directa( f30.activel30);//no Thread
        f30.kbm2lTime.append("Sintesis Directa:: " + (new Date().getTime() - ts0) + ".\n");  
      }
    return true;
    }

  return false;

}//SintesisLocal

/**
* Global (sintesisHammingR30, 2Opt, genetico30,...)
* @see sintesisHammingR30
* @see sintesisHamming2Opt30
* @see genetico30
* @see Genetico
* @see Aev
* @return true si se realiza una accin 
**/
public static boolean SintesisGlobal( ActionEvent e) {
//SintesisGlobal

  if (e.getActionCommand().equals( strMenuItemRandom2)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new sintesisHammingR30( )).start();
      else {
        ts0 = new Date().getTime();
        long its = f30.activel30.dimension()*f30.activel30.dimension();
        f30.activel30 = new sintesisHammingR30( ).HammingR( f30.activel30, its);//no Thread                
        f30.kbm2lTime.append("Sintesis Random2:: " + (new Date().getTime() - ts0) + ".\n");  
        
      }
    return true;
    }

  if (e.getActionCommand().equals( strMenuItem2Opt)) {
    ts0 = new Date().getTime();
    if ( new controlPrefs30().threadMode())
      new Thread ( new sintesisHamming2Opt30( )).start();
      else {
        ts0 = new Date().getTime();
        f30.activel30 = new sintesisHamming2Opt30( ).Hamming2Opt( f30.activel30);//no Thread
        f30.kbm2lTime.append("Sintesis 2Opt:: " + (new Date().getTime() - ts0) + ".\n");  
        }
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemGeneticoJAF)) {
    ts0 = new Date().getTime();
    if ( new controlPrefs30().threadMode())
      new Thread ( new genetico30( f30.activel30)).start();
      else {
        ts0 = new Date().getTime();
        f30.activel30 = new genetico30( f30.activel30).Genetica( f30.activel30);//no Thread
        f30.kbm2lTime.append("Sintesis Genetica-1:: " + (new Date().getTime() - ts0) + ".\n");  
        }
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemGeneticoMGO)) {
    ts0 = new Date().getTime();
    if ( new controlPrefs30().threadMode())
      new Thread ( new Genetico( f30.activel30)).start();
      else {
        ts0 = new Date().getTime();
        f30.activel30 = new Genetico( f30.activel30).genman( );//no Thread
        f30.kbm2lTime.append("Sintesis Genetica-2:: " + (new Date().getTime() - ts0) + ".\n");  
        }
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemEntVarMGO)) {
    ts0 = new Date().getTime();
    if ( new controlPrefs30().threadMode())
      new Thread ( new Aev( f30.activel30)).start();
      else {
        ts0 = new Date().getTime();
        f30.activel30 = new Aev( f30.activel30).aevman( );//no Thread
        f30.kbm2lTime.append("Sintesis Genetica-3:: " + (new Date().getTime() - ts0) + ".\n");  
        }
    return true;
    }

  return false;

}//SintesisGlobal

/**
* @return true si se realiza una accin 
**/
public static boolean Aprendiz( ActionEvent e) {
//Aprendizaje

  if (e.getActionCommand().equals( strMenuItemSimple)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new aprendizSimple30( )).start();
      else new aprendizSimple30( ).aprendizSimple( f30.activel30);//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemOptimo)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new aprendizOptimo30( )).start();
      else f30.activel30 = new aprendizOptimo30( ).aprendizOptimo( f30.activel30, "");//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemBayesianNetwork)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new LBN( "", "")).start();
      else new LBN( "", "").lbn( );//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemBBNConvertor)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new BBNConvertor( "", "")).start();
      else new BBNConvertor( "", "").bbnConvertor( );//no Thread
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemXBNEditor)) {
    if ( new controlPrefs30().threadMode())
      new Thread ( new XBN( )).start();
      else new XBN( );//no Thread
    return true;
    }

  return false; 
     
}//Aprendiz

/**
* @return true si se realiza una accin 
**/
public static boolean MathProg( ActionEvent e) {
//
  if (e.getActionCommand().equals( strMenuItemProgEntera)) {
    f30 = frame30.iniFrame();  
    //new Thread ( new MathProg30( MathProg30.ProgramaEntero)).start();
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemProgContinua)) {
    f30 = frame30.iniFrame();  
    //new Thread ( new MathProg30( MathProg30.ProgramaEntero)).start();
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemProgMixta)) {
    f30 = frame30.iniFrame();  
    //new Thread ( new MathProg30( MathProg30.ProgramaEntero)).start();
    return true;
    }

  if ( f30.activel30 != null)  {

  if (e.getActionCommand().equals( strMenuItemRefinar)) {
      //new MathProg30( MathProg30.ProgramaEntero).Refinar( f30.activel30);
    return true;
    }

  }//if

  return false  ;
}//MP

/**
* @return true si se realiza una accin 
**/
public static boolean CPT( ActionEvent e) {
//

  if (e.getActionCommand().equals( strMenuItemDistrCondicionada)) {
    f30 = frame30.iniFrame();  
    if ( new controlPrefs30().threadMode())
      new Thread ( new cpt30( )).start();
      else f30.activel30 = new cpt30( ).TablaCondicionada( );//no Thread
    return true;
    }

  if ( f30.activel30 != null) {

    if (e.getActionCommand().equals( strMenuItemDistrCheck)) {
      if ( new controlPrefs30().threadMode())
        new Thread ( new checkCPT30( )).start();
        else new checkCPT30( ).checkCPT( f30.activel30);//no Thread
      return true;
      }

    if (e.getActionCommand().equals( strMenuItemConstrCheck)) {
      if ( new controlPrefs30().threadMode())
        new Thread ( new constraintCPT30( )).start();
        else new constraintCPT30( ).constraintCPT( f30.activel30);//no Thread
      return true;
      }

    if (e.getActionCommand().equals( strMenuItemRules)) {
     if ( new controlPrefs30().threadMode())
       new Thread ( new rules30( )).start();
       else new rules30().rules( f30.activel30);//no Thread
      return true;
      }

    }//if

  return false;  
}//CPT

}//class menuListenerBarSystem