//menuListenerSystem
package menu;

//
import java.awt.*;
import java.awt.event.*;
import java.io.*;

//
import kbm2l.*;
import synthesis.*;
import learning.*;
import control.*;

/**
* Clase menuListenerSystem
* SERVIDOR DE ESCUCHA DEL MENU y CONTROLES DE frame
* Las llamadas  los servicios estan agrupadas igual que el menu.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
class  menuListenerSystem  extends  menuSystem30  implements ActionListener {

  private static final String ERROR = "Error(menuListener): ";
  private static frame30 f30 = null;//!!!

/**
* Constructor por defecto.
* @param f30 entorno de la aplicacin.
* @return NO
**/
public menuListenerSystem( frame30 f30) {

  this.f30 = f30;
}//menuListenerSystem

/**
* Alternativas de la barra del menu.
* @param e mensaje de texto que se equipara para seleccionar la accin.
* @return void
**/
public void actionPerformed( ActionEvent e) {
  
  frame30.chk = controlPrefs30.checkMode();
  frame30.utmanager = controlPrefs30.utilityManager();
  
  if ( menuListenerBarSystem.KBM2L( e)) return;
  if ( menuListenerBarSystem.Schema( e)) return;
  if ( menuListenerBarSystem.Tools( e)) return;
  if ( menuListenerBarSystem.Analisis( e)) return;

  if ( f30.activel30 != null) {
    if ( menuListenerBarSystem.Consulta( e)) return;
    if ( menuListenerBarSystem.SintesisLocal( e)) return;
    if ( menuListenerBarSystem.SintesisGlobal( e)) return;
    } else kbm2lSystem.estatus( "There is no active KBM2L");

  if ( menuListenerBarSystem.Aprendiz( e)) return;
  if ( menuListenerBarSystem.MathProg( e)) return;
  if ( menuListenerBarSystem.CPT( e)) return;

  if ( e.getActionCommand().equals( strMenuItemSalir)) 
    if (( !sintesis30.working)&&( !aprendiz30.working)) {
      exit( exitCodeOK);
      }

  if ( menuListenerBarControl.Ver( e)) return;
  if ( menuListenerBarControl.Control(  e)) return;

  return;
}//actionPerformed

}//class menuListener