//consulta30//
package query;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.awt.*;
import java.math.*;
import javax.swing.JDialog;

//
import kbm2l.*;
import tables.*;
import schema.*;
import control.*;
import kernel.*;

/**
* Clase consulta30.
* Tres tipos de consulta y consulta edit. 
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public   class   consulta30   extends   frame30 {

  private  static  final  String  ERROR  =  "Error(consulta30): ";
/**
* flag de ejecucion en curso
**/
  public static boolean working = false;//
/**
*
**/
  public  static  final  String  OpenValue  =  "?";
//
/**
* Texto de la consulta, dialogo.
**/
  protected static String qtexto = null;//
/**
*  Atributo activo del dialogo, foco del dialogo
**/
  protected static int ATRIBUTO = 0;//
/**
* Dominios de los atributos, texto.
**/
  protected static Vector VALORES = null;//

//queryDialog
/**
* Cuadro de dialogo para la consulta, formulario.
**/
  protected static JDialog queryDialog = null;
  
//queryDialog components

/**
* Area de texto que presenta la consulta actual
**/
  protected static TextArea taQuery = null;

/**
* Boton de accion que cierra el dialogo de consulta.
**/
  protected static Button   bExitQuery  = null;
/**
* Etiqueta del boton de accion que cierra el dialogo de consulta.
**/
  protected static String strBExitQuery = "Exit KBM2L QUERY";  

/**
* Boton de accion que lanza la consulta.
**/
  protected static Button   bQuery  = null;
/**
* Etiqueta del boton de accion que lanza la consulta.
**/
  protected static String strBQuery = "KBM2L QUERY !";  

/**
* Boton de seleccion del atributo foco de la asignacin en el dialogo de consulta.
**/
  protected static Button   bAttrib  = null;
/**
* Etiqueta del boton de seleccion del atributo foco de la asignacin en el dialogo de consulta.
**/
  protected static String strBAttrib = "KBM2L Attributes";  

//boton de tipo de query
/**
* Boton de asignacion de valores a los atributos en el dialogo de consulta
**/
  protected static Button   bValues = null;
/**
* Identificador del boton de accion del dialogo de consulta para asignar valores de dominio
* a los atributos. Sirve para identificar el tipo de pregunta: closed, open, bayes, edit.
**/  
  protected static String strBValues = "";  

  protected static String strBClosedValues  = "Closed  KBM2L  Values";  
  protected static String strBOpenValues    = "Open    KBM2L  Values";  
  protected static String strBBayesValues   = "Bayes   KBM2L  Values";  
  protected static String strBEditValues    = "Edit   KBM2L  Values";  

// Default Dialog Size and Location 
  protected static int dlgW  = 600;
  protected static int dlgH  = 250;
  protected static int dlgX  = 200;
  protected static int dlgY  = 380;

/**
* Constructor por defecto.
* Si no hay esquema de la tabla se busca, debe selecionar uno.
**/
public consulta30( ) {

  String pathKBM2L = null;
  
  if ( activel30.Esqu.numDecisiones == 0) {
  
    kbm2lSystem.estatus("Select Query Schema: *.eq  - .");
    pathKBM2L = new String( dato30.selectFile( f30.kbm2lSystem.frame, FileDialog.LOAD, "*.eq"));
    if ( pathKBM2L == null) {
      kbm2lSystem.estatus("No schema selection.");
      return ;//offset
      } 

    pathKBM2L = dato30.nameFile( pathKBM2L);
    pathKBM2L = dato30.extFile( pathKBM2L, "eq");
    activel30.Esqu = new esquema30( activel30.Name(), activel30.ParIndice(), activel30.ParRespuesta());
    activel30.Esqu.leerEq( pathKBM2L);//nombre.eq
    }//if ( eq30 == null)

  ATRIBUTO = 0;
  kbm2lSystem.estatus("Query Schema: " + activel30.Esqu.nombre);

}//consulta30

/**
* Fija la posicion de la ventana de dialogo.
**/
protected void setLocation( int x, int y) {

  queryDialog.setLocation( x, y);
  return;
}//setLocation

/**
* Fija el tamao del la ventana de  dialogo
**/
protected void setSize( int w, int h) {

  queryDialog.setSize( w, h);
  return;
}//setSize

/**
* @return el titulo de la ventana de dialogo
**/
protected String getTitle( ) {

  return queryDialog.getTitle( );
}//getTitle  

/**
* Fija el titulo de la ventana de dialogo
**/
protected void setTitle( String title) {

  queryDialog.setTitle( title);
  return;
}//setTitle  

/**
* Muestra el dialoog de consulta.
**/
protected void show() {

  //if (controlPrefs30.modalCriterion( ))
    //queryDialog.show();//modal  
    //else 
    {
  queryDialog.setVisible(true);
  queryDialog.toFront();  
   }
  return;
}//show

/**
* @return String del texto de la consulta del dialogo.
**/
protected String getText( ) {
  
  return taQuery.getText( ); 
}//getText

/**
* Fija el texto de una consulta en el dialgo.
**/
protected String setText( String text) {

  taQuery.setText( text);
  return text;  
}//setText

/**
* El vector representa un indice abierto.
* @param index Vector
* @return true/false todas las componentes libres estan agrupadas en la parte de menor peso, derecha.
**/
protected boolean open( Vector index) {

  int k = -1;
//  kbm2lSystem.append("Open Query.... Open Index: " + index + "\n");
  for( int i = 0; i < index.size(); i++) {
    if ( ((Integer)index.get( i)).intValue( ) == index30.unKB) { 
      k = i;
      break;
      }
    }  
  if ( k == -1) return true;//es una query cerrada !!!   
  for( int j = k; j < index.size(); j++) {  
    if ( ((Integer)index.get( j)).intValue( ) != index30.unKB) 
    return false;
    }
  
  return true;
}//open

/**
* Pregunta cerrada inferior compatible con la pregunta abierta
* @param indice Vector de la pregunta abierta operativa
**/
protected Vector  Qmin( Vector indice) {

  Vector indiceINF = new Vector();//en la base op
    for( int i = 0; i < indice.size(); i++)
    if (((Integer)indice.get(i)).intValue() == index30.unKB) {
      indiceINF.add( new Integer( 0));//minimo valor
    } else indiceINF.add( new Integer( ((Integer)indice.get(i)).intValue()));  
    
  return indiceINF;    
}//Qmin
  
/**
* Pregunta cerrada superior compatible con la pregunta abierta
* @param indice Vector de la pregunta abierta operativa
**/    
protected Vector Qmax( lista30 op, Vector indice) {
  
  Vector indiceSUP = new Vector();//en la base op
    for( int i = 0; i < indice.size(); i++)
    if (((Integer)indice.get(i)).intValue() == index30.unKB) {
      indiceSUP.add( new Integer( op.Base.dom( i) - 1));// maximo valor
    } else indiceSUP.add( new Integer( ((Integer)indice.get(i)).intValue()));  

  return indiceSUP;
}//Qmax

}//class consulta30