//consultaAbierta30//
package query;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
import tables.*;
import control.*;

/**
* Clase consultaAbierta30, el indice que representa la pregunta est incompleto.
* Hay 4 casos dependiendo del cardinal del conjunto de alternativas-respuestas.
* algoritmo A1, Inferencia.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class consultaAbierta30  extends  consulta30   {

  private  static  final  String  ERROR  =  "Error(consultaAbierta30): ";
  private  static  lista30 op = null;// lista operativa, atributos desconocidos en la base
 
/**
* Constructor por defecto. Fija el tipo de consulta mediante la identificacin del
* boton de accion del dialogo.
**/
public consultaAbierta30( ) {

  strBValues = new String( strBOpenValues);// consulta abierta !!!
}//consultaAbierta30

/**
* Muestra el dialogo de consulta y lanza la consulta seleccionada y muestra el resultado
* Menu action (call thread).
**/
public long consultaAbierta( ) {
//
  dlgQuery30 QDialog = new dlgQuery30( "OPEN");
  kbm2lSystem.append("Open Query....\n");
  
  QDialog.setText( activel30.Esqu.literalEq( OpenValue) + "?");//ini-dlg a valores defecto ?
  ATRIBUTO = 0;//foco del dialogo
  VALORES = activel30.Esqu.valoresEq( OpenValue);//etiqueta de valor por defecto
  qtexto = null;
  String atributo = new String(((String) activel30.Esqu.Atributos.get( ATRIBUTO)));
  QDialog.setTitle( 
    QDialog.getTitle().substring( 0, QDialog.getTitle().indexOf('['))+
    "[" + atributo + "](" + ATRIBUTO + "):" + 
    (String) VALORES.get( ATRIBUTO));//titulo de la ventana de dialogo de consulta

  String tq = taQuery.getText();
  taQuery.select(tq.indexOf( atributo),
                 tq.indexOf( atributo) + 
                   tq.substring(tq.indexOf( atributo),tq.length()).indexOf('['));

  QDialog.show();//modal  

  if ( queryDialog.isModal() && ( qtexto != null)) {
    kbm2lSystem.estatus("End of open query.");
    return 0;//
    } else {
    kbm2lSystem.estatus("Open query started.");
    return 0;//
    }
    
}//consultaAbierta

/**
* Atencion al boton de consulta.
* Cambiar la lista a la base operativa. Gestiona un indice incompleto.
* Los atributos abiertos de la consulta pasan a las posiciones inferiores de la base.
* Calcular Qmin (OffsetMin) y Qmax (OffsetMax) y el conjunto de respuestas 
* sobre el cual se proyectan.
* Analiza el conjunto de respuestas:
* |r| = 1 y es igual o distinto de unKB y
* |r| > 1 y alguna es igual y distinto de unKB. 4 casos.
* Tres bases: esquema, lista activa y operativa.
* @param l30 lista30 sobere la que se plantea la consulta.
* @param INDICE pregunta abierta en la base del esquema, generada en el dialogo.
* @return RESPUESTA Vector con la alternativa propuesta.
**/
public  Vector  openQuery( lista30 l30, Vector INDICE) {

  Vector items = null;//respuesta multiple....
  Vector openIndex = base30.Trnp( null, INDICE, l30.Base);//pregunta abierta en la base de l30
  Vector indiceINF = null;//de op
  Vector indiceSUP = null;//de op

  working = true;
  try {     
  //los atributos abiertos pasan a las posiciones inferiores de la base
    if ( open( openIndex)) {
      op = new lista30( l30, l30);//es operativa
      } else {
        op = new lista30( l30, openIndex);//abierto !!!
        op = l30.union( op);//coste !!! copiar solo entre INF y SUP
        }
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "openQuery.1");
      if ( openIndex == null) System.out.println( "openIndex");
      if ( op == null) System.out.println( "op");
      if ( l30 == null)System.out.println( "l30");
      e.printStackTrace();
      System.exit( 0);
    }//catch

  try {
    p30 = new protocolo30( );
    p30.decisiones = new Vector( );
    p30.decisiones.add( l30);
    p30.decisiones.add( op);
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "openQuery.2");
      if ( p30 == null) System.out.println( "p30");
      if ( l30 == null) System.out.println( "l30");
      if ( op == null) System.out.println( "op");
      e.printStackTrace();
      System.exit( 0);
    }//catch

//indice en la base op, con transposicion.
  Vector indice = base30.Trnp( l30.Base, openIndex, op.Base);
//  
  try {
    indiceINF = Qmin( indice);  
    indiceSUP = Qmax( op, indice);

    items = aproxKBM2L( op, indiceINF, indiceSUP);//cono de proyeccion de la query.
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "openQuery.3");
      if ( indiceINF == null) System.out.println( "indiceINF");
      if ( indiceSUP == null) System.out.println( "indiceSUP");
      if ( items == null) System.out.println( "items");
      e.printStackTrace();
      System.exit( 0);
    }//catch

  if ( items.size() == 0) {  
    kbm2lSystem.append("Open Query....  items query empty.\n");
    kbm2lSystem.append("indiceINF: " + indiceINF.toString() + ".\n");
    kbm2lSystem.append("indiceSUP: " + indiceSUP.toString() + ".\n");
    working = false;
    return null;
    }//

  try {
  if ( items.size() == 1) {
    openQuery1KB( l30, openIndex, indiceINF, indiceSUP, items);   //a   i
    openQuery1unKB( l30, openIndex, indiceINF, indiceSUP, items); //b   ii  
    }//
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "openQuery.4");
      e.printStackTrace();
      System.exit( 0);
    }//catch

  try {
  if ( items.size() > 1) {
    openQueryNKB( l30, openIndex, indiceINF, indiceSUP, items);   //c   iii
    openQueryNunKB( l30, openIndex, indiceINF, indiceSUP, items); //d   iv
    }//    
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "openQuery.5");
      e.printStackTrace();
      System.exit( 0);
    }//catch

  working = false;
  return ((Vector)((item30)items.get( 0)).GetRespuesta());// siempre existe
}//openQuery

/**
* Cono de proyeccion de una pregunta abierta, politicas L, LL, LR, U. 
* @param op lista30 operativa
* @param indiceINF indice de op
* @param indiceSUP indice de op
* @return los items de la lista operativa op en el cono indiceINF-indiceSUP
**/
private Vector aproxKBM2L( lista30 op, Vector indiceINF, Vector indiceSUP) {
// respuesta multiple.... Dos opciones: aprox superior (U) e inferior (L).
//         --inf-----------------------------sup---
//                     i------------s
//        i-----------s       
//                                    i-----------------s
//   i------------------------------------------------s
  Vector items = new Vector();

  kbm2lSystem.append("aproxKBM2L: \n"+ 
    "INF: " + indiceINF.toString() + "  SUP: " + indiceSUP.toString() + ".\n");

  String AproxType = new controlPrefs30().aproxClosedQuery();

  try {

//recorre toda la lista op ........................  
  for( int k = 0; k < op.size(); k++) {

    if ( !working) {
      kbm2lSystem.estatus("AproxType: " + AproxType + "  k: " + k);
      break;
      }

    if ( index30.myT( op.Inf( k), indiceSUP)) {
      kbm2lSystem.estatus("AproxType: " + AproxType + "  k: " + k);
      break;
      }
      
    if ( !index30.myT( indiceINF, op.Sup( k))) {

      item30 it = op.Get( k);

  if ( AproxType.equals( kbm2lControl.Lower)) { //Lower Aprox es por defecto
    kbm2lSystem.append(" --> " + AproxType + " --> ");
//         --inf-----------------------------sup---
//                     i------------s
    if ( index30.myeqT( op.Inf( k), indiceINF) && 
         index30.myeqT( indiceSUP, op.Sup( k))) {
           if ( items.indexOf( it) == -1)
             items.add( it);//de op, con repeticiones !, ordenada por tamao ? 
       }//if
       else {
       kbm2lSystem.append("Inf: " + op.Inf( k) + "  Sup: " + op.Sup( k) + ".\n");
       }
  } //else
  if ( AproxType.equals( kbm2lControl.Left)||AproxType.equals( kbm2lControl.Upper)) { //Left Aprox
    kbm2lSystem.append(" --> " + AproxType + " --> ");
//         --inf-----------------------------sup---
//        i-----------s       
    if ( index30.myeqT( indiceINF, op.Inf( k)) && 
         index30.myeqT( indiceSUP, op.Sup( k))) {
           if ( items.indexOf( it) == -1)
             items.add( it);//de op, con repeticiones !, ordenada por tamao ? 
        }//if   
       else {
       kbm2lSystem.append("Inf: " + op.Inf( k) + "  Sup: " + op.Sup( k) + ".\n");
       }
  } //else 
  if ( AproxType.equals( kbm2lControl.Right)||AproxType.equals( kbm2lControl.Upper)) { //Right Aprox
    kbm2lSystem.append(" --> " + AproxType + " --> ");
//         --inf-----------------------------sup---
//                                    i-----------------s
    if ( index30.myeqT( op.Inf( k), indiceINF) && 
         index30.myeqT( op.Sup( k), indiceSUP)) {
           if ( items.indexOf( it) == -1)
             items.add( it);//de op, con repeticiones !, ordenada por tamao ? 
      }//if
       else {
       kbm2lSystem.append("Inf: " + op.Inf( k) + "  Sup: " + op.Sup( k) + ".\n");
       }
  } //else 
//siempre entra este item, es una caso preciso, it soporta toda la pregunta (INF,SUP)
  if ( true || AproxType.equals( kbm2lControl.Upper)) { //Upper Aprox es por defecto
    kbm2lSystem.append(" --> " + AproxType + " --> ");
//         --inf-----------------------------sup---
//   i------------------------------------------------s
    if ( index30.myeqT( indiceINF, op.Inf( k)) && 
         index30.myeqT( op.Sup( k) ,indiceSUP)) {
           if ( items.indexOf( it) == -1)
             items.add( it);//de op, con repeticiones !, ordenada por tamao ? 
       }//if
       else {
       kbm2lSystem.append("Inf: " + op.Inf( k) + "  Sup: " + op.Sup( k) + ".\n");
       }
    }  

    }//if 

  }//for

    }//try
    catch (Exception e) {
      System.out.println( ERROR + "aproxKBM2L()");
      e.printStackTrace();
      System.exit( 0);
    }//catch

  return items;
}//aproxKBM2L

/**
* Pregunta abierta tipo 1KB: una unica alternativa de respuesta conocida.
**/
private Vector openQuery1KB( lista30 l30,
  Vector openIndex, Vector indiceINF, Vector indiceSUP, Vector items) {

  Vector RESPUESTA = ((Vector)((item30)items.get( 0)).GetRespuesta());// siempre existe
  try {
  if (!index30.eqS(((Vector)((item30)items.get( 0)).GetRespuesta()), l30.UNKB)) { 
  // RESPUESTA OK

      setText( qtexto.substring( 0, qtexto.indexOf('?')+1) + "\n" +
        activel30.Esqu.consultaEqRespuesta( RESPUESTA)); //str al dlg

      //openIndex en base l30, indiceINF e indiceSUP en op, items en op y RESPUESTA
      openQueryDetails( l30, openIndex, indiceINF, indiceSUP, items, RESPUESTA,
        "Open case and accurate knowledged answer.1-KB");

    }//if

    }//try
    catch (Exception e) {
      System.out.println( ERROR + "openQuery1KB()");
      e.printStackTrace();
      System.exit( 0);
    }//catch
    
  return RESPUESTA;    
}//openQuery1KB

/**
* Pregunta abierta tipo 1unKB: una unica alternativa de respuesta desconocida.
* La descompone en dos preguntas cerradas enfocadas en los extremos de la pregunta.
**/
private Vector openQuery1unKB( lista30 l30,
  Vector openIndex, Vector indiceINF, Vector indiceSUP, Vector items) {

  Vector RESPUESTA = null;
  
  if ( items.size() != 1) {
      System.out.println( ERROR + "openQuery1unKB(). items.size() != 1.");
      System.exit( 0);
    }//?
  
  try {
    if ( index30.eqS(((Vector)((item30)items.get( 0)).GetRespuesta()), l30.UNKB)) { 
  // RESPUESTA OK

     //en la base del esquema. 
     kbm2lBrowser.append("\nOpenQuery1unKB(INF).");
     Vector respuestaINF = //sera inferida
       new consultaCerrada30().closedQuery( l30, base30.Trnp( op.Base, indiceINF, null));
     
     kbm2lBrowser.append("\nOpenQuery1unKB(SUP).");
     Vector respuestaSUP = //sera inferida
       new consultaCerrada30().closedQuery( l30, base30.Trnp( op.Base, indiceSUP, null));

      setText( qtexto.substring( 0, qtexto.indexOf('?')+1) + 
        activel30.Esqu.consultaEqRespuesta( respuestaINF) + "\n" + 
        activel30.Esqu.consultaEqRespuesta( respuestaSUP)); //str al dlg

     //openIndex en base l30, indiceINF e indiceSUP en op, items en op y RESPUESTA
     RESPUESTA = ((Vector)((item30)items.get( 0)).GetRespuesta());// siempre existe
     openQueryDetails( l30, openIndex, indiceINF, indiceSUP, items, RESPUESTA,
       "Open case and proximity inference type.1-unKB");
     
    }//if

    }//try
    catch (Exception e) {
      System.out.println( ERROR + "openQuery1unKB()");
      e.printStackTrace();
      System.exit( 0);
    }//catch

  return RESPUESTA;    
}//openQuery1unKB

/**
* Pregunta abierta tipo NKB: multiples alternativas de respuesta conocida.
**/
private Vector openQueryNKB( lista30 l30, 
  Vector openIndex, Vector indiceINF, Vector indiceSUP, Vector items) {

  Vector RESPUESTA = ((Vector)((item30)items.get( 0)).GetRespuesta());// siempre existe
  try {

  if ( !anyUNKB( l30, items)) { // RESPUESTA OK

//?
      setText( qtexto.substring( 0, qtexto.indexOf('?')+1) + "\n" +
        activel30.Esqu.consultaEqRespuesta( RESPUESTA)); //str al dlg

     //openIndex en base l30, indiceINF e indiceSUP en op, items en op y RESPUESTA
     openQueryDetails( l30, openIndex, indiceINF, indiceSUP, items, RESPUESTA,
       "Open case and accurate knowledged answer.N-KB");

    }//if

    }//try
    catch (Exception e) {
      System.out.println( ERROR + "openQueryNKB()");
      e.printStackTrace();
      System.exit( 0);
    }//catch

  return RESPUESTA;    
}//openQueryNKB

/**
* Pregunta abierta tipo NKB: multiples alternativas con respuesta desconocida.
**/
private Vector openQueryNunKB( lista30 l30, 
  Vector openIndex, Vector indiceINF, Vector indiceSUP, Vector items) {

  Vector RESPUESTA = ((Vector)((item30)items.get( 0)).GetRespuesta());// siempre existe
  try {

  if ( anyUNKB( l30, items)) { // RESPUESTA OK

//?
      setText( qtexto.substring( 0, qtexto.indexOf('?')+1) + "\n" +
        activel30.Esqu.consultaEqRespuesta( RESPUESTA)); //str al dlg

     //openIndex en base l30, indiceINF e indiceSUP en op, items en op y RESPUESTA
     openQueryDetails( l30, openIndex, indiceINF, indiceSUP, items, RESPUESTA,
       "Open case and proximity inference type.N-unKB");

    }//if

    }//try
    catch (Exception e) {
      System.out.println( ERROR + "openQueryNunKB()");
      e.printStackTrace();
      System.exit( 0);
    }//catch

  return RESPUESTA;    
}//openQueryNunKB

/**
* Hay alguna politica desconocida en el conjunto de items.
* @params items un conjunto de items.
* @return true si encuentra alguna politica deconocida, en otro caso false
**/
private boolean anyUNKB( lista30 l30, Vector items) {

  for( int k = 0; k < items.size(); k++) {
    if ( index30.eqS( ((item30)items.get( k)).GetRespuesta(), l30.UNKB))
      return true;
    }
 
  return false;
}//anyUNKB

/**
* Detalles de la consulta abierta, gestion interna de la consulta.
* Se muestra si propiedad de las preferencias "BrowseQuery" es "Yes".
* Pregunta abierta, pregunta operativa, base original, base operativa,
* Qmin, Qmax, Respuestas,
* Base, q-indice en BC, q-indice en l30Base, r-indice del item, offset del q-indice 
* offset del r-indice, codigo de respuesta y literal de respuesta.
**/
private  void  openQueryDetails( lista30 l30, Vector openIndex, Vector indiceINF, Vector indiceSUP, 
  Vector items, Vector RESPUESTA, String  queryType) {

  if ( new controlPrefs30().browserQuery()) {

    kbm2lSystem.append( "Open Query...." + queryType + "\n");//
    kbm2lBrowser.append("\nQuery details:\n");

    try {
    
    BigInteger omin = new offset30().offset( 
      l30.Base.Dom(), base30.Trnp( op.Base, indiceINF, l30.Base));
    BigInteger omax = new offset30().offset( 
      l30.Base.Dom(), base30.Trnp( op.Base, indiceSUP, l30.Base));

    kbm2lBrowser.append("Inital Open Query:    " + openIndex + ".\n");
    kbm2lBrowser.append("Operative Open Query: " + base30.Trnp( null, openIndex, op.Base) + ".\n");

    kbm2lBrowser.append("Original base:        " + l30.Base + ".\n");
    kbm2lBrowser.append("indiceINF: "  + 
      base30.Trnp( op.Base, indiceINF, l30.Base).toString() + ".\n");
    kbm2lBrowser.append("indiceSUP: "  + 
      base30.Trnp( op.Base, indiceSUP, l30.Base).toString() + ".\n");
    kbm2lBrowser.append("OFFSET(MIN):   " + omin.toString() + "  ");
    kbm2lBrowser.append("OFFSET(MAX):   " + omax.toString() + "  ");
    kbm2lBrowser.append("query size:   " + 
      omax.add( omin.negate()).add( BigInteger.ONE).toString() +"\n");
        
    kbm2lBrowser.append("\n");      

    omin = new offset30().offset( op.Base.Dom(), indiceINF);
    omax = new offset30().offset( op.Base.Dom(), indiceSUP);
    
    kbm2lBrowser.append("Operative base:       " + op.Base + ".\n");
    kbm2lBrowser.append("indiceINF: "  + indiceINF + ".\n");
    kbm2lBrowser.append("indiceSUP: "  + indiceSUP + ".\n");
    kbm2lBrowser.append("OFFSET(MIN):   " + omin.toString() + "  ");
    kbm2lBrowser.append("OFFSET(MAX):   " + omax.toString() + "  ");
    kbm2lBrowser.append("query size:   " + 
      omax.add( omin.negate()).add( BigInteger.ONE).toString() +"\n");

    kbm2lBrowser.append("\n");      

    kbm2lBrowser.append("RESPUESTAS: " + items.size() + "\n");
    for( int k = 0; k < items.size(); k++) {
      item30 it = ((item30)items.get( k));
      kbm2lBrowser.append("Item: " + it.GetRespuesta().toString() + "   Explanation: fix" +
        op.Fij( op.indexOf( op.GET( it.GetIndice()))) + "  var" +
        op.Var( op.indexOf( op.GET( it.GetIndice()))) +"\n");
      }
    kbm2lBrowser.append("\n");      

    kbm2lBrowser.append("IxRespuesta: " + RESPUESTA.toString() + "\n");
    kbm2lBrowser.append( //unidimensional-0
      activel30.Esqu.consultaEq( base30.Trnp( l30.Base, openIndex, null), RESPUESTA));

    }//try
    catch (Exception e) {
      System.out.println( ERROR + "openQueryDetails()");
      e.printStackTrace();
      System.exit( 0);
    }//catch

    }//if

  return ;
}//openQueryDetails

/**
* working 
* call consultaAbierta( );
**/
public void run() {

  if ( !working) {
    try {
      consultaAbierta( );
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "run()");
      e.printStackTrace();
      System.exit( 0);
    }//catch
  }
  return;
}//run

}//consultaAbierta30

