//consultaCerrada30//
package query;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.awt.*;
import java.math.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
import control.*;

/**
* Clase consultaCerrada30, el indice que representa la pregunta est completo.
* 
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class consultaCerrada30  extends  consulta30  {

/**
* Identificador de mensajes de error de la clase consultaCerrada30
**/
  private static final String ERROR = "Error(consultaCerrada30): ";

/**
* Constructor por defecto.
* Fija el tipo de dilogo con valores cerrados
* @see consulta30#strBValues 
**/
public consultaCerrada30( ) {

  strBValues = new String( strBClosedValues);// consulta cerrada !!!
}//consultaCerrada30

/**
* Muestra el dialogo de consulta y lanza la consulta seleccionada y muestra el resultado.
* Menu action --> (call thread).
**/
public long consultaCerrada( ) {
//
  dlgQuery30 QDialog = new dlgQuery30( "CLOSED");    
  kbm2lSystem.append( "Closed Query....\n");

  QDialog.setText( f30.activel30.Esqu.literalEq() + "?");//ini-dlg a valores defecto
  ATRIBUTO = 0;//foco del dialogo
  VALORES = f30.activel30.Esqu.valoresEq();//valores por defecto
  qtexto = null;//!!!
  String atributo = new String(((String) activel30.Esqu.Atributos.get( ATRIBUTO)));
  QDialog.setTitle( 
    QDialog.getTitle().substring( 0, QDialog.getTitle().indexOf('['))+
    "[" + atributo + "](" + ATRIBUTO + "):" + 
    (String) VALORES.get( ATRIBUTO));//titulo de la ventana de dialogo de consulta

  String tq = taQuery.getText();
  taQuery.select(tq.indexOf( atributo),
                 tq.indexOf( atributo) + 
                   tq.substring(tq.indexOf( atributo),tq.length()).indexOf('['));

  QDialog.show();//modal  

  if ( queryDialog.isModal() && ( qtexto != null)) {
    kbm2lSystem.estatus("End of closed query.");
    return 0;//working <- false on exit-button
    } else {
    kbm2lSystem.estatus("Closed query started.");
    return 0;//working <- false on exit-button
    }

}//consultaCerrada

/**
* Para un INDICE completo exclusivamente. 
* Recupera (GET) el item de interes con el indice transpuesto.
* Recupera la Respuesta. Si es conocido la presenta en el dialogo el resultado.
* Si es desconocida infiere por proximidad en la lista las alternetivas.
* Es el proc de evento del boton "KBM2L QUERY !" para las pregunta cerrada.
* @see consulta30#strBQuery
* @see consultaCerrada30#closedQueryDetails(lista30,item30,Vector,Vector,double,double,String)
* @see consultaCerrada30#mostrarClosedQuery(lista30,Vector,String)
* @see consultaCerrada30#inferirClosedQuery(lista30,Vector)
* @param INDICE vector de valores (codificados) de los atributos del esquema genrado en el dialogo.
* en la base del esquema (BC).
* @return RESPUESTA !!
**/
public  Vector  closedQuery( lista30 l30, Vector INDICE) {

  Vector RESPUESTA = null;
  if ( INDICE.indexOf( new Integer( -1)) == -1) { //es cerrada o abierta ?
    //la KBM2L esta en general en otra base diferene a la del INDICE y el esquema (BC)
    item30 item = l30.GET( base30.Trnp( null, INDICE, l30.Base));//la base de l30
    RESPUESTA = (Vector)item.GetRespuesta();
    //dos casos: conocido y desconocido.
    if ( !index30.eqT( RESPUESTA, l30.UNKB)) { //RESPUESTA OK unidimensional
  
      //RESPUESTA conocida != l30.UNKB
      RESPUESTA = mostrarClosedQuery( l30, INDICE, "Full case and knowledged answer.");    
      kbm2lSystem.estatus("Closed Query End.");

      } else { // INFERIR RESPUESTA desconocida
            
       //RESPUESTA desconocida l30.UNKB
       RESPUESTA = inferirClosedQuery( l30, INDICE);    
      }         
  }
  else {
    int c = INDICE.indexOf( new Integer( -1));
    kbm2lSystem.append("Closed Query with incomplete index. Attribute: " + c + " in \n" + qtexto);
    //RESPUESTA null
    }
      
  return RESPUESTA;        
}//closedQuery

/**
* Recupera la informacion. Muestra detalles segn las preferencias de consultas
* @see base30#Trnp(base30,Vector,base30) 
* @see lista30#GET(Vector)
* @param INDICE pregunta cerrada formaulada sobre el esquema
* @param queryType String inf-mensaje
* @return RESPUESTA
**/
protected Vector mostrarClosedQuery( lista30 l30, Vector INDICE, String  queryType) {

  item30 item = l30.GET( base30.Trnp( null, INDICE, l30.Base));//en la base de l30
  Vector RESPUESTA = (Vector)item.GetRespuesta();
  String strInstancia = qtexto.substring( 0, qtexto.indexOf('?')+1);
  String strRespuesta = activel30.Esqu.consultaEqRespuesta( RESPUESTA);

  setText( strInstancia + strRespuesta); //str al dlg

  closedQueryDetails( l30, item, RESPUESTA, INDICE, 0.0, 0.0, queryType);//

  return RESPUESTA; 
}//mostrarClosedQuery

/**
* Inferir por proximidad la respuesta de una consulta que no se conoce.
* Se deben considerar varias bases en el entorno GH2 de la optima y evaluar 
* los escenarios del item anfitrion desconocido: KNN-KBM2L versus evaluar el modelo de DI.
* RESPUESTAS: --- Q -------- R ----------------- S -------- 
* y R == unKB. 3 escenarios posibles segun el num item en la lista:
* 0. lista vacia sin informacion
* 1. Caso primero:  extremo de la lista, se puede investigar otra base
* 2. Caso intermedio: Estudio de Q y S:
* 2.1 si Q == S R es Q.
* 2.2 si Q != S es R es el valor mas prximo.
* Se pueden investigar otras bases.
* 3. Caso ltimo: extremo de la lista, se puede investigar otra base
* @param INDICE vector de valores (codificados) de los atributos del esquema
* en la base del esquema (BC).
* @return RESPUESTA !!
**/
protected Vector inferirClosedQuery( lista30 l30, Vector INDICE) {

  Vector Q = null;//RESPUESTAS: Q --- R --- S
  Vector S = null;
  Vector RESPUESTA = null;

  //es desconocido, los flancos son conocidos o son los extremos.
  item30 itemY = l30.GET( base30.Trnp( null, INDICE, l30.Base));// el item anfitrion desconocido  
  int y = l30.indexOf( itemY);// Criterio de escenario !!!
  BigInteger Y = new offset30().offset( l30.Base.Dom(), itemY.GetIndice());// Offset
  //flancos de R
  item30 itemX = null;
  BigInteger X = null;
  item30 itemZ = null;
  BigInteger Z = null;
//informacion metrica
  double g = 0.0;//amplitud del item de R
  double Prq = 0.0;//segmento de QR
  double Prs = 0.0;//segmento de RS

  if ( l30.size() == 1) {
  
    kbm2lSystem.estatus("Closed Query End. Empty list. No Inference");
    //RESPUESTA null    
  } else

  if ( y == 0) {// extremo inf
//se podia investiga otra base
    itemZ = l30.Get( y+1);
    Z = new offset30().offset( l30.Base.Dom(), l30.Inf( y+1));// Offset
    S = itemZ.GetRespuesta();

//informacion metrica
    g = (Z.subtract( BigInteger.ZERO)).doubleValue();//amplitud del item de R
    Prq = (Y.subtract( BigInteger.ZERO)).doubleValue() / g;//segmento de QR
    Prs = (Z.subtract( Y)).doubleValue() / g;//segmento de RS
    String strInstancia = qtexto.substring( 0, qtexto.indexOf('?')+1);

    setText( strInstancia + activel30.Esqu.consultaEqRespuesta( S)); //str al dlg
//mas informacion: de proximidad y de amplitud del item. !!!
      closedQueryDetails( l30, itemY, S, INDICE, Prq, Prs,
        "Full case and proximity inference type y=0.");
      kbm2lSystem.estatus("Closed Query End.");
      RESPUESTA = S;//ret
    }//

    else if (( y > 0) && ( y < l30.size()-1)) {// caso generico

//informacion de flancos de y: y-1 de Q en X e y+1 de S en Z.
    itemX = l30.Get( y-1);
    X = new offset30().offset( l30.Base.Dom(), l30.Sup( y-1));// Offset
    Q = itemX.GetRespuesta();

    itemZ = l30.Get( y+1);
    Z = new offset30().offset( l30.Base.Dom(), l30.Inf( y+1));// Offset
    S = itemZ.GetRespuesta();

//informacion metrica
    g = (Z.subtract( X)).doubleValue();//amplitud del item de R
    Prq = (Y.subtract( X)).doubleValue() / g;//segmento de QR
    Prs = (Z.subtract( Y)).doubleValue() / g;//segmento de RS
    String strInstancia = qtexto.substring( 0, qtexto.indexOf('?')+1);

    if ( index30.eqT( Q, S)) {// son iguales

      setText( strInstancia + activel30.Esqu.consultaEqRespuesta( Q)); //str al dlg
//mas informacion: de proximidad y de amplitud del item. !!!
      closedQueryDetails( l30, itemY, Q, INDICE, Prq, Prs,
        "Full case and default inference type.");
      kbm2lSystem.estatus("Closed Query End.");
      RESPUESTA = Q;//ret
    
      }//if
      else {

        setText( strInstancia + 
               activel30.Esqu.consultaEqRespuesta( Q) +
               "   prox: " + Prq + "\n" +
               activel30.Esqu.consultaEqRespuesta( S) +
               "   prox: " + Prs); //str al dlg

        kbm2lSystem.estatus("Closed Query End.");

        if ( Prq < Prs) {
          closedQueryDetails( l30, itemY, Q, INDICE, Prq, Prs,
            "Full case and proximity inference type <.");
          RESPUESTA = Q;//ret
          }
          else if ( Prq >= Prs) {
            closedQueryDetails( l30, itemY, S, INDICE, Prq, Prs, 
              "Full case and proximity inference type >=.");
            RESPUESTA = S;//ret
          }
      }

    }//
    else if ( y == l30.size()-1) {// extremo sup
//se podia investigar otra base
      itemX = l30.Get( y-1);
      X = new offset30().offset( l30.Base.Dom(), l30.Sup( y-1));// Offset
      Q = itemX.GetRespuesta();

    Z = new offset30().offset( l30.Base.Dom(), l30.Sup( y));// Offset
//informacion metrica
    g = (Z.subtract( BigInteger.ZERO)).doubleValue();//amplitud del item de R
    Prq = (Y.subtract( BigInteger.ZERO)).doubleValue() / g;//segmento de QR
    Prs = (Z.subtract( Y)).doubleValue() / g;//segmento de RS
    String strInstancia = qtexto.substring( 0, qtexto.indexOf('?')+1);

    setText( strInstancia + activel30.Esqu.consultaEqRespuesta( Q)); //str al dlg
//mas informacion: de proximidad y de amplitud del item. !!!
      closedQueryDetails( l30, itemX, Q, INDICE, Prq, Prs,
        "Full case and proximity inference type 1.");
      kbm2lSystem.estatus("Closed Query End.");
      RESPUESTA = Q;//ret
    }//
  
  return RESPUESTA;
}//inferirClosedQuery

/**
* Detalles de la consulta cerrada, gestion interna de la consulta.
* Se muestra si propiedad de las preferencias "BrowseQuery" es "Yes".
* Base, q-indice en BC, q-indice en l30.Base, r-indice del item, offset del q-indice 
* offset del r-indice, codigo de respuesta y literal de respuesta.
**/
protected  void  closedQueryDetails( lista30 l30, item30 item, Vector RESPUESTA, Vector INDICE,
  double Prq, double Prs, String  queryType) {

  if ( new controlPrefs30().browserQuery()) {
 
    kbm2lSystem.append( "Closed Query...." + queryType + "\n");//
    kbm2lBrowser.append("\nQuery details:\n");

    try {
    kbm2lBrowser.append("KBM2L (Base): " + l30.Base.toString() + "\n\n");
    kbm2lBrowser.append("INDEX(BC):    " + INDICE.toString() + "\n");
    kbm2lBrowser.append("INDEX(B_):    " + base30.Trnp( null, INDICE, l30.Base).toString() + "\n");
    kbm2lBrowser.append("INDEX(item):  " + item.GetIndice().toString() + "\n");
    kbm2lBrowser.append("FIX(item):    " + 
      l30.Fij( l30.indexOf( l30.GET( base30.Trnp( null, INDICE, l30.Base)))) + "\n");
    kbm2lBrowser.append("VAR(item):    " + 
      l30.Var( l30.indexOf( l30.GET( base30.Trnp( null, INDICE, l30.Base)))) + "\n");
    kbm2lBrowser.append("LONG(item):    " + item.getLongitud() + "\n");
    kbm2lBrowser.append("OFFSET(INDEX):   " + 
      new offset30().offset( l30.Base.Dom(), base30.Trnp( null, INDICE, l30.Base)).toString() + "   ");
    kbm2lBrowser.append("OFFSET(item):   " + 
      new offset30().offset( l30.Base.Dom(), item.GetIndice()).toString() + "\n\n");
    kbm2lBrowser.append("IxRespuesta: " + item.GetRespuesta().toString() + "\n");

    if (!(( Prq == 0.0) && ( Prs == 0.0)))
      kbm2lBrowser.append("Proximity.    Prq: " + Prq + "    Prs: " + Prs +"\n");
    kbm2lBrowser.append( //unidimensional-0
      activel30.Esqu.consultaEq( INDICE, RESPUESTA));

    }//try
    catch (Exception e) {
      kbm2lSystem.append( ERROR + "openQueryDetails()\n");
      exit( 0);
    }//catch

    }//if

  return ;
}//closedQueryDetails

/**
* 
**/
public void run() {

  if ( !working) {
    try {
      consultaCerrada( );
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "run()");
      e.printStackTrace();
      System.exit( 0);
    }//catch
  } else 
    kbm2lSystem.estatus("Exit KBM2L QUERY dialog before launch a new query.");

  return;
}//run

}//consultaCerrada30