//consultaEdit30//
package query;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.awt.*;
import java.math.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
import control.*;

/**
* Clase consultaEdit30, Consulta abierta con politica forzada. item-regla -> l30
* Se operativiza y une a activel30, Opciones de union.
* Por defecto sobrescribe, debe editar los items de menor a mayor importancia.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class consultaEdit30  extends  consulta30  implements  Runnable {

  private  static  final  String  ERROR  =  "Error(consultaEdit30): ";
  private  static  final  String  OpenValue  =  "...";
  private  static  lista30 op = null;// lista operativa, atributos desconocidos en la base
  
/**
* Constructor por defecto. Fija el tipo de consulta mediante la identificacin del
* boton de accion del dialogo.
**/
public consultaEdit30( ) {

  strBValues = new String( strBEditValues);// consulta edit !!!
}//consultaEdit30

/**
* Muestra el dialogo de consulta y lanza la consulta seleccionada y muestra el resultado
* Menu action (call thread).
**/
public long consultaEdit( ) {
//
  dlgQuery30 QDialog = new dlgQuery30( "EDIT");
  kbm2lSystem.append("Edit Query....\n");
  
  QDialog.setText( activel30.Esqu.literalEq( OpenValue) + "?");//ini-dlg a valores defecto ?
  ATRIBUTO = 0;//foco del dialogo
  VALORES = activel30.Esqu.valoresEq( OpenValue);//etiqueta de valor por defecto
  qtexto = null;
  String atributo = new String(((String) activel30.Esqu.Atributos.get( ATRIBUTO)));
  QDialog.setTitle( 
    QDialog.getTitle().substring( 0, QDialog.getTitle().indexOf('['))+
    "[" + atributo + "](" + ATRIBUTO + "):" + 
    (String) VALORES.get( ATRIBUTO));//titulo de la ventana de dialogo de consulta

  String tq = taQuery.getText();
  taQuery.select(tq.indexOf( atributo),
                 tq.indexOf( atributo) + 
                   tq.substring(tq.indexOf( atributo),tq.length()).indexOf('['));

  QDialog.show();//modal  

  if ( queryDialog.isModal() && ( qtexto != null)) {
    kbm2lSystem.estatus("End of edit query.");
    return 0;//
    } else {
    kbm2lSystem.estatus("Edit query started.");
    return 0;//
    }
    
}//consultaEdit

/**
* Cierre del indice unKN ---> 0
**/
private Vector close( Vector indx) {

  Vector index = index30.cpT( indx);
  for( int i = 0; i < index.size(); i++) {
    if ( ((Integer)index.get( i)).intValue( ) == kbm30.unKB) { 
      index.set( i, new Integer( 0));
      }
    } 
  return index;
}//close

/**
* Cierre del indice unKN ---> (Di)-1
**/
private Vector close( Vector dominio, Vector indx) {

  Vector index = index30.cpT( indx);
  for( int i = 0; i < index.size(); i++) {
    if ( ((Integer)index.get( i)).intValue( ) == kbm30.unKB) { 
      int d = ((Integer)dominio.get( i)).intValue( ) - 1;
      index.set( i, new Integer( d));
      }
    } 
  return index;
}//close

/**
* Tamao de los datos de la editQuery.
**/
private BigInteger dataSize( Vector dominio, Vector indx) {

  Vector index = index30.cpT( indx);
  BigInteger ds = new BigInteger( "1");
  BigInteger D = new BigInteger( "0");
  for( int i = 0; i < index.size(); i++) {
    if ( ((Integer)index.get( i)).intValue( ) == kbm30.unKB) { 
      Integer d = (Integer)dominio.get( i);
      D = new BigInteger( d.toString( ));
      ds = ds.multiply( D);
//      System.out.println( ds.toString() + "  " + D.toString());
      }
    } 
  return ds;
}//dataSize

/**
* Atencion al boton de consultaEdit.
* Cambiar la lista a la base operativa. Gestiona un indice incompleto.
* el usuario introduce indices abiertos y la polica, si introduce unKB se asume coKB.
* @param l30 lista30 sobere la que se plantea la consulta.
* @param INDICE pregunta Edit en la base del esquema, generada en el dialogo.
* @return RESPUESTA Vector con la alternativa propuesta.
**/
public  Vector  editQuery( lista30 l30, Vector INDICE) {

  Vector openIndex = base30.Trnp( null, INDICE, l30.Base);//pregunta abierta en la base de l30
  Vector operativeIndex = null;

  Vector indice = null;
  Vector respuesta = new Vector( );      
  Vector medida = new Vector( );

  try {     
  //los atributos abiertos pasan a las posiciones inferiores de la base
    item30 item = null;
     
    op = new lista30( l30, openIndex);//abierto !!!
    op.ini_();//se captura la estructura del fichero y no inicializa el gestor (ini()).

    //indice en la base op, con transposicion.
    operativeIndex = base30.Trnp( l30.Base, openIndex, op.Base);

    medida.add( new Double( -1.0));
    respuesta.add( new Integer( new controlPrefs30().focusPolicy( )));
    if ( index30.eqS( respuesta, l30.UNKB)) {
      respuesta = new Vector( );
      respuesta.add( new Integer( l30.coKB));
      }   

    indice = close( operativeIndex);

    if ( !index30.eqT( indice, index30.primeroT( op.Base.Dom( ))) && 
         !index30.eqT( indice, index30.ultimoT( op.Base.Dom( )))) {

      indice = index30.anteriorT( op.Base.Dom(), indice);
      item = new item30( op, medida, l30.UNKB, indice);
      op.SET( item);

      indice = close( op.Base.Dom(), operativeIndex);
      item = new item30( op, medida, respuesta, indice);
      op.SET( item);

      indice = index30.ultimoT( op.Base.Dom( ));
      item = new item30( op, medida, l30.UNKB, indice);
      op.SET( item);              
      }
      else
    if ( index30.eqT( indice, index30.primeroT( op.Base.Dom( )))) {

      indice = close( op.Base.Dom(), operativeIndex);
      item = new item30( op, medida, respuesta, indice);
      op.SET( item);

      indice = index30.ultimoT( op.Base.Dom( ));
      item = new item30( op, medida, l30.UNKB, indice);
      op.SET( item);              
      }
      else
    if ( index30.eqT( indice, index30.ultimoT( op.Base.Dom( )))) {

      indice = index30.anteriorT( op.Base.Dom(), indice);
      item = new item30( op, medida, l30.UNKB, indice);
      op.SET( item);

      indice = close( op.Base.Dom(), operativeIndex);
      item = new item30( op, medida, respuesta, indice);
      op.SET( item);
      }
     
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "editQuery.1");
      if ( openIndex == null) System.out.println( "openIndex");
      if ( operativeIndex == null) System.out.println( "operativeIndex");
      if ( op == null) System.out.println( "op");
      if ( l30 == null)System.out.println( "l30");
      e.printStackTrace();
      System.exit( 0);
    }//catch

  new checkList30( ).chk( op, "consultaEdit op");

  try {
    kbm2lSystem.append("Edit Query...." + dataSize( op.Base.Dom( ), operativeIndex) + "\n");
  
    l30 = op.union( l30);//coste union
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "openQuery.2");
      if ( l30 == null) System.out.println( "l30");
      if ( op == null) System.out.println( "op");
      e.printStackTrace();
      System.exit( 0);
    }//catch

  new checkList30( ).chk( l30, "consultaEdit l30");

  f30.activel30 = l30;
  return respuesta;// siempre existe
}//editQuery

/**
* working 
* call consultaEdit( );
**/
public void run() {

  if ( !working) {
    try {
      consultaEdit( );
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "run()");
      e.printStackTrace();
      System.exit( 0);
    }//catch
  }
  return;
}//run

}//class consultaEdit30

