//consultaGeneral30//
package query;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.awt.*;
import java.math.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
import control.*;
import tables.*;
import lbnk2.*;
import xbneditor.*;

/**
* Clase consultaGeneral30. Consulta a la lista activa l30.
* Algoritmo A2, dataset for bayes learning y -> .xml -> .net.
**/
public class consultaGeneral30  extends  consulta30  implements  Runnable {

  private  static  final   String  ERROR  =  "Error(consultaGeneral30): ";
  private  static  final   String  GeneralValue  =  consulta30.OpenValue;
  private  static  String  dataSetName  =  "subKBM2L.dat";//learning bayes-net
  private  static  lista30 op = null;// lista operativa, atributos desconocidos en la base

/**
* Tamao del conjunto de datos de aprendizaje de la red bayesiana en el algoritmo A2.
* El conjunto de datos es la explicacion de los items que se solapan con la pregunta abierta
* Cada explicacion se replica segun el tamao del item. Los atributos irrelevantes son NA 
* Se puede recortar el tamao proporcionalmente
**/
  public   static  long    dataSetSize = -1; // todo

/**
* Constructor por defecto.
* Fija el tipo de dilogo con valores cerrados.
* Fija el tamao del conjunto de aprendizaje.
* @see consulta30#strBValues 
**/
public consultaGeneral30( ) {

  strBValues = new String( consulta30.strBBayesValues);// consulta general !!!
// tamao de la muestra, producto de dominio no instanciados  
//  dataSetSize = (new offset30().getLONGITUD( l30.getDominio())).add( BigInteger.ONE))).lonValue();
// tamao de la muestra, KB-casos
// dataSetSize =  l30.KB();
// tamao de la muestra, preferencias
  dataSetSize = new controlPrefs30( ).subKBLearningSize( );//-1;
}//consultaGeneral30

/**
* Muestra el dialogo de consulta y lanza la consulta seleccionada y muestra el resultado
* Menu action (call thread).
**/
public long consultaGeneral( ) {
//
  dlgQuery30 QDialog = new dlgQuery30( "GENERAL");
  kbm2lSystem.append( "General Query....\n");

  QDialog.setText( activel30.Esqu.literalEq( GeneralValue) + "?");//ini-dlg a valores defecto ?
  ATRIBUTO = 0;//foco del dialogo
  VALORES = activel30.Esqu.valoresEq( GeneralValue);//etiqueta de valor por defecto
  qtexto = null;
  String atributo = new String(((String) activel30.Esqu.Atributos.get( ATRIBUTO)));
  QDialog.setTitle( 
    QDialog.getTitle().substring( 0, QDialog.getTitle().indexOf('['))+
    "[" + atributo + "](" + ATRIBUTO + "):" + 
    (String) VALORES.get( ATRIBUTO));//titulo de la ventana de dialogo de consulta

  String tq = taQuery.getText();
  taQuery.select(tq.indexOf( atributo),
                 tq.indexOf( atributo) + 
                   tq.substring(tq.indexOf( atributo),tq.length()).indexOf('['));

  QDialog.show();//modal  

  if ( queryDialog.isModal() && ( qtexto != null)) {
    kbm2lSystem.estatus("End of General query.");
    return 0;//
    } else {
    kbm2lSystem.estatus("General query started.");
    return 0;//
    }

}//consultaGeneral

/**
* El indice es, en general, abierto, 
* los atributos instanciados son hechos (facts), el resto es incierto. <br>
* [X, Y] ---> decision ? * Se explota la lista kbm2l, como KB, para gestionar la incertidumbre.<br>
*
* Procedimento basico:<br>
* El procedimiento pretende dar respuesta mediante un dialogo con el usuario dando soporte 
* tanto a la pregunta como a la respuesta. Una red bayesiana en el contexto de la pregunta
* permite inferir la distribucion de probabilidad del valor de los atributos y respuestas.<br>
* La red se aprende con las explicaciones que soportan la pregunta.
* La consulta consiste en un bucle de cuatro pasos.<br>
*
* Primero: se proyecta la lista kbm2l sobre [X]. Esto constituye el conjunto de datos
* para aprender la red bayesiana (algoritmo K2), solo se hace una vez en cada consulta
* y puede ser toda la sublista o una muestra.<br>
*
* Segundo: se infiere la distribucion de probabilidad del valor de la respuesta, en este contexto.
* Asi el usuario conoce un ranking de las politicas que soporta la KB y debe elegir o fijar un 
* criterio de decision (moda, modas, ....).<br>
*
* Tercero: ahora esta informacion se introduce como evidencia en la red para inferir la
* distribucion de los valores de los atributos no instanciados [Y].<br>
*
* Cuarto: Bajo un criterio de decision se asume el valor de parte de [Y]. 
* Se establece un umbral de varianza y filtramos los atributos que el usuario puede asumir, asi
* un criterio sencillo es que el atributo de menor varianza toma el valor esperado.<br>  
* Los atributos instanciados en el paso cuarto pasan a al conjunto [X] y repetimos hasta que
* el usuario quiera o hasta que [Y] este vacio.<br>
*
* No implementado:<br>
* En los dos pasos de decision el sistema puede considerar multiples alternativas
* Arbol de busqueda: multiples alternativas de seleccion: branch (?) & bound (?).
* @param l30 lista de trabajo.
* @param INDICE pregunta general en la base del esquema.
* @return RESPUESTA Vector
**/
public  Vector  bayesQuery( lista30 l30, Vector INDICE) {

  kbm2lSystem.append( "General Query.\n");
  Vector openIndex = base30.Trnp( null, INDICE, l30.Base);//pregunta abierta en la base de l30
  Vector openRespuesta = new Vector( ); openRespuesta.add( new Integer( -1));
  Vector indiceINF = null;//de op
  Vector indiceSUP = null;//de op

  working = true;
  try {     
  //los atributos abiertos pasan a las posiciones inferiores de la base
    if ( open( openIndex)) {
      op = new lista30( l30, l30);//es operativa
      } else {
        op = new lista30( l30, openIndex);//abierto !!!
        op = l30.union( op);//coste !!! copiar solo entre INF y SUP
        }
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "bayesQuery.1");
      if ( openIndex == null) System.out.println( "openIndex");
      if ( op == null) System.out.println( "op");
      if ( l30 == null)System.out.println( "l30");
      e.printStackTrace();
      System.exit( 0);
    }//catch

  try {
    p30 = new protocolo30( );
    p30.decisiones = new Vector( );
    p30.decisiones.add( l30);
    p30.decisiones.add( op);
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "bayesQuery.2");
      if ( p30 == null) System.out.println( "p30");
      if ( l30 == null) System.out.println( "l30");
      if ( op == null) System.out.println( "op");
      e.printStackTrace();
      System.exit( 0);
    }//catch

//indice en la base op, con transposicion.
  Vector indice = base30.Trnp( l30.Base, openIndex, op.Base);
//  
  try {
    indiceINF = Qmin( indice);  
    indiceSUP = Qmax( op, indice);

    //items = aproxKBM2L( op, indiceINF, indiceSUP);//cono de proyeccion de la query.
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "openQuery.3");
      if ( indiceINF == null) System.out.println( "indiceINF");
      if ( indiceSUP == null) System.out.println( "indiceSUP");
      //if ( items == null) System.out.println( "items");
      e.printStackTrace();
      System.exit( 0);
    }//catch


//0
  dataSetSize = new controlPrefs30().subKBLearningSize();//todo == -1.

  //long casos = new outputTable30( l30, null, l30.UNKB, openIndex, false
    //    ).escribeTabla( l30, new String( dato30.workspace + dataSetName));//no thread

  long casos = new outputTable30( op, null, op.UNKB, openIndex, false
        ).escribeTabla( op, new String( dato30.workspace + dataSetName));//no thread
          
  if ( casos > 0)      {
    new Thread( 
      new LBN( dato30.workspace + dataSetName, 
        dato30.workspace + dato30.nameFile( dato30.extFile( dataSetName, "xml")))).start();//learning

    new Thread ( 
      new BBNConvertor( dato30.workspace + dataSetName, "")).start();//.net

//1


//2


//3


//4


//

        }//si hay casos
    else {
      kbm2lSystem.estatus("General query fail_ empty learning data set.");
      return null; 
    }

  working = false;

  return null;
}//bayesQuery

/**
* Cabecera del fichero de datos para construir la red bayesiana.
* Por defecto toda la lista. Codificada: atributos - base, valores - index
**/
public static String headBayesData( BufferedWriter out, lista30 l30, maskTable30 filter) {
//3
//a|b|c
//2|2|2
//4

  String linea = null;
  try {
//numero de atributos del indice y respuesta
  linea = new String( String.valueOf(( l30.dimension() + l30.ParRespuesta())));
  out.write( linea, 0, linea.length());
  out.newLine();
//lista de identificadores o la base
  linea = new String( dato30.toString( l30.Base.Bas(), "node", "|"));// | separator
  linea = new String( linea + "|respuesta" + l30.dimension());//id de respuesta
  out.write( linea, 0, linea.length());
  out.newLine();
//lista de cardinales de dominio no instanciados
  linea = new String( dato30.toString( l30.Base.Dom(), "", "|"));// | separator
  linea = new String( linea + "|" + listStat30.DS( l30).size());//aridad de respuesta
  out.write( linea, 0, linea.length());
  out.newLine();
// tamao de la muestra, KB-casos
  linea = new String( String.valueOf( dataSetSize));
  out.write( linea, 0, linea.length());
  out.newLine();

    }//try
  catch (Exception e) {
    System.out.println( ERROR + "headBayesData. " + "Line:" + linea);
    e.printStackTrace();
    System.exit(0);
  }//catch

  return linea; 
}//headBayesData


/**
* 
**/
public void run() {

  if ( !working) {
    try {
      consultaGeneral( );
    }//try
    catch (Exception e) {
      System.out.println( ERROR +  "run()");
      e.printStackTrace();
      System.exit( 0);
    }//catch
  }
  return;
}//run

}//consultaGeneral30