//dlgQueryListener
package query;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.JDialog;

//
import kbm2l.*;

/**
* SERVIDOR DE ESCUCHA DEL MENU y CONTROLES DE dialog
**/
class  dlgQueryListener  extends  consulta30  implements  ActionListener {

  private static final String ERROR = "Error(dlgQueryListener): ";

/**
* Constructor por defecto
**/
public dlgQueryListener( ) {

}//dlgQueryListener

/**
* Escucha de eventos.
* Exit, Query, Attrib, Closed, Open y Bayes.
**/
public void actionPerformed( ActionEvent e) {

//comun a todas la clases de query
  if (e.getActionCommand().equals( strBExitQuery)) {
      bExitQueryAction( );//proc de evento del boton
    return ;
    }

  if (e.getActionCommand().equals( strBQuery)) {
      bQueryAction( );//proc de evento del boton
    return ;
    }

  if (e.getActionCommand().equals( strBAttrib)) {
      bAttribAction( );//proc de evento del boton
    return ;
    }

//depende del tipo de pregunta 
  if (e.getActionCommand().equals( strBClosedValues)) {
      bCloseValuesAction( );//proc de evento del boton
    return ;
    }

  if (e.getActionCommand().equals( strBOpenValues)) {
      bOpenValuesAction( );//proc de evento del boton
    return ;
    }

  if (e.getActionCommand().equals( strBBayesValues)) {
      bBayesValuesAction( );//proc de evento del boton
    return ;
    }

  if (e.getActionCommand().equals( strBEditValues)) {
      bEditValuesAction( );//proc de evento del boton
    return ;
    }

  return;
}//actionPerformed

/**
* bExitQueryAction: button exit query action.
**/
private void bExitQueryAction( ) {
//
  queryDialog.setVisible(false);
  queryDialog.dispose();
  working = false;

  return;  
}//bExitQueryAction

/**
* bQueryAction: button query action.
* Cerrada (query completa or incompleta  X  KB or UNKB) 3 casos, incompleta no se resuelve.
* Abierta ( single or multiple  X  KB or UNKB) 4 casos
* General ( cerrada E[q]*d, simulacion E[r], dialogo y estimacion de distribucion en la kbm2l) 
* @see consultaCerrada30#closedQuery( Vector)
* @see consultaAbierta30#openQuery( Vector)
* @see consultaGeneral30#bayesQuery( Vector)
* @return String del texto de la consulta
**/
private String bQueryAction( ) {

//la pregunta-consulta
  qtexto = new String( getText());//texto de la pregunta
  Vector INDICE = activel30.Esqu.indiceEq( qtexto);//en la base canonica o del esquema !!!
//CLOSED QUERY
  if ( strBValues.equals( strBClosedValues)) {
    new consultaCerrada30().closedQuery( f30.activel30, INDICE);
    }  
//OPEN QUERY
  if ( strBValues.equals( strBOpenValues)) {
    new consultaAbierta30().openQuery( f30.activel30, INDICE);
    }  
//BAYES QUERY
  if ( strBValues.equals( strBBayesValues)) {
    new consultaGeneral30().bayesQuery( f30.activel30, INDICE);
    }  

//EDIT QUERY
  if ( strBValues.equals( strBEditValues)) {
    new consultaEdit30().editQuery( f30.activel30, INDICE);
    }  

  return qtexto;  
}//bQueryAction

/**
* Lista circular cerrada de los atributos.
* @return ATRIBUTO:  posicion en la lista de atributos del esquema, base canonica
**/
private int bAttribAction( ) {

  String atributo = null;
  try {

    if ( ATRIBUTO < activel30.Esqu.numAtributos-1) 
      ATRIBUTO++; else ATRIBUTO = 0;

    atributo = new String(((String) activel30.Esqu.Atributos.get( ATRIBUTO)));
    queryDialog.setTitle( 
      queryDialog.getTitle().substring( 0, 
      queryDialog.getTitle().indexOf('[')) + "[" + atributo + "](" + ATRIBUTO + "):" + 
        (String) VALORES.get( ATRIBUTO));

    String tq = taQuery.getText();
    taQuery.select(tq.indexOf( atributo),
                   tq.indexOf( atributo) + 
                     tq.substring(tq.indexOf( atributo),tq.length()).indexOf('['));

    }//try
    catch (Exception e) {
      System.out.println( ERROR + "bAttribAction()");
      System.out.println( "ATRIBUTO: " + ATRIBUTO);
      if ( activel30.Esqu.numDecisiones != 0) 
        System.out.println( "activel30.Esqu.numAtributos: " + activel30.Esqu.numAtributos);
      if ( activel30.Esqu.numDecisiones != 0) 
        System.out.println( "activel30.Esqu.ATRIBUTOS: " + atributo);
      e.printStackTrace();
      System.exit( 0);
    }//catch

  return ATRIBUTO;  
}//bAttribAction

/**
* Lista circular cerrada de los valores de los atributos.
* @return VALOR: ordinal de valor d el dominio de ATRIBUTO
**/
private int bCloseValuesAction( ) {

  int VALOR = -1;
  try {

    String atributo = new String(((String) f30.activel30.Esqu.Atributos.get( ATRIBUTO)));
    Vector valores = ((Vector) f30.activel30.Esqu.ValoresAtributos.get( ATRIBUTO));
    VALOR = valores.indexOf( (String)VALORES.get( ATRIBUTO));

    if (( VALOR < 0 )&&
        ( VALOR >= ((Integer) f30.activel30.Esqu.CDAtributos.get( ATRIBUTO)).intValue())) {
      System.out.println( ERROR + "VALOR. bCloseValuesAction.");
      System.exit(0);  
      }

    if ( VALOR < valores.size()-1) VALOR++; else VALOR = 0;

    VALORES.set( ATRIBUTO, (String)valores.get( VALOR));

    taQuery.setText( f30.activel30.Esqu.literalEq( VALORES) + "?");

    String tq = taQuery.getText();
    taQuery.select(tq.indexOf( atributo),
                   tq.indexOf( atributo) + 
                     tq.substring(tq.indexOf( atributo),tq.length()).indexOf('['));

    }//try
    catch (Exception e) {
      System.out.println( ERROR + "bCloseValuesAction()");
      System.out.println( f30.activel30.Esqu.toString());
      e.printStackTrace();
      System.exit( 0);
    }//catch

  return VALOR;  
}//bValuesAction

/**
* Atiende el boton de valores de atributos en el dialogo de consulta abierta.
* Lista circular abierta de los valores de los atributos
**/
private int bOpenValuesAction( ) {

  int VALOR = -1;//  VALORES es inicialmente ? en todas las componentes
  try {

    String atributo = new String(((String) f30.activel30.Esqu.Atributos.get( ATRIBUTO)));
    Vector valores = ((Vector) f30.activel30.Esqu.ValoresAtributos.get( ATRIBUTO));
    VALOR = valores.indexOf( (String) VALORES.get( ATRIBUTO));

    if (( VALOR < 0 )&&
        ( VALOR >= ((Integer) f30.activel30.Esqu.CDAtributos.get( ATRIBUTO)).intValue())) {
      System.out.println( ERROR + "VALOR. bOpenValuesAction.");
      System.exit(0);  
      }

    if ( VALOR < valores.size()-1) VALOR++; else VALOR = -1;
    if (( VALOR >= 0 )&& ( VALOR < valores.size()))
      VALORES.set( ATRIBUTO, (String)valores.get( VALOR));
      else VALORES.set( ATRIBUTO, OpenValue);

    taQuery.setText( f30.activel30.Esqu.literalEq( VALORES) + OpenValue);
    
    String tq = taQuery.getText();
    taQuery.select(tq.indexOf( atributo),
                   tq.indexOf( atributo) + 
                     tq.substring(tq.indexOf( atributo),tq.length()).indexOf('['));

    }//try
    catch (Exception e) {
      System.out.println( ERROR + "bOpenValuesAction()");
      System.out.println( f30.activel30.Esqu.toString());
      e.printStackTrace();
      System.exit( 0);
    }//catch

  return VALOR;  
}//bOpenValuesAction

/**
* Atiende el boton de valores de atributos en el dialogo de consulta general.
* Lista circular abierta de los valores de los atributos.
**/
private int bBayesValuesAction( ) {

  int VALOR = -1;//  VALORES es inicialmente ? en todas las componentes
  try {

    String atributo = new String(((String) f30.activel30.Esqu.Atributos.get( ATRIBUTO)));
    Vector valores = ((Vector) f30.activel30.Esqu.ValoresAtributos.get( ATRIBUTO));
    VALOR = valores.indexOf( (String) VALORES.get( ATRIBUTO));

    if (( VALOR < 0 )&&
        ( VALOR >= ((Integer) f30.activel30.Esqu.CDAtributos.get( ATRIBUTO)).intValue())) {
      System.out.println( ERROR + "VALOR. bBayesValuesAction.");
      System.exit(0);  
      }

    if ( VALOR < valores.size()-1) VALOR++; else VALOR = -1;

    if (( VALOR >= 0 )&& ( VALOR < valores.size()))
      VALORES.set( ATRIBUTO, (String)valores.get( VALOR));
      else VALORES.set( ATRIBUTO, "?");

    taQuery.setText( f30.activel30.Esqu.literalEq( VALORES) + "?");
    
    String tq = taQuery.getText();
    taQuery.select(tq.indexOf( atributo),
                   tq.indexOf( atributo) + 
                     tq.substring(tq.indexOf( atributo),tq.length()).indexOf('['));

    }//try
    catch (Exception e) {
      System.out.println( ERROR + "bBayesValuesAction()");
      System.out.println( f30.activel30.Esqu.toString());
      e.printStackTrace();
      System.exit( 0);
    }//catch

  return VALOR;  
}//bBayesValuesAction

/**
* Atiende el boton de valores de atributos en el dialogo de consulta edit.
* Lista circular abierta de los valores de los atributos.
**/
private int bEditValuesAction( ) {

  int VALOR = -1;//  VALORES es inicialmente ? en todas las componentes
  try {

    String atributo = new String(((String) f30.activel30.Esqu.Atributos.get( ATRIBUTO)));
    Vector valores = ((Vector) f30.activel30.Esqu.ValoresAtributos.get( ATRIBUTO));
    VALOR = valores.indexOf( (String) VALORES.get( ATRIBUTO));

    if (( VALOR < 0 )&&
        ( VALOR >= ((Integer) f30.activel30.Esqu.CDAtributos.get( ATRIBUTO)).intValue())) {
      System.out.println( ERROR + "VALOR. bEditValuesAction.");
      System.exit(0);  
      }

    if ( VALOR < valores.size()-1) VALOR++; else VALOR = -1;

    if (( VALOR >= 0 )&& ( VALOR < valores.size()))
      VALORES.set( ATRIBUTO, (String)valores.get( VALOR));
      else VALORES.set( ATRIBUTO, "?");

    taQuery.setText( f30.activel30.Esqu.literalEq( VALORES) + "?");
    
    String tq = taQuery.getText();
    taQuery.select(tq.indexOf( atributo),
                   tq.indexOf( atributo) + 
                     tq.substring(tq.indexOf( atributo),tq.length()).indexOf('['));

    }//try
    catch (Exception e) {
      System.out.println( ERROR + "bEditValuesAction()");
      System.out.println( f30.activel30.Esqu.toString());
      e.printStackTrace();
      System.exit( 0);
    }//catch

  return VALOR;  
}//bEditValuesAction

}//class dlgQueryListener