//BREAKATT30//
package schema;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kernel.*;
import tables.*;
import kbm2l.*;
import target.*;
import synthesis.*;

/** 
* Descomposicion de atributos del esquema.
**/
public class breakAtt30  extends  frame30  implements  Runnable  {

  private static final String ERROR = "Error(breakAtt30): ";
/**
* flag de ejecucion en curso
**/
  public static boolean working = false;//

/**
* Constructor por defecto.
**/
public breakAtt30( ) {

}//breakAttl30

/**
* Break Att0 de la lista activa. 
* Pone la lista en base canonica permutando los atributos del esquema.
* Derivada del esquema. Superesquema respecto de Att0.
* Aadir n att binarios de peso max e ini(COKB) con valores - y +. 
* Restringir semanticamente XOR. Copia todo (UNKB) el contenido menos los COKB.
* Modifica el dominio, base y t en la descripcion de la lista.
* Si se trata de una CPT, no se debe de hacer break del Att 
* condicionado ni del parametro de probabilidad. 
* El att condicionante se descompone en n att's condicionantes.
* @return la lista original, la lista derivada se escribe en disco con sufijo "x".
**/
public lista30 breakAtt( lista30 l30) {

  f30.kbm2lSystem.estatus("breaAtt0: " + l30.size());
  working = true;

  l30.canonica(); // !!!!

  esquema30 brkeq30 = new esquema30( l30.Esqu); // esquema original ordenado segun bc
  brkeq30.nombre = l30.Esqu.nombre+"x";  
  int domAtt0 = ((Integer)(l30.Esqu.CDAtributos.get( 0))).intValue();
  brkeq30.numAtributos  = l30.Esqu.numAtributos + domAtt0 - 1;
                           
  int codeAtt0 = ((Integer)(l30.Esqu.CodigosAtributos.get( 0))).intValue();
  for( int i = 0; i < domAtt0; i++)
    brkeq30.CodigosAtributos.add( i, new Integer(codeAtt0*101+i));
  brkeq30.CodigosAtributos.remove( domAtt0); 
  
  String nameAtt0 = (String)(l30.Esqu.Atributos.get( 0));
  Vector valoresAtt0 = (Vector)(l30.Esqu.ValoresAtributos.get( 0));
  for( int i=0; i< domAtt0; i++) 
    brkeq30.Atributos.add( i, new String( nameAtt0+"-"+(String)(valoresAtt0.get(i))));
  brkeq30.Atributos.remove( domAtt0); 
  
  for( int i=0; i< domAtt0; i++) 
    brkeq30.CDAtributos.add( i, new Integer( 2)); // bin: A-, A+
  brkeq30.CDAtributos.remove( domAtt0); 
    
  for( int i=0; i< domAtt0; i++) {
    Vector valores = new Vector();
    valores.add( new String( (String)(valoresAtt0.get(i))+"-"));
    valores.add( new String( (String)(valoresAtt0.get(i))+"+"));
    brkeq30.ValoresAtributos.add( i, valores);
    } 
  brkeq30.ValoresAtributos.remove( domAtt0); 
  
  lista30 brkl30 = new lista30( brkeq30);

  for( int i = 0; i < domAtt0; i++)//el att condicionante se descompone en n att's condicionantes
    brkl30.Base.rol( i, l30.Base.rol( 2));

  for( int i = domAtt0; i < brkl30.dimension(); i++)
    brkl30.Base.rol( i, l30.Base.rol( i-domAtt0+1));

  brkl30.ini( l30.COKB);// !!!! valor por defecto
  
  //copia 
    try {
  Vector INDEX = null; // recorrido de l30
  Vector DOMINIO = l30.Base.Dom();
  Vector ULTIMO = index30.ultimoT( DOMINIO);
  for( INDEX = index30.primeroT( DOMINIO);
       index30.myeqT( ULTIMO, INDEX);
       INDEX = index30.siguienteT( DOMINIO, INDEX)) {

     item30 item = l30.GET( INDEX);
     Vector MEDIDA = item.GetMedida();
     Vector RESPUESTA = item.GetRespuesta();

     if ( !index30.eqS( RESPUESTA, l30.COKB)) {

       Vector SuperINDEX = index30.cpT( INDEX);
       int valAtt0 = ((Integer)(INDEX.get(0))).intValue();
       for( int i = 0; i < domAtt0; i++)
         if ( i == valAtt0)
           SuperINDEX.add( i, new Integer( 1));
           else SuperINDEX.add( i, new Integer( 0));
       SuperINDEX.remove( l30.Base.dom(0));  

       item30 nuevo = new item30( brkl30, MEDIDA, RESPUESTA, SuperINDEX);     
       int regla = brkl30.Set( nuevo);

       f30.kbm2lSystem.estatus("::" + INDEX.toString());

       }//if-COKB
       else { 
         INDEX = l30.GET( INDEX).GetIndice(); 
       }//salta el item COKB que es el valor por defecto de la superlista

     if ( index30.eqT( ULTIMO, INDEX)) { break; }
     if (!working) {
       break;
       }

    }//for-INDEX
    }//try    
    catch (Exception e) {
      System.out.println( ERROR + "breakAtt-FOR");
      e.printStackTrace();
      System.exit( 0);
    }//catch

  new outputList30( ).escribeKBM2L( brkl30, dato30.workspace+File.separator+brkl30.Name());
  
  listStat30.KB( l30);//
  checkList30.CHK( l30, "BreakAtt0");  
  f30.kbm2lSystem.estatus("breaAtt0: " + brkl30.size());

  working = false;
  return l30;
}//breakAtt

/**
* run process
**/
public void run() {

  if ( !working) {
  try {
    f30.activel30 = breakAtt( f30.activel30);
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
  }//catch
  }

  return;
}//run

}//class breakAtt30
