//esquema30//
package schema;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kernel.*;
import kbm2l.*;
import target.*;

/**
* Clase esquema30, semantica de las tablas y las listas. Estructura logica.
* Version con respuesta escalar y vectorial para las consultas.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class esquema30 {

  private static final String ERROR = "Error(esquema30): ";
  /**
  * Atributo no instanciado, libre
  * **/
  public static final int marca_libre = kbm2l30.unKB;//

/**
* Nombre del fichero de la tabla
**/
  public String nombre = "";//.tdu,.txt
/**
* numero de decisiones en un esquema, condicion (==null)
**/
  public int numDecisiones = 0;//1 !!!
/**
* numero de atributos del esquema
**/
  public int numAtributos = 0;//1 o mas

/**
* Codigos de decisiones, unicos
**/
  public Vector CodigosDecisiones = null;//Integer
/**
* Codigos de atributos, unicos
**/
  public Vector CodigosAtributos = null;//Integer

/**
* Literales de decisiones, identificadores, unicos
**/
  public Vector Decisiones = null;//String literales
/**
* Literales de atributos, identificadores, unicos
**/
  public Vector Atributos = null;//String literales

/**
* Cardinal de dominio de las decisiones
**/
  public Vector CDDecisiones = null;//Integer cdD - cardinal de dominio
/**
* Cardinal de dominio de atributos
**/
  public Vector CDAtributos = null;//Integer cdA - cardinal de dominio

/**
* Listas de valores de alterntivas de decision,
**/
  public Vector ValoresDecisiones = null;//String array de literales.
/**
* Listas de valores de modalidades de atributos.
**/
  public Vector ValoresAtributos = null;//String

//
  private inputEsquema30 ieq30 = null;//leerEq
//
  private outputEsquema30 oeq30 = null;//escribirEq
//
  private queryEsquema30 qeq30 = null;//
  
  private lista30 l30 = null;

/**
* Constructor por defecto
**/
public esquema30( String listName, int numAtts, int numDecs) {

  nombre = listName;//nombre de la tabla leida
  numAtributos = numAtts;//
  numDecisiones = numDecs;//

  CodigosDecisiones = new Vector();
  if ( CodigosDecisiones == null) {
    System.out.println( ERROR + "CodigosDecisiones\n");
    frame30.exit( 0);
    }

  CodigosAtributos = new Vector();
  if ( CodigosAtributos == null) {
    System.out.println( ERROR + "CodigosAtributos\n");
    frame30.exit( 0);
    }

  Decisiones = new Vector();
  if ( Decisiones == null) {
    System.out.println( ERROR + "Decisiones\n");
    frame30.exit( 0);
    }
    
  Atributos = new Vector();
  if ( Atributos == null) {
    System.out.println( ERROR + "Atributos\n");
    frame30.exit( 0);
    }

  CDDecisiones = new Vector();
  if ( CDDecisiones == null) {
    System.out.println( ERROR + "CDDecisiones\n");
    frame30.exit( 0);
    }

  CDAtributos = new Vector();
  if ( CDAtributos == null) {
    System.out.println( ERROR + "CDAtributos\n");
    frame30.exit( 0);
    }

  ValoresDecisiones = new Vector();
  if ( ValoresDecisiones == null) {
    System.out.println( ERROR + "ValoresDecisiones\n");
    frame30.exit( 0);
    }

  ValoresAtributos = new Vector();
  if ( ValoresAtributos == null) {
    System.out.println( ERROR + "ValoresAtributos\n");
    frame30.exit( 0);
    }
    
  ieq30 = new inputEsquema30( this);  
  oeq30 = new outputEsquema30( );  
  qeq30 = new queryEsquema30( this);

  this.l30 = l30;  
}//esquema30

/**
* Constructor por defecto
* Esquema para la lista vacia
**/
public esquema30( lista30 l30) {

    nombre = l30.Name();//nombre de la tabla leida
    numAtributos = l30.ParIndice();//
    numDecisiones = l30.ParRespuesta();//

  CodigosDecisiones = new Vector();
  for( int i = 0; i < numDecisiones; i++)  
    CodigosDecisiones.add( new Integer( (i+1)*1000));    
  if ( CodigosDecisiones == null) {
    System.out.println( ERROR + "CodigosDecisiones\n");
    frame30.exit( 0);
    }

  CodigosAtributos = new Vector();
  for( int i = 0; i < numAtributos; i++)  
    CodigosAtributos.add( new Integer( i));    
  if ( CodigosAtributos == null) {
    System.out.println( ERROR + "CodigosAtributos\n");
    frame30.exit( 0);
    }

  Decisiones = new Vector();
  for( int i = 0; i < numDecisiones; i++)  
    Decisiones.add( new String( "Decision#"+i));    
  if ( Decisiones == null) {
    System.out.println( ERROR + "Decisiones\n");
    frame30.exit( 0);
    }
    
  Atributos = new Vector();
  for( int i = 0; i < numAtributos; i++)  
    Atributos.add( new String( "Att#"+i));    
  if ( Atributos == null) {
    System.out.println( ERROR + "Atributos\n");
    frame30.exit( 0);
    }

  CDDecisiones = new Vector();
  for( int i = 0; i < numDecisiones; i++)  
    CDDecisiones.add( new Integer( 16));    
  if ( CDDecisiones == null) {
    System.out.println( ERROR + "CDDecisiones\n");
    frame30.exit( 0);
    }

  CDAtributos = new Vector();
  for( int i = 0; i < numAtributos; i++)  
    CDAtributos.add( new Integer( l30.Base.dom( i)));    
  if ( CDAtributos == null) {
    System.out.println( ERROR + "CDAtributos\n");
    frame30.exit( 0);
    }

  ValoresDecisiones = new Vector();
  for( int i = 0; i < numDecisiones; i++) {  
	 Vector VD = new Vector();  
    for( int j = 0; j < 16; j++)  
      VD.add( new String( "Alt$"+i+"$"+j));    
    ValoresDecisiones.add( VD);    
    }
  if ( ValoresDecisiones == null) {
    System.out.println( ERROR + "ValoresDecisiones\n");
    frame30.exit( 0);
    }

  ValoresAtributos = new Vector();
  for( int i = 0; i < numAtributos; i++) {  
	 Vector VA = new Vector();  
    for( int j = 0; j < l30.Base.dom( i); j++)  
      VA.add( new String( "Val$"+i+"$"+j));    
    ValoresAtributos.add( VA);    
    }
  if ( ValoresAtributos == null) {
    System.out.println( ERROR + "ValoresAtributos\n");
    frame30.exit( 0);
    }
    
  ieq30 = new inputEsquema30( this);  
  oeq30 = new outputEsquema30( );  
  qeq30 = new queryEsquema30( this);

  this.l30 = l30;  
}//esquema30

/**
* Constructor copia
**/
public esquema30( esquema30 eq30) {

  try {
  if ( eq30.numDecisiones == 0) {
    System.out.println( ERROR + "Esquema de la lista sin decisiones.");    
    frame30.exit( 0, new Exception());
    }
    }//try
  catch (Exception e) {
    System.out.println( ERROR + "eq30.numDecisiones == 0");
    e.printStackTrace();
    System.exit( 0);
  }//catch

  try {
    nombre = new String( eq30.nombre);//nombre de la tabla leida
    numAtributos = eq30.numAtributos;//
    numDecisiones = eq30.numDecisiones;//
    }//try
  catch (Exception e) {
    System.out.println( ERROR + "esquema30-copia");
    e.printStackTrace();
    System.exit( 0);
  }//catch

  CodigosDecisiones = (Vector)eq30.CodigosDecisiones.clone();
  if ( CodigosDecisiones == null) {
    System.out.println( ERROR + "CodigosDecisiones\n");
    System.exit(0);
    }
  CodigosAtributos =(Vector)eq30.CodigosAtributos.clone();
  if ( CodigosAtributos == null) {
    System.out.println( ERROR + "CodigosAtributos\n");
    System.exit(0);
    }
  Decisiones = (Vector)eq30.Decisiones.clone();
  if ( Decisiones == null) {
    System.out.println(ERROR + "Decisiones\n");
    System.exit(0);
    }
  Atributos = (Vector)eq30.Atributos.clone();
  if ( Atributos == null) {
    System.out.println(ERROR + "Atributos\n");
    System.exit(0);
    }
  CDDecisiones = (Vector)eq30.CDDecisiones.clone();
  if ( CDDecisiones == null) {
    System.out.println( ERROR + "CDDecisiones\n");
    System.exit(0);
    }
  CDAtributos = (Vector)eq30.CDAtributos.clone();
  if ( CDAtributos == null) {
    System.out.println( ERROR + "CDAtributos\n");
    System.exit(0);
    }
  ValoresDecisiones = (Vector)eq30.ValoresDecisiones.clone();
  if ( ValoresDecisiones == null) {
    System.out.println( ERROR + "ValoresDecisiones\n");
    System.exit(0);
    }
  ValoresAtributos = (Vector)eq30.ValoresAtributos.clone();
  if ( ValoresAtributos == null) {
    System.out.println( ERROR + "ValoresAtributos\n");
    System.exit(0);
    }
    
  ieq30 = new inputEsquema30( this);  
  oeq30 = new outputEsquema30( );  
  qeq30 = new queryEsquema30( this);
  
  this.l30 = eq30.l30;
}//esquema30

/**
* Check schema and base on canonical form.
**/
public boolean check( base30 b30) {
	
	if ( numAtributos != b30.size()) {
    frame30.kbm2lSystem.append( ERROR + "numAtributos" + "\n");
    frame30.kbm2lSystem.append( "numAtributos" + numAtributos + "   b30.size(): " + b30.size() + "\n");
    frame30.exit( 0);
    }//if

  for( int i = 0; i < numAtributos; i++)  
    if (((Integer)CDAtributos.get( i)).intValue() != b30.dom( b30.indexOfbas( i))) {
      frame30.kbm2lSystem.append( ERROR + "CDAtributos, i: " + i + "\n");
      frame30.kbm2lSystem.append( "CDAtributos" + CDAtributos.toString() + "\n");
      frame30.kbm2lSystem.append( "b30.DOM" + b30.Dom().toString() + "\n");
      frame30.exit( 0);
      }//for-i

  frame30.kbm2lTime.append("esquema30 check  - OK.\n");

  return true;
}//check

/**
* browser
**/
public void browser( system30 sys) {

  sys.append( "BROWSER-SCHEMA:\n" + nombre + "  S: " + numDecisiones + "  T: " + numAtributos + "\n");
  for( int i = 0; i < numDecisiones; i++)  
    sys.append( ((Vector)ValoresDecisiones.get( i)).toString( ) + "\n");
  sys.append( "Codes " + CodigosAtributos.toString( ) + "\n");
  sys.append( "Atts  " + Atributos.toString( ) + "\n");
  sys.append( "CDAtt " + CDAtributos.toString( ) + "\n");
  for( int i = 0; i < numAtributos; i++)  
    sys.append( ((Vector)ValoresAtributos.get( i)).toString( ) + "\n");
  return;
}//browser

/**
* remove(i)
**/
public void remove( int i) {

  CodigosAtributos.remove( i);
  Atributos.remove( i);
  CDAtributos.remove( i);
  ValoresAtributos.remove( i);
  return;
}//remove

////
////  inputEsquema30
////

/**
* @see inputEsquema30#leerEq(String).
**/
public esquema30 leerEq( String fileName) {

  return ieq30.leerEq( fileName);
}//leerEq

////
////  inputEsquema30
////

/**
* @see outputEsquema30#escribirEsquema(String,lista30).
**/
public esquema30 escribirEsquema( String fileName, lista30 l30) {

  return oeq30.escribirEsquema( fileName, l30);
}//escribirEsquema

////
////  queryEsquema30
////

/**
* @see queryEsquema30#valoresEq().
**/
public Vector valoresEq() {

  return qeq30.valoresEq();    
}//valoresEq

/**
* @see queryEsquema30#valoresEq(String).
**/
public Vector valoresEq( String etiqueta) {

  return qeq30.valoresEq( etiqueta);    
}//valoresEq

/**
* @see queryEsquema30#literalEq( ).
**/
public String literalEq() {

  return qeq30.literalEq();    
}//literalEq

/**
* @see queryEsquema30#literalEq(String).
**/
public String literalEq( String v) {

  return qeq30.literalEq( v);    
}//literalEq

/**
* @see queryEsquema30#literalEq(Vector).
**/
public String literalEq( Vector V) {
    
  return qeq30.literalEq( V);    
}//literalEq

/**
* @see queryEsquema30#literalEq(String).
**/
public Vector indiceEq( String qtexto) {

  return qeq30.indiceEq( qtexto);  //
}//indiceEq

/**
* @see queryEsquema30#consultaEq(Vector,Vector).
**/
public String consultaEq( Vector INDICE, Vector RESPUESTA) {

  return qeq30.consultaEq( INDICE, RESPUESTA);
}//consultaEq

/**
* @see queryEsquema30#consultaEqIndice(Vector).
**/
public String consultaEqIndice( Vector INDICE) {

  return  qeq30.consultaEqIndice( INDICE); 
}//consultaEqIndice

/**
* @see queryEsquema30#consultaEqRespuesta(Vector).
**/
public String consultaEqRespuesta( Vector RESPUESTA) {

  return qeq30.consultaEqRespuesta( RESPUESTA); 
}//consultaEqRespuesta

}//class esquema30