//inputEsquema30//
package schema;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kbm2l.*;
import control.*;
import tables.*;

/**
* Clase inputEsquema30, semantica de las listas. Input data.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  inputEsquema30  extends  frame30  {

//
  private static final String ERROR = "Error(inputEsquema30): ";
/**
*   
**/
  private esquema30 eq30 = null;
  
/**
* Constructor por defecto
**/
public inputEsquema30( esquema30 eq30) {

  if ( eq30 == null)
    this.eq30 = new esquema30( "SCHEMA2D", 2, 1);
    else this.eq30 = eq30;
}//inputEsquema30

/**
* Lee linea de la descripcion del esquema para un atributo: 
* ignora el flag Att:, lee codigo(numero), lee nombre(cadena), 
* lee cardinal de dominio del atributo(numero),  
* @return cdA int, cardinal del dominio del atributo.
**/
private int leerEqAtributos( String linea) {
//codigo atributo cdA
  Integer codigo = null;
  int cdA = 0;
  String atributo = null;

  linea = (linea.substring( linea.indexOf(':')+1, linea.length())).trim();//del flag  

  codigo = new Integer( (int)( dato30.param( linea)));//

  linea = linea.trim();
  linea = new String( dato30.nextParam( linea, ' ')); 
  linea = linea.trim();

  if ( linea.indexOf( ' ') != -1)
    atributo = new String( linea.substring( 0, linea.indexOf(' '))); 
  atributo = new String( atributo.trim());//  

  linea = linea.trim();
  linea = new String( dato30.nextParam( linea, ' ')); 
  linea = linea.trim();

  cdA = (int)( dato30.param( linea));

//check

  if (( eq30.CodigosDecisiones.indexOf( codigo) == -1) &&
      ( eq30.CodigosAtributos.indexOf( codigo) == -1))
    eq30.CodigosAtributos.add( codigo);//CODIGO nuevo
    else {//duplicado
      System.out.println( ERROR + "leerEqAtributos. dup code: " + codigo);
      System.out.println( "eq30.CodigosDecisiones  " + eq30.CodigosDecisiones);
      System.out.println( "eq30.CodigosAtributos  " + eq30.CodigosAtributos);
      return -1;
    }

  if (( eq30.Decisiones.indexOf( atributo) == -1) && 
      ( eq30.Atributos.indexOf( atributo) == -1))
    eq30.Atributos.add( atributo);//ATRIBUTO nuevo
    else {//duplicado
      System.out.println( ERROR + "leerEqAtributos. dup attribute name: " + atributo);
      System.out.println( "eq30.Decisiones  " + eq30.Decisiones);
      System.out.println( "eq30.Decisiones  " + eq30.Decisiones);
      return -1;
    }
  
  if ( cdA > 1)  
    eq30.CDAtributos.add( new Integer( cdA));//CARDINAL valido
    else {//no es un cardinal de dominio
      System.out.println( ERROR + "leerEqAtributos. bad domain cardinal: " + cdA);
      return -1;
    }
      
  eq30.numAtributos++;//Att

  return cdA;    
}//leerEqAtributos

/**
* Lee linea de la descripcion del esquema para los valores de un atributo: 
* ignora el flag Val:, lee cdA Strings diferentes.
* @return void
**/
private void leerEqValoresAtributos( int cdA, String linea) {

  linea = linea.substring( linea.indexOf(':')+1, linea.length());  linea = linea.trim();
  Vector VA = new Vector();//valores vector
  String vitem = null;
  for( int j = 0; j < cdA-1; j++) {
    vitem = new String( linea.substring( 0, linea.indexOf(' '))); 
    vitem = vitem.trim();
    if ( VA.indexOf( new String( vitem)) == -1)
      VA.add( new String( vitem));
      else {
        System.out.println( ERROR + "leerEqValoresAtributos. dup value name: " + vitem);
      }
    linea = new String( dato30.nextParam( linea, ' ')); 
    linea = linea.trim();
    }//for
  vitem = new String( linea.substring( 0, linea.indexOf(';'))); 
  vitem = vitem.trim();
  if ( VA.indexOf( new String( vitem)) == -1)
    VA.add( new String( vitem));
    else {
      System.out.println( ERROR + "leerEqValoresAtributos. dup alue name: " + vitem);
    }

  eq30.ValoresAtributos.add( VA);

  return;        
}//leerEqValoresAtributos

/**
* Lee linea de la descripcion del esquema para una decision: 
* ignora el flag S:, lee codigo(numero), lee nombre(cadena), 
* lee cardinal del dominio de alternativas(numero),  
* @return cdD int, cardinal del dominio de alternativa de decision.
**/
private int leerEqDecisiones( String linea) {
//codigo decision cdD
  Integer codigo = null; 
  int cdD = 0;
  String decision = null;

  linea = (linea.substring( linea.indexOf(':')+1, linea.length())).trim();

  codigo = new Integer((int)( dato30.param( linea)));

  linea = linea.trim();
  linea = new String( dato30.nextParam( linea, ' ')); 
  linea=linea.trim();

  if ( linea.indexOf( ' ') != -1)
    decision = new String( linea.substring( 0, linea.indexOf(' '))); 
  decision = new String( decision.trim());  

  linea = linea.trim();
  linea = new String( dato30.nextParam( linea, ' ')); 
  linea = linea.trim();
  cdD = (int)( dato30.param( linea));

  if (( eq30.CodigosDecisiones.indexOf( codigo) == -1) &&
      ( eq30.CodigosAtributos.indexOf( codigo) == -1))
    eq30.CodigosDecisiones.add( codigo);//CODIGO nuevo
    else {//duplicado
      System.out.println( ERROR + "leerEqDecisiones. dup code: " + codigo);
      System.out.println( "eq30.CodigosDecisiones  "+ eq30.CodigosDecisiones);
      System.out.println( "eq30.CodigosAtributos   " + eq30.CodigosAtributos);
    }

  if (( eq30.Decisiones.indexOf( decision) == -1) && 
      ( eq30.Atributos.indexOf( decision) == -1))
    eq30.Decisiones.add( decision.trim());//DECISION nueva
    else {//duplicado
      System.out.println( ERROR + "leerEqDecisiones. dup alterantive name: " + decision);
      System.out.println( "eq30.Decisiones  " + eq30.Decisiones);
      System.out.println( "eq30.Atributos   " + eq30.Atributos);
    }

  if ( cdD > 1)  
    eq30.CDDecisiones.add( new Integer( cdD));//CARDINAL valido
    else {//no es un cardinal de dominio
      System.out.println( ERROR + "leerEqDecisiones. bad domain cardinal: " + cdD);
    }

  eq30.numDecisiones++;//S
      
  return cdD;    
}//leerEqDecisiones

/**
* Lee linea de la descripcion del esquema para las alternativas de una decision: 
* ignora el flag Val:, lee cdA Strings diferentes.
**/
private void leerEqValoresDecisiones( int cdD, String linea) {

  linea = linea.substring( linea.indexOf(':')+1, linea.length());  linea = linea.trim();
  Vector VA = new Vector();//valores vector
  String vitem = null;
  for( int j = 0; j < cdD-1; j++) {
    vitem = new String( linea.substring( 0, linea.indexOf(' '))); 
    if ( VA.indexOf( new String( vitem)) == -1)
      VA.add( new String( vitem.trim()));
      else {
        System.out.println( ERROR + "leerEqValoresDecsiones. dup value name: " + vitem);
      }
    linea = new String( dato30.nextParam( linea, ' ')); 
    linea = linea.trim();
    }//for
  vitem = new String( linea.substring( 0, linea.indexOf(';'))); 
  if ( VA.indexOf( new String( vitem)) == -1)
    VA.add( new String( vitem.trim()));
    else {
      System.out.println( ERROR + "leerEqValoresDecsiones. dup value name: " + vitem);
    }

  eq30.ValoresDecisiones.add( VA);
          
  return;
}//leerEqValoresDecisiones

/**
* Leer la descripcion del esquema de una tabla.
* @return eq30, esquema.
**/
public esquema30 leerEq( String fileName) {
/**
File:nombre.tdu;
Att|S: codigo atributo cdA;
V:V0 V1 V2..........;
....................;
**/

  if ( fileName == null) {
    kbm2lSystem.append("fileName == null.\n");
    return null;
    }

  if ( fileName == "") {
    kbm2lSystem.append("fileName == zero.length.\n");
    return null;
    }

  String linea = null; // linea del fichero que contiene una tabla
  BufferedReader in = null;

  kbm2lSystem.append("Access Schema: " + fileName + ".\n");

  try {// 
    in = dato30.openFile( dato30.nameFile( fileName), "eq");
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "leerEsquema. openFile\n");
    kbm2lSystem.append( "file: " + fileName + "\n");
    frame30.exit( 0, e);
  }//catch

  try {//

    do { } while((( linea = in.readLine()).trim()).charAt( 0) == ';');//jumping remarks

    if ( linea != null) {

    linea = linea.trim(); //kbm2lSystem.append( "line: , " + linea + "\n");

//F: nombre.[txt,kbm]
//flag F
    if (!( dato30.flag_check( linea, dato30.flag_F))) {
      kbm2lSystem.append( ERROR + "flag_check: " + dato30.flag_F  + fileName + "\n");
      kbm2lSystem.append( "line: , " + linea + "\n");
      frame30.exit( 0);
      }
    linea = linea.substring( linea.indexOf(':')+1, linea.length());  linea = linea.trim();
    if ( linea.indexOf( '.') != -1)//hay .
      linea = linea.substring( 0, linea.indexOf( '.'));
    if ( linea.indexOf( ';') != -1)//hay ;
      linea = linea.substring( 0, linea.indexOf( ';'));
    linea = linea.trim();
    eq30.nombre = new String( linea);
    }//if
    else {
      kbm2lSystem.append( ERROR + "leerEsquema. flag " + dato30.flag_F + " endoffile ??\n");
      in.close(); 
      return null;
      }
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "leerEsquema. " + dato30.flag_F + "\n");
    kbm2lSystem.append( "file: " + fileName + "\n");
    kbm2lSystem.append( "line: " + linea + "\n");
    frame30.exit( 0, e);
  }//catch

  kbm2lSystem.append("Access Schema. Name: " + eq30.nombre + ".\n");

  eq30.numDecisiones = 0;
  eq30.numAtributos = 0;

  try {//

    while (( linea = in.readLine()) != null) {

      if ( linea.trim().charAt( 0) != ';') {//jumping remarks
    
//ATRIBUTOS
//Att: codigo atributo cdA;
//flag Att
    linea = linea.trim(); 
    if ( dato30.flag_check( linea, dato30.flag_A)) {

      int cdA = leerEqAtributos( linea);
//VALORES
//Val: V0 V1 V2...;
//flag Val
      if ((linea = in.readLine()) != null) {

        while ( linea.trim().charAt( 0) == ';') {
          linea = in.readLine();
          if (linea == null) {
            kbm2lSystem.append( ERROR + "leerEsquema. rem. endoffile \n");
            in.close(); 
            return null;
            }//if
          }//while-remarks-valores

        linea=linea.trim();
        if ( dato30.flag_check( linea, dato30.flag_V)) {
          leerEqValoresAtributos( cdA, linea);          
          }
          else {
           kbm2lSystem.append( ERROR + "flag_check: " + dato30.flag_V + " attribute\n");
           in.close(); 
           return null;
          }//if-
        }//if
      else {
        kbm2lSystem.append( ERROR + "leerEsquema. flag " + dato30.flag_V + " endoffile \n");
        in.close(); 
        return null;
        }
      }//if 
//
      else
    //flag S
    if ( dato30.flag_check( linea, dato30.flag_S)) {
      int cdD = leerEqDecisiones( linea);
//VALORES
      if ((linea = in.readLine()) != null) {

        if ( linea.trim().charAt( 0) != ';') {
          linea=linea.trim(); 
        //V: V0 V1 V2...;
        //flag V
          if ( dato30.flag_check( linea, dato30.flag_V)) {
            leerEqValoresDecisiones( cdD, linea);
            }
            else {
            kbm2lSystem.append( ERROR + "flag_check: " + dato30.flag_V + " decision\n");
            in.close(); 
            return null;
          }//if
        } else continue;//if-remarks
      }//if
  else {
    kbm2lSystem.append( ERROR + "leerEsquema. flag " + dato30.flag_V + " endoffile \n");
    in.close(); 
    return null;
   }
      }
//
      else {
        kbm2lSystem.append( ERROR + "flag_check: AS\n");
        kbm2lSystem.append( ERROR + "line: " + linea + "\n");
        in.close(); 
        return null;
      }
   } else continue;//if-remarks

  }// while ;

  in.close(); 
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "leerEq.");
    e.printStackTrace();
    return null;
  }//catch

  kbm2lSystem.append("Schema readed: " + fileName + ".\n");
  kbm2lControl.setText( kbm2lControl.ListSchema, dato30.workspace + eq30.nombre);

  eq30.browser( frame30.kbm2lSystem);

  return eq30;
}//leerEq

}//class inputEsquema30