//outputEsquema30//
package schema;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kbm2l.*;
import kernel.*;
import control.*;
import tables.*;
import target.*;

/**
* Clase outputEsquema30, semantica de las listas. Output data.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  outputEsquema30  extends  frame30  {

//
  private static final String ERROR = "Error(outputEsquema30): ";
/**
*   
**/
  private esquema30 eq30 = null;
  private base30 b30 = null;
  
/**
* Constructor por defecto
**/
public outputEsquema30( ) {

}//outputEsquema30

/**
* Escribir la descripcion del esquema de una tabla.
* @return eq30, esquema.
**/
public esquema30 escribirEsquema( String fileName, lista30 l30) {
/**
File:nombre.tdu
Att|S: codigo atributo cdA;
V:V0 V1 V2..........;
....................;
**/

  this.eq30 = l30.Esqu;
  this.b30 = l30.Base;

  String linea = null; // linea del fichero que contiene una tabla
  BufferedWriter out = null;
  boolean chk = new controlPrefs30().checkMode();
  int i = 0, k = 0;
  Vector ValoresT = null;
  Vector Valores = null;

  kbm2lSystem.append("Write Schema---: " + dato30.workspace + dato30.nameFile( fileName) + ".\n");

  try {//

  out = new BufferedWriter( new FileWriter( dato30.workspace + dato30.nameFile( dato30.extFile( fileName, "eq"))));

    if ( new controlPrefs30().checkMode()) 
      kbm2lSystem.append("\n" + linea + "\n");

//F: nombre.[txt,kbm]
//flag F
    linea = dato30.flag_F + eq30.nombre + ";";
    out.write( linea, 0, linea.length());
    if ( chk) kbm2lSystem.append("\n" + linea + "\n");
    out.newLine();
  
  try {//
     
  for( i = 0; i < eq30.numDecisiones; i++) {
    linea = dato30.flag_S + " " + 
      ((Integer)eq30.CodigosDecisiones.get( i)).intValue() + " " +
      (String)(eq30.Decisiones.get(i)) + " " + 
      ((Integer)eq30.CDDecisiones.get( i)).intValue() + " ;";
    out.write( linea, 0, linea.length());
    if ( chk) kbm2lSystem.append("\n" + linea + "\n");
    out.newLine();

//VALORES
//Val: V0 V1 V2...;
//flag Val
    linea = dato30.flag_V + " ";
    Vector valores = (Vector)(eq30.ValoresDecisiones.get( i));
    for( int j = 0; j < ((Integer)eq30.CDDecisiones.get( i)).intValue(); j++) 
      linea = linea + " " + ((String)valores.get( j));
    linea = linea + " ;";  
    out.write( linea, 0, linea.length());
    if ( chk) kbm2lSystem.append("\n" + linea + "\n");
    out.newLine();    
  }

}//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "escribirEsquema.1.1\n");
    kbm2lSystem.append( "Dec Code " + ((Integer)eq30.CodigosDecisiones.get( i)).intValue() + "\n");
    kbm2lSystem.append( "Dec Name " + (String)(eq30.Decisiones.get(i)) + "\n");
    kbm2lSystem.append( "Dec Card " + ((Integer)eq30.CDDecisiones.get( i)).intValue() + "\n");
    kbm2lSystem.append( "Values " + ((Vector)(eq30.ValoresDecisiones.get( i))).toString() + "\n");
    kbm2lSystem.append( "BASE:    " + l30.Base.toString() + "\n");
    exit(0, e);
  }//catch

 try {//

  for( i = 0; i < eq30.numAtributos; i++) {

//alinear con la base ext
   ValoresT = ((Vector)eq30.ValoresAtributos.get( i));
   k = b30.indexOfbas( i);
   if ( chk) 
     kbm2lSystem.append( "i: " + i + "  k: " + k + "  dom(k): " + b30.dom( k) + "  att(k): " + b30.att( k).toString()+"\n");
   if ( chk) 
     kbm2lSystem.append( ValoresT.toString() + "\n");
   Valores = new Vector( );
   for( int j = 0; j < b30.dom( k); j++) {
     Valores.add( (String)( ValoresT.get( b30.att( k, j))));      
     }//for-j
   if ( chk) 
     kbm2lSystem.append( Valores.toString() + "\n");
   eq30.ValoresAtributos.set( i, Valores);
//alinear la base   
   for( int j = 0; j < b30.dom( k); j++) 
      b30.att( k, j, j);//dominio en orden canonico

  }//for-i

  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "escribirEsquema. esq|bas.\n");
    kbm2lSystem.append( "BASE:    " + l30.Base.toString() + "\n");
    exit(0, e);
  }//catch

 try {//

//ATRIBUTOS
//Att: codigo atributo cdA;
//flag Att
  for( i = 0; i < eq30.numAtributos; i++) {
    linea = dato30.flag_A + " " + 
      ((Integer)eq30.CodigosAtributos.get( i)).intValue() + " " +
      (String)(eq30.Atributos.get( i)) + " " + 
      ((Integer)eq30.CDAtributos.get( i)).intValue() + " ;";
    out.write( linea, 0, linea.length());
    if ( chk) kbm2lSystem.append("\n" + linea + "\n");
    out.newLine();

//VALORES
//Val: V0 V1 V2...;
//flag Val
    linea = dato30.flag_V+ " ";
    Vector valores = (Vector)(eq30.ValoresAtributos.get( i));
    for( int j = 0; j < ((Integer)eq30.CDAtributos.get( i)).intValue(); j++) 
      linea = linea + " " + ((String)valores.get( j));
    linea = linea + " ;";  
    out.write( linea, 0, linea.length());
    if ( chk) kbm2lSystem.append("\n" + linea + "\n");
    out.newLine(); ;
  }//for-i

}//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "escribirEsquema.1.2\n");
    kbm2lSystem.append( "Att Code " + ((Integer)eq30.CodigosAtributos.get( i)).intValue() + "\n");
    kbm2lSystem.append( "Att Name " + (String)(eq30.Atributos.get( i)) + "\n");
    kbm2lSystem.append( "Att Card " + ((Integer)eq30.CDAtributos.get( i)).intValue() + "\n");
    kbm2lSystem.append( "i: " + i + "  k: " + k + "  dom(k): " + b30.dom( k) + "  att(k): " + b30.att( k).toString()+"\n");
    kbm2lSystem.append( "Values esquema: " + ValoresT.toString() + "\n");
    kbm2lSystem.append( "Values base:    " + Valores.toString() + "\n");     
    kbm2lSystem.append( "BASE:    " + l30.Base.toString() + "\n");
    exit(0, e);
  }//catch

  out.close(); 
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "escribirEsquema.1\n");
    kbm2lSystem.append( "BASE:    " + l30.Base.toString() + "\n");
    exit(0, e);
  }//catch

  kbm2lSystem.append("Schema writed: " + dato30.workspace + dato30.nameFile( fileName) + ".\n");
  kbm2lControl.setText( kbm2lControl.ListSchema, dato30.workspace + eq30.nombre);

  return eq30;
}//escribirEsquema

//flag File
/**
* 
**/
protected String escribeEsquemaFile( BufferedWriter out, String pathKBM, String ext) {
//File: nombre.[kbm]

  int i;
  for( i = pathKBM.length()-1;
      ( pathKBM.charAt( i) != File.separatorChar) && ( pathKBM.charAt( i) != '.') && ( i!=0 ); 
      i--) ;
  if ( pathKBM.charAt( i) == File.separatorChar) pathKBM = pathKBM + "." + ext;
  if ( pathKBM.charAt( i) == '.') pathKBM = pathKBM.substring( 0, i+1) + ext;
  if ( pathKBM.indexOf( File.separatorChar) != -1) {//solo el nombre y extension de la lista
    for( i = pathKBM.length()-1;(pathKBM.charAt( i) != File.separatorChar)&&(1 >= 0); i--) ;
    if (pathKBM.charAt( i) == File.separatorChar) 
      pathKBM = pathKBM.substring( i+1, pathKBM.length());
    }//if

  String linea = dato30.flag_F + "  " + pathKBM + " ;";

  try {
    out.write( linea, 0, linea.length());
    out.newLine();
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "escribeEsquemaFile.\n");
    exit(0, e);
  }//catch

  return linea;
}//escribeEsquemaFile

}//class outputEsquema30