//queryEsquema30//
package schema;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kbm2l.*;
import query.*;

/**
* Clase queryEsquema30, semantica de las tablas y las listas. Query support.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  queryEsquema30    {

//
  private static final String ERROR = "Error(queryEsquema30): ";
  private static final String AVISO = "Warning(queryEsquema30): ";

/**
* flag de ejecucion en curso
**/  
  private esquema30 eq30 = null;
  
/**
* Constructor por defecto
**/
public queryEsquema30( esquema30 eq30) {
  
  this.eq30 = eq30;
}//queryEsquema30

/**
* Vector de strings con los valores de los atributos 
* del esquema para iniciar un dialogo de consulta.
* Por defecto: ZERO valor.
**/
public Vector valoresEq( ) {

  Vector v = null;
  v = new Vector();
  for( int i = 0; i < eq30.numAtributos; i++) {
  try {
    Vector valores = ((Vector)eq30.ValoresAtributos.get( i));
    v.add( new String(((String)valores.get( 0))));
  } catch (Exception e) {
      System.out.println( ERROR + "valoreslEq. " + i);
      e.printStackTrace();
      System.exit( 0);
    }//catch
    }//for
    
  return v;//
}//valoresEq

/**
* Vector de strings con los valores de los atributos 
* del esquema para iniciar un dialogo de consulta.
* Por defecto: "etiqueta" valor.
**/
public Vector valoresEq( String etiqueta) {

  Vector v = null;
  v = new Vector();
  for( int i = 0; i < eq30.numAtributos; i++) {
  try {
    Vector valores = ((Vector)eq30.ValoresAtributos.get( i));
    v.add( new String( etiqueta));
  } catch (Exception e) {
      System.out.println( ERROR + "valoreslEq. " + i);
      e.printStackTrace();
      System.exit( 0);
    }//catch
    }//for
    
  return v;//    
}//valoresEq

/**
* Inicializacion del texto de una consulta. Valor 0.
**/
public String literalEq( ) {
//ATRIBUTOS Y VALORES.
//por defecto, instacias o ZERO valores.
//Att[v0,v1]:v0
  String eqString = null;
  eqString = new String("");
  for( int i = 0; i < eq30.numAtributos; i++) {
  try {
    String atributo = new String(((String)eq30.Atributos.get( i)));
    Vector valores = ((Vector)eq30.ValoresAtributos.get( i));
    eqString = eqString + atributo + "[";
    for( int j = 0; j < valores.size()-1; j++) {
      eqString = eqString + "   " + ((String)valores.get( j)) + ",";
      } 
    eqString = eqString + "   " + ((String)valores.get( valores.size()-1)) + "]:";
    eqString = eqString + ((String)valores.get( 0)) + "\n";
  } catch (Exception e) {
      System.out.println( ERROR + "literalEq. " + i);
      frame30.exit( 0);
    }//catch
    }//for
    
  return eqString;    
}//literalEq

/**
* Inicializacion del texto de una consulta. v etiqueta por defecto 
**/
public String literalEq( String v) {
//ATRIBUTOS Y VALORES.
//Att[v0,v1]:v
  String eqString = null;
  eqString = new String("");
  for( int i = 0; i < eq30.numAtributos; i++) {
  try {
    String atributo = new String(((String) eq30.Atributos.get( i)));
    Vector valores = ((Vector) eq30.ValoresAtributos.get( i));
    eqString = eqString + atributo + "[";
    for( int j = 0; j < valores.size()-1; j++) {
      eqString = eqString + "   " + ((String)valores.get( j)) + ",";
      } 
    eqString = eqString + "   " + ((String)valores.get( valores.size()-1)) + "]:";
    eqString = eqString + v + "\n";
  } catch (Exception e) {
      System.out.println( ERROR + "literalEq. " + i);
      frame30.exit( 0);
    }//catch
    }//for
    
  return eqString;    
}//literalEq

/**
* Inicializacion del texto de una consulta. Valor V.
* Los elementos de V deben estar definidos en el esquema o ser consulta30.OpenValue.
* @param V Vector de String 
* @return eqString String de dialogo
**/
public String literalEq( Vector V) {
//ATRIBUTOS Y VALORES.
//Att[v0,v1]:vi
  String eqString = null;
  eqString = new String("");
  for( int i = 0; i < eq30.numAtributos; i++) {
  try {
    String atributo = new String(((String) eq30.Atributos.get( i)));
    Vector valores = ((Vector) eq30.ValoresAtributos.get( i));
    eqString = eqString + atributo + "[";
    for( int j = 0; j < valores.size()-1; j++) {
      eqString = eqString + "   " + ((String)valores.get( j)) + ",";
      } 
    eqString = eqString + "   " + ((String)valores.get( valores.size()-1)) + "]:";
    if ((valores.indexOf( ((String)V.get( i))) != -1) || 
        (((String)V.get( i))).compareTo( consulta30.OpenValue) == 0)
      eqString = eqString + ((String)V.get( i)) + "\n";
      else {
        System.out.println( ERROR + "literalEq. att: " + atributo + "  val: " + ((String)V.get( i)));
        Exception e = new Exception (); e.printStackTrace();
        System.exit(0);          
      }
  } catch (Exception e) {
      System.out.println( ERROR + "literalEq. " + i);
      e.printStackTrace();
      System.exit( 0);
    }//catch
    }//for
    
  return eqString;    
}//literalEq

/**
* Traduce el texto de una consulta al Indice fisico en la base del esquema, canonica.
* @param qtexto String con la consulta, del dialogo de consultas.
**/
public Vector indiceEq( String qtexto) {
//Para Terapia3, qtexto:
//Concentracion_Bilirrubuna_3[ Normal, Patologica, MuyPatologica]:?    0
//Terapia1[ NoIngresa, Fot6, Fot12]:?                                  1
//Terapia2[ TerNo, ObsAlt, Obs6, Fot6, Fot12, Fot24, Fot6ExaFot12]:?   2
//Concentracion_Hemoglobina[ Normal, Patologica, MuyPatologica]:?      3
//?                                                                    Terapia3
  Vector INDICE = new Vector();//base del esquema
  String eqS = new String( qtexto);//!!!
  for( int i = 0; i < eq30.numAtributos; i++) {//qtexto lista los atributos igual que el esquema
    try {
      String atributo = new String(((String)eq30.Atributos.get( i)));//nombre
      Vector valores = ((Vector)eq30.ValoresAtributos.get( i));      
      String nombre = null;
      String valor = null;

        try {
        nombre = eqS.substring( 0, eqS.indexOf( '['));
        if ( atributo.equals( nombre)) {
          valor = eqS.substring( eqS.indexOf( ':') + 1, eqS.indexOf( '\n'));//es este !!
          }//if
          else {
            System.out.println( AVISO + "Unexpected attribute: " + atributo + "  i:" + i);
            System.out.println( "eqS. " + eqS);
            valor = "?";
           }
        eqS = eqS.substring( eqS.indexOf('\n') + 1, eqS.length());//siguiente linea (atributo)
        }//try
        catch (Exception e) {
          System.out.println( ERROR + "indiceEq-j. " + i);
          frame30.exit( 0);
        }//catch

      int v = valores.indexOf( valor);//-1 si "?", OpenValue
      if ( v != -1) { INDICE.add( new Integer( v)); }// BC
        else { INDICE.add( new Integer( eq30.marca_libre)); }// BC 
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "indiceEq-i. " + i);
      frame30.exit( 0);
    }//catch
  }//for i

  return INDICE;  //en BC del esquema con posibles -1's, OpenValue !!!
}//indiceEq

/**
* Consulta. Traduce el indice a texto del esquema y la respuesta R(codigo del dominio).
* Muestra el resultado de una consulta.
**/
public String consultaEq( Vector INDICE, Vector RESPUESTA) {

  try {//  
    return consultaEqIndice( INDICE) + consultaEqRespuesta( RESPUESTA); 
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "consultaEq.");
    System.out.println(INDICE.toString());
    System.out.println(RESPUESTA.toString());
    e.printStackTrace();
    System.exit( 0);
  }//catch
    
  return null;
}//consultaEq

/**
* Consulta. Traduce el indice a texto del esquema.
* Muestra el indice de una consulta, en su esquema.
* El INDICE esta en la base canonica, el esquema.
**/
public String consultaEqIndice( Vector INDICE) {

  String qtexto = new String("");
  if ( INDICE.size() == eq30.Atributos.size()) {
  try {//  
    for( int i = 0; i < eq30.numAtributos; i++) {
      qtexto = qtexto + "+  " +
        ((String)eq30.Atributos.get( i)) + ":  ";//atributo i
      Integer I = (Integer)INDICE.get( i);//componente del indice !!!
      if ( I.intValue() != eq30.marca_libre)
        qtexto = qtexto + ((Vector)eq30.ValoresAtributos.get( i)).get( I.intValue()) + "\n";//ligada
        else qtexto = qtexto + "<*>" + "\n";//libre 
      }//for
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "consultaEqIndice. indice");
    System.out.println( INDICE.toString());
    e.printStackTrace();
    System.exit( 0);
  }//catch
  } else {
    System.out.println( ERROR + "consultaEqIndice.");
    System.out.println( INDICE.toString());
    System.exit( 0);
  }

  return qtexto; 
}//consultaEqIndice

/**
* Consulta. Traduce la respuesta R(codigo del dominio)
* Respuesta escalar    <>----<>   literal.
* Respuesta vectorial  <>----<>  literales.
**/
public String consultaEqRespuesta( Vector RESPUESTA) {

  String qtexto = new String("");
  if ( RESPUESTA.size() == eq30.Decisiones.size()) {
  try {//  
    for( int i = 0; i < eq30.numDecisiones; i++) {
      qtexto = qtexto + "::#  " + ((String)eq30.Decisiones.get( i)) + ":  ";//decision i
      Integer R = (Integer)RESPUESTA.get( i);//componente de la respuesta !!!
      if ( R.intValue() != eq30.marca_libre)
        qtexto = qtexto + ((Vector)eq30.ValoresDecisiones.get( i)).get( R.intValue()) + "\n";//known
        else qtexto = qtexto + "<*>" + "\n";//desconocida
      }//for
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "consultaEqRespuesta. respuesta");
    System.out.println( RESPUESTA.toString());
    e.printStackTrace();
    System.exit( 0);
  }//catch
  } else {
    System.out.println( ERROR + "consultaEqRespuesta.");
    System.out.println( RESPUESTA.toString());
    System.exit( 0);
  }

  return qtexto; 
}//consultaEqRespuesta

}//class queryEsquema30