//TABEL2D30//
package schema;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
import control.*;
import tables.*;

/**
* Clase table2D30: lista 2D de una lista KBM2L dim1: items, dim2: atts, res: valor atts. 
* crea el esq, hkb y txt de la lista 2D
**/
public class table2D30  extends  frame30  {

//
  private static final String ERROR = "Error(table2D30): ";
/**
* flag de ejecucion en curso
**/  
  public static boolean working = false;

/**
* Constructor por defecto
**/
public table2D30( ) {

}//table2Dl30

/**
* @return la lista 2D de l30
**/
public lista30 table2D( lista30 l30) {

  working = true;

  if ( l30.dimension() == 2) {
    fileTable( l30);
    working = false;
    return l30;
   }

  String pathKBM = esquema2D( l30); 

//leer el esquema 2D
  esquema30 eq30 = new inputEsquema30( (esquema30)null).leerEq( pathKBM);
//escribe la cabecera 2D
  new outputEsquemaCabecera30().escribeCabecera( eq30, 
      dato30.workspace + dato30.extFile( dato30.nameFile( pathKBM), "hkb"), "txt"); 
//contenido
  lista30 l302D = contenido2D( eq30, l30);
  listStat30.KB( l302D);//
  f30.kbm2lSystem.estatus("table2D. " + l302D.size() + "  gapsXY: " + l302D.gapsXY());
//mapa 2D
  fileTable( l302D);
  
  working = false;
  return l302D;
}//table2D

/**
*
**/
private String esquema2D( lista30 l30){

  String pathKBM = l30.Name()+"schema2D.eq";
  String linea = null; // linea del fichero 
  BufferedWriter out = null;

  try {//
    out = new BufferedWriter( new FileWriter( pathKBM));
  }//try
  catch (Exception e) {
    kbm2lSystem.append("Schema generation fail: " + pathKBM + ".\n");
    kbm2lSystem.append( ERROR + "escribeEsquema2D. FileWriter. " + pathKBM + ".\n");
    e.printStackTrace();
    System.exit(0);
  }//catch

 try {//
    linea = dato30.flag_F + "  " + "t2d" + " ;";  
    out.write( linea, 0, linea.length());
    out.newLine();
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR  + "escribeEsquema2DF.\n");
    e.printStackTrace();
    System.exit(0);
  }//catch

try {//
    linea = dato30.flag_S + "  500 " + "VALOR " + sum_dom( l30, l30.dimension())+ " ;";  
    out.write( linea, 0, linea.length());
    out.newLine();
    linea = dato30.flag_V + "  ";
    linea = linea + valores_atts( l30) + " ;";    
    out.write( linea, 0, linea.length());
    out.newLine();
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR  + "escribeEsquema2DS.\n");
    e.printStackTrace();
    System.exit(0);
  }//catch

try {//
    linea = dato30.flag_A + "  100 " + "RULES " + l30.size() + " ;";  
    out.write( linea, 0, linea.length());
    out.newLine();
    linea = dato30.flag_V+ "  ";
    for(int i = 0;i < l30.size(); i++)
      linea = linea + "r"+i + " ";
    linea = linea + " ;";    
    out.write( linea, 0, linea.length());
    out.newLine();
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR  + "escribeEsquema2DA.100\n");
    e.printStackTrace();
    System.exit(0);
  }//catch

try {//
    linea = dato30.flag_A + "  200 " + "FACTORS " + l30.dimension() + " ;";  
    out.write( linea, 0, linea.length());
    out.newLine();
    linea = dato30.flag_V + "  ";
    for(int i = 0;i < l30.dimension();i++)
      linea = linea + ((String)l30.Esqu.Atributos.get( l30.Base.bas( i))) + " ";
    linea = linea + " ;";  
    out.write( linea, 0, linea.length());
    out.newLine();
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR  + "escribeEsquema2DA.200\n");
    e.printStackTrace();
    System.exit(0);
  }//catch

try {//
    out.close(); 
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR  + "esquema2D close\n");
    e.printStackTrace();
    System.exit(0);
  }//catch
  
  return pathKBM;
  
}//esquema2D

/**
* //CONTENIDO: la lista txt
**/
private lista30 contenido2D( esquema30 eq30, lista30 l30) {
  
  String pathKBM = l30.Name()+"schema2D.txt";
  String linea = null; // linea del fichero 
  BufferedWriter out = null;
	
  try {//
    out = new BufferedWriter( new FileWriter( pathKBM));
  }//try
  catch (Exception e) {
    kbm2lSystem.append("Schema generation fail: " + pathKBM + ".\n");
    kbm2lSystem.append( ERROR + "escribeEsquema1. FileWriter. " + pathKBM + ".\n");
    e.printStackTrace();
    System.exit(0);
  }//catch

  for( int i = 0; i < l30.size(); i++) {
	  
  try {//
    linea = "; " + l30.GetIndice( i) + " " + l30.GetRespuesta( i) + l30.GetMedida( i);  
    out.write( linea, 0, linea.length());
    out.newLine();
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR  + "escribeItem.\n");
    e.printStackTrace();
    System.exit(0);
  }//catch

  try {//
    for( int j = 0; j < l30.dimension(); j++) {
      int indexComp = ((Integer)l30.GetIndice( i).get( j)).intValue();
      int sd =0;
	   if (j==0) sd = 0;
	     else sd = sum_dom( l30, j);
      int fixSZ = l30.Fix( i).size();
      if ( j <= fixSZ) {	      
	     int relevCode = indexComp+sd;
        linea = i + " " + j + " " + relevCode + " " + l30.Get( i).getLongitud( ) + " ;"; 
       }
        else {
	        int irrelevCode = 99*(j+1);
	         linea = i + " " + j + " " + irrelevCode + " " + l30.Get( i).getLongitud( ) + " ;";
	        }
      out.write( linea, 0, linea.length());
      out.newLine();
      }//for-j
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR  + "escribeItems.\n");
    e.printStackTrace();
    System.exit(0);
  }//catch

  }//for-i

  try {//
    out.close(); 
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR  + "t2d.txt close\n");
    e.printStackTrace();
    System.exit(0);
  }//catch

  lista30 l302D = new inputTable30().leerTabla( eq30, pathKBM); 
  if ( l302D == null) {
    kbm2lSystem.append( ERROR + "table2D.\n");
    }//if

  return( l302D);
}//contenido2D
	
/**
* //CONTENIDO Rectangular: la lista kbm
**/	
private void fileTable( lista30 l30) { 
  
  String pathKBM = l30.Name()+"Table2D.txt";
  String linea = null; // linea del fichero 
  BufferedWriter out = null;

  try {//
    out = new BufferedWriter( new FileWriter( pathKBM));

   for( int i = 0; i < l30.Base.dom(0); i++) {
     linea= "";
   for( int j = 0; j < l30.Base.dom(1); j++) {
	   Vector INDEX = new Vector();
	   INDEX.add( new Integer( i));
	   INDEX.add( new Integer( j));
      linea = linea + ((Integer)l30.GET( INDEX).GetRespuesta().get( 0)).intValue() + " ";
//      int index_DEC = ((Integer)l30.GET( INDEX).GetRespuesta().get(0)).intValue();
  //    if (index_DEC < l30.Esqu.ValoresDecisiones.size())
    //    linea = linea + ((String)((Vector)l30.Esqu.ValoresDecisiones.get( 0)).get( index_DEC)) + "\t";
      //  else linea = linea + ("ZZZ") + "\t";
       }
      out.write( linea, 0, linea.length());
      out.newLine();
     }

  }//try
  catch (Exception e) {
    kbm2lSystem.append("table2D generation fail: " + pathKBM + ".\n");
    kbm2lSystem.append( ERROR + "escribeEsquema1. FileWriter. " + pathKBM + ".\n");
    e.printStackTrace();
    System.exit(0);
  }//catch

  try {//
    out.close(); 
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR  + "fileTable close\n");
    e.printStackTrace();
    System.exit(0);
  }//catch
  
return;
}//filetable
	
private int sum_dom( lista30 l30, int nAtts) {
	
	int sum = 0;
	for( int i = 0; i < nAtts; i++)
	  sum = sum + l30.Base.dom( i);
	return sum;
}//sum_dom


private String valores_atts( lista30 l30) {
	
	String val = "";
	for( int i = 0; i < l30.dimension(); i++) {
		Vector VAtt = (Vector)l30.Esqu.ValoresAtributos.get( l30.Base.bas( i));
  	   for( int j = 0; j < l30.Base.dom( i); j++) {
        val = val + " " + (String)VAtt.get( j) + "." + i ;	     
	     }
	 }
   System.out.println( val);
	return val;
}//valores_atts

/**
* run()
**/
public void run() {

  if ( !working) {
  try {
    long ts0 = (new Date()).getTime();
    f30.activel30 = table2D( f30.activel30);
    frame30.kbm2lTime.append("table2D:: " + (new Date().getTime() - ts0) + ".\n");      
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "run().\n");
    e.printStackTrace();
  }//catch
  }

  return;
}//run

/**
*
**/
private static int STRESS( lista30 l30, int i, int j) {
	
	int r0, r1, r2, r3, r4;
	
	 Vector Index = new Vector();
	    Index.add( new Integer( i));
	    Index.add( new Integer( j));
	    item30 it = l30.GET( Index);
	    r0 = l30.GetRespuesta( l30.indexOf( it),0);
	    r1=r0;r2=r0;r3=r0;r4=r0;
	    if ( i>0) {
		   Index = new Vector();
	      Index.add( new Integer( i-1));
	      Index.add( new Integer( j));
	      r1 = l30.GetRespuesta( l30.indexOf( it),0); 
	      } 
	    if ( j>0) {
		   Index = new Vector();
	      Index.add( new Integer( i));
	      Index.add( new Integer( j-1));
	      it = l30.GET( Index);
	      r2 = l30.GetRespuesta( l30.indexOf( it),0); 
	      } 
	    if ( i<l30.Base.dom(0)-1) {
		   Index = new Vector();
	      Index.add( new Integer( i+1));
	      Index.add( new Integer( j));
	      it = l30.GET( Index);
	      r3= l30.GetRespuesta( l30.indexOf( it),0); 
	      } 
	    if ( j<l30.Base.dom(1)-1) {
		   Index = new Vector();
	      Index.add( new Integer( i));
	      Index.add( new Integer( j+1));
	      it = l30.GET( Index);
	      r4 = l30.GetRespuesta( l30.indexOf( it),0); 
	      } 
	    return (Math.abs(r0-r1) + Math.abs(r0-r2) + Math.abs(r0-r3) + Math.abs(r0-r4));

	}//STRESS

/**
* Stress 2D, chk All-stress, !chk 10000-stress
**/
public static int stress( lista30 l30) {
	
	int Stress = 0;
	
	if (chk)
	for( int i = 0; i < l30.Base.dom(0); i++)
	  for( int j = 0; j < l30.Base.dom(1); j++) {
	    Stress = Stress + STRESS( l30, i, j);
	   }
	   else {
		   Random gr = control30.gr;
		   int i = 0, j = 0;
		   int S = 0;
		   while ( S < 10000) {
		     i = Math.abs( gr.nextInt() % l30.Base.dom(0));
		     j = Math.abs( gr.nextInt() % l30.Base.dom(1));
		     Stress = Stress + STRESS( l30, i, j);
		     S++;
		     }//while
           Stress = Stress * l30.Base.dom(0) * l30.Base.dom(1) / 10000;
		   }
	   
	return Stress;
}//stress

}//class table2D30
