//SPECTRUMPAINT30.
package spectrum;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;
import java.awt.event.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
import control.*;

/**
* Clase spectrumPaint30, grafica de listas y descripcin de items.
**/
public  class  spectrumPaint30  extends  spectrum30  implements  Runnable  {

  private static final String ERROR = "Error(spectrumPaint30): ";

/**
* Constructor.
* Se le llama cada vez que hay que mostrar el spectrum.
* Ventana y escucha. Cursor, background, 
**/
public spectrumPaint30( frame30 f30) {

  this.f30 = f30;
  this.f30.activel30.Base = new base30( f30.activel30.Base);
  frame = new Frame(  "KBM2L30 = " +  "SPECTRUM - ");
  frame.addWindowListener( new spectrumListener());//eventos de la ventana

  spectrum();
    
  System.out.println( "spectrumPaint30");  
}//BrowserSpectrumPaint30

/**
* Inicializacin del canvas para el spectrum
**/
private void spectrum() {

  setCursor( new Cursor( Cursor.CROSSHAIR_CURSOR));
  setBackground( Color.white);
  COLOR = new Vector();//colores del espectro
  POLITICA = new Vector();//espectro de alternativas

//Layout
  GridBagConstraints C = new GridBagConstraints();
  GridBagLayout gbl = new GridBagLayout();
  frame.setLayout( gbl); 

  C.gridx = 0; C.gridy = 0;
  C.gridwidth = 1; C.gridheight = 2;
  C.fill = GridBagConstraints.BOTH;
  C.ipadx = 0; C.ipady = 0;
  C.insets = new Insets(5,5,5,5);
  C.anchor = GridBagConstraints.CENTER;
  C.weightx = 1; C.weighty = 1;
  gbl.setConstraints( this, C);
  frame.add( this);
  frame.setLocation( 0, 70);
  frame.setSize(900, 100);
  frame.setVisible(true);
  frame.toFront();  

  clearSpectrum( );

  level = 0;
  wCanvas = getSize().width;
  hCanvas = getSize().height;

}//spectrum

/**
* Prepara el canvas
**/
private void clearSpectrum( ) {
//ini

  setBackground( Color.white);
  COLOR = new Vector();//colores del espectro
  POLITICA = new Vector();//espectro de alternativas

  getGraphics( ).setColor( Color.white);
  getGraphics( ).fillRect(0, 0, getSize().width, getSize().height);
  frame.toFront();

  return;
}//clearSpectrum

/**
* Para asignar colores diferentes, la distancia de un nuevo color a los existentes.
**/
private long colorDistance( Vector COLOR, int r, int g, int b) {

  if ( COLOR.size() == 0) return 100000;

  double minD = 1000.0 * 1000.0 * 1000.0, d = 0.0;

  for( int i = 0; i < COLOR.size(); i++) {
    int r0 = ((Color)COLOR.get( i)).getRed(); 
    int g0 = ((Color)COLOR.get( i)).getGreen(); 
    int b0 = ((Color)COLOR.get( i)).getBlue();
    if ((Math.abs( r0 - r) < 3) || (Math.abs( g0 - g) < 3) || (Math.abs( b0 - b) < 3)) {
      return 0;//demasiado cerca
      }
    d = Math.abs( (double)r0 - r) * Math.abs( (double)r0 - r) + 
        Math.abs( (double)g0 - g) * Math.abs( (double)g0 - g) + 
        Math.abs( (double)b0 - b) * Math.abs( (double)b0 - b);
    if ( d < 90) return 0;
    if ( d < minD) minD = d;
  }

  return (long)minD;
}//colorDistance

/**
* Un color al azar a cierta distancia del conjunto COLOR.
**/
private Color randomColor( int distColor) {

  //generador de colores RGB
  int r = Math.abs( control30.gr.nextInt( 240)), 
      g = Math.abs( control30.gr.nextInt( 215)), 
      b = Math.abs( control30.gr.nextInt( 175));

  while ( colorDistance( COLOR, r, g, b) < distColor) {
    r = Math.abs( control30.gr.nextInt( 255));
    g = Math.abs( control30.gr.nextInt( 255));
    b = Math.abs( control30.gr.nextInt( 255));
    }//while

  return new Color( r, g, b);
}//randomColor

/**
* Se asigna automaticamente pero podria ser desde el esquema o la cabecera de l30.
* @params l30 lista
**/
private void colorPolitica( lista30 l30) {

  try {	  
  if ( COLOR.size() == 0) {
	 control30.gr.setSeed( 2005); 
    int i = 0;
    COLOR = new Vector();
    POLITICA = listStat30.DS( l30);
    for( i = 0; i < POLITICA.size(); i++) {
      Vector Respuesta = (Vector)(POLITICA.get( i));
      int r=0, g=0, b=0;
      for( int j = 0; j < l30.ParRespuesta(); j++) {
        r = r + Math.abs( control30.gr.nextInt( 256));
        g = g + Math.abs( control30.gr.nextInt( 256));
        b = b + Math.abs( control30.gr.nextInt( 256));
        }
        r = r % 256; g = g % 256; b = b % 256;
//        System.out.println( Respuesta.toString() + " rgb " + r +" "+ g +" "+ b);  
        COLOR.add( new Color( r, g, b, 207));
    }//for-i
  }//if COLOR
  } catch (Exception e) {
    System.out.println( ERROR + "ColorPolitica(): " + l30.Name());  
    e.printStackTrace();
    System.exit( 0);
  }//catch

  if ( !listStat30.completa( l30)) {
    POLITICA.add( 0, l30.UNKB);
    COLOR.add( 0, Color.black);//unKB
    }

  if ( COLOR.size() != POLITICA.size()) {
    System.out.println( ERROR + "colorPolitica.\nCOLOR: " + 
      COLOR.toString() + " -- \nPOLITICA: " + POLITICA.toString()); 
    System.out.println( "C: " + COLOR.size() + "  P: " + POLITICA.size());  
    System.exit(0); 
    }
    
  if ( new controlPrefs30().checkMode()) System.out.println( "P " + POLITICA.toString());
  if ( new controlPrefs30().checkMode()) System.out.println( "C " + COLOR.toString());
  return;
}//colorPolitica

/**
* Pinta una banda del color de la politica en el spectrum para un item i de la lista
* Pinta Casos o Items asignado un pixel de ancho segun preferencias
* @see controlPrefs30#spectrumChart()
* @params g contexto grafico del canvas
* @params firstOffset primer caso que se va a pintar de la lista
* @params l30 lista
* @params i numero de item en l30
* @return OF2, ultimo offset que se pinta
**/
private double itemSpectrum( Graphics g, BigInteger firstOffset, lista30 l30, int i) {

  double OF1 = -1, OF2 = -1, wItem = -1;
  item30 item = l30.Get( i);

  try {
    g.setColor( (Color)COLOR.get( POLITICA.indexOf( item.GetRespuesta())));
  } catch (Exception e) {
    System.out.println( ERROR + "itemSpectrum()");  
    System.out.println( "COLOR: " + COLOR.toString());  
    System.out.println( "POLITICA: " + POLITICA.toString());
    System.out.println( "respuesta: " +item.GetRespuesta());   
    System.out.println( "C: " + COLOR.size() + "  P: " + POLITICA.size());  
    e.printStackTrace();
    System.exit( 0);
  }//catch

  OF1 = item.getOffsetInf().add( firstOffset.negate()).doubleValue();
  OF2 = item.getOffsetSup().add( firstOffset.negate()).doubleValue();
  wItem = (int)((OF2 - OF1 + 1));//numero de casos

  if ( prefSpectrum) { // Case

    int X = -1, Y = -1;

    if ((int)((OF1+wItem)*(prefResolution)) <= wCanvas) 
      X = (int)((OF1+wItem)*prefResolution);
      else X = wCanvas;
    if ((int)(level+hCanvas/prefLines) <= hCanvas)   
      Y = (int)(level+hCanvas/prefLines);
      else Y = hCanvas;
    item.setBox( (int)(OF1*(prefResolution)),  // X
                 (level),                      // Y==0, ==10, =20,...
                 X,  // X+item-size
                 Y);        // Y+h
                 
    if ((int)(wItem*prefResolution) <= wCanvas) 
      X = (int)(wItem*prefResolution);
      else X = wCanvas;
    if ((int)(hCanvas/prefLines) <= hCanvas)   
      Y = (int)(hCanvas/prefLines);
      else Y = hCanvas;
    g.fillRect( (int)(OF1*(prefResolution)),  // X
                (level),                      // Y==0, ==10, =20,...
                X,  // item-size
                Y);        // h

    if ( prefItemsVBars) { // yes / no
      g.setColor( Color.black); 
      g.fillRect( (int)((OF2+1)*(prefResolution))-1, 
                  (level), 
                   (1), 
                   (int)(hCanvas/prefLines));// vertical limits for items
      }//if-bars

      }//if
      else { // item
        OF2 = 0.0;//no break en Paint( Graphics)
        if ( (i - firstItem) <= wCanvas) {
          item.setBox( (int)((i - firstItem)*prefResolution), 
                       (0), 
                       (int)((i - firstItem)*prefResolution)+(int)(prefResolution), 
                       (0)+(hCanvas/2)+(int)(wItem*hCanvas/MaxwItem.doubleValue( )));
          g.fillRect( (int)((i - firstItem)*prefResolution), 
                      (0), 
                      (int)(prefResolution), 
                      (hCanvas/2)+(int)(wItem*hCanvas/MaxwItem.doubleValue( )));
          }
        }//  
      
  return OF2+1;
}//itemSpectrum

/**
* Muestra el margen derecho del grafico Spectrum.
**/
private void rigthMarg( Graphics g, BigInteger firstOffset, lista30 l30) {

  double OF2 = -1; 
  int i = l30.size()-1;
  item30 item = l30.Get( i);

    if ( prefSpectrum) { // Case

      OF2 = item.getOffsetSup().add( firstOffset.negate()).doubleValue();
  
      //                X                                 Y==0   X+item-size    Y+h
      g.fillRect( (int)((OF2 + 1) * (prefResolution)),  //
                  (level+prefLines/2),   //(int)(hCanvas/2)-5,    
                  (int)(wCanvas), 
                  5); //

      }//if
        else { //item
          if ( (i - firstItem) <= wCanvas) {
            g.fillRect( (int)((i - firstItem + 1) * (prefResolution)), 
                        (int)(hCanvas/2)-5, 
                        (int)(wCanvas), 5);
            }
          }  

  return;
}//rightMarg

/**
* Paint canvas, browserSpectrum del la lista.
* @see control30#FirstItemBrowser
**/
public  synchronized  void Paint( Graphics g) {

  if ( f30.activel30 == null) {
    f30.kbm2lSystem.estatus("There is not active list.");
    return;
    }
  if ( g == null) {
    f30.kbm2lSystem.estatus("There is not active graphic context.");
    return;
    }

  working = true;

  clearSpectrum( );

  prefSpectrum = new controlPrefs30().spectrumChart();  // Case/Item // true/false
  prefResolution = new controlPrefs30().spectrumResolution();// 0.25, 0.5, 1.0, 2.0, 4.0, 8.0
  prefLines = new controlPrefs30().spectrumLines();
  prefItemsVBars = new controlPrefs30().spectrumItemsVBars();//Yes/No
  firstItem = new controlPrefs30().firstItemBrowser();
  level = 0;
  
  listStat30.calc( f30.activel30); //offsetinf, offsetSup, longitud

  frame.toFront();
  if ( new controlPrefs30().spectrumChart()) { // Case
    frame.setTitle( frame.getTitle().substring( 0, frame.getTitle().indexOf('-')-1) + 
        " - " + "BUILDING CASES.");
    } else {    
    frame.setTitle( frame.getTitle().substring( 0, frame.getTitle().indexOf('-')-1) + 
        " - " + "BUILDING ITEMS.");
    }

  colorPolitica( f30.activel30);// COLORES

  if ( firstItem >= f30.activel30.size()) firstItem = f30.activel30.size()-1;
  firstOffset = f30.activel30.Get( firstItem).getOffsetInf(); 
  
  MaxwItem = listStat30.MaximoItem( f30.activel30);
//
  wCanvas = getSize().width;
  hCanvas = getSize().height;

  g.setColor( Color.white);
  g.fillRect( 0, 0, getSize().width, getSize().height);//clear

  int i = -1;
  try {
  for( i = firstItem; i < f30.activel30.size(); i++) {// 

    f30.kbm2lSystem.estatus("Spectrum Paint. Item: " + i);
    if ( !working) break;

    if (( itemSpectrum( g, firstOffset, f30.activel30, i))*prefResolution > wCanvas) {
      if (level < (hCanvas - (int)(hCanvas/prefLines))) { 
        level=level+(int)(hCanvas/prefLines)+1; //siguiente nivel mas 1, separacion
        if ( i+1 < f30.activel30.size()) firstItem = i+1;
        firstOffset = f30.activel30.Get( firstItem).getOffsetInf();      
        }
      } //break;//***

    if ((( i - firstItem)*prefResolution) > wCanvas) { 
      break;
      } //
    
    }//for i

  } catch (Exception e) {
    System.out.println( ERROR + "Paint");  
    e.printStackTrace();
    System.exit( 0);
  }//catch

  g.setColor( Color.black);
  rigthMarg( g,  firstOffset, f30.activel30);//vBars

  endPaint( f30.activel30, i); 

  working = false;
  return;
}//Paint

/**
* Mensaje al titulo de la ventana del espectro de la lista.
* @param i numero del item ultimo que se ha mostrado en el espectro.
* @return void
**/
private void endPaint( lista30 l30, int i) { 

  lastItem = i;
  firstItem = new controlPrefs30().firstItemBrowser();
  if ( new controlPrefs30().spectrumChart()) { //Case

    if ( i < l30.size()-1) {
      frame.setTitle( frame.getTitle().substring( 0, frame.getTitle().indexOf('-')-1) + 
          " - " + "INCOMPLETE CASES (first Item: " + firstItem + ")(last Item: " + i + "). " +
          "Click chart.");

       } else {

      frame.setTitle( frame.getTitle().substring( 0, frame.getTitle().indexOf('-')-1) + 
          " - " + "COMPLETE CASES (first Item: " + firstItem + ". Click chart.");
      }

    } else { //Item

    if ( i < l30.size()-1) {
      frame.setTitle( frame.getTitle().substring( 0, frame.getTitle().indexOf('-')-1) + 
          " - " + "INCOMPLETE CASES (first Item: " + firstItem + ")(last Item: " + i + "). " +
          "Click chart.");

       } else {

      frame.setTitle( frame.getTitle().substring( 0, frame.getTitle().indexOf('-')-1) + 
          " - " + "COMPLETE ITEMS (first Item: " + firstItem + ". Click chart.");
      }
    }//

  return;    
}//endPaint

/**
* Paint in thread.
**/
public void run() {

  if ( !working) {
  try {
    Paint( getGraphics( ));
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
    System.exit( 0);
  }//catch
  }//working
  
  return;
}//run

}//class spectrumPaint30
