//FITNESS30//
package synthesis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kbm2l.*;
import kernel.*;
import target.*;
import control.*;
import tables.*;

/**
* Clase fitness30. Medidas de complejidad de las listas, 
* para algoritmos geneticos y heuristicas
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class fitness30  extends sintesis30  implements  Runnable {

  private static final String ERROR = "Error(fitness30): ";
  public static long maxTime = 0;

/**
* Constructor por defecto
**/
public fitness30(  ) {

  maxTime = new controlPrefs30().timeOutFitness();
}//fitness30

/**
* Constructor por defecto
**/
public fitness30( int timeOutFitness) {

  maxTime = timeOutFitness;
}//fitness30

/**
* Aproximacin del fitness: Low+Upp.
* Crea la lista compatible en la "base"
* Copia los extermos 
* Calcula el Switches neto, scan switches
* @param l30 lista de trabajo, informacin.
* @param base base de atributos de prueba.
* @return Switches entre KB, neto, sin UNKB-items.
**/
public long getFitnessLOWUPP( lista30 l30, base30 base) {

  base30.check(l30.Base);
  base30.check(base);
  if ( base30.cmpB( l30.Base, base)) {
    kbm2lSystem.append( ERROR + "getFitnessLOWUPP.1\n");
    kbm2lSystem.append( "l30.Base.size()= " + l30.Base.size() + "\n");
    kbm2lSystem.append( "l30.Base= " + l30.Base.toString() + "\n");
    kbm2lSystem.append( "base.size()= " + base.size() + "\n");
    kbm2lSystem.append( "base= " + base.toString() + "\n");
    exit(0);
    }

  try {//
    lista30 aux30 = targetStd30.TargetG( l30, base);//crea la lista compatible en la "base"
    if ( new listTest30().aTest( l30, aux30) == null) 
      return ( l30.size() * 2);
    l30.cpLOWUPP( aux30);//copia los casos LOW y UPP de los items
//    System.out.println( "getFitnessLOWUPP: " + aux30.size()); 
    long sw = aux30.Switches( );//scan switches
    if ( sw == 0) return aux30.size(); else return sw;
    } catch (Exception e) {
      kbm2lSystem.append( ERROR + "getFitnessLOWUPP.\n");
      exit( 0);
  }//catch

  return -1;//ERROR 
}//getFitnessLOWUPP

/**
* Crea la lista compatible en la "base"
* Copia los casos LOW de los items items
* Scan switches
**/
public long getFitnessLOW( lista30 l30, base30 base) {

  base30.check(l30.Base);
  base30.check(base);
  if ( base30.cmpB( l30.Base, base)) {
    kbm2lSystem.append( ERROR + "getFitnessLOW.1\n");
    kbm2lSystem.append( "base.size()= " + base.size()+ "\n");
    kbm2lSystem.append( "base= " + base.toString()+ "\n");
    kbm2lSystem.append( "Base.size()= " + l30.Base.size()+ "\n");
    kbm2lSystem.append( "Base.size()= " + l30.Base.toString()+ "\n");
    exit(0);
    }

  try {//
    lista30 aux30 = targetStd30.TargetG( l30, base);//crea la lista compatible en la "base"
    if ( new listTest30().aTest( l30, aux30) == null) 
      return ( l30.size() * 2);
    l30.cpLOW( aux30);//copia los casos LOW de los items
    long sw = aux30.Switches( );//scan switches
    if ( sw == 0) return aux30.size(); else return sw;
    } catch (Exception e) {
      kbm2lSystem.append( ERROR + "getFitnessLOW.\n");
      exit( 0);
  }//catch

  return -1;//ERROR 
}//getFitnessLOW

/**
* Crea la lista compatible en la "base"
* Copia los casos UPP de los items items
* Scan switches
**/
public long getFitnessUPP( lista30 l30, base30 base) {

  base30.check(l30.Base);
  base30.check(base);
  if ( base30.cmpB( l30.Base, base)) {
    kbm2lSystem.append( ERROR + "getFitnessUPP.1\n");
    kbm2lSystem.append( "base.size()= " + base.size()+ "\n");
    kbm2lSystem.append( "base= " + base.toString()+ "\n");
    kbm2lSystem.append( "Base.size()= " + l30.Base.size()+ "\n");
    kbm2lSystem.append( "Base.size()= " + l30.Base.toString()+ "\n");
    exit(0);
    }

  try {//
    lista30 aux30 = targetStd30.TargetG( l30, base);//crea la lista compatible en la "base"
    if ( new listTest30().aTest( l30, aux30) == null) 
      return ( l30.size() * 2);
    l30.cpUPP( aux30);//copia los casos UPP de los items 
    long sw = aux30.Switches( );//scan switches
    if ( sw == 0) return aux30.size(); else return sw;
    } catch (Exception e) {
      kbm2lSystem.append( ERROR + "getFitnessUPP.\n");
      exit( 0);
  }//catch

  return -1;//ERROR 
}//getFitnessUPP

/**
* Fitness de la lista en otra nueva base
**/
public long getFitness( lista30 l30, base30 base) {

  base30.check(l30.Base);
  base30.check(base);
  if ( base30.cmpB( l30.Base, base)) {
    kbm2lSystem.append( ERROR + "getFitness.1\n");
    kbm2lSystem.append( "base.size()= " + base.size()+ "\n");
    kbm2lSystem.append( "base= " + base.toString()+ "\n");
    kbm2lSystem.append( "Base.size()= " + l30.Base.size()+ "\n");
    kbm2lSystem.append( "Base.size()= " + l30.Base.toString()+ "\n");
    exit(0);
    }

  try {//
    maxTime = (new Date().getTime()) + (new controlPrefs30().timeOutFitness());
    
//    return (getFitnessLOW( l30, base) + getFitnessUPP( l30, base))/2;//!!

//    return getFitnessLOW( l30, base);//!

    return getFitnessLOWUPP( l30, base);//!

//    return getFitnessUPP( l30, base);//!

    } catch (Exception e) {
      kbm2lSystem.append( ERROR + "getFitness.1\n");
      exit( 0);
  }//catch

  return -1;//ERROR 
}//getFitness

/**
* Nueva base implicita en el vector orden
**/
public long getFitness( lista30 l30, Vector orden) {

  if ( orden.size() != l30.Base.size()) {
    kbm2lSystem.append( ERROR + "getFitness.2\n");
    kbm2lSystem.append( "orden.size()= " + orden.size()+ "\n");
    kbm2lSystem.append( "orden= " + orden.toString()+ "\n");
    kbm2lSystem.append( "Base.size()= " + l30.Base.size()+ "\n");
    kbm2lSystem.append( "Base.size()= " + l30.Base.toString()+ "\n");
    exit(0);
    }

  if ( !base30.esPermutacion( orden)) {
    kbm2lSystem.append( ERROR + "getFitness.3");
    kbm2lSystem.append( "orden.size()= " + orden.size()+ "\n");
    kbm2lSystem.append( "orden= " + orden.toString()+ "\n");
    exit(0);
    }  

  try {//
    return getFitness( l30, target30.swap( l30.Base, orden));
    } catch (Exception e) {
      kbm2lSystem.append( ERROR + "getFitness.2\n");
      exit( 0);
  }//catch

  return -1;//ERROR 
}//getFitness

/**
* Funcion de fitness de las bases de un fichero con la lista. Sin entorno de ventanas.
**/
public void fitnessF( String kbm2lFile, String basesFile, String fitnessFile) {

	 System.out.println("lista KBM2L: " + kbm2lFile );
	 f30.activel30 = new inputTable30( ).leerTabla( null, kbm2lFile);//
    //
	 System.out.println("Bases: " + basesFile); 
	 int numBases = -1;//param file
	 int timeOutFitness = -1;//param file
	 Vector BASES = new Vector();//poblacion EDA
    BufferedReader in = null;
    String linea = null; // linea del fichero 
    in = dato30.openFile( dato30.nameFile( basesFile), "bas");

    dato30.nextLine( in, linea);
    //extract numBases y timeOutFitness
    numBases = (int)( dato30.param( linea));
    linea = new String( dato30.nextParam( linea, ' '));
    timeOutFitness = (int)( dato30.param( linea));
    maxTime = timeOutFitness;
    for( int i = 0; i<numBases; i++)
      BASES.add( basex30.leerBase( f30.activel30, in));
  try {
    in.close(); 
 }//try
  catch (Exception e) {
    System.out.println( ERROR + "main. " + "file:" + basesFile);
    exit( 0);
  }//catch  
	 
	 System.out.println("Fitness: " + fitnessFile); 	 	 
    fitnessB( fitnessFile, timeOutFitness, f30.activel30, BASES);//kbm2l, bases

  return;
}//fitnessF

/**
* 
*/
public Vector fitnessB( String fitnessFile, int timeOutFitness, lista30 l30, Vector BASES){

	Vector FITNESS = new Vector();
	for( int i = 0; i < BASES.size(); i++) {
		base30 b30 = ((base30)BASES.get( i));
		if ( base30.check( b30)) {
	     Integer FIT = new Integer( (int)getFitnessLOWUPP( l30, b30));
	     FITNESS.add( FIT);
	     } else 
	     FITNESS.add( new Integer( 1000*l30.size()));//bad-fitness
	 }
	 
   //FITTNES >> fitnessFile < edas
    String linea = null; // linea del fichero 
    BufferedWriter out = null;

  try {//
    out = new BufferedWriter( new FileWriter( dato30.workspace + fitnessFile));
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "fitnessB. " + dato30.workspace + fitnessFile + ".\n");
    System.out.println("List fitness generation fail: " + dato30.workspace + fitnessFile + ".\n");
    exit(0, e);
  }//catch
  linea = "";
  for(int i = 0; i < FITNESS.size(); i++) {
    linea = "" + ((Integer)FITNESS.get( i)).intValue();
   
  try {
    out.write( linea, 0, linea.length());
    out.newLine();
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "fitnessB. out.write().");
    exit(0, e);
  }//catch
 }
 
  try {//
    out.close(); 
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "fitnessB. out.close().");
    exit(0, e);
  }//catch
  	 
	return FITNESS;
}//fitnessB

/**
* Funcion de fitness del entorno H2 de la base de la lista active
**/
public void fitness2( ) {

  fitness2( activel30);
  return;
}//fitness2

/**
* Funcin de fitness del entorno H2
* El menor lu se propone como base.
* @param l30 lista30
**/
public void fitness2( lista30 l30) {

  working = true;
//tiempo -cp
  long tcp1 = new Date().getTime();
  long sizeH2 = (l30.dimension()*(l30.dimension()-1)/2);
  kbm2lBrowser.append("Bases Fitness H2. |H2|=" + sizeH2 + ".\n");
  checkList30.chk( l30, "fitness2.");//  checks 
  kbm2lBrowser.append( l30.Name() + " - " + 
    l30.Base.toString() + "\n(low,upp,lowupp)(" 
      + getFitnessLOW( l30, l30.Base) + ", " + getFitnessUPP( l30, l30.Base) + ", " + 
      + getFitnessLOWUPP( l30, l30.Base) + ") G: " + metrica30.G( l30.Base, l30.Base) + "\n");    

  long u0 = getFitnessUPP( l30, l30.Base);
  long minLU = getFitnessLOWUPP( l30, l30.Base);
  base30 minB = new base30( l30.Base);
  long f = 0; long b = 0;
  try {
    FileWriter file;
    PrintWriter p;
  file=new FileWriter(dato30.workspace + File.separatorChar + l30.Name() + ".txt");
  p=new PrintWriter(file);
  for( int i = 0; i < ( l30.dimension() - 1); i++) {
    for( int j = 1; j < ( l30.dimension() - i); j++) {//  Hamming2
      base30 B = null;
      try { B = target30.swap2( new base30( l30.Base), i, i+j); }
      catch (Exception e) {
        System.out.println( ERROR + "fitness2.");
        e.printStackTrace();
        exit( 0);
      }//catch
      long l=0, u=0, lu=0; double g=0;

      if (B.Bas().size() <= 30)
        kbm2lBrowser.append( (f++) + " - " + B.Bas().toString());
      kbm2lBrowser.append( "   " + b++ + " - (" + (l=getFitnessLOW( l30, B)) + ", " + 
        (u=getFitnessUPP( l30, B)) + ", " + (lu=getFitnessLOWUPP( l30, B)) + 
        ") G: " + (g = metrica30.G( l30.Base, B)) + "\n"); 

      if ( minLU > lu) {
        minLU = lu;
        minB = new base30( B);
      }//if

      p.println( b + "," + l + "," + u + "," + lu + "," + g); 

      if ( new controlPrefs30().checkMode()) { 
        kbm2lBrowser.append( " > log(u0-u1)-1 = " + (Math.log(Math.abs(u0-u))-1) + "\n");
        kbm2lBrowser.append( stream( l30) + listStat30.KB( l30)+ "\n");
        lista30 aux30 = l30.cpLOW( targetStd30.TargetG( l30, B));
        kbm2lBrowser.append( stream( aux30) + listStat30.KB( aux30)+ "\n");
        }
      if (!working) break;
    }//for
    if (!working) break;
  }//for
  kbm2lSystem.append("Fitness H2.\n");
  file.close();
  } catch (Exception e) {
    System.out.println( ERROR + "fitness2().");
    e.printStackTrace();
    exit( 0);
  }//catch
 
  frame30.p30 = new  protocolo30();
  lista30 minL = targetStd30.TargetG( l30, minB);
  minL.Name( minL.Name()+"-fitness");
  frame30.p30.add( l30);//original
  minL = new listCopy30().cpl( l30, minL);
  if ( minL != null)
    frame30.p30.add( minL);//copia
  
//  if ( new controlPrefs30().checkMode())
  long tcp2 = (new Date().getTime() - tcp1);
  frame30.kbm2lTime.append( "fitness / B:" + (tcp2 / sizeH2) +
     "   (" + (new Date().getTime() - frame30.TCP1) + ")\n" );
//tiempo cp-
  kbm2lSystem.append("Fitness H2, best in main.\n");
  working = false;
  return;
}//fitness2

private  String  stream( lista30 l30) {

  String s = new String();
  for( int i = 0; i< l30.size(); i++)
    s = s + l30.Get( i).GetRespuesta().toString();

  return s;
}//stream

/**
* 
**/
public void run() {

  if ( activel30.dimension() > 1)
  try {
    long ts0 = (new Date()).getTime();
    fitness2( );
    f30.kbm2lTime.append("fitness2:: " + (new Date().getTime() - ts0) + ".\n");        
  } catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
    exit( 0);
  }//catch

  return;
}//run

}//class fitness30
