//genetico30//
package synthesis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kbm2l.*;
import kernel.*;
import control.*;
import target.*;
import genetic.*;

/**
* Clase genetico30.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class genetico30  extends  sintesis30  implements  Runnable {

  private static final String ERROR = "Error(genetico30): ";
  private static final int porcentajeMutacion = 12;
  private static final int porcentajeSeleccion = 70;

  private int poblacionSize = -1;//tamao de la poblacion
  private Vector bases = null;//Vectores Base, poblacion
  private Vector switches = null;// long fitness

/**
* Constructor general
* Tamao de la poblacion y
* Poblacion de bases aleatoria. 
**/  
public genetico30( lista30 l30) {

  control30.gr.setSeed( new controlPrefs30().randomSeed());
  if ( l30 == null) 
    l30 = f30.activel30;
}//genetico30

/**
*
**/
private int existe( Vector bases, base30 base) {

  for( int i = 0; i < bases.size();i++) {
    if ( base30.eqB( base, ((base30)bases.get( i)))) 
      return i;
    }

  return -1;
}//existe

/**
* Valor del sw de una base de la poblacion
**/
private long swValue( int i) {

  return ((Long)switches.get( i)).longValue();
}//swValue()

/**
* Suma de los valores del sw de las bases de la poblacion
**/
private long sumaSwValue( ) {

  long suma = 0;
  for( int i = 0; i < switches.size(); i++) {
    suma = suma + swValue( i);
    }
  return suma;
}//sumaSwValue()

/**
* Desviacion de los valores del sw de las bases de la poblacion
**/
private long desvSwValue( ) {

  long media = (long)(sumaSwValue() / switches.size());
  double desv = 0.0;
  for( int i = 0; i < switches.size(); i++) {
    long sw = swValue( i);
    desv = desv + Math.pow((sw - media),2);
    }
  return (long)Math.sqrt( desv);
}//desvSwValue()

/**
* Base optima de la poblacion, minimo swValue
* @return b int, indice de la base en el vector de bases, poblacion
**/
private int minPoblacion() {

  long min = 10000;
  int b = 0;
  try {
  for( int i = 0; i < bases.size(); i++)
    if ( min > swValue( i)) {
      min = swValue( i);
      b = i;
      }
  } catch (Exception e) {
    System.out.println( ERROR + "minPoblacion().");
    e.printStackTrace();
    System.exit( 0);
  }//catch

  return b;
}//minPoblacion

/**
* Base pesima de la poblacion, maximo swValue
* @return b int, indice de la base en el vector de bases, poblacion
**/
private int maxPoblacion() {

  long max = 0;
  int b = 0;
  try {
  for( int i = 0; i < bases.size(); i++)
    if ( max < swValue( i)) {
      max = swValue( i);
      b = i;
      }
  } catch (Exception e) {
    System.out.println( ERROR + "maxPoblacion().");
    e.printStackTrace();
    System.exit( 0);
  }//catch

  return b;
}//maxPoblacion

/**
*
**/
private void mutacion( lista30 l30) {

  int bsz = bases.size();
  for( int i = 0; i < bsz; i++) {
    int b = control30.gr.nextInt( bases.size());
    if ( control30.gr.nextInt( 100) < porcentajeMutacion) {

      base30 B = (base30)(bases.get( b));
      int x = control30.gr.nextInt( l30.dimension());
      int y = control30.gr.nextInt( l30.dimension());
      base30 newB = new base30( B);
      if ( x != y) {      
        target30.swap2( newB, x, y);
        }
      bases.add( newB);// mutacion
      switches.add( new Long( new fitness30().getFitness( l30, newB)));

      newB = base30.randomBase( l30.Base); 
      bases.add( newB);// random bases
      switches.add( new Long( new fitness30().getFitness( l30, newB)));

    }//if 
  }//for
  return;
}//mutacion

/**
* Operador de seleccion_cruce de orden. 
* Cruce de dos bases Bp, Bq de bases, poblacion.
* @return boolean.
**/
private boolean seleccion_cruce( lista30 l30, int Bp, int Bq, int orden) {

  base30 BP = null;
  base30 BQ = null;
  try {
    BP = (base30)(bases.get( Bp));
    if ( BP.size() != f30.activel30.Base.size()) {
      System.out.println( ERROR + "cruce()-0.");
      System.out.println( "BP: " + BP.toString());
      System.exit( 0);
      }
    BQ = (base30)(bases.get( Bq));
    if ( BQ.size() != f30.activel30.Base.size()) {
      System.out.println( ERROR + "cruce()-0.");
      System.out.println( "BQ: " + BQ.toString());
      System.exit( 0);
      }
  } catch (Exception e) {
    System.out.println( ERROR + "cruce()-1.");
    e.printStackTrace();
    System.exit( 0);
  }//catch
  
  if (BP.size() != BQ.size()) {
    System.out.println( ERROR + "cruce");
    System.exit( 0);
    }//

//OP-SELEC
  long m = swValue( minPoblacion());
  if (( control30.gr.nextInt( 100) * swValue( Bp)) > (porcentajeSeleccion * m)) 
    return false;
  if (( control30.gr.nextInt( 100) * swValue( Bq)) > (porcentajeSeleccion * m)) 
    return false;

//OP-CRUCE
  base30 BR = new base30();//base hija
  Vector score = new Vector();//puntuaciones para votar
  boolean xb = new controlPrefs30().nBase();
  try {
  for( int i = 0; i < BP.size(); i++) {//att-i

    double vp = 0;
    for ( int k = 0; k < BP.size(); k++) {
      if ( i == BP.bas( k)) { 
        vp = (double)(k / Math.pow( swValue( Bp), orden)); break; 
        }//if
      }//for k

    double vq = 0;
    for ( int k = 0; k < BQ.size(); k++) {
      if ( i == BQ.bas( k)) { 
        vq = (double)(k / Math.pow( swValue( Bq), orden)); break; 
        }//if
      }//for k  
        
    int p = BP.indexOfbas( i);
    int q = BQ.indexOfbas( i);
    double vr = vp + vq;
    
    if ( BR.size() == 0) {      
      if ( xb) 
        BR.add( BP.dom( p), i, BP.att(p), BP.rol( p));//base30.add( d, b, Att, r)
        else BR.add( BP.dom( p), i, BP.rol( p));//base30.add( d, b, r)
      score.add( new Double( vr)); 
      }
      else {
        for ( int k = 0; k < BR.size(); k++) {
          if ( vr >= ((Double)score.get( k)).doubleValue()) {
            if ( xb) 
              BR.add( k, BP.dom( p), i, BP.att(p), BP.rol( p)); 
              else BR.add( k, BP.dom( p), i, BP.rol( p)); 
            score.add( k, new Double( vr)); 
            break;
            }//if
          }//for k

        if ( BR.indexOfbas( i) == -1) { // no esta porque su vr mayor que todos los scores
          if ( xb) 
            BR.add( BP.dom( p), i, BP.att(p), BP.rol( p)); // se pone el ultimo
            else BR.add( BP.dom( p), i, BP.rol( p)); // se pone el ultimo
          score.add( new Double( vr));       
          }//if
          
      }//else    
    }//for i
  } catch (Exception e) {
    System.out.println( ERROR + "cruce()-2.");
    System.out.println( "BP: " + BP.toString());
    System.out.println( "BQ: " + BQ.toString());
    System.out.println( "BR: " + BR.toString());
    System.out.println( "score: " + score);
    System.out.println( "switches: " + switches);
    e.printStackTrace();
    System.exit( 0);
  }//catch

  if ( BR.size() != l30.Base.size()) {
    System.out.println( ERROR + "seleccion()-1");
    System.out.println( "base.size()= " + BR.size());
    System.out.println( "base= " + BR.toString());
    System.out.println( "Base.size()= " + l30.Base.size());
    System.out.println( "Base.size()= " + l30.Base.toString());
    new Exception().printStackTrace();
    System.exit(0);
    }

  bases.add( BR);// random bases + cruces
  switches.add( new Long( new fitness30().getFitness( l30, BR)));

  return true;
}//seleccion_cruce

/**
* @return void.
**/
private void reduccion( lista30 l30) {

  Vector grandes = new Vector();
  Vector swGrandes = new Vector();

  while ( bases.size() > poblacionSize) {
    int b = maxPoblacion();
    try {//dec poblacion
      grandes.add( ((base30)bases.get( b)));
      swGrandes.add( ((Long)switches.get( b)));
      bases.remove( b);
      switches.remove( b);//borra el mayor Switch.
    } catch (Exception e) {
      System.out.println( ERROR + "reduccion()-1. " + b);
      e.printStackTrace();
      System.exit( 0);
    }//catch
  }//while

//conserva algunas bases de switches grandes.
  try {//poblacion
  if ( grandes.size() > 0)
  for( int i = 0; i < bases.size(); i++)
    if ( control30.gr.nextInt( 100) > 85) {
      int j = control30.gr.nextInt( grandes.size());
      bases.add( (base30)grandes.get( j));
      switches.add( swGrandes.get( j));
      }
    } catch (Exception e) {
      System.out.println( ERROR + "reduccion()-2.");
      e.printStackTrace();
      System.exit( 0);
    }//catch
  
  return;
}//reduccion

/**
* Poblacion inicial
**/
private void iniPoblacion( lista30 l30) {

  int improvs = 0;
  lista30 aux = null;

  kbm2lBrowser.append("ini-Poblacion:\n");
  try {
//    control30.gr.setSeed( (long)(new Date().getTime()));
    control30.gr.setSeed( new controlPrefs30().randomSeed());
    poblacionSize = Integer.parseInt( kbm2lControl.getText( kbm2lControl.PoblacionSize));
  } catch (Exception e) { 
    poblacionSize = 2*l30.dimension(); 
    }//catch

  bases = new Vector();
  switches = new Vector();

  for( int i = 0; i < poblacionSize; i++) {

    kbm2lBrowser.append(" " + (poblacionSize-i));
    base30 newBase = null;

    try {
      do {
        newBase = base30.randomBase( l30.Base);//bases aleatorias
        if ( (improvs++) > poblacionSize * 10) break;//do-while
      } while ( existe( bases, newBase) != -1);// mientras existan
    } catch (Exception e) {
      System.out.println( ERROR + "genetico30()-1.");
      e.printStackTrace();
      System.exit( 0);
    }//catch
    
    try {
      if ( (improvs++) > poblacionSize * 10) break;//for i
      aux = targetStd30.TargetG( l30, newBase);//cambio
    } catch (Exception e) {
      System.out.println( ERROR + "genetico30()-2.");
      e.printStackTrace();
      System.exit( 0);
    }//catch

  try{
    if ( aux != null) {//Target ?
      try {
      if ( aux != null) {//improvementTest ?
        bases.add( newBase);//nuevo en la poblacion
        switches.add( new Long( new fitness30().getFitness( l30, newBase)));
        } else {i--;System.out.println( ERROR);}
    } catch (Exception e) {
      System.out.println( ERROR + "genetico30()-3a.");
      e.printStackTrace();
      System.exit( 0);
    }//catch
    }//if
    else {i--;System.out.println( ERROR);}
  } catch (Exception e) {
    System.out.println( ERROR + "genetico30()-3b.");
    e.printStackTrace();
    System.exit( 0);
  }//catch
  if ( !working) break;
  }//for

  kbm2lBrowser.append(".   randomBases: "+ improvs +".\n");
  return; 
}//iniPoblacion

/**
* 
**/
private long verPoblacion( ) {
 
  long desvSw = 0;
  kbm2lBrowser.append("Poblacion.\n");  
  try {
  int bsz = ((base30)bases.get(0)).size();
  for( int i = 0; i < bases.size(); i++) {
    String att = new String();
    for(int j = 0; j < bsz; j++)
      att = att + ((base30)bases.get(i)).att(j).toString() + "\n";
    if (((base30)bases.get(i)).Bas().size() < 20)
      kbm2lBrowser.append( ": " + ((base30)bases.get(i)).Bas() + 
                        " sw: " + swValue( i) + "\n" + att + "\n");
      else kbm2lBrowser.append( ":sw: " + swValue( i) + "\n");
    }//for-i
  } catch (Exception e) {
    System.out.println( ERROR + "verPoblacion().");
    e.printStackTrace();
    System.exit( 0);
  }//catch

  kbm2lBrowser.append("Poblacion.   Bases: " + bases.size() + 
    "   sumaSw: " + sumaSwValue( ) + "   desvSw: " + (desvSw=desvSwValue()) + ".\n\n");
  return desvSw;                        
}//verPoblacion

/**
* optimo.
**/
private base30 optimo() {

  long min = swValue( minPoblacion());
  int opt = 0;//minimo  
  try {
  for( int i = 0; i < bases.size(); i++) {
    if ( swValue( opt) > swValue( i)) opt = i;
    }//for
  } catch (Exception e) {
    System.out.println( ERROR + "optimo().");
    e.printStackTrace();
    System.exit( 0);
  }//catch
  
  try {
    return ((base30)bases.get( opt));
  } catch (Exception e) {
    System.out.println( ERROR + "optimo().");
    e.printStackTrace();
    System.exit( 0);
  }//catch

  return null;
}//optimo

/**
* removeOptimo.
**/
private void removeOptimo() {

  long min = swValue( minPoblacion());
  int opt = 0;//minimo  
  try {
  for( int i = 0; i < bases.size(); i++) {
    if ( swValue( opt) > swValue( i)) opt = i;
    }//for
  } catch (Exception e) {
    System.out.println( ERROR + "removeOptimo().");
    e.printStackTrace();
    System.exit( 0);
  }//catch
  
  try {
    bases.remove( opt);
    switches.remove( opt); 
    return;
  } catch (Exception e) {
    System.out.println( ERROR + "removeOptimo().");
    e.printStackTrace();
    System.exit( 0);
  }//catch

  return;
}//removeOptimo

/**
* Run process. Algoritmo genetico.
**/
public lista30 Genetica( lista30 l30) {

  working = true;
  lista30 aux = null;
  int minKbm = l30.size();
  int iter = 0;

  iniPoblacion( l30);
  kbm2lBrowser.append("Iteration: " + iter + "   bases: " + bases.size( ) + 
    "   sumaSw: " + sumaSwValue( ) + "   desvSw: " + desvSwValue() + "\n");
  verPoblacion( );
  try {
  while ( iter++ < 10) {
    if ( !working) break;
    int beta = bases.size();
    for( int p = 0; p < beta-1; p++) {
      for( int q = p+1; q < beta; q++)  {
        if ( control30.gr.nextInt( 100) > 80)
        if ( seleccion_cruce( l30, p, q, 1)) {
//        if ( new controlPrefs30().checkMode())
          kbm2lSystem.estatus("::" + iter + "Cross. p: " + p + ", q: " + q + 
            "   bases: " + bases.size( ) + 
            "   sumaSw: " + sumaSwValue( ) + 
            "   desvSw: " + desvSwValue());
            }
        if ( !working) break;
        }//for q
        if ( !working) break;
      }//for p
      if ( !working) break;
      kbm2lSystem.estatus("::" + iter + "  Mutation. " + bases.size( ));
      mutacion( l30);
      kbm2lSystem.estatus("::" + iter + "  Reduction. " + bases.size( ));
      reduccion( l30); 
      if ( verPoblacion() == 0) break;
    }//while
  } catch (Exception e) {
    System.out.println( ERROR + "Genetica().1");
    e.printStackTrace();
    System.exit( 0);
  }//catch

  try {

//busca la mejor solucion en la poblacion.
   reduccion( l30); 
   while ( bases.size() > 0) {

    if ( ( aux = l30.aTest( targetStd30.TargetG( l30, optimo() ))) == null) {
      kbm2lSystem.append("Sintesis Gentica OK sin mejora. aText.\n");
      kbm2lSystem.append("aux: " + optimo().Bas() + "\n");
      System.out.println( "aux--aTest");
      removeOptimo( );
//      working = false; 
  //    return l30;//sin mejora
      }
   
      else

    if ( ( aux = l30.cpl( aux)) == null) {
      kbm2lSystem.append("Sintesis Gentica OK sin mejora. cpl.\n");
      kbm2lSystem.append("aux: " + optimo().Bas() + "\n");
      System.out.println( "aux--cpl");
      removeOptimo( );
//      working = false; 
  //    return l30;//sin mejora
      } 

      else break;//optimo !!
      
    }//while

  }// 
  catch (Exception e) {
    System.out.println( ERROR + "Genetica().2");
    e.printStackTrace();
    System.exit( 0);
  }//catch

  if ( bases.size() == 0) {
      kbm2lSystem.append("Sintesis Gentica OK sin mejora.\n");
      working = false; 
      return l30;//sin mejora  
    }//if

  kbm2lSystem.append( "Optimo: " + aux.Base.Bas() + ".\n");
  kbm2lSystem.append("minKbm-its: " + minKbm + 
    "    minPoblacion()-sws: " + swValue( minPoblacion()) + ".\n");

  kbm2lSystem.append("Sintesis Gentica OK.\n");
  kbm2lSystem.append("l30.size(): " + l30.size() + "  BestKBM2L: " + aux.size() + ".\n");
  working = false; 
  return aux;//mejora
}//Genetica

/**
* run process
**/
public void run() {

  if ( f30.activel30.dimension() > 1)
  if ( !working) {
  try {

//    lista30 g30 = null;  
  //  while ( f30.activel30 != ( g30 = Genetica( f30.activel30))) 
    //  f30.activel30 = g30;

    long ts0 = (new Date()).getTime();

    f30.activel30 = Genetica( f30.activel30);

    f30.kbm2lTime.append("Sintesis Genetico:: " + (new Date().getTime() - ts0) + ".\n");      
  } catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
    System.exit( 0);
  }//catch
  }

  return;
}//run

}//class genetico30
