//HEURISTICS30//
package synthesis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kbm2l.*;
import kernel.*;
import tools.*;
import control.*;

/**
* Clase heuristics30, 
*
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  heuristics30  extends  frame30  {

//
  private static final String ERROR = "Error(heuristics30): ";
  
/**
* Traza de HG0, contador de bases aceptadas.
**/
  public static long HG0TRUE = -1;
/**
* Traza de HG0, contador de bases rechazadas.
**/
  public static long HG0FALSE = -1;

/**
* Constructor por defecto. Crea la historia del algoritmo.
* crierio de parada general: if (l30.lkbm.size() == ds) fin; 
**/
public heuristics30( lista30 l30) {

  HG0TRUE = 0;
  HG0FALSE = 0;
  checkList30.chk( l30, "heuristics30.");//checks 
}//heuristics30

/**
* Heuristica de entorno variable.
**/
public static boolean  HG0(lista30 l30, lista30 lTarget) {
// l30 es la lista actual

  double maxOffset = -1.0; 
  int ds = -1;
  double g = -1.0;
  Vector RANGO = null;
  
  try {
	  
    if ( !new controlPrefs30().heuristicG0()) 
      return true;//

      maxOffset = new offset30().offset( l30.Base.Dom(), index30.ultimoT( l30.Base.Dom())).doubleValue();
      ds = listStat30.DS( l30).size();//response domain

      g = metrica30.G( l30.Base, lTarget.Base);//distancia

      RANGO = l30.rango();
 
       } catch (Exception e) {
        kbm2lSystem.append( ERROR + "HG0.0\n");
        frame30.exit( 0);
      }//catch

  try {
 
  double r = ((Double)RANGO.get( (int)(RANGO.size()*1/2))).doubleValue();//radio
  double s = 0.0;//tolerancia
  
//log == ln
  double cuasiopt = (1.2*ds)*Math.log( maxOffset);
  if ( l30.size() < cuasiopt) {// cuasi-opt
    if (chk) kbm2lTime.append(  "\nHG0  Cuasi-opt   ");
    if ( g <= r) {
	    if (chk) kbm2lTime.append( "VNH++: " + l30.size() + " < " + (cuasiopt) +
	    "   G " + (g) + "  R " +  "  r " + (r) + "\n");
	    HG0TRUE++;return true;}
    else if ( g > r+s) {
	    if (chk) kbm2lTime.append( "VNH--: " + l30.size() + " < " + (cuasiopt) +
	    "   G " + (g) + "  R " + "  r+s " +  (r+s) + "\n");
	    HG0FALSE++;return false;}//cerca del opt no debemos ir lejos
    }
    
  double nonopt = (1.2*ds*ds)*Math.log( maxOffset);  
  if ( l30.size() > nonopt) {// non-opt
    if (chk) kbm2lTime.append(  "\nHG0  Non-opt   ");
    if ( g < r-s) {    
	    if (chk) kbm2lTime.append( "VNH--: " + l30.size() + " > " + (nonopt) +
	    "   G " + (g) + "  R " + "  r-s " +  (r-s) + "\n");
	    HG0FALSE++;return false;}//lejos del optimo debemos ir lejos
    else if ( g >= r) {
	    if (chk) kbm2lTime.append( "VNH++: " + l30.size() + " > " + (nonopt) +
	    "   G " + (g) + "  R " + "  r " +  (r) + "\n");
	    HG0TRUE++;return true;}
    }

  kbm2lTime.append( "HG0  ???\n  VNH: " + l30.size() + "  " + (cuasiopt) + "  " + (nonopt)  +
	    "   G " + (g) + "  R " + "  r " +  (r) + "\n");
  HG0TRUE++;
    
       } catch (Exception e) {
        kbm2lSystem.append( ERROR + "HG0.1\n");
        kbm2lSystem.append( RANGO.toString()+"\n");
        frame30.exit( 0);
      }//catch

  return true;//OK
}//HG0

}//class heuristics30
