//sintesis30//
package synthesis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
import tables.*;
import control.*;

/**
* Clase sintesis30, Directa, Hamming y Genetica.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  sintesis30  extends  frame30  {

  private static final String ERROR = "Error(sintesis30): ";
/**
* flag de ejecucion en curso
**/
  public  static boolean working = false;//
  
  protected static lista30 l30 = null;
  protected boolean reset = false;
  protected  lista30 aux1 = null;//opt-local
  protected  long minkbm = -1;//parcial
  protected  long minKBM = -1;//inicial
  protected int targets  =  -1;//en una sintesis.
  protected int copias   =  -1;//en una sintesis.
  protected int iteraciones = -1;//en una sintesis.
  protected int pivotes = -1;//en una sintesis.
  protected int attTop = -1;//0
  protected int attBot = -1;//t
  protected boolean chk = false;//Check List

/**
* Constructor por defecto. Crea la historia del algoritmo.
* Crierio de parada general: if (l30.lkbm.size() == ds) fin; 
**/
public sintesis30( ) {

}//sintesis30

/**
* Fija objetivos y dimensiones que van a permutar [attTop, attBot].
**/
protected lista30 inikbs( lista30 l30) {

  reset = false;
  aux1 = null;//opt-local
  targets  =  0;//en una sintesis.
  copias   =  0;//en una sintesis.
  iteraciones = 0;//en una sintesis.
  pivotes = 1;//en una sintesis.

  chk = new controlPrefs30().checkMode();
  if ( l30 != null) {
    checkList30.chk( l30, "sintesis30.");//checks 
    if ( new controlPrefs30().listHistory()) {
      p30 = new protocolo30( "History-" + l30.Name());
      p30.add( l30);
      }
    }

  try {

    minKBM = l30.optSize();//objetivo-inicial
    minkbm = minKBM;//objetivo-final
    kbm2lSystem.append( "inikbs. Cases: " + listStat30.KB( l30) + 
      "  Alternatives:" + listStat30.DS( l30).size()  + 
      "  Items:" + minKBM + "  Switches: " + l30.Switches( l30.size()) + "\n");

    attTop = new controlPrefs30().onTopAttribute( );
    if (( attTop < 0) || ( attTop >= l30.dimension())) {
      kbm2lSystem.estatus( "Hamming2. " + l30.size() + "  attTop: " + attTop);
      return null;//OK
      }
    attBot = new controlPrefs30().onBotAttribute( );
    if (( attBot <= 0) || ( attBot > l30.dimension())) {
      kbm2lSystem.estatus( "Hamming2. " + l30.size() + "  attBot: " + attBot);
      return null;//OK
      }
    if ( attTop >= attBot) {
      f30.kbm2lSystem.estatus( "Hamming2. sz: " + l30.size() + " attTop: " + attTop + " attBot: " + attBot);
      kbm2lSystem.append( "inikbs. attTop >= attBot. \n");
      return null;//OK
      } 
    }//try
  catch ( Exception e) {
    System.out.println( ERROR + "inikbs.");
    f30.exit( -1, e);
  }//catch
  
  if ( chk) {
    l30.BasesListReset( );    
    }

  f30.kbm2lSystem.append( "inikbs.  attTop: " + attTop + "  attBot: " + attBot + "\n");

  return l30;
}//inikbs

/**
* Mensajes y actualizacion de las lista si es mejor.
* @param l30 lista inicial.
* @param aux1 nueva lista.
* @param tipo de estrategia de optimizacion.
* @return l30 lista.
**/
protected lista30 kbs( lista30 l30, lista30 aux1, String tipo) {

  kbm2lTime.append( "+BASE:" + aux1.Base.Bas().toString() + "\n - Items: " + aux1.size() + "\n");
  kbm2lTime.append( "Hamming: " + metrica30.H( l30.Base, aux1.Base) + "  ");
  kbm2lTime.append( "G: " + metrica30.G(l30.Base, aux1.Base) + "\n");
  kbm2lTime.append( tipo + " - : - Coalescence: " + (minkbm - aux1.size()) + 
                             "  : - Optimmization: " + (minkbm - aux1.optSize()) +
    "   Old Switches: " + l30.Switches( l30.size()) +
    "   New Switches: " + aux1.Switches( l30.size()) + "\n");
  minkbm = aux1.optSize(); // aux1.size();//opt-sist!!!
  l30  = new lista30( aux1, aux1);
  checkList30.chk( l30, "sintesis-min-optimizada.");//checks
  kbm2lBrowser.summaryView( l30);//destino optimizado copiado
  kbm2lControl.setText( kbm2lControl.ListName, l30.Name());
  kbm2lControl.setText( kbm2lControl.ListSize, String.valueOf( l30.size()));
  if ( new controlPrefs30().listHistory()) {
    p30.add( l30);
    }
  return l30;
}//kbs

/**
* knowledge base synthesis.
* Cambia de base a distancia Hamming - R.
* @param l30 lista original
* @return lista con el kb original en la nueva base 
**/
public lista30 kbsR( lista30 l30) {

  lista30 lTarget = null;
  targets++;
  
  kbm2lSystem.estatus( "HR swap  " + l30.BasesList.size());
  if ( chk) System.out.print( "HR swap  " );

  try {
 
    lTarget = targetStd30.TargetR( l30, attTop, attBot);
    if ( lTarget == null) return null;
    
    if (( lTarget = l30.bTest( lTarget)) == null) { kbm2lTime.append( "kbsR.stdCopy.   l30.bTest.\n");
      return null;//incompleta
      }
      else l30.BasesListHistory( lTarget, "TargetR");//add new base

    if ( !heuristics30.HG0(l30, lTarget)) { kbm2lTime.append( "kbsR.stdCopy.   !heuristics30.HG0.\n");
      return null;//!!!
      }

    if ( (lTarget = l30.aTest( lTarget)) == null) { kbm2lTime.append( "kbsR.stdCopy.   l30.aTest.   TRUE.\n");
      return null;//incompleta
      }

    if ( (lTarget = l30.iTest( lTarget)) == null) { kbm2lTime.append( "kbsR.stdCopy.   l30.iTest.   ###\n");
      return null;//incompleta
      } 
      else {
          kbm2lTime.append( "  OK.  target.size: " + lTarget.size() + 
                              ".  target.sw:   " + lTarget.switches +  ".  target.xy:   " + lTarget.gapsXY() + "\n" + 
                              lTarget.Base.Bas().toString() + "  G: " + metrica30.G( l30.Base, lTarget.Base) + "\n"); 
      }
    kbm2lTime.append("\n" + lTarget.Base.toString( lTarget) + "  ***  sw: " + lTarget.switches);  
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "kbsR-1."); frame30.exit( 0);
  }//catch

  if ( chk)
  if ( lTarget.Base.Bas().size() <= 24 ) {
    kbm2lTime.append( "kbsR.cpl " +lTarget.Base.Bas()+ " - " +(copias++)+ " - " + targets+"\n");
    }
    else {
      kbm2lTime.append( "kbsR.cpl - " +(copias++)+ " - " + targets+"\n");
      }

  kbm2lSystem.estatus( "HR swapped " + l30.BasesList.size());
  if ( chk) System.out.println( "   HR swapped  " );

  return l30.cpl( lTarget);  
}//kbsR

/**
* knowledge base synthesis.
* Cambia de base a distancia Hamming - D.
* @param l30 lista original
* @return lista con el kb original en la nueva base 
**/
public lista30 kbsD( lista30 l30, Vector ordenBase) {

  lista30 lTarget = null;
  targets++;
  
  kbm2lSystem.estatus( "HD swap  " );
  if ( chk) System.out.print( "HD swap  " );

  try {

    if ( (lTarget = l30.bTest( targetStd30.TargetG( l30, target30.swap( l30.Base, ordenBase)))) == null) {
      //kbm2lTime.append( "kbsD.stdCopy.   l30.bTest.\n");
      return null;//incompleta
      }
      else l30.BasesListHistory( lTarget, "TargetD");//add new base

    if ( !heuristics30.HG0( l30, lTarget)) {
      //kbm2lTime.append( "kbsD.stdCopy.   !heuristics30.HG0.   TRUE.\n");
      return null;//!!!
      }

     if ( (lTarget = l30.aTest( lTarget)) == null) {
      //kbm2lTime.append( "kbsD.stdCopy.   l30.aTest.   TRUE.\n");
      return null;//incompleta
      }

    if ( (lTarget = l30.iTest( lTarget)) == null) {
      //kbm2lTime.append( "kbsD.stdCopy.   l30.iTest.   ###\n");
      return null;//incompleta
      } 
      else {
          kbm2lTime.append( "  OK.  target.size: " + lTarget.size() + 
                              ".  target.sw:   " + lTarget.switches +  ".  target.xy:   " + lTarget.gapsXY() + "\n" + 
                              lTarget.Base.Bas().toString() + "  G: " + metrica30.G( l30.Base, lTarget.Base) + "\n"); 
      }
    kbm2lTime.append("\n" + lTarget.Base.toString( lTarget) + "  ***  sw: " + lTarget.switches);  
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "kbsD-1.");
    frame30.exit( 0);
  }//catch

  if ( chk)
  if ( lTarget.Base.Bas().size() <= 24 ) {
    kbm2lTime.append( "kbsD.cpl " +lTarget.Base.Bas()+ " - " +(copias++)+ " - " + targets+"\n");
    }
    else {
      kbm2lTime.append( "kbsR.cpl - " +(copias++)+ " - " + targets+"\n");
      }

  kbm2lSystem.estatus( "HD swapped");
  if ( chk) System.out.println( "   HD swapped  " );

  return l30.cpl( lTarget);  
}//kbsD

}//class sintesis30
