//sintesisDirecta30//
package synthesis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kbm2l.*;
import tables.*;
import control.*;
import kernel.*;
import tools.*;
import target.*;

/**
* Test sobre los atributos y las propiedades de union y framentacion.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class sintesisDirecta30 extends sintesisHamming30  {

  private static final String ERROR = "Error(sintesisDirecta30): ";
//
//

/**
* Constructor por defecto
* crierio de parada general: if (l30.lkbm.size() == ds) fin; 
**/
public sintesisDirecta30( ) {

  this.l30 = f30.activel30;
}//sintesisDirecta30

/**
* Constructor por defecto para una lista especifica.
**/
public sintesisDirecta30( lista30 l30) {

  this.l30 = l30;
}//sintesisDirecta30

/**
* Espacio de permutaciones 2!.
* @param BAS Vector orden de la base una lista30
* @return SPACE Vector de Vector espacio de bases
**/
private Vector space2( Vector BAS) {

  if ( BAS.size() != 2) {
    System.out.println( ERROR + "space2.");
    frame30.exit( 0);
    }

  Vector S2 = new Vector();
  Vector P0 = new Vector();
  P0.add( (Integer)BAS.get(0));
  P0.add( (Integer)BAS.get(1));
  S2.add( P0);
  Vector P1 = new Vector();
  P1.add( (Integer)BAS.get(1));
  P1.add( (Integer)BAS.get(0));
  S2.add( P1);    
  return S2;//[[0,1],[1,0]]
}//

/**
* Espacio de permutaciones n!.
* @param SPACE Vector de Vector ordenes !
* @param SPACE2 Vector de Vector ordenes 2!
* @return SPACE Vector de Vector espacio de bases
**/
private Vector producto( Vector SPACE1, Vector SPACE2) {

  if ( SPACE1.size() == 0) {
    return SPACE2;
   }
    
  Vector PROD = new Vector();
  for( int i = 0; i < SPACE2.size(); i++) {
	 Vector S2 = (Vector)SPACE2.get( i);
    for( int j = 0; j < SPACE1.size(); j++) {
      Vector S1 = (Vector)SPACE1.get( j);
      Vector P = S1;
      for( int k = 0; k < S2.size(); k++)
        P.add( (Integer)S2.get( k));
	   PROD.add( P);
      }//for-j  
    }//for-i
  return PROD;
}//

/**
* Espacio de permutaciones n!.
* @param BAS Vector orden de la base una lista30
* @return SPACE Vector de Vector espacio de bases
**/
private Vector space( Vector BAS) {
	
//  System.out.println( "space "+SPACE.toString());
  try {
    Vector iniBAS = BAS;  
    if ( iniBAS.size() == 2) {
//      return producto( SPACE, space2( iniBAS));// fin
      return space2( iniBAS);// fin
      }
      else 
    for( int i = 0; i < BAS.size(); i++) {
	   iniBAS = BAS;  
      Integer I = (Integer)iniBAS.remove( i);// base reducida

      Vector preBAS = new Vector();
      preBAS.add( I);
      Vector SPACE = producto( preBAS, space( iniBAS));

      for( int j = 0; j < SPACE.size(); j++) {
        ((Vector)SPACE.get( j)).add( I);
         SPACE.add( j, ((Vector)SPACE.get( j)));
        }
  System.out.println( "rec " + SPACE.toString());
	       return producto( SPACE, space( iniBAS));// Vector de Vector
        }
    } catch (Exception e) {
      System.out.println( ERROR + "space.");
      frame30.exit( 0, e);
    }//catch

  return null;	
}//space

/**
*
**/
private lista30 DirectBas( lista30 l30) {
	
  Vector SPACE = space( l30.Base.Bas());  //ordenes
  System.out.println( SPACE.toString());
//  System.exit( 0);

  for( int i = 0; i < SPACE.size(); i++) { // 

    iteraciones++;
    try {
      aux1 = kbsD( l30, (Vector)SPACE.get(i));//cambio
    } catch (Exception e) {
      System.out.println( ERROR + "DirectBas.");
      frame30.exit( 0);
    }//catch

      if ( aux1 != null) { // ---> cp - completa

        if ( new controlPrefs30().verboseSystem()) { 
          kbm2lSystem.append("+BASE: " + aux1.Base.Bas().toString() + "\n");
          kbm2lSystem.append( "D:   " + metrica30.H( l30.Base, aux1.Base) + "  ");
          kbm2lSystem.append( "G(D): " + metrica30.G( l30.Base, aux1.Base) + "\n");
          }

        if ( !metrica30.H( l30.Base, aux1.Base, 0)) {
          kbm2lSystem.append( ERROR + "DirectBas. " + metrica30.H( l30.Base, aux1.Base, 0)+"\n");
          frame30.exit( 0);
        }//if         

        if (( minkbm > aux1.optSize())) {
          l30 = kbs( l30, aux1, "D");
          if ( l30.size() == listStat30.DS( l30).size()) working = false;//OPT
          reset = true;//reset H2
          break; //for-j
          }//if opt
        }//if - cp - incompleta

      if ( !working) break;
    }//for-i
	
  return l30;	
}//DirectBas

/**
*
**/
private lista30 DirectxBas( lista30 l30) {
	
	
  return l30;	
}//DirectxBas

/**
* Optimizacion-sintesis mediante permutaciones generales.
* Optimiza la lista activa.
* Fija los objetivos. 
* Busqueda sistematica en el espacio de busqueda general n! de una base mejor.
**/
public lista30 Directa( lista30 l30) {

  working = true;
  try {
    kbm2lTime.append( "Synthesis direct.  C: " + 
      l30.Base.complex( ) + "  xC: " + l30.Base.xComplex( ) + "\n");
     kbm2lTime.append( "ImprovTestParam: " + new controlPrefs30( ).improvTestParam( ) + "\n");
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "Hamming2-3.\n");
    frame30.exit( 0, e);
  }//catch

//  sistematico t*(t-1)/2
  if ( l30.dimension() > 1)//  factorial( 1) ---> 1.
  try {

    if ( inikbs( l30) == null) return l30;

    l30 = DirectBas( l30);

    if ( new controlPrefs30().nBase()) {//extended base?

      String fCpy = "No";
      if ( new controlPrefs30().fastCopy( )) fCpy= "Yes";  
      new controlPrefs30().fastCopy( "No");

//      l30 = DirectxBas( l30);

      new controlPrefs30().fastCopy( fCpy);

      }//xBas

  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "Direct-4.\n");
    frame30.exit( 0, e);
  }//catch

//  listStat30.importanceAtt( l30);//

  if ( minkbm < minKBM) {
    if ( chk) {
      listStat30.calc( l30);
      new outputList30( ).escribeKBM2L( l30, dato30.workspace+File.separator+"Direct");
      kbm2lBrowser.listView( l30);//destino optimizado copiado
      }//if
    }//if
    else kbm2lSystem.append("Synthesis: there is no better base.\n");

  kbm2lSystem.append("Synthesis D: " + minKBM + "  ---> " + minkbm + ".\n"); 
  kbm2lSystem.append("pivots: " + pivotes + "  iterations: " + iteraciones+ ".\n"); 
  kbm2lSystem.append( "HG0 is true " + heuristics30.HG0TRUE + 
                      " and HG0 is false " + heuristics30.HG0FALSE + " times.\n");
  kbm2lSystem.append( "BasesList: " + l30.BasesList.size() + ". OK.\n");

  kbm2lSystem.estatus( "Synthesis D. OK.");
  working = false;
  return l30;//revisar!!!
}//Directa

/**
* 
**/
public void run() {

  if ( f30.activel30.dimension() > 1)
  if ( !working) {
  try {
    long ts0 = (new Date()).getTime();
    f30.activel30 = Directa( f30.activel30);
    f30.kbm2lTime.append("Sintesis Directa:: " + (new Date().getTime() - ts0) + ".\n");        
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run()");
    frame30.exit( 0);
  }//catch
  }

  return;
}//run

}//class sintesisDirecta30
