//sintesisHamming230//
package synthesis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kbm2l.*;
import tables.*;
import control.*;
import kernel.*;
import tools.*;

/**
* Clase sintesisHamming230, optimizacion de la lista kbm2l, mediante
* busqueda de entorno variable a distiancias H2 con bases extendidas.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class sintesisHamming230  extends sintesisHamming30 {

//
  private static final String ERROR = "Error(sintesisHamming230): ";

/**
* Constructor por defecto para la lista activa.
**/
public sintesisHamming230( ) {

  this.l30 = f30.activel30;
}//sintesisHamming230

/**
* Constructor por defecto para una lista especifica.
**/
public sintesisHamming230( lista30 l30) {

  this.l30 = l30;
}//sintesisHamming230

/**
* H2Bas
**/
private  lista30 Hamming2Bas( lista30 l30) {

  //not-xBase
  for( int i = attTop; i <= ( attBot - 1); i++) { // attBot = l30.dimension()
    for( int j = 1; j <= ( attBot - i); j++) {//  Hamming2

      if ( reset) {
        i = attTop; j = 1;//reset H2
        reset = false;
        pivotes++;
      }//if

      iteraciones++;
      aux1 = kbs2( l30, i, i+j, 0, 0, 0);//copia l30 en aux1 en nueva base
      if ( aux1 != null) { // ---> cp - completa - mejora

        kbm2lTime.append( "aux1.size(): " + (l30.size()-aux1.size()) + "  G(H2): " + metrica30.G( l30.Base, aux1.Base) + "\n");

        if ( !metrica30.H( l30.Base, aux1.Base, 2)) {
          kbm2lSystem.append( ERROR + "H2. " + metrica30.H( l30.Base, aux1.Base, 2)+"\n");
          frame30.exit( 0);
        }//if         

        if (( minkbm > aux1.optSize())) {
          l30 = kbs( l30, aux1, "H2");
          listStat30.calc( l30);
          //new outputList30( ).escribeKBM2L( l30, dato30.workspace+File.separator+l30.Name()+"-"+l30.size());
          if ( l30.size() == listStat30.DS( l30).size()) 
            return l30;//OPT
          }//if opt
        }//if - cp - incompleta

        if ( !working) return l30;
        
      }//for-j
      
      if ( !working) return l30;
    }//for-i

  return l30;
}//Hamming2Bas

/**
* H2xBas
**/
private  lista30 Hamming2xBas( lista30 l30) {

  //xBase
  System.gc( );
  for( int k = attTop; k <= attBot; k++) {

  for( int k_i = 0; k_i < (l30.Base.dom( k) - 1); k_i++) {
    for( int k_j = 1; k_j < (l30.Base.dom( k) - k_i); k_j++) {//  Hamming2

      if ( reset) {
	     k = attTop; k_i = 0; k_j = 1;//reset H2
	     reset = false;
        pivotes++;
      }//if

      iteraciones++;             //i+j
      aux1 = kbs2( l30, k, k+0, k, k_i, k_i + k_j);//copia l30 en aux1 en nueva base

      if ( aux1 != null) { // ---> cp - completa

        kbm2lTime.append( "aux1.size(): " + (l30.size()-aux1.size()) + "  G(H2): " + metrica30.G( l30.Base, aux1.Base) + "\n");

        if ( !metrica30.H( l30.Base, aux1.Base, 2)) {
          System.out.println( ERROR + "H2x. " + metrica30.H( l30.Base, aux1.Base, 2));
          frame30.exit( 0);
        }//if         

        if (( minkbm > aux1.optSize())) {
          l30 = kbs( l30, aux1, "H2x");
          listStat30.calc( l30);
          //new outputList30( ).escribeKBM2L( l30, dato30.workspace+File.separator+l30.Name()+"-"+l30.size());
          if ( l30.size() == listStat30.DS( l30).size()) 
            return l30;//OPT
          }//if opt
        }//if - cp - incompleta

        if ( !working) return l30;        
        }//for-k_j
      }//for-k_i
    }//for-k
      
   return l30;
}//Hamming2xBas

/**
* Optimizacion-sintesis mediante permutaciones binarias o de distancia 2.
* Optimiza la lista activa.
* Fija los objetivos. 
* Busqueda sistematica en el entorno H2 t*(t-1)/2 Xi ti*(ti-1)/2 de una base mejor.
* @see frame30#activel30
* @see sintesisHamming30#kbs2(lista30,int,int,int,int,int)
* @param l30 lista30
* @return l30, lista activa en la base mejorada
**/
public  lista30 Hamming2( lista30 l30 ) {

  Vector RANGO = null;

  try {
    kbm2lTime.append( "Synthesis Hamming2.  Complex: " + 
      l30.Base.complex( ) + "  xComplex: " + l30.Base.xComplex( ) + "\n");
    kbm2lTime.append( "ImprovTestParam: " + new controlPrefs30( ).improvTestParam( ) + "\n");  
   }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "Hamming2-1.\n");
    frame30.exit( 0);
  }//catch
  
//  sistematico t*(t-1)/2
  if ( l30.dimension() > 1)//  factorial( 1) ---> 1.
  try {

    if ( inikbs( l30) == null) return l30;//ini knowledge base synthesis

      String fCpy = "No";
      if ( new controlPrefs30().fastCopy( ))
        fCpy= "Yes";//store
      if ( listStat30.KB( l30).doubleValue() < 10000)  
        new controlPrefs30().fastCopy( "No");

    l30 = Hamming2Bas( l30);//permut( Bas)

    if ( new controlPrefs30().nBase()) {//extended base?
      l30 = Hamming2xBas( l30);//permut( DomBas)
      }//xBas

    l30 = Hamming2Bas( l30);//permut( Bas)

    new controlPrefs30().fastCopy( fCpy);//restore

  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "Hamming2-2.\n");
    frame30.exit( 0);
  }//catch

//  listStat30.importanceAtt( l30);//

  if ( minkbm < minKBM) {
    if ( chk) {
      listStat30.calc( l30);
      new outputList30( ).escribeKBM2L( l30, dato30.workspace+File.separator+"Hamming2");
      kbm2lBrowser.listView( l30);//destino optimizado copiado
      }//if
    }//if
    else kbm2lSystem.append("Synthesis: there is no better base.\n");

  kbm2lTime.append("Synthesis H2: " + minKBM + "  ---> " + minkbm + ".\n"); 
  kbm2lTime.append("pivots: " + pivotes + "  iterations: " + iteraciones+ ".\n"); 
  kbm2lTime.append( "HG0 is true " + heuristics30.HG0TRUE + 
                      " and HG0 is false " + heuristics30.HG0FALSE + " times.\n");
  kbm2lTime.append( "BasesList: " + l30.BasesList.size() + ". OK.\n");

  kbm2lSystem.estatus( "Synthesis H2. OK.");
    
  return l30;
}//Hamming2

/**
* run process: f30.activel30 = Hamming2( l30);
**/
public void run() {

  if ( l30.dimension() > 1)
  if ( !working) {
  try {
    working = true;
    long ts0 = (new Date()).getTime();
    this.l30 = f30.activel30;
    f30.activel30 = Hamming2( l30);
    f30.kbm2lTime.append("Synthesis Hamming2:: " + (new Date().getTime() - ts0) + ".\n");      
    working = false;
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "run().\n");
    frame30.exit( 0);
  }//catch
  }

  return;
}//run

}//class sintesisHamming230
