//sintesisHamming30//
package synthesis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kbm2l.*;
import tables.*;
import control.*;
import kernel.*;
import target.*;
import tools.*;

/**
* Clase sintesisHamming30. kbs2, kbsCd, kbs2Opt.
* Sintesis de bases de conocimiento
* Crierio de parada general: if (l30.lkbm.size() == ds) fin; 
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  sintesisHamming30  extends  sintesis30  {

  private static final String ERROR = "Error(sintesisHamming30): ";
  
/**
* Constructor por defecto.
**/
public sintesisHamming30( ) {

}//sintesisHamming30

/**
* knowledge base synthesis. 
* Cambia de base a distancia Hamming - 2 permutando i<->j o! vij<->vik.
* Crea una lista target adecuada al tipo de copia (std o fast) y lanza la copia.
* Previamente realiza un filtrado bTest, aTest, HG0 y el iTest.
* @see targetStd30#Target2(lista30,int,int). Target de copia estandar.
* @see lista30#cpl(lista30). Copia la lista objeto en el argumento que esta en otra base.
* @param l30 lista original.
* @param i posicion de atributo en la base.
* @param j posicion de atributo en la base.
* @return l30 lista con el kb original en la nueva base .
**/
protected lista30 kbs2( lista30 l30, int i, int j, int k, int k_i, int k_j) {

  lista30 lTarget = null;
  targets++;
  
  if ( chk) {
    kbm2lTime.append( 
      "H2 - swap(i,j):  i:" + String.valueOf( i) + "   j:" + String.valueOf( j) + "\n");  
    kbm2lTime.append( 
      "H2 - swap(k,k_i,k_j):  k:" + String.valueOf( k) 
      + "   k_i:" + String.valueOf( k_i) + "   k_j:" + String.valueOf( k_j) + "\n");  
     }
 
  try {

    if ( k_i == k_j)
    lTarget = targetStd30.Target2( l30, i, j);
    else lTarget = targetStd30.Target2( l30, i, j, k, k_i, k_j);
     
      } catch (Exception e) {
        kbm2lSystem.append( ERROR + "kbs2.0\n");
        frame30.exit( 0);
      }//catch

  try {
 
    if ( (lTarget = l30.bTest( lTarget)) == null) {
       kbm2lTime.append( "kbs2. l30.bTest. return null;//incompleta\n");
       return null;//incompleta
       } else { l30.BasesListHistory( lTarget, "Target2"); }

    if ( !heuristics30.HG0(l30, lTarget)) {
      kbm2lTime.append( "kbs2. !heuristics30.HG0. return null;//incompleta\n");
      return null;//!!!incompleta
      }
      
    if ( (lTarget = l30.aTest( lTarget)) == null) {
      kbm2lTime.append( "kbs2. l30.aTest. return null;//incompleta\n");
      return null;//incompleta
      }

    if ( (lTarget = l30.iTest( lTarget)) == null) {
      kbm2lTime.append( "kbs2. l30.iTest: " + l30.switches + " ### return null;//incompleta\n");
      return null;//incompleta
      }

      } catch (Exception e) {
        kbm2lSystem.append( ERROR + "kbs2.1\n");
        kbm2lSystem.append( lTarget.Base.toString() + "\n");
        frame30.exit( 0);
      }//catch

  if ( lTarget.Base.Bas().size() <= 24 ) {
    kbm2lSystem.append( "kbs2.cpl, lTarget. base: " + lTarget.Base.Bas() + 
      " - copies: " +(copias++)+ " - targets: " + targets + "\n");
    }

  return l30.cpl( lTarget);  // test -> cpl!!!
}//kbs2

/**
* knowledge base synthesis. 
* Cambia de base a distancia Hamming - Cd.
* @param l30 lista original
* @param i posicion de atributo en la base
* @param j posicion de atributo en la base
* @return lista con el kb original en la nueva base 
**/
protected lista30 kbsCd( lista30 l30, int i, int j) {
 
  lista30 lTarget = null;
  targets++;
  
  System.out.print(("HCd - swap(i:" + String.valueOf( i) + "   j:" + String.valueOf( j)) + ")");

  kbm2lSystem.estatus( 
    ("HCd - swap(i:" + String.valueOf( i) + "   j:" + String.valueOf( j)) + ")");

  try {

  if ( (lTarget = l30.bTest( targetStd30.TargetCd( l30, i, j))) == null) {
    return null;//incompleta
    } else { l30.BasesListHistory( lTarget, "TargetCd"); }
  
  if ( !heuristics30.HG0(l30, lTarget)) {
    return null;//!!!
    }
      
  if ( (lTarget = l30.aTest( lTarget)) == null) {
    return null;//incompleta
    }

  if ( (lTarget = l30.iTest( lTarget)) == null) 
    return null;//incompleta
    else { kbm2lSystem.Xestatus( "  OK.  target.size: " + lTarget.size() + 
                                 ".  target.sw:   " + lTarget.switches); }
      
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "kbsCd.");
    frame30.exit( 0);
  }//catch

  if ( lTarget.Base.Bas().size() <= 24 ) {
    kbm2lSystem.append( "kbsCd.cpl " +lTarget.Base.Bas()+ " - " +(copias++)+ " - " + targets+"\n");
    }
    else {
      kbm2lSystem.append( "kbsCd.cpl - " + (copias++) + " - " + targets+"\n");
      }

  kbm2lSystem.estatus(("HCd - swapped(i:" + String.valueOf( i) + "  j:" + String.valueOf( j)) + ")");

  System.out.println(("  HCd - swapped(i:" + String.valueOf( i) + "  j:" + String.valueOf( j)) + ")");

  return l30.cpl( lTarget);  
}//kbsCd

/**
* knowledge base synthesis. 
* Cambia de base a distancia Hamming - Ci.
* @param l30 lista original
* @param i posicion de atributo en la base
* @param j posicion de atributo en la base
* @return lista con el kb original en la nueva base 
**/
protected lista30 kbsCi( lista30 l30, int i, int j) {

  lista30 lTarget = null;
  targets++;
  
  System.out.print(("HCi - swap(i:" + String.valueOf( i) + "   j:" + String.valueOf( j)) + ")"); 

  kbm2lSystem.estatus(("HCi - swap(i:" + String.valueOf( i) + "   j:" + String.valueOf( j)) + ")");

  try {

    if ( (lTarget = l30.bTest( targetStd30.TargetCi( l30, i, j))) == null) {
      return null;//incompleta
      } else { l30.BasesListHistory( lTarget, "TargetCi"); }

    if ( !heuristics30.HG0(l30, lTarget)) {
      return null;//!!!
    }
      
    if ( (lTarget = l30.aTest( lTarget)) == null) {
      return null;//incompleta
      }

    if ( (lTarget = l30.iTest( lTarget)) == null) 
      return null;//incompleta
      else { kbm2lSystem.Xestatus( "  OK.  target.size: " + lTarget.size() + 
                                   ".  target.sw:   " + lTarget.switches); }
    
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "kbsCi.");
    frame30.exit( 0);
  }//catch

  if ( lTarget.Base.Bas().size() <= 24 ) {
    kbm2lSystem.estatus( "kbsCi.cpl " +lTarget.Base.Bas()+ " - " +(copias++)+ " - " + targets+"\n");
    }
    else {
      kbm2lSystem.estatus( "kbsCi.cpl - " + (copias++) + " - " + targets+"\n");
      }

  kbm2lSystem.estatus(("HCi - swapped(i:" + String.valueOf( i) + "  j:" + String.valueOf( j)) + ")");

  System.out.println(("  HCi - swapped(i:" + String.valueOf( i) + "  j:" + String.valueOf( j)) + ")");

  return l30.cpl( lTarget);  
}//kbsCi

/**
* knowledge base synthesis. 
* Cambia de base a distancia Hamming - j-i+1 permutando la sub-cadena i<->j.
**/
protected lista30 kbs2Opt( lista30 l30, int i, int j) {

  lista30 lTarget = null;
  targets++;

  try {

  if ( (lTarget = l30.bTest( targetStd30.Target2Opt( l30, i, j))) == null) {
    return null;//incompleta
    } else { l30.BasesListHistory( lTarget, "Target2Opt"); }

  if ( !heuristics30.HG0( l30, lTarget)) {
    return null;//!!!
    }

  if ( (lTarget = l30.aTest( lTarget)) == null) {
    return null;//incompleta
    }

  if ( (lTarget = l30.iTest( lTarget)) == null) 
    return null;//incompleta
    else { kbm2lSystem.Xestatus( "  OK.  target.size: " + lTarget.size() + 
                                 ".  target.sw:   " + lTarget.switches); }
        
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "kbs2Opt.");
    frame30.exit( 0);
  }//catch

  if ( lTarget.Base.Bas().size() <= 24 ) {
    kbm2lSystem.estatus( "kbsOpt.cpl " +lTarget.Base.Bas()+ " - " +(copias++)+ " - " + targets+"\n");
    }
    else {
      kbm2lSystem.estatus( "kbs2Opt.cpl - " + (copias++) + " - " + targets+"\n");
      }

  return l30.cpl( lTarget);  
}//kbs2Opt

}//class sintesisHamming30
