//sintesisHammingCd30//
package synthesis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kbm2l.*;
import tables.*;
import control.*;
import kernel.*;
import tools.*;

/**
* Clase sintesisHammingCd30. Sintesis basada en permutaciones circulares.
**/
public class sintesisHammingCd30 extends sintesisHamming30  {

/**
* 
**/
  private static final String ERROR = "Error(sintesisHammingCd30): ";
  private boolean better = false;

/**
* Constructor por defecto.
* Crierio de parada general: if (l30.lkbm.size() == ds) fin; 
**/
public sintesisHammingCd30( ) {

  this.l30 = f30.activel30;
  better = false;
  System.out.println( "sintesisHammingCd30a");
}//sintesisHammingCd30

/**
* Constructor por defecto.
* Crierio de parada general: if (l30.lkbm.size() == ds) fin; 
**/
public sintesisHammingCd30( lista30 l30) {

  this.l30 = l30;
  better = false;
  System.out.println( "sintesisHammingCd30b");
}//sintesisHammingCd30

/**
* Sintesis de Hamming Cd
**/
public  lista30 HammingCd( lista30 l30) {
//permutaciones circulares

  working = true;
  kbm2lSystem.setText("Sintesis HammingCd.\n");
    
//sistematico (t-2)(t-1)/2
  if ( l30.dimension() > 1)//  factorial( 1) ---> 1.
  try {
  if ( inikbs( l30) == null) return l30;;
  for( int i = attTop; i < attBot - 1; i++) {
    for( int j = i+1; j < attBot - 1 ; j++) {

      if (reset) {
        i = attTop; j = i+1;//reset HC
        reset= false;
        pivotes++;
      }//if

      iteraciones++;
      aux1 = kbsCd( l30, i, j);//copia l30 en aux1 en nueva base
      if ( aux1 != null) { // ---> cp - completa

        if ( new controlPrefs30().verboseSystem()) { 
          kbm2lSystem.append("+BASE: " + aux1.Base.toString() + "\n");
          kbm2lSystem.append( "HCd:   " + metrica30.H(l30.Base, aux1.Base) + "  ");
          kbm2lSystem.append( "G[H]: " + metrica30.G(l30.Base, aux1.Base) + "\n");
        }        
        
        if ( !metrica30.H( l30.Base, aux1.Base, l30.dimension()-i)) {
          System.out.println( ERROR + "HammingCd-2 " + l30.dimension() + ".");
          System.exit( 0);     
          }//if

        if (( minkbm > aux1.optSize())) {
          l30 = kbs( l30, aux1, "HCd"); 
          if ( l30.lkbm.size() == listStat30.DS( l30).size()) working = false;//OPT
          reset = true;//reset HC
          break;
          }//if opt
        }//if - cp - incompleta
        if (l30.size() == listStat30.DS( l30).size()) break;//opt-completa
        if ( !working) break;
      }//for
      if (l30.size() == listStat30.DS( l30).size()) break;//opt-completa
      if ( !working) break;
    }//for

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "HammingCd-3.");
    e.printStackTrace();
    System.exit( 0);
  }//catch

//  listStat30.importanceAtt( l30);//

  if ( minkbm < minKBM) {
    better = true;
    if ( chk) {
      listStat30.calc( l30);
      new outputList30( ).escribeKBM2L( l30, dato30.workspace + File.separator + "HammingCd");
      kbm2lBrowser.listView( l30);//destino optimizado copiado
      }//if
    }
    else {
      better = false;
      kbm2lSystem.append("sintesis: no hay base mejor.\n");
      }

  kbm2lSystem.append("sintesis HCd: " + minKBM + "  ---> " + minkbm + ". OK.\n");
  kbm2lSystem.append("pivots: " + pivotes + "  iterations: " + iteraciones+ ".\n"); 
  kbm2lSystem.append( "HG0 is true " + heuristics30.HG0TRUE + 
                      " and HG0 is false " + heuristics30.HG0FALSE + " times.\n");
  kbm2lSystem.append( "BasesList: " + l30.BasesList.size() + ". OK.\n");

  kbm2lSystem.estatus( "sintesis HCd. OK.");
  working = false;
  return l30;
}//HammingCd

/**
* run process: f30.activel30 = HammingCd( l30);
**/
public void run() {

  if ( l30.dimension() > 1)
  if ( !working) {
  try {
    long ts0 = (new Date()).getTime();
    new controlPrefs30( ).improvTestParam( 100);
    do {
      f30.activel30 = HammingCd( l30);
      this.l30 = f30.activel30;
    } while ( better);  
      f30.kbm2lTime.append("Sintesis HammingCd:: " + (new Date().getTime() - ts0) + ".\n");      
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
    System.exit( 0);
  }//catch
  }

  return;
}//run

}//class sintesisHammingCd30
