//sintesisHammingCi30//
package synthesis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kbm2l.*;
import tables.*;
import control.*;
import kernel.*;
import tools.*;

/**
* Clase sintesisHammingCi30. Sintesis basada en permutaciones circulares.
**/
public class sintesisHammingCi30 extends sintesisHamming30  {

/**
* 
**/
  private static final String ERROR = "Error(sintesisHammingCi30): ";
  private boolean better = false;

/**
* Constructor por defecto.
* Crierio de parada general: if (l30.lkbm.size() == ds) fin; 
**/
public sintesisHammingCi30( ) {

  this.l30 = f30.activel30;
  better = false;
  System.out.println( "sintesisHammingCi30a");
}//sintesisHammingCi30

/**
* Constructor por defecto.
* Crierio de parada general: if (l30.lkbm.size() == ds) fin; 
**/
public sintesisHammingCi30( lista30 l30) {

  this.l30 = l30;
  better = false;
  System.out.println( "sintesisHammingCi30b");
}//sintesisHammingCi30

/**
* Sintesis de Hamming Ci
**/
public  lista30  HammingCi( lista30 l30) {
//permutaciones circulares

  working = true;
  kbm2lSystem.setText("Sintesis HammingCi.\n");

//sistematico (t-2)(t-1)/2
  if ( l30.dimension() > 1)//  factorial( 1) ---> 1.
  try {
  if ( inikbs( l30) == null) return l30;;
  for( int i = attTop+1; i < attBot; i++) {
    for( int j = attTop+1; j < i ; j++) {

      if (reset) {
        i = attTop+1; j = attTop+1;//reset HC
        reset= false;
        pivotes++;
      }

      iteraciones++;
      aux1 = kbsCi( l30, i, j);//copia l30 en aux1 en nueva base
      if ( aux1 != null) { // ---> cp - completa
        if ( new controlPrefs30().verboseSystem()) { 
          kbm2lSystem.append("+BASE: " + aux1.Base.toString() + "\n");
          kbm2lSystem.append( "HCi :   " + metrica30.H(l30.Base, aux1.Base) + "  ");
          kbm2lSystem.append( "G[H]: " + metrica30.G(l30.Base, aux1.Base) + "\n");
        }        
        
        if ( !metrica30.H( l30.Base, aux1.Base, i+1)) {
          System.out.println( ERROR + "HammingCi-2. i:" + i);
          System.out.println( l30.Base.toString());
          System.out.println( aux1.Base.toString());
          System.exit( 0);     
          }//if

        if (( minkbm > aux1.optSize())) {
          l30 = kbs( l30, aux1, "HCi"); 
          if ( l30.lkbm.size() == listStat30.DS( l30).size()) working = false;//OPT
          reset = true;//reset HC
          break;
          }//if opt
        }//if - cp - incompleta
        if (l30.size() == listStat30.DS( l30).size()) break;//opt-completa
        if ( !working) break;
      }//for
      if (l30.size() == listStat30.DS( l30).size()) break;//opt-completa
      if ( !working) break;
    }//for

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "HammingCi-3.\n");
    e.printStackTrace();
    System.exit( 0);
  }//catch

//  listStat30.importanceAtt( l30);//

  if ( minkbm < minKBM) {
    better = true;
    if ( chk) {
      listStat30.calc( l30);
      new outputList30( ).escribeKBM2L( l30, dato30.workspace + File.separator + "HammingCi");
      kbm2lBrowser.listView( l30);//destino optimizado copiado
      }//if
    }
    else {
      better = false;
      kbm2lSystem.append("sintesis: no hay base mejor.\n");
      }

  kbm2lSystem.append("sintesis HCi: " + minKBM + "  ---> " + minkbm + ". OK.\n");
  kbm2lSystem.append("pivots: " + pivotes + "  iterations: " + iteraciones+ ".\n"); 
  kbm2lSystem.append( "HG0 is true " + heuristics30.HG0TRUE + 
                      " and HG0 is false " + heuristics30.HG0FALSE + " times.\n");
  kbm2lSystem.append( "BasesList: " + l30.BasesList.size() + ". OK.\n");

  kbm2lSystem.estatus( "sintesis HCi. OK.");
  working = false;
  return l30;
}//HammingCi

/**
* run process: f30.activel30 = HammingCi( l30);
**/
public void run() {

  if ( l30.dimension() > 1)
  if ( !working) {
  try {
    long ts0 = (new Date()).getTime();
    do {
      f30.activel30 = HammingCi( l30);
      l30 = f30.activel30;
    } while ( better);  
    f30.kbm2lTime.append("Sintesis HammingCi:: " + (new Date().getTime() - ts0) + ".\n");      
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
    System.exit( 0);
  }//catch
  }

  return;
}//run

}//class sintesisHammingCi30
