//sintesisHammingV30//
package synthesis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kbm2l.*;
import kernel.*;

/**
* 
**/
public class sintesisHammingV30  extends  sintesisHamming30  {

  private static final String ERROR = "Error(sintesisHammingV30): ";
  private static lista30 l30 = null;

/**
* Constructor por defecto
**/
public sintesisHammingV30( ) {

  this.l30 = f30.activel30;
}//sintesisHammingV30

/**
* Constructor para optimizar una lista especifica.
**/
public sintesisHammingV30( lista30 l30) {

  this.l30 = l30;
}//sintesisHammingV30

/**
* Combinado para protocolo dinamico: HR+HCd+H2+HCi+H2+HR+HCi+H2+HCd+H2.
**/
public lista30 HammingV( lista30 l30) {


  working = true;

  if ( l30.dimension() > 1) {
    for (int v = 0; (v < 3) && working; v++) {

    kbm2lSystem.estatus( "HV >>> HR.");    
    l30 = new sintesisHammingR30( l30).HammingR( l30, l30.dimension() * 2);
    if (!working) return l30;
    kbm2lSystem.estatus( "HV >>> HCd.");
    l30 = new sintesisHammingCd30( l30).HammingCd( l30);
    if (!working) return l30;
    kbm2lSystem.estatus( "HV >>> H2.");
    l30 = new sintesisHamming230( l30).Hamming2( l30);
    if (!working) return l30;
    kbm2lSystem.estatus( "HV >>> HCi.");
    l30 = new sintesisHammingCi30( l30).HammingCi( l30);
    if (!working) return l30;
    kbm2lSystem.estatus( "HV >>> H2.");
    l30 = new sintesisHamming230( l30).Hamming2( l30);
    if (!working) return l30;

    kbm2lSystem.estatus( "HV >>> HR.");
    l30 = new sintesisHammingR30( l30).HammingR( l30, l30.dimension() * 2);
    if (!working) return l30;
    kbm2lSystem.estatus( "HV >>> HCi.");
    l30 = new sintesisHammingCi30( l30).HammingCi( l30);
    if (!working) return l30;
    kbm2lSystem.estatus( "HV >>> H2.");
    l30 = new sintesisHamming230( l30).Hamming2( l30);
    if (!working) return l30;
    kbm2lSystem.estatus( "HV >>> HCd.");
    l30 = new sintesisHammingCd30( l30).HammingCd( l30);
    if (!working) return l30;
    kbm2lSystem.estatus( "HV >>> H2.");
    l30 = new sintesisHamming230( l30).Hamming2( l30);
    if (!working) return l30;
    }//for v
  }//if

  working = false;
  return l30;
}//Hamming

/**
* run process: f30.activel30 = HammingV( l30);
**/
public void run() {

  if ( l30.dimension() > 1)
  if ( !working) {
  try {
    long ts0 = (new Date()).getTime();
    f30.activel30 = HammingV( l30);
    f30.kbm2lTime.append("Sintesis HammingV:: " + (new Date().getTime() - ts0) + ".\n");        
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
    System.exit( 0);
  }//catch
  }

  return;
}//run

}//class sintesisHammingV30
