//cabecera30//
package tables;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kbm2l.*;
import kernel.*;
import schema.*;

/**
* Clase cabecera30
* Acceso de lectura y escritura fisica de las cabeceras de tablas/listas  .hkb
* Texto plano.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  cabecera30  extends  frame30 {

  private static final String ERROR = "Error(cabecera30): ";

  protected String nombre = null;//del fichero de datos

  public  Vector R = null;//Mascara de fila - medida.
  public Vector S = null;//Mascara de fila - respuesta.
  public Vector T = null;//Mascara de fila - indice.

/**
* Constructor por defecto.
**/
public cabecera30( ) {

  nombre = null;

  R=null;
  S=null;
  T=null;
}//cabecera30

/**
* Si frame30.eq30 es null
* lee un esquema eq de disco y 
* escribe la correspondiente cabecera hkb
**/
public static void EqHkbList() {
//
  String pathKBM2L = null;
  String filename = null;
  kbm2lSystem.estatus( "Reading Schema....");

  if ( activel30.Esqu.numDecisiones == 0) {
    kbm2lSystem.estatus("Select Schema: *.eq  - .");
    filename = dato30.selectFile( f30.kbm2lSystem.frame, FileDialog.LOAD, "*.eq");
    if ( filename == null) {
      kbm2lSystem.estatus("No schema selection.");
      return ;
      } 
     
    pathKBM2L = new String( filename);

    if (( pathKBM2L.equals( "")) || ( pathKBM2L == null)) {
      kbm2lSystem.append("Schema not readed.\n");
      return ;
      }//if

    pathKBM2L = dato30.extFile( dato30.nameFile( pathKBM2L), "eq");
    }//if ( eq30 == null)

  try {

  esquema30 eq30 = new esquema30( (lista30)null).leerEq( pathKBM2L);
  
  new outputEsquemaCabecera30().escribeCabecera( eq30, 
      dato30.workspace + dato30.extFile( dato30.nameFile( pathKBM2L), "hkb"), "kbm"); 

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "EqHkbList.  pathKBM2L: " + pathKBM2L);
    e.printStackTrace();
    frame30.exit( -1);
  }//catch

  return ;
}//EqHkbList

/**
* Lee una cabecera de disco y 
* escribe el correspondiente esquema
**/
public static void HkbEqList() {
//
  String pathKBM2L = null;
  String filename = null;
  kbm2lSystem.estatus( "Reading Header....");

  kbm2lSystem.estatus("Select Header: *.hkb  - .");
  filename = dato30.selectFile( f30.kbm2lSystem.frame, FileDialog.LOAD, "*.hkb");
  if ( filename == null) {
    kbm2lSystem.estatus("No header selection.");
    return ;
    }//if 
     
  pathKBM2L = new String( filename);

  if (( pathKBM2L.equals( "")) || ( pathKBM2L == null)) {
    kbm2lSystem.append("Header not readed.\n");
    return ;
    }//if

  pathKBM2L = dato30.nameFile( pathKBM2L);
  pathKBM2L = dato30.extFile( pathKBM2L, "hkb");

  new outputCabeceraEsquema30().escribeEsquema( 
    f30.activel30, //new inputCabecera30().leerCabecera( pathKBM2L), 
    dato30.workspace + dato30.extFile( dato30.nameFile( pathKBM2L), "eq"), ""); 

  return ;
}//HkbEqList

}//class cabecera30