//dato30//
package tables;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kbm2l.*;
import control.*;

/**
* Clase dato30.
*
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class dato30  {

  private static final String ERROR = "Error(dato30): ";

/**
* Directorio de trabajo, escritura.
**/
  public static String workspace = ".";
/**
* directorio de datos, tablas, lectura.
**/
  public static String dataspace = ".";

  public static final String flag_F =  "File:";//file
  public static final String flag_H =  "Head:";//head
  public static final String flag_R =  "R:";//medida
  public static final String flag_S =  "S:";//respuesta/decision
  public static final String flag_T =  "T:";//indice
  public static final String flag_D =  "Dom:";//dominio
  public static final String flag_B =  "Bas:";//base
  public static final String flag_L =  "Rol:";//role

  public static final String flag_A =  "Att:";//Atributo
  public static final String flag_V =  "Val:";//Valor

/**
* Constructor por defecto.
**/
public dato30( ) {

  workspace = ".";  
  dataspace = ".";
}//dato30

/**
* Comprueba si la linea contine un flag. flag es "string:"
**/
public static boolean flag_check( String linea, String flag) {
  
  linea = linea.trim();
  
  if ( linea.indexOf( ':') < 1) {
    frame30.kbm2lSystem.append( ERROR + "flag_check: :\n");
    frame30.kbm2lSystem.append( "File: " + openedFile + "\n");
    frame30.kbm2lSystem.append( "Line: " + linea + "\n");
    frame30.kbm2lSystem.append( "Flag: " + flag + "\n");    
    try { linea.substring( -1, -2); }//try
    catch (Exception e) { System.out.println( ERROR); frame30.exit( 0, e); }
    }//if

  if ( linea.indexOf( flag) != 0) {//    
      return false;  
    }//if

  return true;
}//flag_check

/**
* 
**/
public static double param( String linea) {

  int x = 0;
  double p = 0;

  linea.replace( '\t', ' ');
  linea = linea.trim();  
  if ((linea.indexOf(' ') == -1) && (linea.indexOf(';') == -1)) { 
    frame30.kbm2lSystem.append( ERROR + "param.\n");
    frame30.kbm2lSystem.append( "File: " + openedFile + "\n");
    frame30.kbm2lSystem.append( linea + ".\n");
    frame30.exit( 0, new Exception());
    }

  while ( numberchar( linea, x)) x++;
  if ( x > 0) { p = Double.parseDouble( linea.substring( 0, x)); } 
    else { 
      frame30.kbm2lSystem.append( ERROR + "param double.\n");
      frame30.kbm2lSystem.append( linea + ".\n");
      frame30.kbm2lSystem.append( "x:" + x + "\n");
      frame30.exit( 0, new Exception());
      }

  return p;
}//param

/**
* 
**/
public static String nextLine( BufferedReader in, String linea) {

  try {
	  
    linea = in.readLine();
    if ( linea != null) {
      linea = linea.trim();
      linea = linea.replace( '\t', ' ');
     }// else - end of file
 }//try
  catch (Exception e) {
    System.out.println( ERROR + "nextLine. " + "Line:" + linea);
    System.exit( 0);
  }//catch  
  
  return linea; 
}//nextLine

/**
* 
**/
public static String nextParam( String linea, char tk) {

  //linea = linea.replace( '\t', ' ');

  int hl = linea.indexOf( tk) + 1;
  int bl = linea.length();

  if (hl == 0) {
    frame30.kbm2lSystem.append( ERROR + "nextParam. hl: " + hl + " tk: " + tk + "\n");
    frame30.kbm2lSystem.append( "File: " + openedFile + "\n");
    frame30.kbm2lSystem.append( linea + "\n");
    frame30.exit( 0, new Exception()); 
    }
  if (bl <= hl) {
    frame30.kbm2lSystem.append( ERROR + "nextParam. hl: " + hl + ", bl: " + bl + " tk: " + tk + "\n");
    frame30.kbm2lSystem.append( "File: " + openedFile + "\n");
    frame30.kbm2lSystem.append( linea + "\n");
    frame30.exit( 0, new Exception()); 
    }

  return (linea.substring( hl , bl)).trim(); 
}//nextParam

/**
* Vector de enteros a String
* @param v Vector de Integer
* @return s String
**/
public static String toString( Vector v, String prefix, String Separator) {

  String s = new String( "");
  
  if ( v == null) return new String( s);
  if ( v.size() == 0) return new String( s);
  
  for( int i = 0; i < v.size() - 1; i++)
    if (((Integer)v.get( i)).intValue() != -1)
      s = new String( s + prefix + ((Integer)v.get( i)).toString() + Separator );

  if (((Integer)v.get( v.size() - 1)).intValue() != -1)
    return new String( s + prefix + ((Integer)v.get( v.size() - 1)).toString());
    else return new String( s);
    
}//toString

////
  private static String fileKBM2L = "";
  private static FileDialog fd30 = null;

/**
* fija el workspace y el fichero de datos, full-path
**/
public static String selectFile( Frame fr, int modo, String ext) {

  fd30 = new FileDialog( fr, "Fichero.... *." + ext);

  if ( fd30 == null) {
    System.err.println("<FileDialog>??");
    frame30.exit( 0);
    }

  fd30.setMode( modo);
  fd30.setDirectory( workspace);
  fd30.setFile( ext);
  fd30.setVisible(true);
  fd30.toFront();  

  fileKBM2L = fd30.getFile();
  if ( fileKBM2L == null) {
    System.err.println("<filepath>?? pathKBM2L");
    return null;
    }

  String directory = fd30.getDirectory();
  if ( directory == null) return null;
    else workspace = new String( directory);

  File f = new File( directory, fileKBM2L);
  if (( modo == FileDialog.LOAD)&&( !f.exists())) {
    System.err.println("FileDialog.LOAD  <filepath>?exists");
    return null;
    }

  fileKBM2L = directory + fileKBM2L;

  return fileKBM2L;
}//selectFile

/**
* Path del fichero, elimina el nombre
**/
public static String pathFile( String fileKBM2L) {

  String filename = new String( fileKBM2L);
  for( int i = filename.indexOf( File.separatorChar); 
           i >= 0 ; 
           i = filename.indexOf( File.separatorChar)) 
     filename = new String( filename.substring( i+1, filename.length()));

  return fileKBM2L.substring( 0, fileKBM2L.indexOf( filename));
}//pathFile

/**
* Nombre del fichero, elimina el path.
**/
public static String nameFile( String fileKBM2L) {

  String filename = new String( fileKBM2L);
  for( int i = filename.indexOf( File.separatorChar); 
           i >= 0 ; 
           i = filename.indexOf( File.separatorChar)) {
     filename = new String( filename.substring( i+1, filename.length()));
     }

  return filename;
}//nameFile

/**
* Cambia la extension de un nombre de fichero.
* @param file nombre inicial
* @param extNew extension nueva
* @return filename nombre nuevo
**/
public static String extFile( String file, String extNew ) {

  int i = 0;
  String filename = new String( file);
  String ext = new String( extNew);

  try {//
    if ( extNew == "")
      if ( filename.indexOf('.') != -1)
        return filename.substring( 0, filename.indexOf('.'));
        else return filename;

  for( i = filename.length()-1; 
      ( filename.charAt( i) != File.separatorChar) && ( filename.charAt( i) != '.') && ( i != 0); 
       i--) { }
  }//try
  catch (Exception e) {
    frame30.kbm2lSystem.append( ERROR + "extFile.\n");
    frame30.kbm2lSystem.append( ERROR + "file: " + file + "\n");
    frame30.kbm2lSystem.append( ERROR + "filename: " + filename + "\n");
    frame30.exit( 0, e);
  }//catch

  if (( filename.charAt( i) == File.separatorChar)||( i == 0)) {
    filename = new String( filename + "." + ext);
    }

  if ( filename.charAt( i) == '.') {
    filename = new String( filename.substring( 0, i+1) + ext);
    }

  return filename;
}//extFile

private static String openedFile = null;
/**
* Abre un fichero file en el workspace con la extension ext.
* Almacena el fichero para informar en caso de error.
* @param file nombre 
* @param ext extension 
* @return el BufferedReader 
**/
public static BufferedReader openFile( String file, String ext ) {

  try {//
    if ( file.indexOf(":")==-1)
      openedFile = workspace + extFile( file, ext);
      else openedFile = extFile( file, ext);
    if ( !new File(openedFile).exists()) {
      frame30.kbm2lSystem.append( "openFile.  file:" + openedFile + "  it is not exist.\n");
	    return null; 
	   }
    FileReader f = new FileReader( openedFile);
    return new BufferedReader( f);
  }//try
  catch (Exception e) {
    frame30.kbm2lSystem.append( ERROR + "openFile.\n");
    frame30.kbm2lSystem.append( dato30.workspace + file + ".   (" + ext + ")\n");
    frame30.kbm2lSystem.append( openedFile + "\n");
    if ( new controlPrefs30().checkMode()) {
      e.printStackTrace();
      String[] d = new File( dato30.workspace).list();
      for (int f= 0; f < Arrays.asList( d).size(); f++)
        frame30.kbm2lSystem.append( d[f] + "\n");
      }//if  
  }//catch
  return null;
}//openFile

////private

/**
* Es una cadena numerica ?
**/
private static boolean numberchar( String linea, int x) {

  if (( x < 0) || ( x >= linea.length())) {
    frame30.kbm2lSystem.append( ERROR + "Error numberchar.\n");
    frame30.kbm2lSystem.append( "File: " + openedFile + "\n");
    frame30.kbm2lSystem.append( linea + "\n");
    frame30.exit( 0);
    }
  return ((linea.charAt( x) >= '0') && (linea.charAt( x) <= '9') || 
          (linea.charAt( x) == '-') || (linea.charAt( x) == '+') ||
          (linea.charAt( x) == '.') || (linea.charAt( x) == ','));
}//numberchar

/**
* log Factorial numerico
**/
public static double logFactorial( long n) {

	double f = Math.log((double)n);
	for( long i = n; i > 1; i--)
	  f = f+Math.log((--n));

	return f;
}//factorial

}//class dato30

