//inputCabecera30//
package tables;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import control.*;
import kernel.*;
import kbm2l.*;
import target.*;

/**
* Clase inputCabecera30
* Acceso de lectura y escritura fisica de las cabeceras de tablas/listas  .hkb
* Texto plano.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  inputCabecera30  extends  cabecera30 {

  private static final String ERROR = "Error(inputCabecera30): ";

//params
  private int r=0, s=0, t=0;//medidas,respuestas,indices.

//componentes
  private Vector D = null;//Dominios de atributos - indice
  private base30 B = null;//Base o Permutacion - indice

/**
* Constructor por defecto.
**/
public inputCabecera30( ) {

}//inputCabecera30

/**
* Lee la cabecera guia de vistas diferentes de tablas completas (con/sin indice), 
* tablas incompletas (casos con indice) y listas kbm2l (items con indice).
* Casos con indice y sin indice h.txt, Item-list kbm2l h.kbm 
* estructura de la cabecera de la lista que guuia el accesso del fichero.
* //F: fichero;
* //H: control rst;
* //RST: mascara de acceso fisico
* //DB: dominio + base.
* @param pathKBM ruta y nombre del fichero de la cabecera de la lista/tabla, 
* si es vacia se muestra el dialogo para abrir un fichero.
* @return lista30: si tiene exito la lectura del la lista/tabla.
**/
public lista30 leerCabecera( String pathKBM) {
////lee el fichero nombre.hkb con la cabeza del fichero
//nombre del fichero de informacion, tabla txt con observaciones, lista kbm con grupos contiguos 
//F: nombre.[txt,kbm]!!! --- extensiones
//H linea con indice(t), respuesta(s>=1) y medida(r)
//H: r=0 s=1 t=2;//t>=1, s>=1.
//mascara de fila indices del vector indice, respuesta y del vector medida, vistas de la tabla.
//R:;// nada sin medida
//S:3;//escalar
//T:0 1 2;// nada == indice implicito
//Dominio de las componentes del vector indice
//D:2 2 2;
//Base de permutaciones del indice, para generar el orden total de almacenamiento y acceso.
//B:0 1 2;
//0 0 0 1;//CERO 
//0 0 1 1;
//0 1 0 2;
//0 1 1 1;
//1 0 0 1; 
//1 0 1 1;
//1 1 0 2;
//1 1 1 1;//ULTIMO

  kbm2lTime.append("List header access: " + pathKBM + ".\n");

  String linea = null; // linea del fichero que contiene una tabla
  BufferedReader in = null; // fichero que contiene una tabla

  try {//

//Header
  in = dato30.openFile( dato30.nameFile( pathKBM), "hkb");
  if (in == null) {
    kbm2lTime.append("List header not readed: " + pathKBM + ".\n");
    return null;//la lista no se puede configurar, la cabecera no existe.
   }

  if ( !leerCabeceraFile( in)) {
      System.out.println( ERROR + "Fichero: " + pathKBM);
      in.close(); 
      frame30.exit(0);
      }

  if ( !leerCabeceraHead( in)) {
      System.out.println( ERROR + "Fichero: " + pathKBM);
      in.close(); 
      frame30.exit(0);
      }

  if ( !leerCabeceraBase( in)) {
      System.out.println( ERROR + "Fichero: " + pathKBM);
      in.close(); 
      frame30.exit(0);
      }

  if ( new controlPrefs30().checkMode()) {
    kbm2lSystem.append("TABLA/LIST HEADER: " + "r=" + r + "  s=" + s + "  t=" + t + "\n");
    kbm2lSystem.append("MASK:   R" + R.toString()+ "\n");
    kbm2lSystem.append("MASK:   S" + S.toString() + "\n");
    kbm2lSystem.append("MASK:   T" + T.toString() + "\n");
    kbm2lSystem.append("DOMAIN: D" + B.Dom().toString() + "\n");
    kbm2lSystem.append("BASE:   B" + B.Bas().toString() + "\n");
    kbm2lSystem.append("ROLE:   L" + B.Rol().toString() + "\n");
    }
    
  in.close(); 
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "leerCabecera. " + pathKBM +".\n");
    frame30.exit(0);
  }//catch

  kbm2lTime.append("List header readed: " + pathKBM + ".\n");

  return new lista30( nombre, r, s, B);//!!!!
}//leerCabecera

/**
*
**/
private boolean leerCabeceraFile( BufferedReader in) {

  String linea = null; // linea del fichero que contiene una tabla

  try {

  if ((linea = in.readLine()) != null) {
    while ( linea.charAt( 0) == ';') linea = in.readLine();
    linea=linea.trim();
//File: nombre.[txt,kbm]
//flag File
    if (!( dato30.flag_check( linea, dato30.flag_F))) {
      System.out.println( ERROR + "flag_check: " + dato30.flag_F + ".\n");
      System.out.println( "Linea: " + linea);
      return false; 
      }
  
    linea = linea.substring( linea.indexOf(':')+1, linea.length());  
    linea=linea.trim();
    if (linea.indexOf(';') != -1) {
      linea = linea.substring( 0, linea.indexOf(';')-1);  
      linea=linea.trim();
     }
 
    nombre = new String( linea);
    }//if
    else {
      System.out.println( ERROR + "leerCabeceraFile.flag " + dato30.flag_F + ".\n");
      return false; 
      }

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "leerCabeceraFile. " + linea + ".\n");
    frame30.exit(0);
  }//catch

  kbm2lTime.append( "OK " + dato30.flag_F + nombre + ".\n");
  return true ; 

}//leerCabeceraFile

private boolean leerCabeceraHead( BufferedReader in) {

  String linea = null; // linea del fichero que contiene una tabla

  try {

  if ((linea = in.readLine()) != null) {
    while ( linea.charAt( 0) == ';') linea = in.readLine();
    linea=linea.trim();
//Head: r s t;
//flag Head
    if (!( dato30.flag_check( linea, dato30.flag_H))) {
      System.out.println( ERROR + "flag_check: " + dato30.flag_H + ".\n");
      return false; 
      }
    linea = linea.substring( linea.indexOf(':')+1, linea.length());  linea=linea.trim();
    r = (int)( dato30.param( linea));
    linea = new String( dato30.nextParam( linea, ' '));
    s = (int)( dato30.param( linea));
    linea = new String( dato30.nextParam( linea, ' '));
    t = (int)( dato30.param( linea));
    }//if 
    else {
      System.out.println( ERROR + "leerCabeceraHead.flag " + dato30.flag_H + ".\n");
      return false; 
      }
    kbm2lTime.append( " OK " + dato30.flag_H + "r(" + r + ")s(" + s + ")t(" + t+"),");

//mascara de fila
  R = new Vector();
if ((linea = in.readLine()) != null) {
  while ( linea.charAt( 0) == ';') linea = in.readLine();
  linea=linea.trim();
//R:r0 r1.....rr-1;
//flag R
  if (!( dato30.flag_check( linea, dato30.flag_R))) {
    System.out.println( ERROR + "flag_check: " + dato30.flag_R + ".\n");
    return false; 
    }
  linea = linea.substring( linea.indexOf(':')+1, linea.length());
  linea=linea.trim();
  if (linea.indexOf(';') != 0) {
  for(int i = 0; i < r-1; i++) {
    R.add( new Integer((int)( dato30.param( linea))));
    linea = new String( dato30.nextParam( linea, ' '));
    }//for
    R.add( new Integer((int)( dato30.param( linea))));
    }// else r==0
  }//if
  else {
    System.out.println( ERROR + "leerCabecera.flag " + dato30.flag_R + ".\n");
    return false; 
    }
  kbm2lTime.append( " OK " + dato30.flag_R + ",");

  S = new Vector();
if ((linea = in.readLine()) != null) {
  while ( linea.charAt( 0) == ';') linea = in.readLine();
  linea=linea.trim();
//S:s0 s1.....ss-1;
//flag S
  if (!( dato30.flag_check( linea, dato30.flag_S))) {
    System.out.println( ERROR + "Error flag_check: " + dato30.flag_S + ".\n");
    return false; 
    }
  linea = linea.substring( linea.indexOf(':')+1, linea.length());
  linea=linea.trim();
  for(int i = 0; i < s-1; i++) {
    S.add( new Integer((int)( dato30.param(linea))));
    linea = new String( dato30.nextParam( linea, ' '));
    }//for
    S.add( new Integer((int)( dato30.param(linea))));
  }//if
  else {
    System.out.println( ERROR + "leerCabecera.flag " + dato30.flag_S + ".\n");
    return false; 
    }
  kbm2lTime.append( " OK " + dato30.flag_S + ",");

  T = new Vector();
if ((linea = in.readLine()) != null) {
  while ( linea.charAt( 0) == ';') linea = in.readLine();
  linea=linea.trim();
//T:t0 t1.....tt-1;
//flag T
  if (!( dato30.flag_check( linea, dato30.flag_T))) {
    System.out.println( ERROR + "flag_check: " + dato30.flag_T + ".\n");
    return false; 
    }
  linea = linea.substring( linea.indexOf(':')+1, linea.length());
  linea=linea.trim();
  if (linea.indexOf(';') != 0) {
    for(int i = 0; i < t-1; i++) {
      T.add( new Integer((int)( dato30.param( linea))));
      linea = new String( dato30.nextParam( linea, ' '));
      }//for
      T.add( new Integer((int)( dato30.param(linea))));
    }//if
  }//if
  else {
    System.out.println( ERROR + "leerCabecera.flag " + dato30.flag_T + ".\n");
    return false; 
    }
  kbm2lTime.append( " OK " + dato30.flag_T + ",\n");

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "leerCabeceraHead. " + linea + ".\n");
    frame30.exit(0);
  }//catch

  return true; 
}//leerCabeceraHead

/**
* DOM BAS ATT ROL
**/
private boolean leerCabeceraBase( BufferedReader in) {

  String linea = null; // linea del fichero que contiene una tabla

  try {

  B = new base30( t,0,null,null,null);//(null,null,null)
  
if ((linea = in.readLine()) != null) {
  while ( linea.charAt( 0) == ';') linea = in.readLine();
  linea=linea.trim();
//Dom:d0 d1.....dt-1;
//flag Dom
  if (!( dato30.flag_check( linea, dato30.flag_D))) {
    System.out.println( ERROR + "Error flag_check: " + dato30.flag_D + ".\n");
    return false; 
    }
  linea = linea.substring( linea.indexOf(':')+1, linea.length());
  linea=linea.trim();
  int d=0;
  for(int i = 0; i < t-1; i++) {
    B.dom( i, (int)( dato30.param( linea)));
    linea = new String( dato30.nextParam( linea, ' '));
  }//for
    B.dom( t-1, (int)( dato30.param( linea)));
  }//if
  else {
    System.out.println( ERROR + "leerCabecera.flag " + dato30.flag_D + ".\n");
    return false; 
    }
  kbm2lTime.append( " OK " + dato30.flag_D + B.Dom()+ ",\n");

if ((linea = in.readLine()) != null) {
  while ( linea.charAt( 0) == ';') linea = in.readLine();
  linea=linea.trim();
//Bas:b0 b1.....bt-1;
//flag Bas
  if (!( dato30.flag_check( linea, dato30.flag_B))) {
    System.out.println( ERROR + "flag_check: " + dato30.flag_B + ".\n");
    return false; 
    }
  linea = linea.substring( linea.indexOf(':')+1, linea.length());
  linea=linea.trim();
  int b = 0;
  for(int i = 0; i < t-1; i++) {
    B.bas( i, (int)( dato30.param( linea)));
    linea = new String( dato30.nextParam( linea, ' '));
  }//for
    B.bas( t-1, (int)( dato30.param( linea)));
  }//if
  else {
    System.out.println( ERROR + "leerCabecera.flag " + dato30.flag_B + ".\n");
    return false; 
    }
  kbm2lTime.append( " OK " + dato30.flag_B + B.Bas() + "\n");

//base ext
  for( int i = 0; i < t; i++) {
	 Vector V = new Vector(); 
    for(int j = 0; j < B.dom( i); j++) {
      V.add( new Integer( (int)j));//canonica
      }//for-j
      B.att( i, V);
    }//for-i

if ((linea = in.readLine()) != null) {
  while ( linea.charAt( 0) == ';') linea = in.readLine();
  linea=linea.trim();
//Rol:b0 b1.....bt-1;
//flag Rol
  if (!( dato30.flag_check( linea, dato30.flag_L))) {
    System.out.println( ERROR + "flag_check: " + dato30.flag_L + ".\n");
    System.out.println( linea);
    return false; 
    }
  linea = linea.substring( linea.indexOf(':')+1, linea.length());
  linea=linea.trim();
  int b = 0;
  for(int i = 0; i < t-1; i++) {
    B.rol( i, (int)( dato30.param( linea)));
    linea = new String( dato30.nextParam( linea, ' '));
  }//for
    B.rol( t-1, (int)( dato30.param( linea)));
  }//if
  else {
    System.out.println( ERROR + "leerCabecera.flag " + dato30.flag_L + ".\n");
    return false; 
    }
  kbm2lTime.append( " OK " + dato30.flag_L + "\n");

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "leerCabeceraBase. " + linea +".\n");
    frame30.exit(0);
  }//catch

  return true; 
}//leerCabeceraBase

}//class inputCabecera30