//INPUTTABLE30//
package tables;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import control.*;
import kbm2l.*;
import kernel.*;
import schema.*;

/**
* Clase inputTable30.
* Acceso de lectura fisica de las tablas/listas. Texto plano.
* Construye los items y los aade a la lista.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class inputTable30  extends  tabla30  {

  private static final String ERROR = "Error(inputTable30): ";

/**
* Constructor por defecto.
**/
public inputTable30( ) {

  fileTable = "";
}//inputTable30

/**
* Constructor por defecto.
* @param tableName nombre del fichero de la tabla.
**/
public inputTable30( String tableName) {

  fileTable = tableName;
}//inputTable30

/**
* Antes de la lectura de la tabla.
* @param pathKBM nombre de la tabla, si es "" lanza FileDialog.LOAD, "*.hkb"
**/
protected String leerTablaPrev( String pathKBM) {

  kbm2lSystem.append("\nBegining of inputTable.\n");

  if ( pathKBM.equals( "")) {
    kbm2lSystem.estatus("Header selection: *.hkb.");
    String filename = dato30.selectFile( f30.kbm2lSystem.frame, FileDialog.LOAD, "*.hkb");
    if ( filename == null) {
      kbm2lSystem.append("Table not readed.\n");
      return null;
      }//if
    pathKBM = new String( filename);
    kbm2lSystem.append("Header selected: " + pathKBM + "\n");
    }//if 

  if (( pathKBM.equals( "")) || ( pathKBM == null)) {
    kbm2lSystem.append("Table not readed.\n");
    return null;
    }//if

  return pathKBM;
}//leerTablaPrev

/**
* Lee vistas diferentes de tablas completas (con/sin indice), 
* tablas incompletas (casos con indice) y listas kbm2l (items con indice).
* Casos con indice y sin indice h.txt, Item-list kbm2l h.kbm 
* estructura de la cabecera de la lista que guia el accesso del fichero.
* ; comentarios
* //File: file.kbm;
* //H: control rst;
* //RST: mascara de acceso fisico
* //DBR: dominio + base + rol.
* @param eq30 esquema de la lista.
* @param pathKBM ruta y nombre del fichero de las lista/tabla, si es vacia se 
* muestra el dialogo para abrir un fichero.
* @return lista30 si tiene exito la lectura del la lista/tabla.
**/
public lista30 leerTabla( esquema30 eq30, String pathKBM) {

  long entradas = 0, t_old = 0, t_new = 0, hit = 0;

  BufferedReader in = null;
  String linea = null; // linea del fichero que contiene una tabla
  
  if (( pathKBM = leerTablaPrev( pathKBM)) == null) { 
	 return null; 
	 }

  inputCabecera30 ic30 = new inputCabecera30( );
  lista30 l30 = ic30.leerCabecera( pathKBM);//nombre.hkb
  if ( l30 == null) return null;// la lista no existe
  if ( eq30 == null)
    l30.Esqu = new esquema30( l30.Name(), l30.ParIndice(), l30.ParRespuesta()).leerEq( dato30.extFile( pathKBM, "eq"));
    else l30.Esqu = new esquema30( eq30);//!!!

  if ( l30.Esqu == null) {
	  kbm2lSystem.append( ERROR + "l30.Esqu. file: " + dato30.extFile( pathKBM, "eq") + "\n");
     frame30.exit( 0);
	  }

  pathKBM =  dato30.pathFile( pathKBM);//

  //tabla txt, data.frame o lista kbm, nombre.[txt|df|kbm], [tT|fF|mM]
  FlagSet = ic30.nombre.substring( ic30.nombre.length()-1, ic30.nombre.length()).charAt( 0);//
  kbm2lSystem.append( "Read Table, FlagSet: " + FlagSet + ".\n" + "hkb name: " + ic30.nombre + ".\n");

  if (( FlagSet == 'm'|| FlagSet == 'M')) {//KBM2L-KBM
    FlagSet = 'm'; 
    l30.ini_();//se captura la estructura del fichero y no inicializa el gestor (ini()).
    kbm2lSystem.append( "List access: " + pathKBM + l30.Name() + ", from disk.\n");
    in = dato30.openFile( dato30.nameFile( l30.Name()), "kbm");
    }

  if (( FlagSet == 't' || FlagSet == 'T')) {//TABLA-TXT
    FlagSet = 't'; 
    kbm2lSystem.append( "Table access: " + pathKBM + l30.Name() + ", from disk.\n");
    in = dato30.openFile( dato30.nameFile( l30.Name()), "txt");
    }

  if (( FlagSet == 'd' || FlagSet == 'D')) {//TABLA-D
    FlagSet = 'd'; 
    kbm2lSystem.append( "Table access: " + pathKBM + l30.Name() + ", from disk.\n");
    in = dato30.openFile( dato30.nameFile( l30.Name()), "df");
    }

   if (( FlagSet == 'c' || FlagSet == 'C')) {//TABLA-D
    FlagSet = 'c'; 
    kbm2lSystem.append( "Table access: " + pathKBM + l30.Name() + ", from disk.\n");
    in = dato30.openFile( dato30.nameFile( l30.Name()), "txt");
    }

  if ( in == null) {
    kbm2lSystem.append( "File does not exit: " + pathKBM + l30.Name() + 
      "  FlagSet: " + FlagSet + ".\n");
    return null;
    }

  Vector Ix = new Vector();//contador para generar el indice en una tabla implicita
  Ix = index30.primeroT( l30.Base.Dom());

  boolean chk = new controlPrefs30().checkMode();

//scanner de tokens en las lineas del tabla.[txt|kbm]
  try {//

    while ((linea = dato30.nextLine( in, linea)) != null) {

      if (linea.indexOf(';') != 0) {//datos  

      if (linea.indexOf('.') == 0) break;//fin de entrada
      
      Vector buftks = new Vector();//buffer-tokens
      Integer I = null;
      for( int i = 0; i < ( l30.ParMedida() + 
                            l30.ParRespuesta() + 
                            l30.ParIndice())-1; i++) {

        I = new Integer( i);
        if ( ic30.R.indexOf( I) != -1)//mascara de medidas reales cast double | integer
          buftks.add( new Double( dato30.param( linea)));//real
          else buftks.add( new Integer( (int)( dato30.param( linea))));//entero
          
        linea = new String( dato30.nextParam( linea, ' '));

        }//for

      I = new Integer(( l30.ParMedida() + 
                        l30.ParRespuesta() + 
                        l30.ParIndice()) - 1);
      if ( ic30.R.indexOf( I) != -1)//mascara de medidas reales cast double | integer
        buftks.add( new Double( dato30.param(linea)));//real
        else buftks.add( new Integer( (int)( dato30.param( linea))));//entero

    try {

      if (( FlagSet == 'd' || FlagSet == 'D')) { //DF
        t_old = l30.size();
        if (chk) 
          kbm2lSystem.append( "leerTabla d : " +  Ix.toString() + " " + buftks.toString() + "\n");
        l30.Set( new item30().item( l30, ic30, Ix, buftks));//!!! TABLA Set de datos
        t_new = l30.size();
        if ( t_old == t_new) hit++;
        }//if

      if (( FlagSet == 't' || FlagSet == 'T')) { //TXT
        t_old = l30.size();
        if (chk) 
          kbm2lSystem.append( "leerTabla t : " +  Ix.toString() + " " + buftks.toString() + "\n");
        l30.Set( new item30().item( l30, ic30, Ix, buftks));//!!! TABLA Set de casos
        t_new = l30.size();
        if ( t_old == t_new) hit++;
        }//if

      if (( FlagSet == 'm' || FlagSet == 'M')) { //KBM
        item30 item = new item30().item( l30, ic30, Ix, buftks);
        l30.SET( item);//!!! LISTA SET de items
        if (chk) kbm2lSystem.append( "item: " +  item.GetIndice().toString() + " " + 
                   item.GetRespuesta().toString() + "" + item.GetMedida().toString() + "\n");        
        }//if

      if ( entradas % 1000 == 0) {
        long casos = listStat30.KB( l30).longValue();
        kbm2lSystem.estatus(("INPUTS: " + entradas + "  ITEMS: "+ l30.size()) + "  KB: " + casos);
        if ( casos > l30.limitCases) {
          kbm2lSystem.append( ERROR + 
            " /Cases-OVF/ " + "SetTabla. " + FlagSet + " Lines:" + entradas + ".\n");
          //break;
          }//if
        if ( l30.size() > l30.limitItems) {
          kbm2lSystem.append( ERROR + 
            " /Items-OVF/ " + "SetTabla. " + FlagSet + " Lines:" + entradas + ".\n");
          break;
          }//if
        }//if  

      }//try
        catch (Exception e) {
        kbm2lSystem.append( ERROR + "SetTabla. " + FlagSet + "  Lines:" + entradas + "\n");
        frame30.exit( 0);
      }//catch

      entradas++;
      
      }//if comentario
      else {
        if ( new controlPrefs30().verboseSystem()) {
          kbm2lSystem.append( "remark:   " + linea + ".\n");
          }
        }
  
    }//while

    in.close(); 
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "leerTabla. " + "Lines:" + entradas + "\n");
    frame30.exit( 0);
  }//catch  

  listStat30.calc( l30);//
//  listStat30.importanceAtt( l30);//

  checkList30.chk( l30, "inputTable30.leerTabla");
//  eqKBM2L30.eqKBM2L( l30, l30, "inputTable30.leeTabla"); // eqKBM2L !!!

  leerTablaPost( l30, entradas, hit, pathKBM);
  return l30;     
}//leerTabla

/**
* Tras la lectura de la tabla.
* Informa a kbm2lSystem, Titula la ventana, informa a kbm2lControl.
* 
**/
protected void leerTablaPost( lista30 l30, long entradas, long hit , String pathKBM) {

  if ((FlagSet=='t'||FlagSet=='T')) {//TXT
    kbm2lSystem.append( "Table readed: " + pathKBM + l30.Name() + ", from disk.\n");
    kbm2lSystem.append("Summary.  hits: " + hit + "  Items: " + l30.size() + 
      "  CASES: "+listStat30.KB(l30) + ",  (rst) = (" + l30.ParMedida() + "," + 
      l30.ParRespuesta() + "," + l30.ParIndice() + ")\n");
    }

  if ((FlagSet=='d'||FlagSet=='D')) {//DF
    kbm2lSystem.append( "Data readed: " + pathKBM + l30.Name() + ", from disk.\n");
    kbm2lSystem.append("Summary.  hits: " + hit + "  Items: " + l30.size() + 
      "  CASES: "+listStat30.KB(l30) + ",  (rst) = (" + l30.ParMedida() + "," + 
      l30.ParRespuesta() + "," + l30.ParIndice() + ")\n");
    }

  if ((FlagSet=='m'||FlagSet=='M')) { //KBM
    kbm2lSystem.append( "List readed: " + pathKBM + l30.Name() + ", from disk.\n");
    kbm2lSystem.append("Summary.  Items: " + l30.size() + 
      "  CASES: "+listStat30.KB(l30) + ",  (rst) = (" + l30.ParMedida() + "," + 
      l30.ParRespuesta() + "," + l30.ParIndice() + ")\n");
    }

  kbm2lSystem.frame.setTitle( 
    kbm2lSystem.frame.getTitle().substring( 0, 
      kbm2lSystem.frame.getTitle().indexOf('-')-1) + " - " + pathKBM + l30.Name());

  kbm2lControl.setText( kbm2lControl.WorkSpace, dato30.workspace);
  kbm2lControl.setText( kbm2lControl.ListName, dato30.nameFile( l30.Name()));
  kbm2lControl.setText( kbm2lControl.ListSize, String.valueOf( l30.size()));
  
  new controlPrefs30().onTopAttribute( 0);
  new controlPrefs30().onBotAttribute( l30.dimension()-1);

  kbm2lSystem.estatus( "KBM2L readed.  INPUTS: " + entradas );
  return;
}//leerTablaPost

/**
* run process: leerTabla.
* filedlg si fileTable es "";
* El esquema debe existir y se llama igual que el fileTable
**/
public void run() {

  try {
    long ts0 = (new Date()).getTime();
    lista30 bkl30 = leerTabla( null, fileTable);
    if ( bkl30 != null) 
        f30.activel30 = bkl30;
    f30.kbm2lTime.append("leerTabla:: " + (new Date().getTime() - ts0) + ".\n");        
  }//try
    catch (Exception e) {
      System.out.println( ERROR + "run().");
      frame30.exit( 0);
    }//catch
  return;
}//run

}//class inputTable30
