//outputCabeceraEsquema30//
package tables;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kbm2l.*;
import kernel.*;
import schema.*;
import tables.*;
import control.*;

/**
* Clase outputCabeceraEsquema30
* Acceso escritura fisica de las cabeceras de tablas/listas  .hkb
* Texto plano.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  outputCabeceraEsquema30  extends  outputEsquema30 {

  private static final String ERROR = "Error(outputCabeceraEsquema30): ";

/**
* Constructor por defecto.
**/
public outputCabeceraEsquema30( ) {

}//outputCabeceraEsquema30

/**
* Escribe el fichero nombre.eq con el esquema del fichero de una lista con cabecera c30
**/
public outputCabeceraEsquema30 escribeEsquema( lista30 l30, String pathKBM, String ext) {
//nombre del fichero de informacion, tabla txt con observaciones, lista kbm con grupos contiguos 
//File:nombre !!! --- extensiones
//S: code id domsz;
//Val: id0, id1,...;
//...
//Att: code id domsz;
//Val: id0, id1,...; 
//...
  if ( new controlPrefs30().verboseSystem())
    kbm2lSystem.append("Schema will be generate: " + pathKBM + ".\n");

  String linea = null; // linea del fichero que contiene una tabla
  BufferedWriter out = null;

  try {//
    out = new BufferedWriter( new FileWriter( pathKBM));
  }//try
  catch (Exception e) {
  kbm2lSystem.append("Schema generation fail: " + pathKBM + ".\n");
    System.out.println( ERROR + "escribeEsquema1. FileWriter. " + pathKBM + ".\n");
    e.printStackTrace();
    System.exit(0);
  }//catch

try {
  escribeEsquemaFile( out, pathKBM, ext);
  escribeEsquemaS( out, l30);
  escribeEsquemaAtt( out, l30);

  out.close(); 
  }//try
  catch (Exception e) {
    System.out.println( ERROR  + "escribeEsquema2.");
    e.printStackTrace();
    System.exit(0);
  }//catch

  if ( new controlPrefs30().verboseSystem())
    kbm2lSystem.append("Schema of " + pathKBM + " stored.\n");

  return this;
}//escribeEsquema

/**
* S: code alt num ; 
* Val:
**/
private String escribeEsquemaS( BufferedWriter out, lista30 l30) {

  String linea = null;
  try {//
    for( int i = 0; i < l30.ParRespuesta(); i++) {
	   int ds = listStat30.ds( l30, i).size();
      linea = dato30.flag_S + "  " + (i+10000) + "  " + "dec"+(i) + " " + ds + ";"; 
      out.write( linea, 0, linea.length());
      out.newLine();
      linea = dato30.flag_V;
      for( int j = 0; j < ds; j++)
        linea = linea + " " + "alt"+(j);
      linea = linea + ";";  
      out.write( linea, 0, linea.length());
      out.newLine();
      }//for
  }//try
  catch (Exception e) {
    System.out.println( ERROR  + "escribeEsquemaS.");
    e.printStackTrace();
    System.exit(0);
  }//catch

  return linea;
}//escribeEsquemaS 

/**
* Att: code att num ; 
* Val:
**/
private String escribeEsquemaAtt( BufferedWriter out, lista30 l30) {

  String linea = null;
  
  try {
    for( int i = 0; i < l30.ParIndice(); i++) {
	   int d = l30.Base.dom( i);
      linea = dato30.flag_A + "  " + i + "  " + "att"+(i) + " " + d + ";"; 
      out.write( linea, 0, linea.length());
      out.newLine();
      linea = dato30.flag_V;
      for( int j = 0; j < d; j++)
        linea = linea + " " + "val"+(j);
      linea = linea + ";";  
      out.write( linea, 0, linea.length());
      out.newLine();
      }//for

  }//try
  catch (Exception e) {
    System.out.println( ERROR  + "escribeEsquemaAtt.");
    e.printStackTrace();
    System.exit(0);
  }//catch

  return linea;
}//escribeEsquemaAtt

}//class outputCabeceraEsquema30