//OUTPUTDATAFRAME30//
package tables;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import query.*;
import control.*;
import kbm2l.*;
import kernel.*;

/**
* Clase outputDataFrame30.
* Escritura fisica de la lista como data.frame R.
* Escribe las listas en el formato de tabla convencional. Texto plano.
* Genera los conjunto de datos para analisis en R.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class outputDataFrame30  extends  tabla30  implements  Runnable {

  private static final String ERROR = "Error(outputDataFrame30): ";
  protected long casos = 0;

/**
* Constructor por defecto.
**/
public outputDataFrame30( ) {

}//outputDataFrame30

/**
* Constructor.
* @param fileTab nombre del fichero.
**/
public outputDataFrame30( String fileTab, lista30 l30 ) {

  fileTable = new String( fileTab);
  casos = 0;
}//outputDataFrame30

/**
* Tablas explicitas con indices. 
* Generacion de casos para aprendizaje de redes bayesianas.
* Si el tamao del conjunto de datos consultaGeneral30.dataSetSize es -1 es un volcado completo.  
* filter es inicializado en algun constructor o en una consulta bayesiana.
**/
public long escribeDataFrame( lista30 l30, String pathKBM) {
//
  casos = 0;

  if ( pathKBM.equals("")) {
    String fileName = dato30.selectFile( f30.kbm2lSystem.frame, FileDialog.SAVE, "*.hkb");
    if ( fileName == null) {
      kbm2lSystem.append( "DataFrame Not Stored.\n");
      return -1;
      }
    pathKBM = new String( fileName);
    }
  if ( pathKBM == "") {
    kbm2lSystem.append( "DataFrame Not Stored.\n");
    return -1;
    }

  outputListaCabecera30 olc30 = new outputListaCabecera30( ).escribeCabecera( l30, dato30.extFile( pathKBM, "hkb"), "txt");

  BufferedWriter out = null;

  try {//
    out = new BufferedWriter( new FileWriter( dato30.extFile( pathKBM, "df")));

//CERO
      casos = new outputTableData30( ).escribeItemTableZero( out, l30, casos);

//RESTO k-items
      casos = new outputTableData30( ).escribeItemTableOne( out, l30, casos);
  
    out.close(); 
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "escribeDataFrame. " + "List size: " + l30.size());
    exit(0, e);
  }//catch

  kbm2lSystem.append( "DataFrame stored: " + pathKBM + ",\n on the disk. Cases: " + casos + "\n");
  kbm2lSystem.frame.setTitle( 
    kbm2lSystem.frame.getTitle().substring( 0, 
    kbm2lSystem.frame.getTitle().indexOf('-')-1) + 
    " - " + pathKBM);

  l30.Name( dato30.nameFile( pathKBM));
  kbm2lControl.setText( kbm2lControl.WorkSpace, dato30.workspace);
  kbm2lControl.setText( kbm2lControl.ListName, l30.Name());
  kbm2lControl.setText( kbm2lControl.ListSize, String.valueOf( l30.size()));
  
  return casos;
}//escribeDataFrame

/**
* run: escribeDataFrame
**/
public void run() {

  try {
    escribeDataFrame( f30.activel30, fileTable);//filedlg si fileTable es "";
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    exit( 0, e);
  }//catch
  return;
}//run

}//class outputDataFrame30
