//outputEsquemaCabecera30//
package tables;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kbm2l.*;
import schema.*;
import control.*;

/**
* Clase outputEsquemaCabecera30
* Acceso escritura fisica de las cabeceras de tablas/listas  .hkb
* Texto plano.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  outputEsquemaCabecera30  extends  outputCabecera30 {

  private static final String ERROR = "Error(outputEsquemaCabecera30): ";

/**
* Constructor por defecto.
**/
public outputEsquemaCabecera30( ) {

}//outputEsquemaCabecera30

/**
* Escribe el fichero nombre.hkb con la cabeza del fichero de una lista con esquema eq30
**/
public outputEsquemaCabecera30 escribeCabecera( esquema30 eq30, String pathKBM, String ext) {
//nombre del fichero de informacion, tabla txt con observaciones, lista kbm con grupos contiguos 
//File:nombre.kbm !!! --- extensiones
//H linea con indice(t), respuesta(s>=1) y medida(r)
//Head: r=0 s=1 t=2;//t>=1, s>=1.
//mascara de fila indices del vector indice, respuesta y del vector medida, vistas de la tabla.
//R:;// nada sin medida
//S:3;//escalar
//T:0 1 2;// nada == indice implicito
//Dominio de las componentes del vector indice
//Dom:2 2 2;
//Base de permutaciones del indice, para generar el orden total de almacenamiento y acceso.
//Bas:0 1 2;

  if ( new controlPrefs30().verboseSystem())
    kbm2lSystem.append("Schema header will be generate: " + pathKBM + ".\n");

  String linea = null; // linea del fichero que contiene una tabla
  BufferedWriter out = null;

  try {//
    out = new BufferedWriter( new FileWriter( pathKBM));
  }//try
  catch (Exception e) {
    kbm2lSystem.append("Schema header generation fail: " + pathKBM + ".\n");
    System.out.println( ERROR + "escribeCabecera2. FileWriter. " + pathKBM + ".\n");
    e.printStackTrace();
    System.exit(0);
  }//catch

try {
  escribeCabeceraFile( out, pathKBM, ext);
  escribeCabeceraHead( out, eq30);
  escribeCabeceraDom( out, eq30);
  escribeCabeceraBas( out, eq30);
  escribeCabeceraRol( out, eq30);

  out.close(); 
  }//try
  catch (Exception e) {
    System.out.println( ERROR  + "escribeCabecera2.");
    e.printStackTrace();
    System.exit(0);
  }//catch

  if ( new controlPrefs30().verboseSystem())
    kbm2lSystem.append("Schema header of " + pathKBM + " stored.\n");

  return this;
}//escribeCabecera

/**
*
**/
private String escribeCabeceraHead( BufferedWriter out, esquema30 eq30) {

  String linea = dato30.flag_H + (1/*lista30.r_default*/) + " " + 
    (eq30.numDecisiones) + " " + (eq30.numAtributos) + ";";

  try {//

//mascara estandar con instancias
  out.write( linea, 0, linea.length());
  out.newLine();

  linea = dato30.flag_R;
  for(int i = 0; i < (1/*lista30.r_default*/); i++)
    linea = linea + " " + (i + eq30.numAtributos + eq30.numDecisiones);
  linea = linea + ";";
  out.write( linea, 0, linea.length());
  out.newLine();
//
  linea = dato30.flag_S;
  for(int i = 0; i < (eq30.numDecisiones); i++)
    linea = linea + " " + (i + eq30.numAtributos);
  linea = linea + ";";
  out.write( linea, 0, linea.length());
  out.newLine();
//
  linea = dato30.flag_T;
  for(int i = 0; i < (eq30.numAtributos); i++) {
    linea = linea + " " + i;
    }
  linea = linea + ";";
  out.write( linea, 0, linea.length());
  out.newLine();

  }//try
  catch (Exception e) {
    System.out.println( ERROR  + "escribeCabeceraHead.");
    e.printStackTrace();
    System.exit(0);
  }//catch

  return linea;
}//escribeCabeceraHead

//flag Dom
private String escribeCabeceraDom( BufferedWriter out, esquema30 eq30) {

  String linea = dato30.flag_D;

  try {
    for(int i = 0; i < (eq30.CodigosAtributos.size()); i++)
      linea = linea + " " + ((Integer)(eq30.CDAtributos.get(i))).intValue();
    linea = linea + ";";
    out.write( linea, 0, linea.length());
    out.newLine();

  }//try
  catch (Exception e) {
    System.out.println( ERROR  + "escribeCabeceraDom.");
    e.printStackTrace();
    System.exit(0);
  }//catch

  return linea;
}//escribeCabeceraDom

//flag Bas
private String escribeCabeceraBas( BufferedWriter out, esquema30 eq30) {

  String linea = dato30.flag_B;

  try {
    for(int i = 0;i < (eq30.numAtributos); i++)
      linea = linea + " " + i;//canonica o del esquema
    linea = linea + ";";
    out.write( linea, 0, linea.length());
    out.newLine();

  }//try
  catch (Exception e) {
    System.out.println( ERROR  + "escribeCabeceraBas.");
    e.printStackTrace();
    System.exit(0);
  }//catch

  return linea;
}//escribeCabeceraBas

//flag Rol
private String escribeCabeceraRol( BufferedWriter out, esquema30 eq30) {

  String linea = dato30.flag_L;

  try {
    for( int i = 0;i < (eq30.numAtributos); i++)
      linea = linea + " " + -1;//canonica o del esquema sin rol
    linea = linea + ";";
    out.write( linea, 0, linea.length());
    out.newLine();

  }//try
  catch (Exception e) {
    System.out.println( ERROR  + "escribeCabeceraRol.");
    e.printStackTrace();
    System.exit(0);
  }//catch

  return linea;
}//escribeCabeceraRol

}//class outputEsquemaCabecera30