//OUTPUTLIST30//
package tables;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import control.*;
import kbm2l.*;
import kernel.*;
import schema.*;

/**
* Clase outputList30.
* Acceso de escritura fisica de las listas.
* Escribe las listas en el formato de KBM2L convencional. Texto plano.
* Construye los items y los aade a la lista.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class outputList30  extends  tabla30 {

  private static final String ERROR = "Error(outputList30): ";

/**
* Constructor por defecto.
**/
public outputList30( ) {

  Ix = null; 
  FlagSet = '.';
  fileTable = "";
}//outputList30

/**
* Constructor por defecto.
* @param table nombre del fichero de la tabla.
**/
public outputList30( String table) {

  Ix = null; 
  FlagSet = '.';
  fileTable = table;
}//outputList30

/**
* Tablas implicitas con indices out_kbm2l, 
* if ( control30.checkMode()) out_index 
**/
public long escribeKBM2L( lista30 l30, String pathKBM) {
//
  BufferedWriter out_kbm2l = null;//kbm2l
  BufferedWriter out_index = null;//indices LOW UPP
  String linea = null; // linea del fichero que contiene una tabla
  boolean userAction = false;
  boolean chk = new controlPrefs30().checkMode();

  checkList30.chk( l30, "outputList30 - escribeKBM2L");
  
  if (pathKBM == "") {
    String filename = dato30.selectFile( f30.kbm2lSystem.frame, FileDialog.SAVE, "*.hkb");
    if ( filename == null) {
      kbm2lSystem.append( "KBM2L not stored.\n");
      return -1;
      }
    pathKBM = new String( filename);
    userAction = true;
    }
  if ( pathKBM == "") {
    kbm2lSystem.append( "KBM2L not stored.\n");
    return -1;
    }

  new outputEsquema30( ).escribirEsquema( pathKBM, l30);
  
  if ( !new File( dato30.extFile( pathKBM, "hkb")).exists()) 
    new outputListaCabecera30( ).escribeCabecera( l30, dato30.extFile( pathKBM, "hkb"), "kbm");     

try {//
  out_kbm2l = new BufferedWriter( new FileWriter( dato30.workspace + dato30.nameFile( dato30.extFile( pathKBM, "kbm"))));
  if ( chk)
    out_index = new BufferedWriter( new FileWriter( dato30.workspace + dato30.nameFile( dato30.extFile( pathKBM, "ind"))));

  item30 ITEM = null;
  Vector MEDIDA = null;
  Vector RESPUESTA = null;
  Vector INDICE = null;

  listStat30.calc( l30);

  for( int j = 0; j < l30.size(); j++) {

    ITEM = l30.Get( j);//un solo item.
    MEDIDA = ITEM.GetMedida();
    RESPUESTA = ITEM.GetRespuesta();
    INDICE = ITEM.GetIndice();

//check
    if (!l30.esUNKB(ITEM) && !l30.esCOKB(ITEM))
      if (ITEM.getLongitud().doubleValue() > 100000)
        frame30.kbm2lSystem.append(j+"  output  "+ ITEM.getLongitud().toString()+"\n");
        
//kbm2l
    try {
    linea = "";//instancia la parte constante del indice, peso maximo.
    for( int i = 0; i < l30.dimension(); i++) 
      linea = linea + ((Integer)(INDICE.get( i))).intValue() + " ";
    for( int i = 0; i < l30.ParRespuesta(); i++) 
      linea = linea + ((Integer)(RESPUESTA.get( i))).intValue() + " ";
    for( int i = 0; i < l30.ParMedida(); i++) 
      linea = linea + ((Double)(MEDIDA.get( i))).doubleValue() + " ";
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "escribeKBM2L.kbm2l-1 " + "Lines:" + l30.size() + ".\n");
    exit(0, e);
  }//catch

  try {
    linea = linea + ";" + " " + ITEM.getLongitud().toString();
    out_kbm2l.write( linea, 0, linea.length());
    out_kbm2l.newLine();
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "escribeKBM2L.kbm2l-2 " + "Lines:" + l30.size() + ".\n");
    exit(0, e);
  }//catch

  try {
    linea = "; j: " + j + " < " + outputRemark( l30, INDICE, RESPUESTA);
    out_kbm2l.write( linea, 0, linea.length());
    out_kbm2l.newLine();
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "escribeKBM2L.kbm2l-3 " + "Lines:" + l30.size() + ".\n");
    exit(0, e);
  }//catch

  if ( chk) {
    
//index low
  try {
    linea = "";//instancia la parte constante del indice, peso maximo.
    INDICE = l30.Inf( j);
    for( int i = 0; i < l30.dimension(); i++) 
      linea = linea + ((Integer)(INDICE.get( i))).intValue() + " ";
    for( int i = 0; i < l30.ParRespuesta(); i++) 
      linea = linea + ((Integer)(RESPUESTA.get( i))).intValue() + " ";
    for( int i = 0; i < l30.ParMedida(); i++) 
      linea = linea + ((Double)(MEDIDA.get( i))).doubleValue() + " ";

    linea = linea + ";";
    out_index.write( linea, 0, linea.length());
    out_index.newLine();

    linea = "; j: " + j + " <LOW> " + outputRemark( l30, INDICE, RESPUESTA);
    out_index.write( linea, 0, linea.length());
    out_index.newLine();
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "escribeKBM2L.inf " + "Lines:" + l30.size() + ".\n");
    exit(0, e);
  }//catch

//index upp
  try {
    linea = "";//instancia la parte constante del indice, peso maximo.
    INDICE = l30.Sup( j);
    for( int i = 0; i < l30.dimension(); i++) 
      linea = linea + ((Integer)(INDICE.get( i))).intValue() + " ";
    for( int i = 0; i < l30.ParRespuesta(); i++) 
      linea = linea + ((Integer)(RESPUESTA.get( i))).intValue() + " ";
    for( int i = 0; i < l30.ParMedida(); i++) 
      linea = linea + ((Double)(MEDIDA.get( i))).doubleValue() + " ";

    linea = linea + ";";
    out_index.write( linea, 0, linea.length());
    out_index.newLine();

    linea = "; j: " + j + " <UPP> " + outputRemark( l30, INDICE, RESPUESTA);
    out_index.write( linea, 0, linea.length());
    out_index.newLine();
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "escribeKBM2L.upp " + "Lines:" + l30.size() + ".\n");
    exit(0, e);
  }//catch
    
  }//  if ( !control30.checkMode())
  
    }//for

    out_kbm2l.close(); 
    if ( new controlPrefs30().checkMode())
      out_index.close(); 
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "escribeKBM2L. " + "Lines:" + l30.size() + ".\n");
    exit(0, e);
  }//catch

  kbm2lSystem.append( "KBM2L stored: " + pathKBM + ", on disk.\n");

  if ( userAction)
  kbm2lSystem.frame.setTitle( 
    kbm2lSystem.frame.getTitle().substring( 0, 
    kbm2lSystem.frame.getTitle().indexOf('-')-1) + 
    " - " + pathKBM);

  l30.Name( dato30.nameFile( pathKBM));
  kbm2lControl.setText( kbm2lControl.WorkSpace, dato30.workspace);
  kbm2lControl.setText( kbm2lControl.ListName, l30.Name());
  kbm2lControl.setText( kbm2lControl.ListSize, String.valueOf( l30.size()));

  return l30.size();
}//escribeKBM2L

/**
* run: escribeKBM2L
**/
public void run() {

  try {
    escribeKBM2L( f30.activel30, fileTable);//filedlg si fileTable es "";
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "run().\n");
    exit( 0, e);
  }//catch
  return;
}//run

}//class outputList30
