//outputListaCabecera30//
package tables;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import control.*;
import kbm2l.*;
import kernel.*;

/**
* Clase outputListaCabecera30
* Acceso escritura fisica de las cabeceras de tablas/listas  .hkb
* Texto plano.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  outputListaCabecera30  extends  outputCabecera30 {

  private static final String ERROR = "Error(outputListaCabecera30): ";

/**
* Constructor por defecto.
**/
public outputListaCabecera30( ) {

}//outputListaCabecera30

/**
* Escribe el fichero nombre.hkb con la cabeza del fichero de la lista l30.
**/
public outputListaCabecera30 escribeCabecera( lista30 l30, String pathKBM, String ext) {
//nombre del fichero de informacion, tabla txt con observaciones, lista kbm con grupos contiguos 
//File:nombre.kbm !!! --- extensiones
//H linea con indice(t), respuesta(s>=1) y medida(r)
//Head: r=0 s=1 t=2;//t>=1, s>=1.
//mascara de fila indices del vector indice, respuesta y del vector medida, vistas de la tabla.
//R:;// nada sin medida
//S:3;//escalar
//T:0 1 2;// nada == indice implicito
//Dominio de las componentes del vector indice
//Dom:2 2 2;
//Base de permutaciones del indice, para generar el orden total de almacenamiento y acceso.
//Bas:0 1 2;

  if ( new controlPrefs30().verboseSystem())
    kbm2lSystem.append("List header will be generate: " + dato30.workspace + dato30.nameFile( pathKBM) + ".\n");

  String linea = null; // linea del fichero que contiene una tabla
  BufferedWriter out = null;

  try {//
    out = new BufferedWriter( new FileWriter( dato30.workspace + dato30.nameFile( pathKBM)));//.hkb
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "escribeCabecera1. " + dato30.workspace + dato30.nameFile( pathKBM) + ".\n");
    System.out.println("List header generation fail: " + dato30.workspace + dato30.nameFile( pathKBM) + ".\n");
    exit(0, e);
  }//catch

  escribeCabeceraFile( out, pathKBM, ext);
  escribeCabeceraHead( out, l30);
  escribeCabeceraDom( out, l30);
  escribeCabeceraBas( out, l30);
  escribeCabeceraRol( out, l30);

  try {//
    out.close(); 
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "escribeCabecera1.");
    exit(0, e);
  }//catch

  if ( new controlPrefs30().verboseSystem())
    kbm2lSystem.append("List header of " + dato30.workspace + pathKBM + " stored.\n");

  return this;
}//escribeCabecera

//flag Head
private String escribeCabeceraHead( BufferedWriter out, lista30 l30) {

  String linea = dato30.flag_H+" "+l30.ParMedida()+" "+l30.ParRespuesta()+" "+l30.ParIndice()+";";

  try {
//mascara en forma estandar sin instancias
    out.write( linea, 0, linea.length());
    out.newLine();

  linea = dato30.flag_R + " ";
  for(int i = 0; i < l30.ParMedida(); i++)
    linea = linea + " " + (i + l30.ParIndice() + l30.ParRespuesta());
  linea = linea + ";";
  out.write( linea, 0, linea.length());
  out.newLine();
  linea = dato30.flag_S + " ";
  for(int i = 0; i < l30.ParRespuesta(); i++)
    linea = linea + " " + (i + l30.ParIndice());
  linea = linea + ";";
  out.write( linea, 0, linea.length());
  out.newLine();
  linea = dato30.flag_T + " ";
  for(int i = 0; i < l30.ParIndice(); i++)
    linea = linea + " " + i;
  linea = linea + ";";
  out.write( linea, 0, linea.length());
  out.newLine();

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "escribeCabeceraHead.");
    exit(0, e);
  }//catch

  return linea;
}//escribeCabeceraHead

//flag Dom
private String escribeCabeceraDom( BufferedWriter out, lista30 l30) {

  String linea = dato30.flag_D + " ";
  
  for(int i = 0; i < l30.dimension(); i++)
    linea = linea + " " + ( l30.Base.dom( i));
  linea = linea + ";";

  try {
    out.write( linea, 0, linea.length());
    out.newLine();
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "escribeCabeceraDom.");
    exit(0, e);
  }//catch
  
  return linea;
}//escribeCabeceraDom

//flag Bas
private String escribeCabeceraBas( BufferedWriter out, lista30 l30) {

  String linea = dato30.flag_B + " ";

  for(int i = 0; i < l30.dimension(); i++)
    linea = linea + " " + ( l30.Base.bas( i));
  linea = linea + ";";

  try {
    out.write( linea, 0, linea.length());
    out.newLine();
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "escribeCabeceraBas.");
    exit(0, e);
  }//catch
  
  return linea;
}//escribeCabeceraBas

//flag Rol
private String escribeCabeceraRol( BufferedWriter out, lista30 l30) {

  String linea = dato30.flag_L + " ";

  for(int i = 0; i < l30.dimension(); i++)
    linea = linea + " " + ( l30.Base.rol( i));
  linea = linea + ";";

  try {
    out.write( linea, 0, linea.length());
    out.newLine();
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "escribeCabeceraRol.");
    exit(0, e);
  }//catch
  
  return linea;
}//escribeCabeceraRol

}//class outputListaCabecera30