//OUTPUTTABLE30//
package tables;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import query.*;
import control.*;
import kbm2l.*;
import kernel.*;

/**
* Clase outputTable30.
* Acceso de escritura fisica de las tablas.
* Escribe las listas en el formato de tabla convencional. Texto plano.
* Genera los conjunto de datos para aprender la redes bayesianas, proyectamos Y-vector.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class outputTable30  extends  tabla30  implements  Runnable {

  private static final String ERROR = "Error(outputTable30): ";
  private static maskTable30 filter = null;//
  protected long casos = 0;

/**
* Constructor por defecto.
**/
public outputTable30( ) {

}//outputTable30

/**
* Constructor por defecto.
* @param l30 lista30.
**/
public outputTable30( lista30 l30) {
  
  fileTable = null;
  filter = new maskTable30( l30);
  casos = 0;
}//outputTable30

/**
* Constructor.
* @param l30 lista30.
**/
public outputTable30( lista30 l30, 
  Vector maskr, Vector masks, Vector maskt, 
  boolean wend) {
  
  fileTable = null;
  filter = new maskTable30( l30, maskr, masks, maskt, wend);
  casos = 0;
}//outputTable30

/**
* Constructor.
* @param fileTab nombre del fichero.
**/
public outputTable30( String fileTab, lista30 l30 ) {

  fileTable = new String( fileTab);
  filter = new maskTable30( l30);
  casos = 0;
}//outputTable30

/**
* Constructor.
* @param fileTab nombre del fichero.
* @param Y proyeccion en X, los atributos que quedan en el esquema al proyectar segun el conjunto X.
**/
public outputTable30( String fileTab, lista30 l30, Vector Y) {

  fileTable = new String( fileTab);
  filter = new maskTable30( l30);
  casos = 0;
}//outputTable30

/**
* Tablas explicitas con indices. 
* Generacion de casos para aprendizaje de redes bayesianas.
* Si el tamao del conjunto de datos consultaGeneral30.dataSetSize es -1 es un volcado completo.  
* filter es inicializado en algun constructor o en una consulta bayesiana.
**/
public long escribeTabla( lista30 l30, String pathKBM) {
//
  casos = 0;

  if ( pathKBM.equals("")) {
    String fileName = dato30.selectFile( f30.kbm2lSystem.frame, FileDialog.SAVE, "*.hkb");
    if ( fileName == null) {
      kbm2lSystem.append( "Not Stored table.\n");
      return -1;
      }
    pathKBM = new String( fileName);
    }
  if ( pathKBM == "") {
    kbm2lSystem.append( "Not Stored table.\n");
    return -1;
    }

  outputListaCabecera30 olc30 = new outputListaCabecera30( ).escribeCabecera( l30, 
    dato30.extFile( pathKBM, "hkb"), "txt");

  BufferedWriter out = null;

  try {//
    out = new BufferedWriter( new FileWriter( dato30.extFile( pathKBM, "dat")));

    if ( new controlPrefs30( ).headK2BayesQuery()) {
        consultaGeneral30.headBayesData( out, l30, filter);
      }//heahK2BayesQuery
 
  if ( consultaGeneral30.dataSetSize == -1) {//sin filtro

//CERO
      casos = new outputTableItem30( ).escribeItemTableZero( out, l30, casos);

//RESTO k-items
      casos = new outputTableItem30( ).escribeItemTableOne( out, l30, casos);
  
  } else {//con filtro
  
  if ( filter == null) {
    kbm2lSystem.append( "Null filter. \n");
    kbm2lSystem.append( "Table not stored: " + pathKBM + ",\n on the disk. Cases: " + casos + "\n");
    return casos;
    }

  while ( casos < consultaGeneral30.dataSetSize) {
  
//CERO
      casos = new outputTableItem30( ).escribeItemTableZero( out, l30, filter, casos);

//RESTO k-items
      casos = new outputTableItem30( ).escribeItemTableOne( out, l30, filter, casos);
  
    }//completar el conjuto de datos

    }//if
    
    out.close(); 
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "escribeTabla. " + "List size: " + l30.size());
    exit(0, e);
  }//catch

  kbm2lSystem.append( "Table stored: " + pathKBM + ",\n on the disk. Cases: " + casos + "\n");
  kbm2lSystem.frame.setTitle( 
    kbm2lSystem.frame.getTitle().substring( 0, 
    kbm2lSystem.frame.getTitle().indexOf('-')-1) + 
    " - " + pathKBM);

  l30.Name( dato30.nameFile( pathKBM));
  kbm2lControl.setText( kbm2lControl.WorkSpace, dato30.workspace);
  kbm2lControl.setText( kbm2lControl.ListName, l30.Name());
  kbm2lControl.setText( kbm2lControl.ListSize, String.valueOf( l30.size()));
  
  return casos;
}//escribeTabla

/**
* run: escribeTabla
**/
public void run() {

  try {
    escribeTabla( f30.activel30, fileTable);//filedlg si fileTable es "";
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    exit( 0, e);
  }//catch
  return;
}//run

}//class outputTable30
