//OUTPUTTABLEDATA30//
package tables;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import control.*;
import kbm2l.*;
import kernel.*;
import query.*;

/**
* Clase outputTableData30.
* Acceso de escritura fisica de las tablas.
* Escribe las listas en el formato de tabla convencional. Texto plano.
* Los casos solo son KB-casos.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class outputTableData30  extends  outputTable30  {

  private static final String ERROR = "Error(outputTableData30): ";

/**
* Volcado de datos o codigos.
**/
  private static boolean prefOutPutData = false;//Data/Code

/**
* Constructor por defecto.
**/
public outputTableData30( ) {
  
}//outputTableData30

/** 
* Volcado completo del item ZERO, 
* Si la lista es vacia la repuesta es no-primo(offset)==0/primo(offset)==0 y 
* la medida el (double)(offset).
* @param out fichero de salida
* @param l30 lista fuente
* @return numero de casos.
**/
public long escribeItemTableZero( BufferedWriter out, lista30 l30, long cases) {

  String linea = null; // linea del fichero que contiene una tabla

  Vector INDEX = null;

  item30 ITEM = null;
  Vector MEDIDA = null;
  Vector RESPUESTA = null;
  Vector INDICE = null;

  item30 ITEM0 = l30.Get( 0);//siempre existe el 0.
  Vector MEDIDA0 = ITEM0.GetMedida();
  Vector RESPUESTA0 = ITEM0.GetRespuesta();
  Vector INDICE0 = ITEM0.GetIndice();

  ITEM = l30.Get( 0);//un solo item.
  MEDIDA = ITEM.GetMedida();
  RESPUESTA = ITEM.GetRespuesta();
  INDICE = ITEM.GetIndice();

  Vector ULTIMO = index30.ultimoT( l30.Base.Dom());//indice ultimo

  long maxKBCases = new controlPrefs30().KBCasesLengthOVF();

  prefOutPutData = new controlPrefs30().outPutData();  // Data/Code // true/false
  
  try { 
    linea = "; ";//R HEADER
    for( int i = 0; i <l30.dimension(); i++)
      linea = linea + ((String)l30.Esqu.Atributos.get( l30.Base.indexOfbas( i))) + "\t";
    for( int i = 0; i < l30.ParRespuesta(); i++)
      linea = linea + ((String)l30.Esqu.Decisiones.get( l30.Base.indexOfbas( i))) + "\t";   
    linea = linea.trim();
    out.write( linea, 0, linea.length());
    out.newLine();
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "escribeTableZero0. " + "header:" + 0);
      try { out.close(); 
      } catch (Exception ex) { }
      exit(0, e);
    }//catch

  
  if ( !l30.esUNKB( ITEM)) 
  for( INDEX = index30.primeroT( l30.Base.Dom());
      (( index30.myT( INDICE0, INDEX) || index30.eqT( INDICE0, INDEX)));
      INDEX = index30.siguienteT( l30.Base.Dom(), INDEX)) {// in ITEM0

    if ( !prefOutPutData)
    try { 
      linea = outputItem( l30, INDEX, RESPUESTA, MEDIDA);
      out.write( linea, 0, linea.length());
      out.newLine();
      }//try
      catch (Exception e) {
        System.out.println( ERROR + "escribeTableZero0. " + "item:" + 0);
        try { out.close(); 
        } catch (Exception ex) { }
        exit(0, e);
      }//catch

    if ( prefOutPutData)
    try { 
      linea = outputData( l30, INDEX, RESPUESTA);
      out.write( linea, 0, linea.length());
      out.newLine();
      }//try
      catch (Exception e) {
        System.out.println( ERROR + "escribeTableZero0.outputData " + "item:" + 0);
        try { out.close(); 
        } catch (Exception ex) { }
        exit(0, e);
      }//catch

      cases++;
      if (cases > maxKBCases) return cases;
      kbm2lSystem.estatus(("OUTPUTS: " + cases + "  ITEMS: "+ l30.size()));

    if ( index30.eqT( ULTIMO, INDEX)) 
      break;

    }//for CERO

  return cases;
}//escribeTableZero

/**
* Volcado completo del item ONE...., 
* Si la lista es vacia la repuesta es no-primo(offset)==0/primo(offset)==0 y 
* la medida el (double)(offset).
* @param out fichero de salida
* @param l30 lista fuente
* @return numero de casos.
**/
public long escribeItemTableOne( BufferedWriter out, lista30 l30, long cases) {

  String linea = null; // linea del fichero que contiene una tabla

  Vector INDEX = null;

  item30 ITEM = null;
  Vector MEDIDA = null;
  Vector RESPUESTA = null;
  Vector INDICE = null;

  item30 ITEM0 = l30.Get( 0);//siempre existe el 0.
  Vector MEDIDA0 = ITEM0.GetMedida();
  Vector RESPUESTA0 = ITEM0.GetRespuesta();
  Vector INDICE0 = ITEM0.GetIndice();

  Vector ULTIMO = index30.ultimoT( l30.Base.Dom());//indice ultimo

  long maxKBCases = new controlPrefs30().KBCasesLengthOVF();

  prefOutPutData = new controlPrefs30().outPutData();  // Data/Code // true/false

  for( int j = 1; j < l30.size(); j++) {

    ITEM0 = l30.Get( j-1);//siempre existe.
    MEDIDA0 = ITEM0.GetMedida();
    RESPUESTA0 = ITEM0.GetRespuesta();
    INDICE0 = ITEM0.GetIndice();

    ITEM = l30.Get( j);//existe el k.
    MEDIDA = ITEM.GetMedida();
    RESPUESTA = ITEM.GetRespuesta();
    INDICE = ITEM.GetIndice();

    if ( !l30.esUNKB( ITEM)) 
    for( INDEX = index30.siguienteT( l30.Base.Dom(), INDICE0);
      (( index30.myT( INDICE, INDEX) || index30.eqT( INDICE, INDEX)));
      INDEX = index30.siguienteT( l30.Base.Dom(), INDEX)) {// in ITEM

    if ( !prefOutPutData)
      try {
        linea = outputItem( l30, INDEX, RESPUESTA, MEDIDA);
        out.write( linea, 0, linea.length());
        out.newLine();
      }//try
      catch (Exception e) {
        System.out.println( ERROR + "escribeTableOne0. " + "item:" + j);
        try { out.close(); }//try
        catch (Exception ex) { }
        exit(0, e);
      }//catch

    if ( prefOutPutData)
      try {
        linea = outputData( l30, INDEX, RESPUESTA);
        out.write( linea, 0, linea.length());
        out.newLine();
      }//try
      catch (Exception e) {
        System.out.println( ERROR + "escribeTableOne0.outputData " + "item:" + j);
        exit(0, e);
      }//catch

      casos++;
      if ( cases > maxKBCases) return cases;
      kbm2lSystem.estatus(("OUTPUTS: " + cases + "  ITEMS: "+ l30.size()));

      if ( index30.eqT( ULTIMO, INDEX)) 
        break;

    }//for k-item

  }//for RESTO k-items

  return cases;
}//escribeItemTableOne

private String outputItem( lista30 l30, Vector INDEX, Vector RESPUESTA, Vector MEDIDA) {
	
  String linea = "";
  for( int i = 0; i < l30.dimension(); i++) 
    linea = linea + ((Integer)(INDEX.get( i))).intValue() + "\t";

    BigInteger R = new offset30().offset( l30.Base.Dom(), INDEX);
    for( int i = 0; i < l30.ParRespuesta(); i++) 
      if ( l30.size() > 1) {
        linea = linea + ((Integer)(RESPUESTA.get( i))).intValue() + "\t";
        }
        else {
        if ( !R.isProbablePrime( 10)) {linea = linea + ((int)0) + "\t";}
          else {linea = linea + ((int)1) + "\t";}
        }  

    for( int i = 0; i < l30.ParMedida(); i++) 
      if (l30.size() > 1) {
        linea = linea + ((Double)(MEDIDA.get( i))).doubleValue() + "\t";
        }
        else {
          linea = linea + R.doubleValue() + "\t";
        }

  return linea.trim();
}//outputItem

}//class outputTable30
