//OUTPUTTABLEITEM30//
package tables;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import control.*;
import kbm2l.*;
import kernel.*;
import query.*;

/**
* Clase outputTableItem30.
* Acceso de escritura fisica de las tablas.
* Escribe las listas en el formato de tabla convencional. Texto plano.
* Genera los conjunto de datos para aprender la redes bayesianas, proyectamos Y-vector.
* Los casos solo son KB-casos.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class outputTableItem30  extends  outputTable30  {

  private static final String ERROR = "Error(outputTableItem30): ";

/**
* Constructor por defecto.
**/
public outputTableItem30( ) {
  
}//outputTableItem30

/** 
* Volcado de la seleccion del item ZERO, no unKB
* @param out fichero de salida
* @param l30 lista fuente
* @param filter mascara
* @param cases contador de casos
* @return numero de casos.
**/
public long escribeItemTableZero( BufferedWriter out, lista30 l30, 
  maskTable30 filter, long cases) {

  String linea = null; // linea del fichero que contiene una tabla

  Vector INDEX = null;

  item30 ITEM = null;
  Vector MEDIDA = null;
  Vector RESPUESTA = null;
  Vector INDICE = null;

  item30 ITEM0 = l30.Get( 0);//siempre existe el 0.
  Vector MEDIDA0 = ITEM0.GetMedida();
  Vector RESPUESTA0 = ITEM0.GetRespuesta();
  Vector INDICE0 = ITEM0.GetIndice();

  ITEM = l30.Get( 0);//un solo item.
  MEDIDA = ITEM.GetMedida();
  RESPUESTA = ITEM.GetRespuesta();
  INDICE = ITEM.GetIndice();

  if ( index30.eqS( RESPUESTA, l30.UNKB ))
    return cases;

  boolean nl = false;
  
  for( INDEX = index30.primeroT( l30.Base.Dom());
      (( index30.myT( INDICE0, INDEX) || index30.eqT( INDICE0, INDEX)));
      INDEX = index30.siguienteT( l30.Base.Dom(), INDEX)) {// in ITEM0
   
    if ( cases >= consultaGeneral30.dataSetSize) break;

    try { nl = false;
    linea = "";//
    if ( filter.selMaskt( INDEX)) {
      for( int i = 0; i < l30.dimension(); i++) 
        if ( filter.prjMaskt( i))
          linea = linea + ((Integer)(INDEX.get( i))).intValue() + " ";
          
    if ( filter.selMasks( RESPUESTA)) 
      for( int i = 0; i < l30.ParRespuesta(); i++) 
        if ( filter.prjMasks( i))
          linea = linea + ((Integer)(RESPUESTA.get( i))).intValue() + " ";

    if ( filter.selMaskr( MEDIDA)) 
      for( int i = 0; i < l30.ParMedida(); i++) 
        if ( filter.prjMaskr( i))
          linea = linea + ((Double)(MEDIDA.get( i))).doubleValue() + " ";

          nl = true;
          }

    if ( filter.wend) linea = linea + ";";

      }//try
      catch (Exception e) {
        System.out.println( ERROR + "escribeTableZero0. " + "Lines:" + casos);
        try { out.close(); }//try
        catch (Exception ex) { }
          exit(0, e);
      }//catch

    if (nl)
    try {
      out.write( linea, 0, linea.length());
      out.newLine();
      cases++;
      kbm2lSystem.estatus(("OUTPUTS: " + cases + "  ITEMS: "+ l30.size()));
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "escribeTableZero. " + "Lines:" + cases);
      exit(0, e);
    }//catch

//    if (!working) break;
    }//for CERO

  return cases;
}//escribeTableZero

/**
*
**/
public long escribeItemTableOne( BufferedWriter out, lista30 l30, 
  maskTable30 filter, long cases) {

  String linea = null; // linea del fichero que contiene una tabla

  Vector INDEX = null;

  item30 ITEM = null;
  Vector MEDIDA = null;
  Vector RESPUESTA = null;
  Vector INDICE = null;

  item30 ITEM0 = l30.Get( 0);// siempre existe el 0.
  Vector MEDIDA0 = ITEM0.GetMedida();
  Vector RESPUESTA0 = ITEM0.GetRespuesta();
  Vector INDICE0 = ITEM0.GetIndice();

  Vector ULTIMO = index30.ultimoT( l30.Base.Dom());// indice primero

  for( int j = 1; j < l30.size(); j++) {

    ITEM0 = l30.Get( j-1);//siempre existe.
    MEDIDA0 = ITEM0.GetMedida();
    RESPUESTA0 = ITEM0.GetRespuesta();
    INDICE0 = ITEM0.GetIndice();

    ITEM = l30.Get( j);//existe el k.
    MEDIDA = ITEM.GetMedida();
    RESPUESTA = ITEM.GetRespuesta();
    INDICE = ITEM.GetIndice();

    if ( !index30.eqS( RESPUESTA, l30.UNKB )) {

    boolean nl = false;

    for( INDEX = index30.siguienteT( l30.Base.Dom(), INDICE0);
      (( index30.myT( INDICE, INDEX) || index30.eqT( INDICE, INDEX)));
      INDEX = index30.siguienteT( l30.Base.Dom(), INDEX)) {// in ITEM

      if ( cases >= consultaGeneral30.dataSetSize) break;

      try { nl = false;
      linea = "";//
      if ( filter.selMaskt( INDEX)) {
        for( int i = 0; i < l30.dimension(); i++) 
          if ( filter.prjMaskt( i))
            linea = linea + ((Integer)(INDEX.get( i))).intValue() + " ";

      if ( filter.selMasks( RESPUESTA)) 
        for( int i = 0; i < l30.ParRespuesta(); i++) 
          if ( filter.prjMasks( i))
            linea = linea + ((Integer)(RESPUESTA.get( i))).intValue() + " ";

      if ( filter.selMaskr( MEDIDA)) 
        for( int i = 0; i < l30.ParMedida(); i++) 
          if ( filter.prjMaskr( i))
            linea = linea + ((Double)(MEDIDA.get( i))).doubleValue() + " ";

            nl = true;
            }

      if ( filter.wend) linea = linea + ";";

      }//try
      catch (Exception e) {
        System.out.println( ERROR + "escribeTableOne0. " + "Lines:" + casos);
        try { out.close(); }//try
        catch (Exception ex) { }
          exit(0, e);
      }//catch

      if ( nl)
      try {
        out.write( linea, 0, linea.length());
        out.newLine();
        cases++;
        kbm2lSystem.estatus(("OUTPUTS: " + cases + "  ITEMS: "+ l30.size()));
      }//try
      catch (Exception e) {
        System.out.println( ERROR + "escribeTableOne0. " + "Lines:" + cases);
        exit(0, e);
      }//catch

      if ( index30.eqT( ULTIMO, INDEX)) 
        break;
//    if (!working) break;
    }//for k-item

//    if (!working) break;
    }//!UNKB

    if ( cases >= consultaGeneral30.dataSetSize) break;

  }//for RESTO k-items

  return cases;
}//escribeItemTableOne

////////////
////////////
// completo o sin filtro.
////////////
////////////

/** 
* Volcado completo del item ZERO, 
* Si la lista es vacia la repuesta es no-primo(offset)==0/primo(offset)==0 y 
* la medida el (double)(offset).
* @param out fichero de salida
* @param l30 lista fuente
* @return numero de casos.
**/
public long escribeItemTableZero( BufferedWriter out, lista30 l30, long cases) {

  String linea = null; // linea del fichero que contiene una tabla

  Vector INDEX = null;

  item30 ITEM = null;
  Vector MEDIDA = null;
  Vector RESPUESTA = null;
  Vector INDICE = null;

  item30 ITEM0 = l30.Get( 0);//siempre existe el 0.
  Vector MEDIDA0 = ITEM0.GetMedida();
  Vector RESPUESTA0 = ITEM0.GetRespuesta();
  Vector INDICE0 = ITEM0.GetIndice();

  ITEM = l30.Get( 0);//un solo item.
  MEDIDA = ITEM.GetMedida();
  RESPUESTA = ITEM.GetRespuesta();
  INDICE = ITEM.GetIndice();

  Vector ULTIMO = index30.ultimoT( l30.Base.Dom());//indice ultimo

  long maxKBCases = new controlPrefs30().KBCasesLengthOVF();
  
  for( INDEX = index30.primeroT( l30.Base.Dom());
      (( index30.myT( INDICE0, INDEX) || index30.eqT( INDICE0, INDEX)));
      INDEX = index30.siguienteT( l30.Base.Dom(), INDEX)) {// in ITEM0
   
    try { 
      linea = outputItem( l30, INDEX, RESPUESTA, MEDIDA);
      out.write( linea, 0, linea.length());
      out.newLine();
      }//try
      catch (Exception e) {
        System.out.println( ERROR + "escribeTableZero0. " + "item:" + 0);
        try { out.close(); 
        } catch (Exception ex) { }
        exit(0, e);
      }//catch

    try { 
      linea = outputRemark( l30, INDICE, RESPUESTA);
//      linea = outputRemark( l30, INDEX, RESPUESTA);
      out.write( linea, 0, linea.length());
      out.newLine();
      }//try
      catch (Exception e) {
        System.out.println( ERROR + "escribeTableZero0.outputRemark " + "item:" + 0);
        try { out.close(); 
        } catch (Exception ex) { }
        exit(0, e);
      }//catch

      cases++;
      if (cases > maxKBCases) return cases;
      kbm2lSystem.estatus(("OUTPUTS: " + cases + "  ITEMS: "+ l30.size()));

    if ( index30.eqT( ULTIMO, INDEX)) 
      break;

    }//for CERO

  return cases;
}//escribeTableZero

/**
* Volcado completo del item ONE...., 
* Si la lista es vacia la repuesta es no-primo(offset)==0/primo(offset)==0 y 
* la medida el (double)(offset).
* @param out fichero de salida
* @param l30 lista fuente
* @return numero de casos.
**/
public long escribeItemTableOne( BufferedWriter out, lista30 l30, long cases) {

  String linea = null; // linea del fichero que contiene una tabla

  Vector INDEX = null;

  item30 ITEM = null;
  Vector MEDIDA = null;
  Vector RESPUESTA = null;
  Vector INDICE = null;

  item30 ITEM0 = l30.Get( 0);//siempre existe el 0.
  Vector MEDIDA0 = ITEM0.GetMedida();
  Vector RESPUESTA0 = ITEM0.GetRespuesta();
  Vector INDICE0 = ITEM0.GetIndice();

  Vector ULTIMO = index30.ultimoT( l30.Base.Dom());//indice ultimo

  long maxKBCases = new controlPrefs30().KBCasesLengthOVF();

  for( int j = 1; j < l30.size(); j++) {

    ITEM0 = l30.Get( j-1);//siempre existe.
    MEDIDA0 = ITEM0.GetMedida();
    RESPUESTA0 = ITEM0.GetRespuesta();
    INDICE0 = ITEM0.GetIndice();

    ITEM = l30.Get( j);//existe el k.
    MEDIDA = ITEM.GetMedida();
    RESPUESTA = ITEM.GetRespuesta();
    INDICE = ITEM.GetIndice();

    for( INDEX = index30.siguienteT( l30.Base.Dom(), INDICE0);
      (( index30.myT( INDICE, INDEX) || index30.eqT( INDICE, INDEX)));
      INDEX = index30.siguienteT( l30.Base.Dom(), INDEX)) {// in ITEM

      try {
        linea = outputItem( l30, INDEX, RESPUESTA, MEDIDA);
        out.write( linea, 0, linea.length());
        out.newLine();
      }//try
      catch (Exception e) {
        System.out.println( ERROR + "escribeTableOne0. " + "item:" + j);
        try { out.close(); }//try
        catch (Exception ex) { }
        exit(0, e);
      }//catch

      try {
        linea = outputRemark( l30, INDICE, RESPUESTA);
//        linea = outputRemark( l30, INDEX, RESPUESTA);
        out.write( linea, 0, linea.length());
        out.newLine();
      }//try
      catch (Exception e) {
        System.out.println( ERROR + "escribeTableOne0.outputRemark " + "item:" + j);
        exit(0, e);
      }//catch

      casos++;
      if ( cases > maxKBCases) return cases;
      kbm2lSystem.estatus(("OUTPUTS: " + cases + "  ITEMS: "+ l30.size()));

      if ( index30.eqT( ULTIMO, INDEX)) 
        break;

    }//for k-item

  }//for RESTO k-items

  return cases;
}//escribeItemTableOne

private String outputItem( lista30 l30, Vector INDEX, Vector RESPUESTA, Vector MEDIDA) {
	
  String linea = "";
  for( int i = 0; i < l30.dimension(); i++) 
    linea = linea + ((Integer)(INDEX.get( i))).intValue() + " ";

    BigInteger R = new offset30().offset( l30.Base.Dom(), INDEX);
    for( int i = 0; i < l30.ParRespuesta(); i++) 
      if ( l30.size() > 1) {
        linea = linea + ((Integer)(RESPUESTA.get( i))).intValue() + " ";
        }
        else {
        if ( !R.isProbablePrime( 10)) {linea = linea + ((int)0) + " ";}
          else {linea = linea + ((int)1) + " ";}
        }  

    for( int i = 0; i < l30.ParMedida(); i++) 
      if (l30.size() > 1) {
        linea = linea + ((Double)(MEDIDA.get( i))).doubleValue() + " ";
        }
        else {
          linea = linea + R.doubleValue() + " ";
        }

  return linea;
}//outputItem

}//class outputTable30
