//protocolo30//
package tables;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import control.*;
import kernel.*;
import kbm2l.*;
import target.*;

/**
* Clase protocolo30, ipd, itd, tdu, 
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class protocolo30  extends  tabla30  {

  private static final String ERROR = "Error(protocolo30): ";

/*
* Si una lista tiene mas items se trata de sintetizar.
*/
  private static long maxitems = 0;// 
/*
* Nombre del protocolo, listas
*/  
  public String name = null;//
/*
* Listas kbm2l - decisiones
*/  
  public Vector decisiones = null;//

/**
* Constructor por defecto
**/  
public protocolo30( ) {

  this.maxitems = 100;//sintesis
  name = "";
  decisiones = new Vector();
//  System.out.println( "protocolo30a");
}//protocolo30

/**
* Constructor para un protocolo 
* @param Protocol nombre de la descripcion de un protocolo de decisiones.
**/  
public protocolo30( String Protocol) {

  this.maxitems = 100;//sintesis
  name = new String( Protocol);
  decisiones = new Vector();
//  System.out.println( "protocolo30b");
}//protocolo30

/*
* La decision (i) del protocolo
*/
public lista30 get( int i) {

  try {
    if (( i < decisiones.size()) && ( i >= 0))
      return ((lista30)decisiones.get( i));//
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "get. " + i + ".\n");
    exit( 0, e);
  }//catch
  return null;
}//get

/*
* La decision (i) del protocolo
*/
public void set( int i, lista30 l30) {

  try {
    if (( i < decisiones.size()) && ( i >= 0))
      decisiones.set( i, l30);//
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "set. " + i + ".\n");
    exit( 0, e);
  }//catch
  return;
}//set

/*
* Aade una lista al protocolo
*/
public void add( lista30 aux) {

  try {
    decisiones.add( aux);
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "add. " + aux.Name() + ".\n");
    exit( 0, e);
  }//catch
  return;
}//add

/*
* Tamao del protocolo, numero de tablas-listas-decisiones
*/
public int size( ) {

  try {
    return decisiones.size( );
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "size. " + name + ".\n");
    exit( 0, e);
  }//catch
  return -1;
}//size

/**
* Lectura de la descripcion del protocolo de decisiones: ipd - indice de protocolo de decisiones.
* Si no existen las listas busca instancias de las tablas de decisiones optimas y construye las kbm2l.
* Si existen las listas kbm2l de las decisiones busca instancias de las tablas de decisiones optimas 
* compone la lista el protocolo aadiendo las instancias.
*; ipd -> itd -> tdu
*; indice de protocolo de decisiones
*; indice de tablas de decisiones
*; instancia de tabla de decisiones optimas
* ===> p30: vector de kbm2l de las tablas de decisiones optimas y kbm2l del protocolo.
* @param fileIPD nombre del fichero de descripcion de protocolo con las decisiones en orden cronologico.
* @return p30 un vector de listas kbm2l, una de cada tabla de decision y la lista agregada.
**/
public protocolo30 protocolo( String fileIPD) {

  Vector ipd = ipdAccess( fileIPD);//fileIPD, DimParam, PARAMS, Decs...   
  if ( ipd == null) {
    kbm2lSystem.append( "Protocol is not reading: " + fileIPD + ".\n");
    return null;
    }
  fileIPD = (String)ipd.get(0);
  name = new String( dato30.nameFile( fileIPD));
  decisiones = new Vector();
  kbm2lControl.setText( kbm2lControl.WorkSpace, dato30.workspace);
  kbm2lControl.setText( kbm2lControl.ProtocolName, name);
  kbm2lSystem.append( "\nProtocol is reading: " + fileIPD + ".\n");

//    
  try {//
  int d = 3;//0 fileIPD, 1 DimParam, 2 PARAMS, 3 Decs .....
  while ( d < ipd.size()) {// mientras haya tablas en el indice
    
    lista30 l30 = null;
    String decision = dato30.workspace + dato30.extFile( (String)ipd.get( d), "kbm") ;
    //intenta leer una kbm2l.
    l30 = new inputTable30().leerTabla( null, decision );
    kbm2lSystem.append( "protocolo: " + decision + ".\n");

    try {//
      if ( l30 != null) {// hay kbm2l.
        try {//
        l30.dimparam = ((Integer)(ipd.get(1))).intValue();
        if ( l30.dimparam > 0) {
          l30.PARAMS = (Vector)(ipd.get(2));
          new controlPrefs30().protocolType( "Table");
         } else new controlPrefs30().protocolType( "List");  
        l30 = new listUnion30().union_rl( l30, TablaDecision( dato30.extFile( decision, ""), l30.dimparam));//tdu + opt
        this.add( l30);
        new outputList30( ).escribeKBM2L( l30, dato30.extFile( decision, "hkb"));
        }//try
        catch (Exception e) {
          kbm2lSystem.append( ERROR + "protocol.if.then. " + ipd.toString() + ".\n");
          exit( 0, e);
        }//catch
        }
        else {//no hay kbm2l.
        //lee varias instancias de la tabla y las une en una kbm2l.
        try {//                        l30.dimparam
        new controlPrefs30().protocolType( "Table");
        l30 = TablaDecision( dato30.extFile( decision, ""), ((Integer)(ipd.get(1))).intValue());
        if ( l30 != null) {
          l30.dimparam = ((Integer)(ipd.get(1))).intValue();
          if ( l30.dimparam > 0)
            l30.PARAMS = (Vector)(ipd.get(2));
          this.add( l30);
          new outputList30( ).escribeKBM2L( l30, dato30.extFile( decision, "hkb"));
          }
          else {
            kbm2lSystem.append( ERROR + "protocol: " + fileIPD + ".\n");
            kbm2lSystem.append( "Table not found. :?" + decision + ".\n");
//            return null;
          }
        }//try
        catch (Exception e) {
          kbm2lSystem.append( ERROR + "protocol.if.else. " + ipd.toString() + ".\n");
          exit( 0, e);
        }//catch
        }
      }//try
      catch (Exception e) {
        kbm2lSystem.append( ERROR + "protocol.if. " + ipd.toString() + ".\n");
        exit( 0, e);
      }//catch
        d++;
  }//while
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "protocol.while. " + ipd.toString() + ".\n");
    exit( 0, e);
  }//catch

  return endProtocolo( fileIPD);
}//protocolo

/**
* Fin protocolo. 
**/
private protocolo30 endProtocolo( String fileIPD) {

  kbm2lSystem.frame.setTitle( 
    kbm2lSystem.frame.getTitle().substring( 0, 
      kbm2lSystem.frame.getTitle().indexOf('-')-1) + " - " + fileIPD);

  activel30 = this.get( 0);//la primera decision del protocolo

  kbm2lSystem.append( "\nProtocol readed: " + fileIPD + ".\n");

  kbm2lControl.setText( kbm2lControl.ListName, activel30.Name());
  kbm2lControl.setText( kbm2lControl.ListSize, String.valueOf( activel30.size()));
  kbm2lControl.setText( kbm2lControl.ListSchema, "");
 
  try {  
  lista30 xl30 = Protocolo( fileIPD);
  if ( xl30 != null) {
//    this.add( xl30);
    new outputList30( ).escribeKBM2L( xl30, dato30.workspace + dato30.extFile( dato30.nameFile( fileIPD), "hkb"));
    }
    else {
      kbm2lSystem.append( ERROR + "endProtocol: " + fileIPD + ".\n");
//        return null;
    }
    }//try    
    catch (Exception e) {
      kbm2lSystem.append( ERROR + "endProtocol(). xl30\n");
      exit( 0, e);
    }//catch

  kbm2lSystem.estatus( "endProtocol succesfull.");

  return this;
}//endProtocolo

/**
* join de las listas del protocolo en una lista.
* p30 tiene las listas en orden cronologico.
* Escribe todas las listas parciales del protocolo y la lista final.
**/
private lista30 Protocolo( String fileIPD) {

  if ( this.size() == 0) return null;
  if ( this.size() == 1) return ((lista30) this.get( 0));

  kbm2lSystem.append( "Protocolo::\n");
  for( int i = 0; i < this.size(); i++)
    kbm2lSystem.append( "List: " + i + "  " + ((lista30) this.get( i)).Name()+"\n");

  lista30 join = null;
  Vector partialProtocols = new Vector();
  try {
  lista30 prev = ((lista30) this.get( 0));
  new outputList30( ).escribeKBM2L( prev,
    dato30.workspace + dato30.extFile( dato30.nameFile( fileIPD+"("+0+")"), "hkb"));//no filedlg
  for( int i = 1; i < this.size(); i++) {
    lista30 l30 = new lista30( ((lista30) this.get( i)), ((lista30) this.get( i)));//copia contenido
    join = new join30().join( prev, l30);//!!!
    listStat30.KB( join);
    join.Name( fileIPD+"("+i+")");
    partialProtocols.add( join);
//  listStat30.importanceAtt( join);//
    new outputList30( ).escribeKBM2L( join,
      dato30.workspace + dato30.extFile( dato30.nameFile( fileIPD+"("+i+")"), "hkb"));//no filedlg
    prev = new lista30( join, join);//copia contenido
    }//for-i
    }//try    
    catch (Exception e) {
      System.out.println( ERROR + "protocol(). join");
      exit( 0, e);
    }//catch

  for( int i = 0; i < partialProtocols.size(); i++) {
	 this.add( ((lista30) partialProtocols.get( i))); 
    }
  
  return join;//att's -> dec's
}//Protocolo

/**
* Union de las listas de los protocolos, son compatibles
**/
public protocolo30 union( protocolo30 p30, protocolo30 q30) {
	
  try {
  for( int i = 0; i < p30.size(); i++) {
	 lista30 l30 = p30.get( i);
	 lista30 m30 = q30.get( i);
    p30.set(i, new listUnion30().union_rl( l30, m30)); 
	 }//for-i
  }//try    
    catch (Exception e) {
      System.out.println( ERROR + "union.");
      exit( 0, e);
    }//catch
	
  return p30;	
}//union

/**
* Run().
**/
public void run() {
//lectura del protocolo-tablas-instancias concurrente.

  try {
    long ts0 = (new Date()).getTime();
    protocolo30 bkp30 = protocolo( name);//filedlg si name es ""
    if ( bkp30 != null)
      f30.p30 = bkp30;
    frame30.kbm2lTime.append("protocolo:: " + (new Date().getTime() - ts0) + ".\n");      
  }//try    
    catch (Exception e) {
      System.out.println( ERROR + "run().");
      exit( 0, e);
    }//catch
  return;
}//run

}//class protocolo30
