//tabla30//
package tables;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import control.*;
import kbm2l.*;
import kernel.*;
import schema.*;
import synthesis.*;

/**
* Clase tabla30.
* Acceso de lectura y escritura fisica de las tablas/listas.
* Escribe las listas en el formato de KBM2L y de tabla convencional. Texto plano.
* Construye los items y los aade a la lista.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  tabla30  extends  frame30  {

  private static final String ERROR = "Error(tabla30): ";

/**
* 't' is .TXT-table, '' is .DAT-data'm' is .KBM-list
**/
  public static char FlagSet = '.';//'t' is .TXT-table, 'd' is .DAT-data, 'm' is .KBM-list.
  
  protected Vector Ix = null;
  protected String fileTable = null;

/**
* Constructor por defecto.
**/
public tabla30( ) {

  Ix = null; 
  FlagSet = '.';
}//tabla30

/**
* Constructor por defecto.
* @param fileTab nombre del fichero de la tabla de decision.
**/
public tabla30( String fileTab) {

  Ix = null; 
  FlagSet = '.';
  fileTable = new String( fileTab);
}//tabla30

/**
* Leee el esquema, 
* escribe la cabecera y 
* procesa las instancias de las tdu
* leyendo las tablas asociadas.
* @param pathTabla tdu, se concatena la codificacin de las intancias.
* @param p int numero de parametros en el esquema, no se optimizan.
* @return la lista de la tabla.
**/
protected lista30 TablaDecision( String pathTabla, int p) {
//; ipd -> itd -> tdu/kbm
//; indice de protocolo de decisiones
//; indice de tablas de decisiones
//; instancia de tabla de decision
// ===> p30
  boolean pType = new controlPrefs30().protocolType();//  Table/List
  boolean optModRef = new controlPrefs30().optimizeReferenceModel(); //la primera instancia
  long INST = new controlPrefs30().instancesOVF( );//
  if (INST <= 0) INST = 100000;
  boolean chk = new controlPrefs30().checkMode();
  
//El esquema se lee asociado a la tabla: nombre.eq
//La lista se crea con el esquema asociado 
  kbm2lSystem.append("Access schema of decision table: " + pathTabla + ".\n");
  esquema30 eq30 = new esquema30( "TablaDecision" , 0, 0).leerEq( dato30.extFile( pathTabla, "eq"));
  lista30 auxl30 = new lista30( eq30);//std-ini

//La cabecera y a disco  
  kbm2lSystem.append("Output header of kbm2l: " + pathTabla + ".\n");
  outputEsquemaCabecera30 oec30 = 
    new outputEsquemaCabecera30( ).escribeCabecera( auxl30.Esqu, dato30.extFile( pathTabla, "hkb"), "kbm"); 

  kbm2lSystem.append("Access decision table: " + pathTabla + ".\n");

//La descripcion de las instancias. Codificacin en la base cannica del esquema.
  kbm2lSystem.append("Access instances of decision table: " + pathTabla + ".\n");
  String linea = null; // linea del fichero
  BufferedReader in = dato30.openFile( pathTabla, "itd"); // Tabla de decisiones itd
  if ( in == null) {
    kbm2lSystem.append( "tabla30 TablaDecision itd?  \n");
    return null;    
   }

  try {//
//; las instancias de la tabla Decision(i) 
  while (( linea = in.readLine()) != null) { // 
    linea = linea.trim();
    if ( !linea.equals("")) if ( !linea.equals("\n"))
    if ( linea.charAt( 0) != ';') {// no es comentario

  //composicion del nombre del fichero fuente tdu/kbm.
    Vector inst = instanciaTabla( auxl30.Esqu, linea);// x y z
    String strInst = dato30.toString( inst, "", "");// xyz

      String tabla = null;
      lista30 l30inst = null;
  try {//
      if ( pType) {
        tabla = new String( dato30.nameFile( pathTabla) + "-" + strInst + ".tdu");// - tabla
        }
        else { tabla = new String( dato30.nameFile( pathTabla) + ".kbm"); }// - lista        

      tabla = dato30.workspace + tabla;          
      if ( chk) kbm2lSystem.append( "instance: " + tabla + ".\n");

      if ( pType) {
        l30inst = new utilidad30( ).Tabla( eq30, tabla, inst);//Table tdu
        }
        else { 
	        l30inst = new inputTable30().leerTabla( eq30, tabla); 
	        }//List kbm                  
          
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "TablaDecision.  table: " + tabla + "  Line: " + linea + "\n");
    exit( 0, e);
  }//catch

      if ( l30inst != null) {

      if ( pType) {
        if ( chk) kbm2lSystem.append( "Table instance: " + tabla + "  l30inst: " + l30inst.size() + ".\n");
        }
        else { 
           if ( chk) kbm2lSystem.append( "List instance: " + tabla + "  l30inst: " + l30inst.size() + ".\n");
	        }//List kbm                  

        auxl30 = new listUnion30().union_rl( auxl30, l30inst); //INST++; 
        f30.activel30 = auxl30;//env
        if ( optModRef) {//la primera instancia es el modelo de referencia que es el que se optimiza
          //los parametros a la izq, solo optimizamos las variables
          new controlPrefs30().onTopAttribute( p+1);
          new controlPrefs30().onBotAttribute( auxl30.dimension()-1);
          kbm2lSystem.append( "InstanceTableUnion dynamic synthesis 1 - KBM2L:\n" +
            auxl30.Base.Bas() + " Items - " + auxl30.size() + "\n");         
          auxl30 = new sintesisHamming230( auxl30).Hamming2( auxl30);
          kbm2lSystem.append( "InstanceTableUnion dynamic syntehsis 2 - KBM2L:\n" +
            auxl30.Base.Bas() + " Items - " + auxl30.size() + "\n");
          optModRef = false;  //el resto de instancias no se optimiza
          }
        f30.activel30 = auxl30;//env
        if (( INST % 20) == 0) {
          checkList30.chk( auxl30, ERROR + "TablaDecision-2");//!!!
          new outputList30( ).escribeKBM2L( auxl30, dato30.extFile( pathTabla, "hkb"));
          kbm2lControl.setText( kbm2lControl.ListName, auxl30.Name());
          kbm2lControl.setText( kbm2lControl.ListSize, String.valueOf( auxl30.size()));
          }//if
        f30.activel30 = auxl30;//env
        }
        else {
          kbm2lSystem.append( ERROR + "TablaDecision.  ");
          kbm2lSystem.append( "No List. :?" + tabla + ".\n");
        }
      
      if (INST-- <= 0) break;//while

    }//if - comentario en la instancia  
  }//while
  in.close(); 
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "TablaDecision.  File: " + pathTabla + "  Line: " + linea);
    frame30.exit( 0, e);
  }//catch

  checkList30.chk( auxl30, ERROR + "TablaDecision-3");//!!!

  new outputList30( ).escribeKBM2L( auxl30, dato30.extFile( pathTabla, "hkb"));

  kbm2lControl.setText( kbm2lControl.ListName, auxl30.Name());   
  kbm2lControl.setText( kbm2lControl.ListSize, String.valueOf( auxl30.size()));

  kbm2lSystem.append( "\nTablaDecision readed: " + pathTabla + 
    ".  Instances: " + (100000-INST) + ".\n");

  return auxl30;//union de las instancias -> tabla completa
}//TablaDecision

/**
* Lee la descripcion de la instancia del esquema para leer la tabla de utilidad
* instanciada con un indice fijo en los atributos instanciados
* @param eq30 esquema de la tabla/instancia
* @param linea linea del fichero con la instancia *.itd
* @return Index el Vector de valores que instancias atributos del esquema eq30
**/
protected Vector instanciaTabla( esquema30 eq30, String linea) {

  Vector Index = null;// Integer - valores de instancias
  int inst = 0;//ordinal del dominio del atributo instanciado.

//LEEMOS UNA INST	
  Index = new Vector();
  for( int i = 0; i < eq30.numAtributos; i++)
    Index.add( new Integer( -1));//sin instancias

  try {//
    linea = new String( linea.trim());
    linea = linea.substring( 0, linea.indexOf(';')+1); // con ; !!
    kbm2lBrowser.append( "TableInst: " + linea + "\n");      
    for( int i = 0; i < eq30.numAtributos; i++) {
      linea = linea.trim();
      if ( linea.charAt( 0) == ';') break;
      Index.set( i, new Integer( (int)( dato30.param( linea))));
      linea = new String( dato30.nextParam( linea, ' '));//inst-value
      }//for
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "instanciaTabla.0"+ "\n");
    kbm2lSystem.append( "Linea: " + linea+ ".\n");
    frame30.exit( 0, e);
  }//catch

  kbm2lBrowser.append( "TableInst: " + Index.toString() + "\n");      
  return Index;
}//instanciaTabla

/**
* Acceso al indice de protocolo de decisiones.
* ipd: fileIPD, DimParam, PARAMS, Decs....
**/
public static Vector ipdAccess( String fileIPD) {

  Vector ipd = new Vector();//dimparam,PARAMS,lista de decisiones
  int dp = -1;
  BufferedReader in = null; // protocolo de decisiones
  String linea = null; // linea del fichero

  if ( fileIPD != "") 
    kbm2lSystem.append( "\nProtocol. Index: - " + fileIPD + ".\n");

  try {//
  if ( fileIPD == "") { 
    kbm2lSystem.append( "Protocol. Select Index: *.ipd  - " + fileIPD + ".\n");
    String filename = dato30.selectFile( f30.kbm2lSystem.frame, FileDialog.LOAD, "*.ipd");
    if ( filename == null) {
      kbm2lSystem.append("Potocolo Index no readed.\n");
      return null;
      }
    fileIPD = new String( filename);
    kbm2lSystem.append( "Protocol. Index: - " + fileIPD + ".\n");
    }
  if (( fileIPD == "")||( fileIPD == null)) {
    kbm2lSystem.append("Potocolo Index no readed.\n");
    return null;
    } 

  ipd.add( dato30.extFile( fileIPD, ""));//ipd.get(0)
  in = dato30.openFile( dato30.nameFile( fileIPD), "ipd");

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "ipdAccess.0 " + fileIPD + ".");
    frame30.exit( 0, e);
  }//catch

//    
  try {//

  while (( linea = in.readLine()) != null) {
    linea = new String( linea.trim());
    if ( linea.charAt( 0) == ';') {//es comentario
      if ( new controlPrefs30().verboseSystem()) {
        kbm2lSystem.append( "remark:   " + linea + ".\n");
        }//if
      }//if  
      else {
        linea = linea.substring( linea.indexOf(':')+1,linea.indexOf(';')).trim();//DimParam: 4 ; 0,1,2,3,4
        Integer DimParam = new Integer( linea.trim());
        dp = DimParam.intValue();
        ipd.add( DimParam);//ipd.get(1)
        kbm2lSystem.append( "DimParam: " + dp + ".\n");
        break;//!!!
        }//if
    }//while

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "ipdAccess.1 " + linea + ".");
    frame30.exit( 0, e);
  }//catch
  
  try {//
  if ( dp >= 0)
  while (( linea = in.readLine()) != null) {
    linea = new String( linea.trim());
    if ( linea.charAt( 0) == ';') {//es comentario
      if ( new controlPrefs30().verboseSystem()) {
        kbm2lSystem.append( "remark:   " + linea + ".\n");
        }//if
      }//if  
      else {
        linea = linea.substring( linea.indexOf(':')+1,linea.indexOf(';')).trim();//  PARAMS: 7 7 7 7 7 ;
        Vector PARAMS = new Vector();
        for( int i = 0; i <= dp; i++) {
          if ( linea.indexOf(' ') != -1) 
          PARAMS.add( new Integer( linea.substring( 0, linea.indexOf(' ')).trim()));
            else PARAMS.add( new Integer( linea.substring( 0, linea.length()).trim()));
          linea = linea.substring( linea.indexOf(' ')+1, linea.length()).trim();      
          linea = new String( linea.trim());
          }//for
        ipd.add( PARAMS);////ipd.get(1)
        kbm2lSystem.append( "PARAMS: " + PARAMS.toString() + ".\n");
        break;
        }//if
    }//while

  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "ipdAccess.2 " + linea + ".\n");
    frame30.exit( 0, e);
  }//catch

  try {//
    
  while (( linea = in.readLine()) != null) {
    linea = new String( linea.trim());
    if ( linea.charAt( 0) != ';') {//no es comentario
    
      if ( new controlPrefs30().verboseSystem())
        kbm2lSystem.append( "Table:   " + linea);
        else kbm2lSystem.estatus( "Table:   " + linea);
        
      linea = linea.substring( 0, linea.indexOf(';'));  
      String decision = new String( linea.trim());
      ipd.add( new String( linea.trim()));//Decs, ipd.get(2,3,4,...)
      kbm2lSystem.append( "ipdAccess: " + linea + ".\n");

      }//if - comentario en el protocolo
      else {
        if ( new controlPrefs30().verboseSystem()) {
          kbm2lSystem.append( "remark:   " + linea + ".\n");
          }
        }  
  }//while
  in.close(); 

  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "ipdAccess.3 " + linea + ".\n");
    frame30.exit( 0, e);
  }//catch

  return ipd;
}//ipdAccess

/**
* Crea un comentario de los items en una cadena de texto intercalado en el fichero kbm, el fichero es legible(?).
* @param l30 lista30
* @param INDEX Vector indice del item
* @param RESPUESTA Vector respuesta del item
* @return linea String comentario de texto de un item
**/
protected String outputRemark( lista30 l30, Vector INDEX, Vector RESPUESTA) {
	
  String linea = new String("; [");
  int i = -1, k = -1, v = -1;

  try {//
    for( i = 0; i < l30.dimension(); i++) {
      k = l30.Base.indexOfbas( i);      
	   v = ((Integer)(INDEX.get( k))).intValue();
      linea = linea + ((String)((Vector)l30.Esqu.ValoresAtributos.get( i)).get( v)) + "-("+ k + ")" + " ";
      }//for-i
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "outputRemark-1 " + linea + ". i: " + i + ".\n");
    kbm2lSystem.append( "INDEX. " + INDEX.toString() + " k: " + k + " v: " + v + ".\n");
    kbm2lSystem.append( "" + ((String)((Vector)l30.Esqu.ValoresAtributos.get( i)).get( v)) + ".\n");
    frame30.exit( 0, e);
  }//catch
       
  linea = linea + "] :: (";    

  try {//
    for( i = 0; i < l30.ParRespuesta(); i++) {
	   v = ((Integer)(RESPUESTA.get( i))).intValue(); 
	   if (( v >= 0) && ( v < ((Vector)l30.Esqu.ValoresDecisiones.get( i)).size()))
        linea = linea + ((String)((Vector)l30.Esqu.ValoresDecisiones.get( i)).get( v)) + " ";
        else linea = linea + l30.unKB; 
      }
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "outputRemark-2 " + linea + ". i: " + i + ".\n");
    kbm2lSystem.append( "RESPUESTA. " + RESPUESTA.toString() + " k: " + k + " v: " + v + ".\n");
    kbm2lSystem.append( "" + ((String)((Vector)l30.Esqu.ValoresDecisiones.get( i)).get( v)) + ".\n");
    frame30.exit( 0, e);
  }//catch

  linea = linea + ")|";

  return linea.trim();	
}//outputRemark

/**
* Datos con valores del esquema
* @param l30 lista30
* @param INDEX Vector indice del item
* @param RESPUESTA Vector respuesta del item
* @return linea String comentario de texto de un item
**/
protected String outputData( lista30 l30, Vector INDEX, Vector RESPUESTA) {
	
  String linea = new String("");
  int i = -1, k = -1, v = -1;

  try {//
    for( i = 0; i < l30.dimension(); i++) {
      k = l30.Base.indexOfbas( i);      
	   v = ((Integer)(INDEX.get( k))).intValue();
      linea = linea + ((String)((Vector)l30.Esqu.ValoresAtributos.get( i)).get( v)) + "\t";
      }//for-i
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "outputData-1 " + linea + ". i: " + i + ".\n");
    kbm2lSystem.append( "INDEX. " + INDEX.toString() + " k: " + k + " v: " + v + ".\n");
    kbm2lSystem.append( "" + ((String)((Vector)l30.Esqu.ValoresAtributos.get( i)).get( v)) + ".\n");
    frame30.exit( 0, e);
  }//catch
       
  try {//
    for( i = 0; i < l30.ParRespuesta(); i++) {
	   v = ((Integer)(RESPUESTA.get( i))).intValue(); 
	   if (( v >= 0) && ( v < ((Vector)l30.Esqu.ValoresDecisiones.get( i)).size()))
        linea = linea + ((String)((Vector)l30.Esqu.ValoresDecisiones.get( i)).get( v)) + " ";
        else linea = linea + v + "\t";//unKB, coKB, rsKB, rrKB 
      }
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "outputData-2 " + linea + ". i: " + i + ".\n");
    kbm2lSystem.append( "RESPUESTA. " + RESPUESTA.toString() + " k: " + k + " v: " + v + ".\n");
    kbm2lSystem.append( "" + ((String)((Vector)l30.Esqu.ValoresDecisiones.get( i)).get( v)) + ".\n");
    frame30.exit( 0, e);
  }//catch

  return linea.trim();	
}//outputData

}//class tabla30

