//BASEx30//
package target;

//
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kernel.*;
import control.*;
import tables.*;
import kbm2l.*;

/**
* Clase basex30, cambio de base los indices. Implementacin.
* La base de esquema es BC, canonica.
* La transposiciones de indices comprueban el dominio, se permiten indices kbm2l.unKB (-1)
* Las bases son vectores estandar. [DOM-BAS-ATT-ROL-IMP]
* @see Vector
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  basex30  extends  frame30  {

  private static final String ERROR = "Error(basex30): ";

/**
* no static. Estructural.
* dominio de las tablas: cardinal de valores de los atributos-dimensiones.
**/
  protected Vector DOM = null;  
  
/**
* no static. 
* base de las tablas: orden de los atributos-dimensiones.
**/
  protected Vector BAS = null;  

/*
* no static. 
* base de los atributos: orden de los valores de dominio.
*/
  protected Vector ATT = null;  

/**
* no static. Estructural.
* variable de azar, decision, 
* probabilidad, variable condicionada, context.
**/
  protected Vector ROL = null;  
  
/**
* no static. Es dinamico, depende del contenido. 
* Caracteriza la importancia de los atributos con independencia de la base.
* Attribute IMPortance. IMP[i]:-1,0,..,l30.DS()
* -1: desconocida, 0: irrelevante, 1: en una alternativa de respuesta, 2: en dos alt...
**/  
  protected Vector IMP = null;  

/**
*
**/  
  protected double XCOMPLEX = -1.0;//

////
////
////
////

/**
* Constructor por defecto
**/
public basex30() {

  
}//basex30

/**
* base30 size
**/
public int size() {

  if (( BAS.size() == ROL.size()) && ( BAS.size() == DOM.size()) && ( BAS.size() == IMP.size())){
    return BAS.size();
    }
    else {
      System.out.println(ERROR + "size().");
      new Exception().printStackTrace();
      System.out.println("DOM:"+DOM.size());
      System.out.println("BAS:"+BAS.size());
      System.out.println("ATT:"+ATT.size());
      for( int i = 0; i < ATT.size(); i++)
        System.out.println("ATT:"+((Vector)ATT.get(i)).size());
      System.out.println("ROL:"+ROL.size());
      System.out.println("IMP:"+IMP.size());
      exit( 0);
      return -1;
      }
}//size

/**
* Bases iguales: DOM, BAS, ATT, ROL
* @return boolean
**/
public static boolean eqB( base30 B1, base30 B2) {//B1 == B2

  if ( B1.size() != B2.size()) return false;
  for( int i = 0; i < B1.size(); i++) {
    if ( B1.dom( i) !=  B2.dom( i)) return false;
    if ( B1.bas( i) != B2.bas( i)) return false;
	 if ( B1.att( i).size() != B2.att( i).size()) return false; 
    if ( !B1.att( i).equals( B2.att( i))) return false;
    if ( B1.rol( i) != B2.rol( i)) return false;
    }//for-i
  return ( B1.DOM.equals( B2.DOM) && B1.BAS.equals( B2.BAS) && B1.ROL.equals( B2.ROL));
}//eqB

/**
* Bases compatibles: DOM, BAS, ATT, ROL
* @return boolean
**/
public static boolean cmpB( base30 B1, base30 B2) {//B1 == B2

  if ( B1.size() != B2.size()) return false;
  for( int i = 0; i < B1.size(); i++) {
	 int j = B1.bas( i); 
	 int k = B2.indexOfbas( j);
    if ( B1.dom( i) != B2.dom( k)) return false;
	 if ( B1.att( i).size() != B2.att( k).size()) return false; 
	 if ( B1.rol( i) != B2.rol( k)) return false; 
    }//for-i
  return ( true);
}//cmpB

/**
* fix: es indice invariante y offset invariante en la permutacion B1 -> B2. Test fix de un caso.
* Una dimension que permuta tiene el mismo valor en ambas bases. El offset no cambia.
* Los extremos son fijos. El indice es fijo en ambas permutaciones B1 -> B2 y B2 -> B1.
* El cambio de base es generico, no solamente en H2.
* La prueba de item fijo/movil en la transformacion es que Sup e Inf son fix. 
* Clave en la fastCopy.
* @param B1 base inicial.
* @param I  indice de un caso o parte fija de un item.
* @param B2 base nueva.
* @return invariante boolean. 
**/
public static boolean fix( base30 B1, Vector I, base30 B2) {//

  boolean invariante = true;
  BigInteger oB1 = null;
  BigInteger oB2 = null;
  int i = 0, j = 0;

  //indice invariante
  try {
  for( i = 0; ( i < I.size()  &&  invariante); i++) 
    if ( B1.att ( i).equals( B2.att( i))) {// restricitivo ??? solo para bases naturales
      if ( B1.bas( i) != B2.bas( i)) {//i permuta   
        j = B2.indexOfbas( B1.bas( i));
        invariante = invariante && 
        ( ((Integer)I.get( i)).intValue() == ((Integer)I.get( j)).intValue());
        }//es coord movil
      }//if-
      else { return false; }//base extendida
  } catch (Exception e) {
    System.out.println( ERROR + "fix.1");
    System.out.println( "i: " + i + "  j: " + j + "   I: " + I.toString());
    System.out.println( "B1(i): " + B1.bas( i) + "  B2(i): " + B2.bas( i));
    System.out.println( "B1: " + B1.Bas() + "  B2: " + B2.Bas());
    frame30.exit( 0, e);
  }//catch
     
  //osffet invariante   
  try {
  if ( invariante) {
	 oB1 = new offset30().offset( B1.Dom(), I);
	 oB2 = new offset30().offset( B2.Dom(), I);
    invariante = ( oB1.compareTo( oB2) == 0);
   }//
  } catch (Exception e) {
    System.out.println( ERROR + "fix.2");
    System.out.println( "I:   " + I.toString());
    System.out.println( "oB1: " + oB1.toString());
    System.out.println( "oB2: " + oB2.toString());
    exit( 0, e);
  }//catch

  return invariante;
}//fix

/**
* Fix: item i invariante en B1 -> B2. 
**/
public static boolean Fix( lista30 l30, lista30 lTarget, int i) {//
  
//  if (0==0) return false;
  if ( l30.Fix( i).size() == l30.dimension()) return false;
  
  int k = 0;  
  base30 B1 = l30.Base;
  base30 B2 = lTarget.Base;
//  for( int j = l30.dimension()-1; j >=0 ; j--)
  for( int j = 0; j < l30.dimension(); j++)
    if ( B1.bas( j) != B2.bas( j)) { k = j; break; }

  return ( l30.Fix( i).size() <= k) && 
         fix( B1, l30.Sup( i), B2) && 
         fix( B1, l30.Inf( i), B2);
}//fix

/**
* El Vector orden en una permutacin de 0..orden.size(). 
* @param orden Vector de Integer.
* @return true/false
**/
public static boolean esPermutacion( Vector orden) {
  
  int t = orden.size();
  try {
  for( int i = 0; i < t; i++) {
    int o = ((Integer)(orden.get( i))).intValue();
    if (( o < 0)||( o >= t)) return false;
    for( int j = 0; j < t; j++) {
      int p = ((Integer)(orden.get( j))).intValue();
      if (( p < 0)||( p >= t)) return false;
      if ( j != i) {
        if ( o == p) return false;
        }//if    
      }//for-j    
    }//for-i
  } catch (Exception e) {
    System.out.println( ERROR + "esPermutacion.");
    exit( 0, e);
  }//catch

  return true;
}//esPermutacion

/**
* Los dominios son mayores que 1 e iguales al tamao de los Att(i).
* Comprueba que tanto BAS como ATT(i) para todos los atributos son permutaciones.
**/
public static boolean check( base30 b30) {

  if ( !esPermutacion( b30.BAS)) {
    System.out.println( ERROR + "check.0");
    return false;    
    //exit( 0);      
    }
  try {
    for( int i = 0; i < b30.BAS.size(); i++) {
      int d = ((Integer)b30.DOM.get( i)).intValue();
      Vector A = ((Vector)b30.ATT.get( i));
      if ( d <= 1) {
        System.out.println( ERROR + "check.1   d <= 1, d: " + d);
        //return false;    
        exit( 0);      
        }
      if ( d != A.size()) {
        System.out.println( ERROR + "check.2   d != A.size()");
        System.out.println( "d: " + d);
        System.out.println( "A: " + A.size());
        System.out.println( "A: " + A.toString());
        //return false;    
        exit( 0);      
        }
      if ( !esPermutacion( A)) {
        System.out.println( ERROR + "check.3   !esPermutacion( A)");
        System.out.println( A.toString());
        return false;    
        //exit( 0);      
        }
    }//for
  } catch (Exception e) {
    System.out.println( ERROR + "check.");
    exit( 0, e);
  }//catch  

  System.out.println( "basex30 check  - OK.\n");

  return true;
}//check

/**
* Base al azar compatible con B.
* @param B base30
* @return rb base30
**/
public static base30 randomBase( base30 B) {

  base30 rb = new base30( B);//copy-base

  int swaps = Math.abs( control30.gr.nextInt( 2*B.size()));
  try {
  for( int n = 0; n < swaps; n++) {
    int i = Math.abs( control30.gr.nextInt( B.size()));
    int j = Math.abs( control30.gr.nextInt( B.size()));

    //DOM
    int d = rb.dom( i); rb.dom( i, rb.dom( j)); rb.dom( j, d);
    //BAS
    int b = rb.bas( i); rb.bas( i, rb.bas( j)); rb.bas( j, b);

    //ATT
    Vector V = rb.att( i); rb.att( i, rb.att( j)); rb.att( j, V);

    if ( new controlPrefs30().nBase()) {
      int xswaps = Math.abs( control30.gr.nextInt( B.size()));
      for( int m = 0; m < xswaps; m++) {
        int a = Math.abs( control30.gr.nextInt( B.size())); // atributo
        int u1 = Math.abs( control30.gr.nextInt( rb.dom( a))); //i
        int u2 = Math.abs( control30.gr.nextInt( rb.dom( a))); //j
        //att
        int v = rb.att( a, u1); rb.att( a, u1, rb.att( a, u2)); rb.att( a, u2, v);
        }//for-m
      }//if
    
    //ROL
    int r = rb.rol( i); rb.rol( i, rb.rol( j)); rb.rol( j, r);
    }//for-n
  } catch (Exception e) {
    System.out.println( ERROR + "randomBase().");
    exit( 0, e);
  }//catch
  
  if ( !cmpB( B, rb)) {
    System.out.println( ERROR + "randomBase() not cmpB.");
    exit( 0);
    }//if
   
  return rb;  
}//randomBase

////
////

/**
* Transposicion de indices general.
* B1 -> BC -> B2. Transposicion de indices.
* @param B1 base30 
* @param INDEX indice en la base de l301, Vector
* @param B2 base30 
* @return indice en la base de B2. Vector.
**/
public  static  Vector Trnp( base30 B1, Vector INDEX, base30 B2) {

  Vector I = index30.cpT( INDEX), It = null, Itt = null;
  if ( B1 == null) {
	 It = Trnp2( INDEX, B2);
	 if ( chk)
	   Itt = Trnp1( B2, index30.cpT( It)); 
    } else
  if ( B2 == null) {
	 It = Trnp1( B1, INDEX);
	 if (chk)
	   Itt = Trnp2( index30.cpT( It), B1);
 	 } else {
      It = Trnp12( B1, INDEX, B2);
      if (chk)
	     Itt = Trnp12( B2, index30.cpT( It), B1);
	 }	 
  
   if (!chk) return It;// OK
	if ( index30.eqT( I, Itt)) return It;// OK
	 else {
    kbm2lSystem.append( ERROR + "Trnp-1.\n");
    kbm2lSystem.append( "I:   " + I.toString() + "in B1\n"); 
    kbm2lSystem.append( "It:  " + It.toString() + "in B2\n"); 
    kbm2lSystem.append( "Itt: " + Itt.toString() + "in B1\n"); 
    kbm2lSystem.append( "BASE1: \n" + B1.toString( ) + "\n"); 
    kbm2lSystem.append( "BASE2: \n" + B2.toString( ) + "\n");      
    exit( 0, new Exception());
    return null;
   }
}//Trnp

/**
* Transposicion de indices general.
* B1 -> BC -> B2. Transposicion de indices.
* @param B1 base30 
* @param I indice en la base de l301, Vector
* @param B2 base30 
* @return indice en la base de B2. Vector.
**/
private  static  Vector Trnp12( base30 B1, Vector INDEX, base30 B2) {

  Vector I = index30.cpT( INDEX);

  if ( eqB( B1, B2)) return I; 
  
  int b1sz = B1.size();
  Vector U = new Vector( );
  for( int k = 0; k < b1sz; k++) { U.add( new Integer( -1)); }

  int b2sz = B2.size();
  Vector V = new Vector( );
  for( int k = 0; k < b2sz; k++) { V.add( new Integer( -1)); }

  if (chk) {
    System.out.println(I + " B1");
   }

  try {//Trnp doms -> c
  for( int k = 0; k < b1sz; k++) {
	 int v = ((Integer)I.get( k)).intValue( );
	 I.set( k, new Integer( B1.att( k, v)));
    }//for-k
  } catch (Exception e) {
    kbm2lSystem.append( ERROR + "Trnp12-1.");
    exit( 0, e);
  }//catch

  if (chk) {
    System.out.println(I + " B1c");
   }

  try {//Trnp atts -> c  OK!!
  for( int k = 0; k < b1sz; k++) {
    if (!chk) checkTrnp( B1.bas( k), b1sz);
    int v = ((Integer)I.get( k)).intValue();
    U.set( B1.bas( k), new Integer( v));//B1C
    }//for-k
  } catch (Exception e) {
    kbm2lSystem.append( ERROR + "Trnp12-2.");
    exit( 0, e);
  }//catch

  if (chk) {
    System.out.println(U + " C");
    }

  try {//Trnp atts -> 2c
  for( int k = 0; k < b2sz; k++) {
    if (!chk) checkTrnp( B2.bas( k), b2sz);
    int i = ((Integer)U.get( B2.bas( k))).intValue();
    V.set( k, new Integer( i));//CB2
    }//for-k
  } catch (Exception e) {
    kbm2lSystem.append( ERROR + "Trnp12-3.");
    exit( 0, e);
  }//catch

  if (chk) {
    System.out.println(V + " B2c");
    }

  try {//Trnp doms -> 2
  for( int k = 0; k < b2sz; k++) {
    int v = ((Integer)V.get( k)).intValue();
	 V.set( k, new Integer( B2.indexOfatt( k, new Integer( v)))); 
    }//for-k
  } catch (Exception e) {
    kbm2lSystem.append( ERROR + "Trnp12-4.");
    exit( 0, e);
  }//catch

  if (chk) {
    System.out.println(V + " B2");
    }
  
  return V;//en B2
}//Trnp12

/**
* Tansposicion de indices al esquema, BC.
* B1 -> BC. Transposicion de indices.
* @param B1 base30. 
* @param I indice en la base de B1. Vector
* @return indice en la  base del esquema, BC.
**/
private  static  Vector Trnp1( base30 B1, Vector INDEX) {

  Vector I = index30.cpT( INDEX);

  int b1sz = B1.size();
  Vector U = new Vector( );
  for( int k = 0; k < b1sz; k++) { U.add( new Integer( -1)); }

  if (chk) {
    System.out.println(I + " B1");
   }

  try {//Trnp doms -> c
  for( int k = 0; k < b1sz; k++) {
	 I.set( k, new Integer( B1.indexOfatt( k, ((Integer)I.get( k)))));
    }//for-k
  } catch (Exception e) {
    System.out.println( ERROR + "Trnp1-1.");
    exit( 0, e);
  }//catch

  if (chk) {
    System.out.println(I + " B1c");
   }

  try {//Trnp atts -> c
  for( int k = 0; k < b1sz; k++) {
    if (!chk) checkTrnp( B1.bas( k), b1sz);
    int i = ((Integer)I.get( k)).intValue();
    U.set( B1.bas( k), new Integer( i));//B1C
    }//for-k
  } catch (Exception e) {
    System.out.println( ERROR + "Trnp1-2.");
    exit( 0, e);
  }//catch

  if (chk) {
    System.out.println(U + " C");
    }

  return U;//en C
}//Trnp1

/**
* Tansposicion de dominios en indices al esquema, BC.
* B1 -> BC. Transposicion de indices.
* @param B1 base30. 
* @param I indice en la base de B1. Vector
* @return indice en la  base del esquema, BC.
**/
private  static  Vector Trnp1Dom( base30 B1, Vector INDEX) {

  Vector I = index30.cpT( INDEX);

  int b1sz = B1.size();
  Vector U = new Vector( );
  for( int k = 0; k < b1sz; k++) { U.add( new Integer( -1)); }

  if (chk) {
    System.out.println(I + " B1");
   }

  try {//Trnp doms -> c
  for( int k = 0; k < b1sz; k++) {
	 I.set( k, new Integer( B1.indexOfatt( k, ((Integer)I.get( k)))));
    }//for-k
  } catch (Exception e) {
    System.out.println( ERROR + "Trnp1Dom-1.");
    exit( 0, e);
  }//catch

  if (chk) {
    System.out.println(I + " B1c");
   }

  return I;//en C
}//TrnpDom

/**
* Transposicion de indices del esquema, BC.
* BC -> B2. Transposicion de indices.
* @param I indice en la base del esquema BC. Vector
* @param B2 base30.
* @return indice en la base de B2. Vector.
**/
private  static  Vector Trnp2( Vector INDEX, base30 B2) {

  Vector I = index30.cpT( INDEX);

  int b2sz = B2.size();
  Vector V = new Vector( );
  for( int k = 0; k < b2sz; k++) { V.add( new Integer( -1)); }

  try {//Trnp atts -> 2c
  for( int k = 0; k < b2sz; k++) {
    if (!chk) checkTrnp( B2.bas( k), b2sz);
    int i = ((Integer)I.get( B2.bas( k))).intValue();
    V.set( k, new Integer( i));//CB2
    }//for-k
  } catch (Exception e) {
    System.out.println( ERROR + "Trnp2-1.");
    exit( 0, e);
  }//catch

  if (chk) {
    System.out.println(V + " B2c");
    }

  int k=-1, i=-1, l=-1;
  try {//Trnp doms -> 2
  for( k = 0; k < b2sz; k++) {
    i = ((Integer)V.get( k)).intValue();
    if ( i != kbm2l30.unKB)
      V.set( k, new Integer( B2.att( k, i)));
      else V.set( k, new Integer( kbm2l30.unKB));
    }//for-k
  } catch (Exception e) {
    System.out.println( ERROR + "Trnp2-2.");
    System.out.println( "k: "+ k);
    System.out.println( "V: "+ V.toString());
    System.out.println( "i: "+i);
    System.out.println( "B2.att(k): "+B2.att( k));
    exit( 0, e);
  }//catch

  if (chk) {
    System.out.println(V + " B2");
    }

  return V;//en B2
}//Trnp2

/**
* check posicion de un att, kB, y el tamao de la base, bsz.
**/
private static void checkTrnp( int kB, int bsz) {

  if (( kB < 0) || ( kB >= bsz)) {
    kbm2lSystem.append( ERROR + "checkTrnp: kB" + kB );
    kbm2lSystem.append( "B.size():" + bsz);
    exit( 0, new Exception());
  }
}//check

/**
* Leer bases naturales de un fichero: BAS, ATT, pueden no ser bases correctas
* @return b30 base30
**/
public static base30 leerBase( lista30 l30, BufferedReader in) {//

  base30 b30 = new base30( l30.Base);
  String linea = null; // linea del fichero  
  
  try {
	 //BAS 
	 dato30.nextLine( in, linea);
    for( int i = 0; i <  b30.size()-1; i++) {
      b30.bas( i, (int)( dato30.param( linea)));
      linea = new String( dato30.nextParam( linea, ' '));
      }//for-i
    b30.bas( b30.size()-1, (int)( dato30.param( linea)));
    //ATT
    for( int i = 0; i < b30.size(); i++) {
	 dato30.nextLine( in, linea);
      for( int j = 0; j <  b30.dom( i)-1; j++) {
        b30.att( j, (int)( dato30.param( linea)));
        linea = new String( dato30.nextParam( linea, ' '));
        }//for-j
      b30.att( b30.size()-1, (int)( dato30.param( linea)));
    }//for-i
   
    } catch (Exception e) {
    System.out.println( ERROR + "leerBase.");
    exit( 0, e);
  }//catch

  return ( b30);//
}//leerBase

}//class basex30
