//
package xbneditor;

//
import java.lang.System;
import java.io.*;
import java.awt.*;

//
import kbm2l.*;
import tables.*;

/**
 * Title:        xbneditor
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company: KSUKDD
 * @author Haipeng Guo
 * @version 1.0
 */

public  class  BBNConvertor  extends  frame30  implements  Runnable {

  private static final String ERROR = "Error(BBNConvertor): ";
/**
* flag de ejecucion en curso
**/
  public static boolean working = false;//
  private String inputfilename = null;
  private String outputfilename = null;

public BBNConvertor( String inputfilename, String outputfilename) {
  
    if( inputfilename.equals( "")) {
      f30.kbm2lSystem.estatus("Bayesian Network selecc: *.xml.");
      String filename = dato30.selectFile( f30.kbm2lSystem.frame, FileDialog.LOAD, "*.xml");
      if ( filename == null) {
        f30.kbm2lSystem.append("Data Set not readed.\n");
        return ;
        }//if
      this.inputfilename = new String( filename);
      }//if 
      else this.inputfilename = inputfilename;
  
    if( this.inputfilename == null) {
      System.out.println("[inputfilename] is null...");
      System.exit(0);
      }

    f30.kbm2lSystem.estatus("Bayesian Network seleccted: " + dato30.workspace + 
        dato30.nameFile( dato30.extFile( this.inputfilename, "xml")));
            
    if( outputfilename.equals( "")) {
      this.outputfilename = dato30.workspace + 
        dato30.nameFile( dato30.extFile( this.inputfilename, "net"));
        }
      else {  
        this.outputfilename = outputfilename;
      }//if

    if( this.outputfilename == null) {
      System.out.println("[outputfilename] is null...");
      System.exit(0);
     }

    
}//BBNConvertor

public void bbnConvertor( ) {

    String informat = inputfilename.substring(inputfilename.indexOf(".")+1, inputfilename.length());
    String outformat = outputfilename.substring(outputfilename.indexOf(".")+1, outputfilename.length());

    System.out.println("informat = " + informat);
    System.out.println("outformat = " + outformat);

    if( informat.equals(outformat))
      { System.out.println("Come on, no joke...");
    } else {
      FileIO fileIO = new FileIO();
      fileIO.convert(outputfilename, fileIO.load(inputfilename), outformat);
    }

}//bnnConvertor

/**
* main
**/
  public static void main(String[] args) {
    if((args.length==0)|| (args.length>2)){System.out.println(
      "Usage: Java BBNConvertor inputfilename outputfilename ...");
      new BBNConvertor( "", "").bbnConvertor( );
      return;
      }

    String inputfilename = args[0];
    String outputfilename = args[1];
    String informat = inputfilename.substring(inputfilename.indexOf(".")+1, inputfilename.length());
    String outformat = outputfilename.substring(outputfilename.indexOf(".")+1, outputfilename.length());

    System.out.println("informat = " + informat);
    System.out.println("outformat = " + outformat);

    if(informat.equals(outformat))
      { System.out.println("Come on, no joke...");
    } else {
      FileIO fileIO = new FileIO();
      fileIO.convert(outputfilename, fileIO.load(inputfilename), outformat);
    }
  }//main

/**
*
**/
public void run() {

  if ( !working) {
    try {
      bbnConvertor( );
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "run().");
      e.printStackTrace();
      System.exit( 0);
    }//catch
    }
  return;
}//run

}//BNNConvertor